"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(B){for(var n=[],N=0,t=B.length;N<t;N++)n[N]=J[B[N]];return n},Ue=this,Oe=typeof global=="object"?global:{},le;(function(B){B.global=Ue;var n=function(){function N(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(N.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),N.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=N._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},N._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},N}();B.Environment=n})(le||(le={}));var le;(function(B){var n=function(){function D(f,A,h){this.type=f,this.detail=A,this.timestamp=h}return D}();B.LoaderEvent=n;var N=function(){function D(f){this._events=[new n(1,"",f)]}return D.prototype.record=function(f,A){this._events.push(new n(f,A,B.Utilities.getHighPerformanceTimestamp()))},D.prototype.getEvents=function(){return this._events},D}();B.LoaderEventRecorder=N;var t=function(){function D(){}return D.prototype.record=function(f,A){},D.prototype.getEvents=function(){return[]},D.INSTANCE=new D,D}();B.NullLoaderEventRecorder=t})(le||(le={}));var le;(function(B){var n=function(){function N(){}return N.fileUriToFilePath=function(t,D){if(D=decodeURI(D).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(D))return D.substr(8);if(/^file:\/\//.test(D))return D.substr(5)}else if(/^file:\/\//.test(D))return D.substr(7);return D},N.startsWith=function(t,D){return t.length>=D.length&&t.substr(0,D.length)===D},N.endsWith=function(t,D){return t.length>=D.length&&t.substr(t.length-D.length)===D},N.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},N.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},N.forEachProperty=function(t,D){if(t){var f=void 0;for(f in t)t.hasOwnProperty(f)&&D(f,t[f])}},N.isEmpty=function(t){var D=!0;return N.forEachProperty(t,function(){D=!1}),D},N.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var D=Array.isArray(t)?[]:{};return N.forEachProperty(t,function(f,A){A&&typeof A=="object"?D[f]=N.recursiveClone(A):D[f]=A}),D},N.generateAnonymousModule=function(){return"===anonymous"+N.NEXT_ANONYMOUS_ID+++"==="},N.isAnonymousModule=function(t){return N.startsWith(t,"===anonymous")},N.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()},N.NEXT_ANONYMOUS_ID=1,N.PERFORMANCE_NOW_PROBED=!1,N.HAS_PERFORMANCE_NOW=!1,N}();B.Utilities=n})(le||(le={}));var le;(function(B){function n(D){if(D instanceof Error)return D;var f=new Error(D.message||String(D)||"Unknown Error");return D.stack&&(f.stack=D.stack),f}B.ensureError=n;var N=function(){function D(){}return D.validateConfigurationOptions=function(f){function A(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=A),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(B.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){var h=n(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f},D.mergeConfigurationOptions=function(f,A){f===void 0&&(f=null),A===void 0&&(A=null);var h=B.Utilities.recursiveClone(A||{});return B.Utilities.forEachProperty(f,function(o,u){o==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(u):o==="paths"&&typeof h.paths<"u"?B.Utilities.forEachProperty(u,function(C,M){return h.paths[C]=M}):o==="config"&&typeof h.config<"u"?B.Utilities.forEachProperty(u,function(C,M){return h.config[C]=M}):h[o]=B.Utilities.recursiveClone(u)}),D.validateConfigurationOptions(h)},D}();B.ConfigurationOptionsUtil=N;var t=function(){function D(f,A){if(this._env=f,this.options=N.mergeConfigurationOptions(A),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var h=this.options.nodeRequire.main.filename,o=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,o+1)}}return D.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0},D.prototype._createSortedPathsRules=function(){var f=this;this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,function(A,h){Array.isArray(h)?f.sortedPathsRules.push({from:A,to:h}):f.sortedPathsRules.push({from:A,to:[h]})}),this.sortedPathsRules.sort(function(A,h){return h.from.length-A.from.length})},D.prototype.cloneAndMerge=function(f){return new D(this._env,N.mergeConfigurationOptions(f,this.options))},D.prototype.getOptionsLiteral=function(){return this.options},D.prototype._applyPaths=function(f){for(var A,h=0,o=this.sortedPathsRules.length;h<o;h++)if(A=this.sortedPathsRules[h],B.Utilities.startsWith(f,A.from)){for(var u=[],C=0,M=A.to.length;C<M;C++)u.push(A.to[C]+f.substr(A.from.length));return u}return[f]},D.prototype._addUrlArgsToUrl=function(f){return B.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs},D.prototype._addUrlArgsIfNecessaryToUrl=function(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f},D.prototype._addUrlArgsIfNecessaryToUrls=function(f){if(this.options.urlArgs)for(var A=0,h=f.length;A<h;A++)f[A]=this._addUrlArgsToUrl(f[A]);return f},D.prototype.moduleIdToPaths=function(f){if(this._env.isNode){var A=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f);if(A)return this.isBuild()?["empty:"]:["node|"+f]}var h=f,o;if(!B.Utilities.endsWith(h,".js")&&!B.Utilities.isAbsolutePath(h)){o=this._applyPaths(h);for(var u=0,C=o.length;u<C;u++)this.isBuild()&&o[u]==="empty:"||(B.Utilities.isAbsolutePath(o[u])||(o[u]=this.options.baseUrl+o[u]),!B.Utilities.endsWith(o[u],".js")&&!B.Utilities.containsQueryString(o[u])&&(o[u]=o[u]+".js"))}else!B.Utilities.endsWith(h,".js")&&!B.Utilities.containsQueryString(h)&&(h=h+".js"),o=[h];return this._addUrlArgsIfNecessaryToUrls(o)},D.prototype.requireToUrl=function(f){var A=f;return B.Utilities.isAbsolutePath(A)||(A=this._applyPaths(A)[0],B.Utilities.isAbsolutePath(A)||(A=this.options.baseUrl+A)),this._addUrlArgsIfNecessaryToUrl(A)},D.prototype.isBuild=function(){return this.options.isBuild},D.prototype.shouldInvokeFactory=function(f){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])},D.prototype.isDuplicateMessageIgnoredFor=function(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)},D.prototype.getConfigForModule=function(f){if(this.options.config)return this.options.config[f]},D.prototype.shouldCatchError=function(){return this.options.catchError},D.prototype.shouldRecordStats=function(){return this.options.recordStats},D.prototype.onError=function(f){this.options.onError(f)},D}();B.Configuration=t})(le||(le={}));var le;(function(B){var n=function(){function o(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(u,C,M,v){var d=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new D;else if(this._env.isElectronRenderer){var e=u.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new N:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new N;var E={callback:M,errorback:v};if(this._callbackMap.hasOwnProperty(C)){this._callbackMap[C].push(E);return}this._callbackMap[C]=[E],this._scriptLoader.load(u,C,function(){return d.triggerCallback(C)},function(F){return d.triggerErrorback(C,F)})},o.prototype.triggerCallback=function(u){var C=this._callbackMap[u];delete this._callbackMap[u];for(var M=0;M<C.length;M++)C[M].callback()},o.prototype.triggerErrorback=function(u,C){var M=this._callbackMap[u];delete this._callbackMap[u];for(var v=0;v<M.length;v++)M[v].errorback(C)},o}(),N=function(){function o(){}return o.prototype.attachListeners=function(u,C,M){var v=function(){u.removeEventListener("load",d),u.removeEventListener("error",e)},d=function(E){v(),C()},e=function(E){v(),M(E)};u.addEventListener("load",d),u.addEventListener("error",e)},o.prototype.load=function(u,C,M,v){if(/^node\|/.test(C)){var d=u.getConfig().getOptionsLiteral(),e=A(u.getRecorder(),d.nodeRequire||B.global.nodeRequire),E=C.split("|"),F=null;try{F=e(E[1])}catch(s){v(s);return}u.enqueueDefineAnonymousModule([],function(){return F}),M()}else{var y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript"),this.attachListeners(y,M,v);var L=u.getConfig().getOptionsLiteral().trustedTypesPolicy;L&&(C=L.createScriptURL(C)),y.setAttribute("src",C);var i=u.getConfig().getOptionsLiteral().cspNonce;i&&y.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(y)}},o}();function t(o){var u=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var C=u?self.eval(u.createScript("","true")):new Function("true");return C.call(self),!0}catch{return!1}}var D=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(u)),this._cachedCanUseEval},o.prototype.load=function(u,C,M,v){if(/^node\|/.test(C)){var d=u.getConfig().getOptionsLiteral(),e=A(u.getRecorder(),d.nodeRequire||B.global.nodeRequire),E=C.split("|"),F=null;try{F=e(E[1])}catch(i){v(i);return}u.enqueueDefineAnonymousModule([],function(){return F}),M()}else{var y=u.getConfig().getOptionsLiteral().trustedTypesPolicy,L=/^((http:)|(https:)|(file:))/.test(C)&&C.substring(0,self.origin.length)!==self.origin;if(!L&&this._canUseEval(u)){fetch(C).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+C;var s=y?self.eval(y.createScript("",i)):new Function(i);s.call(self),M()}).then(void 0,v);return}try{y&&(C=y.createScriptURL(C)),importScripts(C),M()}catch(i){v(i)}}},o}(),f=function(){function o(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))},o.prototype._initNodeRequire=function(u,C){var M=C.getConfig().getOptionsLiteral().nodeCachedData;if(!M||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var v=this,d=u("module");function e(E){var F=E.constructor,y=function(i){try{return E.require(i)}finally{}};return y.resolve=function(i,s){return F._resolveFilename(i,E,!1,s)},y.resolve.paths=function(i){return F._resolveLookupPaths(i,E)},y.main=process.mainModule,y.extensions=F._extensions,y.cache=F._cache,y}d.prototype._compile=function(E,F){var y=d.wrap(E.replace(/^#!.*/,"")),L=C.getRecorder(),i=v._getCachedDataPath(M,F),s={filename:F},a;try{var l=v._fs.readFileSync(i);a=l.slice(0,16),s.cachedData=l.slice(16),L.record(60,i)}catch{L.record(61,i)}var c=new v._vm.Script(y,s),g=c.runInThisContext(s),m=v._path.dirname(F),p=e(this),b=[this.exports,p,this,F,m,process,Oe,Buffer],_=g.apply(this.exports,b);return v._handleCachedData(c,y,i,!s.cachedData,C),v._verifyCachedData(c,y,i,a,C),_}},o.prototype.load=function(u,C,M,v){var d=this,e=u.getConfig().getOptionsLiteral(),E=A(u.getRecorder(),e.nodeRequire||B.global.nodeRequire),F=e.nodeInstrumenter||function(g){return g};this._init(E),this._initNodeRequire(E,u);var y=u.getRecorder();if(/^node\|/.test(C)){var L=C.split("|"),i=null;try{i=E(L[1])}catch(g){v(g);return}u.enqueueDefineAnonymousModule([],function(){return i}),M()}else{C=B.Utilities.fileUriToFilePath(this._env.isWindows,C);var s=this._path.normalize(C),a=this._getElectronRendererScriptPathOrUri(s),l=Boolean(e.nodeCachedData),c=l?this._getCachedDataPath(e.nodeCachedData,C):void 0;this._readSourceAndCachedData(s,c,y,function(g,m,p,b){if(g){v(g);return}var _;m.charCodeAt(0)===o._BOM?_=o._PREFIX+m.substring(1)+o._SUFFIX:_=o._PREFIX+m+o._SUFFIX,_=F(_,s);var w={filename:a,cachedData:p},R=d._createAndEvalScript(u,_,w,M,v);d._handleCachedData(R,_,c,l&&!p,u),d._verifyCachedData(R,_,c,b,u)})}},o.prototype._createAndEvalScript=function(u,C,M,v,d){var e=u.getRecorder();e.record(31,M.filename);var E=new this._vm.Script(C,M),F=E.runInThisContext(M),y=u.getGlobalAMDDefineFunc(),L=!1,i=function(){return L=!0,y.apply(null,arguments)};return i.amd=y.amd,F.call(B.global,u.getGlobalAMDRequireFunc(),i,M.filename,this._path.dirname(M.filename)),e.record(32,M.filename),L?v():d(new Error("Didn't receive define call in "+M.filename+"!")),E},o.prototype._getElectronRendererScriptPathOrUri=function(u){if(!this._env.isElectronRenderer)return u;var C=u.match(/^([a-z])\:(.*)/i);return C?"file:///"+(C[1].toUpperCase()+":"+C[2]).replace(/\\/g,"/"):"file://"+u},o.prototype._getCachedDataPath=function(u,C){var M=this._crypto.createHash("md5").update(C,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),v=this._path.basename(C).replace(/\.js$/,"");return this._path.join(u.path,v+"-"+M+".code")},o.prototype._handleCachedData=function(u,C,M,v,d){var e=this;u.cachedDataRejected?this._fs.unlink(M,function(E){d.getRecorder().record(62,M),e._createAndWriteCachedData(u,C,M,d),E&&d.getConfig().onError(E)}):v&&this._createAndWriteCachedData(u,C,M,d)},o.prototype._createAndWriteCachedData=function(u,C,M,v){var d=this,e=Math.ceil(v.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),E=-1,F=0,y=void 0,L=function(){setTimeout(function(){y||(y=d._crypto.createHash("md5").update(C,"utf8").digest());var i=u.createCachedData();if(!(i.length===0||i.length===E||F>=5)){if(i.length<E){L();return}E=i.length,d._fs.writeFile(M,Buffer.concat([y,i]),function(s){s&&v.getConfig().onError(s),v.getRecorder().record(63,M),L()})}},e*Math.pow(4,F++))};L()},o.prototype._readSourceAndCachedData=function(u,C,M,v){if(!C)this._fs.readFile(u,{encoding:"utf8"},v);else{var d=void 0,e=void 0,E=void 0,F=2,y=function(L){L?v(L):--F===0&&v(void 0,d,e,E)};this._fs.readFile(u,{encoding:"utf8"},function(L,i){d=i,y(L)}),this._fs.readFile(C,function(L,i){!L&&i&&i.length>0?(E=i.slice(0,16),e=i.slice(16),M.record(60,C)):M.record(61,C),y()})}},o.prototype._verifyCachedData=function(u,C,M,v,d){var e=this;!v||u.cachedDataRejected||setTimeout(function(){var E=e._crypto.createHash("md5").update(C,"utf8").digest();v.equals(E)||(d.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+M+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(M,function(F){F&&d.getConfig().onError(F)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function A(o,u){if(u.__$__isRecorded)return u;var C=function(v){o.record(33,v);try{return u(v)}finally{o.record(34,v)}};return C.__$__isRecorded=!0,C}B.ensureRecordedNodeRequire=A;function h(o){return new n(o)}B.createScriptLoader=h})(le||(le={}));var le;(function(B){var n=function(){function h(o){var u=o.lastIndexOf("/");u!==-1?this.fromModulePath=o.substr(0,u+1):this.fromModulePath=""}return h._normalizeModuleId=function(o){var u=o,C;for(C=/\/\.\//;C.test(u);)u=u.replace(C,"/");for(u=u.replace(/^\.\//g,""),C=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;C.test(u);)u=u.replace(C,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u},h.prototype.resolveModule=function(o){var u=o;return B.Utilities.isAbsolutePath(u)||(B.Utilities.startsWith(u,"./")||B.Utilities.startsWith(u,"../"))&&(u=h._normalizeModuleId(this.fromModulePath+u)),u},h.ROOT=new h(""),h}();B.ModuleIdResolver=n;var N=function(){function h(o,u,C,M,v,d){this.id=o,this.strId=u,this.dependencies=C,this._callback=M,this._errorback=v,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return h._safeInvokeFunction=function(o,u){try{return{returnedValue:o.apply(B.global,u),producedError:null}}catch(C){return{returnedValue:null,producedError:C}}},h._invokeFactory=function(o,u,C,M){return o.shouldInvokeFactory(u)?o.shouldCatchError()?this._safeInvokeFunction(C,M):{returnedValue:C.apply(B.global,M),producedError:null}:{returnedValue:null,producedError:null}},h.prototype.complete=function(o,u,C,M){this._isComplete=!0;var v=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var d=h._invokeFactory(u,this.strId,this._callback,C);v=d.producedError,o.record(22,this.strId),!v&&typeof d.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(v){var e=B.ensureError(v);e.phase="factory",e.moduleId=this.strId,e.neededBy=M(this.id),this.error=e,u.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},h.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},h.prototype.isComplete=function(){return this._isComplete},h}();B.Module=N;var t=function(){function h(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return h.prototype.getMaxModuleId=function(){return this._nextId},h.prototype.getModuleId=function(o){var u=this._strModuleIdToIntModuleId.get(o);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(o,u),this._intModuleIdToStrModuleId[u]=o),u},h.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},h}(),D=function(){function h(o){this.id=o}return h.EXPORTS=new h(0),h.MODULE=new h(1),h.REQUIRE=new h(2),h}();B.RegularDependency=D;var f=function(){function h(o,u,C){this.id=o,this.pluginId=u,this.pluginParam=C}return h}();B.PluginDependency=f;var A=function(){function h(o,u,C,M,v){v===void 0&&(v=0),this._env=o,this._scriptLoader=u,this._loaderAvailableTimestamp=v,this._defineFunc=C,this._requireFunc=M,this._moduleIdProvider=new t,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return h.prototype.reset=function(){return new h(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},h.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},h.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},h._findRelevantLocationInStack=function(o,u){for(var C=function(s){return s.replace(/\\/g,"/")},M=C(o),v=u.split(/\n/),d=0;d<v.length;d++){var e=v[d].match(/(.*):(\d+):(\d+)\)?$/);if(e){var E=e[1],F=e[2],y=e[3],L=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr(L),E=C(E),E===M){var i={line:parseInt(F,10),col:parseInt(y,10)};return i.line===1&&(i.col-=53),i}}}throw new Error("Could not correlate define call site for needle "+o)},h.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],u=0,C=0,M=this._modules2.length;C<M;C++){var v=this._modules2[C];if(!!v){var d=this._buildInfoPath[v.id]||null,e=this._buildInfoDefineStack[v.id]||null,E=this._buildInfoDependencies[v.id];o[u++]={id:v.strId,path:d,defineLocation:d&&e?h._findRelevantLocationInStack(d,e):null,dependencies:E,shim:null,exports:v.exports}}}return o},h.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder},h.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},h.prototype.enqueueDefineAnonymousModule=function(o,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var C=null;this._config.isBuild()&&(C=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:C,dependencies:o,callback:u}},h.prototype.defineModule=function(o,u,C,M,v,d){var e=this;d===void 0&&(d=new n(o));var E=this._moduleIdProvider.getModuleId(o);if(this._modules2[E]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var F=new N(E,o,this._normalizeDependencies(u,d),C,M,d);this._modules2[E]=F,this._config.isBuild()&&(this._buildInfoDefineStack[E]=v,this._buildInfoDependencies[E]=(F.dependencies||[]).map(function(y){return e._moduleIdProvider.getStrModuleId(y.id)})),this._resolve(F)},h.prototype._normalizeDependency=function(o,u){if(o==="exports")return D.EXPORTS;if(o==="module")return D.MODULE;if(o==="require")return D.REQUIRE;var C=o.indexOf("!");if(C>=0){var M=u.resolveModule(o.substr(0,C)),v=u.resolveModule(o.substr(C+1)),d=this._moduleIdProvider.getModuleId(M+"!"+v),e=this._moduleIdProvider.getModuleId(M);return new f(d,e,v)}return new D(this._moduleIdProvider.getModuleId(u.resolveModule(o)))},h.prototype._normalizeDependencies=function(o,u){for(var C=[],M=0,v=0,d=o.length;v<d;v++)C[M++]=this._normalizeDependency(o[v],u);return C},h.prototype._relativeRequire=function(o,u,C,M){if(typeof u=="string")return this.synchronousRequire(u,o);this.defineModule(B.Utilities.generateAnonymousModule(),u,C,M,null,o)},h.prototype.synchronousRequire=function(o,u){u===void 0&&(u=new n(o));var C=this._normalizeDependency(o,u),M=this._modules2[C.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(M.error)throw M.error;return M.exports},h.prototype.configure=function(o,u){var C=this._config.shouldRecordStats();u?this._config=new B.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!C&&(this._recorder=null)},h.prototype.getConfig=function(){return this._config},h.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),u.dependencies,u.callback,null,u.stack)}},h.prototype._createLoadError=function(o,u){var C=this,M=this._moduleIdProvider.getStrModuleId(o),v=(this._inverseDependencies2[o]||[]).map(function(e){return C._moduleIdProvider.getStrModuleId(e)}),d=B.ensureError(u);return d.phase="loading",d.moduleId=M,d.neededBy=v,d},h.prototype._onLoadError=function(o,u){var C=this._createLoadError(o,u);this._modules2[o]||(this._modules2[o]=new N(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var M=[],v=0,d=this._moduleIdProvider.getMaxModuleId();v<d;v++)M[v]=!1;var e=!1,E=[];for(E.push(o),M[o]=!0;E.length>0;){var F=E.shift(),y=this._modules2[F];y&&(e=y.onDependencyError(C)||e);var L=this._inverseDependencies2[F];if(L)for(var v=0,d=L.length;v<d;v++){var i=L[v];M[i]||(E.push(i),M[i]=!0)}}e||this._config.onError(C)},h.prototype._hasDependencyPath=function(o,u){var C=this._modules2[o];if(!C)return!1;for(var M=[],v=0,d=this._moduleIdProvider.getMaxModuleId();v<d;v++)M[v]=!1;var e=[];for(e.push(C),M[o]=!0;e.length>0;){var E=e.shift(),F=E.dependencies;if(F)for(var v=0,d=F.length;v<d;v++){var y=F[v];if(y.id===u)return!0;var L=this._modules2[y.id];L&&!M[y.id]&&(M[y.id]=!0,e.push(L))}}return!1},h.prototype._findCyclePath=function(o,u,C){if(o===u||C===50)return[o];var M=this._modules2[o];if(!M)return null;var v=M.dependencies;if(v)for(var d=0,e=v.length;d<e;d++){var E=this._findCyclePath(v[d].id,u,C+1);if(E!==null)return E.push(o),E}return null},h.prototype._createRequire=function(o){var u=this,C=function(M,v,d){return u._relativeRequire(o,M,v,d)};return C.toUrl=function(M){return u._config.requireToUrl(o.resolveModule(M))},C.getStats=function(){return u.getLoaderEvents()},C.hasDependencyCycle=function(){return u._hasDependencyCycle},C.config=function(M,v){v===void 0&&(v=!1),u.configure(M,v)},C.__$__nodeRequire=B.global.nodeRequire,C},h.prototype._loadModule=function(o){var u=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var C=this._moduleIdProvider.getStrModuleId(o),M=this._config.moduleIdToPaths(C),v=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(C.indexOf("/")===-1||v.test(C))&&M.push("node|"+C);var d=-1,e=function(E){if(d++,d>=M.length)u._onLoadError(o,E);else{var F=M[d],y=u.getRecorder();if(u._config.isBuild()&&F==="empty:"){u._buildInfoPath[o]=F,u.defineModule(u._moduleIdProvider.getStrModuleId(o),[],null,null,null),u._onLoad(o);return}y.record(10,F),u._scriptLoader.load(u,F,function(){u._config.isBuild()&&(u._buildInfoPath[o]=F),y.record(11,F),u._onLoad(o)},function(L){y.record(12,F),e(L)})}};e(null)}},h.prototype._loadPluginDependency=function(o,u){var C=this;if(!(this._modules2[u.id]||this._knownModules2[u.id])){this._knownModules2[u.id]=!0;var M=function(v){C.defineModule(C._moduleIdProvider.getStrModuleId(u.id),[],v,null,null)};M.error=function(v){C._config.onError(C._createLoadError(u.id,v))},o.load(u.pluginParam,this._createRequire(n.ROOT),M,this._config.getOptionsLiteral())}},h.prototype._resolve=function(o){var u=this,C=o.dependencies;if(C)for(var M=0,v=C.length;M<v;M++){var d=C[M];if(d===D.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(d===D.MODULE){o.unresolvedDependenciesCount--;continue}if(d===D.REQUIRE){o.unresolvedDependenciesCount--;continue}var e=this._modules2[d.id];if(e&&e.isComplete()){if(e.error){o.onDependencyError(e.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var E=this._findCyclePath(d.id,o.id,0)||[];E.reverse(),E.push(d.id),console.warn(E.map(function(L){return u._moduleIdProvider.getStrModuleId(L)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(o.id),d instanceof f){var F=this._modules2[d.pluginId];if(F&&F.isComplete()){this._loadPluginDependency(F.exports,d);continue}var y=this._inversePluginDependencies2.get(d.pluginId);y||(y=[],this._inversePluginDependencies2.set(d.pluginId,y)),y.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},h.prototype._onModuleComplete=function(o){var u=this,C=this.getRecorder();if(!o.isComplete()){var M=o.dependencies,v=[];if(M)for(var d=0,e=M.length;d<e;d++){var E=M[d];if(E===D.EXPORTS){v[d]=o.exports;continue}if(E===D.MODULE){v[d]={id:o.strId,config:function(){return u._config.getConfigForModule(o.strId)}};continue}if(E===D.REQUIRE){v[d]=this._createRequire(o.moduleIdResolver);continue}var F=this._modules2[E.id];if(F){v[d]=F.exports;continue}v[d]=null}var y=function(l){return(u._inverseDependencies2[l]||[]).map(function(c){return u._moduleIdProvider.getStrModuleId(c)})};o.complete(C,this._config,v,y);var L=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,L)for(var d=0,e=L.length;d<e;d++){var i=L[d],s=this._modules2[i];s.unresolvedDependenciesCount--,s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}var a=this._inversePluginDependencies2.get(o.id);if(a){this._inversePluginDependencies2.delete(o.id);for(var d=0,e=a.length;d<e;d++)this._loadPluginDependency(o.exports,a[d])}}},h}();B.ModuleManager=A})(le||(le={}));var Z,le;(function(B){var n=new B.Environment,N=null,t=function(h,o,u){typeof h!="string"&&(u=o,o=h,h=null),(typeof o!="object"||!Array.isArray(o))&&(u=o,o=null),o||(o=["require","exports","module"]),h?N.defineModule(h,o,u,null,null):N.enqueueDefineAnonymousModule(o,u)};t.amd={jQuery:!0};var D=function(h,o){o===void 0&&(o=!1),N.configure(h,o)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){D(arguments[0]);return}if(typeof arguments[0]=="string")return N.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){N.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=D,f.getConfig=function(){return N.getConfig().getOptionsLiteral()},f.reset=function(){N=N.reset()},f.getBuildInfo=function(){return N.getBuildInfo()},f.getStats=function(){return N.getLoaderEvents()},f.define=t;function A(){if(typeof B.global.require<"u"||typeof require<"u"){var h=B.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){var o=B.ensureRecordedNodeRequire(N.getRecorder(),h);B.global.nodeRequire=o,f.nodeRequire=o,f.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=f:(n.isElectronRenderer||(B.global.define=t),B.global.require=f)}B.init=A,(typeof B.global.define!="function"||!B.global.define.amd)&&(N=new B.ModuleManager(n,B.createScriptLoader(n),t,f,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&f.config(B.global.require),Z=function(){return t.apply(null,arguments)},Z.amd=t.amd,typeof doNotInitLoader>"u"&&A())})(le||(le={})),Z(J[53],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=void 0;function N(h,o,u,C){if(C=C||{},(C["vs/css"]||{}).disabled){u({});return}const v=o.toUrl(h+".css");t(h,v,()=>{u({})},d=>{typeof u.error=="function"&&u.error("Could not find "+v+".")})}n.load=N;function t(h,o,u,C){if(D(h,o)){u();return}f(h,o,u,C)}function D(h,o){const u=document.getElementsByTagName("link");for(let C=0,M=u.length;C<M;C++){const v=u[C].getAttribute("data-name"),d=u[C].getAttribute("href");if(v===h||d===o)return!0}return!1}function f(h,o,u,C){const M=document.createElement("link");M.setAttribute("rel","stylesheet"),M.setAttribute("type","text/css"),M.setAttribute("data-name",h),A(h,M,u,C),M.setAttribute("href",o),(document.head||document.getElementsByTagName("head")[0]).appendChild(M)}function A(h,o,u,C){const M=()=>{o.removeEventListener("load",v),o.removeEventListener("error",d)},v=e=>{M(),u()},d=e=>{M(),C(e)};o.addEventListener("load",v),o.addEventListener("error",d)}}),Z("vs/nls",["require","exports"],function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let N=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const t="i-default";function D(e,E){let F;return E.length===0?F=e:F=e.replace(/\{(\d+)\}/g,(y,L)=>{const i=L[0],s=E[i];let a=y;return typeof s=="string"?a=s:(typeof s=="number"||typeof s=="boolean"||s===void 0||s===null)&&(a=String(s)),a}),N&&(F="\uFF3B"+F.replace(/[aouei]/g,"$&$&")+"\uFF3D"),F}function f(e,E){let F=e[E];return F||(F=e["*"],F)?F:null}function A(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function h(e,E,F){const y=A(e)+A(E)+"vscode/"+A(F),L=await fetch(y);if(L.ok)return await L.json();throw new Error(`${L.status} - ${L.statusText}`)}function o(e){return function(E,F){const y=Array.prototype.slice.call(arguments,2);return D(e[E],y)}}function u(e,E,...F){return D(E,F)}n.localize=u;function C(e){}n.getConfiguredDefaultLocale=C;function M(e){N=e}n.setPseudoTranslation=M;function v(e,E){return{localize:o(E[e]),getConfiguredDefaultLocale:E.getConfiguredDefaultLocale??(F=>{})}}n.create=v;function d(e,E,F,y){const L=y["vs/nls"]??{};if(!e||e.length===0)return F({localize:u,getConfiguredDefaultLocale:()=>L.availableLanguages?.["*"]});const i=L.availableLanguages?f(L.availableLanguages,e):null,s=i===null||i===t;let a=".nls";s||(a=a+"."+i);const l=c=>{Array.isArray(c)?c.localize=o(c):c.localize=o(c[e]),c.getConfiguredDefaultLocale=()=>L.availableLanguages?.["*"],F(c)};typeof L.loadBundle=="function"?L.loadBundle(e,i,(c,g)=>{c?E([e+".nls"],l):l(g)}):L.translationServiceUrl&&!s?(async()=>{try{const c=await h(L.translationServiceUrl,i,e);return l(c)}catch(c){if(!i.includes("-"))return console.error(c),E([e+".nls"],l);try{const g=i.split("-")[0],m=await h(L.translationServiceUrl,g,e);return L.availableLanguages??={},L.availableLanguages["*"]=g,l(m)}catch(g){return console.error(g),E([e+".nls"],l)}}})():E([e+a],l,c=>{if(a===".nls"){console.error("Failed trying to load default language strings",c);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,c),E([e+".nls"],l)})}n.load=d}),function(){const B=self.MonacoEnvironment,n=B&&B.baseUrl?B.baseUrl:"../../../",N=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:u=>u,createScript:(u,...C)=>{const M=C.slice(0,-1).join(","),v=C.pop().toString();return`(function anonymous(${M}) { ${v}
})`}}):void 0;function t(){try{return(N?self.eval(N.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function D(){return new Promise((u,C)=>{if(typeof self.define=="function"&&self.define.amd)return u();const M=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(M)&&M.substring(0,self.origin.length)!==self.origin)&&t()){fetch(M).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${M}`,(N?self.eval(N.createScript("",d)):new Function(d)).call(self),u()}).then(void 0,C);return}N?importScripts(N.createScriptURL(M)):importScripts(M),u()})}function f(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:N,amdModulesPattern:/^vs\//})}function A(u){D().then(()=>{f(),require([u],function(C){setTimeout(function(){const M=C.create((v,d)=>{self.postMessage(v,d)},null);for(self.onmessage=v=>M.onmessage(v.data,v.ports);o.length>0;)self.onmessage(o.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&f();let h=!0;const o=[];self.onmessage=u=>{if(!h){o.push(u);return}h=!1,A(u.data)}}(),Z(J[24],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.getClassNamesArray=n.Codicon=n.getCodiconAriaLabel=void 0;function N(A){return A?A.replace(/\$\((.*?)\)/g,(h,o)=>` ${o} `).trim():""}n.getCodiconAriaLabel=N;class t{constructor(h,o,u){this.id=h,this.definition=o,this.description=u,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}n.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(A,h){const o=["codicon","codicon-"+A];return h&&o.push("codicon-modifier-"+h),o}n.getClassNamesArray=D;var f;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function o(M){if(M instanceof t)return["codicon","codicon-"+M.id];const v=h.exec(M.id);if(!v)return o(t.error);const[,d,e]=v,E=["codicon","codicon-"+d];return e&&E.push("codicon-modifier-"+e.substr(1)),E}A.asClassNameArray=o;function u(M){return o(M).join(" ")}A.asClassName=u;function C(M){return"."+o(M).join(".")}A.asCSSSelector=C})(f=n.CSSIcon||(n.CSSIcon={}))}),Z(J[25],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class N{constructor(D,f,A,h){this.originalStart=D,this.originalLength=f,this.modifiedStart=A,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=N}),Z(J[6],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class N{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?i.isErrorNoTelemetry(l)?new i(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(c=>{c(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}n.ErrorHandler=N,n.errorHandler=new N;function t(a){n.errorHandler.setUnexpectedErrorHandler(a)}n.setUnexpectedErrorHandler=t;function D(a){o(a)||n.errorHandler.onUnexpectedError(a)}n.onUnexpectedError=D;function f(a){o(a)||n.errorHandler.onUnexpectedExternalError(a)}n.onUnexpectedExternalError=f;function A(a){if(a instanceof Error){const{name:l,message:c}=a,g=a.stacktrace||a.stack;return{$isError:!0,name:l,message:c,stack:g,noTelemetry:i.isErrorNoTelemetry(a)}}return a}n.transformErrorForSerialization=A;const h="Canceled";function o(a){return a instanceof u?!0:a instanceof Error&&a.name===h&&a.message===h}n.isCancellationError=o;class u extends Error{constructor(){super(h),this.name=this.message}}n.CancellationError=u;function C(){const a=new Error(h);return a.name=a.message,a}n.canceled=C;function M(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}n.illegalArgument=M;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}n.illegalState=v;function d(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=d;function e(a){const l=new Error(`${a} has been disposed`);return l.name="DISPOSED",l}n.disposed=e;function E(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}n.getErrorMessage=E;class F extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}n.NotImplementedError=F;class y extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}n.NotSupportedError=y;class L extends Error{constructor(){super(...arguments),this.isExpected=!0}}n.ExpectedError=L;class i extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof i)return l;const c=new i;return c.message=l.message,c.stack=l.stack,c}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}n.ErrorNoTelemetry=i;class s extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype);debugger}}n.BugIndicatingError=s}),Z(J[26],K([0,1,6]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function t(S,k=0){return S[S.length-(1+k)]}n.tail=t;function D(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}n.tail2=D;function f(S,k,I=(q,H)=>q===H){if(S===k)return!0;if(!S||!k||S.length!==k.length)return!1;for(let q=0,H=S.length;q<H;q++)if(!I(S[q],k[q]))return!1;return!0}n.equals=f;function A(S,k){const I=S.length-1;k<I&&(S[k]=S[I]),S.pop()}n.removeFastWithoutKeepingOrder=A;function h(S,k,I){return o(S.length,q=>I(S[q],k))}n.binarySearch=h;function o(S,k){let I=0,q=S-1;for(;I<=q;){const H=(I+q)/2|0,ne=k(H);if(ne<0)I=H+1;else if(ne>0)q=H-1;else return H}return-(I+1)}n.binarySearch2=o;function u(S,k){let I=0,q=S.length;if(q===0)return 0;for(;I<q;){const H=Math.floor((I+q)/2);k(S[H])?q=H:I=H+1}return I}n.findFirstInSorted=u;function C(S,k,I){if(S=S|0,S>=k.length)throw new TypeError("invalid index");const q=k[Math.floor(k.length*Math.random())],H=[],ne=[],re=[];for(const ue of k){const ae=I(ue,q);ae<0?H.push(ue):ae>0?ne.push(ue):re.push(ue)}return S<H.length?C(S,H,I):S<H.length+re.length?re[0]:C(S-(H.length+re.length),ne,I)}n.quickSelect=C;function M(S,k){const I=[];let q;for(const H of S.slice(0).sort(k))!q||k(q[0],H)!==0?(q=[H],I.push(q)):q.push(H);return I}n.groupBy=M;function v(S,k,I){const q=[];function H(ue,ae,fe){if(ae===0&&fe.length===0)return;const he=q[q.length-1];he&&he.start+he.deleteCount===ue?(he.deleteCount+=ae,he.toInsert.push(...fe)):q.push({start:ue,deleteCount:ae,toInsert:fe})}let ne=0,re=0;for(;;){if(ne===S.length){H(ne,0,k.slice(re));break}if(re===k.length){H(ne,S.length-ne,[]);break}const ue=S[ne],ae=k[re],fe=I(ue,ae);fe===0?(ne+=1,re+=1):fe<0?(H(ne,1,[]),ne+=1):fe>0&&(H(ne,0,[ae]),re+=1)}return q}n.sortedDiff=v;function d(S,k,I){const q=v(S,k,I),H=[],ne=[];for(const re of q)H.push(...S.slice(re.start,re.start+re.deleteCount)),ne.push(...re.toInsert);return{removed:H,added:ne}}n.delta=d;function e(S,k,I){if(I===0)return[];const q=S.slice(0,I).sort(k);return F(S,k,q,I,S.length),q}n.top=e;function E(S,k,I,q,H){return I===0?Promise.resolve([]):new Promise((ne,re)=>{(async()=>{const ue=S.length,ae=S.slice(0,I).sort(k);for(let fe=I,he=Math.min(I+q,ue);fe<ue;fe=he,he=Math.min(he+q,ue)){if(fe>I&&await new Promise(Se=>setTimeout(Se)),H&&H.isCancellationRequested)throw new N.CancellationError;F(S,k,ae,fe,he)}return ae})().then(ne,re)})}n.topAsync=E;function F(S,k,I,q,H){for(const ne=I.length;q<H;q++){const re=S[q];if(k(re,I[ne-1])<0){I.pop();const ue=u(I,ae=>k(re,ae)<0);I.splice(ue,0,re)}}}function y(S){return S.filter(k=>!!k)}n.coalesce=y;function L(S){let k=0;for(let I=0;I<S.length;I++)S[I]&&(S[k]=S[I],k+=1);S.length=k}n.coalesceInPlace=L;function i(S,k,I){S.splice(I,0,S.splice(k,1)[0])}n.move=i;function s(S){return!Array.isArray(S)||S.length===0}n.isFalsyOrEmpty=s;function a(S){return Array.isArray(S)&&S.length>0}n.isNonEmptyArray=a;function l(S,k=I=>I){const I=new Set;return S.filter(q=>{const H=k(q);return I.has(H)?!1:(I.add(H),!0)})}n.distinct=l;function c(S){const k=new Set;return I=>{const q=S(I);return k.has(q)?!1:(k.add(q),!0)}}n.uniqueFilter=c;function g(S,k){const I=m(S,k);if(I!==-1)return S[I]}n.findLast=g;function m(S,k){for(let I=S.length-1;I>=0;I--){const q=S[I];if(k(q))return I}return-1}n.lastIndex=m;function p(S,k){return S.length>0?S[0]:k}n.firstOrDefault=p;function b(S,k){return S.length>0?S[S.length-1]:k}n.lastOrDefault=b;function _(S,k,I=(q,H)=>q===H){let q=0;for(let H=0,ne=Math.min(S.length,k.length);H<ne&&I(S[H],k[H]);H++)q++;return q}n.commonPrefixLength=_;function w(S){return[].concat(...S)}n.flatten=w;function R(S,k){let I=typeof k=="number"?S:0;typeof k=="number"?I=S:(I=0,k=S);const q=[];if(I<=k)for(let H=I;H<k;H++)q.push(H);else for(let H=I;H>k;H--)q.push(H);return q}n.range=R;function U(S,k,I){return S.reduce((q,H)=>(q[k(H)]=I?I(H):H,q),Object.create(null))}n.index=U;function O(S,k){return S.push(k),()=>V(S,k)}n.insert=O;function V(S,k){const I=S.indexOf(k);if(I>-1)return S.splice(I,1),k}n.remove=V;function $(S,k,I){const q=S.slice(0,k),H=S.slice(k);return q.concat(I,H)}n.arrayInsert=$;function z(S,k){let I;if(typeof k=="number"){let q=k;I=()=>{const H=Math.sin(q++)*179426549;return H-Math.floor(H)}}else I=Math.random;for(let q=S.length-1;q>0;q-=1){const H=Math.floor(I()*(q+1)),ne=S[q];S[q]=S[H],S[H]=ne}}n.shuffle=z;function X(S,k){const I=S.indexOf(k);I>-1&&(S.splice(I,1),S.unshift(k))}n.pushToStart=X;function se(S,k){const I=S.indexOf(k);I>-1&&(S.splice(I,1),S.push(k))}n.pushToEnd=se;function te(S,k){for(const I of k)S.push(I)}n.pushMany=te;function x(S,k){return Array.isArray(S)?S.map(k):k(S)}n.mapArrayOrNot=x;function r(S){return Array.isArray(S)?S:[S]}n.asArray=r;function Ae(S){return S[Math.floor(Math.random()*S.length)]}n.getRandomElement=Ae;function Ee(S,k){for(const I of S){const q=k(I);if(q!==void 0)return q}}n.mapFind=Ee;function de(S,k,I){const q=we(S,k),H=S.length,ne=I.length;S.length=H+ne;for(let re=H-1;re>=q;re--)S[re+ne]=S[re];for(let re=0;re<ne;re++)S[re+q]=I[re]}n.insertInto=de;function pe(S,k,I,q){const H=we(S,k),ne=S.splice(H,I);return de(S,H,q),ne}n.splice=pe;function we(S,k){return k<0?Math.max(k+S.length,0):Math.min(k,S.length)}var ve;(function(S){function k(H){return H<0}S.isLessThan=k;function I(H){return H>0}S.isGreaterThan=I;function q(H){return H===0}S.isNeitherLessOrGreaterThan=q,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(ve=n.CompareResult||(n.CompareResult={}));function ye(S,k){return(I,q)=>k(S(I),S(q))}n.compareBy=ye;function Re(...S){return(k,I)=>{for(const q of S){const H=q(k,I);if(!ve.isNeitherLessOrGreaterThan(H))return H}return ve.neitherLessOrGreaterThan}}n.tieBreakComparators=Re;const De=(S,k)=>S-k;n.numberComparator=De;function Ce(S,k){if(S.length===0)return;let I=S[0];for(let q=1;q<S.length;q++){const H=S[q];k(H,I)>0&&(I=H)}return I}n.findMaxBy=Ce;function Fe(S,k){if(S.length===0)return;let I=S[0];for(let q=1;q<S.length;q++){const H=S[q];k(H,I)>=0&&(I=H)}return I}n.findLastMaxBy=Fe;function ee(S,k){return Ce(S,(I,q)=>-k(I,q))}n.findMinBy=ee;class G{constructor(k){this.items=k,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(k){let I=this.firstIdx;for(;I<this.items.length&&k(this.items[I]);)I++;const q=I===this.firstIdx?null:this.items.slice(this.firstIdx,I);return this.firstIdx=I,q}takeFromEndWhile(k){let I=this.lastIdx;for(;I>=0&&k(this.items[I]);)I--;const q=I===this.lastIdx?null:this.items.slice(I+1,this.lastIdx+1);return this.lastIdx=I,q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const k=this.items[this.firstIdx];return this.firstIdx++,k}removeLast(){const k=this.items[this.lastIdx];return this.lastIdx--,k}takeCount(k){const I=this.items.slice(this.firstIdx,this.firstIdx+k);return this.firstIdx+=k,I}}n.ArrayQueue=G;class Y{constructor(k){this.iterate=k}forEach(k){this.iterate(I=>(k(I),!0))}toArray(){const k=[];return this.iterate(I=>(k.push(I),!0)),k}filter(k){return new Y(I=>this.iterate(q=>k(q)?I(q):!0))}map(k){return new Y(I=>this.iterate(q=>I(k(q))))}some(k){let I=!1;return this.iterate(q=>(I=k(q),!I)),I}findFirst(k){let I;return this.iterate(q=>k(q)?(I=q,!1):!0),I}findLast(k){let I;return this.iterate(q=>(k(q)&&(I=q),!0)),I}findLastMaxBy(k){let I,q=!0;return this.iterate(H=>((q||ve.isGreaterThan(k(H,I)))&&(q=!1,I=H),!0)),I}}n.CallbackIterable=Y,Y.empty=new Y(S=>{})}),Z(J[10],K([0,1,6]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assert=n.assertNever=n.ok=void 0;function t(o,u){if(!o)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}n.ok=t;function D(o,u="Unreachable"){throw new Error(u)}n.assertNever=D;function f(o){if(!o)throw new N.BugIndicatingError("Assertion Failed")}n.assert=f;function A(o){if(!o()){debugger;o(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}n.assertFn=A;function h(o,u){let C=0;for(;C<o.length-1;){const M=o[C],v=o[C+1];if(!u(M,v))return!1;C++}return!0}n.checkAdjacentItems=h}),Z(J[13],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function N(t){const D=this;let f=!1,A;return function(){return f||(f=!0,A=t.apply(D,arguments)),A}}n.once=N}),Z(J[14],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var N;(function(t){function D(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}t.is=D;const f=Object.freeze([]);function A(){return f}t.empty=A;function*h(s){yield s}t.single=h;function o(s){return D(s)?s:h(s)}t.wrap=o;function u(s){return s||f}t.from=u;function C(s){return!s||s[Symbol.iterator]().next().done===!0}t.isEmpty=C;function M(s){return s[Symbol.iterator]().next().value}t.first=M;function v(s,a){for(const l of s)if(a(l))return!0;return!1}t.some=v;function d(s,a){for(const l of s)if(a(l))return l}t.find=d;function*e(s,a){for(const l of s)a(l)&&(yield l)}t.filter=e;function*E(s,a){let l=0;for(const c of s)yield a(c,l++)}t.map=E;function*F(...s){for(const a of s)for(const l of a)yield l}t.concat=F;function y(s,a,l){let c=l;for(const g of s)c=a(c,g);return c}t.reduce=y;function*L(s,a,l=s.length){for(a<0&&(a+=s.length),l<0?l+=s.length:l>s.length&&(l=s.length);a<l;a++)yield s[a]}t.slice=L;function i(s,a=Number.POSITIVE_INFINITY){const l=[];if(a===0)return[l,s];const c=s[Symbol.iterator]();for(let g=0;g<a;g++){const m=c.next();if(m.done)return[l,t.empty()];l.push(m.value)}return[l,{[Symbol.iterator](){return c}}]}t.consume=i})(N=n.Iterable||(n.Iterable={}))}),Z(J[27],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(N=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,F){this._keyCodeToStr[E]=F,this._strToKeyCode[F.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const f=new D,A=new D,h=new D;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const o=[],u=Object.create(null),C=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>C[e]||0,toEnum:e=>u[e]||0,toString:e=>o[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",E=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],F=[],y=[];for(const L of E){const[i,s,a,l,c,g,m,p,b,_]=L;if(y[a]||(y[a]=!0,o[a]=l,u[l]=a,C[l.toLowerCase()]=a,s&&(n.IMMUTABLE_CODE_TO_KEY_CODE[a]=c,c!==0&&c!==3&&c!==5&&c!==4&&c!==6&&c!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[c]=a))),!F[c]){if(F[c]=!0,!g)throw new Error(`String representation missing for key code ${c} around scan code ${l}`);f.define(c,g),A.define(c,b||g),h.define(c,_||b||g)}m&&(n.EVENT_KEY_CODE_MAP[m]=c),p&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[p]=c)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function E(a){return f.keyCodeToStr(a)}e.toString=E;function F(a){return f.strToKeyCode(a)}e.fromString=F;function y(a){return A.keyCodeToStr(a)}e.toUserSettingsUS=y;function L(a){return h.keyCodeToStr(a)}e.toUserSettingsGeneral=L;function i(a){return A.strToKeyCode(a)||h.strToKeyCode(a)}e.fromUserSettings=i;function s(a){if(a>=93&&a<=108)return null;switch(a){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(a)}e.toElectronAccelerator=s})(M=n.KeyCodeUtils||(n.KeyCodeUtils={}));var v;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(v=n.KeyMod||(n.KeyMod={}));function d(e,E){const F=(E&65535)<<16>>>0;return(e|F)>>>0}n.KeyChord=d}),Z(J[28],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class N{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new N(()=>D(this.getValue()))}}n.Lazy=N}),Z(J[7],K([0,1,13,14]),function(B,n,N,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.disposeIfDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const D=!1;let f=null;function A(b){f=b}if(n.setDisposableTracker=A,D){const b="__is_disposable_tracked__";A(new class{trackDisposable(_){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[b]||console.log(w)},3e3)}setParent(_,w){if(_&&_!==L.None)try{_[b]=!0}catch{}}markAsDisposed(_){if(_&&_!==L.None)try{_[b]=!0}catch{}}markAsSingleton(_){}})}function h(b){return f?.trackDisposable(b),b}function o(b){f?.markAsDisposed(b)}function u(b,_){f?.setParent(b,_)}function C(b,_){if(!!f)for(const w of b)f.setParent(w,_)}function M(b){return f?.markAsSingleton(b),b}n.markAsSingleton=M;function v(b){return typeof b.dispose=="function"&&b.dispose.length===0}n.isDisposable=v;function d(b){if(t.Iterable.is(b)){const _=[];for(const w of b)if(w)try{w.dispose()}catch(R){_.push(R)}if(_.length===1)throw _[0];if(_.length>1)throw new AggregateError(_,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}n.dispose=d;function e(b){for(const _ of b)v(_)&&_.dispose();return[]}n.disposeIfDisposable=e;function E(...b){const _=F(()=>d(b));return C(b,_),_}n.combinedDisposable=E;function F(b){const _=h({dispose:(0,N.once)(()=>{o(_),b()})});return _}n.toDisposable=F;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,h(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return u(_,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(_),_}}n.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class L{constructor(){this._store=new y,h(this),u(this._store,this)}dispose(){o(this),this._store.dispose()}_register(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(_)}}n.Disposable=L,L.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(_){this._isDisposed||_===this._value||(this._value?.dispose(),_&&u(_,this),this._value=_)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const _=this._value;return this._value=void 0,_&&u(_,null),_}}n.MutableDisposable=i;class s{constructor(_){this._disposable=_,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(_){let w=_;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,o(this))},this}}n.SafeDisposable=a;class l{constructor(){this.references=new Map}acquire(_,...w){let R=this.references.get(_);R||(R={counter:0,object:this.createReferencedObject(_,...w)},this.references.set(_,R));const{object:U}=R,O=(0,N.once)(()=>{--R.counter===0&&(this.destroyReferencedObject(_,R.object),this.references.delete(_))});return R.counter++,{object:U,dispose:O}}}n.ReferenceCollection=l;class c{constructor(_){this.referenceCollection=_}async acquire(_,...w){const R=this.referenceCollection.acquire(_,...w);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(U){throw R.dispose(),U}}}n.AsyncReferenceCollection=c;class g{constructor(_){this.object=_}dispose(){}}n.ImmortalReference=g;function m(b){const _=new y;try{b(_)}finally{_.dispose()}}n.disposeOnReturn=m;class p{constructor(){this._store=new Map,this._isDisposed=!1,h(this)}dispose(){o(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(_){return this._store.has(_)}get(_){return this._store.get(_)}set(_,w,R=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this._store.get(_)?.dispose(),this._store.set(_,w)}deleteAndDispose(_){this._store.get(_)?.dispose(),this._store.delete(_)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=p}),Z(J[15],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class N{constructor(f){this.element=f,this.next=N.Undefined,this.prev=N.Undefined}}N.Undefined=new N(void 0);class t{constructor(){this._first=N.Undefined,this._last=N.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===N.Undefined}clear(){let f=this._first;for(;f!==N.Undefined;){const A=f.next;f.prev=N.Undefined,f.next=N.Undefined,f=A}this._first=N.Undefined,this._last=N.Undefined,this._size=0}unshift(f){return this._insert(f,!1)}push(f){return this._insert(f,!0)}_insert(f,A){const h=new N(f);if(this._first===N.Undefined)this._first=h,this._last=h;else if(A){const u=this._last;this._last=h,h.prev=u,u.next=h}else{const u=this._first;this._first=h,h.next=u,u.prev=h}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(h))}}shift(){if(this._first!==N.Undefined){const f=this._first.element;return this._remove(this._first),f}}pop(){if(this._last!==N.Undefined){const f=this._last.element;return this._remove(this._last),f}}_remove(f){if(f.prev!==N.Undefined&&f.next!==N.Undefined){const A=f.prev;A.next=f.next,f.next.prev=A}else f.prev===N.Undefined&&f.next===N.Undefined?(this._first=N.Undefined,this._last=N.Undefined):f.next===N.Undefined?(this._last=this._last.prev,this._last.next=N.Undefined):f.prev===N.Undefined&&(this._first=this._first.next,this._first.prev=N.Undefined);this._size-=1}*[Symbol.iterator](){let f=this._first;for(;f!==N.Undefined;)yield f.element,f=f.next}}n.LinkedList=t}),Z(J[5],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.setTimeout0IsFaster=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let N=!1,t=!1,D=!1,f=!1,A=!1,h=!1,o=!1,u=!1,C=!1,M=!1,v,d=n.LANGUAGE_DEFAULT,e,E;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let F;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?F=n.globals.vscode.process:typeof process<"u"&&(F=process);const y=typeof F?.versions?.electron=="string",L=y&&F?.type==="renderer";if(typeof navigator=="object"&&!L){E=navigator.userAgent,N=E.indexOf("Windows")>=0,t=E.indexOf("Macintosh")>=0,u=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=E.indexOf("Linux")>=0,M=E?.indexOf("Mobi")>=0,h=!0,v=n.LANGUAGE_DEFAULT,d=v;const b=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),_=b&&b.getAttribute("data-settings");if(_)try{const w=JSON.parse(_);v=w.locale,e=w._translationsConfigFile,d=w.availableLanguages["*"]||n.LANGUAGE_DEFAULT}catch{}}else if(typeof F=="object"){N=F.platform==="win32",t=F.platform==="darwin",D=F.platform==="linux",f=D&&!!F.env.SNAP&&!!F.env.SNAP_REVISION,o=y,C=!!F.env.CI||!!F.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=n.LANGUAGE_DEFAULT,d=n.LANGUAGE_DEFAULT;const b=F.env.VSCODE_NLS_CONFIG;if(b)try{const _=JSON.parse(b),w=_.availableLanguages["*"];v=_.locale,d=w||n.LANGUAGE_DEFAULT,e=_._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var i;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(i=n.Platform||(n.Platform={}));function s(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=s;let a=0;t?a=1:N?a=3:D&&(a=2),n.isWindows=N,n.isMacintosh=t,n.isLinux=D,n.isLinuxSnap=f,n.isNative=A,n.isElectron=o,n.isWeb=h,n.isWebWorker=h&&typeof n.globals.importScripts=="function",n.isIOS=u,n.isMobile=M,n.isCI=C,n.platform=a,n.userAgent=E,n.language=d;var l;(function(b){function _(){return n.language}b.value=_;function w(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}b.isDefaultVariant=w;function R(){return n.language==="en"}b.isDefault=R})(l=n.Language||(n.Language={})),n.locale=v,n.translationsConfigFile=e,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const b=[];n.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let R=0,U=b.length;R<U;R++){const O=b[R];if(O.id===w.data.vscodeScheduleAsyncWork){b.splice(R,1),O.callback();return}}});let _=0;return w=>{const R=++_;b.push({id:R,callback:w}),n.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return b=>setTimeout(b)})();var c;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(c=n.OperatingSystem||(n.OperatingSystem={})),n.OS=t||u?2:N?1:3;let g=!0,m=!1;function p(){if(!m){m=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,g=new Uint16Array(b.buffer)[0]===(2<<8)+1}return g}n.isLittleEndian=p,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Z(J[29],K([0,1,5]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof N.globals.vscode<"u"&&typeof N.globals.vscode.process<"u"){const D=N.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return N.isWindows?"win32":N.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),Z(J[30],K([0,1,29]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,D=97,f=90,A=122,h=46,o=47,u=92,C=58,M=63;class v extends Error{constructor(s,a,l){let c;typeof a=="string"&&a.indexOf("not ")===0?(c="must not be",a=a.replace(/^not /,"")):c="must be";const g=s.indexOf(".")!==-1?"property":"argument";let m=`The "${s}" ${g} ${c} of type ${a}`;m+=`. Received type ${typeof l}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,s){if(typeof i!="string")throw new v(s,"string",i)}function e(i){return i===o||i===u}function E(i){return i===o}function F(i){return i>=t&&i<=f||i>=D&&i<=A}function y(i,s,a,l){let c="",g=0,m=-1,p=0,b=0;for(let _=0;_<=i.length;++_){if(_<i.length)b=i.charCodeAt(_);else{if(l(b))break;b=o}if(l(b)){if(!(m===_-1||p===1))if(p===2){if(c.length<2||g!==2||c.charCodeAt(c.length-1)!==h||c.charCodeAt(c.length-2)!==h){if(c.length>2){const w=c.lastIndexOf(a);w===-1?(c="",g=0):(c=c.slice(0,w),g=c.length-1-c.lastIndexOf(a)),m=_,p=0;continue}else if(c.length!==0){c="",g=0,m=_,p=0;continue}}s&&(c+=c.length>0?`${a}..`:"..",g=2)}else c.length>0?c+=`${a}${i.slice(m+1,_)}`:c=i.slice(m+1,_),g=_-m-1;m=_,p=0}else b===h&&p!==-1?++p:p=-1}return c}function L(i,s){if(s===null||typeof s!="object")throw new v("pathObject","Object",s);const a=s.dir||s.root,l=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${l}`:`${a}${i}${l}`:l}n.win32={resolve(...i){let s="",a="",l=!1;for(let c=i.length-1;c>=-1;c--){let g;if(c>=0){if(g=i[c],d(g,"path"),g.length===0)continue}else s.length===0?g=N.cwd():(g=N.env[`=${s}`]||N.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==s.toLowerCase()&&g.charCodeAt(2)===u)&&(g=`${s}\\`));const m=g.length;let p=0,b="",_=!1;const w=g.charCodeAt(0);if(m===1)e(w)&&(p=1,_=!0);else if(e(w))if(_=!0,e(g.charCodeAt(1))){let R=2,U=R;for(;R<m&&!e(g.charCodeAt(R));)R++;if(R<m&&R!==U){const O=g.slice(U,R);for(U=R;R<m&&e(g.charCodeAt(R));)R++;if(R<m&&R!==U){for(U=R;R<m&&!e(g.charCodeAt(R));)R++;(R===m||R!==U)&&(b=`\\\\${O}\\${g.slice(U,R)}`,p=R)}}}else p=1;else F(w)&&g.charCodeAt(1)===C&&(b=g.slice(0,2),p=2,m>2&&e(g.charCodeAt(2))&&(_=!0,p=3));if(b.length>0)if(s.length>0){if(b.toLowerCase()!==s.toLowerCase())continue}else s=b;if(l){if(s.length>0)break}else if(a=`${g.slice(p)}\\${a}`,l=_,_&&s.length>0)break}return a=y(a,!l,"\\",e),l?`${s}\\${a}`:`${s}${a}`||"."},normalize(i){d(i,"path");const s=i.length;if(s===0)return".";let a=0,l,c=!1;const g=i.charCodeAt(0);if(s===1)return E(g)?"\\":i;if(e(g))if(c=!0,e(i.charCodeAt(1))){let p=2,b=p;for(;p<s&&!e(i.charCodeAt(p));)p++;if(p<s&&p!==b){const _=i.slice(b,p);for(b=p;p<s&&e(i.charCodeAt(p));)p++;if(p<s&&p!==b){for(b=p;p<s&&!e(i.charCodeAt(p));)p++;if(p===s)return`\\\\${_}\\${i.slice(b)}\\`;p!==b&&(l=`\\\\${_}\\${i.slice(b,p)}`,a=p)}}}else a=1;else F(g)&&i.charCodeAt(1)===C&&(l=i.slice(0,2),a=2,s>2&&e(i.charCodeAt(2))&&(c=!0,a=3));let m=a<s?y(i.slice(a),!c,"\\",e):"";return m.length===0&&!c&&(m="."),m.length>0&&e(i.charCodeAt(s-1))&&(m+="\\"),l===void 0?c?`\\${m}`:m:c?`${l}\\${m}`:`${l}${m}`},isAbsolute(i){d(i,"path");const s=i.length;if(s===0)return!1;const a=i.charCodeAt(0);return e(a)||s>2&&F(a)&&i.charCodeAt(1)===C&&e(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,a;for(let g=0;g<i.length;++g){const m=i[g];d(m,"path"),m.length>0&&(s===void 0?s=a=m:s+=`\\${m}`)}if(s===void 0)return".";let l=!0,c=0;if(typeof a=="string"&&e(a.charCodeAt(0))){++c;const g=a.length;g>1&&e(a.charCodeAt(1))&&(++c,g>2&&(e(a.charCodeAt(2))?++c:l=!1))}if(l){for(;c<s.length&&e(s.charCodeAt(c));)c++;c>=2&&(s=`\\${s.slice(c)}`)}return n.win32.normalize(s)},relative(i,s){if(d(i,"from"),d(s,"to"),i===s)return"";const a=n.win32.resolve(i),l=n.win32.resolve(s);if(a===l||(i=a.toLowerCase(),s=l.toLowerCase(),i===s))return"";let c=0;for(;c<i.length&&i.charCodeAt(c)===u;)c++;let g=i.length;for(;g-1>c&&i.charCodeAt(g-1)===u;)g--;const m=g-c;let p=0;for(;p<s.length&&s.charCodeAt(p)===u;)p++;let b=s.length;for(;b-1>p&&s.charCodeAt(b-1)===u;)b--;const _=b-p,w=m<_?m:_;let R=-1,U=0;for(;U<w;U++){const V=i.charCodeAt(c+U);if(V!==s.charCodeAt(p+U))break;V===u&&(R=U)}if(U!==w){if(R===-1)return l}else{if(_>w){if(s.charCodeAt(p+U)===u)return l.slice(p+U+1);if(U===2)return l.slice(p+U)}m>w&&(i.charCodeAt(c+U)===u?R=U:U===2&&(R=3)),R===-1&&(R=0)}let O="";for(U=c+R+1;U<=g;++U)(U===g||i.charCodeAt(U)===u)&&(O+=O.length===0?"..":"\\..");return p+=R,O.length>0?`${O}${l.slice(p,b)}`:(l.charCodeAt(p)===u&&++p,l.slice(p,b))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const s=n.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const a=s.charCodeAt(2);if(a!==M&&a!==h)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(F(s.charCodeAt(0))&&s.charCodeAt(1)===C&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return i},dirname(i){d(i,"path");const s=i.length;if(s===0)return".";let a=-1,l=0;const c=i.charCodeAt(0);if(s===1)return e(c)?i:".";if(e(c)){if(a=l=1,e(i.charCodeAt(1))){let p=2,b=p;for(;p<s&&!e(i.charCodeAt(p));)p++;if(p<s&&p!==b){for(b=p;p<s&&e(i.charCodeAt(p));)p++;if(p<s&&p!==b){for(b=p;p<s&&!e(i.charCodeAt(p));)p++;if(p===s)return i;p!==b&&(a=l=p+1)}}}}else F(c)&&i.charCodeAt(1)===C&&(a=s>2&&e(i.charCodeAt(2))?3:2,l=a);let g=-1,m=!0;for(let p=s-1;p>=l;--p)if(e(i.charCodeAt(p))){if(!m){g=p;break}}else m=!1;if(g===-1){if(a===-1)return".";g=a}return i.slice(0,g)},basename(i,s){s!==void 0&&d(s,"ext"),d(i,"path");let a=0,l=-1,c=!0,g;if(i.length>=2&&F(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(a=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let m=s.length-1,p=-1;for(g=i.length-1;g>=a;--g){const b=i.charCodeAt(g);if(e(b)){if(!c){a=g+1;break}}else p===-1&&(c=!1,p=g+1),m>=0&&(b===s.charCodeAt(m)?--m===-1&&(l=g):(m=-1,l=p))}return a===l?l=p:l===-1&&(l=i.length),i.slice(a,l)}for(g=i.length-1;g>=a;--g)if(e(i.charCodeAt(g))){if(!c){a=g+1;break}}else l===-1&&(c=!1,l=g+1);return l===-1?"":i.slice(a,l)},extname(i){d(i,"path");let s=0,a=-1,l=0,c=-1,g=!0,m=0;i.length>=2&&i.charCodeAt(1)===C&&F(i.charCodeAt(0))&&(s=l=2);for(let p=i.length-1;p>=s;--p){const b=i.charCodeAt(p);if(e(b)){if(!g){l=p+1;break}continue}c===-1&&(g=!1,c=p+1),b===h?a===-1?a=p:m!==1&&(m=1):a!==-1&&(m=-1)}return a===-1||c===-1||m===0||m===1&&a===c-1&&a===l+1?"":i.slice(a,c)},format:L.bind(null,"\\"),parse(i){d(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.length;let l=0,c=i.charCodeAt(0);if(a===1)return e(c)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(e(c)){if(l=1,e(i.charCodeAt(1))){let R=2,U=R;for(;R<a&&!e(i.charCodeAt(R));)R++;if(R<a&&R!==U){for(U=R;R<a&&e(i.charCodeAt(R));)R++;if(R<a&&R!==U){for(U=R;R<a&&!e(i.charCodeAt(R));)R++;R===a?l=R:R!==U&&(l=R+1)}}}}else if(F(c)&&i.charCodeAt(1)===C){if(a<=2)return s.root=s.dir=i,s;if(l=2,e(i.charCodeAt(2))){if(a===3)return s.root=s.dir=i,s;l=3}}l>0&&(s.root=i.slice(0,l));let g=-1,m=l,p=-1,b=!0,_=i.length-1,w=0;for(;_>=l;--_){if(c=i.charCodeAt(_),e(c)){if(!b){m=_+1;break}continue}p===-1&&(b=!1,p=_+1),c===h?g===-1?g=_:w!==1&&(w=1):g!==-1&&(w=-1)}return p!==-1&&(g===-1||w===0||w===1&&g===p-1&&g===m+1?s.base=s.name=i.slice(m,p):(s.name=i.slice(m,g),s.base=i.slice(m,p),s.ext=i.slice(g,p))),m>0&&m!==l?s.dir=i.slice(0,m-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...i){let s="",a=!1;for(let l=i.length-1;l>=-1&&!a;l--){const c=l>=0?i[l]:N.cwd();d(c,"path"),c.length!==0&&(s=`${c}/${s}`,a=c.charCodeAt(0)===o)}return s=y(s,!a,"/",E),a?`/${s}`:s.length>0?s:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===o,a=i.charCodeAt(i.length-1)===o;return i=y(i,!s,"/",E),i.length===0?s?"/":a?"./":".":(a&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===o},join(...i){if(i.length===0)return".";let s;for(let a=0;a<i.length;++a){const l=i[a];d(l,"path"),l.length>0&&(s===void 0?s=l:s+=`/${l}`)}return s===void 0?".":n.posix.normalize(s)},relative(i,s){if(d(i,"from"),d(s,"to"),i===s||(i=n.posix.resolve(i),s=n.posix.resolve(s),i===s))return"";const a=1,l=i.length,c=l-a,g=1,m=s.length-g,p=c<m?c:m;let b=-1,_=0;for(;_<p;_++){const R=i.charCodeAt(a+_);if(R!==s.charCodeAt(g+_))break;R===o&&(b=_)}if(_===p)if(m>p){if(s.charCodeAt(g+_)===o)return s.slice(g+_+1);if(_===0)return s.slice(g+_)}else c>p&&(i.charCodeAt(a+_)===o?b=_:_===0&&(b=0));let w="";for(_=a+b+1;_<=l;++_)(_===l||i.charCodeAt(_)===o)&&(w+=w.length===0?"..":"/..");return`${w}${s.slice(g+b)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===o;let a=-1,l=!0;for(let c=i.length-1;c>=1;--c)if(i.charCodeAt(c)===o){if(!l){a=c;break}}else l=!1;return a===-1?s?"/":".":s&&a===1?"//":i.slice(0,a)},basename(i,s){s!==void 0&&d(s,"ext"),d(i,"path");let a=0,l=-1,c=!0,g;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let m=s.length-1,p=-1;for(g=i.length-1;g>=0;--g){const b=i.charCodeAt(g);if(b===o){if(!c){a=g+1;break}}else p===-1&&(c=!1,p=g+1),m>=0&&(b===s.charCodeAt(m)?--m===-1&&(l=g):(m=-1,l=p))}return a===l?l=p:l===-1&&(l=i.length),i.slice(a,l)}for(g=i.length-1;g>=0;--g)if(i.charCodeAt(g)===o){if(!c){a=g+1;break}}else l===-1&&(c=!1,l=g+1);return l===-1?"":i.slice(a,l)},extname(i){d(i,"path");let s=-1,a=0,l=-1,c=!0,g=0;for(let m=i.length-1;m>=0;--m){const p=i.charCodeAt(m);if(p===o){if(!c){a=m+1;break}continue}l===-1&&(c=!1,l=m+1),p===h?s===-1?s=m:g!==1&&(g=1):s!==-1&&(g=-1)}return s===-1||l===-1||g===0||g===1&&s===l-1&&s===a+1?"":i.slice(s,l)},format:L.bind(null,"/"),parse(i){d(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.charCodeAt(0)===o;let l;a?(s.root="/",l=1):l=0;let c=-1,g=0,m=-1,p=!0,b=i.length-1,_=0;for(;b>=l;--b){const w=i.charCodeAt(b);if(w===o){if(!p){g=b+1;break}continue}m===-1&&(p=!1,m=b+1),w===h?c===-1?c=b:_!==1&&(_=1):c!==-1&&(_=-1)}if(m!==-1){const w=g===0&&a?1:g;c===-1||_===0||_===1&&c===m-1&&c===g+1?s.base=s.name=i.slice(w,m):(s.name=i.slice(w,c),s.base=i.slice(w,m),s.ext=i.slice(c,m))}return g>0?s.dir=i.slice(0,g-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=N.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=N.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=N.platform==="win32"?n.win32.join:n.posix.join,n.resolve=N.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=N.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=N.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=N.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=N.platform==="win32"?n.win32.extname:n.posix.extname,n.format=N.platform==="win32"?n.win32.format:n.posix.format,n.parse=N.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=N.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=N.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=N.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),Z(J[16],K([0,1,5]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=N.globals.performance&&typeof N.globals.performance.now=="function";class D{static create(A=!0){return new D(A)}constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?N.globals.performance.now():Date.now()}}n.StopWatch=D}),Z(J[8],K([0,1,6,13,7,15,16]),function(B,n,N,t,D,f,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.EventDeliveryQueue=n.Emitter=n.setGlobalLeakWarningThreshold=n.EventProfiling=n.Event=void 0;const h=!1,o=!1;var u;(function(b){b.None=()=>D.Disposable.None;function _(ee){if(o){const{onListenerDidAdd:G}=ee,Y=e.create();let S=0;ee.onListenerDidAdd=()=>{++S===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),G?.()}}}function w(ee,G){return x(ee,()=>{},0,void 0,void 0,G)}b.defer=w;function R(ee,G=0,Y){return b.debounce(ee,(S,k)=>S?(S.push(k),S):[k],G,void 0,void 0,Y)}b.accumulate=R;function U(ee){return(G,Y=null,S)=>{let k=!1,I;return I=ee(q=>{if(!k)return I?I.dispose():k=!0,G.call(Y,q)},null,S),k&&I.dispose(),I}}b.once=U;function O(ee,G,Y){return te((S,k=null,I)=>ee(q=>S.call(k,G(q)),null,I),Y)}b.map=O;function V(ee,G,Y){return te((S,k=null,I)=>ee(q=>{G(q),S.call(k,q)},null,I),Y)}b.forEach=V;function $(ee,G,Y){return te((S,k=null,I)=>ee(q=>G(q)&&S.call(k,q),null,I),Y)}b.filter=$;function z(ee){return ee}b.signal=z;function X(...ee){return(G,Y=null,S)=>(0,D.combinedDisposable)(...ee.map(k=>k(I=>G.call(Y,I),null,S)))}b.any=X;function se(ee,G,Y,S){let k=Y;return O(ee,I=>(k=G(k,I),k),S)}b.reduce=se;function te(ee,G){let Y;const S={onFirstListenerAdd(){Y=ee(k.fire,k)},onLastListenerRemove(){Y?.dispose()}};G||_(S);const k=new F(S);return G?.add(k),k.event}function x(ee,G,Y=100,S=!1,k,I){let q,H,ne,re=0;const ue={leakWarningThreshold:k,onFirstListenerAdd(){q=ee(fe=>{re++,H=G(H,fe),S&&!ne&&(ae.fire(H),H=void 0),clearTimeout(ne),ne=setTimeout(()=>{const he=H;H=void 0,ne=void 0,(!S||re>1)&&ae.fire(he),re=0},Y)})},onLastListenerRemove(){q.dispose()}};I||_(ue);const ae=new F(ue);return I?.add(ae),ae.event}b.debounce=x;function r(ee,G=(S,k)=>S===k,Y){let S=!0,k;return $(ee,I=>{const q=S||!G(I,k);return S=!1,k=I,q},Y)}b.latch=r;function Ae(ee,G,Y){return[b.filter(ee,G,Y),b.filter(ee,S=>!G(S),Y)]}b.split=Ae;function Ee(ee,G=!1,Y=[]){let S=Y.slice(),k=ee(H=>{S?S.push(H):q.fire(H)});const I=()=>{S?.forEach(H=>q.fire(H)),S=null},q=new F({onFirstListenerAdd(){k||(k=ee(H=>q.fire(H)))},onFirstListenerDidAdd(){S&&(G?setTimeout(I):I())},onLastListenerRemove(){k&&k.dispose(),k=null}});return q.event}b.buffer=Ee;class de{constructor(G){this.event=G,this.disposables=new D.DisposableStore}map(G){return new de(O(this.event,G,this.disposables))}forEach(G){return new de(V(this.event,G,this.disposables))}filter(G){return new de($(this.event,G,this.disposables))}reduce(G,Y){return new de(se(this.event,G,Y,this.disposables))}latch(){return new de(r(this.event,void 0,this.disposables))}debounce(G,Y=100,S=!1,k){return new de(x(this.event,G,Y,S,k,this.disposables))}on(G,Y,S){return this.event(G,Y,S)}once(G,Y,S){return U(this.event)(G,Y,S)}dispose(){this.disposables.dispose()}}function pe(ee){return new de(ee)}b.chain=pe;function we(ee,G,Y=S=>S){const S=(...H)=>q.fire(Y(...H)),k=()=>ee.on(G,S),I=()=>ee.removeListener(G,S),q=new F({onFirstListenerAdd:k,onLastListenerRemove:I});return q.event}b.fromNodeEventEmitter=we;function ve(ee,G,Y=S=>S){const S=(...H)=>q.fire(Y(...H)),k=()=>ee.addEventListener(G,S),I=()=>ee.removeEventListener(G,S),q=new F({onFirstListenerAdd:k,onLastListenerRemove:I});return q.event}b.fromDOMEventEmitter=ve;function ye(ee){return new Promise(G=>U(ee)(G))}b.toPromise=ye;function Re(ee,G){return G(void 0),ee(Y=>G(Y))}b.runAndSubscribe=Re;function De(ee,G){let Y=null;function S(I){Y?.dispose(),Y=new D.DisposableStore,G(I,Y)}S(void 0);const k=ee(I=>S(I));return(0,D.toDisposable)(()=>{k.dispose(),Y?.dispose()})}b.runAndSubscribeWithStore=De;class Ce{constructor(G,Y){this.obs=G,this._counter=0,this._hasChanged=!1;const S={onFirstListenerAdd:()=>{G.addObserver(this)},onLastListenerRemove:()=>{G.removeObserver(this)}};Y||_(S),this.emitter=new F(S),Y&&Y.add(this.emitter)}beginUpdate(G){this._counter++}handleChange(G,Y){this._hasChanged=!0}endUpdate(G){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Fe(ee,G){return new Ce(ee,G).emitter.event}b.fromObservable=Fe})(u=n.Event||(n.Event={}));class C{constructor(_){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${_}_${C._idPool++}`,C.all.add(this)}start(_){this._stopWatch=new A.StopWatch(!0),this.listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this.durations.push(_),this.elapsedOverall+=_,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=C,C.all=new Set,C._idPool=0;let M=-1;function v(b){const _=M;return M=b,{dispose(){M=_}}}n.setGlobalLeakWarningThreshold=v;class d{constructor(_,w=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=w,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_,w){let R=M;if(typeof this.customThreshold=="number"&&(R=this.customThreshold),R<=0||w<R)return;this._stacks||(this._stacks=new Map);const U=this._stacks.get(_.value)||0;if(this._stacks.set(_.value,U+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=R*.5;let O,V=0;for(const[$,z]of this._stacks)(!O||V<z)&&(O=$,V=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${V}):`),console.warn(O)}return()=>{const O=this._stacks.get(_.value)||0;this._stacks.set(_.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(_){this.value=_}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(_,w,R){this.callback=_,this.callbackThis=w,this.stack=R,this.subscription=new D.SafeDisposable}invoke(_){this.callback.call(this.callbackThis,_)}}class F{constructor(_){this._disposed=!1,this._options=_,this._leakageMon=M>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(h){const _=Array.from(this._listeners);queueMicrotask(()=>{for(const w of _)w.subscription.isset()&&(w.subscription.unset(),w.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(_,w,R)=>{this._listeners||(this._listeners=new f.LinkedList);const U=this._listeners.isEmpty();U&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,V;this._leakageMon&&this._listeners.size>=30&&(V=e.create(),O=this._leakageMon.check(V,this._listeners.size+1)),h&&(V=V??e.create());const $=new E(_,w,V),z=this._listeners.push($);U&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,w);const X=$.subscription.set(()=>{O?.(),this._disposed||(z(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return R instanceof D.DisposableStore?R.add(X):Array.isArray(R)&&R.push(X),X}),this._event}fire(_){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L);for(const w of this._listeners)this._deliveryQueue.push(this,w,_);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=F;class y{constructor(){this._queue=new f.LinkedList}get size(){return this._queue.size}push(_,w,R){this._queue.push(new i(_,w,R))}clear(_){const w=new f.LinkedList;for(const R of this._queue)R.emitter!==_&&w.push(R);this._queue=w}deliver(){for(;this._queue.size>0;){const _=this._queue.shift();try{_.listener.invoke(_.event)}catch(w){(0,N.onUnexpectedError)(w)}}}}n.EventDeliveryQueue=y;class L extends y{clear(_){this._queue.clear()}}class i{constructor(_,w,R){this.emitter=_,this.listener=w,this.event=R}}class s extends F{async fireAsync(_,w,R){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new f.LinkedList);for(const U of this._listeners)this._asyncDeliveryQueue.push([U,_]);for(;this._asyncDeliveryQueue.size>0&&!w.isCancellationRequested;){const[U,O]=this._asyncDeliveryQueue.shift(),V=[],$={...O,token:w,waitUntil:z=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");R&&(z=R(z,U.callback)),V.push(z)}};try{U.invoke($)}catch(z){(0,N.onUnexpectedError)(z);continue}Object.freeze(V),await Promise.allSettled(V).then(z=>{for(const X of z)X.status==="rejected"&&(0,N.onUnexpectedError)(X.reason)})}}}}n.AsyncEmitter=s;class a extends F{constructor(_){super(_),this._isPaused=0,this._eventQueue=new f.LinkedList,this._mergeFn=_?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}n.PauseableEmitter=a;class l extends a{constructor(_){super(_),this._delay=_.delay??100}fire(_){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(_)}}n.DebounceEmitter=l;class c extends F{constructor(_){super(_),this._queuedEvents=[],this._mergeFn=_?.merge}fire(_){!this.hasListeners()||(this._queuedEvents.push(_),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(w=>super.fire(w)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=c;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new F({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const w={event:_,listener:null};this.events.push(w),this.hasListeners&&this.hook(w);const R=()=>{this.hasListeners&&this.unhook(w);const U=this.events.indexOf(w);this.events.splice(U,1)};return(0,D.toDisposable)((0,t.once)(R))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(w=>this.emitter.fire(w))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=g;class m{constructor(){this.buffers=[]}wrapEvent(_){return(w,R,U)=>_(O=>{const V=this.buffers[this.buffers.length-1];V?V.push(()=>w.call(R,O)):w.call(R,O)},void 0,U)}bufferEvents(_){const w=[];this.buffers.push(w);const R=_();return this.buffers.pop(),w.forEach(U=>U()),R}}n.EventBufferer=m;class p{constructor(){this.listening=!1,this.inputEvent=u.None,this.inputEventListener=D.Disposable.None,this.emitter=new F({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=p}),Z(J[17],K([0,1,8]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(h,o){const u=setTimeout(h.bind(o),0);return{dispose(){clearTimeout(u)}}});var D;(function(h){function o(u){return u===h.None||u===h.Cancelled||u instanceof f?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}h.isCancellationToken=o,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:N.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=n.CancellationToken||(n.CancellationToken={}));class f{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new N.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new f),this._token}cancel(){this._token?this._token instanceof f&&this._token.cancel():this._token=D.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof f&&this._token.dispose():this._token=D.None}}n.CancellationTokenSource=A}),Z(J[31],K([0,1,17]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=n.Cache=void 0;class t{constructor(h){this.task=h,this.result=null}get(){if(this.result)return this.result;const h=new N.CancellationTokenSource,o=this.task(h.token);return this.result={promise:o,dispose:()=>{this.result=null,h.cancel(),h.dispose()}},this.result}}n.Cache=t;class D{constructor(h){this.fn=h,this.lastCache=void 0,this.lastArgKey=void 0}get(h){const o=JSON.stringify(h);return this.lastArgKey!==o&&(this.lastArgKey=o,this.lastCache=this.fn(h)),this.lastCache}}n.LRUCachedFunction=D;class f{get cachedValues(){return this._map}constructor(h){this.fn=h,this._map=new Map}get(h){if(this._map.has(h))return this._map.get(h);const o=this.fn(h);return this._map.set(h,o),o}}n.CachedFunction=f}),Z(J[4],K([0,1,31,28]),function(B,n,N,t){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.charCount=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.replaceAsync=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function f(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=f;const A=/{(\d+)}/g;function h(P,...T){return T.length===0?P:P.replace(A,function(W,j){const Q=parseInt(j,10);return isNaN(Q)||Q<0||Q>=T.length?W:T[Q]})}n.format=h;const o=/{([^}]+)}/g;function u(P,T){return P.replace(o,(W,j)=>T[j]??W)}n.format2=u;function C(P){return P.replace(/[<>&]/g,function(T){switch(T){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return T}})}n.escape=C;function M(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=M;function v(P,T){let W=0;const j=T.charCodeAt(0);for(let Q=P.length-1;Q>=0;Q--)P.charCodeAt(Q)===j&&W++;return W}n.count=v;function d(P,T,W="\u2026"){return P.length<=T?P:`${P.substr(0,T)}${W}`}n.truncate=d;function e(P,T=" "){const W=E(P,T);return F(W,T)}n.trim=e;function E(P,T){if(!P||!T)return P;const W=T.length;if(W===0||P.length===0)return P;let j=0;for(;P.indexOf(T,j)===j;)j=j+W;return P.substring(j)}n.ltrim=E;function F(P,T){if(!P||!T)return P;const W=T.length,j=P.length;if(W===0||j===0)return P;let Q=j,ie=-1;for(;ie=P.lastIndexOf(T,Q-1),!(ie===-1||ie+W!==Q);){if(ie===0)return"";Q=ie}return P.substring(0,Q)}n.rtrim=F;function y(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=y;function L(P){return P.replace(/\*/g,"")}n.stripWildcards=L;function i(P,T,W={}){if(!P)throw new Error("Cannot create regex from empty string");T||(P=M(P)),W.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let j="";return W.global&&(j+="g"),W.matchCase||(j+="i"),W.multiline&&(j+="m"),W.unicode&&(j+="u"),new RegExp(P,j)}n.createRegExp=i;function s(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=s;function a(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=a;function l(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=l;function c(P){return P.split(/\r\n|\r|\n/)}n.splitLines=c;function g(P){for(let T=0,W=P.length;T<W;T++){const j=P.charCodeAt(T);if(j!==32&&j!==9)return T}return-1}n.firstNonWhitespaceIndex=g;function m(P,T=0,W=P.length){for(let j=T;j<W;j++){const Q=P.charCodeAt(j);if(Q!==32&&Q!==9)return P.substring(T,j)}return P.substring(T,W)}n.getLeadingWhitespace=m;function p(P,T=P.length-1){for(let W=T;W>=0;W--){const j=P.charCodeAt(W);if(j!==32&&j!==9)return W}return-1}n.lastNonWhitespaceIndex=p;function b(P,T,W){const j=[];let Q=0;for(const ie of P.matchAll(T)){if(j.push(P.slice(Q,ie.index)),ie.index===void 0)throw new Error("match.index should be defined");Q=ie.index+ie[0].length,j.push(W(ie[0],...ie.slice(1),ie.index,P,ie.groups))}return j.push(P.slice(Q)),Promise.all(j).then(ie=>ie.join(""))}n.replaceAsync=b;function _(P,T){return P<T?-1:P>T?1:0}n.compare=_;function w(P,T,W=0,j=P.length,Q=0,ie=T.length){for(;W<j&&Q<ie;W++,Q++){const be=P.charCodeAt(W),oe=T.charCodeAt(Q);if(be<oe)return-1;if(be>oe)return 1}const ce=j-W,Ne=ie-Q;return ce<Ne?-1:ce>Ne?1:0}n.compareSubstring=w;function R(P,T){return U(P,T,0,P.length,0,T.length)}n.compareIgnoreCase=R;function U(P,T,W=0,j=P.length,Q=0,ie=T.length){for(;W<j&&Q<ie;W++,Q++){let be=P.charCodeAt(W),oe=T.charCodeAt(Q);if(be===oe)continue;if(be>=128||oe>=128)return w(P.toLowerCase(),T.toLowerCase(),W,j,Q,ie);V(be)&&(be-=32),V(oe)&&(oe-=32);const ge=be-oe;if(ge!==0)return ge}const ce=j-W,Ne=ie-Q;return ce<Ne?-1:ce>Ne?1:0}n.compareSubstringIgnoreCase=U;function O(P){return P>=48&&P<=57}n.isAsciiDigit=O;function V(P){return P>=97&&P<=122}n.isLowerAsciiLetter=V;function $(P){return P>=65&&P<=90}n.isUpperAsciiLetter=$;function z(P,T){return P.length===T.length&&U(P,T)===0}n.equalsIgnoreCase=z;function X(P,T){const W=T.length;return T.length>P.length?!1:U(P,T,0,W)===0}n.startsWithIgnoreCase=X;function se(P,T){const W=Math.min(P.length,T.length);let j;for(j=0;j<W;j++)if(P.charCodeAt(j)!==T.charCodeAt(j))return j;return W}n.commonPrefixLength=se;function te(P,T){const W=Math.min(P.length,T.length);let j;const Q=P.length-1,ie=T.length-1;for(j=0;j<W;j++)if(P.charCodeAt(Q-j)!==T.charCodeAt(ie-j))return j;return W}n.commonSuffixLength=te;function x(P){return 55296<=P&&P<=56319}n.isHighSurrogate=x;function r(P){return 56320<=P&&P<=57343}n.isLowSurrogate=r;function Ae(P,T){return(P-55296<<10)+(T-56320)+65536}n.computeCodePoint=Ae;function Ee(P,T,W){const j=P.charCodeAt(W);if(x(j)&&W+1<T){const Q=P.charCodeAt(W+1);if(r(Q))return Ae(j,Q)}return j}n.getNextCodePoint=Ee;function de(P,T){const W=P.charCodeAt(T-1);if(r(W)&&T>1){const j=P.charCodeAt(T-2);if(x(j))return Ae(j,W)}return W}class pe{get offset(){return this._offset}constructor(T,W=0){this._str=T,this._len=T.length,this._offset=W}setOffset(T){this._offset=T}prevCodePoint(){const T=de(this._str,this._offset);return this._offset-=T>=65536?2:1,T}nextCodePoint(){const T=Ee(this._str,this._len,this._offset);return this._offset+=T>=65536?2:1,T}eol(){return this._offset>=this._len}}n.CodePointIterator=pe;class we{get offset(){return this._iterator.offset}constructor(T,W=0){this._iterator=new pe(T,W)}nextGraphemeLength(){const T=Le.getInstance(),W=this._iterator,j=W.offset;let Q=T.getGraphemeBreakType(W.nextCodePoint());for(;!W.eol();){const ie=W.offset,ce=T.getGraphemeBreakType(W.nextCodePoint());if(Ie(Q,ce)){W.setOffset(ie);break}Q=ce}return W.offset-j}prevGraphemeLength(){const T=Le.getInstance(),W=this._iterator,j=W.offset;let Q=T.getGraphemeBreakType(W.prevCodePoint());for(;W.offset>0;){const ie=W.offset,ce=T.getGraphemeBreakType(W.prevCodePoint());if(Ie(ce,Q)){W.setOffset(ie);break}Q=ce}return j-W.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=we;function ve(P,T){return new we(P,T).nextGraphemeLength()}n.nextCharLength=ve;function ye(P,T){return new we(P,T).prevGraphemeLength()}n.prevCharLength=ye;function Re(P,T){T>0&&r(P.charCodeAt(T))&&T--;const W=T+ve(P,T);return[W-ye(P,W),W]}n.getCharContainingOffset=Re;function De(P){const T=new we(P);let W=0;for(;!T.eol();)W++,T.nextGraphemeLength();return W}n.charCount=De;let Ce;function Fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ee(P){return Ce||(Ce=Fe()),Ce.test(P)}n.containsRTL=ee;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(P){return G.test(P)}n.isBasicASCII=Y,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function S(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=S;function k(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=k;function I(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=I;function q(P,T){if(P.length<T)return P;const W=/\b/g;let j=0;for(;W.test(P)&&!(P.length-W.lastIndex<T);)j=W.lastIndex,W.lastIndex+=1;return P.substring(j).replace(/^\s/,"")}n.lcut=q;const H=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function ue(P){return P&&(P=P.replace(H,""),P=P.replace(ne,""),P=P.replace(re,"")),P}n.removeAnsiEscapeCodes=ue,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ae;function fe(P){return ae(P)?P.substr(1):P}n.stripUTF8BOM=fe;function he(P,T){if(!P||!T||P.length<T.length)return!1;const W=T.length,j=P.toLowerCase();let Q=0,ie=-1;for(;Q<W;){const ce=j.indexOf(T[Q],ie+1);if(ce<0)return!1;ie=ce,Q++}return!0}n.fuzzyContains=he;function Se(P,T=!1){return P?(T&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=Se;function Be(P){return P.charAt(0).toUpperCase()+P.slice(1)}n.uppercaseFirstLetter=Be;function qe(P,T=1){if(T===0)return"";let W=-1;do W=P.indexOf(`
`,W+1),T--;while(T>0&&W>=0);return W===-1?P:(P[W-1]==="\r"&&W--,P.substr(0,W))}n.getNLines=qe;function Ve(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=Ve;function We(P){return Le.getInstance().getGraphemeBreakType(P)}n.getGraphemeBreakType=We;function Ie(P,T){return P===0?T!==5&&T!==7:P===2&&T===3?!1:P===4||P===2||P===3||T===4||T===2||T===3?!0:!(P===8&&(T===8||T===9||T===11||T===12)||(P===11||P===9)&&(T===9||T===10)||(P===12||P===10)&&T===10||T===5||T===13||T===7||P===1||P===13&&T===14||P===6&&T===6)}var He;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(He=n.GraphemeBreakType||(n.GraphemeBreakType={}));class Le{static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(T){if(T<32)return T===10?3:T===13?2:4;if(T<127)return 0;const W=this._data,j=W.length/3;let Q=1;for(;Q<=j;)if(T<W[3*Q])Q=2*Q;else if(T>W[3*Q+1])Q=2*Q+1;else return W[3*Q+2];return 0}}Le._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(P,T){if(P===0)return 0;const W=$e(P,T);if(W!==void 0)return W;const j=new pe(T,P);return j.prevCodePoint(),j.offset}n.getLeftDeleteOffset=je;function $e(P,T){const W=new pe(T,P);let j=W.prevCodePoint();for(;Ge(j)||j===65039||j===8419;){if(W.offset===0)return;j=W.prevCodePoint()}if(!I(j))return;let Q=W.offset;return Q>0&&W.prevCodePoint()===8205&&(Q=W.offset),Q}function Ge(P){return 127995<=P&&P<=127999}var Te;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),n.noBreakWhitespace="\xA0";class me{static getInstance(T){return me.cache.get(Array.from(T))}static getLocales(){return me._locales.getValue()}constructor(T){this.confusableDictionary=T}isAmbiguous(T){return this.confusableDictionary.has(T)}getPrimaryConfusable(T){return this.confusableDictionary.get(T)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=me,D=me,me.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.cache=new N.LRUCachedFunction(P=>{function T(oe){const ge=new Map;for(let _e=0;_e<oe.length;_e+=2)ge.set(oe[_e],oe[_e+1]);return ge}function W(oe,ge){const _e=new Map(oe);for(const[Pe,ke]of ge)_e.set(Pe,ke);return _e}function j(oe,ge){if(!oe)return ge;const _e=new Map;for(const[Pe,ke]of oe)ge.has(Pe)&&_e.set(Pe,ke);return _e}const Q=D.ambiguousCharacterData.getValue();let ie=P.filter(oe=>!oe.startsWith("_")&&oe in Q);ie.length===0&&(ie=["_default"]);let ce;for(const oe of ie){const ge=T(Q[oe]);ce=j(ce,ge)}const Ne=T(Q._common),be=W(Ne,ce);return new me(be)}),me._locales=new t.Lazy(()=>Object.keys(me.ambiguousCharacterData.getValue()).filter(P=>!P.startsWith("_")));class Me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Me.getRawData())),this._data}static isInvisibleCharacter(T){return Me.getData().has(T)}static get codePoints(){return Me.getData()}}n.InvisibleCharacters=Me,Me._data=void 0}),Z(J[32],K([0,1,4]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(y){return D(y,0)}n.hash=t;function D(y,L){switch(typeof y){case"object":return y===null?f(349,L):Array.isArray(y)?o(y,L):u(y,L);case"string":return h(y,L);case"boolean":return A(y,L);case"number":return f(y,L);case"undefined":return f(937,L);default:return f(617,L)}}n.doHash=D;function f(y,L){return(L<<5)-L+y|0}n.numberHash=f;function A(y,L){return f(y?433:863,L)}function h(y,L){L=f(149417,L);for(let i=0,s=y.length;i<s;i++)L=f(y.charCodeAt(i),L);return L}n.stringHash=h;function o(y,L){return L=f(104579,L),y.reduce((i,s)=>D(s,i),L)}function u(y,L){return L=f(181387,L),Object.keys(y).sort().reduce((i,s)=>(i=h(s,i),D(y[s],i)),L)}class C{constructor(){this._value=0}get value(){return this._value}hash(L){return this._value=D(L,this._value),this._value}}n.Hasher=C;var M;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function v(y,L,i=32){const s=i-L,a=~((1<<s)-1);return(y<<L|(a&y)>>>s)>>>0}function d(y,L=0,i=y.byteLength,s=0){for(let a=0;a<i;a++)y[L+a]=s}function e(y,L,i="0"){for(;y.length<L;)y=i+y;return y}function E(y,L=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(i=>i.toString(16).padStart(2,"0")).join(""):e((y>>>0).toString(16),L/4)}n.toHexString=E;class F{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(L){const i=L.length;if(i===0)return;const s=this._buff;let a=this._buffLen,l=this._leftoverHighSurrogate,c,g;for(l!==0?(c=l,g=-1,l=0):(c=L.charCodeAt(0),g=0);;){let m=c;if(N.isHighSurrogate(c))if(g+1<i){const p=L.charCodeAt(g+1);N.isLowSurrogate(p)?(g++,m=N.computeCodePoint(c,p)):m=65533}else{l=c;break}else N.isLowSurrogate(c)&&(m=65533);if(a=this._push(s,a,m),g++,g<i)c=L.charCodeAt(g);else break}this._buffLen=a,this._leftoverHighSurrogate=l}_push(L,i,s){return s<128?L[i++]=s:s<2048?(L[i++]=192|(s&1984)>>>6,L[i++]=128|(s&63)>>>0):s<65536?(L[i++]=224|(s&61440)>>>12,L[i++]=128|(s&4032)>>>6,L[i++]=128|(s&63)>>>0):(L[i++]=240|(s&1835008)>>>18,L[i++]=128|(s&258048)>>>12,L[i++]=128|(s&4032)>>>6,L[i++]=128|(s&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,L[0]=L[64+0],L[1]=L[64+1],L[2]=L[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const L=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(L/4294967296),!1),this._buffDV.setUint32(60,L%4294967296,!1),this._step()}_step(){const L=F._bigBlock32,i=this._buffDV;for(let _=0;_<64;_+=4)L.setUint32(_,i.getUint32(_,!1),!1);for(let _=64;_<320;_+=4)L.setUint32(_,v(L.getUint32(_-12,!1)^L.getUint32(_-32,!1)^L.getUint32(_-56,!1)^L.getUint32(_-64,!1),1),!1);let s=this._h0,a=this._h1,l=this._h2,c=this._h3,g=this._h4,m,p,b;for(let _=0;_<80;_++)_<20?(m=a&l|~a&c,p=1518500249):_<40?(m=a^l^c,p=1859775393):_<60?(m=a&l|a&c|l&c,p=2400959708):(m=a^l^c,p=3395469782),b=v(s,5)+m+g+p+L.getUint32(_*4,!1)&4294967295,g=c,c=l,l=v(a,30),a=s,s=b;this._h0=this._h0+s&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+g&4294967295}}n.StringSHA1=F,F._bigBlock32=new DataView(new ArrayBuffer(320))}),Z(J[18],K([0,1,25,32]),function(B,n,N,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class D{constructor(v){this.source=v}getElements(){const v=this.source,d=new Int32Array(v.length);for(let e=0,E=v.length;e<E;e++)d[e]=v.charCodeAt(e);return d}}n.StringDiffSequence=D;function f(M,v,d){return new C(new D(M),new D(v)).ComputeDiff(d).changes}n.stringDiff=f;class A{static Assert(v,d){if(!v)throw new Error(d)}}n.Debug=A;class h{static Copy(v,d,e,E,F){for(let y=0;y<F;y++)e[E+y]=v[d+y]}static Copy2(v,d,e,E,F){for(let y=0;y<F;y++)e[E+y]=v[d+y]}}n.MyArray=h;var o;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class u{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new N.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(v,d){this.m_originalStart=Math.min(this.m_originalStart,v),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(v,d){this.m_originalStart=Math.min(this.m_originalStart,v),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class C{constructor(v,d,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=v,this._modifiedSequence=d;const[E,F,y]=C._getElements(v),[L,i,s]=C._getElements(d);this._hasStrings=y&&s,this._originalStringElements=E,this._originalElementsOrHash=F,this._modifiedStringElements=L,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(v){return v.length>0&&typeof v[0]=="string"}static _getElements(v){const d=v.getElements();if(C._isStringArray(d)){const e=new Int32Array(d.length);for(let E=0,F=d.length;E<F;E++)e[E]=(0,t.stringHash)(d[E],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(v,d){return this._originalElementsOrHash[v]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[v]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(v,d){if(!this.ElementsAreEqual(v,d))return!1;const e=C._getStrictElement(this._originalSequence,v),E=C._getStrictElement(this._modifiedSequence,d);return e===E}static _getStrictElement(v,d){return typeof v.getStrictElement=="function"?v.getStrictElement(d):null}OriginalElementsAreEqual(v,d){return this._originalElementsOrHash[v]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[v]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(v,d){return this._modifiedElementsOrHash[v]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[v]===this._modifiedStringElements[d]:!0}ComputeDiff(v){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,v)}_ComputeDiff(v,d,e,E,F){const y=[!1];let L=this.ComputeDiffRecursive(v,d,e,E,y);return F&&(L=this.PrettifyChanges(L)),{quitEarly:y[0],changes:L}}ComputeDiffRecursive(v,d,e,E,F){for(F[0]=!1;v<=d&&e<=E&&this.ElementsAreEqual(v,e);)v++,e++;for(;d>=v&&E>=e&&this.ElementsAreEqual(d,E);)d--,E--;if(v>d||e>E){let l;return e<=E?(A.Assert(v===d+1,"originalStart should only be one more than originalEnd"),l=[new N.DiffChange(v,0,e,E-e+1)]):v<=d?(A.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),l=[new N.DiffChange(v,d-v+1,e,0)]):(A.Assert(v===d+1,"originalStart should only be one more than originalEnd"),A.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),l=[]),l}const y=[0],L=[0],i=this.ComputeRecursionPoint(v,d,e,E,y,L,F),s=y[0],a=L[0];if(i!==null)return i;if(!F[0]){const l=this.ComputeDiffRecursive(v,s,e,a,F);let c=[];return F[0]?c=[new N.DiffChange(s+1,d-(s+1)+1,a+1,E-(a+1)+1)]:c=this.ComputeDiffRecursive(s+1,d,a+1,E,F),this.ConcatenateChanges(l,c)}return[new N.DiffChange(v,d-v+1,e,E-e+1)]}WALKTRACE(v,d,e,E,F,y,L,i,s,a,l,c,g,m,p,b,_,w){let R=null,U=null,O=new u,V=d,$=e,z=g[0]-b[0]-E,X=-1073741824,se=this.m_forwardHistory.length-1;do{const te=z+v;te===V||te<$&&s[te-1]<s[te+1]?(l=s[te+1],m=l-z-E,l<X&&O.MarkNextChange(),X=l,O.AddModifiedElement(l+1,m),z=te+1-v):(l=s[te-1]+1,m=l-z-E,l<X&&O.MarkNextChange(),X=l-1,O.AddOriginalElement(l,m+1),z=te-1-v),se>=0&&(s=this.m_forwardHistory[se],v=s[0],V=1,$=s.length-1)}while(--se>=-1);if(R=O.getReverseChanges(),w[0]){let te=g[0]+1,x=b[0]+1;if(R!==null&&R.length>0){const r=R[R.length-1];te=Math.max(te,r.getOriginalEnd()),x=Math.max(x,r.getModifiedEnd())}U=[new N.DiffChange(te,c-te+1,x,p-x+1)]}else{O=new u,V=y,$=L,z=g[0]-b[0]-i,X=1073741824,se=_?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const te=z+F;te===V||te<$&&a[te-1]>=a[te+1]?(l=a[te+1]-1,m=l-z-i,l>X&&O.MarkNextChange(),X=l+1,O.AddOriginalElement(l+1,m+1),z=te+1-F):(l=a[te-1],m=l-z-i,l>X&&O.MarkNextChange(),X=l,O.AddModifiedElement(l+1,m+1),z=te-1-F),se>=0&&(a=this.m_reverseHistory[se],F=a[0],V=1,$=a.length-1)}while(--se>=-1);U=O.getChanges()}return this.ConcatenateChanges(R,U)}ComputeRecursionPoint(v,d,e,E,F,y,L){let i=0,s=0,a=0,l=0,c=0,g=0;v--,e--,F[0]=0,y[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const m=d-v+(E-e),p=m+1,b=new Int32Array(p),_=new Int32Array(p),w=E-e,R=d-v,U=v-e,O=d-E,$=(R-w)%2===0;b[w]=v,_[R]=d,L[0]=!1;for(let z=1;z<=m/2+1;z++){let X=0,se=0;a=this.ClipDiagonalBound(w-z,z,w,p),l=this.ClipDiagonalBound(w+z,z,w,p);for(let x=a;x<=l;x+=2){x===a||x<l&&b[x-1]<b[x+1]?i=b[x+1]:i=b[x-1]+1,s=i-(x-w)-U;const r=i;for(;i<d&&s<E&&this.ElementsAreEqual(i+1,s+1);)i++,s++;if(b[x]=i,i+s>X+se&&(X=i,se=s),!$&&Math.abs(x-R)<=z-1&&i>=_[x])return F[0]=i,y[0]=s,r<=_[x]&&1447>0&&z<=1447+1?this.WALKTRACE(w,a,l,U,R,c,g,O,b,_,i,d,F,s,E,y,$,L):null}const te=(X-v+(se-e)-z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(X,te))return L[0]=!0,F[0]=X,y[0]=se,te>0&&1447>0&&z<=1447+1?this.WALKTRACE(w,a,l,U,R,c,g,O,b,_,i,d,F,s,E,y,$,L):(v++,e++,[new N.DiffChange(v,d-v+1,e,E-e+1)]);c=this.ClipDiagonalBound(R-z,z,R,p),g=this.ClipDiagonalBound(R+z,z,R,p);for(let x=c;x<=g;x+=2){x===c||x<g&&_[x-1]>=_[x+1]?i=_[x+1]-1:i=_[x-1],s=i-(x-R)-O;const r=i;for(;i>v&&s>e&&this.ElementsAreEqual(i,s);)i--,s--;if(_[x]=i,$&&Math.abs(x-w)<=z&&i<=b[x])return F[0]=i,y[0]=s,r>=b[x]&&1447>0&&z<=1447+1?this.WALKTRACE(w,a,l,U,R,c,g,O,b,_,i,d,F,s,E,y,$,L):null}if(z<=1447){let x=new Int32Array(l-a+2);x[0]=w-a+1,h.Copy2(b,a,x,1,l-a+1),this.m_forwardHistory.push(x),x=new Int32Array(g-c+2),x[0]=R-c+1,h.Copy2(_,c,x,1,g-c+1),this.m_reverseHistory.push(x)}}return this.WALKTRACE(w,a,l,U,R,c,g,O,b,_,i,d,F,s,E,y,$,L)}PrettifyChanges(v){for(let d=0;d<v.length;d++){const e=v[d],E=d<v.length-1?v[d+1].originalStart:this._originalElementsOrHash.length,F=d<v.length-1?v[d+1].modifiedStart:this._modifiedElementsOrHash.length,y=e.originalLength>0,L=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<F&&(!y||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!L||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const s=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!s)break;e.originalStart++,e.modifiedStart++}const i=[null];if(d<v.length-1&&this.ChangesOverlap(v[d],v[d+1],i)){v[d]=i[0],v.splice(d+1,1),d--;continue}}for(let d=v.length-1;d>=0;d--){const e=v[d];let E=0,F=0;if(d>0){const l=v[d-1];E=l.originalStart+l.originalLength,F=l.modifiedStart+l.modifiedLength}const y=e.originalLength>0,L=e.modifiedLength>0;let i=0,s=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let l=1;;l++){const c=e.originalStart-l,g=e.modifiedStart-l;if(c<E||g<F||y&&!this.OriginalElementsAreEqual(c,c+e.originalLength)||L&&!this.ModifiedElementsAreEqual(g,g+e.modifiedLength))break;const p=(c===E&&g===F?5:0)+this._boundaryScore(c,e.originalLength,g,e.modifiedLength);p>s&&(s=p,i=l)}e.originalStart-=i,e.modifiedStart-=i;const a=[null];if(d>0&&this.ChangesOverlap(v[d-1],v[d],a)){v[d-1]=a[0],v.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,e=v.length;d<e;d++){const E=v[d-1],F=v[d],y=F.originalStart-E.originalStart-E.originalLength,L=E.originalStart,i=F.originalStart+F.originalLength,s=i-L,a=E.modifiedStart,l=F.modifiedStart+F.modifiedLength,c=l-a;if(y<5&&s<20&&c<20){const g=this._findBetterContiguousSequence(L,s,a,c,y);if(g){const[m,p]=g;(m!==E.originalStart+E.originalLength||p!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=m-E.originalStart,E.modifiedLength=p-E.modifiedStart,F.originalStart=m+y,F.modifiedStart=p+y,F.originalLength=i-F.originalStart,F.modifiedLength=l-F.modifiedStart)}}}return v}_findBetterContiguousSequence(v,d,e,E,F){if(d<F||E<F)return null;const y=v+d-F+1,L=e+E-F+1;let i=0,s=0,a=0;for(let l=v;l<y;l++)for(let c=e;c<L;c++){const g=this._contiguousSequenceScore(l,c,F);g>0&&g>i&&(i=g,s=l,a=c)}return i>0?[s,a]:null}_contiguousSequenceScore(v,d,e){let E=0;for(let F=0;F<e;F++){if(!this.ElementsAreEqual(v+F,d+F))return 0;E+=this._originalStringElements[v+F].length}return E}_OriginalIsBoundary(v){return v<=0||v>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[v])}_OriginalRegionIsBoundary(v,d){if(this._OriginalIsBoundary(v)||this._OriginalIsBoundary(v-1))return!0;if(d>0){const e=v+d;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(v){return v<=0||v>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[v])}_ModifiedRegionIsBoundary(v,d){if(this._ModifiedIsBoundary(v)||this._ModifiedIsBoundary(v-1))return!0;if(d>0){const e=v+d;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(v,d,e,E){const F=this._OriginalRegionIsBoundary(v,d)?1:0,y=this._ModifiedRegionIsBoundary(e,E)?1:0;return F+y}ConcatenateChanges(v,d){const e=[];if(v.length===0||d.length===0)return d.length>0?d:v;if(this.ChangesOverlap(v[v.length-1],d[0],e)){const E=new Array(v.length+d.length-1);return h.Copy(v,0,E,0,v.length-1),E[v.length-1]=e[0],h.Copy(d,1,E,v.length,d.length-1),E}else{const E=new Array(v.length+d.length);return h.Copy(v,0,E,0,v.length),h.Copy(d,0,E,v.length,d.length),E}}ChangesOverlap(v,d,e){if(A.Assert(v.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),A.Assert(v.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),v.originalStart+v.originalLength>=d.originalStart||v.modifiedStart+v.modifiedLength>=d.modifiedStart){const E=v.originalStart;let F=v.originalLength;const y=v.modifiedStart;let L=v.modifiedLength;return v.originalStart+v.originalLength>=d.originalStart&&(F=d.originalStart+d.originalLength-v.originalStart),v.modifiedStart+v.modifiedLength>=d.modifiedStart&&(L=d.modifiedStart+d.modifiedLength-v.modifiedStart),e[0]=new N.DiffChange(E,F,y,L),!0}else return e[0]=null,!1}ClipDiagonalBound(v,d,e,E){if(v>=0&&v<E)return v;const F=e,y=E-e-1,L=d%2===0;if(v<0){const i=F%2===0;return L===i?0:1}else{const i=y%2===0;return L===i?E-1:E-2}}}n.LcsDiff=C}),Z(J[33],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=void 0;function N(c){return typeof c=="string"}n.isString=N;function t(c){return Array.isArray(c)&&c.every(g=>N(g))}n.isStringArray=t;function D(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}n.isObject=D;function f(c){const g=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof g}n.isTypedArray=f;function A(c){return typeof c=="number"&&!isNaN(c)}n.isNumber=A;function h(c){return!!c&&typeof c[Symbol.iterator]=="function"}n.isIterable=h;function o(c){return c===!0||c===!1}n.isBoolean=o;function u(c){return typeof c>"u"}n.isUndefined=u;function C(c){return!M(c)}n.isDefined=C;function M(c){return u(c)||c===null}n.isUndefinedOrNull=M;function v(c,g){if(!c)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}n.assertType=v;function d(c){if(M(c))throw new Error("Assertion Failed: argument is undefined or null");return c}n.assertIsDefined=d;function e(...c){const g=[];for(let m=0;m<c.length;m++){const p=c[m];if(M(p))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);g.push(p)}return g}n.assertAllDefined=e;const E=Object.prototype.hasOwnProperty;function F(c){if(!D(c))return!1;for(const g in c)if(E.call(c,g))return!1;return!0}n.isEmptyObject=F;function y(c){return typeof c=="function"}n.isFunction=y;function L(...c){return c.length>0&&c.every(y)}n.areFunctions=L;function i(c,g){const m=Math.min(c.length,g.length);for(let p=0;p<m;p++)s(c[p],g[p])}n.validateConstraints=i;function s(c,g){if(N(g)){if(typeof c!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(y(g)){try{if(c instanceof g)return}catch{}if(!M(c)&&c.constructor===g||g.length===1&&g.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=s;function a(c){return c===null?void 0:c}n.withNullAsUndefined=a;function l(c){return typeof c>"u"?null:c}n.withUndefinedAsNull=l}),Z(J[11],K([0,1,33]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.filter=n.getCaseInsensitive=n.distinct=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const L=Array.isArray(y)?[]:{};return Object.entries(y).forEach(([i,s])=>{L[i]=s&&typeof s=="object"?t(s):s}),L}n.deepClone=t;function D(y){if(!y||typeof y!="object")return y;const L=[y];for(;L.length>0;){const i=L.shift();Object.freeze(i);for(const s in i)if(f.call(i,s)){const a=i[s];typeof a=="object"&&!Object.isFrozen(a)&&!(0,N.isTypedArray)(a)&&L.push(a)}}return y}n.deepFreeze=D;const f=Object.prototype.hasOwnProperty;function A(y,L){return h(y,L,new Set)}n.cloneAndChange=A;function h(y,L,i){if((0,N.isUndefinedOrNull)(y))return y;const s=L(y);if(typeof s<"u")return s;if(Array.isArray(y)){const a=[];for(const l of y)a.push(h(l,L,i));return a}if((0,N.isObject)(y)){if(i.has(y))throw new Error("Cannot clone recursive data-structure");i.add(y);const a={};for(const l in y)f.call(y,l)&&(a[l]=h(y[l],L,i));return i.delete(y),a}return y}function o(y,L,i=!0){return(0,N.isObject)(y)?((0,N.isObject)(L)&&Object.keys(L).forEach(s=>{s in y?i&&((0,N.isObject)(y[s])&&(0,N.isObject)(L[s])?o(y[s],L[s],i):y[s]=L[s]):y[s]=L[s]}),y):L}n.mixin=o;function u(y,L){if(y===L)return!0;if(y==null||L===null||L===void 0||typeof y!=typeof L||typeof y!="object"||Array.isArray(y)!==Array.isArray(L))return!1;let i,s;if(Array.isArray(y)){if(y.length!==L.length)return!1;for(i=0;i<y.length;i++)if(!u(y[i],L[i]))return!1}else{const a=[];for(s in y)a.push(s);a.sort();const l=[];for(s in L)l.push(s);if(l.sort(),!u(a,l))return!1;for(i=0;i<a.length;i++)if(!u(y[a[i]],L[a[i]]))return!1}return!0}n.equals=u;function C(y){const L=new Set;return JSON.stringify(y,(i,s)=>{if((0,N.isObject)(s)||Array.isArray(s)){if(L.has(s))return"[Circular]";L.add(s)}return s})}n.safeStringify=C;function M(y,L){const i=Object.create(null);return!y||!L||Object.keys(L).forEach(a=>{const l=y[a],c=L[a];u(l,c)||(i[a]=c)}),i}n.distinct=M;function v(y,L){const i=L.toLowerCase(),s=Object.keys(y).find(a=>a.toLowerCase()===i);return s?y[s]:y[L]}n.getCaseInsensitive=v;function d(y,L){const i=Object.create(null);for(const[s,a]of Object.entries(y))L(s,a)&&(i[s]=a);return i}n.filter=d;function e(y){let L=[],i=Object.getPrototypeOf(y);for(;Object.prototype!==i;)L=L.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return L}n.getAllPropertyNames=e;function E(y){const L=[];for(const i of e(y))typeof y[i]=="function"&&L.push(i);return L}n.getAllMethodNames=E;function F(y,L){const i=a=>function(){const l=Array.prototype.slice.call(arguments,0);return L(a,l)},s={};for(const a of y)s[a]=i(a);return s}n.createProxyObject=F}),Z(J[19],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var N;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(N=n.Constants||(n.Constants={}));function t(f){return f<0?0:f>255?255:f|0}n.toUint8=t;function D(f){return f<0?0:f>4294967295?4294967295:f|0}n.toUint32=D}),Z(J[12],K([0,1,30,5]),function(B,n,N,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const D=/^\w[\w\d+.-]*$/,f=/^\//,A=/^\/\//;function h(g,m){if(!g.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!D.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!f.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(g,m){return!g&&!m?"file":g}function u(g,m){switch(g){case"https":case"http":case"file":m?m[0]!==M&&(m=M+m):m=M;break}return m}const C="",M="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(m){return m instanceof d?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,p,b,_,w,R=!1){typeof m=="object"?(this.scheme=m.scheme||C,this.authority=m.authority||C,this.path=m.path||C,this.query=m.query||C,this.fragment=m.fragment||C):(this.scheme=o(m,R),this.authority=p||C,this.path=u(this.scheme,b||C),this.query=_||C,this.fragment=w||C,h(this,R))}get fsPath(){return i(this,!1)}with(m){if(!m)return this;let{scheme:p,authority:b,path:_,query:w,fragment:R}=m;return p===void 0?p=this.scheme:p===null&&(p=C),b===void 0?b=this.authority:b===null&&(b=C),_===void 0?_=this.path:_===null&&(_=C),w===void 0?w=this.query:w===null&&(w=C),R===void 0?R=this.fragment:R===null&&(R=C),p===this.scheme&&b===this.authority&&_===this.path&&w===this.query&&R===this.fragment?this:new E(p,b,_,w,R)}static parse(m,p=!1){const b=v.exec(m);return b?new E(b[2]||C,c(b[4]||C),c(b[5]||C),c(b[7]||C),c(b[9]||C),p):new E(C,C,C,C,C)}static file(m){let p=C;if(t.isWindows&&(m=m.replace(/\\/g,M)),m[0]===M&&m[1]===M){const b=m.indexOf(M,2);b===-1?(p=m.substring(2),m=M):(p=m.substring(2,b),m=m.substring(b)||M)}return new E("file",p,m,C,C)}static from(m){const p=new E(m.scheme,m.authority,m.path,m.query,m.fragment);return h(p,!0),p}static joinPath(m,...p){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return t.isWindows&&m.scheme==="file"?b=d.file(N.win32.join(i(m,!0),...p)).path:b=N.posix.join(m.path,...p),m.with({path:b})}toString(m=!1){return s(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof d)return m;{const p=new E(m);return p._formatted=m.external,p._fsPath=m._sep===e?m.fsPath:null,p}}else return m}}n.URI=d;const e=t.isWindows?1:void 0;class E extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(m=!1){return m?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=e),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const F={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(g,m){let p,b=-1;for(let _=0;_<g.length;_++){const w=g.charCodeAt(_);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||m&&w===47)b!==-1&&(p+=encodeURIComponent(g.substring(b,_)),b=-1),p!==void 0&&(p+=g.charAt(_));else{p===void 0&&(p=g.substr(0,_));const R=F[w];R!==void 0?(b!==-1&&(p+=encodeURIComponent(g.substring(b,_)),b=-1),p+=R):b===-1&&(b=_)}}return b!==-1&&(p+=encodeURIComponent(g.substring(b))),p!==void 0?p:g}function L(g){let m;for(let p=0;p<g.length;p++){const b=g.charCodeAt(p);b===35||b===63?(m===void 0&&(m=g.substr(0,p)),m+=F[b]):m!==void 0&&(m+=g[p])}return m!==void 0?m:g}function i(g,m){let p;return g.authority&&g.path.length>1&&g.scheme==="file"?p=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?m?p=g.path.substr(1):p=g.path[1].toLowerCase()+g.path.substr(2):p=g.path,t.isWindows&&(p=p.replace(/\//g,"\\")),p}n.uriToFsPath=i;function s(g,m){const p=m?L:y;let b="",{scheme:_,authority:w,path:R,query:U,fragment:O}=g;if(_&&(b+=_,b+=":"),(w||_==="file")&&(b+=M,b+=M),w){let V=w.indexOf("@");if(V!==-1){const $=w.substr(0,V);w=w.substr(V+1),V=$.indexOf(":"),V===-1?b+=p($,!1):(b+=p($.substr(0,V),!1),b+=":",b+=p($.substr(V+1),!1)),b+="@"}w=w.toLowerCase(),V=w.indexOf(":"),V===-1?b+=p(w,!1):(b+=p(w.substr(0,V),!1),b+=w.substr(V))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const V=R.charCodeAt(1);V>=65&&V<=90&&(R=`/${String.fromCharCode(V+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const V=R.charCodeAt(0);V>=65&&V<=90&&(R=`${String.fromCharCode(V+32)}:${R.substr(2)}`)}b+=p(R,!0)}return U&&(b+="?",b+=p(U,!1)),O&&(b+="#",b+=m?O:y(O,!1)),b}function a(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+a(g.substr(3)):g}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(g){return g.match(l)?g.replace(l,m=>a(m)):g}}),Z(J[54],K([0,1,6,8,7,11,5,4]),function(B,n,N,t,D,f,A,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const o="$initialize";let u=!1;function C(g){!A.isWeb||(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(g.message))}n.logOnceWebWorkerWarning=C;var M;(function(g){g[g.Request=0]="Request",g[g.Reply=1]="Reply",g[g.SubscribeEvent=2]="SubscribeEvent",g[g.Event=3]="Event",g[g.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class v{constructor(m,p,b,_){this.vsWorker=m,this.req=p,this.method=b,this.args=_,this.type=0}}class d{constructor(m,p,b,_){this.vsWorker=m,this.seq=p,this.res=b,this.err=_,this.type=1}}class e{constructor(m,p,b,_){this.vsWorker=m,this.req=p,this.eventName=b,this.arg=_,this.type=2}}class E{constructor(m,p,b){this.vsWorker=m,this.req=p,this.event=b,this.type=3}}class F{constructor(m,p){this.vsWorker=m,this.req=p,this.type=4}}class y{constructor(m){this._workerId=-1,this._handler=m,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(m){this._workerId=m}sendMessage(m,p){const b=String(++this._lastSentReq);return new Promise((_,w)=>{this._pendingReplies[b]={resolve:_,reject:w},this._send(new v(this._workerId,b,m,p))})}listen(m,p){let b=null;const _=new t.Emitter({onFirstListenerAdd:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,_),this._send(new e(this._workerId,b,m,p))},onLastListenerRemove:()=>{this._pendingEmitters.delete(b),this._send(new F(this._workerId,b)),b=null}});return _.event}handleMessage(m){!m||!m.vsWorker||this._workerId!==-1&&m.vsWorker!==this._workerId||this._handleMessage(m)}_handleMessage(m){switch(m.type){case 1:return this._handleReplyMessage(m);case 0:return this._handleRequestMessage(m);case 2:return this._handleSubscribeEventMessage(m);case 3:return this._handleEventMessage(m);case 4:return this._handleUnsubscribeEventMessage(m)}}_handleReplyMessage(m){if(!this._pendingReplies[m.seq]){console.warn("Got reply to unknown seq");return}const p=this._pendingReplies[m.seq];if(delete this._pendingReplies[m.seq],m.err){let b=m.err;m.err.$isError&&(b=new Error,b.name=m.err.name,b.message=m.err.message,b.stack=m.err.stack),p.reject(b);return}p.resolve(m.res)}_handleRequestMessage(m){const p=m.req;this._handler.handleMessage(m.method,m.args).then(_=>{this._send(new d(this._workerId,p,_,void 0))},_=>{_.detail instanceof Error&&(_.detail=(0,N.transformErrorForSerialization)(_.detail)),this._send(new d(this._workerId,p,void 0,(0,N.transformErrorForSerialization)(_)))})}_handleSubscribeEventMessage(m){const p=m.req,b=this._handler.handleEvent(m.eventName,m.arg)(_=>{this._send(new E(this._workerId,p,_))});this._pendingEvents.set(p,b)}_handleEventMessage(m){if(!this._pendingEmitters.has(m.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(m.req).fire(m.event)}_handleUnsubscribeEventMessage(m){if(!this._pendingEvents.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(m.req).dispose(),this._pendingEvents.delete(m.req)}_send(m){const p=[];if(m.type===0)for(let b=0;b<m.args.length;b++)m.args[b]instanceof ArrayBuffer&&p.push(m.args[b]);else m.type===1&&m.res instanceof ArrayBuffer&&p.push(m.res);this._handler.sendMessage(m,p)}}class L extends D.Disposable{constructor(m,p,b){super();let _=null;this._worker=this._register(m.create("vs/base/common/worker/simpleWorker",V=>{this._protocol.handleMessage(V)},V=>{_?.(V)})),this._protocol=new y({sendMessage:(V,$)=>{this._worker.postMessage(V,$)},handleMessage:(V,$)=>{if(typeof b[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(b[V].apply(b,$))}catch(z){return Promise.reject(z)}},handleEvent:(V,$)=>{if(s(V)){const z=b[V].call(b,$);if(typeof z!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return z}if(i(V)){const z=b[V];if(typeof z!="function")throw new Error(`Missing event ${V} on main thread host.`);return z}throw new Error(`Malformed event name ${V}`)}}),this._protocol.setWorkerId(this._worker.getId());let w=null;typeof A.globals.require<"u"&&typeof A.globals.require.getConfig=="function"?w=A.globals.require.getConfig():typeof A.globals.requirejs<"u"&&(w=A.globals.requirejs.s.contexts._.config);const R=(0,f.getAllMethodNames)(b);this._onModuleLoaded=this._protocol.sendMessage(o,[this._worker.getId(),JSON.parse(JSON.stringify(w)),p,R]);const U=(V,$)=>this._request(V,$),O=(V,$)=>this._protocol.listen(V,$);this._lazyProxy=new Promise((V,$)=>{_=$,this._onModuleLoaded.then(z=>{V(a(z,U,O))},z=>{$(z),this._onError("Worker failed to load "+p,z)})})}getProxyObject(){return this._lazyProxy}_request(m,p){return new Promise((b,_)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(m,p).then(b,_)},_)})}_onError(m,p){console.error(m),console.info(p)}}n.SimpleWorkerClient=L;function i(g){return g[0]==="o"&&g[1]==="n"&&h.isUpperAsciiLetter(g.charCodeAt(2))}function s(g){return/^onDynamic/.test(g)&&h.isUpperAsciiLetter(g.charCodeAt(9))}function a(g,m,p){const b=R=>function(){const U=Array.prototype.slice.call(arguments,0);return m(R,U)},_=R=>function(U){return p(R,U)},w={};for(const R of g){if(s(R)){w[R]=_(R);continue}if(i(R)){w[R]=p(R,void 0);continue}w[R]=b(R)}return w}class l{constructor(m,p){this._requestHandlerFactory=p,this._requestHandler=null,this._protocol=new y({sendMessage:(b,_)=>{m(b,_)},handleMessage:(b,_)=>this._handleMessage(b,_),handleEvent:(b,_)=>this._handleEvent(b,_)})}onmessage(m){this._protocol.handleMessage(m)}_handleMessage(m,p){if(m===o)return this.initialize(p[0],p[1],p[2],p[3]);if(!this._requestHandler||typeof this._requestHandler[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this._requestHandler[m].apply(this._requestHandler,p))}catch(b){return Promise.reject(b)}}_handleEvent(m,p){if(!this._requestHandler)throw new Error("Missing requestHandler");if(s(m)){const b=this._requestHandler[m].call(this._requestHandler,p);if(typeof b!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return b}if(i(m)){const b=this._requestHandler[m];if(typeof b!="function")throw new Error(`Missing event ${m} on request handler.`);return b}throw new Error(`Malformed event name ${m}`)}initialize(m,p,b,_){this._protocol.setWorkerId(m);const U=a(_,(O,V)=>this._protocol.sendMessage(O,V),(O,V)=>this._protocol.listen(O,V));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(U),Promise.resolve((0,f.getAllMethodNames)(this._requestHandler))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy!==void 0&&delete p.trustedTypesPolicy,p.catchError=!0,A.globals.require.config(p)),new Promise((O,V)=>{(A.globals.require||B)([b],z=>{if(this._requestHandler=z.create(U),!this._requestHandler){V(new Error("No RequestHandler!"));return}O((0,f.getAllMethodNames)(this._requestHandler))},V)}))}}n.SimpleWorkerServer=l;function c(g){return new l(g,null)}n.create=c}),Z(J[20],K([0,1,19]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(h){const o=(0,N.toUint8)(h);this._defaultValue=o,this._asciiMap=t._createAsciiMap(o),this._map=new Map}static _createAsciiMap(h){const o=new Uint8Array(256);return o.fill(h),o}set(h,o){const u=(0,N.toUint8)(o);h>=0&&h<256?this._asciiMap[h]=u:this._map.set(h,u)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=t;var D;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(D||(D={}));class f{constructor(){this._actual=new t(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}clear(){return this._actual.clear()}}n.CharacterSet=f}),Z(J[3],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class N{constructor(D,f){this.lineNumber=D,this.column=f}with(D=this.lineNumber,f=this.column){return D===this.lineNumber&&f===this.column?this:new N(D,f)}delta(D=0,f=0){return this.with(this.lineNumber+D,this.column+f)}equals(D){return N.equals(this,D)}static equals(D,f){return!D&&!f?!0:!!D&&!!f&&D.lineNumber===f.lineNumber&&D.column===f.column}isBefore(D){return N.isBefore(this,D)}static isBefore(D,f){return D.lineNumber<f.lineNumber?!0:f.lineNumber<D.lineNumber?!1:D.column<f.column}isBeforeOrEqual(D){return N.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,f){return D.lineNumber<f.lineNumber?!0:f.lineNumber<D.lineNumber?!1:D.column<=f.column}static compare(D,f){const A=D.lineNumber|0,h=f.lineNumber|0;if(A===h){const o=D.column|0,u=f.column|0;return o-u}return A-h}clone(){return new N(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new N(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}n.Position=N}),Z(J[2],K([0,1,3]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(f,A,h,o){f>h||f===h&&A>o?(this.startLineNumber=h,this.startColumn=o,this.endLineNumber=f,this.endColumn=A):(this.startLineNumber=f,this.startColumn=A,this.endLineNumber=h,this.endColumn=o)}isEmpty(){return t.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return t.containsPosition(this,f)}static containsPosition(f,A){return!(A.lineNumber<f.startLineNumber||A.lineNumber>f.endLineNumber||A.lineNumber===f.startLineNumber&&A.column<f.startColumn||A.lineNumber===f.endLineNumber&&A.column>f.endColumn)}static strictContainsPosition(f,A){return!(A.lineNumber<f.startLineNumber||A.lineNumber>f.endLineNumber||A.lineNumber===f.startLineNumber&&A.column<=f.startColumn||A.lineNumber===f.endLineNumber&&A.column>=f.endColumn)}containsRange(f){return t.containsRange(this,f)}static containsRange(f,A){return!(A.startLineNumber<f.startLineNumber||A.endLineNumber<f.startLineNumber||A.startLineNumber>f.endLineNumber||A.endLineNumber>f.endLineNumber||A.startLineNumber===f.startLineNumber&&A.startColumn<f.startColumn||A.endLineNumber===f.endLineNumber&&A.endColumn>f.endColumn)}strictContainsRange(f){return t.strictContainsRange(this,f)}static strictContainsRange(f,A){return!(A.startLineNumber<f.startLineNumber||A.endLineNumber<f.startLineNumber||A.startLineNumber>f.endLineNumber||A.endLineNumber>f.endLineNumber||A.startLineNumber===f.startLineNumber&&A.startColumn<=f.startColumn||A.endLineNumber===f.endLineNumber&&A.endColumn>=f.endColumn)}plusRange(f){return t.plusRange(this,f)}static plusRange(f,A){let h,o,u,C;return A.startLineNumber<f.startLineNumber?(h=A.startLineNumber,o=A.startColumn):A.startLineNumber===f.startLineNumber?(h=A.startLineNumber,o=Math.min(A.startColumn,f.startColumn)):(h=f.startLineNumber,o=f.startColumn),A.endLineNumber>f.endLineNumber?(u=A.endLineNumber,C=A.endColumn):A.endLineNumber===f.endLineNumber?(u=A.endLineNumber,C=Math.max(A.endColumn,f.endColumn)):(u=f.endLineNumber,C=f.endColumn),new t(h,o,u,C)}intersectRanges(f){return t.intersectRanges(this,f)}static intersectRanges(f,A){let h=f.startLineNumber,o=f.startColumn,u=f.endLineNumber,C=f.endColumn;const M=A.startLineNumber,v=A.startColumn,d=A.endLineNumber,e=A.endColumn;return h<M?(h=M,o=v):h===M&&(o=Math.max(o,v)),u>d?(u=d,C=e):u===d&&(C=Math.min(C,e)),h>u||h===u&&o>C?null:new t(h,o,u,C)}equalsRange(f){return t.equalsRange(this,f)}static equalsRange(f,A){return!f&&!A?!0:!!f&&!!A&&f.startLineNumber===A.startLineNumber&&f.startColumn===A.startColumn&&f.endLineNumber===A.endLineNumber&&f.endColumn===A.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(f){return new N.Position(f.endLineNumber,f.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(f){return new N.Position(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,A){return new t(this.startLineNumber,this.startColumn,f,A)}setStartPosition(f,A){return new t(f,A,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(f){return new t(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static collapseToStart(f){return new t(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}static fromPositions(f,A=f){return new t(f.lineNumber,f.column,A.lineNumber,A.column)}static lift(f){return f?new t(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,A){return!(f.endLineNumber<A.startLineNumber||f.endLineNumber===A.startLineNumber&&f.endColumn<A.startColumn||A.endLineNumber<f.startLineNumber||A.endLineNumber===f.startLineNumber&&A.endColumn<f.startColumn)}static areIntersecting(f,A){return!(f.endLineNumber<A.startLineNumber||f.endLineNumber===A.startLineNumber&&f.endColumn<=A.startColumn||A.endLineNumber<f.startLineNumber||A.endLineNumber===f.startLineNumber&&A.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,A){if(f&&A){const u=f.startLineNumber|0,C=A.startLineNumber|0;if(u===C){const M=f.startColumn|0,v=A.startColumn|0;if(M===v){const d=f.endLineNumber|0,e=A.endLineNumber|0;if(d===e){const E=f.endColumn|0,F=A.endColumn|0;return E-F}return d-e}return M-v}return u-C}return(f?1:0)-(A?1:0)}static compareRangesUsingEnds(f,A){return f.endLineNumber===A.endLineNumber?f.endColumn===A.endColumn?f.startLineNumber===A.startLineNumber?f.startColumn-A.startColumn:f.startLineNumber-A.startLineNumber:f.endColumn-A.endColumn:f.endLineNumber-A.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}n.Range=t}),Z(J[34],K([0,1,3,2]),function(B,n,N,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var D;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(D=n.SelectionDirection||(n.SelectionDirection={}));class f extends t.Range{constructor(h,o,u,C){super(h,o,u,C),this.selectionStartLineNumber=h,this.selectionStartColumn=o,this.positionLineNumber=u,this.positionColumn=C}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,o){return h.selectionStartLineNumber===o.selectionStartLineNumber&&h.selectionStartColumn===o.selectionStartColumn&&h.positionLineNumber===o.positionLineNumber&&h.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,o){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,o):new f(h,o,this.startLineNumber,this.startColumn)}getPosition(){return new N.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new N.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,o){return this.getDirection()===0?new f(h,o,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,o)}static fromPositions(h,o=h){return new f(h.lineNumber,h.column,o.lineNumber,o.column)}static fromRange(h,o){return o===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,o){if(h&&!o||!h&&o)return!1;if(!h&&!o)return!0;if(h.length!==o.length)return!1;for(let u=0,C=h.length;u<C;u++)if(!this.selectionsEqual(h[u],o[u]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,o,u,C,M){return M===0?new f(h,o,u,C):new f(u,C,h,o)}}n.Selection=f}),Z(J[35],K([0,1,20]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class D extends N.CharacterClassifier{constructor(h){super(0);for(let o=0,u=h.length;o<u;o++)this.set(h.charCodeAt(o),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function f(A){const h={};return o=>(h.hasOwnProperty(o)||(h[o]=A(o)),h[o])}n.getMapForWordSeparators=f(A=>new D(A))}),Z(J[21],K([0,1,14,7,15]),function(B,n,N,t,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.setDefaultGetWordAtTextConfig=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(M=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const d of n.USUAL_WORD_SEPARATORS)M.indexOf(d)>=0||(v+="\\"+d);return v+="\\s]+)",new RegExp(v,"g")}n.DEFAULT_WORD_REGEXP=f();function A(M){let v=n.DEFAULT_WORD_REGEXP;if(M&&M instanceof RegExp)if(M.global)v=M;else{let d="g";M.ignoreCase&&(d+="i"),M.multiline&&(d+="m"),M.unicode&&(d+="u"),v=new RegExp(M.source,d)}return v.lastIndex=0,v}n.ensureValidWordDefinition=A;const h=new D.LinkedList;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function o(M){const v=h.unshift(M);return(0,t.toDisposable)(v)}n.setDefaultGetWordAtTextConfig=o;function u(M,v,d,e,E){if(E||(E=N.Iterable.first(h)),d.length>E.maxLen){let s=M-E.maxLen/2;return s<0?s=0:e+=s,d=d.substring(s,M+E.maxLen/2),u(M,v,d,e,E)}const F=Date.now(),y=M-1-e;let L=-1,i=null;for(let s=1;!(Date.now()-F>=E.timeBudget);s++){const a=y-E.windowSize*s;v.lastIndex=Math.max(0,a);const l=C(v,d,y,L);if(!l&&i||(i=l,a<=0))break;L=a}if(i){const s={word:i[0],startColumn:e+1+i.index,endColumn:e+1+i.index+i[0].length};return v.lastIndex=0,s}return null}n.getWordAtText=u;function C(M,v,d,e){let E;for(;E=M.exec(v);){const F=E.index||0;if(F<=d&&M.lastIndex>=d)return E;if(e>0&&F>e)return null}return null}}),Z(J[9],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SequenceFromIntArray=n.OffsetRange=n.SequenceDiff=void 0;class N{constructor(A,h){this.seq1Range=A,this.seq2Range=h}reverse(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}n.SequenceDiff=N;class t{constructor(A,h){this.start=A,this.endExclusive=h}get isEmpty(){return this.start===this.endExclusive}delta(A){return new t(this.start+A,this.endExclusive+A)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}}n.OffsetRange=t;class D{constructor(A){this.arr=A}getElement(A){return this.arr[A]}get length(){return this.arr.length}}n.SequenceFromIntArray=D}),Z(J[36],K([0,1,9]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.optimizeSequenceDiffs=void 0;function t(h,o,u){let C=u;return C=D(h,o,C),C=f(h,o,C),C}n.optimizeSequenceDiffs=t;function D(h,o,u){const C=[];u.length>0&&C.push(u[0]);for(let M=1;M<u.length;M++){const v=C[C.length-1],d=u[M];if(d.seq1Range.isEmpty){let e=!0;const E=d.seq1Range.start-v.seq1Range.endExclusive;for(let F=1;F<=E;F++)if(o.getElement(d.seq2Range.start-F)!==o.getElement(d.seq2Range.endExclusive-F)){e=!1;break}if(e){C[C.length-1]=new N.SequenceDiff(v.seq1Range,new N.OffsetRange(v.seq2Range.start,d.seq2Range.endExclusive-E));continue}}C.push(d)}return C}n.joinSequenceDiffs=D;function f(h,o,u){if(!h.getBoundaryScore||!o.getBoundaryScore)return u;for(let C=0;C<u.length;C++){const M=u[C];if(M.seq1Range.isEmpty){const v=C>0?u[C-1].seq2Range.endExclusive:-1,d=C+1<u.length?u[C+1].seq2Range.start:o.length+1;u[C]=A(M,h,o,d,v)}else if(M.seq2Range.isEmpty){const v=C>0?u[C-1].seq1Range.endExclusive:-1,d=C+1<u.length?u[C+1].seq1Range.start:h.length+1;u[C]=A(M.reverse(),o,h,d,v).reverse()}}return u}n.shiftSequenceDiffs=f;function A(h,o,u,C,M){let v=1;for(;h.seq1Range.start-v>M&&u.getElement(h.seq2Range.start-v)===u.getElement(h.seq2Range.endExclusive-v);)v++;v--;let d=1;for(;h.seq1Range.start+d<C&&u.getElement(h.seq2Range.start+d)===u.getElement(h.seq2Range.endExclusive+d);)d++;d--;let e=0,E=-1;for(let F=-v;F<d;F++){const y=h.seq2Range.start+F,L=h.seq2Range.endExclusive+F,i=h.seq1Range.start+F,s=o.getBoundaryScore(i)+u.getBoundaryScore(y)+u.getBoundaryScore(L);s>E&&(E=s,e=F)}return e!==0?new N.SequenceDiff(h.seq1Range.delta(e),h.seq2Range.delta(e)):h}}),Z(J[37],K([0,1,9]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class t{compute(o,u){if(o.length===0)return[new N.SequenceDiff(new N.OffsetRange(0,0),new N.OffsetRange(0,u.length))];if(u.length===0)return[new N.SequenceDiff(new N.OffsetRange(0,o.length),new N.OffsetRange(0,0))];function C(i,s){for(;i<o.length&&s<u.length&&o.getElement(i)===u.getElement(s);)i++,s++;return i}let M=0;const v=new f;v.set(0,C(0,0));const d=new A;d.set(0,v.get(0)===0?null:new D(null,0,0,v.get(0)));let e=0;e:for(;;)for(M++,e=-M;e<=M;e+=2){const i=e===M?-1:v.get(e+1),s=e===-M?-1:v.get(e-1)+1,a=Math.min(Math.max(i,s),o.length),l=a-e,c=C(a,l);v.set(e,c);const g=a===i?d.get(e+1):d.get(e-1);if(d.set(e,c!==a?new D(g,a,l,c-a):g),v.get(e)===o.length&&v.get(e)-e===u.length)break e}let E=d.get(e);const F=[];let y=o.length,L=u.length;for(;;){const i=E?E.x+E.length:0,s=E?E.y+E.length:0;if((i!==y||s!==L)&&F.push(new N.SequenceDiff(new N.OffsetRange(i,y),new N.OffsetRange(s,L))),!E)break;y=E.x,L=E.y,E=E.prev}return F.reverse(),F}}n.MyersDiffAlgorithm=t;class D{constructor(o,u,C,M){this.prev=o,this.x=u,this.y=C,this.length=M}}class f{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,u){if(o<0){if(o=-o-1,o>=this.negativeArr.length){const C=this.negativeArr;this.negativeArr=new Int32Array(C.length*2),this.negativeArr.set(C)}this.negativeArr[o]=u}else{if(o>=this.positiveArr.length){const C=this.positiveArr;this.positiveArr=new Int32Array(C.length*2),this.positiveArr.set(C)}this.positiveArr[o]=u}}}class A{constructor(){this.positiveArr=[],this.negativeArr=[]}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,u){o<0?(o=-o-1,this.negativeArr[o]=u):this.positiveArr[o]=u}}}),Z(J[38],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class N{constructor(D,f){this.width=D,this.height=f,this.array=[],this.array=new Array(D*f)}get(D,f){return this.array[D+f*this.width]}set(D,f,A){this.array[D+f*this.width]=A}}n.Array2D=N}),Z(J[39],K([0,1,9,38]),function(B,n,N,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class D{compute(A,h,o){const u=new t.Array2D(A.length,h.length),C=new t.Array2D(A.length,h.length),M=new t.Array2D(A.length,h.length);for(let L=0;L<A.length;L++)for(let i=0;i<h.length;i++){const s=L===0?0:u.get(L-1,i),a=i===0?0:u.get(L,i-1);let l;A.getElement(L)===h.getElement(i)?(L===0||i===0?l=0:l=u.get(L-1,i-1),L>0&&i>0&&C.get(L-1,i-1)===3&&(l+=.1),l+=o?o(L,i):1):l=-1;const c=Math.max(s,a,l);if(c===l){const g=L>0&&i>0?M.get(L-1,i-1):0;M.set(L,i,g+1),C.set(L,i,3)}else c===s?(M.set(L,i,0),C.set(L,i,1)):c===a&&(M.set(L,i,0),C.set(L,i,2));u.set(L,i,c)}const v=[];let d=A.length,e=h.length;function E(L,i){(L+1!==d||i+1!==e)&&v.push(new N.SequenceDiff(new N.OffsetRange(L+1,d),new N.OffsetRange(i+1,e))),d=L,e=i}let F=A.length-1,y=h.length-1;for(;F>=0&&y>=0;)C.get(F,y)===3?(E(F,y),F--,y--):C.get(F,y)===1?F--:y--;return E(-1,-1),v.reverse(),v}}n.DynamicProgrammingDiffing=D}),Z(J[22],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=n.RangeMapping=n.LineRangeMapping=void 0;class N{constructor(A,h,o){this.originalRange=A,this.modifiedRange=h,this.innerChanges=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=N;class t{constructor(A,h){this.originalRange=A,this.modifiedRange=h}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=t;class D{constructor(A,h){this.startLineNumber=A,this.endLineNumberExclusive=h}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(A){return new D(this.startLineNumber+A,this.endLineNumberExclusive+A)}get length(){return this.endLineNumberExclusive-this.startLineNumber}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}join(A){return new D(Math.min(this.startLineNumber,A.startLineNumber),Math.max(this.endLineNumberExclusive,A.endLineNumberExclusive))}}n.LineRange=D}),Z(J[23],K([0,1,18,22,4,2,10]),function(B,n,N,t,D,f,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const h=3;class o{computeDiff(s,a,l){const g=new E(s,a,{maxComputationTime:l.maxComputationTime,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),m=[];let p=null;for(const b of g.changes){let _;b.originalEndLineNumber===0?_=new t.LineRange(b.originalStartLineNumber+1,b.originalStartLineNumber+1):_=new t.LineRange(b.originalStartLineNumber,b.originalEndLineNumber+1);let w;b.modifiedEndLineNumber===0?w=new t.LineRange(b.modifiedStartLineNumber+1,b.modifiedStartLineNumber+1):w=new t.LineRange(b.modifiedStartLineNumber,b.modifiedEndLineNumber+1);let R=new t.LineRangeMapping(_,w,b.charChanges?.map(U=>new t.RangeMapping(new f.Range(U.originalStartLineNumber,U.originalStartColumn,U.originalEndLineNumber,U.originalEndColumn),new f.Range(U.modifiedStartLineNumber,U.modifiedStartColumn,U.modifiedEndLineNumber,U.modifiedEndColumn))));p&&(p.modifiedRange.endLineNumberExclusive===R.modifiedRange.startLineNumber||p.originalRange.endLineNumberExclusive===R.originalRange.startLineNumber)&&(R=new t.LineRangeMapping(p.originalRange.join(R.originalRange),p.modifiedRange.join(R.modifiedRange),p.innerChanges&&R.innerChanges?p.innerChanges.concat(R.innerChanges):void 0),m.pop()),m.push(R),p=R}return(0,A.assertFn)(()=>(0,A.checkAdjacentItems)(m,(b,_)=>_.originalRange.startLineNumber-b.originalRange.endLineNumberExclusive===_.modifiedRange.startLineNumber-b.modifiedRange.endLineNumberExclusive&&b.originalRange.endLineNumberExclusive<_.originalRange.startLineNumber&&b.modifiedRange.endLineNumberExclusive<_.modifiedRange.startLineNumber)),{quitEarly:g.quitEarly,changes:m}}}n.SmartLinesDiffComputer=o;function u(i,s,a,l){return new N.LcsDiff(i,s,a).ComputeDiff(l)}class C{constructor(s){const a=[],l=[];for(let c=0,g=s.length;c<g;c++)a[c]=F(s[c],1),l[c]=y(s[c],1);this.lines=s,this._startColumns=a,this._endColumns=l}getElements(){const s=[];for(let a=0,l=this.lines.length;a<l;a++)s[a]=this.lines[a].substring(this._startColumns[a]-1,this._endColumns[a]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,a,l){const c=[],g=[],m=[];let p=0;for(let b=a;b<=l;b++){const _=this.lines[b],w=s?this._startColumns[b]:1,R=s?this._endColumns[b]:_.length+1;for(let U=w;U<R;U++)c[p]=_.charCodeAt(U-1),g[p]=b+1,m[p]=U,p++;!s&&b<l&&(c[p]=10,g[p]=b+1,m[p]=_.length+1,p++)}return new M(c,g,m)}}class M{constructor(s,a,l){this._charCodes=s,this._lineNumbers=a,this._columns=l}toString(){return"["+this._charCodes.map((s,a)=>(s===10?"\\n":String.fromCharCode(s))+`-(${this._lineNumbers[a]},${this._columns[a]})`).join(", ")+"]"}_assertIndex(s,a){if(s<0||s>=a.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(s){return s>0&&s===this._lineNumbers.length?this.getEndLineNumber(s-1):(this._assertIndex(s,this._lineNumbers),this._lineNumbers[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this._assertIndex(s,this._lineNumbers),this._charCodes[s]===10?this._lineNumbers[s]+1:this._lineNumbers[s])}getStartColumn(s){return s>0&&s===this._columns.length?this.getEndColumn(s-1):(this._assertIndex(s,this._columns),this._columns[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this._assertIndex(s,this._columns),this._charCodes[s]===10?1:this._columns[s]+1)}}class v{constructor(s,a,l,c,g,m,p,b){this.originalStartLineNumber=s,this.originalStartColumn=a,this.originalEndLineNumber=l,this.originalEndColumn=c,this.modifiedStartLineNumber=g,this.modifiedStartColumn=m,this.modifiedEndLineNumber=p,this.modifiedEndColumn=b}static createFromDiffChange(s,a,l){const c=a.getStartLineNumber(s.originalStart),g=a.getStartColumn(s.originalStart),m=a.getEndLineNumber(s.originalStart+s.originalLength-1),p=a.getEndColumn(s.originalStart+s.originalLength-1),b=l.getStartLineNumber(s.modifiedStart),_=l.getStartColumn(s.modifiedStart),w=l.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),R=l.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new v(c,g,m,p,b,_,w,R)}}function d(i){if(i.length<=1)return i;const s=[i[0]];let a=s[0];for(let l=1,c=i.length;l<c;l++){const g=i[l],m=g.originalStart-(a.originalStart+a.originalLength),p=g.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(m,p)<h?(a.originalLength=g.originalStart+g.originalLength-a.originalStart,a.modifiedLength=g.modifiedStart+g.modifiedLength-a.modifiedStart):(s.push(g),a=g)}return s}class e{constructor(s,a,l,c,g){this.originalStartLineNumber=s,this.originalEndLineNumber=a,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=c,this.charChanges=g}static createFromDiffResult(s,a,l,c,g,m,p){let b,_,w,R,U;if(a.originalLength===0?(b=l.getStartLineNumber(a.originalStart)-1,_=0):(b=l.getStartLineNumber(a.originalStart),_=l.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(w=c.getStartLineNumber(a.modifiedStart)-1,R=0):(w=c.getStartLineNumber(a.modifiedStart),R=c.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),m&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&g()){const O=l.createCharSequence(s,a.originalStart,a.originalStart+a.originalLength-1),V=c.createCharSequence(s,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(O.getElements().length>0&&V.getElements().length>0){let $=u(O,V,g,!0).changes;p&&($=d($)),U=[];for(let z=0,X=$.length;z<X;z++)U.push(v.createFromDiffChange($[z],O,V))}}return new e(b,_,w,R,U)}}class E{constructor(s,a,l){this.shouldComputeCharChanges=l.shouldComputeCharChanges,this.shouldPostProcessCharChanges=l.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=l.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=l.shouldMakePrettyDiff,this.originalLines=s,this.modifiedLines=a,this.original=new C(s),this.modified=new C(a),this.continueLineDiff=L(l.maxComputationTime),this.continueCharDiff=L(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=u(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),a=s.changes,l=s.quitEarly;if(this.shouldIgnoreTrimWhitespace){const p=[];for(let b=0,_=a.length;b<_;b++)p.push(e.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a[b],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:l,changes:p}}const c=[];let g=0,m=0;for(let p=-1,b=a.length;p<b;p++){const _=p+1<b?a[p+1]:null,w=_?_.originalStart:this.originalLines.length,R=_?_.modifiedStart:this.modifiedLines.length;for(;g<w&&m<R;){const U=this.originalLines[g],O=this.modifiedLines[m];if(U!==O){{let V=F(U,1),$=F(O,1);for(;V>1&&$>1;){const z=U.charCodeAt(V-2),X=O.charCodeAt($-2);if(z!==X)break;V--,$--}(V>1||$>1)&&this._pushTrimWhitespaceCharChange(c,g+1,1,V,m+1,1,$)}{let V=y(U,1),$=y(O,1);const z=U.length+1,X=O.length+1;for(;V<z&&$<X;){const se=U.charCodeAt(V-1),te=U.charCodeAt($-1);if(se!==te)break;V++,$++}(V<z||$<X)&&this._pushTrimWhitespaceCharChange(c,g+1,V,z,m+1,$,X)}}g++,m++}_&&(c.push(e.createFromDiffResult(this.shouldIgnoreTrimWhitespace,_,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),g+=_.originalLength,m+=_.modifiedLength)}return{quitEarly:l,changes:c}}_pushTrimWhitespaceCharChange(s,a,l,c,g,m,p){if(this._mergeTrimWhitespaceCharChange(s,a,l,c,g,m,p))return;let b;this.shouldComputeCharChanges&&(b=[new v(a,l,a,c,g,m,g,p)]),s.push(new e(a,a,g,g,b))}_mergeTrimWhitespaceCharChange(s,a,l,c,g,m,p){const b=s.length;if(b===0)return!1;const _=s[b-1];return _.originalEndLineNumber===0||_.modifiedEndLineNumber===0?!1:_.originalEndLineNumber+1===a&&_.modifiedEndLineNumber+1===g?(_.originalEndLineNumber=a,_.modifiedEndLineNumber=g,this.shouldComputeCharChanges&&_.charChanges&&_.charChanges.push(new v(a,l,a,c,g,m,g,p)),!0):!1}}n.DiffComputer=E;function F(i,s){const a=D.firstNonWhitespaceIndex(i);return a===-1?s:a+1}function y(i,s){const a=D.lastNonWhitespaceIndex(i);return a===-1?s:a+2}function L(i){if(i===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<i}}),Z(J[40],K([0,1,10,3,2,9,39,36,37,22]),function(B,n,N,t,D,f,A,h,o,u){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class C{constructor(){this.dynamicProgrammingDiffing=new A.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new o.MyersDiffAlgorithm}computeDiff(s,a,l){const c=new Map;function g(z){let X=c.get(z);return X===void 0&&(X=c.size,c.set(z,X)),X}const m=s.map(z=>g(z.trim())),p=a.map(z=>g(z.trim())),b=new f.SequenceFromIntArray(m),_=new f.SequenceFromIntArray(p),w=(()=>b.length+_.length<1500?this.dynamicProgrammingDiffing.compute(b,_,(z,X)=>s[z]===a[X]?a[X].length===0?.1:1+Math.log(1+a[X].length):.99):this.myersDiffingAlgorithm.compute(b,_))(),R=[],U=z=>{for(let X=0;X<z;X++){const se=O+X,te=V+X;if(s[se]!==a[te]){const x=this.refineDiff(s,a,new f.SequenceDiff(new f.OffsetRange(se,se+1),new f.OffsetRange(te,te+1)));for(const r of x)R.push(r)}}};let O=0,V=0;for(const z of w){(0,N.assertFn)(()=>z.seq1Range.start-O===z.seq2Range.start-V);const X=z.seq1Range.start-O;U(X),O=z.seq1Range.endExclusive,V=z.seq2Range.endExclusive;const se=this.refineDiff(s,a,z);for(const te of se)R.push(te)}U(s.length-O);const $=M(R);return{quitEarly:!1,changes:$}}refineDiff(s,a,l){const c=new d(s,l.seq1Range),g=new d(a,l.seq2Range),m=c.length+g.length<500?this.dynamicProgrammingDiffing.compute(c,g):this.myersDiffingAlgorithm.compute(c,g);return(0,h.optimizeSequenceDiffs)(c,g,m).map(_=>new u.RangeMapping(c.translateRange(_.seq1Range).delta(l.seq1Range.start),g.translateRange(_.seq2Range).delta(l.seq2Range.start)))}}n.StandardLinesDiffComputer=C;function M(i){const s=[];for(const a of v(i,(l,c)=>c.originalRange.startLineNumber-(l.originalRange.endLineNumber-(l.originalRange.endColumn>1?0:1))<=1||c.modifiedRange.startLineNumber-(l.modifiedRange.endLineNumber-(l.modifiedRange.endColumn>1?0:1))<=1)){const l=a[0],c=a[a.length-1];s.push(new u.LineRangeMapping(new u.LineRange(l.originalRange.startLineNumber,c.originalRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),new u.LineRange(l.modifiedRange.startLineNumber,c.modifiedRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),a))}return(0,N.assertFn)(()=>(0,N.checkAdjacentItems)(s,(a,l)=>l.originalRange.startLineNumber-a.originalRange.endLineNumberExclusive===l.modifiedRange.startLineNumber-a.modifiedRange.endLineNumberExclusive&&a.originalRange.endLineNumberExclusive<l.originalRange.startLineNumber&&a.modifiedRange.endLineNumberExclusive<l.modifiedRange.startLineNumber)),s}n.lineRangeMappingFromRangeMappings=M;function*v(i,s){let a,l;for(const c of i)l!==void 0&&s(l,c)?a.push(c):(a&&(yield a),a=[c]),l=c;a&&(yield a)}class d{constructor(s,a){this.lines=s,this.lineRange=a;let l=0;this.firstCharOnLineOffsets=new Int32Array(a.length);for(let g=a.start;g<a.endExclusive;g++)l+=s[g].length,this.firstCharOnLineOffsets[g-a.start]=l+1,l++;this.elements=new Int32Array(l);let c=0;for(let g=a.start;g<a.endExclusive;g++){const m=s[g];for(let p=0;p<m.length;p++)this.elements[c+p]=m.charCodeAt(p);c+=m.length,g<s.length-1&&(this.elements[c]=`
`.charCodeAt(0),c+=1)}}getElement(s){return this.elements[s]}get length(){return this.elements.length}getBoundaryScore(s){const a=F(s>0?this.elements[s-1]:-1),l=F(s<this.elements.length?this.elements[s]:-1);let c=0;return a!==l&&(c+=10),c+=a,c+=l,c}translateOffset(s){let a=0,l=this.firstCharOnLineOffsets.length;for(;a<l;){const g=Math.floor((a+l)/2);this.firstCharOnLineOffsets[g]>s?l=g:a=g+1}const c=a===0?0:this.firstCharOnLineOffsets[a-1];return new t.Position(a+1,s-c+1)}translateRange(s){return D.Range.fromPositions(this.translateOffset(s.start),this.translateOffset(s.endExclusive))}}var e;(function(i){i[i.Word=0]="Word",i[i.End=1]="End",i[i.Other=2]="Other",i[i.Space=3]="Space"})(e||(e={}));function E(i){return i}function F(i){return L(i)?3:y(i)?0:i===-1?1:2}function y(i){return i>=97&&i<=122||i>=65&&i<=90||i>=48&&i<=57}function L(i){return i===32||i===9||i===10||i===13}}),Z(J[41],K([0,1,23,40]),function(B,n,N,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new N.SmartLinesDiffComputer,experimental:new t.StandardLinesDiffComputer}}),Z(J[42],K([0,1,20]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var t;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class D{constructor(e,E,F){const y=new Uint8Array(e*E);for(let L=0,i=e*E;L<i;L++)y[L]=F;this._data=y,this.rows=e,this.cols=E}get(e,E){return this._data[e*this.cols+E]}set(e,E,F){this._data[e*this.cols+E]=F}}n.Uint8Matrix=D;class f{constructor(e){let E=0,F=0;for(let L=0,i=e.length;L<i;L++){const[s,a,l]=e[L];a>E&&(E=a),s>F&&(F=s),l>F&&(F=l)}E++,F++;const y=new D(F,E,0);for(let L=0,i=e.length;L<i;L++){const[s,a,l]=e[L];y.set(s,a,l)}this._states=y,this._maxCharCode=E}nextState(e,E){return E<0||E>=this._maxCharCode?0:this._states.get(e,E)}}n.StateMachine=f;let A=null;function h(){return A===null&&(A=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var o;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let u=null;function C(){if(u===null){u=new N.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<d.length;E++)u.set(d.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)u.set(e.charCodeAt(E),2)}return u}class M{static _createLink(e,E,F,y,L){let i=L-1;do{const s=E.charCodeAt(i);if(e.get(s)!==2)break;i--}while(i>y);if(y>0){const s=E.charCodeAt(y-1),a=E.charCodeAt(i);(s===40&&a===41||s===91&&a===93||s===123&&a===125)&&i--}return{range:{startLineNumber:F,startColumn:y+1,endLineNumber:F,endColumn:i+2},url:E.substring(y,i+1)}}static computeLinks(e,E=h()){const F=C(),y=[];for(let L=1,i=e.getLineCount();L<=i;L++){const s=e.getLineContent(L),a=s.length;let l=0,c=0,g=0,m=1,p=!1,b=!1,_=!1,w=!1;for(;l<a;){let R=!1;const U=s.charCodeAt(l);if(m===13){let O;switch(U){case 40:p=!0,O=0;break;case 41:O=p?0:1;break;case 91:_=!0,b=!0,O=0;break;case 93:_=!1,O=b?0:1;break;case 123:w=!0,O=0;break;case 125:O=w?0:1;break;case 39:case 34:case 96:g===U?O=1:g===39||g===34||g===96?O=0:O=1;break;case 42:O=g===42?1:0;break;case 124:O=g===124?1:0;break;case 32:O=_?0:1;break;default:O=F.get(U)}O===1&&(y.push(M._createLink(F,s,L,c,l)),R=!0)}else if(m===12){let O;U===91?(b=!0,O=0):O=F.get(U),O===1?R=!0:m=13}else m=E.nextState(m,U),m===0&&(R=!0);R&&(m=1,p=!1,b=!1,w=!1,c=l+1,g=U),l++}m===13&&y.push(M._createLink(F,s,L,c,a))}return y}}n.LinkComputer=M;function v(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:M.computeLinks(d)}n.computeLinks=v}),Z(J[43],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class N{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(D,f,A,h,o){if(D&&f){const u=this.doNavigateValueSet(f,o);if(u)return{range:D,value:u}}if(A&&h){const u=this.doNavigateValueSet(h,o);if(u)return{range:A,value:u}}return null}doNavigateValueSet(D,f){const A=this.numberReplace(D,f);return A!==null?A:this.textReplace(D,f)}numberReplace(D,f){const A=Math.pow(10,D.length-(D.lastIndexOf(".")+1));let h=Number(D);const o=parseFloat(D);return!isNaN(h)&&!isNaN(o)&&h===o?h===0&&!f?null:(h=Math.floor(h*A),h+=f?A:-A,String(h/A)):null}textReplace(D,f){return this.valueSetsReplace(this._defaultValueSet,D,f)}valueSetsReplace(D,f,A){let h=null;for(let o=0,u=D.length;h===null&&o<u;o++)h=this.valueSetReplace(D[o],f,A);return h}valueSetReplace(D,f,A){let h=D.indexOf(f);return h>=0?(h+=A?1:-1,h<0?h=D.length-1:h%=D.length,D[h]):null}}n.BasicInplaceReplace=N,N.INSTANCE=new N}),Z(J[44],K([0,1,11]),function(B,n,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.isITextSnapshot=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var D;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(D=n.MinimapPosition||(n.MinimapPosition={}));var f;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(f=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var A;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(A=n.EndOfLinePreference||(n.EndOfLinePreference={}));var h;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(h=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var o;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(o=n.EndOfLineSequence||(n.EndOfLineSequence={}));class u{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,N.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}n.TextModelResolvedOptions=u;class C{constructor(s,a){this._findMatchBrand=void 0,this.range=s,this.matches=a}}n.FindMatch=C;var M;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(M=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));function v(i){return i&&typeof i.read=="function"}n.isITextSnapshot=v;var d;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(d=n.PositionAffinity||(n.PositionAffinity={}));var e;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=n.ModelConstants||(n.ModelConstants={}));class E{constructor(s,a,l,c,g,m){this.identifier=s,this.range=a,this.text=l,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=g,this._isTracked=m}}n.ValidAnnotatedEditOperation=E;class F{constructor(s,a,l){this.regex=s,this.wordSeparators=a,this.simpleSearch=l}}n.SearchData=F;class y{constructor(s,a,l){this.reverseEdits=s,this.changes=a,this.trimAutoWhitespaceLineNumbers=l}}n.ApplyEditsResult=y;function L(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}n.shouldSynchronizeModel=L}),Z(J[45],K([0,1,26,19]),function(B,n,N,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class D{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(o,u){o=(0,t.toUint32)(o);const C=this.values,M=this.prefixSum,v=u.length;return v===0?!1:(this.values=new Uint32Array(C.length+v),this.values.set(C.subarray(0,o),0),this.values.set(C.subarray(o),o+v),this.values.set(u,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,u){return o=(0,t.toUint32)(o),u=(0,t.toUint32)(u),this.values[o]===u?!1:(this.values[o]=u,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,u){o=(0,t.toUint32)(o),u=(0,t.toUint32)(u);const C=this.values,M=this.prefixSum;if(o>=C.length)return!1;const v=C.length-o;return u>=v&&(u=v),u===0?!1:(this.values=new Uint32Array(C.length-u),this.values.set(C.subarray(0,o),0),this.values.set(C.subarray(o+u),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,t.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let u=this.prefixSumValidIndex[0]+1;u===0&&(this.prefixSum[0]=this.values[0],u++),o>=this.values.length&&(o=this.values.length-1);for(let C=u;C<=o;C++)this.prefixSum[C]=this.prefixSum[C-1]+this.values[C];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let u=0,C=this.values.length-1,M=0,v=0,d=0;for(;u<=C;)if(M=u+(C-u)/2|0,v=this.prefixSum[M],d=v-this.values[M],o<d)C=M-1;else if(o>=v)u=M+1;else break;return new A(M,o-d)}}n.PrefixSumComputer=D;class f{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const u=this._indexBySum[o],C=u>0?this._prefixSum[u-1]:0;return new A(u,o-C)}removeValues(o,u){this._values.splice(o,u),this._invalidate(o)}insertValues(o,u){this._values=(0,N.arrayInsert)(this._values,o,u),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,u=this._values.length;o<u;o++){const C=this._values[o],M=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=M+C;for(let v=0;v<C;v++)this._indexBySum[M+v]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,u){this._values[o]!==u&&(this._values[o]=u,this._invalidate(o))}}n.ConstantTimePrefixSumComputer=f;class A{constructor(o,u){this.index=o,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=u}}n.PrefixSumIndexOfResult=A}),Z(J[46],K([0,1,4,3,45]),function(B,n,N,t,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class f{constructor(h,o,u,C){this._uri=h,this._lines=o,this._eol=u,this._versionId=C,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(h){h.eol&&h.eol!==this._eol&&(this._eol=h.eol,this._lineStarts=null);const o=h.changes;for(const u of o)this._acceptDeleteRange(u.range),this._acceptInsertText(new t.Position(u.range.startLineNumber,u.range.startColumn),u.text);this._versionId=h.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const h=this._eol.length,o=this._lines.length,u=new Uint32Array(o);for(let C=0;C<o;C++)u[C]=this._lines[C].length+h;this._lineStarts=new D.PrefixSumComputer(u)}}_setLineText(h,o){this._lines[h]=o,this._lineStarts&&this._lineStarts.setValue(h,this._lines[h].length+this._eol.length)}_acceptDeleteRange(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.startLineNumber-1].substring(h.endColumn-1));return}this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.endLineNumber-1].substring(h.endColumn-1)),this._lines.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}_acceptInsertText(h,o){if(o.length===0)return;const u=(0,N.splitLines)(o);if(u.length===1){this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+u[0]+this._lines[h.lineNumber-1].substring(h.column-1));return}u[u.length-1]+=this._lines[h.lineNumber-1].substring(h.column-1),this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+u[0]);const C=new Uint32Array(u.length-1);for(let M=1;M<u.length;M++)this._lines.splice(h.lineNumber+M-1,0,u[M]),C[M-1]=u[M].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(h.lineNumber,C)}}n.MirrorTextModel=f}),Z(J[47],K([0,1,4,35,3,2,44]),function(B,n,N,t,D,f,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const h=999;class o{constructor(L,i,s,a){this.searchString=L,this.isRegex=i,this.matchCase=s,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=u(this.searchString):L=this.searchString.indexOf(`
`)>=0;let i=null;try{i=N.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!L;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new A.SearchData(i,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}n.SearchParams=o;function u(y){if(!y||y.length===0)return!1;for(let L=0,i=y.length;L<i;L++){const s=y.charCodeAt(L);if(s===10)return!0;if(s===92){if(L++,L>=i)break;const a=y.charCodeAt(L);if(a===110||a===114||a===87)return!0}}return!1}n.isMultilineRegexSource=u;function C(y,L,i){if(!i)return new A.FindMatch(y,null);const s=[];for(let a=0,l=L.length;a<l;a++)s[a]=L[a];return new A.FindMatch(y,s)}n.createFindMatch=C;class M{constructor(L){const i=[];let s=0;for(let a=0,l=L.length;a<l;a++)L.charCodeAt(a)===10&&(i[s++]=a);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(L){const i=this._lineFeedsOffsets;let s=0,a=i.length-1;if(a===-1||L<=i[0])return 0;for(;s<a;){const l=s+((a-s)/2>>0);i[l]>=L?a=l-1:i[l+1]>=L?(s=l,a=l):s=l+1}return s+1}}class v{static findMatches(L,i,s,a,l){const c=i.parseSearchRequest();return c?c.regex.multiline?this._doFindMatchesMultiline(L,s,new F(c.wordSeparators,c.regex),a,l):this._doFindMatchesLineByLine(L,s,c,a,l):[]}static _getMultilineMatchRange(L,i,s,a,l,c){let g,m=0;a?(m=a.findLineFeedCountBeforeOffset(l),g=i+l+m):g=i+l;let p;if(a){const R=a.findLineFeedCountBeforeOffset(l+c.length)-m;p=g+c.length+R}else p=g+c.length;const b=L.getPositionAt(g),_=L.getPositionAt(p);return new f.Range(b.lineNumber,b.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(L,i,s,a,l){const c=L.getOffsetAt(i.getStartPosition()),g=L.getValueInRange(i,1),m=L.getEOL()===`\r
`?new M(g):null,p=[];let b=0,_;for(s.reset(0);_=s.next(g);)if(p[b++]=C(this._getMultilineMatchRange(L,c,g,m,_.index,_[0]),_,a),b>=l)return p;return p}static _doFindMatchesLineByLine(L,i,s,a,l){const c=[];let g=0;if(i.startLineNumber===i.endLineNumber){const p=L.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return g=this._findMatchesInLine(s,p,i.startLineNumber,i.startColumn-1,g,c,a,l),c}const m=L.getLineContent(i.startLineNumber).substring(i.startColumn-1);g=this._findMatchesInLine(s,m,i.startLineNumber,i.startColumn-1,g,c,a,l);for(let p=i.startLineNumber+1;p<i.endLineNumber&&g<l;p++)g=this._findMatchesInLine(s,L.getLineContent(p),p,0,g,c,a,l);if(g<l){const p=L.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);g=this._findMatchesInLine(s,p,i.endLineNumber,0,g,c,a,l)}return c}static _findMatchesInLine(L,i,s,a,l,c,g,m){const p=L.wordSeparators;if(!g&&L.simpleSearch){const w=L.simpleSearch,R=w.length,U=i.length;let O=-R;for(;(O=i.indexOf(w,O+R))!==-1;)if((!p||E(p,i,U,O,R))&&(c[l++]=new A.FindMatch(new f.Range(s,O+1+a,s,O+1+R+a),null),l>=m))return l;return l}const b=new F(L.wordSeparators,L.regex);let _;b.reset(0);do if(_=b.next(i),_&&(c[l++]=C(new f.Range(s,_.index+1+a,s,_.index+1+_[0].length+a),_,g),l>=m))return l;while(_);return l}static findNextMatch(L,i,s,a){const l=i.parseSearchRequest();if(!l)return null;const c=new F(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindNextMatchMultiline(L,s,c,a):this._doFindNextMatchLineByLine(L,s,c,a)}static _doFindNextMatchMultiline(L,i,s,a){const l=new D.Position(i.lineNumber,1),c=L.getOffsetAt(l),g=L.getLineCount(),m=L.getValueInRange(new f.Range(l.lineNumber,l.column,g,L.getLineMaxColumn(g)),1),p=L.getEOL()===`\r
`?new M(m):null;s.reset(i.column-1);const b=s.next(m);return b?C(this._getMultilineMatchRange(L,c,m,p,b.index,b[0]),b,a):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(L,new D.Position(1,1),s,a):null}static _doFindNextMatchLineByLine(L,i,s,a){const l=L.getLineCount(),c=i.lineNumber,g=L.getLineContent(c),m=this._findFirstMatchInLine(s,g,c,i.column,a);if(m)return m;for(let p=1;p<=l;p++){const b=(c+p-1)%l,_=L.getLineContent(b+1),w=this._findFirstMatchInLine(s,_,b+1,1,a);if(w)return w}return null}static _findFirstMatchInLine(L,i,s,a,l){L.reset(a-1);const c=L.next(i);return c?C(new f.Range(s,c.index+1,s,c.index+1+c[0].length),c,l):null}static findPreviousMatch(L,i,s,a){const l=i.parseSearchRequest();if(!l)return null;const c=new F(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindPreviousMatchMultiline(L,s,c,a):this._doFindPreviousMatchLineByLine(L,s,c,a)}static _doFindPreviousMatchMultiline(L,i,s,a){const l=this._doFindMatchesMultiline(L,new f.Range(1,1,i.lineNumber,i.column),s,a,10*h);if(l.length>0)return l[l.length-1];const c=L.getLineCount();return i.lineNumber!==c||i.column!==L.getLineMaxColumn(c)?this._doFindPreviousMatchMultiline(L,new D.Position(c,L.getLineMaxColumn(c)),s,a):null}static _doFindPreviousMatchLineByLine(L,i,s,a){const l=L.getLineCount(),c=i.lineNumber,g=L.getLineContent(c).substring(0,i.column-1),m=this._findLastMatchInLine(s,g,c,a);if(m)return m;for(let p=1;p<=l;p++){const b=(l+c-p-1)%l,_=L.getLineContent(b+1),w=this._findLastMatchInLine(s,_,b+1,a);if(w)return w}return null}static _findLastMatchInLine(L,i,s,a){let l=null,c;for(L.reset(0);c=L.next(i);)l=C(new f.Range(s,c.index+1,s,c.index+1+c[0].length),c,a);return l}}n.TextModelSearch=v;function d(y,L,i,s,a){if(s===0)return!0;const l=L.charCodeAt(s-1);if(y.get(l)!==0||l===13||l===10)return!0;if(a>0){const c=L.charCodeAt(s);if(y.get(c)!==0)return!0}return!1}function e(y,L,i,s,a){if(s+a===i)return!0;const l=L.charCodeAt(s+a);if(y.get(l)!==0||l===13||l===10)return!0;if(a>0){const c=L.charCodeAt(s+a-1);if(y.get(c)!==0)return!0}return!1}function E(y,L,i,s,a){return d(y,L,i,s,a)&&e(y,L,i,s,a)}n.isValidMatch=E;class F{constructor(L,i){this._wordSeparators=L,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(L){this._searchRegex.lastIndex=L,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(L){const i=L.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(s=this._searchRegex.exec(L),!s))return null;const a=s.index,l=s[0].length;if(a===this._prevMatchStartIndex&&l===this._prevMatchLength){if(l===0){N.getNextCodePoint(L,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=l,!this._wordSeparators||E(this._wordSeparators,L,i,a,l))return s}while(s);return null}}n.Searcher=F}),Z(J[48],K([0,1,2,47,4,10,21]),function(B,n,N,t,D,f,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class h{static computeUnicodeHighlights(e,E,F){const y=F?F.startLineNumber:1,L=F?F.endLineNumber:e.getLineCount(),i=new C(E),s=i.getCandidateCodePoints();let a;s==="allNonBasicAscii"?a=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):a=new RegExp(`${o(Array.from(s))}`,"g");const l=new t.Searcher(null,a),c=[];let g=!1,m,p=0,b=0,_=0;e:for(let w=y,R=L;w<=R;w++){const U=e.getLineContent(w),O=U.length;l.reset(0);do if(m=l.next(U),m){let V=m.index,$=m.index+m[0].length;if(V>0){const te=U.charCodeAt(V-1);D.isHighSurrogate(te)&&V--}if($+1<O){const te=U.charCodeAt($-1);D.isHighSurrogate(te)&&$++}const z=U.substring(V,$),X=(0,A.getWordAtText)(V+1,A.DEFAULT_WORD_REGEXP,U,0),se=i.shouldHighlightNonBasicASCII(z,X?X.word:null);if(se!==0){se===3?p++:se===2?b++:se===1?_++:(0,f.assertNever)(se);const te=1e3;if(c.length>=te){g=!0;break e}c.push(new N.Range(w,V+1,w,$+1))}}while(m)}return{ranges:c,hasMore:g,ambiguousCharacterCount:p,invisibleCharacterCount:b,nonBasicAsciiCharacterCount:_}}static computeUnicodeHighlightReason(e,E){const F=new C(E);switch(F.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=e.codePointAt(0),i=F.ambiguousCharacters.getPrimaryConfusable(L),s=D.AmbiguousCharacters.getLocales().filter(a=>!D.AmbiguousCharacters.getInstance(new Set([...E.allowedLocales,a])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(i),notAmbiguousInLocales:s}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=h;function o(d,e){return`[${D.escapeRegExpCharacters(d.map(F=>String.fromCodePoint(F)).join(""))}]`}var u;(function(d){d[d.Ambiguous=0]="Ambiguous",d[d.Invisible=1]="Invisible",d[d.NonBasicAscii=2]="NonBasicAscii"})(u=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class C{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=D.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const E of D.InvisibleCharacters.codePoints)M(String.fromCodePoint(E))||e.add(E);if(this.options.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.allowedCodePoints)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const F=e.codePointAt(0);if(this.allowedCodePoints.has(F))return 0;if(this.options.nonBasicASCII)return 1;let y=!1,L=!1;if(E)for(const i of E){const s=i.codePointAt(0),a=D.isBasicASCII(i);y=y||a,!a&&!this.ambiguousCharacters.isAmbiguous(s)&&!D.InvisibleCharacters.isInvisibleCharacter(s)&&(L=!0)}return!y&&L?0:this.options.invisibleCharacters&&!M(e)&&D.InvisibleCharacters.isInvisibleCharacter(F)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(F)?3:0}}function M(d){return d===" "||d===`
`||d==="	"}var v;(function(d){d[d.None=0]="None",d[d.NonBasicASCII=1]="NonBasicASCII",d[d.Invisible=2]="Invisible",d[d.Ambiguous=3]="Ambiguous"})(v||(v={}))}),Z(J[49],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var N;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(N=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(t=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var D;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(D=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var f;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(f=n.CompletionItemKind||(n.CompletionItemKind={}));var A;(function(r){r[r.Deprecated=1]="Deprecated"})(A=n.CompletionItemTag||(n.CompletionItemTag={}));var h;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var o;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(o=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u=n.CursorChangeReason||(n.CursorChangeReason={}));var C;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(C=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var M;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(M=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var v;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(v=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var d;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.dropIntoEditor=32]="dropIntoEditor",r[r.emptySelectionClipboard=33]="emptySelectionClipboard",r[r.extraEditorClassName=34]="extraEditorClassName",r[r.fastScrollSensitivity=35]="fastScrollSensitivity",r[r.find=36]="find",r[r.fixedOverflowWidgets=37]="fixedOverflowWidgets",r[r.folding=38]="folding",r[r.foldingStrategy=39]="foldingStrategy",r[r.foldingHighlight=40]="foldingHighlight",r[r.foldingImportsByDefault=41]="foldingImportsByDefault",r[r.foldingMaximumRegions=42]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=44]="fontFamily",r[r.fontInfo=45]="fontInfo",r[r.fontLigatures=46]="fontLigatures",r[r.fontSize=47]="fontSize",r[r.fontWeight=48]="fontWeight",r[r.formatOnPaste=49]="formatOnPaste",r[r.formatOnType=50]="formatOnType",r[r.glyphMargin=51]="glyphMargin",r[r.gotoLocation=52]="gotoLocation",r[r.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",r[r.hover=54]="hover",r[r.inDiffEditor=55]="inDiffEditor",r[r.inlineSuggest=56]="inlineSuggest",r[r.letterSpacing=57]="letterSpacing",r[r.lightbulb=58]="lightbulb",r[r.lineDecorationsWidth=59]="lineDecorationsWidth",r[r.lineHeight=60]="lineHeight",r[r.lineNumbers=61]="lineNumbers",r[r.lineNumbersMinChars=62]="lineNumbersMinChars",r[r.linkedEditing=63]="linkedEditing",r[r.links=64]="links",r[r.matchBrackets=65]="matchBrackets",r[r.minimap=66]="minimap",r[r.mouseStyle=67]="mouseStyle",r[r.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=69]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",r[r.multiCursorModifier=71]="multiCursorModifier",r[r.multiCursorPaste=72]="multiCursorPaste",r[r.occurrencesHighlight=73]="occurrencesHighlight",r[r.overviewRulerBorder=74]="overviewRulerBorder",r[r.overviewRulerLanes=75]="overviewRulerLanes",r[r.padding=76]="padding",r[r.parameterHints=77]="parameterHints",r[r.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",r[r.quickSuggestions=80]="quickSuggestions",r[r.quickSuggestionsDelay=81]="quickSuggestionsDelay",r[r.readOnly=82]="readOnly",r[r.renameOnType=83]="renameOnType",r[r.renderControlCharacters=84]="renderControlCharacters",r[r.renderFinalNewline=85]="renderFinalNewline",r[r.renderLineHighlight=86]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=88]="renderValidationDecorations",r[r.renderWhitespace=89]="renderWhitespace",r[r.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",r[r.roundedSelection=91]="roundedSelection",r[r.rulers=92]="rulers",r[r.scrollbar=93]="scrollbar",r[r.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=95]="scrollBeyondLastLine",r[r.scrollPredominantAxis=96]="scrollPredominantAxis",r[r.selectionClipboard=97]="selectionClipboard",r[r.selectionHighlight=98]="selectionHighlight",r[r.selectOnLineNumbers=99]="selectOnLineNumbers",r[r.showFoldingControls=100]="showFoldingControls",r[r.showUnused=101]="showUnused",r[r.snippetSuggestions=102]="snippetSuggestions",r[r.smartSelect=103]="smartSelect",r[r.smoothScrolling=104]="smoothScrolling",r[r.stickyScroll=105]="stickyScroll",r[r.stickyTabStops=106]="stickyTabStops",r[r.stopRenderingLineAfter=107]="stopRenderingLineAfter",r[r.suggest=108]="suggest",r[r.suggestFontSize=109]="suggestFontSize",r[r.suggestLineHeight=110]="suggestLineHeight",r[r.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",r[r.suggestSelection=112]="suggestSelection",r[r.tabCompletion=113]="tabCompletion",r[r.tabIndex=114]="tabIndex",r[r.unicodeHighlighting=115]="unicodeHighlighting",r[r.unusualLineTerminators=116]="unusualLineTerminators",r[r.useShadowDOM=117]="useShadowDOM",r[r.useTabStops=118]="useTabStops",r[r.wordSeparators=119]="wordSeparators",r[r.wordWrap=120]="wordWrap",r[r.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=123]="wordWrapColumn",r[r.wordWrapOverride1=124]="wordWrapOverride1",r[r.wordWrapOverride2=125]="wordWrapOverride2",r[r.wrappingIndent=126]="wrappingIndent",r[r.wrappingStrategy=127]="wrappingStrategy",r[r.showDeprecated=128]="showDeprecated",r[r.inlayHints=129]="inlayHints",r[r.editorClassName=130]="editorClassName",r[r.pixelRatio=131]="pixelRatio",r[r.tabFocusMode=132]="tabFocusMode",r[r.layoutInfo=133]="layoutInfo",r[r.wrappingInfo=134]="wrappingInfo"})(d=n.EditorOption||(n.EditorOption={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e=n.EndOfLinePreference||(n.EndOfLinePreference={}));var E;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(E=n.EndOfLineSequence||(n.EndOfLineSequence={}));var F;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(F=n.IndentAction||(n.IndentAction={}));var y;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(y=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var L;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(L=n.InlayHintKind||(n.InlayHintKind={}));var i;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(i=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(s=n.KeyCode||(n.KeyCode={}));var a;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(a=n.MarkerSeverity||(n.MarkerSeverity={}));var l;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(l=n.MarkerTag||(n.MarkerTag={}));var c;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(c=n.MinimapPosition||(n.MinimapPosition={}));var g;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(g=n.MouseTargetType||(n.MouseTargetType={}));var m;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(m=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var p;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(p=n.OverviewRulerLane||(n.OverviewRulerLane={}));var b;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(b=n.PositionAffinity||(n.PositionAffinity={}));var _;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(_=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var w;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(w=n.RenderMinimap||(n.RenderMinimap={}));var R;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(R=n.ScrollType||(n.ScrollType={}));var U;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(U=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var O;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(O=n.SelectionDirection||(n.SelectionDirection={}));var V;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(V=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var $;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})($=n.SymbolKind||(n.SymbolKind={}));var z;(function(r){r[r.Deprecated=1]="Deprecated"})(z=n.SymbolTag||(n.SymbolTag={}));var X;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(X=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var se;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(se=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var te;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(te=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var x;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(x=n.WrappingIndent||(n.WrappingIndent={}))}),Z(J[50],K([0,1,8,7]),function(B,n,N,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new N.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(h){this._onDidChange.fire({changedLanguages:h,changedColorMap:!1})}register(h,o){return this._map.set(h,o),this.fire([h]),(0,t.toDisposable)(()=>{this._map.get(h)===o&&(this._map.delete(h),this.fire([h]))})}registerFactory(h,o){this._factories.get(h)?.dispose();const u=new f(this,h,o);return this._factories.set(h,u),(0,t.toDisposable)(()=>{const C=this._factories.get(h);!C||C!==u||(this._factories.delete(h),C.dispose())})}async getOrCreate(h){const o=this.get(h);if(o)return o;const u=this._factories.get(h);return!u||u.isResolved?null:(await u.resolve(),this.get(h))}get(h){return this._map.get(h)||null}isResolved(h){if(this.get(h))return!0;const u=this._factories.get(h);return!!(!u||u.isResolved)}setColorMap(h){this._colorMap=h,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=D;class f extends t.Disposable{get isResolved(){return this._isResolved}constructor(h,o,u){super(),this._registry=h,this._languageId=o,this._factory=u,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const h=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,h&&!this._isDisposed&&this._register(this._registry.register(this._languageId,h))}}}),Z(J[51],K([0,1,24,12,2,50]),function(B,n,N,t,D,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class A{constructor(R,U,O){this._tokenBrand=void 0,this.offset=R,this.type=U,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=A;class h{constructor(R,U){this._tokenizationResultBrand=void 0,this.tokens=R,this.endState=U}}n.TokenizationResult=h;class o{constructor(R,U){this._encodedTokenizationResultBrand=void 0,this.tokens=R,this.endState=U}}n.EncodedTokenizationResult=o;var u;(function(w){w[w.Method=0]="Method",w[w.Function=1]="Function",w[w.Constructor=2]="Constructor",w[w.Field=3]="Field",w[w.Variable=4]="Variable",w[w.Class=5]="Class",w[w.Struct=6]="Struct",w[w.Interface=7]="Interface",w[w.Module=8]="Module",w[w.Property=9]="Property",w[w.Event=10]="Event",w[w.Operator=11]="Operator",w[w.Unit=12]="Unit",w[w.Value=13]="Value",w[w.Constant=14]="Constant",w[w.Enum=15]="Enum",w[w.EnumMember=16]="EnumMember",w[w.Keyword=17]="Keyword",w[w.Text=18]="Text",w[w.Color=19]="Color",w[w.File=20]="File",w[w.Reference=21]="Reference",w[w.Customcolor=22]="Customcolor",w[w.Folder=23]="Folder",w[w.TypeParameter=24]="TypeParameter",w[w.User=25]="User",w[w.Issue=26]="Issue",w[w.Snippet=27]="Snippet"})(u=n.CompletionItemKind||(n.CompletionItemKind={}));var C;(function(w){const R=new Map;R.set(0,N.Codicon.symbolMethod),R.set(1,N.Codicon.symbolFunction),R.set(2,N.Codicon.symbolConstructor),R.set(3,N.Codicon.symbolField),R.set(4,N.Codicon.symbolVariable),R.set(5,N.Codicon.symbolClass),R.set(6,N.Codicon.symbolStruct),R.set(7,N.Codicon.symbolInterface),R.set(8,N.Codicon.symbolModule),R.set(9,N.Codicon.symbolProperty),R.set(10,N.Codicon.symbolEvent),R.set(11,N.Codicon.symbolOperator),R.set(12,N.Codicon.symbolUnit),R.set(13,N.Codicon.symbolValue),R.set(15,N.Codicon.symbolEnum),R.set(14,N.Codicon.symbolConstant),R.set(15,N.Codicon.symbolEnum),R.set(16,N.Codicon.symbolEnumMember),R.set(17,N.Codicon.symbolKeyword),R.set(27,N.Codicon.symbolSnippet),R.set(18,N.Codicon.symbolText),R.set(19,N.Codicon.symbolColor),R.set(20,N.Codicon.symbolFile),R.set(21,N.Codicon.symbolReference),R.set(22,N.Codicon.symbolCustomColor),R.set(23,N.Codicon.symbolFolder),R.set(24,N.Codicon.symbolTypeParameter),R.set(25,N.Codicon.account),R.set(26,N.Codicon.issues);function U($){let z=R.get($);return z||(console.info("No codicon found for CompletionItemKind "+$),z=N.Codicon.symbolProperty),z}w.toIcon=U;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function V($,z){let X=O.get($);return typeof X>"u"&&!z&&(X=9),X}w.fromString=V})(C=n.CompletionItemKinds||(n.CompletionItemKinds={}));var M;(function(w){w[w.Deprecated=1]="Deprecated"})(M=n.CompletionItemTag||(n.CompletionItemTag={}));var v;(function(w){w[w.KeepWhitespace=1]="KeepWhitespace",w[w.InsertAsSnippet=4]="InsertAsSnippet"})(v=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var d;(function(w){w[w.Invoke=0]="Invoke",w[w.TriggerCharacter=1]="TriggerCharacter",w[w.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var e;(function(w){w[w.Automatic=0]="Automatic",w[w.Explicit=1]="Explicit"})(e=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var E;(function(w){w[w.Invoke=1]="Invoke",w[w.Auto=2]="Auto"})(E=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var F;(function(w){w[w.Invoke=1]="Invoke",w[w.TriggerCharacter=2]="TriggerCharacter",w[w.ContentChange=3]="ContentChange"})(F=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var y;(function(w){w[w.Text=0]="Text",w[w.Read=1]="Read",w[w.Write=2]="Write"})(y=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function L(w){return w&&t.URI.isUri(w.uri)&&D.Range.isIRange(w.range)&&(D.Range.isIRange(w.originSelectionRange)||D.Range.isIRange(w.targetSelectionRange))}n.isLocationLink=L;var i;(function(w){w[w.File=0]="File",w[w.Module=1]="Module",w[w.Namespace=2]="Namespace",w[w.Package=3]="Package",w[w.Class=4]="Class",w[w.Method=5]="Method",w[w.Property=6]="Property",w[w.Field=7]="Field",w[w.Constructor=8]="Constructor",w[w.Enum=9]="Enum",w[w.Interface=10]="Interface",w[w.Function=11]="Function",w[w.Variable=12]="Variable",w[w.Constant=13]="Constant",w[w.String=14]="String",w[w.Number=15]="Number",w[w.Boolean=16]="Boolean",w[w.Array=17]="Array",w[w.Object=18]="Object",w[w.Key=19]="Key",w[w.Null=20]="Null",w[w.EnumMember=21]="EnumMember",w[w.Struct=22]="Struct",w[w.Event=23]="Event",w[w.Operator=24]="Operator",w[w.TypeParameter=25]="TypeParameter"})(i=n.SymbolKind||(n.SymbolKind={}));var s;(function(w){w[w.Deprecated=1]="Deprecated"})(s=n.SymbolTag||(n.SymbolTag={}));var a;(function(w){const R=new Map;R.set(0,N.Codicon.symbolFile),R.set(1,N.Codicon.symbolModule),R.set(2,N.Codicon.symbolNamespace),R.set(3,N.Codicon.symbolPackage),R.set(4,N.Codicon.symbolClass),R.set(5,N.Codicon.symbolMethod),R.set(6,N.Codicon.symbolProperty),R.set(7,N.Codicon.symbolField),R.set(8,N.Codicon.symbolConstructor),R.set(9,N.Codicon.symbolEnum),R.set(10,N.Codicon.symbolInterface),R.set(11,N.Codicon.symbolFunction),R.set(12,N.Codicon.symbolVariable),R.set(13,N.Codicon.symbolConstant),R.set(14,N.Codicon.symbolString),R.set(15,N.Codicon.symbolNumber),R.set(16,N.Codicon.symbolBoolean),R.set(17,N.Codicon.symbolArray),R.set(18,N.Codicon.symbolObject),R.set(19,N.Codicon.symbolKey),R.set(20,N.Codicon.symbolNull),R.set(21,N.Codicon.symbolEnumMember),R.set(22,N.Codicon.symbolStruct),R.set(23,N.Codicon.symbolEvent),R.set(24,N.Codicon.symbolOperator),R.set(25,N.Codicon.symbolTypeParameter);function U(O){let V=R.get(O);return V||(console.info("No codicon found for SymbolKind "+O),V=N.Codicon.symbolProperty),V}w.toIcon=U})(a=n.SymbolKinds||(n.SymbolKinds={}));class l{constructor(R){this.value=R}}n.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var c;(function(w){function R(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}w.is=R})(c=n.Command||(n.Command={}));var g;(function(w){w[w.Collapsed=0]="Collapsed",w[w.Expanded=1]="Expanded"})(g=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var m;(function(w){w[w.Unresolved=0]="Unresolved",w[w.Resolved=1]="Resolved"})(m=n.CommentThreadState||(n.CommentThreadState={}));var p;(function(w){w[w.Editing=0]="Editing",w[w.Preview=1]="Preview"})(p=n.CommentMode||(n.CommentMode={}));var b;(function(w){w[w.Type=1]="Type",w[w.Parameter=2]="Parameter"})(b=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new f.TokenizationRegistry;var _;(function(w){w[w.None=0]="None",w[w.Option=1]="Option",w[w.Default=2]="Default",w[w.Preferred=3]="Preferred"})(_=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),Z(J[52],K([0,1,17,8,27,12,3,2,34,51,49]),function(B,n,N,t,D,f,A,h,o,u,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class M{static chord(e,E){return(0,D.KeyChord)(e,E)}}n.KeyMod=M,M.CtrlCmd=2048,M.Shift=1024,M.Alt=512,M.WinCtrl=256;function v(){return{editor:void 0,languages:void 0,CancellationTokenSource:N.CancellationTokenSource,Emitter:t.Emitter,KeyCode:C.KeyCode,KeyMod:M,Position:A.Position,Range:h.Range,Selection:o.Selection,SelectionDirection:C.SelectionDirection,MarkerSeverity:C.MarkerSeverity,MarkerTag:C.MarkerTag,Uri:f.URI,Token:u.Token}}n.createMonacoBaseAPI=v}),Z(J[55],K([0,1,18,5,12,3,2,46,21,42,43,52,16,48,23,41,11]),function(B,n,N,t,D,f,A,h,o,u,C,M,v,d,e,E,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class y extends h.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(a){return this._lines[a-1]}getWordAtPosition(a,l){const c=(0,o.getWordAtText)(a.column,(0,o.ensureValidWordDefinition)(l),this._lines[a.lineNumber-1],0);return c?new A.Range(a.lineNumber,c.startColumn,a.lineNumber,c.endColumn):null}getWordUntilPosition(a,l){const c=this.getWordAtPosition(a,l);return c?{word:this._lines[a.lineNumber-1].substring(c.startColumn-1,a.column-1),startColumn:c.startColumn,endColumn:a.column}:{word:"",startColumn:a.column,endColumn:a.column}}words(a){const l=this._lines,c=this._wordenize.bind(this);let g=0,m="",p=0,b=[];return{*[Symbol.iterator](){for(;;)if(p<b.length){const _=m.substring(b[p].start,b[p].end);p+=1,yield _}else if(g<l.length)m=l[g],b=c(m,a),p=0,g+=1;else break}}}getLineWords(a,l){const c=this._lines[a-1],g=this._wordenize(c,l),m=[];for(const p of g)m.push({word:c.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return m}_wordenize(a,l){const c=[];let g;for(l.lastIndex=0;(g=l.exec(a))&&g[0].length!==0;)c.push({start:g.index,end:g.index+g[0].length});return c}getValueInRange(a){if(a=this._validateRange(a),a.startLineNumber===a.endLineNumber)return this._lines[a.startLineNumber-1].substring(a.startColumn-1,a.endColumn-1);const l=this._eol,c=a.startLineNumber-1,g=a.endLineNumber-1,m=[];m.push(this._lines[c].substring(a.startColumn-1));for(let p=c+1;p<g;p++)m.push(this._lines[p]);return m.push(this._lines[g].substring(0,a.endColumn-1)),m.join(l)}offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.lineNumber-2)+(a.column-1)}positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(a),c=this._lines[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,c)}}_validateRange(a){const l=this._validatePosition({lineNumber:a.startLineNumber,column:a.startColumn}),c=this._validatePosition({lineNumber:a.endLineNumber,column:a.endColumn});return l.lineNumber!==a.startLineNumber||l.column!==a.startColumn||c.lineNumber!==a.endLineNumber||c.column!==a.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:c.lineNumber,endColumn:c.column}:a}_validatePosition(a){if(!f.Position.isIPosition(a))throw new Error("bad position");let{lineNumber:l,column:c}=a,g=!1;if(l<1)l=1,c=1,g=!0;else if(l>this._lines.length)l=this._lines.length,c=this._lines[l-1].length+1,g=!0;else{const m=this._lines[l-1].length+1;c<1?(c=1,g=!0):c>m&&(c=m,g=!0)}return g?{lineNumber:l,column:c}:a}}n.MirrorModel=y;class L{constructor(a,l){this._host=a,this._models=Object.create(null),this._foreignModuleFactory=l,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(a){return this._models[a]}_getModels(){const a=[];return Object.keys(this._models).forEach(l=>a.push(this._models[l])),a}acceptNewModel(a){this._models[a.url]=new y(D.URI.parse(a.url),a.lines,a.EOL,a.versionId)}acceptModelChanged(a,l){if(!this._models[a])return;this._models[a].onEvents(l)}acceptRemovedModel(a){!this._models[a]||delete this._models[a]}async computeUnicodeHighlights(a,l,c){const g=this._getModel(a);return g?d.UnicodeTextModelHighlighter.computeUnicodeHighlights(g,l,c):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(a,l,c){const g=this._getModel(a),m=this._getModel(l);return!g||!m?null:L.computeDiff(g,m,c)}static computeDiff(a,l,c){const g=c.diffAlgorithm==="experimental"?E.linesDiffComputers.experimental:E.linesDiffComputers.smart,m=a.getLinesContent(),p=l.getLinesContent(),b=g.computeDiff(m,p,c);return{identical:b.changes.length>0?!1:this._modelsAreIdentical(a,l),quitEarly:b.quitEarly,changes:b.changes.map(w=>[w.originalRange.startLineNumber,w.originalRange.endLineNumberExclusive,w.modifiedRange.startLineNumber,w.modifiedRange.endLineNumberExclusive,w.innerChanges?.map(R=>[R.originalRange.startLineNumber,R.originalRange.startColumn,R.originalRange.endLineNumber,R.originalRange.endColumn,R.modifiedRange.startLineNumber,R.modifiedRange.startColumn,R.modifiedRange.endLineNumber,R.modifiedRange.endColumn])])}}static _modelsAreIdentical(a,l){const c=a.getLineCount(),g=l.getLineCount();if(c!==g)return!1;for(let m=1;m<=c;m++){const p=a.getLineContent(m),b=l.getLineContent(m);if(p!==b)return!1}return!0}async computeDirtyDiff(a,l,c){const g=this._getModel(a),m=this._getModel(l);if(!g||!m)return null;const p=g.getLinesContent(),b=m.getLinesContent();return new e.DiffComputer(p,b,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:c,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(a,l){const c=this._getModel(a);if(!c)return l;const g=[];let m;l=l.slice(0).sort((p,b)=>{if(p.range&&b.range)return A.Range.compareRangesUsingStarts(p.range,b.range);const _=p.range?0:1,w=b.range?0:1;return _-w});for(let{range:p,text:b,eol:_}of l){if(typeof _=="number"&&(m=_),A.Range.isEmpty(p)&&!b)continue;const w=c.getValueInRange(p);if(b=b.replace(/\r\n|\n|\r/g,c.eol),w===b)continue;if(Math.max(b.length,w.length)>L._diffLimit){g.push({range:p,text:b});continue}const R=(0,N.stringDiff)(w,b,!1),U=c.offsetAt(A.Range.lift(p).getStartPosition());for(const O of R){const V=c.positionAt(U+O.originalStart),$=c.positionAt(U+O.originalStart+O.originalLength),z={text:b.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:V.lineNumber,startColumn:V.column,endLineNumber:$.lineNumber,endColumn:$.column}};c.getValueInRange(z.range)!==z.text&&g.push(z)}}return typeof m=="number"&&g.push({eol:m,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),g}async computeLinks(a){const l=this._getModel(a);return l?(0,u.computeLinks)(l):null}async textualSuggest(a,l,c,g){const m=new v.StopWatch(!0),p=new RegExp(c,g),b=new Set;e:for(const _ of a){const w=this._getModel(_);if(!!w){for(const R of w.words(p))if(!(R===l||!isNaN(Number(R)))&&(b.add(R),b.size>L._suggestionsLimit))break e}}return{words:Array.from(b),duration:m.elapsed()}}async computeWordRanges(a,l,c,g){const m=this._getModel(a);if(!m)return Object.create(null);const p=new RegExp(c,g),b=Object.create(null);for(let _=l.startLineNumber;_<l.endLineNumber;_++){const w=m.getLineWords(_,p);for(const R of w){if(!isNaN(Number(R.word)))continue;let U=b[R.word];U||(U=[],b[R.word]=U),U.push({startLineNumber:_,startColumn:R.startColumn,endLineNumber:_,endColumn:R.endColumn})}}return b}async navigateValueSet(a,l,c,g,m){const p=this._getModel(a);if(!p)return null;const b=new RegExp(g,m);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const _=p.getValueInRange(l),w=p.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},b);if(!w)return null;const R=p.getValueInRange(w);return C.BasicInplaceReplace.INSTANCE.navigateValueSet(l,_,w,R,c)}loadForeignModule(a,l,c){const g=(b,_)=>this._host.fhr(b,_),p={host:(0,F.createProxyObject)(c,g),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(p,l),Promise.resolve((0,F.getAllMethodNames)(this._foreignModule))):new Promise((b,_)=>{B([a],w=>{this._foreignModule=w.create(p,l),b((0,F.getAllMethodNames)(this._foreignModule))},_)})}fmr(a,l){if(!this._foreignModule||typeof this._foreignModule[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._foreignModule[a].apply(this._foreignModule,l))}catch(c){return Promise.reject(c)}}}n.EditorSimpleWorker=L,L._diffLimit=1e5,L._suggestionsLimit=1e4;function i(s){return new L(s,null)}n.create=i,typeof importScripts=="function"&&(t.globals.monaco=(0,M.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
