"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var y=["require","exports","vs/base/common/ternarySearchTree","vs/platform/instantiation/common/instantiation","vs/platform/profiling/common/profiling","vs/base/common/path","vs/platform/profiling/common/profilingModel","vs/base/common/arrays","vs/base/common/strings","vs/platform/profiling/electron-sandbox/profileAnalysisWorker","vs/base/common/uri"],S=function(w){for(var l=[],_=0,v=w.length;_<v;_++)l[_]=y[w[_]];return l};define(y[2],S([0,1,7,8]),function(w,l,_,v){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.TernarySearchTree=l.UriIterator=l.PathIterator=l.ConfigKeysIterator=l.StringIterator=void 0;class N{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){const s=e.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}l.StringIterator=N;class p{constructor(e=!0){this._caseSensitive=e}reset(e){return this._value=e,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(e)this._from++;else break;else e=!1;return this}cmp(e){return this._caseSensitive?(0,v.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}l.ConfigKeysIterator=p;class m{constructor(e=!0,s=!0){this._splitOnBackslash=e,this._caseSensitive=s}reset(e){this._from=0,this._to=0,this._value=e,this._valueLen=e.length;for(let s=e.length-1;s>=0;s--,this._valueLen--){const i=this._value.charCodeAt(s);if(!(i===47||this._splitOnBackslash&&i===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let e=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(e)this._from++;else break;else e=!1}return this}cmp(e){return this._caseSensitive?(0,v.compareSubstring)(e,this._value,0,e.length,this._from,this._to):(0,v.compareSubstringIgnoreCase)(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}l.PathIterator=m;var h;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(h||(h={}));class u{constructor(e,s){this._ignorePathCasing=e,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(e)),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(e)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(this._states[this._stateIdx]===1)return(0,v.compareIgnoreCase)(e,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,v.compareIgnoreCase)(e,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(e);if(this._states[this._stateIdx]===4)return(0,v.compare)(e,this._value.query);if(this._states[this._stateIdx]===5)return(0,v.compare)(e,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}l.UriIterator=u;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(g||(g={}));class c{static forUris(e=()=>!1,s=()=>!1){return new c(new u(e,s))}static forPaths(e=!1){return new c(new m(void 0,!e))}static forStrings(){return new c(new N)}static forConfigKeys(){return new c(new p)}constructor(e){this._iter=e}clear(){this._root=void 0}fill(e,s){if(s){const i=s.slice(0);(0,_.shuffle)(i);for(const r of i)this.set(r,e)}else{const i=e.slice(0);(0,_.shuffle)(i);for(const r of i)this.set(r[0],r[1])}}set(e,s){const i=this._iter.reset(e);let r;this._root||(this._root=new f,this._root.segment=i.value());const t=[];for(r=this._root;;){const a=i.cmp(r.segment);if(a>0)r.left||(r.left=new f,r.left.segment=i.value()),t.push([-1,r]),r=r.left;else if(a<0)r.right||(r.right=new f,r.right.segment=i.value()),t.push([1,r]),r=r.right;else if(i.hasNext())i.next(),r.mid||(r.mid=new f,r.mid.segment=i.value()),t.push([0,r]),r=r.mid;else break}const n=r.value;r.value=s,r.key=e;for(let a=t.length-1;a>=0;a--){const d=t[a][1];d.updateHeight();const I=d.balanceFactor();if(I<-1||I>1){const b=t[a][0],T=t[a+1][0];if(b===1&&T===1)t[a][1]=d.rotateLeft();else if(b===-1&&T===-1)t[a][1]=d.rotateRight();else if(b===1&&T===-1)d.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=d.rotateLeft();else if(b===-1&&T===1)d.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=d.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this._root=t[0][1]}}return n}get(e){return this._getNode(e)?.value}_getNode(e){const s=this._iter.reset(e);let i=this._root;for(;i;){const r=s.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(e){const s=this._getNode(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this._delete(e,!1)}deleteSuperstr(e){return this._delete(e,!0)}_delete(e,s){const i=this._iter.reset(e),r=[];let t=this._root;for(;t;){const n=i.cmp(t.segment);if(n>0)r.push([-1,t]),t=t.left;else if(n<0)r.push([1,t]),t=t.right;else if(i.hasNext())i.next(),r.push([0,t]),t=t.mid;else break}if(!!t){if(s?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this._min(t.right);if(n.key){const{key:a,value:d,segment:I}=n;this._delete(n.key,!1),t.key=a,t.value=d,t.segment=I}}else{const n=t.left??t.right;if(r.length>0){const[a,d]=r[r.length-1];switch(a){case-1:d.left=n;break;case 0:d.mid=n;break;case 1:d.right=n;break}}else this._root=n}for(let n=r.length-1;n>=0;n--){const a=r[n][1];a.updateHeight();const d=a.balanceFactor();if(d>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),r[n][1]=a.rotateLeft()):d<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),r[n][1]=a.rotateRight()),n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this._root=r[0][1]}}}_min(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this._iter.reset(e);let i=this._root,r;for(;i;){const t=s.cmp(i.segment);if(t>0)i=i.left;else if(t<0)i=i.right;else if(s.hasNext())s.next(),r=i.value||r,i=i.mid;else break}return i&&i.value||r}findSuperstr(e){const s=this._iter.reset(e);let i=this._root;for(;i;){const r=s.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(e){for(const[s,i]of this)e(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(e){const s=[];return this._dfsEntries(e,s),s[Symbol.iterator]()}_dfsEntries(e,s){!e||(e.left&&this._dfsEntries(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this._dfsEntries(e.mid,s),e.right&&this._dfsEntries(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const i=s.balanceFactor();return i<-1||i>1?!1:e(s.left)&&e(s.right)};return e(this._root)}}l.TernarySearchTree=c}),define(y[3],S([0,1]),function(w,l){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.refineServiceDecorator=l.createDecorator=l.IInstantiationService=l._util=void 0;var _;(function(m){m.serviceIds=new Map,m.DI_TARGET="$di$target",m.DI_DEPENDENCIES="$di$dependencies";function h(u){return u[m.DI_DEPENDENCIES]||[]}m.getServiceDependencies=h})(_=l._util||(l._util={})),l.IInstantiationService=N("instantiationService");function v(m,h,u){h[_.DI_TARGET]===h?h[_.DI_DEPENDENCIES].push({id:m,index:u}):(h[_.DI_DEPENDENCIES]=[{id:m,index:u}],h[_.DI_TARGET]=h)}function N(m){if(_.serviceIds.has(m))return _.serviceIds.get(m);const h=function(u,f,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");v(h,u,g)};return h.toString=()=>m,_.serviceIds.set(m,h),h}l.createDecorator=N;function p(m){return m}l.refineServiceDecorator=p}),define(y[4],S([0,1,5,3]),function(w,l,_,v){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.Utils=l.IV8InspectProfilingService=void 0,l.IV8InspectProfilingService=(0,v.createDecorator)("IV8InspectProfilingService");var N;(function(p){function m(u){return Boolean(u.samples&&u.timeDeltas)}p.isValidProfile=m;function h(u,f="noAbsolutePaths"){for(const g of u.nodes)g.callFrame&&g.callFrame.url&&((0,_.isAbsolute)(g.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(g.callFrame.url))&&(g.callFrame.url=(0,_.join)(f,(0,_.basename)(g.callFrame.url)));return u}p.rewriteAbsolutePaths=h})(N=l.Utils||(l.Utils={}))}),define(y[6],S([0,1]),function(w,l){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.processNode=l.BottomUpNode=l.buildModel=void 0;const _=(h,u)=>{const f=u[h];if(f.aggregateTime)return f.aggregateTime;let g=f.selfTime;for(const c of f.children)g+=_(c,u);return f.aggregateTime=g},v=h=>{let u=0;const f=new Map,g=c=>{const o=[c.functionName,c.url,c.scriptId,c.lineNumber,c.columnNumber].join(":"),e=f.get(o);if(e)return e.id;const s=u++;return f.set(o,{id:s,callFrame:c,location:{lineNumber:c.lineNumber+1,columnNumber:c.columnNumber+1}}),s};for(const c of h.nodes)c.locationId=g(c.callFrame),c.positionTicks=c.positionTicks?.map(o=>({...o,startLocationId:g({...c.callFrame,lineNumber:o.line-1,columnNumber:0}),endLocationId:g({...c.callFrame,lineNumber:o.line,columnNumber:0})}));return[...f.values()].sort((c,o)=>c.id-o.id).map(c=>({locations:[c.location],callFrame:c.callFrame}))},N=h=>{if(!h.timeDeltas||!h.samples)return{nodes:[],locations:[],samples:h.samples||[],timeDeltas:h.timeDeltas||[],duration:h.endTime-h.startTime};const{samples:u,timeDeltas:f}=h,c=v(h).map((t,n)=>{const a=t.locations[0];return{id:n,selfTime:0,aggregateTime:0,ticks:0,callFrame:t.callFrame,src:a}}),o=new Map,e=t=>{let n=o.get(t);return n===void 0&&(n=o.size,o.set(t,n)),n},s=new Array(h.nodes.length);for(let t=0;t<h.nodes.length;t++){const n=h.nodes[t],a=e(n.id);s[a]={id:a,selfTime:0,aggregateTime:0,locationId:n.locationId,children:n.children?.map(e)||[]};for(const d of n.positionTicks||[])d.startLocationId&&(c[d.startLocationId].ticks+=d.ticks)}for(const t of s)for(const n of t.children)s[n].parent=t.id;const i=h.endTime-h.startTime;let r=i-f[0];for(let t=0;t<f.length-1;t++){const n=f[t+1];s[e(u[t])].selfTime+=n,r-=n}s.length&&(s[e(u[f.length-1])].selfTime+=r,f.push(r));for(let t=0;t<s.length;t++){const n=s[t],a=c[n.locationId];a.aggregateTime+=_(t,s),a.selfTime+=n.selfTime}return{nodes:s,locations:c,samples:u.map(e),timeDeltas:f,duration:i}};l.buildModel=N;class p{static root(){return new p({id:-1,selfTime:0,aggregateTime:0,ticks:0,callFrame:{functionName:"(root)",lineNumber:-1,columnNumber:-1,scriptId:"0",url:""}})}get id(){return this.location.id}get callFrame(){return this.location.callFrame}get src(){return this.location.src}constructor(u,f){this.location=u,this.parent=f,this.children={},this.aggregateTime=0,this.selfTime=0,this.ticks=0,this.childrenSize=0}addNode(u){this.selfTime+=u.selfTime,this.aggregateTime+=u.aggregateTime}}l.BottomUpNode=p;const m=(h,u,f,g=u)=>{let c=h.children[u.locationId];c||(c=new p(f.locations[u.locationId],h),h.childrenSize++,h.children[u.locationId]=c),c.addNode(g),u.parent&&(0,l.processNode)(c,f.nodes[u.parent],f,g)};l.processNode=m}),define(y[9],S([0,1,5,2,10,4,6]),function(w,l,_,v,N,p,m){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.create=void 0;function h(){return new u}l.create=h;class u{analyseBottomUp(e){if(!p.Utils.isValidProfile(e))return{kind:1,samples:[]};const s=(0,m.buildModel)(e),i=c(s,5,!1).filter(r=>!r.isSpecial);return i.length===0||i[1].percentage<10?{kind:1,samples:[]}:{kind:2,samples:i}}analyseByUrlCategory(e,s){const i=v.TernarySearchTree.forUris();i.fill(s);const r=(0,m.buildModel)(e),t=new Map;for(const a of r.nodes){const d=r.locations[a.locationId];let I;try{I=i.findSubstr(N.URI.parse(d.callFrame.url))}catch{}I||(I=g(d.callFrame,!1));const T=(t.get(I)??0)+a.selfTime;t.set(I,T)}const n=[];for(const[a,d]of t)n.push([a,d]);return n}}function f(o){return o.functionName.startsWith("(")&&o.functionName.endsWith(")")}function g(o,e){let s=o.functionName||"(anonymous)";return o.url&&(s+="#",s+=e?o.url:(0,_.basename)(o.url),o.lineNumber>=0&&(s+=":",s+=o.lineNumber+1)),s}function c(o,e,s=!1){const i=m.BottomUpNode.root();for(const n of o.nodes)(0,m.processNode)(i,n,o),i.addNode(n);const r=Object.values(i.children).sort((n,a)=>a.selfTime-n.selfTime).slice(0,e),t=[];for(const n of r){const a={selfTime:Math.round(n.selfTime/1e3),totalTime:Math.round(n.aggregateTime/1e3),location:g(n.callFrame,s),url:n.callFrame.url,caller:[],percentage:Math.round(n.selfTime/(o.duration/100)),isSpecial:f(n.callFrame)},d=[n];for(;d.length;){const I=d.pop();let b;for(const T of Object.values(I.children))(!b||b.selfTime<T.selfTime)&&(b=T);if(b){const T=Math.round(b.selfTime/(I.selfTime/100));a.caller.push({percentage:T,location:g(b.callFrame,!1)}),d.push(b)}}t.push(a)}return t}})}).call(this);

//# sourceMappingURL=profileAnalysisWorker.js.map
