"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/event","vs/base/common/errors","vs/base/common/network","vs/nls","vs/nls!vs/server/node/server.main","vs/platform/log/common/log","vs/base/common/types","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/uuid","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/process","os","vs/platform/environment/common/environment","fs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetry","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","vs/platform/uriIdentity/common/uriIdentity","vs/server/node/serverEnvironmentService","vs/base/common/codicons","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/performance","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/htmlContent","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/telemetry/common/commonProperties","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/node/loggerService","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","zlib","vs/server/node/server.main"],ye=function(oe){for(var e=[],y=0,t=oe.length;y<t;y++)e[y]=we[oe[y]];return e};define(we[136],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class y{static get(){const D=new Map,I=new Map,P=new Map,C=new Map;function E(w,d){w.has(d.detail)||w.set(d.detail,-d.timestamp)}function b(w,d){const g=w.get(d.detail);!g||g>=0||w.set(d.detail,g+d.timestamp)}const k=oe.getStats().slice(0).sort((w,d)=>w.timestamp-d.timestamp);for(const w of k)switch(w.type){case 10:E(D,w);break;case 11:case 12:b(D,w);break;case 21:E(I,w);break;case 22:b(I,w);break;case 33:E(P,w);break;case 34:b(P,w);break;case 31:E(C,w);break;case 32:b(C,w);break}let R=0;P.forEach(w=>R+=w);function S(w){const d=[];return w.forEach((g,v)=>d.push([v,g])),d}return{amdLoad:S(D),amdInvoke:S(I),nodeRequire:S(P),nodeEval:S(C),nodeRequireTotal:R}}static toMarkdownTable(D,I){let P="";const C=[];return D.forEach((E,b)=>{C[b]=E.length}),I.forEach(E=>{E.forEach((b,k)=>{typeof b>"u"&&(b=E[k]="-");const R=b.toString().length;C[k]=Math.max(R,C[k])})}),D.forEach((E,b)=>{P+=`| ${E+" ".repeat(C[b]-E.toString().length)} `}),P+=`|
`,D.forEach((E,b)=>{P+=`| ${"-".repeat(C[b])} `}),P+=`|
`,I.forEach(E=>{E.forEach((b,k)=>{typeof b<"u"&&(P+=`| ${b+" ".repeat(C[k]-b.toString().length)} `)}),P+=`|
`}),P}}e.LoaderStats=y}),define(we[41],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function y(P){return P?P.replace(/\$\((.*?)\)/g,(C,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=y;class t{constructor(C,E,b){this.id=C,this.definition=E,this.description=b,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(P,C){const E=["codicon","codicon-"+P];return C&&E.push("codicon-modifier-"+C),E}e.getClassNamesArray=D;var I;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function E(R){if(R instanceof t)return["codicon","codicon-"+R.id];const S=C.exec(R.id);if(!S)return E(t.error);const[,w,d]=S,g=["codicon","codicon-"+w];return d&&g.push("codicon-modifier-"+d.substr(1)),g}P.asClassNameArray=E;function b(R){return E(R).join(" ")}P.asClassName=b;function k(R){return"."+E(R).join(".")}P.asCSSSelector=k})(I=e.CSSIcon||(e.CSSIcon={}))}),define(we[85],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(P){return(C,E,b)=>{let k=null,R=null;if(typeof b.value=="function"?(k="value",R=b.value):typeof b.get=="function"&&(k="get",R=b.get),!R)throw new Error("not supported");b[k]=P(R,E)}}e.createDecorator=y;function t(P,C,E){let b=null,k=null;if(typeof E.value=="function"?(b="value",k=E.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",k=E.get),!k)throw new Error("not supported");const R=`$memoize$${C}`;E[b]=function(...S){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,S)}),this[R]}}e.memoize=t;function D(P,C,E){return y((b,k)=>{const R=`$debounce$${k}`,S=`$debounce$result$${k}`;return function(...w){this[S]||(this[S]=E?E():void 0),clearTimeout(this[R]),C&&(this[S]=C(this[S],...w),w=[this[S]]),this[R]=setTimeout(()=>{b.apply(this,w),this[S]=E?E():void 0},P)}})}e.debounce=D;function I(P,C,E){return y((b,k)=>{const R=`$throttle$timer$${k}`,S=`$throttle$result$${k}`,w=`$throttle$lastRun$${k}`,d=`$throttle$pending$${k}`;return function(...g){if(this[S]||(this[S]=E?E():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),C&&(this[S]=C(this[S],...g)),this[d])return;const v=this[w]+P;v<=Date.now()?(this[w]=Date.now(),b.apply(this,[this[S]]),this[S]=E?E():void 0):(this[d]=!0,this[R]=setTimeout(()=>{this[d]=!1,this[w]=Date.now(),b.apply(this,[this[S]]),this[S]=E?E():void 0},v-Date.now()))}})}e.throttle=I}),define(we[8],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?u.isErrorNoTelemetry(i)?new u(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(r=>{r(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=y,e.errorHandler=new y;function t(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=t;function D(h){E(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=D;function I(h){E(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=I;function P(h){if(h instanceof Error){const{name:i,message:r}=h,n=h.stacktrace||h.stack;return{$isError:!0,name:i,message:r,stack:n,noTelemetry:u.isErrorNoTelemetry(h)}}return h}e.transformErrorForSerialization=P;const C="Canceled";function E(h){return h instanceof b?!0:h instanceof Error&&h.name===C&&h.message===C}e.isCancellationError=E;class b extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=b;function k(){const h=new Error(C);return h.name=h.message,h}e.canceled=k;function R(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=R;function S(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=S;function w(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function d(h){const i=new Error(`${h} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function g(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=g;class v extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=v;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class u extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof u)return i;const r=new u;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class l extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(we[18],ye([1,0,8]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(z,Q=0){return z[z.length-(1+Q)]}e.tail=t;function D(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=D;function I(z,Q,J=(W,V)=>W===V){if(z===Q)return!0;if(!z||!Q||z.length!==Q.length)return!1;for(let W=0,V=z.length;W<V;W++)if(!J(z[W],Q[W]))return!1;return!0}e.equals=I;function P(z,Q){const J=z.length-1;Q<J&&(z[Q]=z[J]),z.pop()}e.removeFastWithoutKeepingOrder=P;function C(z,Q,J){return E(z.length,W=>J(z[W],Q))}e.binarySearch=C;function E(z,Q){let J=0,W=z-1;for(;J<=W;){const V=(J+W)/2|0,x=Q(V);if(x<0)J=V+1;else if(x>0)W=V-1;else return V}return-(J+1)}e.binarySearch2=E;function b(z,Q){let J=0,W=z.length;if(W===0)return 0;for(;J<W;){const V=Math.floor((J+W)/2);Q(z[V])?W=V:J=V+1}return J}e.findFirstInSorted=b;function k(z,Q,J){if(z=z|0,z>=Q.length)throw new TypeError("invalid index");const W=Q[Math.floor(Q.length*Math.random())],V=[],x=[],X=[];for(const ce of Q){const pe=J(ce,W);pe<0?V.push(ce):pe>0?x.push(ce):X.push(ce)}return z<V.length?k(z,V,J):z<V.length+X.length?X[0]:k(z-(V.length+X.length),x,J)}e.quickSelect=k;function R(z,Q){const J=[];let W;for(const V of z.slice(0).sort(Q))!W||Q(W[0],V)!==0?(W=[V],J.push(W)):W.push(V);return J}e.groupBy=R;function S(z,Q,J){const W=[];function V(ce,pe,ke){if(pe===0&&ke.length===0)return;const Te=W[W.length-1];Te&&Te.start+Te.deleteCount===ce?(Te.deleteCount+=pe,Te.toInsert.push(...ke)):W.push({start:ce,deleteCount:pe,toInsert:ke})}let x=0,X=0;for(;;){if(x===z.length){V(x,0,Q.slice(X));break}if(X===Q.length){V(x,z.length-x,[]);break}const ce=z[x],pe=Q[X],ke=J(ce,pe);ke===0?(x+=1,X+=1):ke<0?(V(x,1,[]),x+=1):ke>0&&(V(x,0,[pe]),X+=1)}return W}e.sortedDiff=S;function w(z,Q,J){const W=S(z,Q,J),V=[],x=[];for(const X of W)V.push(...z.slice(X.start,X.start+X.deleteCount)),x.push(...X.toInsert);return{removed:V,added:x}}e.delta=w;function d(z,Q,J){if(J===0)return[];const W=z.slice(0,J).sort(Q);return v(z,Q,W,J,z.length),W}e.top=d;function g(z,Q,J,W,V){return J===0?Promise.resolve([]):new Promise((x,X)=>{(async()=>{const ce=z.length,pe=z.slice(0,J).sort(Q);for(let ke=J,Te=Math.min(J+W,ce);ke<ce;ke=Te,Te=Math.min(Te+W,ce)){if(ke>J&&await new Promise(Ne=>setTimeout(Ne)),V&&V.isCancellationRequested)throw new y.CancellationError;v(z,Q,pe,ke,Te)}return pe})().then(x,X)})}e.topAsync=g;function v(z,Q,J,W,V){for(const x=J.length;W<V;W++){const X=z[W];if(Q(X,J[x-1])<0){J.pop();const ce=b(J,pe=>Q(X,pe)<0);J.splice(ce,0,X)}}}function m(z){return z.filter(Q=>!!Q)}e.coalesce=m;function p(z){let Q=0;for(let J=0;J<z.length;J++)z[J]&&(z[Q]=z[J],Q+=1);z.length=Q}e.coalesceInPlace=p;function u(z,Q,J){z.splice(J,0,z.splice(Q,1)[0])}e.move=u;function l(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=l;function h(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=h;function i(z,Q=J=>J){const J=new Set;return z.filter(W=>{const V=Q(W);return J.has(V)?!1:(J.add(V),!0)})}e.distinct=i;function r(z){const Q=new Set;return J=>{const W=z(J);return Q.has(W)?!1:(Q.add(W),!0)}}e.uniqueFilter=r;function n(z,Q){const J=s(z,Q);if(J!==-1)return z[J]}e.findLast=n;function s(z,Q){for(let J=z.length-1;J>=0;J--){const W=z[J];if(Q(W))return J}return-1}e.lastIndex=s;function a(z,Q){return z.length>0?z[0]:Q}e.firstOrDefault=a;function f(z,Q){return z.length>0?z[z.length-1]:Q}e.lastOrDefault=f;function o(z,Q,J=(W,V)=>W===V){let W=0;for(let V=0,x=Math.min(z.length,Q.length);V<x&&J(z[V],Q[V]);V++)W++;return W}e.commonPrefixLength=o;function c(z){return[].concat(...z)}e.flatten=c;function T(z,Q){let J=typeof Q=="number"?z:0;typeof Q=="number"?J=z:(J=0,Q=z);const W=[];if(J<=Q)for(let V=J;V<Q;V++)W.push(V);else for(let V=J;V>Q;V--)W.push(V);return W}e.range=T;function O(z,Q,J){return z.reduce((W,V)=>(W[Q(V)]=J?J(V):V,W),Object.create(null))}e.index=O;function K(z,Q){return z.push(Q),()=>re(z,Q)}e.insert=K;function re(z,Q){const J=z.indexOf(Q);if(J>-1)return z.splice(J,1),Q}e.remove=re;function le(z,Q,J){const W=z.slice(0,Q),V=z.slice(Q);return W.concat(J,V)}e.arrayInsert=le;function ae(z,Q){let J;if(typeof Q=="number"){let W=Q;J=()=>{const V=Math.sin(W++)*179426549;return V-Math.floor(V)}}else J=Math.random;for(let W=z.length-1;W>0;W-=1){const V=Math.floor(J()*(W+1)),x=z[W];z[W]=z[V],z[V]=x}}e.shuffle=ae;function F(z,Q){const J=z.indexOf(Q);J>-1&&(z.splice(J,1),z.unshift(Q))}e.pushToStart=F;function Y(z,Q){const J=z.indexOf(Q);J>-1&&(z.splice(J,1),z.push(Q))}e.pushToEnd=Y;function B(z,Q){for(const J of Q)z.push(J)}e.pushMany=B;function H(z,Q){return Array.isArray(z)?z.map(Q):Q(z)}e.mapArrayOrNot=H;function $(z){return Array.isArray(z)?z:[z]}e.asArray=$;function j(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=j;function L(z,Q){for(const J of z){const W=Q(J);if(W!==void 0)return W}}e.mapFind=L;function N(z,Q,J){const W=se(z,Q),V=z.length,x=J.length;z.length=V+x;for(let X=V-1;X>=W;X--)z[X+x]=z[X];for(let X=0;X<x;X++)z[X+W]=J[X]}e.insertInto=N;function q(z,Q,J,W){const V=se(z,Q),x=z.splice(V,J);return N(z,V,W),x}e.splice=q;function se(z,Q){return Q<0?Math.max(Q+z.length,0):Math.min(Q,z.length)}var he;(function(z){function Q(V){return V<0}z.isLessThan=Q;function J(V){return V>0}z.isGreaterThan=J;function W(V){return V===0}z.isNeitherLessOrGreaterThan=W,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(he=e.CompareResult||(e.CompareResult={}));function Z(z,Q){return(J,W)=>Q(z(J),z(W))}e.compareBy=Z;function ee(...z){return(Q,J)=>{for(const W of z){const V=W(Q,J);if(!he.isNeitherLessOrGreaterThan(V))return V}return he.neitherLessOrGreaterThan}}e.tieBreakComparators=ee;const _=(z,Q)=>z-Q;e.numberComparator=_;function U(z,Q){if(z.length===0)return;let J=z[0];for(let W=1;W<z.length;W++){const V=z[W];Q(V,J)>0&&(J=V)}return J}e.findMaxBy=U;function te(z,Q){if(z.length===0)return;let J=z[0];for(let W=1;W<z.length;W++){const V=z[W];Q(V,J)>=0&&(J=V)}return J}e.findLastMaxBy=te;function ie(z,Q){return U(z,(J,W)=>-Q(J,W))}e.findMinBy=ie;class fe{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let J=this.firstIdx;for(;J<this.items.length&&Q(this.items[J]);)J++;const W=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,W}takeFromEndWhile(Q){let J=this.lastIdx;for(;J>=0&&Q(this.items[J]);)J--;const W=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,W}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Q=this.items[this.firstIdx];return this.firstIdx++,Q}removeLast(){const Q=this.items[this.lastIdx];return this.lastIdx--,Q}takeCount(Q){const J=this.items.slice(this.firstIdx,this.firstIdx+Q);return this.firstIdx+=Q,J}}e.ArrayQueue=fe;class ve{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(J=>(Q(J),!0))}toArray(){const Q=[];return this.iterate(J=>(Q.push(J),!0)),Q}filter(Q){return new ve(J=>this.iterate(W=>Q(W)?J(W):!0))}map(Q){return new ve(J=>this.iterate(W=>J(Q(W))))}some(Q){let J=!1;return this.iterate(W=>(J=Q(W),!J)),J}findFirst(Q){let J;return this.iterate(W=>Q(W)?(J=W,!1):!0),J}findLast(Q){let J;return this.iterate(W=>(Q(W)&&(J=W),!0)),J}findLastMaxBy(Q){let J,W=!0;return this.iterate(V=>((W||he.isGreaterThan(Q(V,J)))&&(W=!1,J=V),!0)),J}}e.CallbackIterable=ve,ve.empty=new ve(z=>{})}),define(we[86],ye([1,0,8]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=t;function D(E,b="Unreachable"){throw new Error(b)}e.assertNever=D;function I(E){if(!E)throw new y.BugIndicatingError("Assertion Failed")}e.assert=I;function P(E){if(!E()){debugger;E(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}e.assertFn=P;function C(E,b){let k=0;for(;k<E.length-1;){const R=E[k],S=E[k+1];if(!b(R,S))return!1;k++}return!0}e.checkAdjacentItems=C}),define(we[66],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(t){const D=this;let I=!1,P;return function(){return I||(I=!0,P=t.apply(D,arguments)),P}}e.once=y}),define(we[55],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(t){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}t.is=D;const I=Object.freeze([]);function P(){return I}t.empty=P;function*C(l){yield l}t.single=C;function E(l){return D(l)?l:C(l)}t.wrap=E;function b(l){return l||I}t.from=b;function k(l){return!l||l[Symbol.iterator]().next().done===!0}t.isEmpty=k;function R(l){return l[Symbol.iterator]().next().value}t.first=R;function S(l,h){for(const i of l)if(h(i))return!0;return!1}t.some=S;function w(l,h){for(const i of l)if(h(i))return i}t.find=w;function*d(l,h){for(const i of l)h(i)&&(yield i)}t.filter=d;function*g(l,h){let i=0;for(const r of l)yield h(r,i++)}t.map=g;function*v(...l){for(const h of l)for(const i of h)yield i}t.concat=v;function m(l,h,i){let r=i;for(const n of l)r=h(r,n);return r}t.reduce=m;function*p(l,h,i=l.length){for(h<0&&(h+=l.length),i<0?i+=l.length:i>l.length&&(i=l.length);h<i;h++)yield l[h]}t.slice=p;function u(l,h=Number.POSITIVE_INFINITY){const i=[];if(h===0)return[i,l];const r=l[Symbol.iterator]();for(let n=0;n<h;n++){const s=r.next();if(s.done)return[i,t.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=u})(y=e.Iterable||(e.Iterable={}))}),define(we[67],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(i){i.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function P(i,r=!1){let n=0;const s=i.length;let a="",f=0,o=16,c=0;function T(Y){let B=0,H=0;for(;B<Y;){const $=i.charCodeAt(n);if($>=48&&$<=57)H=H*16+$-48;else if($>=65&&$<=70)H=H*16+$-65+10;else if($>=97&&$<=102)H=H*16+$-97+10;else break;n++,B++}return B<Y&&(H=-1),H}function O(Y){n=Y,a="",f=0,o=16,c=0}function K(){const Y=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&b(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&b(i.charCodeAt(n)))for(n++;n<i.length&&b(i.charCodeAt(n));)n++;else return c=3,i.substring(Y,n);let B=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&b(i.charCodeAt(n))){for(n++;n<i.length&&b(i.charCodeAt(n));)n++;B=n}else c=3;return i.substring(Y,B)}function re(){let Y="",B=n;for(;;){if(n>=s){Y+=i.substring(B,n),c=2;break}const H=i.charCodeAt(n);if(H===34){Y+=i.substring(B,n),n++;break}if(H===92){if(Y+=i.substring(B,n),n++,n>=s){c=2;break}switch(i.charCodeAt(n++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const j=T(4);j>=0?Y+=String.fromCharCode(j):c=4;break}default:c=5}B=n;continue}if(H>=0&&H<=31)if(E(H)){Y+=i.substring(B,n),c=2;break}else c=6;n++}return Y}function le(){if(a="",c=0,f=n,n>=s)return f=s,o=17;let Y=i.charCodeAt(n);if(C(Y)){do n++,a+=String.fromCharCode(Y),Y=i.charCodeAt(n);while(C(Y));return o=15}if(E(Y))return n++,a+=String.fromCharCode(Y),Y===13&&i.charCodeAt(n)===10&&(n++,a+=`
`),o=14;switch(Y){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,a=re(),o=10;case 47:{const B=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!E(i.charCodeAt(n));)n++;return a=i.substring(B,n),o=12}if(i.charCodeAt(n+1)===42){n+=2;const H=s-1;let $=!1;for(;n<H;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,$=!0;break}n++}return $||(n++,c=1),a=i.substring(B,n),o=13}return a+=String.fromCharCode(Y),n++,o=16}case 45:if(a+=String.fromCharCode(Y),n++,n===s||!b(i.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=K(),o=11;default:for(;n<s&&ae(Y);)n++,Y=i.charCodeAt(n);if(f!==n){switch(a=i.substring(f,n),a){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return a+=String.fromCharCode(Y),n++,o=16}}function ae(Y){if(C(Y)||E(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let Y;do Y=le();while(Y>=12&&Y<=15);return Y}return{setPosition:O,getPosition:()=>n,scan:r?F:le,getToken:()=>o,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>c}}e.createScanner=P;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var k;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(k||(k={}));function R(i,r){const n=[],s=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function c(T,O,K,re){f.value=T,f.offset=O,f.length=K,f.type=re,f.colonOffset=void 0,a=f}try{u(i,{onObjectBegin:(T,O)=>{if(r<=T)throw s;a=void 0,o=r>T,n.push("")},onObjectProperty:(T,O,K)=>{if(r<O||(c(T,O,K,"property"),n[n.length-1]=T,r<=O+K))throw s},onObjectEnd:(T,O)=>{if(r<=T)throw s;a=void 0,n.pop()},onArrayBegin:(T,O)=>{if(r<=T)throw s;a=void 0,n.push(0)},onArrayEnd:(T,O)=>{if(r<=T)throw s;a=void 0,n.pop()},onLiteralValue:(T,O,K)=>{if(r<O||(c(T,O,K,h(T)),r<=O+K))throw s},onSeparator:(T,O,K)=>{if(r<=O)throw s;if(T===":"&&a&&a.type==="property")a.colonOffset=O,o=!1,a=void 0;else if(T===","){const re=n[n.length-1];typeof re=="number"?n[n.length-1]=re+1:(o=!0,n[n.length-1]=""),a=void 0}}})}catch(T){if(T!==s)throw T}return{path:n,previousNode:a,isAtPropertyKey:o,matches:T=>{let O=0;for(let K=0;O<T.length&&K<n.length;K++)if(T[O]===n[K]||T[O]==="*")O++;else if(T[O]!=="**")return!1;return O===T.length}}}e.getLocation=R;function S(i,r=[],n=I.DEFAULT){let s=null,a=[];const f=[];function o(T){Array.isArray(a)?a.push(T):s!==null&&(a[s]=T)}return u(i,{onObjectBegin:()=>{const T={};o(T),f.push(a),a=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const T=[];o(T),f.push(a),a=T,s=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:o,onError:(T,O,K)=>{r.push({error:T,offset:O,length:K})}},n),a[0]}e.parse=S;function w(i,r=[],n=I.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(T){s.type==="property"&&(s.length=T-s.offset,s=s.parent)}function f(T){return s.children.push(T),T}u(i,{onObjectBegin:T=>{s=f({type:"object",offset:T,length:-1,parent:s,children:[]})},onObjectProperty:(T,O,K)=>{s=f({type:"property",offset:O,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:T,offset:O,length:K,parent:s})},onObjectEnd:(T,O)=>{s.length=T+O-s.offset,s=s.parent,a(T+O)},onArrayBegin:(T,O)=>{s=f({type:"array",offset:T,length:-1,parent:s,children:[]})},onArrayEnd:(T,O)=>{s.length=T+O-s.offset,s=s.parent,a(T+O)},onLiteralValue:(T,O,K)=>{f({type:h(T),offset:O,length:K,parent:s,value:T}),a(O+K)},onSeparator:(T,O,K)=>{s.type==="property"&&(T===":"?s.colonOffset=O:T===","&&a(O))},onError:(T,O,K)=>{r.push({error:T,offset:O,length:K})}},n);const c=s.children[0];return c&&delete c.parent,c}e.parseTree=w;function d(i,r){if(!i)return;let n=i;for(const s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===s){n=f.children[1],a=!0;break}if(!a)return}else{const a=s;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}e.findNodeAtLocation=d;function g(i){if(!i.parent||!i.parent.children)return[];const r=g(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;r.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&r.push(n)}return r}e.getNodePath=g;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const r=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(r[n.children[0].value]=v(s))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function m(i,r,n=!1){return r>=i.offset&&r<i.offset+i.length||n&&r===i.offset+i.length}e.contains=m;function p(i,r,n=!1){if(m(i,r,n)){const s=i.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=r;a++){const f=p(s[a],r,n);if(f)return f}return i}}e.findNodeAtOffset=p;function u(i,r,n=I.DEFAULT){const s=P(i,!1);function a(Z){return Z?()=>Z(s.getTokenOffset(),s.getTokenLength()):()=>!0}function f(Z){return Z?ee=>Z(ee,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=a(r.onObjectBegin),c=f(r.onObjectProperty),T=a(r.onObjectEnd),O=a(r.onArrayBegin),K=a(r.onArrayEnd),re=f(r.onLiteralValue),le=f(r.onSeparator),ae=a(r.onComment),F=f(r.onError),Y=n&&n.disallowComments,B=n&&n.allowTrailingComma;function H(){for(;;){const Z=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:Y||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(Z){case 12:case 13:Y?$(10):ae();break;case 16:$(1);break;case 15:case 14:break;default:return Z}}}function $(Z,ee=[],_=[]){if(F(Z),ee.length+_.length>0){let U=s.getToken();for(;U!==17;){if(ee.indexOf(U)!==-1){H();break}else if(_.indexOf(U)!==-1)break;U=H()}}}function j(Z){const ee=s.getTokenValue();return Z?re(ee):c(ee),H(),!0}function L(){switch(s.getToken()){case 11:{let Z=0;try{Z=JSON.parse(s.getTokenValue()),typeof Z!="number"&&($(2),Z=0)}catch{$(2)}re(Z);break}case 7:re(null);break;case 8:re(!0);break;case 9:re(!1);break;default:return!1}return H(),!0}function N(){return s.getToken()!==10?($(3,[],[2,5]),!1):(j(!1),s.getToken()===6?(le(":"),H(),he()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function q(){o(),H();let Z=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Z||$(4,[],[]),le(","),H(),s.getToken()===2&&B)break}else Z&&$(6,[],[]);N()||$(4,[],[2,5]),Z=!0}return T(),s.getToken()!==2?$(7,[2],[]):H(),!0}function se(){O(),H();let Z=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Z||$(4,[],[]),le(","),H(),s.getToken()===4&&B)break}else Z&&$(6,[],[]);he()||$(4,[],[4,5]),Z=!0}return K(),s.getToken()!==4?$(8,[4],[]):H(),!0}function he(){switch(s.getToken()){case 3:return se();case 1:return q();case 10:return j(!0);default:return L()}}return H(),s.getToken()===17?n.allowEmptyContent?!0:($(4,[],[]),!1):he()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=u;function l(i,r){const n=P(i),s=[];let a,f=0,o;do switch(o=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:f!==o&&s.push(i.substring(f,o)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),f=n.getPosition();break}while(a!==17);return s.join("")}e.stripComments=l;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(we[137],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class y{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new y(()=>D(this.getValue()))}}e.Lazy=y}),define(we[2],ye([1,0,66,55]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let I=null;function P(f){I=f}if(e.setDisposableTracker=P,D){const f="__is_disposable_tracked__";P(new class{trackDisposable(o){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[f]||console.log(c)},3e3)}setParent(o,c){if(o&&o!==p.None)try{o[f]=!0}catch{}}markAsDisposed(o){if(o&&o!==p.None)try{o[f]=!0}catch{}}markAsSingleton(o){}})}function C(f){return I?.trackDisposable(f),f}function E(f){I?.markAsDisposed(f)}function b(f,o){I?.setParent(f,o)}function k(f,o){if(!!I)for(const c of f)I.setParent(c,o)}function R(f){return I?.markAsSingleton(f),f}e.markAsSingleton=R;function S(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=S;function w(f){if(t.Iterable.is(f)){const o=[];for(const c of f)if(c)try{c.dispose()}catch(T){o.push(T)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.dispose=w;function d(f){for(const o of f)S(o)&&o.dispose();return[]}e.disposeIfDisposable=d;function g(...f){const o=v(()=>w(f));return k(f,o),o}e.combinedDisposable=g;function v(f){const o=C({dispose:(0,y.once)(()=>{E(o),f()})});return o}e.toDisposable=v;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{w(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return b(o,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new m,C(this),b(this._store,this)}dispose(){E(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&b(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&b(o,null),o}}e.MutableDisposable=u;class l{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(o){let c=o;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,E(this))},this}}e.SafeDisposable=h;class i{constructor(){this.references=new Map}acquire(o,...c){let T=this.references.get(o);T||(T={counter:0,object:this.createReferencedObject(o,...c)},this.references.set(o,T));const{object:O}=T,K=(0,y.once)(()=>{--T.counter===0&&(this.destroyReferencedObject(o,T.object),this.references.delete(o))});return T.counter++,{object:O,dispose:K}}}e.ReferenceCollection=i;class r{constructor(o){this.referenceCollection=o}async acquire(o,...c){const T=this.referenceCollection.acquire(o,...c);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(O){throw T.dispose(),O}}}e.AsyncReferenceCollection=r;class n{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=n;function s(f){const o=new m;try{f(o)}finally{o.dispose()}}e.disposeOnReturn=s;class a{constructor(){this._store=new Map,this._isDisposed=!1,C(this)}dispose(){E(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{w(this._store.values())}finally{this._store.clear()}}has(o){return this._store.has(o)}get(o){return this._store.get(o)}set(o,c,T=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this._store.get(o)?.dispose(),this._store.set(o,c)}deleteAndDispose(o){this._store.get(o)?.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=a}),define(we[87],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(I){this.element=I,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class t{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let I=this._first;for(;I!==y.Undefined;){const P=I.next;I.prev=y.Undefined,I.next=y.Undefined,I=P}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,P){const C=new y(I);if(this._first===y.Undefined)this._first=C,this._last=C;else if(P){const b=this._last;this._last=C,C.prev=b,b.next=C}else{const b=this._first;this._first=C,C.next=b,b.prev=C}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(C))}}shift(){if(this._first!==y.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==y.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==y.Undefined&&I.next!==y.Undefined){const P=I.prev;P.next=I.next,I.next.prev=P}else I.prev===y.Undefined&&I.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):I.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):I.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==y.Undefined;)yield I.element,I=I.next}}e.LinkedList=t}),define(we[31],ye([1,0]),function(oe,e){"use strict";var y,t,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function I(d,g,v){let m=d.get(g);return m===void 0&&(m=v,d.set(g,m)),m}e.getOrSet=I;function P(d){const g=[];return d.forEach((v,m)=>{g.push(`${m} => ${v}`)}),`Map(${d.size}) {${g.join(", ")}}`}e.mapToString=P;function C(d){const g=[];return d.forEach(v=>{g.push(v)}),`Set(${d.size}) {${g.join(", ")}}`}e.setToString=C;class E{constructor(g,v){this.uri=g,this.value=v}}class b{constructor(g,v){this[y]="ResourceMap",g instanceof b?(this.map=new Map(g.map),this.toKey=v??b.defaultToKey):(this.map=new Map,this.toKey=g??b.defaultToKey)}set(g,v){return this.map.set(this.toKey(g),new E(g,v)),this}get(g){return this.map.get(this.toKey(g))?.value}has(g){return this.map.has(this.toKey(g))}get size(){return this.map.size}clear(){this.map.clear()}delete(g){return this.map.delete(this.toKey(g))}forEach(g,v){typeof v<"u"&&(g=g.bind(v));for(const[m,p]of this.map)g(p.value,p.uri,this)}*values(){for(const g of this.map.values())yield g.value}*keys(){for(const g of this.map.values())yield g.uri}*entries(){for(const g of this.map.values())yield[g.uri,g.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.map)yield[g.uri,g.value]}}e.ResourceMap=b,b.defaultToKey=d=>d.toString();class k{constructor(g,v){this[t]="ResourceSet",!g||typeof g=="function"?this._map=new b(g):(this._map=new b(v),g.forEach(this.add,this))}get size(){return this._map.size}add(g){return this._map.set(g,g),this}clear(){this._map.clear()}delete(g){return this._map.delete(g)}forEach(g,v){this._map.forEach((m,p)=>g.call(v,p,p,this))}has(g){return this._map.has(g)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=k;var R;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(R=e.Touch||(e.Touch={}));class S{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(g){return this._map.has(g)}get(g,v=0){const m=this._map.get(g);if(!!m)return v!==0&&this.touch(m,v),m.value}set(g,v,m=0){let p=this._map.get(g);if(p)p.value=v,m!==0&&this.touch(p,m);else{switch(p={key:g,value:v,next:void 0,previous:void 0},m){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(g,p),this._size++}return this}delete(g){return!!this.remove(g)}remove(g){const v=this._map.get(g);if(!!v)return this._map.delete(g),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const g=this._head;return this._map.delete(g.key),this.removeItem(g),this._size--,g.value}forEach(g,v){const m=this._state;let p=this._head;for(;p;){if(v?g.bind(v)(p.value,p.key,this):g(p.value,p.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const g=this,v=this._state;let m=this._head;const p={[Symbol.iterator](){return p},next(){if(g._state!==v)throw new Error("LinkedMap got modified during iteration.");if(m){const u={value:m.key,done:!1};return m=m.next,u}else return{value:void 0,done:!0}}};return p}values(){const g=this,v=this._state;let m=this._head;const p={[Symbol.iterator](){return p},next(){if(g._state!==v)throw new Error("LinkedMap got modified during iteration.");if(m){const u={value:m.value,done:!1};return m=m.next,u}else return{value:void 0,done:!0}}};return p}entries(){const g=this,v=this._state;let m=this._head;const p={[Symbol.iterator](){return p},next(){if(g._state!==v)throw new Error("LinkedMap got modified during iteration.");if(m){const u={value:[m.key,m.value],done:!1};return m=m.next,u}else return{value:void 0,done:!0}}};return p}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(g){if(g>=this.size)return;if(g===0){this.clear();return}let v=this._head,m=this.size;for(;v&&m>g;)this._map.delete(v.key),v=v.next,m--;this._head=v,this._size=m,v&&(v.previous=void 0),this._state++}addItemFirst(g){if(!this._head&&!this._tail)this._tail=g;else if(this._head)g.next=this._head,this._head.previous=g;else throw new Error("Invalid list");this._head=g,this._state++}addItemLast(g){if(!this._head&&!this._tail)this._head=g;else if(this._tail)g.previous=this._tail,this._tail.next=g;else throw new Error("Invalid list");this._tail=g,this._state++}removeItem(g){if(g===this._head&&g===this._tail)this._head=void 0,this._tail=void 0;else if(g===this._head){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this._head=g.next}else if(g===this._tail){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this._tail=g.previous}else{const v=g.next,m=g.previous;if(!v||!m)throw new Error("Invalid list");v.previous=m,m.next=v}g.next=void 0,g.previous=void 0,this._state++}touch(g,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(g===this._head)return;const m=g.next,p=g.previous;g===this._tail?(p.next=void 0,this._tail=p):(m.previous=p,p.next=m),g.previous=void 0,g.next=this._head,this._head.previous=g,this._head=g,this._state++}else if(v===2){if(g===this._tail)return;const m=g.next,p=g.previous;g===this._head?(m.previous=void 0,this._head=m):(m.previous=p,p.next=m),g.next=void 0,g.previous=this._tail,this._tail.next=g,this._tail=g,this._state++}}}toJSON(){const g=[];return this.forEach((v,m)=>{g.push([m,v])}),g}fromJSON(g){this.clear();for(const[v,m]of g)this.set(v,m)}}e.LinkedMap=S;class w extends S{constructor(g,v=1){super(),this._limit=g,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(g){this._limit=g,this.checkTrim()}get ratio(){return this._ratio}set ratio(g){this._ratio=Math.min(Math.max(0,g),1),this.checkTrim()}get(g,v=2){return super.get(g,v)}peek(g){return super.get(g,0)}set(g,v){return super.set(g,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=w}),function(oe,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(we[138],ye([0]),e):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(z,Q){for(var J=0;J<Q.length;J++){var W=Q[J];W.enumerable=W.enumerable||!1,W.configurable=!0,"value"in W&&(W.writable=!0),Object.defineProperty(z,W.key,W)}}function y(z,Q,J){return Q&&e(z.prototype,Q),J&&e(z,J),Object.defineProperty(z,"prototype",{writable:!1}),z}function t(z,Q){if(!!z){if(typeof z=="string")return D(z,Q);var J=Object.prototype.toString.call(z).slice(8,-1);if(J==="Object"&&z.constructor&&(J=z.constructor.name),J==="Map"||J==="Set")return Array.from(z);if(J==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(J))return D(z,Q)}}function D(z,Q){(Q==null||Q>z.length)&&(Q=z.length);for(var J=0,W=new Array(Q);J<Q;J++)W[J]=z[J];return W}function I(z,Q){var J=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(J)return(J=J.call(z)).next.bind(J);if(Array.isArray(z)||(J=t(z))||Q&&z&&typeof z.length=="number"){J&&(z=J);var W=0;return function(){return W>=z.length?{done:!0}:{done:!1,value:z[W++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=P();function C(z){oe.defaults=z}var E=/[&<>"']/,b=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(Q){return S[Q]};function d(z,Q){if(Q){if(E.test(z))return z.replace(b,w)}else if(k.test(z))return z.replace(R,w);return z}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(z){return z.replace(g,function(Q,J){return J=J.toLowerCase(),J==="colon"?":":J.charAt(0)==="#"?J.charAt(1)==="x"?String.fromCharCode(parseInt(J.substring(2),16)):String.fromCharCode(+J.substring(1)):""})}var m=/(^|[^\[])\^/g;function p(z,Q){z=typeof z=="string"?z:z.source,Q=Q||"";var J={replace:function(V,x){return x=x.source||x,x=x.replace(m,"$1"),z=z.replace(V,x),J},getRegex:function(){return new RegExp(z,Q)}};return J}var u=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(z,Q,J){if(z){var W;try{W=decodeURIComponent(v(J)).replace(u,"").toLowerCase()}catch{return null}if(W.indexOf("javascript:")===0||W.indexOf("vbscript:")===0||W.indexOf("data:")===0)return null}Q&&!l.test(J)&&(J=a(Q,J));try{J=encodeURI(J).replace(/%25/g,"%")}catch{return null}return J}var i={},r=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(z,Q){i[" "+z]||(r.test(z)?i[" "+z]=z+"/":i[" "+z]=T(z,"/",!0)),z=i[" "+z];var J=z.indexOf(":")===-1;return Q.substring(0,2)==="//"?J?Q:z.replace(n,"$1")+Q:Q.charAt(0)==="/"?J?Q:z.replace(s,"$1")+Q:z+Q}var f={exec:function(){}};function o(z){for(var Q=1,J,W;Q<arguments.length;Q++){J=arguments[Q];for(W in J)Object.prototype.hasOwnProperty.call(J,W)&&(z[W]=J[W])}return z}function c(z,Q){var J=z.replace(/\|/g,function(x,X,ce){for(var pe=!1,ke=X;--ke>=0&&ce[ke]==="\\";)pe=!pe;return pe?"|":" |"}),W=J.split(/ \|/),V=0;if(W[0].trim()||W.shift(),W.length>0&&!W[W.length-1].trim()&&W.pop(),W.length>Q)W.splice(Q);else for(;W.length<Q;)W.push("");for(;V<W.length;V++)W[V]=W[V].trim().replace(/\\\|/g,"|");return W}function T(z,Q,J){var W=z.length;if(W===0)return"";for(var V=0;V<W;){var x=z.charAt(W-V-1);if(x===Q&&!J)V++;else if(x!==Q&&J)V++;else break}return z.slice(0,W-V)}function O(z,Q){if(z.indexOf(Q[1])===-1)return-1;for(var J=z.length,W=0,V=0;V<J;V++)if(z[V]==="\\")V++;else if(z[V]===Q[0])W++;else if(z[V]===Q[1]&&(W--,W<0))return V;return-1}function K(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function re(z,Q){if(Q<1)return"";for(var J="";Q>1;)Q&1&&(J+=z),Q>>=1,z+=z;return J+z}function le(z,Q,J,W){var V=Q.href,x=Q.title?d(Q.title):null,X=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){W.state.inLink=!0;var ce={type:"link",raw:J,href:V,title:x,text:X,tokens:W.inlineTokens(X)};return W.state.inLink=!1,ce}return{type:"image",raw:J,href:V,title:x,text:d(X)}}function ae(z,Q){var J=z.match(/^(\s+)(?:```)/);if(J===null)return Q;var W=J[1];return Q.split(`
`).map(function(V){var x=V.match(/^\s+/);if(x===null)return V;var X=x[0];return X.length>=W.length?V.slice(W.length):V}).join(`
`)}var F=function(){function z(J){this.options=J||oe.defaults}var Q=z.prototype;return Q.space=function(W){var V=this.rules.block.newline.exec(W);if(V&&V[0].length>0)return{type:"space",raw:V[0]}},Q.code=function(W){var V=this.rules.block.code.exec(W);if(V){var x=V[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:V[0],codeBlockStyle:"indented",text:this.options.pedantic?x:T(x,`
`)}}},Q.fences=function(W){var V=this.rules.block.fences.exec(W);if(V){var x=V[0],X=ae(x,V[3]||"");return{type:"code",raw:x,lang:V[2]?V[2].trim():V[2],text:X}}},Q.heading=function(W){var V=this.rules.block.heading.exec(W);if(V){var x=V[2].trim();if(/#$/.test(x)){var X=T(x,"#");(this.options.pedantic||!X||/ $/.test(X))&&(x=X.trim())}return{type:"heading",raw:V[0],depth:V[1].length,text:x,tokens:this.lexer.inline(x)}}},Q.hr=function(W){var V=this.rules.block.hr.exec(W);if(V)return{type:"hr",raw:V[0]}},Q.blockquote=function(W){var V=this.rules.block.blockquote.exec(W);if(V){var x=V[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:V[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},Q.list=function(W){var V=this.rules.block.list.exec(W);if(V){var x,X,ce,pe,ke,Te,Ne,Oe,me,be,Ee,Me,Be=V[1].trim(),Ge=Be.length>1,ze={type:"list",raw:"",ordered:Ge,start:Ge?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ge?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ge?Be:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");W&&(Me=!1,!(!(V=Ke.exec(W))||this.rules.block.hr.test(W)));){if(x=V[0],W=W.substring(x.length),Oe=V[2].split(`
`,1)[0],me=W.split(`
`,1)[0],this.options.pedantic?(pe=2,Ee=Oe.trimLeft()):(pe=V[2].search(/[^ ]/),pe=pe>4?1:pe,Ee=Oe.slice(pe),pe+=V[1].length),Te=!1,!Oe&&/^ *$/.test(me)&&(x+=me+`
`,W=W.substring(me.length+1),Me=!0),!Me)for(var xe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ze=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Qe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),He=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");W&&(be=W.split(`
`,1)[0],Oe=be,this.options.pedantic&&(Oe=Oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Qe.test(Oe)||He.test(Oe)||xe.test(Oe)||Ze.test(W)));){if(Oe.search(/[^ ]/)>=pe||!Oe.trim())Ee+=`
`+Oe.slice(pe);else if(!Te)Ee+=`
`+Oe;else break;!Te&&!Oe.trim()&&(Te=!0),x+=be+`
`,W=W.substring(be.length+1)}ze.loose||(Ne?ze.loose=!0:/\n *\n *$/.test(x)&&(Ne=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(Ee),X&&(ce=X[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:x,task:!!X,checked:ce,loose:!1,text:Ee}),ze.raw+=x}ze.items[ze.items.length-1].raw=x.trimRight(),ze.items[ze.items.length-1].text=Ee.trimRight(),ze.raw=ze.raw.trimRight();var je=ze.items.length;for(ke=0;ke<je;ke++){this.lexer.state.top=!1,ze.items[ke].tokens=this.lexer.blockTokens(ze.items[ke].text,[]);var ue=ze.items[ke].tokens.filter(function(Ce){return Ce.type==="space"}),De=ue.every(function(Ce){for(var Re=Ce.raw.split(""),Fe=0,$e=I(Re),qe;!(qe=$e()).done;){var nt=qe.value;if(nt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!ze.loose&&ue.length&&De&&(ze.loose=!0,ze.items[ke].loose=!0)}return ze}},Q.html=function(W){var V=this.rules.block.html.exec(W);if(V){var x={type:"html",raw:V[0],pre:!this.options.sanitizer&&(V[1]==="pre"||V[1]==="script"||V[1]==="style"),text:V[0]};if(this.options.sanitize){var X=this.options.sanitizer?this.options.sanitizer(V[0]):d(V[0]);x.type="paragraph",x.text=X,x.tokens=this.lexer.inline(X)}return x}},Q.def=function(W){var V=this.rules.block.def.exec(W);if(V){V[3]&&(V[3]=V[3].substring(1,V[3].length-1));var x=V[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:V[0],href:V[2],title:V[3]}}},Q.table=function(W){var V=this.rules.block.table.exec(W);if(V){var x={type:"table",header:c(V[1]).map(function(Ne){return{text:Ne}}),align:V[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:V[3]&&V[3].trim()?V[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=V[0];var X=x.align.length,ce,pe,ke,Te;for(ce=0;ce<X;ce++)/^ *-+: *$/.test(x.align[ce])?x.align[ce]="right":/^ *:-+: *$/.test(x.align[ce])?x.align[ce]="center":/^ *:-+ *$/.test(x.align[ce])?x.align[ce]="left":x.align[ce]=null;for(X=x.rows.length,ce=0;ce<X;ce++)x.rows[ce]=c(x.rows[ce],x.header.length).map(function(Ne){return{text:Ne}});for(X=x.header.length,pe=0;pe<X;pe++)x.header[pe].tokens=this.lexer.inline(x.header[pe].text);for(X=x.rows.length,pe=0;pe<X;pe++)for(Te=x.rows[pe],ke=0;ke<Te.length;ke++)Te[ke].tokens=this.lexer.inline(Te[ke].text);return x}}},Q.lheading=function(W){var V=this.rules.block.lheading.exec(W);if(V)return{type:"heading",raw:V[0],depth:V[2].charAt(0)==="="?1:2,text:V[1],tokens:this.lexer.inline(V[1])}},Q.paragraph=function(W){var V=this.rules.block.paragraph.exec(W);if(V){var x=V[1].charAt(V[1].length-1)===`
`?V[1].slice(0,-1):V[1];return{type:"paragraph",raw:V[0],text:x,tokens:this.lexer.inline(x)}}},Q.text=function(W){var V=this.rules.block.text.exec(W);if(V)return{type:"text",raw:V[0],text:V[0],tokens:this.lexer.inline(V[0])}},Q.escape=function(W){var V=this.rules.inline.escape.exec(W);if(V)return{type:"escape",raw:V[0],text:d(V[1])}},Q.tag=function(W){var V=this.rules.inline.tag.exec(W);if(V)return!this.lexer.state.inLink&&/^<a /i.test(V[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(V[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(V[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(V[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:V[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(V[0]):d(V[0]):V[0]}},Q.link=function(W){var V=this.rules.inline.link.exec(W);if(V){var x=V[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var X=T(x.slice(0,-1),"\\");if((x.length-X.length)%2===0)return}else{var ce=O(V[2],"()");if(ce>-1){var pe=V[0].indexOf("!")===0?5:4,ke=pe+V[1].length+ce;V[2]=V[2].substring(0,ce),V[0]=V[0].substring(0,ke).trim(),V[3]=""}}var Te=V[2],Ne="";if(this.options.pedantic){var Oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Oe&&(Te=Oe[1],Ne=Oe[3])}else Ne=V[3]?V[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(x)?Te=Te.slice(1):Te=Te.slice(1,-1)),le(V,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},V[0],this.lexer)}},Q.reflink=function(W,V){var x;if((x=this.rules.inline.reflink.exec(W))||(x=this.rules.inline.nolink.exec(W))){var X=(x[2]||x[1]).replace(/\s+/g," ");if(X=V[X.toLowerCase()],!X||!X.href){var ce=x[0].charAt(0);return{type:"text",raw:ce,text:ce}}return le(x,X,x[0],this.lexer)}},Q.emStrong=function(W,V,x){x===void 0&&(x="");var X=this.rules.inline.emStrong.lDelim.exec(W);if(!!X&&!(X[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=X[1]||X[2]||"";if(!ce||ce&&(x===""||this.rules.inline.punctuation.exec(x))){var pe=X[0].length-1,ke,Te,Ne=pe,Oe=0,me=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,V=V.slice(-1*W.length+pe);(X=me.exec(V))!=null;)if(ke=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!ke){if(Te=ke.length,X[3]||X[4]){Ne+=Te;continue}else if((X[5]||X[6])&&pe%3&&!((pe+Te)%3)){Oe+=Te;continue}if(Ne-=Te,!(Ne>0)){if(Te=Math.min(Te,Te+Ne+Oe),Math.min(pe,Te)%2){var be=W.slice(1,pe+X.index+Te);return{type:"em",raw:W.slice(0,pe+X.index+Te+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=W.slice(2,pe+X.index+Te-1);return{type:"strong",raw:W.slice(0,pe+X.index+Te+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Q.codespan=function(W){var V=this.rules.inline.code.exec(W);if(V){var x=V[2].replace(/\n/g," "),X=/[^ ]/.test(x),ce=/^ /.test(x)&&/ $/.test(x);return X&&ce&&(x=x.substring(1,x.length-1)),x=d(x,!0),{type:"codespan",raw:V[0],text:x}}},Q.br=function(W){var V=this.rules.inline.br.exec(W);if(V)return{type:"br",raw:V[0]}},Q.del=function(W){var V=this.rules.inline.del.exec(W);if(V)return{type:"del",raw:V[0],text:V[2],tokens:this.lexer.inlineTokens(V[2])}},Q.autolink=function(W,V){var x=this.rules.inline.autolink.exec(W);if(x){var X,ce;return x[2]==="@"?(X=d(this.options.mangle?V(x[1]):x[1]),ce="mailto:"+X):(X=d(x[1]),ce=X),{type:"link",raw:x[0],text:X,href:ce,tokens:[{type:"text",raw:X,text:X}]}}},Q.url=function(W,V){var x;if(x=this.rules.inline.url.exec(W)){var X,ce;if(x[2]==="@")X=d(this.options.mangle?V(x[0]):x[0]),ce="mailto:"+X;else{var pe;do pe=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(pe!==x[0]);X=d(x[0]),x[1]==="www."?ce="http://"+X:ce=X}return{type:"link",raw:x[0],text:X,href:ce,tokens:[{type:"text",raw:X,text:X}]}}},Q.inlineText=function(W,V){var x=this.rules.inline.text.exec(W);if(x){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]:X=d(this.options.smartypants?V(x[0]):x[0]),{type:"text",raw:x[0],text:X}}},z}(),Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=p(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.listItemStart=p(/^( *)(bull) */).replace("bull",Y.bullet).getRegex(),Y.list=p(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=p(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=p(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=p(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=o({},Y),Y.gfm=o({},Y.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.table=p(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.gfm.paragraph=p(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Y.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=o({},Y.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:p(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=p(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=p(Y._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=p(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=p(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=p(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=p(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=p(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=p(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=p(B.reflink).replace("label",B._label).replace("ref",Y._label).getRegex(),B.nolink=p(B.nolink).replace("ref",Y._label).getRegex(),B.reflinkSearch=p(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=o({},B),B.pedantic=o({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=o({},B.normal,{escape:p(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=p(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=o({},B.gfm,{br:p(B.br).replace("{2,}","*").getRegex(),text:p(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function H(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(z){var Q="",J,W,V=z.length;for(J=0;J<V;J++)W=z.charCodeAt(J),Math.random()>.5&&(W="x"+W.toString(16)),Q+="&#"+W+";";return Q}var j=function(){function z(J){this.tokens=[],this.tokens.links=Object.create(null),this.options=J||oe.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var W={block:Y.normal,inline:B.normal};this.options.pedantic?(W.block=Y.pedantic,W.inline=B.pedantic):this.options.gfm&&(W.block=Y.gfm,this.options.breaks?W.inline=B.breaks:W.inline=B.gfm),this.tokenizer.rules=W}z.lex=function(W,V){var x=new z(V);return x.lex(W)},z.lexInline=function(W,V){var x=new z(V);return x.inlineTokens(W)};var Q=z.prototype;return Q.lex=function(W){W=W.replace(/\r\n|\r/g,`
`),this.blockTokens(W,this.tokens);for(var V;V=this.inlineQueue.shift();)this.inlineTokens(V.src,V.tokens);return this.tokens},Q.blockTokens=function(W,V){var x=this;V===void 0&&(V=[]),this.options.pedantic?W=W.replace(/\t/g,"    ").replace(/^ +$/gm,""):W=W.replace(/^( *)(\t+)/gm,function(Ne,Oe,me){return Oe+"    ".repeat(me.length)});for(var X,ce,pe,ke;W;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(X=Ne.call({lexer:x},W,V))?(W=W.substring(X.raw.length),V.push(X),!0):!1}))){if(X=this.tokenizer.space(W)){W=W.substring(X.raw.length),X.raw.length===1&&V.length>0?V[V.length-1].raw+=`
`:V.push(X);continue}if(X=this.tokenizer.code(W)){W=W.substring(X.raw.length),ce=V[V.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):V.push(X);continue}if(X=this.tokenizer.fences(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.heading(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.hr(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.blockquote(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.list(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.html(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.def(W)){W=W.substring(X.raw.length),ce=V[V.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.lheading(W)){W=W.substring(X.raw.length),V.push(X);continue}if(pe=W,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,Oe=W.slice(1),me=void 0;x.options.extensions.startBlock.forEach(function(be){me=be.call({lexer:this},Oe),typeof me=="number"&&me>=0&&(Ne=Math.min(Ne,me))}),Ne<1/0&&Ne>=0&&(pe=W.substring(0,Ne+1))}(),this.state.top&&(X=this.tokenizer.paragraph(pe))){ce=V[V.length-1],ke&&ce.type==="paragraph"?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):V.push(X),ke=pe.length!==W.length,W=W.substring(X.raw.length);continue}if(X=this.tokenizer.text(W)){W=W.substring(X.raw.length),ce=V[V.length-1],ce&&ce.type==="text"?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):V.push(X);continue}if(W){var Te="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,V},Q.inline=function(W,V){return V===void 0&&(V=[]),this.inlineQueue.push({src:W,tokens:V}),V},Q.inlineTokens=function(W,V){var x=this;V===void 0&&(V=[]);var X,ce,pe,ke=W,Te,Ne,Oe;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)me.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Te.index)+"["+re("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"["+re("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;W;)if(Ne||(Oe=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(X=Ee.call({lexer:x},W,V))?(W=W.substring(X.raw.length),V.push(X),!0):!1}))){if(X=this.tokenizer.escape(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.tag(W)){W=W.substring(X.raw.length),ce=V[V.length-1],ce&&X.type==="text"&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):V.push(X);continue}if(X=this.tokenizer.link(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.reflink(W,this.tokens.links)){W=W.substring(X.raw.length),ce=V[V.length-1],ce&&X.type==="text"&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):V.push(X);continue}if(X=this.tokenizer.emStrong(W,ke,Oe)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.codespan(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.br(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.del(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.autolink(W,$)){W=W.substring(X.raw.length),V.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(W,$))){W=W.substring(X.raw.length),V.push(X);continue}if(pe=W,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,Me=W.slice(1),Be=void 0;x.options.extensions.startInline.forEach(function(Ge){Be=Ge.call({lexer:this},Me),typeof Be=="number"&&Be>=0&&(Ee=Math.min(Ee,Be))}),Ee<1/0&&Ee>=0&&(pe=W.substring(0,Ee+1))}(),X=this.tokenizer.inlineText(pe,H)){W=W.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(Oe=X.raw.slice(-1)),Ne=!0,ce=V[V.length-1],ce&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):V.push(X);continue}if(W){var be="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return V},y(z,null,[{key:"rules",get:function(){return{block:Y,inline:B}}}]),z}(),L=function(){function z(J){this.options=J||oe.defaults}var Q=z.prototype;return Q.code=function(W,V,x){var X=(V||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(W,X);ce!=null&&ce!==W&&(x=!0,W=ce)}return W=W.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+d(X,!0)+'">'+(x?W:d(W,!0))+`</code></pre>
`:"<pre><code>"+(x?W:d(W,!0))+`</code></pre>
`},Q.blockquote=function(W){return`<blockquote>
`+W+`</blockquote>
`},Q.html=function(W){return W},Q.heading=function(W,V,x,X){if(this.options.headerIds){var ce=this.options.headerPrefix+X.slug(x);return"<h"+V+' id="'+ce+'">'+W+"</h"+V+`>
`}return"<h"+V+">"+W+"</h"+V+`>
`},Q.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Q.list=function(W,V,x){var X=V?"ol":"ul",ce=V&&x!==1?' start="'+x+'"':"";return"<"+X+ce+`>
`+W+"</"+X+`>
`},Q.listitem=function(W){return"<li>"+W+`</li>
`},Q.checkbox=function(W){return"<input "+(W?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Q.paragraph=function(W){return"<p>"+W+`</p>
`},Q.table=function(W,V){return V&&(V="<tbody>"+V+"</tbody>"),`<table>
<thead>
`+W+`</thead>
`+V+`</table>
`},Q.tablerow=function(W){return`<tr>
`+W+`</tr>
`},Q.tablecell=function(W,V){var x=V.header?"th":"td",X=V.align?"<"+x+' align="'+V.align+'">':"<"+x+">";return X+W+("</"+x+`>
`)},Q.strong=function(W){return"<strong>"+W+"</strong>"},Q.em=function(W){return"<em>"+W+"</em>"},Q.codespan=function(W){return"<code>"+W+"</code>"},Q.br=function(){return this.options.xhtml?"<br/>":"<br>"},Q.del=function(W){return"<del>"+W+"</del>"},Q.link=function(W,V,x){if(W=h(this.options.sanitize,this.options.baseUrl,W),W===null)return x;var X='<a href="'+d(W)+'"';return V&&(X+=' title="'+V+'"'),X+=">"+x+"</a>",X},Q.image=function(W,V,x){if(W=h(this.options.sanitize,this.options.baseUrl,W),W===null)return x;var X='<img src="'+W+'" alt="'+x+'"';return V&&(X+=' title="'+V+'"'),X+=this.options.xhtml?"/>":">",X},Q.text=function(W){return W},z}(),N=function(){function z(){}var Q=z.prototype;return Q.strong=function(W){return W},Q.em=function(W){return W},Q.codespan=function(W){return W},Q.del=function(W){return W},Q.html=function(W){return W},Q.text=function(W){return W},Q.link=function(W,V,x){return""+x},Q.image=function(W,V,x){return""+x},Q.br=function(){return""},z}(),q=function(){function z(){this.seen={}}var Q=z.prototype;return Q.serialize=function(W){return W.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Q.getNextSafeSlug=function(W,V){var x=W,X=0;if(this.seen.hasOwnProperty(x)){X=this.seen[W];do X++,x=W+"-"+X;while(this.seen.hasOwnProperty(x))}return V||(this.seen[W]=X,this.seen[x]=0),x},Q.slug=function(W,V){V===void 0&&(V={});var x=this.serialize(W);return this.getNextSafeSlug(x,V.dryrun)},z}(),se=function(){function z(J){this.options=J||oe.defaults,this.options.renderer=this.options.renderer||new L,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new N,this.slugger=new q}z.parse=function(W,V){var x=new z(V);return x.parse(W)},z.parseInline=function(W,V){var x=new z(V);return x.parseInline(W)};var Q=z.prototype;return Q.parse=function(W,V){V===void 0&&(V=!0);var x="",X,ce,pe,ke,Te,Ne,Oe,me,be,Ee,Me,Be,Ge,ze,Ke,xe,Ze,Qe,He,je=W.length;for(X=0;X<je;X++){if(Ee=W[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(He=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),He!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){x+=He||"";continue}switch(Ee.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,v(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(me="",Oe="",ke=Ee.header.length,ce=0;ce<ke;ce++)Oe+=this.renderer.tablecell(this.parseInline(Ee.header[ce].tokens),{header:!0,align:Ee.align[ce]});for(me+=this.renderer.tablerow(Oe),be="",ke=Ee.rows.length,ce=0;ce<ke;ce++){for(Ne=Ee.rows[ce],Oe="",Te=Ne.length,pe=0;pe<Te;pe++)Oe+=this.renderer.tablecell(this.parseInline(Ne[pe].tokens),{header:!1,align:Ee.align[pe]});be+=this.renderer.tablerow(Oe)}x+=this.renderer.table(me,be);continue}case"blockquote":{be=this.parse(Ee.tokens),x+=this.renderer.blockquote(be);continue}case"list":{for(Me=Ee.ordered,Be=Ee.start,Ge=Ee.loose,ke=Ee.items.length,be="",ce=0;ce<ke;ce++)Ke=Ee.items[ce],xe=Ke.checked,Ze=Ke.task,ze="",Ke.task&&(Qe=this.renderer.checkbox(xe),Ge?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=Qe+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=Qe+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:Qe}):ze+=Qe),ze+=this.parse(Ke.tokens,Ge),be+=this.renderer.listitem(ze,Ze,xe);x+=this.renderer.list(be,Me,Be);continue}case"html":{x+=this.renderer.html(Ee.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;X+1<je&&W[X+1].type==="text";)Ee=W[++X],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);x+=V?this.renderer.paragraph(be):be;continue}default:{var ue='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return x},Q.parseInline=function(W,V){V=V||this.renderer;var x="",X,ce,pe,ke=W.length;for(X=0;X<ke;X++){if(ce=W[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(pe=this.options.extensions.renderers[ce.type].call({parser:this},ce),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ce.type))){x+=pe||"";continue}switch(ce.type){case"escape":{x+=V.text(ce.text);break}case"html":{x+=V.html(ce.text);break}case"link":{x+=V.link(ce.href,ce.title,this.parseInline(ce.tokens,V));break}case"image":{x+=V.image(ce.href,ce.title,ce.text);break}case"strong":{x+=V.strong(this.parseInline(ce.tokens,V));break}case"em":{x+=V.em(this.parseInline(ce.tokens,V));break}case"codespan":{x+=V.codespan(ce.text);break}case"br":{x+=V.br();break}case"del":{x+=V.del(this.parseInline(ce.tokens,V));break}case"text":{x+=V.text(ce.text);break}default:{var Te='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return x},z}();function he(z,Q,J){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof Q=="function"&&(J=Q,Q=null),Q=o({},he.defaults,Q||{}),K(Q),J){var W=Q.highlight,V;try{V=j.lex(z,Q)}catch(ke){return J(ke)}var x=function(Te){var Ne;if(!Te)try{Q.walkTokens&&he.walkTokens(V,Q.walkTokens),Ne=se.parse(V,Q)}catch(Oe){Te=Oe}return Q.highlight=W,Te?J(Te):J(null,Ne)};if(!W||W.length<3||(delete Q.highlight,!V.length))return x();var X=0;he.walkTokens(V,function(ke){ke.type==="code"&&(X++,setTimeout(function(){W(ke.text,ke.lang,function(Te,Ne){if(Te)return x(Te);Ne!=null&&Ne!==ke.text&&(ke.text=Ne,ke.escaped=!0),X--,X===0&&x()})},0))}),X===0&&x();return}function ce(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Q.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var pe=j.lex(z,Q);if(Q.walkTokens){if(Q.async)return Promise.all(he.walkTokens(pe,Q.walkTokens)).then(function(){return se.parse(pe,Q)}).catch(ce);he.walkTokens(pe,Q.walkTokens)}return se.parse(pe,Q)}catch(ke){ce(ke)}}he.options=he.setOptions=function(z){return o(he.defaults,z),C(he.defaults),he},he.getDefaults=P,he.defaults=oe.defaults,he.use=function(){for(var z=arguments.length,Q=new Array(z),J=0;J<z;J++)Q[J]=arguments[J];var W=o.apply(void 0,[{}].concat(Q)),V=he.defaults.extensions||{renderers:{},childTokens:{}},x;Q.forEach(function(X){if(X.extensions&&(x=!0,X.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var ke=V.renderers?V.renderers[pe.name]:null;ke?V.renderers[pe.name]=function(){for(var Te=arguments.length,Ne=new Array(Te),Oe=0;Oe<Te;Oe++)Ne[Oe]=arguments[Oe];var me=pe.renderer.apply(this,Ne);return me===!1&&(me=ke.apply(this,Ne)),me}:V.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");V[pe.level]?V[pe.level].unshift(pe.tokenizer):V[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?V.startBlock?V.startBlock.push(pe.start):V.startBlock=[pe.start]:pe.level==="inline"&&(V.startInline?V.startInline.push(pe.start):V.startInline=[pe.start]))}pe.childTokens&&(V.childTokens[pe.name]=pe.childTokens)})),X.renderer&&function(){var pe=he.defaults.renderer||new L,ke=function(Oe){var me=pe[Oe];pe[Oe]=function(){for(var be=arguments.length,Ee=new Array(be),Me=0;Me<be;Me++)Ee[Me]=arguments[Me];var Be=X.renderer[Oe].apply(pe,Ee);return Be===!1&&(Be=me.apply(pe,Ee)),Be}};for(var Te in X.renderer)ke(Te);W.renderer=pe}(),X.tokenizer&&function(){var pe=he.defaults.tokenizer||new F,ke=function(Oe){var me=pe[Oe];pe[Oe]=function(){for(var be=arguments.length,Ee=new Array(be),Me=0;Me<be;Me++)Ee[Me]=arguments[Me];var Be=X.tokenizer[Oe].apply(pe,Ee);return Be===!1&&(Be=me.apply(pe,Ee)),Be}};for(var Te in X.tokenizer)ke(Te);W.tokenizer=pe}(),X.walkTokens){var ce=he.defaults.walkTokens;W.walkTokens=function(pe){var ke=[];return ke.push(X.walkTokens.call(this,pe)),ce&&(ke=ke.concat(ce.call(this,pe))),ke}}x&&(W.extensions=V),he.setOptions(W)})},he.walkTokens=function(z,Q){for(var J=[],W=function(){var ce=x.value;switch(J=J.concat(Q.call(he,ce)),ce.type){case"table":{for(var pe=I(ce.header),ke;!(ke=pe()).done;){var Te=ke.value;J=J.concat(he.walkTokens(Te.tokens,Q))}for(var Ne=I(ce.rows),Oe;!(Oe=Ne()).done;)for(var me=Oe.value,be=I(me),Ee;!(Ee=be()).done;){var Me=Ee.value;J=J.concat(he.walkTokens(Me.tokens,Q))}break}case"list":{J=J.concat(he.walkTokens(ce.items,Q));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[ce.type]?he.defaults.extensions.childTokens[ce.type].forEach(function(Be){J=J.concat(he.walkTokens(ce[Be],Q))}):ce.tokens&&(J=J.concat(he.walkTokens(ce.tokens,Q)))}},V=I(z),x;!(x=V()).done;)W();return J},he.parseInline=function(z,Q){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");Q=o({},he.defaults,Q||{}),K(Q);try{var J=j.lexInline(z,Q);return Q.walkTokens&&he.walkTokens(J,Q.walkTokens),se.parseInline(J,Q)}catch(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,Q.silent)return"<p>An error occurred:</p><pre>"+d(W.message+"",!0)+"</pre>";throw W}},he.Parser=se,he.parser=se.parse,he.Renderer=L,he.TextRenderer=N,he.Lexer=j,he.lexer=j.lex,he.Tokenizer=F,he.Slugger=q,he.parse=he;var Z=he.options,ee=he.setOptions,_=he.use,U=he.walkTokens,te=he.parseInline,ie=he,fe=se.parse,ve=j.lex;oe.Lexer=j,oe.Parser=se,oe.Renderer=L,oe.Slugger=q,oe.TextRenderer=N,oe.Tokenizer=F,oe.getDefaults=P,oe.lexer=ve,oe.marked=he,oe.options=Z,oe.parse=ie,oe.parseInline=te,oe.parser=fe,oe.setOptions=ee,oe.use=_,oe.walkTokens=U,Object.defineProperty(oe,"__esModule",{value:!0})}),define(we[88],ye([1,0,31]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new y.LRUCache(1e4);function D(b){return E(b,"NFC",t)}e.normalizeNFC=D;const I=new y.LRUCache(1e4);function P(b){return E(b,"NFD",I)}e.normalizeNFD=P;const C=/[^\u0000-\u0080]/;function E(b,k,R){if(!b)return b;const S=R.get(b);if(S)return S;let w;return C.test(b)?w=b.normalize(k):w=b,R.set(b,w),w}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(k){return P(k).replace(b,"")}}()}),function(){function oe(D){const I=[];typeof D=="number"&&I.push("code/timeOrigin",D);function P(E){I.push(E,Date.now())}function C(){const E=[];for(let b=0;b<I.length;b+=2)E.push({name:I[b],startTime:I[b+1]});return E}return{mark:P,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))I.push({name:P.name,startTime:Math.round(D+P.startTime)});return I}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function y(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=y(t))}(),define(we[3],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let y=!1,t=!1,D=!1,I=!1,P=!1,C=!1,E=!1,b=!1,k=!1,R=!1,S,w=e.LANGUAGE_DEFAULT,d,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?v=e.globals.vscode.process:typeof process<"u"&&(v=process);const m=typeof v?.versions?.electron=="string",p=m&&v?.type==="renderer";if(typeof navigator=="object"&&!p){g=navigator.userAgent,y=g.indexOf("Windows")>=0,t=g.indexOf("Macintosh")>=0,b=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=g.indexOf("Linux")>=0,R=g?.indexOf("Mobi")>=0,C=!0,S=e.LANGUAGE_DEFAULT,w=S;const f=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),o=f&&f.getAttribute("data-settings");if(o)try{const c=JSON.parse(o);S=c.locale,d=c._translationsConfigFile,w=c.availableLanguages["*"]||e.LANGUAGE_DEFAULT}catch{}}else if(typeof v=="object"){y=v.platform==="win32",t=v.platform==="darwin",D=v.platform==="linux",I=D&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,E=m,k=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const f=v.env.VSCODE_NLS_CONFIG;if(f)try{const o=JSON.parse(f),c=o.availableLanguages["*"];S=o.locale,w=c||e.LANGUAGE_DEFAULT,d=o._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var u;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function l(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let h=0;t?h=1:y?h=3:D&&(h=2),e.isWindows=y,e.isMacintosh=t,e.isLinux=D,e.isLinuxSnap=I,e.isNative=P,e.isElectron=E,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=R,e.isCI=k,e.platform=h,e.userAgent=g,e.language=w;var i;(function(f){function o(){return e.language}f.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}f.isDefaultVariant=c;function T(){return e.language==="en"}f.isDefault=T})(i=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const f=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let T=0,O=f.length;T<O;T++){const K=f[T];if(K.id===c.data.vscodeScheduleAsyncWork){f.splice(T,1),K.callback();return}}});let o=0;return c=>{const T=++o;f.push({id:T,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return f=>setTimeout(f)})();var r;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=t||b?2:y?1:3;let n=!0,s=!1;function a(){if(!s){s=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,n=new Uint16Array(f.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[26],ye([1,0,3]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const D=y.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[6],ye([1,0,26]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,I=90,P=122,C=46,E=47,b=92,k=58,R=63;class S extends Error{constructor(l,h,i){let r;typeof h=="string"&&h.indexOf("not ")===0?(r="must not be",h=h.replace(/^not /,"")):r="must be";const n=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${n} ${r} of type ${h}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function w(u,l){if(typeof u!="string")throw new S(l,"string",u)}function d(u){return u===E||u===b}function g(u){return u===E}function v(u){return u>=t&&u<=I||u>=D&&u<=P}function m(u,l,h,i){let r="",n=0,s=-1,a=0,f=0;for(let o=0;o<=u.length;++o){if(o<u.length)f=u.charCodeAt(o);else{if(i(f))break;f=E}if(i(f)){if(!(s===o-1||a===1))if(a===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const c=r.lastIndexOf(h);c===-1?(r="",n=0):(r=r.slice(0,c),n=r.length-1-r.lastIndexOf(h)),s=o,a=0;continue}else if(r.length!==0){r="",n=0,s=o,a=0;continue}}l&&(r+=r.length>0?`${h}..`:"..",n=2)}else r.length>0?r+=`${h}${u.slice(s+1,o)}`:r=u.slice(s+1,o),n=o-s-1;s=o,a=0}else f===C&&a!==-1?++a:a=-1}return r}function p(u,l){if(l===null||typeof l!="object")throw new S("pathObject","Object",l);const h=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return h?h===l.root?`${h}${i}`:`${h}${u}${i}`:i}e.win32={resolve(...u){let l="",h="",i=!1;for(let r=u.length-1;r>=-1;r--){let n;if(r>=0){if(n=u[r],w(n,"path"),n.length===0)continue}else l.length===0?n=y.cwd():(n=y.env[`=${l}`]||y.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${l}\\`));const s=n.length;let a=0,f="",o=!1;const c=n.charCodeAt(0);if(s===1)d(c)&&(a=1,o=!0);else if(d(c))if(o=!0,d(n.charCodeAt(1))){let T=2,O=T;for(;T<s&&!d(n.charCodeAt(T));)T++;if(T<s&&T!==O){const K=n.slice(O,T);for(O=T;T<s&&d(n.charCodeAt(T));)T++;if(T<s&&T!==O){for(O=T;T<s&&!d(n.charCodeAt(T));)T++;(T===s||T!==O)&&(f=`\\\\${K}\\${n.slice(O,T)}`,a=T)}}}else a=1;else v(c)&&n.charCodeAt(1)===k&&(f=n.slice(0,2),a=2,s>2&&d(n.charCodeAt(2))&&(o=!0,a=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(i){if(l.length>0)break}else if(h=`${n.slice(a)}\\${h}`,i=o,o&&l.length>0)break}return h=m(h,!i,"\\",d),i?`${l}\\${h}`:`${l}${h}`||"."},normalize(u){w(u,"path");const l=u.length;if(l===0)return".";let h=0,i,r=!1;const n=u.charCodeAt(0);if(l===1)return g(n)?"\\":u;if(d(n))if(r=!0,d(u.charCodeAt(1))){let a=2,f=a;for(;a<l&&!d(u.charCodeAt(a));)a++;if(a<l&&a!==f){const o=u.slice(f,a);for(f=a;a<l&&d(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&!d(u.charCodeAt(a));)a++;if(a===l)return`\\\\${o}\\${u.slice(f)}\\`;a!==f&&(i=`\\\\${o}\\${u.slice(f,a)}`,h=a)}}}else h=1;else v(n)&&u.charCodeAt(1)===k&&(i=u.slice(0,2),h=2,l>2&&d(u.charCodeAt(2))&&(r=!0,h=3));let s=h<l?m(u.slice(h),!r,"\\",d):"";return s.length===0&&!r&&(s="."),s.length>0&&d(u.charCodeAt(l-1))&&(s+="\\"),i===void 0?r?`\\${s}`:s:r?`${i}\\${s}`:`${i}${s}`},isAbsolute(u){w(u,"path");const l=u.length;if(l===0)return!1;const h=u.charCodeAt(0);return d(h)||l>2&&v(h)&&u.charCodeAt(1)===k&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let l,h;for(let n=0;n<u.length;++n){const s=u[n];w(s,"path"),s.length>0&&(l===void 0?l=h=s:l+=`\\${s}`)}if(l===void 0)return".";let i=!0,r=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++r;const n=h.length;n>1&&d(h.charCodeAt(1))&&(++r,n>2&&(d(h.charCodeAt(2))?++r:i=!1))}if(i){for(;r<l.length&&d(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(u,l){if(w(u,"from"),w(l,"to"),u===l)return"";const h=e.win32.resolve(u),i=e.win32.resolve(l);if(h===i||(u=h.toLowerCase(),l=i.toLowerCase(),u===l))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===b;)r++;let n=u.length;for(;n-1>r&&u.charCodeAt(n-1)===b;)n--;const s=n-r;let a=0;for(;a<l.length&&l.charCodeAt(a)===b;)a++;let f=l.length;for(;f-1>a&&l.charCodeAt(f-1)===b;)f--;const o=f-a,c=s<o?s:o;let T=-1,O=0;for(;O<c;O++){const re=u.charCodeAt(r+O);if(re!==l.charCodeAt(a+O))break;re===b&&(T=O)}if(O!==c){if(T===-1)return i}else{if(o>c){if(l.charCodeAt(a+O)===b)return i.slice(a+O+1);if(O===2)return i.slice(a+O)}s>c&&(u.charCodeAt(r+O)===b?T=O:O===2&&(T=3)),T===-1&&(T=0)}let K="";for(O=r+T+1;O<=n;++O)(O===n||u.charCodeAt(O)===b)&&(K+=K.length===0?"..":"\\..");return a+=T,K.length>0?`${K}${i.slice(a,f)}`:(i.charCodeAt(a)===b&&++a,i.slice(a,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const l=e.win32.resolve(u);if(l.length<=2)return u;if(l.charCodeAt(0)===b){if(l.charCodeAt(1)===b){const h=l.charCodeAt(2);if(h!==R&&h!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===k&&l.charCodeAt(2)===b)return`\\\\?\\${l}`;return u},dirname(u){w(u,"path");const l=u.length;if(l===0)return".";let h=-1,i=0;const r=u.charCodeAt(0);if(l===1)return d(r)?u:".";if(d(r)){if(h=i=1,d(u.charCodeAt(1))){let a=2,f=a;for(;a<l&&!d(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&d(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&!d(u.charCodeAt(a));)a++;if(a===l)return u;a!==f&&(h=i=a+1)}}}}else v(r)&&u.charCodeAt(1)===k&&(h=l>2&&d(u.charCodeAt(2))?3:2,i=h);let n=-1,s=!0;for(let a=l-1;a>=i;--a)if(d(u.charCodeAt(a))){if(!s){n=a;break}}else s=!1;if(n===-1){if(h===-1)return".";n=h}return u.slice(0,n)},basename(u,l){l!==void 0&&w(l,"ext"),w(u,"path");let h=0,i=-1,r=!0,n;if(u.length>=2&&v(u.charCodeAt(0))&&u.charCodeAt(1)===k&&(h=2),l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let s=l.length-1,a=-1;for(n=u.length-1;n>=h;--n){const f=u.charCodeAt(n);if(d(f)){if(!r){h=n+1;break}}else a===-1&&(r=!1,a=n+1),s>=0&&(f===l.charCodeAt(s)?--s===-1&&(i=n):(s=-1,i=a))}return h===i?i=a:i===-1&&(i=u.length),u.slice(h,i)}for(n=u.length-1;n>=h;--n)if(d(u.charCodeAt(n))){if(!r){h=n+1;break}}else i===-1&&(r=!1,i=n+1);return i===-1?"":u.slice(h,i)},extname(u){w(u,"path");let l=0,h=-1,i=0,r=-1,n=!0,s=0;u.length>=2&&u.charCodeAt(1)===k&&v(u.charCodeAt(0))&&(l=i=2);for(let a=u.length-1;a>=l;--a){const f=u.charCodeAt(a);if(d(f)){if(!n){i=a+1;break}continue}r===-1&&(n=!1,r=a+1),f===C?h===-1?h=a:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||r===-1||s===0||s===1&&h===r-1&&h===i+1?"":u.slice(h,r)},format:p.bind(null,"\\"),parse(u){w(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const h=u.length;let i=0,r=u.charCodeAt(0);if(h===1)return d(r)?(l.root=l.dir=u,l):(l.base=l.name=u,l);if(d(r)){if(i=1,d(u.charCodeAt(1))){let T=2,O=T;for(;T<h&&!d(u.charCodeAt(T));)T++;if(T<h&&T!==O){for(O=T;T<h&&d(u.charCodeAt(T));)T++;if(T<h&&T!==O){for(O=T;T<h&&!d(u.charCodeAt(T));)T++;T===h?i=T:T!==O&&(i=T+1)}}}}else if(v(r)&&u.charCodeAt(1)===k){if(h<=2)return l.root=l.dir=u,l;if(i=2,d(u.charCodeAt(2))){if(h===3)return l.root=l.dir=u,l;i=3}}i>0&&(l.root=u.slice(0,i));let n=-1,s=i,a=-1,f=!0,o=u.length-1,c=0;for(;o>=i;--o){if(r=u.charCodeAt(o),d(r)){if(!f){s=o+1;break}continue}a===-1&&(f=!1,a=o+1),r===C?n===-1?n=o:c!==1&&(c=1):n!==-1&&(c=-1)}return a!==-1&&(n===-1||c===0||c===1&&n===a-1&&n===s+1?l.base=l.name=u.slice(s,a):(l.name=u.slice(s,n),l.base=u.slice(s,a),l.ext=u.slice(n,a))),s>0&&s!==i?l.dir=u.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let l="",h=!1;for(let i=u.length-1;i>=-1&&!h;i--){const r=i>=0?u[i]:y.cwd();w(r,"path"),r.length!==0&&(l=`${r}/${l}`,h=r.charCodeAt(0)===E)}return l=m(l,!h,"/",g),h?`/${l}`:l.length>0?l:"."},normalize(u){if(w(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===E,h=u.charCodeAt(u.length-1)===E;return u=m(u,!l,"/",g),u.length===0?l?"/":h?"./":".":(h&&(u+="/"),l?`/${u}`:u)},isAbsolute(u){return w(u,"path"),u.length>0&&u.charCodeAt(0)===E},join(...u){if(u.length===0)return".";let l;for(let h=0;h<u.length;++h){const i=u[h];w(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.posix.normalize(l)},relative(u,l){if(w(u,"from"),w(l,"to"),u===l||(u=e.posix.resolve(u),l=e.posix.resolve(l),u===l))return"";const h=1,i=u.length,r=i-h,n=1,s=l.length-n,a=r<s?r:s;let f=-1,o=0;for(;o<a;o++){const T=u.charCodeAt(h+o);if(T!==l.charCodeAt(n+o))break;T===E&&(f=o)}if(o===a)if(s>a){if(l.charCodeAt(n+o)===E)return l.slice(n+o+1);if(o===0)return l.slice(n+o)}else r>a&&(u.charCodeAt(h+o)===E?f=o:o===0&&(f=0));let c="";for(o=h+f+1;o<=i;++o)(o===i||u.charCodeAt(o)===E)&&(c+=c.length===0?"..":"/..");return`${c}${l.slice(n+f)}`},toNamespacedPath(u){return u},dirname(u){if(w(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===E;let h=-1,i=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===E){if(!i){h=r;break}}else i=!1;return h===-1?l?"/":".":l&&h===1?"//":u.slice(0,h)},basename(u,l){l!==void 0&&w(l,"ext"),w(u,"path");let h=0,i=-1,r=!0,n;if(l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let s=l.length-1,a=-1;for(n=u.length-1;n>=0;--n){const f=u.charCodeAt(n);if(f===E){if(!r){h=n+1;break}}else a===-1&&(r=!1,a=n+1),s>=0&&(f===l.charCodeAt(s)?--s===-1&&(i=n):(s=-1,i=a))}return h===i?i=a:i===-1&&(i=u.length),u.slice(h,i)}for(n=u.length-1;n>=0;--n)if(u.charCodeAt(n)===E){if(!r){h=n+1;break}}else i===-1&&(r=!1,i=n+1);return i===-1?"":u.slice(h,i)},extname(u){w(u,"path");let l=-1,h=0,i=-1,r=!0,n=0;for(let s=u.length-1;s>=0;--s){const a=u.charCodeAt(s);if(a===E){if(!r){h=s+1;break}continue}i===-1&&(r=!1,i=s+1),a===C?l===-1?l=s:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||i===-1||n===0||n===1&&l===i-1&&l===h+1?"":u.slice(l,i)},format:p.bind(null,"/"),parse(u){w(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const h=u.charCodeAt(0)===E;let i;h?(l.root="/",i=1):i=0;let r=-1,n=0,s=-1,a=!0,f=u.length-1,o=0;for(;f>=i;--f){const c=u.charCodeAt(f);if(c===E){if(!a){n=f+1;break}continue}s===-1&&(a=!1,s=f+1),c===C?r===-1?r=f:o!==1&&(o=1):r!==-1&&(o=-1)}if(s!==-1){const c=n===0&&h?1:n;r===-1||o===0||o===1&&r===s-1&&r===n+1?l.base=l.name=u.slice(c,s):(l.name=u.slice(c,r),l.base=u.slice(c,s),l.ext=u.slice(r,s))}return n>0?l.dir=u.slice(0,n-1):h&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[68],ye([1,0,6]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(k){const R=(0,y.extname)(k),S=t[R.toLowerCase()];return S!==void 0?S:P(k)}e.getMediaOrTextMime=I;function P(k){const R=(0,y.extname)(k);return D[R.toLowerCase()]}e.getMediaMime=P;function C(k){for(const R in D)if(D[R]===k)return R}e.getExtensionForMimeType=C;const E=/^(.+)\/(.+?)(;.+)?$/;function b(k,R){const S=E.exec(k);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:R?void 0:k}e.normalizeMimeType=b}),define(we[56],ye([1,0,3]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(C,...E){const b=E.reduce((S,w)=>(S[w]=!0,S),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(C).filter(S=>!b[S]).forEach(S=>{for(let w=0;w<k.length;w++)if(S.search(k[w])!==-1){delete C[S];break}})}e.sanitizeProcessEnvironment=I;function P(C){!C||(delete C.DEBUG,y.isMacintosh&&delete C.DYLD_LIBRARY_PATH,y.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=P}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var t in y)(typeof exports=="object"?exports:oe)[t]=y[t]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function y(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return oe[t].call(D.exports,D,D.exports,y),D.l=!0,D.exports}return y.m=oe,y.c=e,y.d=function(t,D,I){y.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:I})},y.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},y.t=function(t,D){if(1&D&&(t=y(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var I=Object.create(null);if(y.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var P in t)y.d(I,P,function(C){return t[C]}.bind(null,P));return I},y.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return y.d(D,"a",D),D},y.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},y.p="",y(y.s=0)}([function(oe,e,y){(function(t){var D;e=oe.exports=_,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],E=e.src=[],b=0,k=b++;E[k]="0|[1-9]\\d*";var R=b++;E[R]="[0-9]+";var S=b++;E[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=b++;E[w]="("+E[k]+")\\.("+E[k]+")\\.("+E[k]+")";var d=b++;E[d]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var g=b++;E[g]="(?:"+E[k]+"|"+E[S]+")";var v=b++;E[v]="(?:"+E[R]+"|"+E[S]+")";var m=b++;E[m]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var p=b++;E[p]="(?:-?("+E[v]+"(?:\\."+E[v]+")*))";var u=b++;E[u]="[0-9A-Za-z-]+";var l=b++;E[l]="(?:\\+("+E[u]+"(?:\\."+E[u]+")*))";var h=b++,i="v?"+E[w]+E[m]+"?"+E[l]+"?";E[h]="^"+i+"$";var r="[v=\\s]*"+E[d]+E[p]+"?"+E[l]+"?",n=b++;E[n]="^"+r+"$";var s=b++;E[s]="((?:<|>)?=?)";var a=b++;E[a]=E[R]+"|x|X|\\*";var f=b++;E[f]=E[k]+"|x|X|\\*";var o=b++;E[o]="[v=\\s]*("+E[f]+")(?:\\.("+E[f]+")(?:\\.("+E[f]+")(?:"+E[m]+")?"+E[l]+"?)?)?";var c=b++;E[c]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[p]+")?"+E[l]+"?)?)?";var T=b++;E[T]="^"+E[s]+"\\s*"+E[o]+"$";var O=b++;E[O]="^"+E[s]+"\\s*"+E[c]+"$";var K=b++;E[K]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var re=b++;E[re]="(?:~>?)";var le=b++;E[le]="(\\s*)"+E[re]+"\\s+",C[le]=new RegExp(E[le],"g");var ae=b++;E[ae]="^"+E[re]+E[o]+"$";var F=b++;E[F]="^"+E[re]+E[c]+"$";var Y=b++;E[Y]="(?:\\^)";var B=b++;E[B]="(\\s*)"+E[Y]+"\\s+",C[B]=new RegExp(E[B],"g");var H=b++;E[H]="^"+E[Y]+E[o]+"$";var $=b++;E[$]="^"+E[Y]+E[c]+"$";var j=b++;E[j]="^"+E[s]+"\\s*("+r+")$|^$";var L=b++;E[L]="^"+E[s]+"\\s*("+i+")$|^$";var N=b++;E[N]="(\\s*)"+E[s]+"\\s*("+r+"|"+E[o]+")",C[N]=new RegExp(E[N],"g");var q=b++;E[q]="^\\s*("+E[o]+")\\s+-\\s+("+E[o]+")\\s*$";var se=b++;E[se]="^\\s*("+E[c]+")\\s+-\\s+("+E[c]+")\\s*$";var he=b++;E[he]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)D(Z,E[Z]),C[Z]||(C[Z]=new RegExp(E[Z]));function ee(me,be){if(me instanceof _)return me;if(typeof me!="string"||me.length>I||!(be?C[n]:C[h]).test(me))return null;try{return new _(me,be)}catch{return null}}function _(me,be){if(me instanceof _){if(me.loose===be)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof _))return new _(me,be);D("SemVer",me,be),this.loose=be;var Ee=me.trim().match(be?C[n]:C[h]);if(!Ee)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Be=+Me;if(Be>=0&&Be<P)return Be}return Me}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ee,e.valid=function(me,be){var Ee=ee(me,be);return Ee?Ee.version:null},e.clean=function(me,be){var Ee=ee(me.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(me){return D("SemVer.compare",this.version,this.loose,me),me instanceof _||(me=new _(me,this.loose)),this.compareMain(me)||this.comparePre(me)},_.prototype.compareMain=function(me){return me instanceof _||(me=new _(me,this.loose)),te(this.major,me.major)||te(this.minor,me.minor)||te(this.patch,me.patch)},_.prototype.comparePre=function(me){if(me instanceof _||(me=new _(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],Me=me.prerelease[be];if(D("prerelease compare",be,Ee,Me),Ee===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==Me)return te(Ee,Me)}while(++be)},_.prototype.inc=function(me,be){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,be,Ee,Me){typeof Ee=="string"&&(Me=Ee,Ee=void 0);try{return new _(me,Ee).inc(be,Me).version}catch{return null}},e.diff=function(me,be){if(z(me,be))return null;var Ee=ee(me),Me=ee(be);if(Ee.prerelease.length||Me.prerelease.length){for(var Be in Ee)if((Be==="major"||Be==="minor"||Be==="patch")&&Ee[Be]!==Me[Be])return"pre"+Be;return"prerelease"}for(var Be in Ee)if((Be==="major"||Be==="minor"||Be==="patch")&&Ee[Be]!==Me[Be])return Be},e.compareIdentifiers=te;var U=/^[0-9]+$/;function te(me,be){var Ee=U.test(me),Me=U.test(be);return Ee&&Me&&(me=+me,be=+be),Ee&&!Me?-1:Me&&!Ee?1:me<be?-1:me>be?1:0}function ie(me,be,Ee){return new _(me,Ee).compare(new _(be,Ee))}function fe(me,be,Ee){return ie(me,be,Ee)>0}function ve(me,be,Ee){return ie(me,be,Ee)<0}function z(me,be,Ee){return ie(me,be,Ee)===0}function Q(me,be,Ee){return ie(me,be,Ee)!==0}function J(me,be,Ee){return ie(me,be,Ee)>=0}function W(me,be,Ee){return ie(me,be,Ee)<=0}function V(me,be,Ee,Me){var Be;switch(be){case"===":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),Be=me===Ee;break;case"!==":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),Be=me!==Ee;break;case"":case"=":case"==":Be=z(me,Ee,Me);break;case"!=":Be=Q(me,Ee,Me);break;case">":Be=fe(me,Ee,Me);break;case">=":Be=J(me,Ee,Me);break;case"<":Be=ve(me,Ee,Me);break;case"<=":Be=W(me,Ee,Me);break;default:throw new TypeError("Invalid operator: "+be)}return Be}function x(me,be){if(me instanceof x){if(me.loose===be)return me;me=me.value}if(!(this instanceof x))return new x(me,be);D("comparator",me,be),this.loose=be,this.parse(me),this.semver===X?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(me,be){return te(be,me)},e.major=function(me,be){return new _(me,be).major},e.minor=function(me,be){return new _(me,be).minor},e.patch=function(me,be){return new _(me,be).patch},e.compare=ie,e.compareLoose=function(me,be){return ie(me,be,!0)},e.rcompare=function(me,be,Ee){return ie(be,me,Ee)},e.sort=function(me,be){return me.sort(function(Ee,Me){return e.compare(Ee,Me,be)})},e.rsort=function(me,be){return me.sort(function(Ee,Me){return e.rcompare(Ee,Me,be)})},e.gt=fe,e.lt=ve,e.eq=z,e.neq=Q,e.gte=J,e.lte=W,e.cmp=V,e.Comparator=x;var X={};function ce(me,be){if(me instanceof ce)return me.loose===be?me:new ce(me.raw,be);if(me instanceof x)return new ce(me.value,be);if(!(this instanceof ce))return new ce(me,be);if(this.loose=be,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function pe(me){return!me||me.toLowerCase()==="x"||me==="*"}function ke(me,be,Ee,Me,Be,Ge,ze,Ke,xe,Ze,Qe,He,je){return((be=pe(Ee)?"":pe(Me)?">="+Ee+".0.0":pe(Be)?">="+Ee+"."+Me+".0":">="+be)+" "+(Ke=pe(xe)?"":pe(Ze)?"<"+(+xe+1)+".0.0":pe(Qe)?"<"+xe+"."+(+Ze+1)+".0":He?"<="+xe+"."+Ze+"."+Qe+"-"+He:"<="+Ke)).trim()}function Te(me,be){for(var Ee=0;Ee<me.length;Ee++)if(!me[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<me.length;Ee++)if(D(me[Ee].semver),me[Ee].semver!==X&&me[Ee].semver.prerelease.length>0){var Me=me[Ee].semver;if(Me.major===be.major&&Me.minor===be.minor&&Me.patch===be.patch)return!0}return!1}return!0}function Ne(me,be,Ee){try{be=new ce(be,Ee)}catch{return!1}return be.test(me)}function Oe(me,be,Ee,Me){var Be,Ge,ze,Ke,xe;switch(me=new _(me,Me),be=new ce(be,Me),Ee){case">":Be=fe,Ge=W,ze=ve,Ke=">",xe=">=";break;case"<":Be=ve,Ge=J,ze=fe,Ke="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(me,be,Me))return!1;for(var Ze=0;Ze<be.set.length;++Ze){var Qe=be.set[Ze],He=null,je=null;if(Qe.forEach(function(ue){ue.semver===X&&(ue=new x(">=0.0.0")),He=He||ue,je=je||ue,Be(ue.semver,He.semver,Me)?He=ue:ze(ue.semver,je.semver,Me)&&(je=ue)}),He.operator===Ke||He.operator===xe||(!je.operator||je.operator===Ke)&&Ge(me,je.semver)||je.operator===xe&&ze(me,je.semver))return!1}return!0}x.prototype.parse=function(me){var be=this.loose?C[j]:C[L],Ee=me.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+me);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new _(Ee[2],this.loose):this.semver=X},x.prototype.toString=function(){return this.value},x.prototype.test=function(me){return D("Comparator.test",me,this.loose),this.semver===X||(typeof me=="string"&&(me=new _(me,this.loose)),V(me,this.operator,this.semver,this.loose))},x.prototype.intersects=function(me,be){if(!(me instanceof x))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new ce(me.value,be),Ne(this.value,Ee,be);if(me.operator==="")return Ee=new ce(this.value,be),Ne(me.semver,Ee,be);var Me=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Ge=this.semver.version===me.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ke=V(this.semver,"<",me.semver,be)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),xe=V(this.semver,">",me.semver,be)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Me||Be||Ge&&ze||Ke||xe},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(me){var be=this.loose;me=me.trim(),D("range",me,be);var Ee=be?C[se]:C[q];me=me.replace(Ee,ke),D("hyphen replace",me),me=me.replace(C[N],"$1$2$3"),D("comparator trim",me,C[N]),me=(me=(me=me.replace(C[le],"$1~")).replace(C[B],"$1^")).split(/\s+/).join(" ");var Me=be?C[j]:C[L],Be=me.split(" ").map(function(Ge){return function(ze,Ke){return D("comp",ze),ze=function(xe,Ze){return xe.trim().split(/\s+/).map(function(Qe){return function(He,je){D("caret",He,je);var ue=je?C[$]:C[H];return He.replace(ue,function(De,Ce,Re,Fe,$e){var qe;return D("caret",He,De,Ce,Re,Fe,$e),pe(Ce)?qe="":pe(Re)?qe=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":pe(Fe)?qe=Ce==="0"?">="+Ce+"."+Re+".0 <"+Ce+"."+(+Re+1)+".0":">="+Ce+"."+Re+".0 <"+(+Ce+1)+".0.0":$e?(D("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),qe=Ce==="0"?Re==="0"?">="+Ce+"."+Re+"."+Fe+$e+" <"+Ce+"."+Re+"."+(+Fe+1):">="+Ce+"."+Re+"."+Fe+$e+" <"+Ce+"."+(+Re+1)+".0":">="+Ce+"."+Re+"."+Fe+$e+" <"+(+Ce+1)+".0.0"):(D("no pr"),qe=Ce==="0"?Re==="0"?">="+Ce+"."+Re+"."+Fe+" <"+Ce+"."+Re+"."+(+Fe+1):">="+Ce+"."+Re+"."+Fe+" <"+Ce+"."+(+Re+1)+".0":">="+Ce+"."+Re+"."+Fe+" <"+(+Ce+1)+".0.0"),D("caret return",qe),qe})}(Qe,Ze)}).join(" ")}(ze,Ke),D("caret",ze),ze=function(xe,Ze){return xe.trim().split(/\s+/).map(function(Qe){return function(He,je){var ue=je?C[F]:C[ae];return He.replace(ue,function(De,Ce,Re,Fe,$e){var qe;return D("tilde",He,De,Ce,Re,Fe,$e),pe(Ce)?qe="":pe(Re)?qe=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":pe(Fe)?qe=">="+Ce+"."+Re+".0 <"+Ce+"."+(+Re+1)+".0":$e?(D("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),qe=">="+Ce+"."+Re+"."+Fe+$e+" <"+Ce+"."+(+Re+1)+".0"):qe=">="+Ce+"."+Re+"."+Fe+" <"+Ce+"."+(+Re+1)+".0",D("tilde return",qe),qe})}(Qe,Ze)}).join(" ")}(ze,Ke),D("tildes",ze),ze=function(xe,Ze){return D("replaceXRanges",xe,Ze),xe.split(/\s+/).map(function(Qe){return function(He,je){He=He.trim();var ue=je?C[O]:C[T];return He.replace(ue,function(De,Ce,Re,Fe,$e,qe){D("xRange",He,De,Ce,Re,Fe,$e,qe);var nt=pe(Re),rt=nt||pe(Fe),et=rt||pe($e);return Ce==="="&&et&&(Ce=""),nt?De=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&et?(rt&&(Fe=0),et&&($e=0),Ce===">"?(Ce=">=",rt?(Re=+Re+1,Fe=0,$e=0):et&&(Fe=+Fe+1,$e=0)):Ce==="<="&&(Ce="<",rt?Re=+Re+1:Fe=+Fe+1),De=Ce+Re+"."+Fe+"."+$e):rt?De=">="+Re+".0.0 <"+(+Re+1)+".0.0":et&&(De=">="+Re+"."+Fe+".0 <"+Re+"."+(+Fe+1)+".0"),D("xRange return",De),De})}(Qe,Ze)}).join(" ")}(ze,Ke),D("xrange",ze),ze=function(xe,Ze){return D("replaceStars",xe,Ze),xe.trim().replace(C[he],"")}(ze,Ke),D("stars",ze),ze}(Ge,be)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ge){return!!Ge.match(Me)})),Be=Be.map(function(Ge){return new x(Ge,be)})},ce.prototype.intersects=function(me,be){if(!(me instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(Me){return me.set.some(function(Be){return Be.every(function(Ge){return Me.intersects(Ge,be)})})})})},e.toComparators=function(me,be){return new ce(me,be).set.map(function(Ee){return Ee.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new _(me,this.loose));for(var be=0;be<this.set.length;be++)if(Te(this.set[be],me))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(me,be,Ee){var Me=null,Be=null;try{var Ge=new ce(be,Ee)}catch{return null}return me.forEach(function(ze){Ge.test(ze)&&(Me&&Be.compare(ze)!==-1||(Be=new _(Me=ze,Ee)))}),Me},e.minSatisfying=function(me,be,Ee){var Me=null,Be=null;try{var Ge=new ce(be,Ee)}catch{return null}return me.forEach(function(ze){Ge.test(ze)&&(Me&&Be.compare(ze)!==1||(Be=new _(Me=ze,Ee)))}),Me},e.validRange=function(me,be){try{return new ce(me,be).range||"*"}catch{return null}},e.ltr=function(me,be,Ee){return Oe(me,be,"<",Ee)},e.gtr=function(me,be,Ee){return Oe(me,be,">",Ee)},e.outside=Oe,e.prerelease=function(me,be){var Ee=ee(me,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(me,be,Ee){return me=new ce(me,Ee),be=new ce(be,Ee),me.intersects(be)},e.coerce=function(me){if(me instanceof _)return me;if(typeof me!="string")return null;var be=me.match(C[K]);return be==null?null:ee((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,y(1))},function(oe,e){var y,t,D=oe.exports={};function I(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function C(v){if(y===setTimeout)return setTimeout(v,0);if((y===I||!y)&&setTimeout)return y=setTimeout,setTimeout(v,0);try{return y(v,0)}catch{try{return y.call(null,v,0)}catch{return y.call(this,v,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:I}catch{y=I}try{t=typeof clearTimeout=="function"?clearTimeout:P}catch{t=P}})();var E,b=[],k=!1,R=-1;function S(){k&&E&&(k=!1,E.length?b=E.concat(b):R=-1,b.length&&w())}function w(){if(!k){var v=C(S);k=!0;for(var m=b.length;m;){for(E=b,b=[];++R<m;)E&&E[R].run();R=-1,m=b.length}E=null,k=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===P||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(v)}}function d(v,m){this.fun=v,this.array=m}function g(){}D.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)m[p-1]=arguments[p];b.push(new d(v,m)),b.length!==1||k||C(w)},d.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=g,D.addListener=g,D.once=g,D.off=g,D.removeListener=g,D.removeAllListeners=g,D.emit=g,D.prependListener=g,D.prependOnceListener=g,D.listeners=function(v){return[]},D.binding=function(v){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(v){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(we[139],ye([1,0]),function(oe,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(C,E,b){this.level=C,this.key=E,this.value=b,this.forward=[]}}const D=void 0;class I{constructor(C,E=2**16){this.comparator=C,this[y]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new t(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,D,D)}has(C){return Boolean(I._search(this,C,this.comparator))}get(C){return I._search(this,C,this.comparator)?.value}set(C,E){return I._insert(this,C,E,this.comparator)&&(this._size+=1),this}delete(C){const E=I._delete(this,C,this.comparator);return E&&(this._size-=1),E}forEach(C,E){let b=this._header.forward[0];for(;b;)C.call(E,b.value,b.key,this),b=b.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",E=this._header.forward[0];for(;E;)C+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return C}static _search(C,E,b){let k=C._header;for(let R=C._level-1;R>=0;R--)for(;k.forward[R]&&b(k.forward[R].key,E)<0;)k=k.forward[R];if(k=k.forward[0],k&&b(k.key,E)===0)return k}static _insert(C,E,b,k){const R=[];let S=C._header;for(let w=C._level-1;w>=0;w--){for(;S.forward[w]&&k(S.forward[w].key,E)<0;)S=S.forward[w];R[w]=S}if(S=S.forward[0],S&&k(S.key,E)===0)return S.value=b,!1;{const w=I._randomLevel(C);if(w>C._level){for(let d=C._level;d<w;d++)R[d]=C._header;C._level=w}S=new t(w,E,b);for(let d=0;d<w;d++)S.forward[d]=R[d].forward[d],R[d].forward[d]=S;return!0}}static _randomLevel(C,E=.5){let b=1;for(;Math.random()<E&&b<C._maxLevel;)b+=1;return b}static _delete(C,E,b){const k=[];let R=C._header;for(let S=C._level-1;S>=0;S--){for(;R.forward[S]&&b(R.forward[S].key,E)<0;)R=R.forward[S];k[S]=R}if(R=R.forward[0],!R||b(R.key,E)!==0)return!1;for(let S=0;S<C._level&&k[S].forward[S]===R;S++)k[S].forward[S]=R.forward[S];for(;C._level>0&&C._header.forward[C._level-1]===D;)C._level-=1;return!0}}e.SkipList=I}),define(we[140],ye([1,0,3]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=y.globals.performance&&typeof y.globals.performance.now=="function";class D{static create(P=!0){return new D(P)}constructor(P){this._highResolution=t&&P,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=D}),define(we[7],ye([1,0,8,66,2,87,140]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const C=!1,E=!1;var b;(function(f){f.None=()=>D.Disposable.None;function o(ie){if(E){const{onListenerDidAdd:fe}=ie,ve=d.create();let z=0;ie.onListenerDidAdd=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),fe?.()}}}function c(ie,fe){return H(ie,()=>{},0,void 0,void 0,fe)}f.defer=c;function T(ie,fe=0,ve){return f.debounce(ie,(z,Q)=>z?(z.push(Q),z):[Q],fe,void 0,void 0,ve)}f.accumulate=T;function O(ie){return(fe,ve=null,z)=>{let Q=!1,J;return J=ie(W=>{if(!Q)return J?J.dispose():Q=!0,fe.call(ve,W)},null,z),Q&&J.dispose(),J}}f.once=O;function K(ie,fe,ve){return B((z,Q=null,J)=>ie(W=>z.call(Q,fe(W)),null,J),ve)}f.map=K;function re(ie,fe,ve){return B((z,Q=null,J)=>ie(W=>{fe(W),z.call(Q,W)},null,J),ve)}f.forEach=re;function le(ie,fe,ve){return B((z,Q=null,J)=>ie(W=>fe(W)&&z.call(Q,W),null,J),ve)}f.filter=le;function ae(ie){return ie}f.signal=ae;function F(...ie){return(fe,ve=null,z)=>(0,D.combinedDisposable)(...ie.map(Q=>Q(J=>fe.call(ve,J),null,z)))}f.any=F;function Y(ie,fe,ve,z){let Q=ve;return K(ie,J=>(Q=fe(Q,J),Q),z)}f.reduce=Y;function B(ie,fe){let ve;const z={onFirstListenerAdd(){ve=ie(Q.fire,Q)},onLastListenerRemove(){ve?.dispose()}};fe||o(z);const Q=new v(z);return fe?.add(Q),Q.event}function H(ie,fe,ve=100,z=!1,Q,J){let W,V,x,X=0;const ce={leakWarningThreshold:Q,onFirstListenerAdd(){W=ie(ke=>{X++,V=fe(V,ke),z&&!x&&(pe.fire(V),V=void 0),clearTimeout(x),x=setTimeout(()=>{const Te=V;V=void 0,x=void 0,(!z||X>1)&&pe.fire(Te),X=0},ve)})},onLastListenerRemove(){W.dispose()}};J||o(ce);const pe=new v(ce);return J?.add(pe),pe.event}f.debounce=H;function $(ie,fe=(z,Q)=>z===Q,ve){let z=!0,Q;return le(ie,J=>{const W=z||!fe(J,Q);return z=!1,Q=J,W},ve)}f.latch=$;function j(ie,fe,ve){return[f.filter(ie,fe,ve),f.filter(ie,z=>!fe(z),ve)]}f.split=j;function L(ie,fe=!1,ve=[]){let z=ve.slice(),Q=ie(V=>{z?z.push(V):W.fire(V)});const J=()=>{z?.forEach(V=>W.fire(V)),z=null},W=new v({onFirstListenerAdd(){Q||(Q=ie(V=>W.fire(V)))},onFirstListenerDidAdd(){z&&(fe?setTimeout(J):J())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return W.event}f.buffer=L;class N{constructor(fe){this.event=fe,this.disposables=new D.DisposableStore}map(fe){return new N(K(this.event,fe,this.disposables))}forEach(fe){return new N(re(this.event,fe,this.disposables))}filter(fe){return new N(le(this.event,fe,this.disposables))}reduce(fe,ve){return new N(Y(this.event,fe,ve,this.disposables))}latch(){return new N($(this.event,void 0,this.disposables))}debounce(fe,ve=100,z=!1,Q){return new N(H(this.event,fe,ve,z,Q,this.disposables))}on(fe,ve,z){return this.event(fe,ve,z)}once(fe,ve,z){return O(this.event)(fe,ve,z)}dispose(){this.disposables.dispose()}}function q(ie){return new N(ie)}f.chain=q;function se(ie,fe,ve=z=>z){const z=(...V)=>W.fire(ve(...V)),Q=()=>ie.on(fe,z),J=()=>ie.removeListener(fe,z),W=new v({onFirstListenerAdd:Q,onLastListenerRemove:J});return W.event}f.fromNodeEventEmitter=se;function he(ie,fe,ve=z=>z){const z=(...V)=>W.fire(ve(...V)),Q=()=>ie.addEventListener(fe,z),J=()=>ie.removeEventListener(fe,z),W=new v({onFirstListenerAdd:Q,onLastListenerRemove:J});return W.event}f.fromDOMEventEmitter=he;function Z(ie){return new Promise(fe=>O(ie)(fe))}f.toPromise=Z;function ee(ie,fe){return fe(void 0),ie(ve=>fe(ve))}f.runAndSubscribe=ee;function _(ie,fe){let ve=null;function z(J){ve?.dispose(),ve=new D.DisposableStore,fe(J,ve)}z(void 0);const Q=ie(J=>z(J));return(0,D.toDisposable)(()=>{Q.dispose(),ve?.dispose()})}f.runAndSubscribeWithStore=_;class U{constructor(fe,ve){this.obs=fe,this._counter=0,this._hasChanged=!1;const z={onFirstListenerAdd:()=>{fe.addObserver(this)},onLastListenerRemove:()=>{fe.removeObserver(this)}};ve||o(z),this.emitter=new v(z),ve&&ve.add(this.emitter)}beginUpdate(fe){this._counter++}handleChange(fe,ve){this._hasChanged=!0}endUpdate(fe){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function te(ie,fe){return new U(ie,fe).emitter.event}f.fromObservable=te})(b=e.Event||(e.Event={}));class k{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${k._idPool++}`,k.all.add(this)}start(o){this._stopWatch=new P.StopWatch(!0),this.listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=k,k.all=new Set,k._idPool=0;let R=-1;function S(f){const o=R;return R=f,{dispose(){R=o}}}e.setGlobalLeakWarningThreshold=S;class w{constructor(o,c=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,c){let T=R;if(typeof this.customThreshold=="number"&&(T=this.customThreshold),T<=0||c<T)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=T*.5;let K,re=0;for(const[le,ae]of this._stacks)(!K||re<ae)&&(K=le,re=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${re}):`),console.warn(K)}return()=>{const K=this._stacks.get(o.value)||0;this._stacks.set(o.value,K-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(o,c,T){this.callback=o,this.callbackThis=c,this.stack=T,this.subscription=new D.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class v{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=R>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new k(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(C){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const c of o)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,c,T)=>{this._listeners||(this._listeners=new I.LinkedList);const O=this._listeners.isEmpty();O&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let K,re;this._leakageMon&&this._listeners.size>=30&&(re=d.create(),K=this._leakageMon.check(re,this._listeners.size+1)),C&&(re=re??d.create());const le=new g(o,c,re),ae=this._listeners.push(le);O&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,c);const F=le.subscription.set(()=>{K?.(),this._disposed||(ae(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return T instanceof D.DisposableStore?T.add(F):Array.isArray(T)&&T.push(F),F}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(const c of this._listeners)this._deliveryQueue.push(this,c,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class m{constructor(){this._queue=new I.LinkedList}get size(){return this._queue.size}push(o,c,T){this._queue.push(new u(o,c,T))}clear(o){const c=new I.LinkedList;for(const T of this._queue)T.emitter!==o&&c.push(T);this._queue=c}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(c){(0,y.onUnexpectedError)(c)}}}}e.EventDeliveryQueue=m;class p extends m{clear(o){this._queue.clear()}}class u{constructor(o,c,T){this.emitter=o,this.listener=c,this.event=T}}class l extends v{async fireAsync(o,c,T){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList);for(const O of this._listeners)this._asyncDeliveryQueue.push([O,o]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[O,K]=this._asyncDeliveryQueue.shift(),re=[],le={...K,token:c,waitUntil:ae=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");T&&(ae=T(ae,O.callback)),re.push(ae)}};try{O.invoke(le)}catch(ae){(0,y.onUnexpectedError)(ae);continue}Object.freeze(re),await Promise.allSettled(re).then(ae=>{for(const F of ae)F.status==="rejected"&&(0,y.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=l;class h extends v{constructor(o){super(o),this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=h;class i extends h{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=i;class r extends v{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){!this.hasListeners()||(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const c={event:o,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const T=()=>{this.hasListeners&&this.unhook(c);const O=this.events.indexOf(c);this.events.splice(O,1)};return(0,D.toDisposable)((0,t.once)(T))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(c=>this.emitter.fire(c))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class s{constructor(){this.buffers=[]}wrapEvent(o){return(c,T,O)=>o(K=>{const re=this.buffers[this.buffers.length-1];re?re.push(()=>c.call(T,K)):c.call(T,K)},void 0,O)}bufferEvents(o){const c=[];this.buffers.push(c);const T=o();return this.buffers.pop(),c.forEach(O=>O()),T}}e.EventBufferer=s;class a{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=D.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(we[20],ye([1,0,7]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(C,E){const b=setTimeout(C.bind(E),0);return{dispose(){clearTimeout(b)}}});var D;(function(C){function E(b){return b===C.None||b===C.Cancelled||b instanceof I?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}C.isCancellationToken=E,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(we[141],ye([1,0,20]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new y.CancellationTokenSource,E=this.task(C.token);return this.result={promise:E,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=t;class D{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const E=JSON.stringify(C);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=D;class I{get cachedValues(){return this._map}constructor(C){this.fn=C,this._map=new Map}get(C){if(this._map.has(C))return this._map.get(C);const E=this.fn(C);return this._map.set(C,E),E}}e.CachedFunction=I}),define(we[89],ye([1,0,7,2]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=P=>({onDidChange:y.Event.None,value:P});e.staticObservableValue=D;class I extends t.Disposable{get value(){return this._value}set value(C){C!==this._value&&(this._value=C,this.changeEmitter.fire(C))}constructor(C){super(),this._value=C,this.changeEmitter=this._register(new y.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=I}),define(we[44],ye([1,0,8,2]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(l){const h=l;return h?typeof h.read=="function":!1}e.isReadable=D;function I(l){const h=l;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=I;function P(l){const h=l;return h?I(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=P;function C(l,h){return new E(l,h)}e.newWriteableStream=C;class E{constructor(h,i){this.reducer=h,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h<"u"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(i=>i(h))}emitError(h){this.listeners.error.length===0?(0,y.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(i=>i(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,i){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(h,i){if(this.state.destroyed)return;let r;switch(h){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(i);n>=0&&r.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(l,h){const i=[];let r;for(;(r=l.read())!==null;)i.push(r);return h(i)}e.consumeReadable=b;function k(l,h,i){const r=[];let n;for(;(n=l.read())!==null&&r.length<i;)r.push(n);return n===null&&r.length>0?h(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return l.read()}}}e.peekReadable=k;function R(l,h){return new Promise((i,r)=>{const n=[];S(l,{onData:s=>{h&&n.push(s)},onError:s=>{h?r(s):i(void 0)},onEnd:()=>{i(h?h(n):void 0)}})})}e.consumeStream=R;function S(l,h){let i=!1;return l.on("error",r=>{i||h.onError(r)}),l.on("end",()=>{i||h.onEnd()}),l.on("data",r=>{i||h.onData(r)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=S;function w(l,h){return new Promise((i,r)=>{const n=new t.DisposableStore,s=[],a=c=>{if(s.push(c),s.length>h)return n.dispose(),l.pause(),i({stream:l,buffer:s,ended:!1})},f=c=>r(c),o=()=>i({stream:l,buffer:s,ended:!0});n.add((0,t.toDisposable)(()=>l.removeListener("error",f))),l.on("error",f),n.add((0,t.toDisposable)(()=>l.removeListener("end",o))),l.on("end",o),n.add((0,t.toDisposable)(()=>l.removeListener("data",a))),l.on("data",a)})}e.peekStream=w;function d(l,h){const i=C(h);return i.end(l),i}e.toStream=d;function g(){const l=C(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=g;function v(l){let h=!1;return{read:()=>h?null:(h=!0,l)}}e.toReadable=v;function m(l,h,i){const r=C(i);return S(l,{onData:n=>r.write(h.data(n)),onError:n=>r.error(h.error?h.error(n):n),onEnd:()=>r.end()}),r}e.transform=m;function p(l,h,i){let r=!1;return{read:()=>{const n=h.read();return r?n:(r=!0,n!==null?i([l,n]):l)}}}e.prefixedReadable=p;function u(l,h,i){let r=!1;const n=C(i);return S(h,{onData:s=>r?n.write(s):(r=!0,n.write(i([l,s]))),onError:s=>n.error(s),onEnd:()=>{r||(r=!0,n.write(l)),n.end()}}),n}e.prefixedStream=u}),define(we[16],ye([1,0,44]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let D,I;class P{static alloc(c){return t?new P(Buffer.allocUnsafe(c)):new P(new Uint8Array(c))}static wrap(c){return t&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new P(c)}static fromString(c,T){return!(T?.dontUseNodeBuffer||!1)&&t?new P(Buffer.from(c)):(D||(D=new TextEncoder),new P(D.encode(c)))}static fromByteArray(c){const T=P.alloc(c.length);for(let O=0,K=c.length;O<K;O++)T.buffer[O]=c[O];return T}static concat(c,T){if(typeof T>"u"){T=0;for(let re=0,le=c.length;re<le;re++)T+=c[re].byteLength}const O=P.alloc(T);let K=0;for(let re=0,le=c.length;re<le;re++){const ae=c[re];O.set(ae,K),K+=ae.byteLength}return O}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=P.alloc(this.byteLength);return c.set(this),c}toString(){return t?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(c,T){return new P(this.buffer.subarray(c,T))}set(c,T){if(c instanceof P)this.buffer.set(c.buffer,T);else if(c instanceof Uint8Array)this.buffer.set(c,T);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),T);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return b(this.buffer,c)}writeUInt32BE(c,T){k(this.buffer,c,T)}readUInt32LE(c){return R(this.buffer,c)}writeUInt32LE(c,T){S(this.buffer,c,T)}readUInt8(c){return w(this.buffer,c)}writeUInt8(c,T){d(this.buffer,c,T)}}e.VSBuffer=P;function C(o,c){return o[c+0]<<0>>>0|o[c+1]<<8>>>0}e.readUInt16LE=C;function E(o,c,T){o[T+0]=c&255,c=c>>>8,o[T+1]=c&255}e.writeUInt16LE=E;function b(o,c){return o[c]*2**24+o[c+1]*2**16+o[c+2]*2**8+o[c+3]}e.readUInt32BE=b;function k(o,c,T){o[T+3]=c,c=c>>>8,o[T+2]=c,c=c>>>8,o[T+1]=c,c=c>>>8,o[T]=c}e.writeUInt32BE=k;function R(o,c){return o[c+0]<<0>>>0|o[c+1]<<8>>>0|o[c+2]<<16>>>0|o[c+3]<<24>>>0}e.readUInt32LE=R;function S(o,c,T){o[T+0]=c&255,c=c>>>8,o[T+1]=c&255,c=c>>>8,o[T+2]=c&255,c=c>>>8,o[T+3]=c&255}e.writeUInt32LE=S;function w(o,c){return o[c]}e.readUInt8=w;function d(o,c,T){o[T]=c}e.writeUInt8=d;function g(o){return y.consumeReadable(o,c=>P.concat(c))}e.readableToBuffer=g;function v(o){return y.toReadable(o)}e.bufferToReadable=v;function m(o){return y.consumeStream(o,c=>P.concat(c))}e.streamToBuffer=m;async function p(o){return o.ended?P.concat(o.buffer):P.concat([...o.buffer,await m(o.stream)])}e.bufferedStreamToBuffer=p;function u(o){return y.toStream(o,c=>P.concat(c))}e.bufferToStream=u;function l(o){return y.transform(o,{data:c=>typeof c=="string"?P.fromString(c):P.wrap(c)},c=>P.concat(c))}e.streamToBufferReadableStream=l;function h(o){return y.newWriteableStream(c=>P.concat(c),o)}e.newWriteableBufferStream=h;function i(o,c){return y.prefixedReadable(o,c,T=>P.concat(T))}e.prefixedBufferReadable=i;function r(o,c){return y.prefixedStream(o,c,T=>P.concat(T))}e.prefixedBufferStream=r;function n(o){let c=0,T=0,O=0;const K=new Uint8Array(Math.floor(o.length/4*3)),re=ae=>{switch(T){case 3:K[O++]=c|ae,T=0;break;case 2:K[O++]=c|ae>>>2,c=ae<<6,T=3;break;case 1:K[O++]=c|ae>>>4,c=ae<<4,T=2;break;default:c=ae<<2,T=1}};for(let ae=0;ae<o.length;ae++){const F=o.charCodeAt(ae);if(F>=65&&F<=90)re(F-65);else if(F>=97&&F<=122)re(F-97+26);else if(F>=48&&F<=57)re(F-48+52);else if(F===43||F===45)re(62);else if(F===47||F===95)re(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${o[ae]}`)}}const le=O;for(;T>0;)re(0);return P.wrap(K).slice(0,le)}e.decodeBase64=n;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:o},c=!0,T=!1){const O=T?a:s;let K="";const re=o.byteLength%3;let le=0;for(;le<o.byteLength-re;le+=3){const ae=o[le+0],F=o[le+1],Y=o[le+2];K+=O[ae>>>2],K+=O[(ae<<4|F>>>4)&63],K+=O[(F<<2|Y>>>6)&63],K+=O[Y&63]}if(re===1){const ae=o[le+0];K+=O[ae>>>2],K+=O[ae<<4&63],c&&(K+="==")}else if(re===2){const ae=o[le+0],F=o[le+1];K+=O[ae>>>2],K+=O[(ae<<4|F>>>4)&63],K+=O[F<<2&63],c&&(K+="=")}return K}e.encodeBase64=f}),define(we[15],ye([1,0,141,137]),function(oe,e,y,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function I(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=I;const P=/{(\d+)}/g;function C(ue,...De){return De.length===0?ue:ue.replace(P,function(Ce,Re){const Fe=parseInt(Re,10);return isNaN(Fe)||Fe<0||Fe>=De.length?Ce:De[Fe]})}e.format=C;const E=/{([^}]+)}/g;function b(ue,De){return ue.replace(E,(Ce,Re)=>De[Re]??Ce)}e.format2=b;function k(ue){return ue.replace(/[<>&]/g,function(De){switch(De){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return De}})}e.escape=k;function R(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function S(ue,De){let Ce=0;const Re=De.charCodeAt(0);for(let Fe=ue.length-1;Fe>=0;Fe--)ue.charCodeAt(Fe)===Re&&Ce++;return Ce}e.count=S;function w(ue,De,Ce="\u2026"){return ue.length<=De?ue:`${ue.substr(0,De)}${Ce}`}e.truncate=w;function d(ue,De=" "){const Ce=g(ue,De);return v(Ce,De)}e.trim=d;function g(ue,De){if(!ue||!De)return ue;const Ce=De.length;if(Ce===0||ue.length===0)return ue;let Re=0;for(;ue.indexOf(De,Re)===Re;)Re=Re+Ce;return ue.substring(Re)}e.ltrim=g;function v(ue,De){if(!ue||!De)return ue;const Ce=De.length,Re=ue.length;if(Ce===0||Re===0)return ue;let Fe=Re,$e=-1;for(;$e=ue.lastIndexOf(De,Fe-1),!($e===-1||$e+Ce!==Fe);){if($e===0)return"";Fe=$e}return ue.substring(0,Fe)}e.rtrim=v;function m(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function p(ue){return ue.replace(/\*/g,"")}e.stripWildcards=p;function u(ue,De,Ce={}){if(!ue)throw new Error("Cannot create regex from empty string");De||(ue=R(ue)),Ce.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Re="";return Ce.global&&(Re+="g"),Ce.matchCase||(Re+="i"),Ce.multiline&&(Re+="m"),Ce.unicode&&(Re+="u"),new RegExp(ue,Re)}e.createRegExp=u;function l(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function h(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function i(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=i;function r(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=r;function n(ue){for(let De=0,Ce=ue.length;De<Ce;De++){const Re=ue.charCodeAt(De);if(Re!==32&&Re!==9)return De}return-1}e.firstNonWhitespaceIndex=n;function s(ue,De=0,Ce=ue.length){for(let Re=De;Re<Ce;Re++){const Fe=ue.charCodeAt(Re);if(Fe!==32&&Fe!==9)return ue.substring(De,Re)}return ue.substring(De,Ce)}e.getLeadingWhitespace=s;function a(ue,De=ue.length-1){for(let Ce=De;Ce>=0;Ce--){const Re=ue.charCodeAt(Ce);if(Re!==32&&Re!==9)return Ce}return-1}e.lastNonWhitespaceIndex=a;function f(ue,De,Ce){const Re=[];let Fe=0;for(const $e of ue.matchAll(De)){if(Re.push(ue.slice(Fe,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");Fe=$e.index+$e[0].length,Re.push(Ce($e[0],...$e.slice(1),$e.index,ue,$e.groups))}return Re.push(ue.slice(Fe)),Promise.all(Re).then($e=>$e.join(""))}e.replaceAsync=f;function o(ue,De){return ue<De?-1:ue>De?1:0}e.compare=o;function c(ue,De,Ce=0,Re=ue.length,Fe=0,$e=De.length){for(;Ce<Re&&Fe<$e;Ce++,Fe++){const rt=ue.charCodeAt(Ce),et=De.charCodeAt(Fe);if(rt<et)return-1;if(rt>et)return 1}const qe=Re-Ce,nt=$e-Fe;return qe<nt?-1:qe>nt?1:0}e.compareSubstring=c;function T(ue,De){return O(ue,De,0,ue.length,0,De.length)}e.compareIgnoreCase=T;function O(ue,De,Ce=0,Re=ue.length,Fe=0,$e=De.length){for(;Ce<Re&&Fe<$e;Ce++,Fe++){let rt=ue.charCodeAt(Ce),et=De.charCodeAt(Fe);if(rt===et)continue;if(rt>=128||et>=128)return c(ue.toLowerCase(),De.toLowerCase(),Ce,Re,Fe,$e);re(rt)&&(rt-=32),re(et)&&(et-=32);const st=rt-et;if(st!==0)return st}const qe=Re-Ce,nt=$e-Fe;return qe<nt?-1:qe>nt?1:0}e.compareSubstringIgnoreCase=O;function K(ue){return ue>=48&&ue<=57}e.isAsciiDigit=K;function re(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=re;function le(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=le;function ae(ue,De){return ue.length===De.length&&O(ue,De)===0}e.equalsIgnoreCase=ae;function F(ue,De){const Ce=De.length;return De.length>ue.length?!1:O(ue,De,0,Ce)===0}e.startsWithIgnoreCase=F;function Y(ue,De){const Ce=Math.min(ue.length,De.length);let Re;for(Re=0;Re<Ce;Re++)if(ue.charCodeAt(Re)!==De.charCodeAt(Re))return Re;return Ce}e.commonPrefixLength=Y;function B(ue,De){const Ce=Math.min(ue.length,De.length);let Re;const Fe=ue.length-1,$e=De.length-1;for(Re=0;Re<Ce;Re++)if(ue.charCodeAt(Fe-Re)!==De.charCodeAt($e-Re))return Re;return Ce}e.commonSuffixLength=B;function H(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=H;function $(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=$;function j(ue,De){return(ue-55296<<10)+(De-56320)+65536}e.computeCodePoint=j;function L(ue,De,Ce){const Re=ue.charCodeAt(Ce);if(H(Re)&&Ce+1<De){const Fe=ue.charCodeAt(Ce+1);if($(Fe))return j(Re,Fe)}return Re}e.getNextCodePoint=L;function N(ue,De){const Ce=ue.charCodeAt(De-1);if($(Ce)&&De>1){const Re=ue.charCodeAt(De-2);if(H(Re))return j(Re,Ce)}return Ce}class q{get offset(){return this._offset}constructor(De,Ce=0){this._str=De,this._len=De.length,this._offset=Ce}setOffset(De){this._offset=De}prevCodePoint(){const De=N(this._str,this._offset);return this._offset-=De>=65536?2:1,De}nextCodePoint(){const De=L(this._str,this._len,this._offset);return this._offset+=De>=65536?2:1,De}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class se{get offset(){return this._iterator.offset}constructor(De,Ce=0){this._iterator=new q(De,Ce)}nextGraphemeLength(){const De=Ge.getInstance(),Ce=this._iterator,Re=Ce.offset;let Fe=De.getGraphemeBreakType(Ce.nextCodePoint());for(;!Ce.eol();){const $e=Ce.offset,qe=De.getGraphemeBreakType(Ce.nextCodePoint());if(Me(Fe,qe)){Ce.setOffset($e);break}Fe=qe}return Ce.offset-Re}prevGraphemeLength(){const De=Ge.getInstance(),Ce=this._iterator,Re=Ce.offset;let Fe=De.getGraphemeBreakType(Ce.prevCodePoint());for(;Ce.offset>0;){const $e=Ce.offset,qe=De.getGraphemeBreakType(Ce.prevCodePoint());if(Me(qe,Fe)){Ce.setOffset($e);break}Fe=qe}return Re-Ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=se;function he(ue,De){return new se(ue,De).nextGraphemeLength()}e.nextCharLength=he;function Z(ue,De){return new se(ue,De).prevGraphemeLength()}e.prevCharLength=Z;function ee(ue,De){De>0&&$(ue.charCodeAt(De))&&De--;const Ce=De+he(ue,De);return[Ce-Z(ue,Ce),Ce]}e.getCharContainingOffset=ee;function _(ue){const De=new se(ue);let Ce=0;for(;!De.eol();)Ce++,De.nextGraphemeLength();return Ce}e.charCount=_;let U;function te(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(ue){return U||(U=te()),U.test(ue)}e.containsRTL=ie;const fe=/^[\t\n\r\x20-\x7E]*$/;function ve(ue){return fe.test(ue)}e.isBasicASCII=ve,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=z;function Q(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=Q;function J(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=J;function W(ue,De){if(ue.length<De)return ue;const Ce=/\b/g;let Re=0;for(;Ce.test(ue)&&!(ue.length-Ce.lastIndex<De);)Re=Ce.lastIndex,Ce.lastIndex+=1;return ue.substring(Re).replace(/^\s/,"")}e.lcut=W;const V=/\x1B\x5B[12]?K/g,x=/\x1b\[\d+m/g,X=/\x1b\[0?m/g;function ce(ue){return ue&&(ue=ue.replace(V,""),ue=ue.replace(x,""),ue=ue.replace(X,"")),ue}e.removeAnsiEscapeCodes=ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function ke(ue){return pe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ke;function Te(ue,De){if(!ue||!De||ue.length<De.length)return!1;const Ce=De.length,Re=ue.toLowerCase();let Fe=0,$e=-1;for(;Fe<Ce;){const qe=Re.indexOf(De[Fe],$e+1);if(qe<0)return!1;$e=qe,Fe++}return!0}e.fuzzyContains=Te;function Ne(ue,De=!1){return ue?(De&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=Ne;function Oe(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Oe;function me(ue,De=1){if(De===0)return"";let Ce=-1;do Ce=ue.indexOf(`
`,Ce+1),De--;while(De>0&&Ce>=0);return Ce===-1?ue:(ue[Ce-1]==="\r"&&Ce--,ue.substr(0,Ce))}e.getNLines=me;function be(ue){return ue=ue%(2*26),ue<26?String.fromCharCode(97+ue):String.fromCharCode(65+ue-26)}e.singleLetterHash=be;function Ee(ue){return Ge.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Ee;function Me(ue,De){return ue===0?De!==5&&De!==7:ue===2&&De===3?!1:ue===4||ue===2||ue===3||De===4||De===2||De===3?!0:!(ue===8&&(De===8||De===9||De===11||De===12)||(ue===11||ue===9)&&(De===9||De===10)||(ue===12||ue===10)&&De===10||De===5||De===13||De===7||ue===1||ue===13&&De===14||ue===6&&De===6)}var Be;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(Be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ge{static getInstance(){return Ge._INSTANCE||(Ge._INSTANCE=new Ge),Ge._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(De){if(De<32)return De===10?3:De===13?2:4;if(De<127)return 0;const Ce=this._data,Re=Ce.length/3;let Fe=1;for(;Fe<=Re;)if(De<Ce[3*Fe])Fe=2*Fe;else if(De>Ce[3*Fe+1])Fe=2*Fe+1;else return Ce[3*Fe+2];return 0}}Ge._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ke(ue,De){if(ue===0)return 0;const Ce=xe(ue,De);if(Ce!==void 0)return Ce;const Re=new q(De,ue);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=Ke;function xe(ue,De){const Ce=new q(De,ue);let Re=Ce.prevCodePoint();for(;Ze(Re)||Re===65039||Re===8419;){if(Ce.offset===0)return;Re=Ce.prevCodePoint()}if(!J(Re))return;let Fe=Ce.offset;return Fe>0&&Ce.prevCodePoint()===8205&&(Fe=Ce.offset),Fe}function Ze(ue){return 127995<=ue&&ue<=127999}var Qe;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class He{static getInstance(De){return He.cache.get(Array.from(De))}static getLocales(){return He._locales.getValue()}constructor(De){this.confusableDictionary=De}isAmbiguous(De){return this.confusableDictionary.has(De)}getPrimaryConfusable(De){return this.confusableDictionary.get(De)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,D=He,He.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new y.LRUCachedFunction(ue=>{function De(et){const st=new Map;for(let lt=0;lt<et.length;lt+=2)st.set(et[lt],et[lt+1]);return st}function Ce(et,st){const lt=new Map(et);for(const[ft,ct]of st)lt.set(ft,ct);return lt}function Re(et,st){if(!et)return st;const lt=new Map;for(const[ft,ct]of et)st.has(ft)&&lt.set(ft,ct);return lt}const Fe=D.ambiguousCharacterData.getValue();let $e=ue.filter(et=>!et.startsWith("_")&&et in Fe);$e.length===0&&($e=["_default"]);let qe;for(const et of $e){const st=De(Fe[et]);qe=Re(qe,st)}const nt=De(Fe._common),rt=Ce(nt,qe);return new He(rt)}),He._locales=new t.Lazy(()=>Object.keys(He.ambiguousCharacterData.getValue()).filter(ue=>!ue.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(De){return je.getData().has(De)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(we[142],ye([1,0,31,15]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...x){return function(X,ce){for(let pe=0,ke=x.length;pe<ke;pe++){const Te=x[pe](X,ce);if(Te)return Te}return null}}e.or=D,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(x,X,ce){if(!ce||ce.length<X.length)return null;let pe;return x?pe=t.startsWithIgnoreCase(ce,X):pe=ce.indexOf(X)===0,pe?X.length>0?[{start:0,end:X.length}]:[]:null}function P(x,X){const ce=X.toLowerCase().indexOf(x.toLowerCase());return ce===-1?null:[{start:ce,end:ce+x.length}]}e.matchesContiguousSubString=P;function C(x,X){return E(x.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=C;function E(x,X,ce,pe){if(ce===x.length)return[];if(pe===X.length)return null;if(x[ce]===X[pe]){let ke=null;return(ke=E(x,X,ce+1,pe+1))?m({start:pe,end:pe+1},ke):null}return E(x,X,ce,pe+1)}function b(x){return 97<=x&&x<=122}function k(x){return 65<=x&&x<=90}e.isUpper=k;function R(x){return 48<=x&&x<=57}function S(x){return x===32||x===9||x===10||x===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(x=>w.add(x.charCodeAt(0)));function d(x){return S(x)||w.has(x)}function g(x,X){return x===X||d(x)&&d(X)}function v(x){return b(x)||k(x)||R(x)}function m(x,X){return X.length===0?X=[x]:x.end===X[0].start?X[0].start=x.start:X.unshift(x),X}function p(x,X){for(let ce=X;ce<x.length;ce++){const pe=x.charCodeAt(ce);if(k(pe)||R(pe)||ce>0&&!v(x.charCodeAt(ce-1)))return ce}return x.length}function u(x,X,ce,pe){if(ce===x.length)return[];if(pe===X.length)return null;if(x[ce]!==X[pe].toLowerCase())return null;{let ke=null,Te=pe+1;for(ke=u(x,X,ce+1,pe+1);!ke&&(Te=p(X,Te))<X.length;)ke=u(x,X,ce+1,Te),Te++;return ke===null?null:m({start:pe,end:pe+1},ke)}}function l(x){let X=0,ce=0,pe=0,ke=0,Te=0;for(let Ee=0;Ee<x.length;Ee++)Te=x.charCodeAt(Ee),k(Te)&&X++,b(Te)&&ce++,v(Te)&&pe++,R(Te)&&ke++;const Ne=X/x.length,Oe=ce/x.length,me=pe/x.length,be=ke/x.length;return{upperPercent:Ne,lowerPercent:Oe,alphaPercent:me,numericPercent:be}}function h(x){const{upperPercent:X,lowerPercent:ce}=x;return ce===0&&X>.6}function i(x){const{upperPercent:X,lowerPercent:ce,alphaPercent:pe,numericPercent:ke}=x;return ce>.2&&X<.8&&pe>.6&&ke<.2}function r(x){let X=0,ce=0,pe=0,ke=0;for(let Te=0;Te<x.length;Te++)pe=x.charCodeAt(Te),k(pe)&&X++,b(pe)&&ce++,S(pe)&&ke++;return(X===0||ce===0)&&ke===0?x.length<=30:X<=5}function n(x,X){if(!X||(X=X.trim(),X.length===0)||!r(x)||X.length>60)return null;const ce=l(X);if(!i(ce)){if(!h(ce))return null;X=X.toLowerCase()}let pe=null,ke=0;for(x=x.toLowerCase();ke<X.length&&(pe=u(x,X,0,ke))===null;)ke=p(X,ke+1);return pe}e.matchesCamelCase=n;function s(x,X,ce=!1){if(!X||X.length===0)return null;let pe=null,ke=0;for(x=x.toLowerCase(),X=X.toLowerCase();ke<X.length&&(pe=a(x,X,0,ke,ce))===null;)ke=f(X,ke+1);return pe}e.matchesWords=s;function a(x,X,ce,pe,ke){if(ce===x.length)return[];if(pe===X.length)return null;if(g(x.charCodeAt(ce),X.charCodeAt(pe))){let Te=null,Ne=pe+1;if(Te=a(x,X,ce+1,pe+1,ke),!ke)for(;!Te&&(Ne=f(X,Ne))<X.length;)Te=a(x,X,ce+1,Ne,ke),Ne++;return Te?x.charCodeAt(ce)!==X.charCodeAt(pe)?Te:m({start:pe,end:pe+1},Te):null}else return null}function f(x,X){for(let ce=X;ce<x.length;ce++)if(d(x.charCodeAt(ce))||ce>0&&d(x.charCodeAt(ce-1)))return ce;return x.length}const o=D(e.matchesPrefix,n,P),c=D(e.matchesPrefix,n,C),T=new y.LRUCache(1e4);function O(x,X,ce=!1){if(typeof x!="string"||typeof X!="string")return null;let pe=T.get(x);pe||(pe=new RegExp(t.convertSimple2RegExpPattern(x),"i"),T.set(x,pe));const ke=pe.exec(X);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:ce?c(x,X):o(x,X)}e.matchesFuzzy=O;function K(x,X){const ce=fe(x,x.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ce?le(ce):null}e.matchesFuzzy2=K;function re(x,X,ce,pe,ke,Te){const Ne=Math.min(13,x.length);for(;ce<Ne;ce++){const Oe=fe(x,X,ce,pe,ke,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Oe)return Oe}return[0,Te]}e.anyScore=re;function le(x){if(typeof x>"u")return[];const X=[],ce=x[1];for(let pe=x.length-1;pe>1;pe--){const ke=x[pe]+ce,Te=X[X.length-1];Te&&Te.end===ke?Te.end=ke+1:X.push({start:ke,end:ke+1})}return X}e.createMatches=le;const ae=128;function F(){const x=[],X=[];for(let ce=0;ce<=ae;ce++)X[ce]=0;for(let ce=0;ce<=ae;ce++)x.push(X.slice(0));return x}function Y(x){const X=[];for(let ce=0;ce<=x;ce++)X[ce]=0;return X}const B=Y(2*ae),H=Y(2*ae),$=F(),j=F(),L=F(),N=!1;function q(x,X,ce,pe,ke){function Te(Oe,me,be=" "){for(;Oe.length<me;)Oe=be+Oe;return Oe}let Ne=` |   |${pe.split("").map(Oe=>Te(Oe,3)).join("|")}
`;for(let Oe=0;Oe<=ce;Oe++)Oe===0?Ne+=" |":Ne+=`${X[Oe-1]}|`,Ne+=x[Oe].slice(0,ke+1).map(me=>Te(me.toString(),3)).join("|")+`
`;return Ne}function se(x,X,ce,pe){x=x.substr(X),ce=ce.substr(pe),console.log(q(j,x,x.length,ce,ce.length)),console.log(q(L,x,x.length,ce,ce.length)),console.log(q($,x,x.length,ce,ce.length))}function he(x,X){if(X<0||X>=x.length)return!1;const ce=x.codePointAt(X);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(ce)}}function Z(x,X){if(X<0||X>=x.length)return!1;switch(x.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function ee(x,X,ce){return X[x]!==ce[x]}function _(x,X,ce,pe,ke,Te,Ne=!1){for(;X<ce&&ke<Te;)x[X]===pe[ke]&&(Ne&&(B[X]=ke),X+=1),ke+=1;return X===ce}e.isPatternInWord=_;var U;(function(x){x[x.Diag=1]="Diag",x[x.Left=2]="Left",x[x.LeftLeft=3]="LeftLeft"})(U||(U={}));var te;(function(x){x.Default=[-100,0];function X(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}x.isDefault=X})(te=e.FuzzyScore||(e.FuzzyScore={}));class ie{constructor(X,ce){this.firstMatchCanBeWeak=X,this.boostFullMatch=ce}}e.FuzzyScoreOptions=ie,ie.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function fe(x,X,ce,pe,ke,Te,Ne=ie.default){const Oe=x.length>ae?ae:x.length,me=pe.length>ae?ae:pe.length;if(ce>=Oe||Te>=me||Oe-ce>me-Te||!_(X,ce,Oe,ke,Te,me,!0))return;ve(Oe,me,ce,Te,X,ke);let be=1,Ee=1,Me=ce,Be=Te;const Ge=[!1];for(be=1,Me=ce;Me<Oe;be++,Me++){const Qe=B[Me],He=H[Me],je=Me+1<Oe?H[Me+1]:me;for(Ee=Qe-Te+1,Be=Qe;Be<je;Ee++,Be++){let ue=Number.MIN_SAFE_INTEGER,De=!1;Be<=He&&(ue=z(x,X,Me,ce,pe,ke,Be,me,Te,$[be-1][Ee-1]===0,Ge));let Ce=0;ue!==Number.MAX_SAFE_INTEGER&&(De=!0,Ce=ue+j[be-1][Ee-1]);const Re=Be>Qe,Fe=Re?j[be][Ee-1]+($[be][Ee-1]>0?-5:0):0,$e=Be>Qe+1&&$[be][Ee-1]>0,qe=$e?j[be][Ee-2]+($[be][Ee-2]>0?-5:0):0;if($e&&(!Re||qe>=Fe)&&(!De||qe>=Ce))j[be][Ee]=qe,L[be][Ee]=3,$[be][Ee]=0;else if(Re&&(!De||Fe>=Ce))j[be][Ee]=Fe,L[be][Ee]=2,$[be][Ee]=0;else if(De)j[be][Ee]=Ce,L[be][Ee]=1,$[be][Ee]=$[be-1][Ee-1]+1;else throw new Error("not possible")}}if(N&&se(x,ce,pe,Te),!Ge[0]&&!Ne.firstMatchCanBeWeak)return;be--,Ee--;const ze=[j[be][Ee],Te];let Ke=0,xe=0;for(;be>=1;){let Qe=Ee;do{const He=L[be][Qe];if(He===3)Qe=Qe-2;else if(He===2)Qe=Qe-1;else break}while(Qe>=1);Ke>1&&X[ce+be-1]===ke[Te+Ee-1]&&!ee(Qe+Te-1,pe,ke)&&Ke+1>$[be][Qe]&&(Qe=Ee),Qe===Ee?Ke++:Ke=1,xe||(xe=Qe),be--,Ee=Qe-1,ze.push(Ee)}me===Oe&&Ne.boostFullMatch&&(ze[0]+=2);const Ze=xe-Oe;return ze[0]-=Ze,ze}e.fuzzyScore=fe;function ve(x,X,ce,pe,ke,Te){let Ne=x-1,Oe=X-1;for(;Ne>=ce&&Oe>=pe;)ke[Ne]===Te[Oe]&&(H[Ne]=Oe,Ne--),Oe--}function z(x,X,ce,pe,ke,Te,Ne,Oe,me,be,Ee){if(X[ce]!==Te[Ne])return Number.MIN_SAFE_INTEGER;let Me=1,Be=!1;return Ne===ce-pe?Me=x[ce]===ke[Ne]?7:5:ee(Ne,ke,Te)&&(Ne===0||!ee(Ne-1,ke,Te))?(Me=x[ce]===ke[Ne]?7:5,Be=!0):he(Te,Ne)&&(Ne===0||!he(Te,Ne-1))?Me=5:(he(Te,Ne-1)||Z(Te,Ne-1))&&(Me=5,Be=!0),Me>1&&ce===pe&&(Ee[0]=!0),Be||(Be=ee(Ne,ke,Te)||he(Te,Ne-1)||Z(Te,Ne-1)),ce===pe?Ne>me&&(Me-=Be?3:5):be?Me+=Be?2:0:Me+=Be?0:1,Ne+1===Oe&&(Me-=Be?3:5),Me}function Q(x,X,ce,pe,ke,Te,Ne){return W(x,X,ce,pe,ke,Te,!0,Ne)}e.fuzzyScoreGracefulAggressive=Q;function J(x,X,ce,pe,ke,Te,Ne){return W(x,X,ce,pe,ke,Te,!1,Ne)}e.fuzzyScoreGraceful=J;function W(x,X,ce,pe,ke,Te,Ne,Oe){let me=fe(x,X,ce,pe,ke,Te,Oe);if(me&&!Ne)return me;if(x.length>=3){const be=Math.min(7,x.length-1);for(let Ee=ce+1;Ee<be;Ee++){const Me=V(x,Ee);if(Me){const Be=fe(Me,Me.toLowerCase(),ce,pe,ke,Te,Oe);Be&&(Be[0]-=3,(!me||Be[0]>me[0])&&(me=Be))}}}return me}function V(x,X){if(X+1>=x.length)return;const ce=x[X],pe=x[X+1];if(ce!==pe)return x.slice(0,X)+pe+ce+x.slice(X+2)}}),define(we[90],ye([1,0,15]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return D(m,0)}e.hash=t;function D(m,p){switch(typeof m){case"object":return m===null?I(349,p):Array.isArray(m)?E(m,p):b(m,p);case"string":return C(m,p);case"boolean":return P(m,p);case"number":return I(m,p);case"undefined":return I(937,p);default:return I(617,p)}}e.doHash=D;function I(m,p){return(p<<5)-p+m|0}e.numberHash=I;function P(m,p){return I(m?433:863,p)}function C(m,p){p=I(149417,p);for(let u=0,l=m.length;u<l;u++)p=I(m.charCodeAt(u),p);return p}e.stringHash=C;function E(m,p){return p=I(104579,p),m.reduce((u,l)=>D(l,u),p)}function b(m,p){return p=I(181387,p),Object.keys(m).sort().reduce((u,l)=>(u=C(l,u),D(m[l],u)),p)}class k{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=D(p,this._value),this._value}}e.Hasher=k;var R;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function S(m,p,u=32){const l=u-p,h=~((1<<l)-1);return(m<<p|(h&m)>>>l)>>>0}function w(m,p=0,u=m.byteLength,l=0){for(let h=0;h<u;h++)m[p+h]=l}function d(m,p,u="0"){for(;m.length<p;)m=u+m;return m}function g(m,p=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),p/4)}e.toHexString=g;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const u=p.length;if(u===0)return;const l=this._buff;let h=this._buffLen,i=this._leftoverHighSurrogate,r,n;for(i!==0?(r=i,n=-1,i=0):(r=p.charCodeAt(0),n=0);;){let s=r;if(y.isHighSurrogate(r))if(n+1<u){const a=p.charCodeAt(n+1);y.isLowSurrogate(a)?(n++,s=y.computeCodePoint(r,a)):s=65533}else{i=r;break}else y.isLowSurrogate(r)&&(s=65533);if(h=this._push(l,h,s),n++,n<u)r=p.charCodeAt(n);else break}this._buffLen=h,this._leftoverHighSurrogate=i}_push(p,u,l){return l<128?p[u++]=l:l<2048?(p[u++]=192|(l&1984)>>>6,p[u++]=128|(l&63)>>>0):l<65536?(p[u++]=224|(l&61440)>>>12,p[u++]=128|(l&4032)>>>6,p[u++]=128|(l&63)>>>0):(p[u++]=240|(l&1835008)>>>18,p[u++]=128|(l&258048)>>>12,p[u++]=128|(l&4032)>>>6,p[u++]=128|(l&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=v._bigBlock32,u=this._buffDV;for(let o=0;o<64;o+=4)p.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)p.setUint32(o,S(p.getUint32(o-12,!1)^p.getUint32(o-32,!1)^p.getUint32(o-56,!1)^p.getUint32(o-64,!1),1),!1);let l=this._h0,h=this._h1,i=this._h2,r=this._h3,n=this._h4,s,a,f;for(let o=0;o<80;o++)o<20?(s=h&i|~h&r,a=1518500249):o<40?(s=h^i^r,a=1859775393):o<60?(s=h&i|h&r|i&r,a=2400959708):(s=h^i^r,a=3395469782),f=S(l,5)+s+n+a+p.getUint32(o*4,!1)&4294967295,n=r,r=i,i=S(h,30),h=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[143],ye([1,0,41,142,15]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(y.CSSIcon.iconNameCharacter),C=new RegExp(`(\\\\)?${I.source}`,"g");function E(v){return v.replace(C,(m,p)=>p?m:`\\${m}`)}e.escapeIcons=E;const b=new RegExp(`\\\\${I.source}`,"g");function k(v){return v.replace(b,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=k;const R=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function S(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(R,(m,p,u,l)=>u?m:p||l||"")}e.stripIcons=S;function w(v){const m=v.indexOf(e.iconStartMarker);return m===-1?{text:v}:d(v,m)}e.parseLabelWithIcons=w;function d(v,m){const p=[];let u="";function l(o){if(o){u+=o;for(const c of o)p.push(r)}}let h=-1,i="",r=0,n,s,a=m;const f=v.length;for(l(v.substr(0,m));a<f;)n=v[a],s=v[a+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=a,l(i),i=e.iconStartMarker,a++):n===")"&&h!==-1?(r+=a-h+1,h=-1,i=""):h!==-1?P.test(n)?i+=n:(l(i),h=-1,i=""):l(n),a++;return l(i),{text:u,iconOffsets:p}}function g(v,m,p=!1){const{text:u,iconOffsets:l}=m;if(!l||l.length===0)return(0,t.matchesFuzzy)(v,u,p);const h=(0,D.ltrim)(u," "),i=u.length-h.length,r=(0,t.matchesFuzzy)(v,h,p);if(r)for(const n of r){const s=l[n.start+i]+i;n.start+=s,n.end+=s}return r}e.matchesFuzzyIconAware=g}),define(we[69],ye([1,0,15]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const I="error",P="warning",C="warn",E="info",b="ignore";function k(S){return S?y.equalsIgnoreCase(I,S)?D.Error:y.equalsIgnoreCase(P,S)||y.equalsIgnoreCase(C,S)?D.Warning:y.equalsIgnoreCase(E,S)?D.Info:D.Ignore:D.Ignore}D.fromValue=k;function R(S){switch(S){case D.Error:return I;case D.Warning:return P;case D.Info:return E;default:return b}}D.toString=R}(t||(t={})),e.default=t}),define(we[57],ye([1,0,18,15]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this._value="",this._pos=0}reset(w){return this._value=w,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(w){const d=w.charCodeAt(0),g=this._value.charCodeAt(this._pos);return d-g}value(){return this._value[this._pos]}}e.StringIterator=D;class I{constructor(w=!0){this._caseSensitive=w}reset(w){return this._value=w,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let w=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(w)this._from++;else break;else w=!1;return this}cmp(w){return this._caseSensitive?(0,t.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class P{constructor(w=!0,d=!0){this._splitOnBackslash=w,this._caseSensitive=d}reset(w){this._from=0,this._to=0,this._value=w,this._valueLen=w.length;for(let d=w.length-1;d>=0;d--,this._valueLen--){const g=this._value.charCodeAt(d);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let w=!0;for(;this._to<this._valueLen;this._to++){const d=this._value.charCodeAt(this._to);if(d===47||this._splitOnBackslash&&d===92)if(w)this._from++;else break;else w=!1}return this}cmp(w){return this._caseSensitive?(0,t.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var C;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(C||(C={}));class E{constructor(w,d){this._ignorePathCasing=w,this._ignoreQueryAndFragment=d,this._states=[],this._stateIdx=0}reset(w){return this._value=w,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(w)),this._pathIterator.reset(w.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(w)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(w){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(w,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(w,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(w);if(this._states[this._stateIdx]===4)return(0,t.compare)(w,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(w,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var k;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(k||(k={}));class R{static forUris(w=()=>!1,d=()=>!1){return new R(new E(w,d))}static forPaths(w=!1){return new R(new P(void 0,!w))}static forStrings(){return new R(new D)}static forConfigKeys(){return new R(new I)}constructor(w){this._iter=w}clear(){this._root=void 0}fill(w,d){if(d){const g=d.slice(0);(0,y.shuffle)(g);for(const v of g)this.set(v,w)}else{const g=w.slice(0);(0,y.shuffle)(g);for(const v of g)this.set(v[0],v[1])}}set(w,d){const g=this._iter.reset(w);let v;this._root||(this._root=new b,this._root.segment=g.value());const m=[];for(v=this._root;;){const u=g.cmp(v.segment);if(u>0)v.left||(v.left=new b,v.left.segment=g.value()),m.push([-1,v]),v=v.left;else if(u<0)v.right||(v.right=new b,v.right.segment=g.value()),m.push([1,v]),v=v.right;else if(g.hasNext())g.next(),v.mid||(v.mid=new b,v.mid.segment=g.value()),m.push([0,v]),v=v.mid;else break}const p=v.value;v.value=d,v.key=w;for(let u=m.length-1;u>=0;u--){const l=m[u][1];l.updateHeight();const h=l.balanceFactor();if(h<-1||h>1){const i=m[u][0],r=m[u+1][0];if(i===1&&r===1)m[u][1]=l.rotateLeft();else if(i===-1&&r===-1)m[u][1]=l.rotateRight();else if(i===1&&r===-1)l.right=m[u+1][1]=m[u+1][1].rotateRight(),m[u][1]=l.rotateLeft();else if(i===-1&&r===1)l.left=m[u+1][1]=m[u+1][1].rotateLeft(),m[u][1]=l.rotateRight();else throw new Error;if(u>0)switch(m[u-1][0]){case-1:m[u-1][1].left=m[u][1];break;case 1:m[u-1][1].right=m[u][1];break;case 0:m[u-1][1].mid=m[u][1];break}else this._root=m[0][1]}}return p}get(w){return this._getNode(w)?.value}_getNode(w){const d=this._iter.reset(w);let g=this._root;for(;g;){const v=d.cmp(g.segment);if(v>0)g=g.left;else if(v<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else break}return g}has(w){const d=this._getNode(w);return!(d?.value===void 0&&d?.mid===void 0)}delete(w){return this._delete(w,!1)}deleteSuperstr(w){return this._delete(w,!0)}_delete(w,d){const g=this._iter.reset(w),v=[];let m=this._root;for(;m;){const p=g.cmp(m.segment);if(p>0)v.push([-1,m]),m=m.left;else if(p<0)v.push([1,m]),m=m.right;else if(g.hasNext())g.next(),v.push([0,m]),m=m.mid;else break}if(!!m){if(d?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const p=this._min(m.right);if(p.key){const{key:u,value:l,segment:h}=p;this._delete(p.key,!1),m.key=u,m.value=l,m.segment=h}}else{const p=m.left??m.right;if(v.length>0){const[u,l]=v[v.length-1];switch(u){case-1:l.left=p;break;case 0:l.mid=p;break;case 1:l.right=p;break}}else this._root=p}for(let p=v.length-1;p>=0;p--){const u=v[p][1];u.updateHeight();const l=u.balanceFactor();if(l>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),v[p][1]=u.rotateLeft()):l<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),v[p][1]=u.rotateRight()),p>0)switch(v[p-1][0]){case-1:v[p-1][1].left=v[p][1];break;case 1:v[p-1][1].right=v[p][1];break;case 0:v[p-1][1].mid=v[p][1];break}else this._root=v[0][1]}}}_min(w){for(;w.left;)w=w.left;return w}findSubstr(w){const d=this._iter.reset(w);let g=this._root,v;for(;g;){const m=d.cmp(g.segment);if(m>0)g=g.left;else if(m<0)g=g.right;else if(d.hasNext())d.next(),v=g.value||v,g=g.mid;else break}return g&&g.value||v}findSuperstr(w){const d=this._iter.reset(w);let g=this._root;for(;g;){const v=d.cmp(g.segment);if(v>0)g=g.left;else if(v<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(w){for(const[d,g]of this)w(g,d)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(w){const d=[];return this._dfsEntries(w,d),d[Symbol.iterator]()}_dfsEntries(w,d){!w||(w.left&&this._dfsEntries(w.left,d),w.value&&d.push([w.key,w.value]),w.mid&&this._dfsEntries(w.mid,d),w.right&&this._dfsEntries(w.right,d))}_isBalanced(){const w=d=>{if(!d)return!0;const g=d.balanceFactor();return g<-1||g>1?!1:w(d.left)&&w(d.right)};return w(this._root)}}e.TernarySearchTree=R}),define(we[13],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function y(r){return typeof r=="string"}e.isString=y;function t(r){return Array.isArray(r)&&r.every(n=>y(n))}e.isStringArray=t;function D(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=D;function I(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=I;function P(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=P;function C(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=C;function E(r){return r===!0||r===!1}e.isBoolean=E;function b(r){return typeof r>"u"}e.isUndefined=b;function k(r){return!R(r)}e.isDefined=k;function R(r){return b(r)||r===null}e.isUndefinedOrNull=R;function S(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=S;function w(r){if(R(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=w;function d(...r){const n=[];for(let s=0;s<r.length;s++){const a=r[s];if(R(a))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(a)}return n}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function v(r){if(!D(r))return!1;for(const n in r)if(g.call(r,n))return!1;return!0}e.isEmptyObject=v;function m(r){return typeof r=="function"}e.isFunction=m;function p(...r){return r.length>0&&r.every(m)}e.areFunctions=p;function u(r,n){const s=Math.min(r.length,n.length);for(let a=0;a<s;a++)l(r[a],n[a])}e.validateConstraints=u;function l(r,n){if(y(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(m(n)){try{if(r instanceof n)return}catch{}if(!R(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function h(r){return r===null?void 0:r}e.withNullAsUndefined=h;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(we[36],ye([1,0,6,3,15,13]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(a){return a===47||a===92}e.isPathSeparator=P;function C(a){return a.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=C;function E(a){return a.indexOf("/")===-1&&(a=C(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=E;function b(a,f=y.posix.sep){if(!a)return"";const o=a.length,c=a.charCodeAt(0);if(P(c)){if(P(a.charCodeAt(1))&&!P(a.charCodeAt(2))){let O=3;const K=O;for(;O<o&&!P(a.charCodeAt(O));O++);if(K!==O&&!P(a.charCodeAt(O+1))){for(O+=1;O<o;O++)if(P(a.charCodeAt(O)))return a.slice(0,O+1).replace(/[\\/]/g,f)}}return f}else if(m(c)&&a.charCodeAt(1)===58)return P(a.charCodeAt(2))?a.slice(0,2)+f:a.slice(0,2);let T=a.indexOf("://");if(T!==-1){for(T+=3;T<o;T++)if(P(a.charCodeAt(T)))return a.slice(0,T+1)}return""}e.getRoot=b;function k(a){if(!t.isWindows||!a||a.length<5)return!1;let f=a.charCodeAt(0);if(f!==92||(f=a.charCodeAt(1),f!==92))return!1;let o=2;const c=o;for(;o<a.length&&(f=a.charCodeAt(o),f!==92);o++);return!(c===o||(f=a.charCodeAt(o+1),isNaN(f)||f===92))}e.isUNC=k;const R=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(a,f=t.isWindows){const o=f?R:S;return!(!a||a.length===0||/^\s+$/.test(a)||(o.lastIndex=0,o.test(a))||f&&w.test(a)||a==="."||a===".."||f&&a[a.length-1]==="."||f&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=d;function g(a,f,o){const c=a===f;return!o||c?c:!a||!f?!1:(0,D.equalsIgnoreCase)(a,f)}e.isEqual=g;function v(a,f,o,c=y.sep){if(a===f)return!0;if(!a||!f||f.length>a.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(a,f))return!1;if(f.length===a.length)return!0;let O=f.length;return f.charAt(f.length-1)===c&&O--,a.charAt(O)===c}return f.charAt(f.length-1)!==c&&(f+=c),a.indexOf(f)===0}e.isEqualOrParent=v;function m(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=m;function p(a,f){return t.isWindows&&a.endsWith(":")&&(a+=y.sep),(0,y.isAbsolute)(a)||(a=(0,y.join)(f,a)),a=(0,y.normalize)(a),t.isWindows?(a=(0,D.rtrim)(a,y.sep),a.endsWith(":")&&(a+=y.sep)):(a=(0,D.rtrim)(a,y.sep),a||(a=y.sep)),a}e.sanitizeFilePath=p;function u(a){const f=(0,y.normalize)(a);return t.isWindows?a.length>3?!1:l(f)&&(a.length===2||f.charCodeAt(2)===92):f===y.posix.sep}e.isRootOrDriveLetter=u;function l(a,f=t.isWindows){return f?m(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function h(a){return l(a)?a[0]:void 0}e.getDriveLetter=h;function i(a,f,o){return f.length>a.length?-1:a===f?0:(o&&(a=a.toLowerCase(),f=f.toLowerCase()),a.indexOf(f))}e.indexOfPath=i;function r(a){const f=a.split(":");let o,c,T;for(const O of f){const K=Number(O);(0,I.isNumber)(K)?c===void 0?c=K:T===void 0&&(T=K):o=o?[o,O].join(":"):O}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:c!==void 0?c:void 0,column:T!==void 0?T:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(a,f,o=8){let c="";for(let O=0;O<o;O++)c+=n.charAt(Math.floor(Math.random()*n.length));let T;return f?T=`${f}-${c}`:T=c,a?(0,y.join)(a,T):T}e.randomPath=s}),define(we[23],ye([1,0,13]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const p=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([u,l])=>{p[u]=l&&typeof l=="object"?t(l):l}),p}e.deepClone=t;function D(m){if(!m||typeof m!="object")return m;const p=[m];for(;p.length>0;){const u=p.shift();Object.freeze(u);for(const l in u)if(I.call(u,l)){const h=u[l];typeof h=="object"&&!Object.isFrozen(h)&&!(0,y.isTypedArray)(h)&&p.push(h)}}return m}e.deepFreeze=D;const I=Object.prototype.hasOwnProperty;function P(m,p){return C(m,p,new Set)}e.cloneAndChange=P;function C(m,p,u){if((0,y.isUndefinedOrNull)(m))return m;const l=p(m);if(typeof l<"u")return l;if(Array.isArray(m)){const h=[];for(const i of m)h.push(C(i,p,u));return h}if((0,y.isObject)(m)){if(u.has(m))throw new Error("Cannot clone recursive data-structure");u.add(m);const h={};for(const i in m)I.call(m,i)&&(h[i]=C(m[i],p,u));return u.delete(m),h}return m}function E(m,p,u=!0){return(0,y.isObject)(m)?((0,y.isObject)(p)&&Object.keys(p).forEach(l=>{l in m?u&&((0,y.isObject)(m[l])&&(0,y.isObject)(p[l])?E(m[l],p[l],u):m[l]=p[l]):m[l]=p[l]}),m):p}e.mixin=E;function b(m,p){if(m===p)return!0;if(m==null||p===null||p===void 0||typeof m!=typeof p||typeof m!="object"||Array.isArray(m)!==Array.isArray(p))return!1;let u,l;if(Array.isArray(m)){if(m.length!==p.length)return!1;for(u=0;u<m.length;u++)if(!b(m[u],p[u]))return!1}else{const h=[];for(l in m)h.push(l);h.sort();const i=[];for(l in p)i.push(l);if(i.sort(),!b(h,i))return!1;for(u=0;u<h.length;u++)if(!b(m[h[u]],p[h[u]]))return!1}return!0}e.equals=b;function k(m){const p=new Set;return JSON.stringify(m,(u,l)=>{if((0,y.isObject)(l)||Array.isArray(l)){if(p.has(l))return"[Circular]";p.add(l)}return l})}e.safeStringify=k;function R(m,p){const u=Object.create(null);return!m||!p||Object.keys(p).forEach(h=>{const i=m[h],r=p[h];b(i,r)||(u[h]=r)}),u}e.distinct=R;function S(m,p){const u=p.toLowerCase(),l=Object.keys(m).find(h=>h.toLowerCase()===u);return l?m[l]:m[p]}e.getCaseInsensitive=S;function w(m,p){const u=Object.create(null);for(const[l,h]of Object.entries(m))p(l,h)&&(u[l]=h);return u}e.filter=w;function d(m){let p=[],u=Object.getPrototypeOf(m);for(;Object.prototype!==u;)p=p.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return p}e.getAllPropertyNames=d;function g(m){const p=[];for(const u of d(m))typeof m[u]=="function"&&p.push(u);return p}e.getAllMethodNames=g;function v(m,p){const u=h=>function(){const i=Array.prototype.slice.call(arguments,0);return p(h,i)},l={};for(const h of m)l[h]=u(h);return l}e.createProxyObject=v}),define(we[4],ye([1,0,6,3]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,I=/^\//,P=/^\/\//;function C(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!I.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(n,s){return!n&&!s?"file":n}function b(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==R&&(s=R+s):s=R;break}return s}const k="",R="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(s){return s instanceof w?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,a,f,o,c,T=!1){typeof s=="object"?(this.scheme=s.scheme||k,this.authority=s.authority||k,this.path=s.path||k,this.query=s.query||k,this.fragment=s.fragment||k):(this.scheme=E(s,T),this.authority=a||k,this.path=b(this.scheme,f||k),this.query=o||k,this.fragment=c||k,C(this,T))}get fsPath(){return u(this,!1)}with(s){if(!s)return this;let{scheme:a,authority:f,path:o,query:c,fragment:T}=s;return a===void 0?a=this.scheme:a===null&&(a=k),f===void 0?f=this.authority:f===null&&(f=k),o===void 0?o=this.path:o===null&&(o=k),c===void 0?c=this.query:c===null&&(c=k),T===void 0?T=this.fragment:T===null&&(T=k),a===this.scheme&&f===this.authority&&o===this.path&&c===this.query&&T===this.fragment?this:new g(a,f,o,c,T)}static parse(s,a=!1){const f=S.exec(s);return f?new g(f[2]||k,r(f[4]||k),r(f[5]||k),r(f[7]||k),r(f[9]||k),a):new g(k,k,k,k,k)}static file(s){let a=k;if(t.isWindows&&(s=s.replace(/\\/g,R)),s[0]===R&&s[1]===R){const f=s.indexOf(R,2);f===-1?(a=s.substring(2),s=R):(a=s.substring(2,f),s=s.substring(f)||R)}return new g("file",a,s,k,k)}static from(s){const a=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return C(a,!0),a}static joinPath(s,...a){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return t.isWindows&&s.scheme==="file"?f=w.file(y.win32.join(u(s,!0),...a)).path:f=y.posix.join(s.path,...a),s.with({path:f})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof w)return s;{const a=new g(s);return a._formatted=s.external,a._fsPath=s._sep===d?s.fsPath:null,a}}else return s}}e.URI=w;const d=t.isWindows?1:void 0;class g extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,s){let a,f=-1;for(let o=0;o<n.length;o++){const c=n.charCodeAt(o);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||s&&c===47)f!==-1&&(a+=encodeURIComponent(n.substring(f,o)),f=-1),a!==void 0&&(a+=n.charAt(o));else{a===void 0&&(a=n.substr(0,o));const T=v[c];T!==void 0?(f!==-1&&(a+=encodeURIComponent(n.substring(f,o)),f=-1),a+=T):f===-1&&(f=o)}}return f!==-1&&(a+=encodeURIComponent(n.substring(f))),a!==void 0?a:n}function p(n){let s;for(let a=0;a<n.length;a++){const f=n.charCodeAt(a);f===35||f===63?(s===void 0&&(s=n.substr(0,a)),s+=v[f]):s!==void 0&&(s+=n[a])}return s!==void 0?s:n}function u(n,s){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function l(n,s){const a=s?p:m;let f="",{scheme:o,authority:c,path:T,query:O,fragment:K}=n;if(o&&(f+=o,f+=":"),(c||o==="file")&&(f+=R,f+=R),c){let re=c.indexOf("@");if(re!==-1){const le=c.substr(0,re);c=c.substr(re+1),re=le.indexOf(":"),re===-1?f+=a(le,!1):(f+=a(le.substr(0,re),!1),f+=":",f+=a(le.substr(re+1),!1)),f+="@"}c=c.toLowerCase(),re=c.indexOf(":"),re===-1?f+=a(c,!1):(f+=a(c.substr(0,re),!1),f+=c.substr(re))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const re=T.charCodeAt(1);re>=65&&re<=90&&(T=`/${String.fromCharCode(re+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const re=T.charCodeAt(0);re>=65&&re<=90&&(T=`${String.fromCharCode(re+32)}:${T.substr(2)}`)}f+=a(T,!0)}return O&&(f+="?",f+=a(O,!1)),K&&(f+="#",f+=s?K:m(K,!1)),f}function h(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+h(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(i)?n.replace(i,s=>h(s)):n}}),define(we[144],ye([1,0,4]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(b){const k=b;return k&&typeof k.type=="string"&&typeof k.severity=="string"}e.isRemoteConsoleLog=t;function D(b){const k=[];let R;try{const S=JSON.parse(b.arguments),w=S[S.length-1];w&&w.__$stack&&(S.pop(),R=w.__$stack),k.push(...S)}catch{k.push("Unable to log remote console arguments",b.arguments)}return{args:k,stack:R}}e.parse=D;function I(b){if(typeof b!="string")return I(D(b).stack);const k=b;if(k){const R=P(k),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(S&&S.length===4)return{uri:y.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=I;function P(b){if(!b)return b;const k=b.indexOf(`
`);return k===-1?b:b.substring(0,k)}function C(b,k){const{args:R,stack:S}=D(b),w=typeof R[0]=="string"&&R.length===1;let d=P(S);d&&(d=`(${d.trim()})`);let g=[];if(typeof R[0]=="string"?d&&w?g=[`%c[${k}] %c${R[0]} %c${d}`,E("blue"),E(""),E("grey")]:g=[`%c[${k}] %c${R[0]}`,E("blue"),E(""),...R.slice(1)]:g=[`%c[${k}]%`,E("blue"),...R],d&&!w&&g.push(d),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,g)}e.log=C;function E(b){return`color: ${b}`}}),define(we[45],ye([1,0,16,15,4]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(b){return JSON.stringify(b,C)}e.stringify=I;function P(b){let k=JSON.parse(b);return k=E(k),k}e.parse=P;function C(b,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,t.regExpFlags)(k)}:k}function E(b,k=0){if(!b||k>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 15:return new Date(b.source)}if(b instanceof y.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let R=0;R<b.length;++R)b[R]=E(b[R],k+1);else for(const R in b)Object.hasOwnProperty.call(b,R)&&(b[R]=E(b[R],k+1))}return b}e.revive=E}),define(we[9],ye([1,0,3,4]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${D.vscodeRemoteResource}`}set(b,k,R){this._hosts[b]=k,this._ports[b]=R}setConnectionToken(b,k){this._connectionTokens[b]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const k=b.authority;let R=this._hosts[k];R&&R.indexOf(":")!==-1&&R.indexOf("[")===-1&&(R=`[${R}]`);const S=this._ports[k],w=this._connectionTokens[k];let d=`path=${encodeURIComponent(b.path)}`;return typeof w=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),t.URI.from({scheme:y.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${R}:${S}`,path:y.isWeb?(window.location.pathname+"/"+this._remoteResourcesPath).replace(/\/\/+/g,"/"):this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new I;class P{asBrowserUri(b,k){const R=this.toUri(b,k);return R.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===D.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${D.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?R.with({scheme:D.vscodeFileResource,authority:R.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(b,k){const R=this.toUri(b,k);return R.scheme===D.vscodeFileResource?R.with({scheme:D.file,authority:R.authority!==P.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(b,k){return t.URI.isUri(b)?b:t.URI.parse(k.toUrl(b))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P;var C;(function(E){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(b.get("3"));const k="vscode-coi";function R(w){let d;typeof w=="string"?d=new URL(w).searchParams:w instanceof URL?d=w.searchParams:t.URI.isUri(w)&&(d=new URL(w.toString(!0)).searchParams);const g=d?.get(k);if(!!g)return b.get(g)}E.getHeadersFromQuery=R;function S(w,d,g){if(!globalThis.crossOriginIsolated)return;const v=d&&g?"3":g?"2":"1";w instanceof URLSearchParams?w.set(k,v):w[k]=v}E.addSearchParam=S})(C=e.COI||(e.COI={}))}),define(we[19],ye([1,0,36,9,6,3,15,4]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(w){return(0,C.uriToFsPath)(w,!0)}e.originalFSPath=E;class b{constructor(d){this._ignorePathCasing=d}compare(d,g,v=!1){return d===g?0:(0,P.compare)(this.getComparisonKey(d,v),this.getComparisonKey(g,v))}isEqual(d,g,v=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,v)===this.getComparisonKey(g,v)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,v=!1){if(d.scheme===g.scheme){if(d.scheme===t.Schemas.file)return y.isEqualOrParent(E(d),E(g),this._ignorePathCasing(d))&&d.query===g.query&&(v||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return y.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(v||d.fragment===g.fragment)}return!1}joinPath(d,...g){return C.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return D.posix.basename(d.path)}extname(d){return D.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===t.Schemas.file?g=C.URI.file(D.dirname(E(d))).path:(g=D.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===t.Schemas.file?g=C.URI.file(D.normalize(E(d))).path:g=D.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===t.Schemas.file){const p=D.relative(E(d),E(g));return I.isWindows?y.toSlashes(p):p}let v=d.path||"/";const m=g.path||"/";if(this._ignorePathCasing(d)){let p=0;for(const u=Math.min(v.length,m.length);p<u&&!(v.charCodeAt(p)!==m.charCodeAt(p)&&v.charAt(p).toLowerCase()!==m.charAt(p).toLowerCase());p++);v=m.substr(0,p)+v.substr(p)}return D.posix.relative(v,m)}resolvePath(d,g){if(d.scheme===t.Schemas.file){const v=C.URI.file(D.resolve(E(d),g));return d.with({authority:v.authority,path:v.path})}return g=y.toPosixPath(g),d.with({path:D.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||d!==void 0&&g!==void 0&&(0,P.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=D.sep){if(d.scheme===t.Schemas.file){const v=E(d);return v.length>y.getRoot(v).length&&v[v.length-1]===g}else{const v=d.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=D.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=D.sep){let v=!1;if(d.scheme===t.Schemas.file){const m=E(d);v=m!==void 0&&m.length===y.getRoot(m).length&&m[m.length-1]===g}else{g="/";const m=d.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(w=>w.scheme===t.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new b(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function k(w,d){const g=[];for(let v=0;v<w.length;v++){const m=d(w[v]);w.some((p,u)=>u===v?!1:(0,e.isEqualOrParent)(m,d(p)))||g.push(w[v])}return g}e.distinctParents=k;var R;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function d(g){const v=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[l,h]=u.split(":");l&&h&&v.set(l,h)});const p=g.path.substring(0,g.path.indexOf(";"));return p&&v.set(w.META_DATA_MIME,p),v}w.parseMetaData=d})(R=e.DataUri||(e.DataUri={}));function S(w,d,g){if(d){let v=w.path;return v&&v[0]!==D.posix.sep&&(v=D.posix.sep+v),w.with({scheme:g,authority:d,path:v})}return w.with({scheme:g})}e.toLocalResource=S}),define(we[14],ye([1,0,20,8,7,2,19,3]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(ee){return!!ee&&typeof ee.then=="function"}e.isThenable=E;function b(ee){const _=new y.CancellationTokenSource,U=ee(_.token),te=new Promise((ie,fe)=>{const ve=_.token.onCancellationRequested(()=>{ve.dispose(),_.dispose(),fe(new t.CancellationError)});Promise.resolve(U).then(z=>{ve.dispose(),_.dispose(),ie(z)},z=>{ve.dispose(),_.dispose(),fe(z)})});return new class{cancel(){_.cancel()}then(ie,fe){return te.then(ie,fe)}catch(ie){return this.then(void 0,ie)}finally(ie){return te.finally(ie)}}}e.createCancelablePromise=b;function k(ee,_,U){return new Promise((te,ie)=>{const fe=_.onCancellationRequested(()=>{fe.dispose(),te(U)});ee.then(te,ie).finally(()=>fe.dispose())})}e.raceCancellation=k;function R(ee,_){return new Promise((U,te)=>{const ie=_.onCancellationRequested(()=>{ie.dispose(),te(new t.CancellationError)});ee.then(U,te).finally(()=>ie.dispose())})}e.raceCancellationError=R;async function S(ee){let _=-1;const U=ee.map((ie,fe)=>ie.then(ve=>(_=fe,ve))),te=await Promise.race(U);return ee.forEach((ie,fe)=>{fe!==_&&ie.cancel()}),te}e.raceCancellablePromises=S;function w(ee,_,U){let te;const ie=setTimeout(()=>{te?.(void 0),U?.()},_);return Promise.race([ee.finally(()=>clearTimeout(ie)),new Promise(fe=>te=fe)])}e.raceTimeout=w;function d(ee){return new Promise((_,U)=>{const te=ee();E(te)?te.then(_,U):_(te)})}e.asPromise=d;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const te=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,te};this.queuedPromise=new Promise(te=>{this.activePromise.then(U,U).then(te)})}return new Promise((U,te)=>{this.queuedPromise.then(U,te)})}return this.activePromise=_(),new Promise((U,te)=>{this.activePromise.then(ie=>{this.activePromise=null,U(ie)},ie=>{this.activePromise=null,te(ie)})})}}e.Throttler=g;class v{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=v;class m{constructor(){this.promiseMap=new Map}queue(_,U){const ie=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(_)===ie&&this.promiseMap.delete(_)});return this.promiseMap.set(_,ie),ie}}e.SequencerByKey=m;const p=(ee,_)=>{let U=!0;const te=setTimeout(()=>{U=!1,_()},ee);return{isTriggered:()=>U,dispose:()=>{clearTimeout(te),U=!1}}},u=ee=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,ee())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,U=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ie,fe)=>{this.doResolve=ie,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ie=this.task;return this.task=null,ie()}}));const te=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?u(te):p(U,te),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class h{constructor(_){this.delayer=new l(_),this.throttler=new g}trigger(_,U){return this.delayer.trigger(()=>this.throttler.queue(_),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=h;class i{constructor(){this._isOpen=!1,this._promise=new Promise((_,U)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class r extends i{constructor(_){super(),this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function n(ee,_){return _?new Promise((U,te)=>{const ie=setTimeout(()=>{fe.dispose(),U()},ee),fe=_.onCancellationRequested(()=>{clearTimeout(ie),fe.dispose(),te(new t.CancellationError)})}):b(U=>n(ee,U))}e.timeout=n;function s(ee,_=0){const U=setTimeout(ee,_);return(0,I.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=s;function a(ee){const _=[];let U=0;const te=ee.length;function ie(){return U<te?ee[U++]():null}function fe(ve){ve!=null&&_.push(ve);const z=ie();return z?z.then(fe):Promise.resolve(_)}return Promise.resolve(null).then(fe)}e.sequence=a;function f(ee,_=te=>!!te,U=null){let te=0;const ie=ee.length,fe=()=>{if(te>=ie)return Promise.resolve(U);const ve=ee[te++];return Promise.resolve(ve()).then(Q=>_(Q)?Promise.resolve(Q):fe())};return fe()}e.first=f;function o(ee,_=te=>!!te,U=null){if(ee.length===0)return Promise.resolve(U);let te=ee.length;const ie=()=>{te=-1;for(const fe of ee)fe.cancel?.()};return new Promise((fe,ve)=>{for(const z of ee)z.then(Q=>{--te>=0&&_(Q)?(ie(),fe(Q)):te===0&&fe(U)}).catch(Q=>{--te>=0&&(ie(),ve(Q))})})}e.firstParallel=o;class c{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((U,te)=>{this.outstandingPromises.push({factory:_,c:U,e:te}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const U=_.factory();U.then(_.c,_.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=c;class T extends c{constructor(){super(1)}}e.Queue=T;class O{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new L;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,U=P.extUri){const te=U.getComparisonKey(_);let ie=this.queues.get(te);return ie||(ie=new T,D.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.queues.delete(te),this.onDidQueueDrain()}),this.queues.set(te,ie)),ie}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=O;class K{constructor(_,U){this._token=-1,typeof _=="function"&&typeof U=="number"&&this.setIfNotSet(_,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},U)}setIfNotSet(_,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},U))}}e.TimeoutTimer=K;class re{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setInterval(()=>{_()},U)}}e.IntervalTimer=re;class le{constructor(_,U){this.timeoutToken=-1,this.runner=_,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=le;class ae{constructor(_,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ae;class F extends le{constructor(_,U){super(_,U),this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class Y extends I.Disposable{constructor(_,U){super(),this.options=_,this.handler=U,this.pendingWork=[],this.throttler=this._register(new I.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new le(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Y,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ee=>{(0,C.setTimeout0)(()=>{if(_)return;const U=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(ee,_)=>{const U=requestIdleCallback(ee,typeof _=="number"?{timeout:_}:void 0);let te=!1;return{dispose(){te||(te=!0,cancelIdleCallback(U))}}}}();class B{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function H(ee,_,U){let te;for(let ie=0;ie<U;ie++)try{return await ee()}catch(fe){te=fe,await n(_)}throw te}e.retry=H;class ${hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(_,U,te){return this._pending={taskId:_,cancel:()=>te?.(),promise:U},U.then(()=>this.donePending(_),()=>this.donePending(_)),U}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let U,te;const ie=new Promise((fe,ve)=>{U=fe,te=ve});this._next={run:_,promise:ie,promiseResolve:U,promiseReject:te}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=$;class j{constructor(_,U=()=>Date.now()){this.interval=_,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class L{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,U)=>{this.completeCallback=_,this.errorCallback=U})}complete(_){return new Promise(U=>{this.completeCallback(_),this.resolved=!0,U()})}error(_){return new Promise(U=>{this.errorCallback(_),this.rejected=!0,U()})}cancel(){new Promise(_=>{this.errorCallback(new t.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=L;var N;(function(ee){async function _(te){let ie;const fe=await Promise.all(te.map(ve=>ve.then(z=>z,z=>{ie||(ie=z)})));if(typeof ie<"u")throw ie;return fe}ee.settled=_;function U(te){return new Promise(async(ie,fe)=>{try{await te(ie,fe)}catch(ve){fe(ve)}})}ee.withAsyncBody=U})(N=e.Promises||(e.Promises={}));var q;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(q||(q={}));class se{static fromArray(_){return new se(U=>{U.emitMany(_)})}static fromPromise(_){return new se(async U=>{U.emitMany(await _)})}static fromPromises(_){return new se(async U=>{await Promise.all(_.map(async te=>U.emitOne(await te)))})}static merge(_){return new se(async U=>{await Promise.all(_.map(async te=>{for await(const ie of te)U.emitOne(ie)}))})}constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const U={emitOne:te=>this.emitOne(te),emitMany:te=>this.emitMany(te),reject:te=>this.reject(te)};try{await Promise.resolve(_(U)),this.resolve()}catch(te){this.reject(te)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,U){return new se(async te=>{for await(const ie of _)te.emitOne(U(ie))})}map(_){return se.map(this,_)}static filter(_,U){return new se(async te=>{for await(const ie of _)U(ie)&&te.emitOne(ie)})}filter(_){return se.filter(this,_)}static coalesce(_){return se.filter(_,U=>!!U)}coalesce(){return se.coalesce(this)}static async toPromise(_){const U=[];for await(const te of _)U.push(te);return U}toPromise(){return se.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=se,se.EMPTY=se.fromArray([]);class he extends se{constructor(_,U){super(U),this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=he;function Z(ee){const _=new y.CancellationTokenSource,U=ee(_.token);return new he(_,async te=>{const ie=_.token.onCancellationRequested(()=>{ie.dispose(),_.dispose(),te.reject(new t.CancellationError)});try{for await(const fe of U){if(_.token.isCancellationRequested)return;te.emitOne(fe)}ie.dispose(),_.dispose()}catch(fe){ie.dispose(),_.dispose(),te.reject(fe)}})}e.createCancelableAsyncIterable=Z}),define(we[70],ye([1,0,18,14,36,31,6,3,15]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const k="[/\\\\]",R="[^/\\\\]",S=/\//g;function w(L,N){switch(L){case 0:return"";case 1:return`${R}*?`;default:return`(?:${k}|${R}+${k}${N?`|${k}${R}+`:""})*?`}}function d(L,N){if(!L)return[];const q=[];let se=!1,he=!1,Z="";for(const ee of L){switch(ee){case N:if(!se&&!he){q.push(Z),Z="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":he=!0;break;case"]":he=!1;break}Z+=ee}return Z&&q.push(Z),q}e.splitGlobAware=d;function g(L){if(!L)return"";let N="";const q=d(L,e.GLOB_SPLIT);if(q.every(se=>se===e.GLOBSTAR))N=".*";else{let se=!1;q.forEach((he,Z)=>{if(he===e.GLOBSTAR){if(se)return;N+=w(2,Z===q.length-1)}else{let ee=!1,_="",U=!1,te="";for(const ie of he){if(ie!=="}"&&ee){_+=ie;continue}if(U&&(ie!=="]"||!te)){let fe;ie==="-"?fe=ie:(ie==="^"||ie==="!")&&!te?fe="^":ie===e.GLOB_SPLIT?fe="":fe=(0,E.escapeRegExpCharacters)(ie),te+=fe;continue}switch(ie){case"{":ee=!0;continue;case"[":U=!0;continue;case"}":{N+=`(?:${d(_,",").map(z=>g(z)).join("|")})`,ee=!1,_="";break}case"]":{N+="["+te+"]",U=!1,te="";break}case"?":N+=R;continue;case"*":N+=w(1);continue;default:N+=(0,E.escapeRegExpCharacters)(ie)}}Z<q.length-1&&(q[Z+1]!==e.GLOBSTAR||Z+2<q.length)&&(N+=k)}se=he===e.GLOBSTAR})}return N}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new I.LRUCache(1e4),r=function(){return!1},n=function(){return null};function s(L,N){if(!L)return n;let q;typeof L!="string"?q=L.pattern:q=L,q=q.trim();const se=`${q}_${!!N.trimForExclusions}`;let he=i.get(se);if(he)return a(he,L);let Z;return v.test(q)?he=o(q.substr(4),q):(Z=m.exec(f(q,N)))?he=c(Z[1],q):(N.trimForExclusions?u:p).test(q)?he=T(q,N):(Z=l.exec(f(q,N)))?he=O(Z[1].substr(1),q,!0):(Z=h.exec(f(q,N)))?he=O(Z[1],q,!1):he=K(q),i.set(se,he),a(he,L)}function a(L,N){if(typeof N=="string")return L;const q=function(se,he){return(0,D.isEqualOrParent)(se,N.base,!C.isLinux)?L(se.substr(N.base.length+1),he):null};return q.allBasenames=L.allBasenames,q.allPaths=L.allPaths,q.basenames=L.basenames,q.patterns=L.patterns,q}function f(L,N){return N.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function o(L,N){return function(q,se){return typeof q=="string"&&q.endsWith(L)?N:null}}function c(L,N){const q=`/${L}`,se=`\\${L}`,he=function(ee,_){return typeof ee!="string"?null:_?_===L?N:null:ee===L||ee.endsWith(q)||ee.endsWith(se)?N:null},Z=[L];return he.basenames=Z,he.patterns=[N],he.allBasenames=Z,he}function T(L,N){const q=$(L.slice(1,-1).split(",").map(_=>s(_,N)).filter(_=>_!==n),L),se=q.length;if(!se)return n;if(se===1)return q[0];const he=function(_,U){for(let te=0,ie=q.length;te<ie;te++)if(q[te](_,U))return L;return null},Z=q.find(_=>!!_.allBasenames);Z&&(he.allBasenames=Z.allBasenames);const ee=q.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return ee.length&&(he.allPaths=ee),he}function O(L,N,q){const se=P.sep===P.posix.sep,he=se?L:L.replace(S,P.sep),Z=P.sep+he,ee=P.posix.sep+L;let _;return q?_=function(U,te){return typeof U=="string"&&(U===he||U.endsWith(Z)||!se&&(U===L||U.endsWith(ee)))?N:null}:_=function(U,te){return typeof U=="string"&&(U===he||!se&&U===L)?N:null},_.allPaths=[(q?"*/":"./")+L],_}function K(L){try{const N=new RegExp(`^${g(L)}$`);return function(q){return N.lastIndex=0,typeof q=="string"&&N.test(q)?L:null}}catch{return n}}function re(L,N,q){return!L||typeof N!="string"?!1:le(L)(N,void 0,q)}e.match=re;function le(L,N={}){if(!L)return r;if(typeof L=="string"||ae(L)){const q=s(L,N);if(q===n)return r;const se=function(he,Z){return!!q(he,Z)};return q.allBasenames&&(se.allBasenames=q.allBasenames),q.allPaths&&(se.allPaths=q.allPaths),se}return B(L,N)}e.parse=le;function ae(L){const N=L;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=ae;function F(L){return L.allBasenames||[]}e.getBasenameTerms=F;function Y(L){return L.allPaths||[]}e.getPathTerms=Y;function B(L,N){const q=$(Object.getOwnPropertyNames(L).map(_=>H(_,L[_],N)).filter(_=>_!==n)),se=q.length;if(!se)return n;if(!q.some(_=>!!_.requiresSiblings)){if(se===1)return q[0];const _=function(ie,fe){let ve;for(let z=0,Q=q.length;z<Q;z++){const J=q[z](ie,fe);if(typeof J=="string")return J;(0,t.isThenable)(J)&&(ve||(ve=[]),ve.push(J))}return ve?(async()=>{for(const z of ve){const Q=await z;if(typeof Q=="string")return Q}return null})():null},U=q.find(ie=>!!ie.allBasenames);U&&(_.allBasenames=U.allBasenames);const te=q.reduce((ie,fe)=>fe.allPaths?ie.concat(fe.allPaths):ie,[]);return te.length&&(_.allPaths=te),_}const he=function(_,U,te){let ie,fe;for(let ve=0,z=q.length;ve<z;ve++){const Q=q[ve];Q.requiresSiblings&&te&&(U||(U=(0,P.basename)(_)),ie||(ie=U.substr(0,U.length-(0,P.extname)(_).length)));const J=Q(_,U,ie,te);if(typeof J=="string")return J;(0,t.isThenable)(J)&&(fe||(fe=[]),fe.push(J))}return fe?(async()=>{for(const ve of fe){const z=await ve;if(typeof z=="string")return z}return null})():null},Z=q.find(_=>!!_.allBasenames);Z&&(he.allBasenames=Z.allBasenames);const ee=q.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return ee.length&&(he.allPaths=ee),he}function H(L,N,q){if(N===!1)return n;const se=s(L,q);if(se===n)return n;if(typeof N=="boolean")return se;if(N){const he=N.when;if(typeof he=="string"){const Z=(ee,_,U,te)=>{if(!te||!se(ee,_))return null;const ie=he.replace("$(basename)",U),fe=te(ie);return(0,t.isThenable)(fe)?fe.then(ve=>ve?L:null):fe?L:null};return Z.requiresSiblings=!0,Z}}return se}function $(L,N){const q=L.filter(_=>!!_.basenames);if(q.length<2)return L;const se=q.reduce((_,U)=>{const te=U.basenames;return te?_.concat(te):_},[]);let he;if(N){he=[];for(let _=0,U=se.length;_<U;_++)he.push(N)}else he=q.reduce((_,U)=>{const te=U.patterns;return te?_.concat(te):_},[]);const Z=function(_,U){if(typeof _!="string")return null;if(!U){let ie;for(ie=_.length;ie>0;ie--){const fe=_.charCodeAt(ie-1);if(fe===47||fe===92)break}U=_.substr(ie)}const te=se.indexOf(U);return te!==-1?he[te]:null};Z.basenames=se,Z.patterns=he,Z.allBasenames=se;const ee=L.filter(_=>!_.basenames);return ee.push(Z),ee}function j(L,N){return(0,y.equals)(L,N,(q,se)=>typeof q=="string"&&typeof se=="string"?q===se:typeof q!="string"&&typeof se!="string"?q.base===se.base&&q.pattern===se.pattern:!1)}e.patternsEquals=j}),define(we[91],ye([1,0,8,143,19,15,4]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(v){v[v.Paragraph=0]="Paragraph",v[v.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(m="",p=!1){if(this.value=m,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(m,p=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(u,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,p){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(m,p,u){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(m),")"),u&&(this.value+=` "${this._escape(this._escape(u,'"'),")")}"`),this.value+=")",this}_escape(m,p){const u=new RegExp((0,I.escapeRegExpCharacters)(p),"g");return m.replace(u,(l,h)=>m.charAt(h-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=E;function b(v){return k(v)?!v.value:Array.isArray(v)?v.every(b):!0}e.isEmptyMarkdownString=b;function k(v){return v instanceof E?!0:v&&typeof v=="object"?typeof v.value=="string"&&(typeof v.isTrusted=="boolean"||v.isTrusted===void 0)&&(typeof v.supportThemeIcons=="boolean"||v.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function R(v,m){return v===m?!0:!v||!m?!1:v.value===m.value&&v.isTrusted===m.isTrusted&&v.supportThemeIcons===m.supportThemeIcons&&v.supportHtml===m.supportHtml&&(v.baseUri===m.baseUri||!!v.baseUri&&!!m.baseUri&&(0,D.isEqual)(P.URI.from(v.baseUri),P.URI.from(m.baseUri)))}e.markdownStringEqual=R;function S(v){return v.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function w(v){return v.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=w;function d(v){return v&&v.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function g(v){const m=[],p=v.split("|").map(l=>l.trim());v=p[0];const u=p[1];if(u){const l=/height=(\d+)/.exec(u),h=/width=(\d+)/.exec(u),i=l?l[1]:"",r=h?h[1]:"",n=isFinite(parseInt(r)),s=isFinite(parseInt(i));n&&m.push(`width="${r}"`),s&&m.push(`height="${i}"`)}return{href:v,dimensions:m}}e.parseHrefAndDimensions=g}),define(we[145],ye([1,0,18,36,6,3,19,15]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(n,s){const{os:a,tildify:f,relative:o}=s;if(o){const O=b(n,o,a);if(typeof O=="string")return O}let c=n.fsPath;if(a===1&&!I.isWindows?c=c.replace(/\//g,"\\"):a!==1&&I.isWindows&&(c=c.replace(/\\/g,"/")),a!==1&&f?.userHome){const O=f.userHome.fsPath;let K;n.scheme!==f.userHome.scheme&&n.path.startsWith(D.posix.sep)?K=f.userHome.with({path:n.path}).fsPath:K=n.fsPath,c=S(K,O,a)}return(a===1?D.win32:D.posix).normalize(k(c,a===1))}e.getPathLabel=E;function b(n,s,a){const f=a===1?D.win32:D.posix,o=a===3?P.extUri:P.extUriIgnorePathCase,c=s.getWorkspace(),T=(0,y.firstOrDefault)(c.folders);if(!T)return;n.scheme!==T.uri.scheme&&n.path.startsWith(D.posix.sep)&&(n=T.uri.with({path:n.path}));const O=s.getWorkspaceFolder(n);if(!O)return;let K;if(o.isEqual(O.uri,n)?K="":K=o.relativePath(O.uri,n)??"",K&&(K=f.normalize(K)),c.folders.length>1&&!s.noPrefix){const re=O.name?O.name:o.basenameOrAuthority(O.uri);K=K?`${re} \u2022 ${K}`:re}return K}function k(n,s=I.isWindows){return(0,t.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=k;let R=Object.create(null);function S(n,s,a=I.OS){if(a===1||!n||!s)return n;let f=R.original===s?R.normalized:void 0;f||(f=s,I.isWindows&&(f=(0,t.toSlashes)(f)),f=`${(0,C.rtrim)(f,D.posix.sep)}${D.posix.sep}`,R={original:s,normalized:f});let o=n;return I.isWindows&&(o=(0,t.toSlashes)(o)),(a===3?o.startsWith(f):(0,C.startsWithIgnoreCase)(o,f))?`~/${o.substr(f.length)}`:n}e.tildify=S;function w(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=w;const d="\u2026",g="\\\\",v="~";function m(n,s=D.sep){const a=new Array(n.length);let f=!1;for(let o=0;o<n.length;o++){const c=n[o];if(c===""){a[o]=`.${s}`;continue}if(!c){a[o]=c;continue}f=!0;let T="",O=c;O.indexOf(g)===0?(T=O.substr(0,O.indexOf(g)+g.length),O=O.substr(O.indexOf(g)+g.length)):O.indexOf(s)===0?(T=O.substr(0,O.indexOf(s)+s.length),O=O.substr(O.indexOf(s)+s.length)):O.indexOf(v)===0&&(T=O.substr(0,O.indexOf(v)+v.length),O=O.substr(O.indexOf(v)+v.length));const K=O.split(s);for(let re=1;f&&re<=K.length;re++)for(let le=K.length-re;f&&le>=0;le--){f=!1;let ae=K.slice(le,le+re).join(s);for(let F=0;!f&&F<n.length;F++)if(F!==o&&n[F]&&n[F].indexOf(ae)>-1){const Y=le+re===K.length,B=le>0&&n[F].indexOf(s)>-1?s+ae:ae,H=n[F].endsWith(B);f=!Y||H}if(!f){let F="";(K[0].endsWith(":")||T!=="")&&(le===1&&(le=0,re++,ae=K[0]+s+ae),le>0&&(F=K[0]+s),F=T+F),le>0&&(F=F+d+s),F=F+ae,le+re<K.length&&(F=F+s+d),a[o]=F}}f&&(a[o]=c)}return a}e.shorten=m;var p;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function u(n,s=Object.create(null)){const a=[];let f=!1,o="";for(const c of n)if(c==="$"||f&&c==="{")o&&a.push({value:o,type:p.TEXT}),o="",f=!0;else if(c==="}"&&f){const T=s[o];if(typeof T=="string")T.length&&a.push({value:T,type:p.VARIABLE});else if(T){const O=a[a.length-1];(!O||O.type!==p.SEPARATOR)&&a.push({value:T.label,type:p.SEPARATOR})}o="",f=!1}else o+=c;return o&&!f&&a.push({value:o,type:p.TEXT}),a.filter((c,T)=>{if(c.type===p.SEPARATOR){const O=a[T-1],K=a[T+1];return[O,K].every(re=>re&&(re.type===p.VARIABLE||re.type===p.TEXT)&&re.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=u;function l(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function h(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=h;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function r(n){const s=n.indexOf("/")!==-1?D.posix:D.win32,a=s.basename(n),f=s.dirname(n);return a.length?{name:a,parentPath:f}:{name:f,parentPath:""}}e.splitName=r}),define(we[71],ye([1,0,4]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(k){return k.toJSON()}class D{constructor(R){this._uriTransformer=R}transformIncoming(R){const S=this._uriTransformer.transformIncoming(R);return S===R?R:t(y.URI.from(S))}transformOutgoing(R){const S=this._uriTransformer.transformOutgoing(R);return S===R?R:t(y.URI.from(S))}transformOutgoingURI(R){const S=this._uriTransformer.transformOutgoing(R);return S===R?R:y.URI.from(S)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function I(k,R,S){if(!k||S>200)return null;if(typeof k=="object"){if(k instanceof y.URI)return R.transformOutgoing(k);for(const w in k)if(Object.hasOwnProperty.call(k,w)){const d=I(k[w],R,S+1);d!==null&&(k[w]=d)}}return null}function P(k,R){const S=I(k,R,0);return S===null?k:S}e.transformOutgoingURIs=P;function C(k,R,S,w){if(!k||w>200)return null;if(typeof k=="object"){if(k.$mid===1)return S?y.URI.revive(R.transformIncoming(k)):R.transformIncoming(k);for(const d in k)if(Object.hasOwnProperty.call(k,d)){const g=C(k[d],R,S,w+1);g!==null&&(k[d]=g)}}return null}function E(k,R){const S=C(k,R,!1,0);return S===null?k:S}e.transformIncomingURIs=E;function b(k,R){const S=C(k,R,!0,0);return S===null?k:S}e.transformAndReviveIncomingURIs=b}),define(we[22],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return y.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(C){for(let E=0;E<C.length;E++)C[E]=Math.floor(Math.random()*256);return C};const I=new Uint8Array(16),P=[];for(let C=0;C<256;C++)P.push(C.toString(16).padStart(2,"0"));return function(){D(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let E=0,b="";return b+=P[I[E++]],b+=P[I[E++]],b+=P[I[E++]],b+=P[I[E++]],b+="-",b+=P[I[E++]],b+=P[I[E++]],b+="-",b+=P[I[E++]],b+=P[I[E++]],b+="-",b+=P[I[E++]],b+=P[I[E++]],b+="-",b+=P[I[E++]],b+=P[I[E++]],b+=P[I[E++]],b+=P[I[E++]],b+=P[I[E++]],b+=P[I[E++]],b}}()}),function(){"use strict";function oe(e,y,t){function D(w){return new Promise(d=>y.exists(w,d))}function I(w){return new Promise((d,g)=>{const v=new Date;y.utimes(w,v,v,m=>m?g(m):d())})}function P(w){return new Promise((d,g)=>y.mkdir(w,{recursive:!0},v=>v&&v.code!=="EEXIST"?g(v):d(w)))}function C(w){return new Promise((d,g)=>y.rm(w,{recursive:!0,force:!0,maxRetries:3},v=>v?g(v):d()))}function E(w){return new Promise((d,g)=>y.readFile(w,"utf8",(v,m)=>v?g(v):d(m)))}function b(w,d){return new Promise((g,v)=>y.writeFile(w,d,"utf8",m=>m?v(m):g()))}async function k(w){const d=e.join(w,"languagepacks.json");try{return JSON.parse(await E(d))}catch{}}function R(w,d){try{for(;d;){if(w[d])return d;{const g=d.lastIndexOf("-");if(g>0)d=d.substring(0,g);else return}}}catch(g){console.error("Resolving language pack configuration failed.",g)}}function S(w,d,g,v){if(v==="pseudo")return Promise.resolve({locale:v,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:v,availableLanguages:{}});if(v&&(v==="en"||v==="en-us"))return Promise.resolve({locale:v,availableLanguages:{}});const m=v;t.mark("code/willGenerateNls");const p=function(u){return t.mark("code/didGenerateNls"),Promise.resolve({locale:u,availableLanguages:{}})};try{return w?k(d).then(u=>{if(!u||(v=R(u,v),!v))return p(m);const l=u[v];let h;return!l||typeof l.hash!="string"||!l.translations||typeof(h=l.translations.vscode)!="string"?p(m):D(h).then(i=>{if(!i)return p(m);const r=l.hash+"."+v,n=e.join(d,"clp",r),s=e.join(n,w),a=e.join(n,"tcf.json"),f=e.join(n,"corrupted.info"),o={locale:m,availableLanguages:{"*":v},_languagePackId:r,_translationsConfigFile:a,_cacheRoot:n,_resolvedLanguagePackCoreLocation:s,_corruptedFile:f};return D(f).then(c=>{let T;return c?T=C(n):T=Promise.resolve(void 0),T.then(()=>D(s).then(O=>O?(I(s).catch(()=>{}),t.mark("code/didGenerateNls"),o):P(s).then(()=>Promise.all([E(g),E(h)])).then(K=>{const re=JSON.parse(K[0]),le=JSON.parse(K[1]).contents,ae=Object.keys(re.bundles),F=[];for(const Y of ae){const B=re.bundles[Y],H=Object.create(null);for(const $ of B){const j=re.keys[$],L=re.messages[$],N=le[$];let q;if(N){q=[];for(let se=0;se<j.length;se++){const he=j[se],Z=typeof he=="string"?he:he.key;let ee=N[Z];ee===void 0&&(ee=L[se]),q.push(ee)}}else q=L;H[$]=q}F.push(b(e.join(s,Y.replace(/\//g,"!")+".nls.json"),JSON.stringify(H)))}return F.push(b(a,JSON.stringify(l.translations))),Promise.all(F)}).then(()=>(t.mark("code/didGenerateNls"),o)).catch(K=>(console.error("Generating translation files failed.",K),p(v)))))})})}):p(m)}catch(u){return console.error("Generating translation files failed.",u),p(v)}}return{getNLSConfiguration:S}}if(typeof define=="function")define(we[146],ye([92,29,46]),function(e,y,t){return oe(e,y,t)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),t=require("../common/performance");module.exports=oe(e,y,t)}else throw new Error("Unknown context")}(),define(we[147],ye([1,0,27]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(P){const C=P.replace(/\-/g,":").toLowerCase();return!t.has(C)}function I(){const P=(0,y.networkInterfaces)();for(const C in P){const E=P[C];if(E){for(const{mac:b}of E)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=I}),define(we[93],ye([1,0,27,8,57,22,147]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(k){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(k)}value(){if(this._value===void 0){let k=0,R=0;const S=(0,y.networkInterfaces)();for(const w in S){const d=S[w];if(d)for(const{mac:g,internal:v}of d)v||(R+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(k+=1))}this._value=R>0?k/R:0}return this._value}};let C;async function E(){return C||(C=(async()=>await b()||I.generateUuid())()),C}e.getMachineId=E;async function b(){try{const k=await new Promise((S,w)=>{oe(["crypto"],S,w)}),R=(0,P.getMac)();return k.createHash("sha256").update(R,"utf8").digest("hex")}catch(k){t.onUnexpectedError(k);return}}}),define(we[21],ye([1,0,29,27,272,14,36,88,6,3,19,4]),function(oe,e,y,t,D,I,P,C,E,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function w(B,H=S.UNLINK){if((0,P.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return H===S.UNLINK?g(B):d(B)}async function d(B){try{const H=(0,P.randomPath)((0,t.tmpdir)());try{await y.promises.rename(B,H)}catch($){return $.code==="ENOENT"?void 0:g(B)}g(H).catch($=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function g(B){return(0,D.promisify)(y.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function v(B){if((0,P.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function m(B,H){return l(await(H?p(B):(0,D.promisify)(y.readdir)(B)))}async function p(B){try{return await(0,D.promisify)(y.readdir)(B,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const H=[],$=await m(B);for(const j of $){let L=!1,N=!1,q=!1;try{const se=await e.Promises.lstat((0,E.join)(B,j));L=se.isFile(),N=se.isDirectory(),q=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}H.push({name:j,isFile:()=>L,isDirectory:()=>N,isSymbolicLink:()=>q})}return H}function u(B){return l(y.readdirSync(B))}e.readdirSync=u;function l(B){return B.map(H=>typeof H=="string"?b.isMacintosh?(0,C.normalizeNFC)(H):H:(H.name=b.isMacintosh?(0,C.normalizeNFC)(H.name):H.name,H))}async function h(B){const H=await m(B),$=[];for(const j of H)await r.existsDirectory((0,E.join)(B,j))&&$.push(j);return $}function i(B,H=1e3){return new Promise($=>{let j=!1;const L=setInterval(()=>{j||(j=!0,y.access(B,N=>{j=!1,N&&(clearInterval(L),$(void 0))}))},H)})}e.whenDeleted=i;var r;(function(B){async function H(L){let N;try{if(N=await e.Promises.lstat(L),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(L),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(b.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw se}throw q}}B.stat=H;async function $(L){try{const{stat:N,symbolicLink:q}=await B.stat(L);return N.isFile()&&q?.dangling!==!0}catch{}return!1}B.existsFile=$;async function j(L){try{const{stat:N,symbolicLink:q}=await B.stat(L);return N.isDirectory()&&q?.dangling!==!0}catch{}return!1}B.existsDirectory=j})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new I.ResourceQueue;function s(B,H,$){return n.queueFor(R.URI.file(B),k.extUriBiasedIgnorePathCase).queue(()=>{const j=T($);return new Promise((L,N)=>o(B,H,j,q=>q?N(q):L()))})}let a=!0;function f(B){a=B}e.configureFlushOnWrite=f;function o(B,H,$,j){if(!a)return y.writeFile(B,H,{mode:$.mode,flag:$.flag},j);y.open(B,$.flag,$.mode,(L,N)=>{if(L)return j(L);y.writeFile(N,H,q=>{if(q)return y.close(N,()=>j(q));y.fdatasync(N,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),f(!1)),y.close(N,he=>j(he))))})})}function c(B,H,$){const j=T($);if(!a)return y.writeFileSync(B,H,{mode:j.mode,flag:j.flag});const L=y.openSync(B,j.flag,j.mode);try{y.writeFileSync(L,H);try{y.fdatasyncSync(L)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),f(!1)}}finally{y.closeSync(L)}}e.writeFileSync=c;function T(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function O(B,H){if(B!==H)try{await e.Promises.rename(B,H)}catch($){if(B.toLowerCase()!==H.toLowerCase()&&$.code==="EXDEV"||B.endsWith("."))await K(B,H,{preserveSymlinks:!1}),await w(B,S.MOVE);else throw $}}async function K(B,H,$){return le(B,H,{root:{source:B,target:H},options:$,handledSourcePaths:new Set})}const re=511;async function le(B,H,$){if($.handledSourcePaths.has(B))return;$.handledSourcePaths.add(B);const{stat:j,symbolicLink:L}=await r.stat(B);if(L){if($.options.preserveSymlinks)try{return await Y(B,H,$)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(L.dangling)return}return j.isDirectory()?ae(B,H,j.mode&re,$):F(B,H,j.mode&re)}async function ae(B,H,$,j){await e.Promises.mkdir(H,{recursive:!0,mode:$});const L=await m(B);for(const N of L)await le((0,E.join)(B,N),(0,E.join)(H,N),j)}async function F(B,H,$){await e.Promises.copyFile(B,H),await e.Promises.chmod(H,$)}async function Y(B,H,$){let j=await e.Promises.readlink(B);(0,P.isEqualOrParent)(j,$.root.source,!b.isLinux)&&(j=(0,E.join)($.root.target,j.substr($.root.source.length+1))),await e.Promises.symlink(j,H)}e.Promises=new class{get access(){return(0,D.promisify)(y.access)}get stat(){return(0,D.promisify)(y.stat)}get lstat(){return(0,D.promisify)(y.lstat)}get utimes(){return(0,D.promisify)(y.utimes)}get read(){return(B,H,$,j,L)=>new Promise((N,q)=>{y.read(B,H,$,j,L,(se,he,Z)=>se?q(se):N({bytesRead:he,buffer:Z}))})}get readFile(){return(0,D.promisify)(y.readFile)}get write(){return(B,H,$,j,L)=>new Promise((N,q)=>{y.write(B,H,$,j,L,(se,he,Z)=>se?q(se):N({bytesWritten:he,buffer:Z}))})}get appendFile(){return(0,D.promisify)(y.appendFile)}get fdatasync(){return(0,D.promisify)(y.fdatasync)}get truncate(){return(0,D.promisify)(y.truncate)}get rename(){return(0,D.promisify)(y.rename)}get copyFile(){return(0,D.promisify)(y.copyFile)}get open(){return(0,D.promisify)(y.open)}get close(){return(0,D.promisify)(y.close)}get symlink(){return(0,D.promisify)(y.symlink)}get readlink(){return(0,D.promisify)(y.readlink)}get chmod(){return(0,D.promisify)(y.chmod)}get mkdir(){return(0,D.promisify)(y.mkdir)}get unlink(){return(0,D.promisify)(y.unlink)}get rmdir(){return(0,D.promisify)(y.rmdir)}get realpath(){return(0,D.promisify)(y.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return h}get writeFile(){return s}get rm(){return w}get move(){return O}get copy(){return K}}}),define(we[148],ye([1,0,29,6,3,15,21]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(S){if(D.isLinux)return S;const w=(0,t.dirname)(S);if(S===w)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const v=(0,P.readdirSync)(w).filter(m=>m.toLowerCase()===d);if(v.length===1){const m=C(w);if(m)return(0,t.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(d);if(m>=0){const p=C(w);if(p)return(0,t.join)(p,v[m])}}}catch{}return null}e.realcaseSync=C;async function E(S){if(D.isLinux)return S;const w=(0,t.dirname)(S);if(S===w)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const v=(await P.Promises.readdir(w)).filter(m=>m.toLowerCase()===d);if(v.length===1){const m=await E(w);if(m)return(0,t.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(d);if(m>=0){const p=await E(w);if(p)return(0,t.join)(p,v[m])}}}catch{}return null}e.realcase=E;async function b(S){try{return await P.Promises.realpath(S)}catch{const d=R(S);return await P.Promises.access(d,y.constants.R_OK),d}}e.realpath=b;function k(S){try{return y.realpathSync(S)}catch{const d=R(S);return y.accessSync(d,y.constants.R_OK),d}}e.realpathSync=k;function R(S){return(0,I.rtrim)((0,t.normalize)(S),t.sep)}}),define(we[149],ye([1,0,94]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(C,E,b,k=1){let R=!1;return new Promise(S=>{const w=setTimeout(()=>{if(!R)return R=!0,S(0)},b);D(C,E,k,d=>{if(!R)return R=!0,clearTimeout(w),S(d)})})}e.findFreePort=t;function D(C,E,b,k){if(E===0)return k(0);const R=new y.Socket;R.once("connect",()=>(P(R),D(C+b,E-1,b,k))),R.once("data",()=>{}),R.once("error",S=>(P(R),S.code!=="ECONNREFUSED"?D(C+b,E-1,b,k):k(C))),R.connect(C,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(C,E,b,k="127.0.0.1"){let R=!1,S,w=1;const d=y.createServer({pauseOnConnect:!0});function g(v,m){R||(R=!0,d.removeAllListeners(),d.close(),S&&clearTimeout(S),m(v))}return new Promise(v=>{S=setTimeout(()=>{g(0,v)},b),d.on("listening",()=>{g(C,v)}),d.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&w<E?(C++,w++,d.listen(C,k)):g(0,v)}),d.on("close",()=>{g(0,v)}),d.listen(C,k)})}e.findFreePortFaster=I;function P(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(E){console.error(E)}}}),define(we[95],ye([1,0,27,6,21]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,P=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var E;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(E||(E={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let k;process.env.PROCESSOR_ARCHITEW6432?k=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?k=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?k=1:k=0;class R{constructor(h,i,r){this.exePath=h,this.displayName=i,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:l=!1}={}){return l?b===0?process.env["ProgramFiles(x86)"]||null:k===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:l=!1,findPreview:h=!1}={}){const i=S({useAlternateBitness:l});if(!i)return null;const r=t.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let n=-1,s=null;for(const o of await D.Promises.readdir(r)){let c=-1;if(h){const O=o.indexOf("-");if(O<0)continue;const K=o.substring(0,O);if(!I.test(K)||o.substring(O+1)!=="preview")continue;c=parseInt(K,10)}else{if(!I.test(o))continue;c=parseInt(o,10)}if(c<=n)continue;const T=t.join(r,o,"pwsh.exe");!await D.SymlinkSupport.existsFile(T)||(s=T,n=c)}if(!s)return null;const a=i.includes("x86")?" (x86)":"",f=h?" Preview":"";return new R(s,`PowerShell${f}${a}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const h=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=l?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(h))if(i.test(n)){const s=t.join(h,n,"pwsh.exe");return new R(s,r)}return null}function g(){const l=t.join(y.homedir(),".dotnet","tools","pwsh.exe");return new R(l,".NET Core PowerShell Global Tool")}function v(){const l=t.join(process.env.windir,b===1&&k!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(l,"Windows PowerShell",!0)}async function*m(){let l=await w();l&&(yield l),l=await w({useAlternateBitness:!0}),l&&(yield l),l=await d(),l&&(yield l),l=g(),l&&(yield l),l=await w({findPreview:!0}),l&&(yield l),l=await d({findPreview:!0}),l&&(yield l),l=await w({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=v(),l&&(yield l)}async function*p(){for await(const l of m())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=p;async function u(){for await(const l of p())return l;return null}e.getFirstAvailablePowerShellInstallation=u}),define(we[96],ye([1,0,6,3,26,56,13,21]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function E(R=D.env){return R.comspec||"cmd.exe"}e.getWindowsShell=E;function b(R){let S=[],w=!1;const d=function(g){if(w){S.push(g);return}(!R.send(g,m=>{if(m&&console.error(m),w=!1,S.length>0){const p=S.slice(0);S=[],p.forEach(u=>d(u))}})||t.isWindows)&&(w=!0)};return{send:d}}e.createQueuedSender=b;var k;(function(R){async function S(w,d,g){if(y.isAbsolute(w))return w;if(d===void 0&&(d=D.cwd()),y.dirname(w)!=="."||(g===void 0&&P.isString(D.env.PATH)&&(g=D.env.PATH.split(y.delimiter)),g===void 0||g.length===0))return y.join(d,w);async function m(p){if(await C.Promises.exists(p)){let u;try{u=await C.Promises.stat(p)}catch(l){l.message.startsWith("EACCES")&&(u=await C.Promises.lstat(p))}return u?!u.isDirectory():!1}return!1}for(const p of g){let u;if(y.isAbsolute(p)?u=y.join(p,w):u=y.join(d,p,w),await m(u))return u;let l=u+".com";if(await m(l)||(l=u+".exe",await m(l)))return l}return y.join(d,w)}R.findExecutable=S})(k=e.win32||(e.win32={}))}),define(we[97],ye([1,0,47,9]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(P){return new Promise((C,E)=>{let b;const k=new Map;function R(w,d,g,v,m){const p=k.get(d);if(w===P||p){const u={name:S(g),cmd:g,pid:w,ppid:d,load:v,mem:m};k.set(w,u),w===P&&(b=u),p&&(p.children||(p.children=[]),p.children.push(u),p.children.length>1&&(p.children=p.children.sort((l,h)=>l.pid-h.pid)))}}function S(w){const d=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,p=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,l=/\\pipe\\winpty-control/,h=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(u.exec(w))return"electron-crash-reporter";if(l.exec(w))return"winpty-process";if(h.exec(w))return"console-window-host (Windows internal process)";let r=i.exec(w);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(w)?"shared-process":g.exec(w)?"issue-reporter":v.exec(w)?"process-explorer":"window";if(r[1]==="utility"){if(m.exec(w))return"utility-network-service";if(p.exec(w))return"extension-host"}return r[1]}const n=/[a-zA-Z-]+\.js/g;let s="";do r=n.exec(w),r&&(s+=r+" ");while(r);return s&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${s}`:w}if(process.platform==="win32"){const w=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{oe(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(P,g=>{if(!g){E(new Error(`Root process ${P} not found`));return}d.getProcessCpuUsage(g,v=>{const m=new Map;v.forEach(p=>{const u=w(p.commandLine||"");m.set(p.pid,{name:S(u),cmd:u,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),b=m.get(P),b?(m.forEach(p=>{const u=m.get(p.ppid);u&&(u.children||(u.children=[]),u.children.push(p))}),m.forEach(p=>{p.children&&(p.children=p.children.sort((u,l)=>u.pid-l.pid))}),C(b)):E(new Error(`Root process ${P} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let w=function(){let d=[b];const g=[];for(;d.length;){const m=d.shift();m&&(g.push(m.pid),m.children&&(d=d.concat(m.children)))}let v=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",oe).fsPath);v+=" "+g.join(" "),(0,y.exec)(v,{},(m,p,u)=>{if(m||u)E(m||new Error(u.toString()));else{const l=p.toString().split(`
`);for(let h=0;h<g.length;h++){const i=k.get(g[h]);i.load=parseFloat(l[h])}if(!b){E(new Error(`Root process ${P} not found`));return}C(b)}})};(0,y.exec)("which ps",{},(d,g,v)=>{if(d||v)if(process.platform!=="linux")E(d||new Error(v.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",oe).fsPath);(0,y.exec)(m,{},(p,u,l)=>{p||l?E(p||new Error(l.toString())):(I(u,R),w())})}else{const m=g.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${m} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,l,h)=>{u||h&&!h.includes("screen size is bogus")?E(u||new Error(h.toString())):(I(l,R),process.platform==="linux"?w():b?C(b):E(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=D;function I(P,C){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=P.toString().split(`
`);for(const k of b){const R=E.exec(k.trim());R&&R.length===6&&C(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}}),define(we[150],ye([1,0,27,3,95,96]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(w,d){return w===1?t.isWindows?R():I.getWindowsShell(d):b(w,d)}e.getSystemShell=P;function C(w,d){return w===1?t.isWindows?S(d):I.getWindowsShell(d):b(w,d)}e.getSystemShellSync=C;let E=null;function b(w,d){if(t.isLinux&&w===2||t.isMacintosh&&w===3)return"/bin/bash";if(!E){let g;if(t.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,y.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}E=g}return E}let k=null;async function R(){return k||(k=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),k}function S(w){if(k)return k;const d=t.isWindows&&parseFloat((0,y.release)())>=10,g=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${w.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?v:I.getWindowsShell(w)}});var Ae=this&&this.__decorate||function(oe,e,y,t){var D=arguments.length,I=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,y):t,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(oe,e,y,t);else for(var C=oe.length-1;C>=0;C--)(P=oe[C])&&(I=(D<3?P(I):D>3?P(e,y,I):P(e,y))||I);return D>3&&I&&Object.defineProperty(e,y,I),I};define(we[42],ye([1,0,18,14,16,20,85,8,7,2,45,15,13]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function d(L){switch(L){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function v(L){switch(L){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(m||(m={}));class p{constructor(N){this.buffer=N,this.pos=0}read(N){const q=this.buffer.slice(this.pos,this.pos+N);return this.pos+=q.byteLength,q}}class u{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var l;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object"})(l||(l={}));function h(L){const N=D.VSBuffer.alloc(4);return N.writeUInt32BE(L,0),N}function i(L){return L.read(4).readUInt32BE(0)}function r(L){const N=D.VSBuffer.alloc(1);return N.writeUInt8(L,0),N}const n={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object)},s=typeof Buffer<"u";function a(L,N){if(typeof N>"u")L.write(n.Undefined);else if(typeof N=="string"){const q=D.VSBuffer.fromString(N);L.write(n.String),L.write(h(q.byteLength)),L.write(q)}else if(s&&Buffer.isBuffer(N)){const q=D.VSBuffer.wrap(N);L.write(n.Buffer),L.write(h(q.byteLength)),L.write(q)}else if(N instanceof D.VSBuffer)L.write(n.VSBuffer),L.write(h(N.byteLength)),L.write(N);else if(Array.isArray(N)){L.write(n.Array),L.write(h(N.length));for(const q of N)a(L,q)}else{const q=D.VSBuffer.fromString(JSON.stringify(N));L.write(n.Object),L.write(h(q.byteLength)),L.write(q)}}function f(L){switch(L.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return L.read(i(L)).toString();case l.Buffer:return L.read(i(L)).buffer;case l.VSBuffer:return L.read(i(L));case l.Array:{const q=i(L),se=[];for(let he=0;he<q;he++)se.push(f(L));return se}case l.Object:return JSON.parse(L.read(i(L)).toString())}}class o{constructor(N,q,se=null,he=1e3){this.protocol=N,this.ctx=q,this.logger=se,this.timeoutDelay=he,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(N,q){this.channels.set(N,q),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const q=this.send([N.type]);this.logger?.logOutgoing(q,0,1,v(N.type));return}case 201:case 202:case 204:case 203:{const q=this.send([N.type,N.id],N.data);this.logger?.logOutgoing(q,N.id,1,v(N.type),N.data);return}}}send(N,q=void 0){const se=new u;return a(se,N),a(se,q),this.sendBuffer(se.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onRawMessage(N){const q=new p(N),se=f(q),he=f(q),Z=se[0];switch(Z){case 100:return this.logger?.logIncoming(N.byteLength,se[1],1,`${d(Z)}: ${se[2]}.${se[3]}`,he),this.onPromise({type:Z,id:se[1],channelName:se[2],name:se[3],arg:he});case 102:return this.logger?.logIncoming(N.byteLength,se[1],1,`${d(Z)}: ${se[2]}.${se[3]}`,he),this.onEventListen({type:Z,id:se[1],channelName:se[2],name:se[3],arg:he});case 101:return this.logger?.logIncoming(N.byteLength,se[1],1,`${d(Z)}`),this.disposeActiveRequest({type:Z,id:se[1]});case 103:return this.logger?.logIncoming(N.byteLength,se[1],1,`${d(Z)}`),this.disposeActiveRequest({type:Z,id:se[1]})}}onPromise(N){const q=this.channels.get(N.channelName);if(!q){this.collectPendingRequest(N);return}const se=new I.CancellationTokenSource;let he;try{he=q.call(this.ctx,N.name,N.arg,se.token)}catch(_){he=Promise.reject(_)}const Z=N.id;he.then(_=>{this.sendResponse({id:Z,data:_,type:201}),this.activeRequests.delete(N.id)},_=>{_ instanceof Error?this.sendResponse({id:Z,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:Z,data:_,type:203}),this.activeRequests.delete(N.id)});const ee=(0,b.toDisposable)(()=>se.cancel());this.activeRequests.set(N.id,ee)}onEventListen(N){const q=this.channels.get(N.channelName);if(!q){this.collectPendingRequest(N);return}const se=N.id,Z=q.listen(this.ctx,N.name,N.arg)(ee=>this.sendResponse({id:se,data:ee,type:204}));this.activeRequests.set(N.id,Z)}disposeActiveRequest(N){const q=this.activeRequests.get(N.id);q&&(q.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let q=this.pendingRequests.get(N.channelName);q||(q=[],this.pendingRequests.set(N.channelName,q));const se=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:N,timeoutTimer:se})}flushPendingRequests(N){const q=this.pendingRequests.get(N);if(q){for(const se of q)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.onPromise(se.request);break;case 102:this.onEventListen(se.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var c;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(N,q=null){this.protocol=N,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(se=>this.onBuffer(se)),this.logger=q}getChannel(N){const q=this;return{call(se,he,Z){return q.isDisposed?Promise.reject(new C.CancellationError):q.requestPromise(N,se,he,Z)},listen(se,he){return q.isDisposed?E.Event.None:q.requestEvent(N,se,he)}}}requestPromise(N,q,se,he=I.CancellationToken.None){const Z=this.lastRequestId++,_={id:Z,type:100,channelName:N,name:q,arg:se};if(he.isCancellationRequested)return Promise.reject(new C.CancellationError);let U;return new Promise((ie,fe)=>{if(he.isCancellationRequested)return fe(new C.CancellationError);const ve=()=>{const W=V=>{switch(V.type){case 201:this.handlers.delete(Z),ie(V.data);break;case 202:{this.handlers.delete(Z);const x=new Error(V.data.message);x.stack=Array.isArray(V.data.stack)?V.data.stack.join(`
`):V.data.stack,x.name=V.data.name,fe(x);break}case 203:this.handlers.delete(Z),fe(V.data);break}};this.handlers.set(Z,W),this.sendRequest(_)};let z=null;this.state===m.Idle?ve():(z=(0,t.createCancelablePromise)(W=>this.whenInitialized()),z.then(()=>{z=null,ve()}));const Q=()=>{z?(z.cancel(),z=null):this.sendRequest({id:Z,type:101}),fe(new C.CancellationError)},J=he.onCancellationRequested(Q);U=(0,b.combinedDisposable)((0,b.toDisposable)(Q),J),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(N,q,se){const he=this.lastRequestId++,ee={id:he,type:102,channelName:N,name:q,arg:se};let _=null;const U=new E.Emitter({onFirstListenerAdd:()=>{_=(0,t.createCancelablePromise)(ie=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(U),this.sendRequest(ee)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(U),this.sendRequest({id:he,type:103}))}}),te=ie=>U.fire(ie.data);return this.handlers.set(he,te),U.event}sendRequest(N){switch(N.type){case 100:case 102:{const q=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger?.logOutgoing(q,N.id,0,`${d(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const q=this.send([N.type,N.id]);this.logger?.logOutgoing(q,N.id,0,d(N.type));return}}}send(N,q=void 0){const se=new u;return a(se,N),a(se,q),this.sendBuffer(se.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onBuffer(N){const q=new p(N),se=f(q),he=f(q),Z=se[0];switch(Z){case 200:return this.logger?.logIncoming(N.byteLength,0,0,v(Z)),this.onResponse({type:se[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(N.byteLength,se[1],0,v(Z),he),this.onResponse({type:se[0],id:se[1],data:he})}}onResponse(N){if(N.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(N.id)?.(N)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ae([P.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class O{get connections(){const N=[];return this._connections.forEach(q=>N.push(q)),N}constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:q,onDidClientDisconnect:se})=>{E.Event.once(q.onMessage)(Z=>{const ee=new p(Z),_=f(ee),U=new o(q,_),te=new T(q);this.channels.forEach((fe,ve)=>U.registerChannel(ve,fe));const ie={channelServer:U,channelClient:te,ctx:_};this._connections.add(ie),this._onDidAddConnection.fire(ie),se(()=>{U.dispose(),te.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}getChannel(N,q){const se=this;return{call(he,Z,ee){let _;if((0,S.isFunction)(q)){const te=(0,y.getRandomElement)(se.connections.filter(q));_=te?Promise.resolve(te):E.Event.toPromise(E.Event.filter(se.onDidAddConnection,q))}else _=q.routeCall(se,he,Z);const U=_.then(te=>te.channelClient.getChannel(N));return re(U).call(he,Z,ee)},listen(he,Z){if((0,S.isFunction)(q))return se.getMulticastEvent(N,q,he,Z);const ee=q.routeEvent(se,he,Z).then(_=>_.channelClient.getChannel(N));return re(ee).listen(he,Z)}}}getMulticastEvent(N,q,se,he){const Z=this;let ee=new b.DisposableStore;const _=new E.Emitter({onFirstListenerAdd:()=>{ee=new b.DisposableStore;const U=new E.EventMultiplexer,te=new Map,ie=ve=>{const Q=ve.channelClient.getChannel(N).listen(se,he),J=U.add(Q);te.set(ve,J)},fe=ve=>{const z=te.get(ve);!z||(z.dispose(),te.delete(ve))};Z.connections.filter(q).forEach(ie),E.Event.filter(Z.onDidAddConnection,q)(ie,void 0,ee),Z.onDidRemoveConnection(fe,void 0,ee),U.event(_.fire,_,ee),ee.add(U)},onLastListenerRemove:()=>{ee.dispose()}});return _.event}registerChannel(N,q){this.channels.set(N,q),this._connections.forEach(se=>{se.channelServer.registerChannel(N,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=O;class K{constructor(N,q,se=null){const he=new u;a(he,q),N.send(he.buffer),this.channelClient=new T(N,se),this.channelServer=new o(N,q,se)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,q){this.channelServer.registerChannel(N,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=K;function re(L){return{call(N,q,se){return L.then(he=>he.call(N,q,se))},listen(N,q){const se=new E.Relay;return L.then(he=>se.input=he.listen(N,q)),se.event}}}e.getDelayedChannel=re;function le(L){let N=!1;return{call(q,se,he){return N?L.call(q,se,he):(0,t.timeout)(0).then(()=>N=!0).then(()=>L.call(q,se,he))},listen(q,se){if(N)return L.listen(q,se);const he=new E.Relay;return(0,t.timeout)(0).then(()=>N=!0).then(()=>he.input=L.listen(q,se)),he.event}}}e.getNextTickChannel=le;class ae{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const q of N.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=ae;var F;(function(L){function N(Z,ee){const _=Z,U=ee&&ee.disableMarshalling,te=new Map;for(const ie in _)se(ie)&&te.set(ie,E.Event.buffer(_[ie],!0));return new class{listen(ie,fe,ve){const z=te.get(fe);if(z)return z;if(he(fe)){const Q=_[fe];if(typeof Q=="function")return Q.call(_,ve)}throw new Error(`Event not found: ${fe}`)}call(ie,fe,ve){const z=_[fe];if(typeof z=="function"){if(!U&&Array.isArray(ve))for(let Q=0;Q<ve.length;Q++)ve[Q]=(0,k.revive)(ve[Q]);return z.apply(_,ve)}throw new Error(`Method not found: ${fe}`)}}}L.fromService=N;function q(Z,ee){const _=ee&&ee.disableMarshalling;return new Proxy({},{get(U,te){if(typeof te=="string")return ee?.properties?.has(te)?ee.properties.get(te):he(te)?function(ie){return Z.listen(te,ie)}:se(te)?Z.listen(te):async function(...ie){let fe;ee&&!(0,S.isUndefinedOrNull)(ee.context)?fe=[ee.context,...ie]:fe=ie;const ve=await Z.call(te,fe);return _?ve:(0,k.revive)(ve)};throw new Error(`Property not found: ${String(te)}`)}})}L.toService=q;function se(Z){return Z[0]==="o"&&Z[1]==="n"&&R.isUpperAsciiLetter(Z.charCodeAt(2))}function he(Z){return/^onDynamic/.test(Z)&&R.isUpperAsciiLetter(Z.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){const N=L.toString();if(N!=="[object Object]")return N}return L}function H(L){return Array.isArray(L)?L.map(B):B(L)}function $(L,N,q,se,he,Z,ee){ee=H(ee);const _=Y[he],U=_[se%_.length];let te=[`%c[${L}]%c[${String(N).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(Z)?(te=te.concat(ee),te.push(")")):te.push(ee),console.log.apply(console,te)}e.logWithColors=$;class j{constructor(N,q){this._outgoingPrefix=N,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,q,se,he,Z){this._totalOutgoing+=N,$(this._outgoingPrefix,this._totalOutgoing,N,q,se,he,Z)}logIncoming(N,q,se,he,Z){this._totalIncoming+=N,$(this._incomingPrefix,this._totalIncoming,N,q,se,he,Z)}}e.IPCLogger=j}),define(we[98],ye([1,0,16,7,2,42]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let f=0;function o(T,O){if(!a.has(T)){const K=String(++f);a.set(T,K)}return a.get(T)}function c(T,O,K,re){if(!s.enableDiagnostics)return;const le=o(T,O);if(re instanceof y.VSBuffer||re instanceof Uint8Array||re instanceof ArrayBuffer||ArrayBuffer.isView(re)){const ae=y.VSBuffer.alloc(re.byteLength);ae.set(re),s.records.push({timestamp:Date.now(),id:le,label:O,type:K,buff:ae})}else s.records.push({timestamp:Date.now(),id:le,label:O,type:K,data:re})}s.traceSocketEvent=c})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function k(){return b||(b=y.VSBuffer.alloc(0)),b}class R{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,f){if(a===0)return k();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const O=this._chunks[0];return f&&(this._chunks.shift(),this._totalLength-=a),O}if(this._chunks[0].byteLength>a){const O=this._chunks[0].slice(0,a);return f&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),O}const o=y.VSBuffer.alloc(a);let c=0,T=0;for(;a>0;){const O=this._chunks[T];if(O.byteLength>a){const K=O.slice(0,a);o.set(K,c),c+=a,f&&(this._chunks[T]=O.slice(a),this._totalLength-=a),a-=a}else o.set(O,c),c+=O.byteLength,f?(this._chunks.shift(),this._totalLength-=O.byteLength):T++,a-=O.byteLength}return o}}e.ChunkStream=R;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(S||(S={}));function w(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(a,f,o,c){this.type=a,this.id=f,this.ack=o,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(a){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(f=>this.acceptChunk(f))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const f=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=f.readUInt32BE(9),this._state.messageType=f.readUInt8(0),this._state.id=f.readUInt32BE(1),this._state.ack=f.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,c=this._state.id,T=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",f),this._onMessage.fire(new g(o,c,T,f)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const f=y.VSBuffer.alloc(13);f.writeUInt8(a.type,0),f.writeUInt32BE(a.id,1),f.writeUInt32BE(a.ack,5),f.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(f,a.data)}_bufferAdd(a,f){const o=this._totalLength===0;return this._data.push(a,f),this._totalLength+=a.byteLength+f.byteLength,o}_bufferTake(){const a=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,f){this._bufferAdd(a,f)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class p extends D.Disposable{constructor(a){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(f=>{f.type===1&&this._onMessage.fire(f.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new g(1,0,0,a))}}e.Protocol=p;class u extends I.IPCClient{static fromSocket(a,f){return new u(new p(a),f)}get onDidDispose(){return this.protocol.onDidDispose}constructor(a,f,o=null){super(a,f,o),this.protocol=a}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=u;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class h{constructor(a){this.data=a,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let a=0,f=this._first;for(;f;)f=f.next,a++;return a}peek(){return this._first?this._first.data:null}toArray(){const a=[];let f=0,o=this._first;for(;o;)a[f++]=o.data,o=o.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const f=new h(a);if(!this._first){this._first=f,this._last=f;return}this._last.next=f,this._last=f}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const a=Date.now();for(let f=0;f<r._HISTORY_LENGTH;f++)this.lastRuns[f]=a-1e3*f;setInterval(()=>{for(let f=r._HISTORY_LENGTH;f>=1;f--)this.lastRuns[f]=this.lastRuns[f-1];this.lastRuns[0]=Date.now()},1e3)}load(){const a=Date.now(),f=(1+r._HISTORY_LENGTH)*1e3;let o=0;for(let c=0;c<r._HISTORY_LENGTH;c++)a-this.lastRuns[c]<=f&&o++;return 1-o/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(a,f=null,o=r.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),f&&this._socketReader.acceptChunk(f),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new g(5,0,0,k());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new g(7,0,0,k());this._socketWriter.write(a)}sendResume(){const a=new g(8,0,0,k());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,f){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(f)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new g(3,0,this._incomingAckId,k());this._socketWriter.write(a);const f=this._outgoingUnackMsg.toArray();for(let o=0,c=f.length;o<c;o++)this._socketWriter.write(f[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const f=this._outgoingUnackMsg.peek();if(f&&f.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const f=Date.now();f-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=f,this._socketWriter.write(new g(6,0,0,k())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const f=this._outgoingUnackMsg.toArray();for(let o=0,c=f.length;o<c;o++)this._socketWriter.write(f[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const f=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new g(1,f,this._incomingAckId,a);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(a){const f=new g(2,0,0,a);this._socketWriter.write(f)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),f=Date.now()-a.writtenTime,o=Date.now()-this._socketReader.lastReadTime,c=Date.now()-this._lastSocketTimeoutTime;if(f>=2e4&&o>=2e4&&c>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:f,timeSinceLastReceivedSomeData:o});return}const T=Math.max(2e4-f,2e4-o,2e4-c,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},T)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new g(3,0,this._incomingAckId,k());this._socketWriter.write(a)}_sendKeepAlive(){const a=new g(9,0,0,k());this._socketWriter.write(a)}}e.PersistentProtocol=n}),define(we[99],ye([1,0,47,14,16,20,144,8,7,2,23,96,56,42]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends w.ChannelServer{constructor(m){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",p=>D.VSBuffer.wrap(Buffer.from(p,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(m,p){this.modulePath=m,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new t.Delayer(u),this.child=null,this._client=null}getChannel(m){const p=this;return{call(u,l,h){return p.requestPromise(m,u,l,h)},listen(u,l){return p.requestEvent(m,u,l)}}}requestPromise(m,p,u,l=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const h=this.getCachedChannel(m),i=(0,t.createCancelablePromise)(s=>h.call(p,u,s)),r=l.onCancellationRequested(()=>i.cancel()),n=(0,b.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(m,p,u){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let l;const h=new E.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(m).listen(p,u)(h.fire,h),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return h.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,S.removeDangerousEnvVariables)(p.env),this.child=(0,y.fork)(this.modulePath,m,p);const u=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,P.isRemoteConsoleLog)(a)){(0,P.log)(a,`IPC Library: ${this.options.serverName}`);return}u.fire(D.VSBuffer.wrap(Buffer.from(a,"base64")))});const h=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,i=a=>this.child&&this.child.connected&&h.send(a.buffer.toString("base64")),r=u.event,n={send:i,onMessage:r};this._client=new w.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,f)=>{process.removeListener("exit",s),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),a!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+f),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:f})})}return this._client}getCachedChannel(m){let p=this.channels.get(m);return p||(p=this.client.getChannel(m),this.channels.set(m,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(we[58],ye([1,0,16,8,7,2,6,3,22,42,98]),function(oe,e,y,t,D,I,P,C,E,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function R(){return{crypto:oe.__$__nodeRequire("crypto"),zlib:oe.__$__nodeRequire("zlib"),net:oe.__$__nodeRequire("net"),os:oe.__$__nodeRequire("os")}}class S{traceSocketEvent(o,c){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,c)}constructor(o,c=""){this._canWrite=!0,this.debugLabel=c,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,t.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener),this._closeListener=T=>{this.traceSocketEvent("close",{hadError:T}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(o){const c=T=>{this.traceSocketEvent("read",T),o(y.VSBuffer.wrap(T))};return this.socket.on("data",c),{dispose:()=>this.socket.off("data",c)}}onClose(o){const c=T=>{o({type:0,hadError:T,error:void 0})};return this.socket.on("close",c),{dispose:()=>this.socket.off("close",c)}}onEnd(o){const c=()=>{o()};return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(o){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,c=>{if(c){if(c.code==="EPIPE")return;(0,t.onUnexpectedError)(c)}})}catch(c){if(c.code==="EPIPE")return;(0,t.onUnexpectedError)(c)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,c)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=S;var w;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var d;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(d||(d={}));class g extends I.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,c){this.socket.traceSocketEvent(o,c)}constructor(o,c,T,O){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:c,inflateBytesLength:T?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new v(this,c,T,O,this._onData,(K,re)=>this._write(K,re))),this._register(this._flowManager.onError(K=>{console.error(K),(0,t.onUnexpectedError)(K),this._onClose.fire({type:0,hadError:!0,error:K})})),this._incomingData=new k.ChunkStream,this._register(this.socket.onData(K=>this._acceptChunk(K))),this._register(this.socket.onClose(K=>this._onClose.fire(K)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,c){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let T=2;o.byteLength<126?T+=0:o.byteLength<2**16?T+=2:T+=8;const O=y.VSBuffer.alloc(T);if(c?O.writeUInt8(194,0):O.writeUInt8(130,0),o.byteLength<126)O.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){O.writeUInt8(126,1);let K=1;O.writeUInt8(o.byteLength>>>8&255,++K),O.writeUInt8(o.byteLength>>>0&255,++K)}else{O.writeUInt8(127,1);let K=1;O.writeUInt8(0,++K),O.writeUInt8(0,++K),O.writeUInt8(0,++K),O.writeUInt8(0,++K),O.writeUInt8(o.byteLength>>>24&255,++K),O.writeUInt8(o.byteLength>>>16&255,++K),O.writeUInt8(o.byteLength>>>8&255,++K),O.writeUInt8(o.byteLength>>>0&255,++K)}this.socket.write(y.VSBuffer.concat([O,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const c=this._incomingData.peek(this._state.readLen),T=c.readUInt8(0),O=(T&128)>>>7,K=(T&64)>>>6,re=c.readUInt8(1),le=(re&128)>>>7,ae=re&127;this._state.state=2,this._state.readLen=2+(le?4:0)+(ae===126?2:0)+(ae===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(K)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const c=this._incomingData.read(this._state.readLen),T=c.readUInt8(1),O=(T&128)>>>7;let K=T&127,re=1;K===126?K=c.readUInt8(++re)*2**8+c.readUInt8(++re):K===127&&(K=c.readUInt8(++re)*0+c.readUInt8(++re)*0+c.readUInt8(++re)*0+c.readUInt8(++re)*0+c.readUInt8(++re)*2**24+c.readUInt8(++re)*2**16+c.readUInt8(++re)*2**8+c.readUInt8(++re));let le=0;O&&(le=c.readUInt8(++re)*2**24+c.readUInt8(++re)*2**16+c.readUInt8(++re)*2**8+c.readUInt8(++re)),this._state.state=3,this._state.readLen=K,this._state.mask=le,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const c=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",c),u(c,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",c),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(c,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class v extends I.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:y.VSBuffer.alloc(0)}constructor(o,c,T,O,K,re){super(),this._tracer=o,this._onData=K,this._writeFn=re,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,c?(this._zlibInflateStream=this._register(new m(this._tracer,O,T,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(le=>this._onError.fire(le))),this._register(this._zlibDeflateStream.onError(le=>this._onError.fire(le)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const c=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(c,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,c){return new Promise((T,O)=>{o.write(c),o.flush(K=>T(K))})}acceptFrame(o,c,T){this._readQueue.push({data:o,isCompressed:c,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const c=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(c)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,c,T){return new Promise((O,K)=>{o.write(c),T&&o.write(y.VSBuffer.fromByteArray([0,0,255,255])),o.flush(re=>O(re))})}}class m extends I.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.concat(this._recordedInflateBytes):y.VSBuffer.alloc(0)}constructor(o,c,T,O){super(),this._tracer=o,this._recordInflateBytes=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=R().zlib.createInflateRaw(O),this._zlibInflate.on("error",K=>{this._tracer.traceSocketEvent("zlibInflateError",{message:K?.message,code:K?.code}),this._onError.fire(K)}),this._zlibInflate.on("data",K=>{this._tracer.traceSocketEvent("zlibInflateData",K),this._pendingInflateData.push(y.VSBuffer.wrap(K))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const c=y.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(c)})}}class p extends I.Disposable{constructor(o,c){super(),this._tracer=o,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=R().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(y.VSBuffer.wrap(T))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let c=y.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,c=c.slice(0,c.byteLength-4),o(c)})}}function u(f,o){if(o===0)return;const c=f.byteLength>>>2;for(let ae=0;ae<c;ae++){const F=f.readUInt32BE(ae*4);f.writeUInt32BE(F^o,ae*4)}const T=c*4,O=f.byteLength-T,K=o>>>24&255,re=o>>>16&255,le=o>>>8&255;O>=1&&f.writeUInt8(f.readUInt8(T)^K,T),O>=2&&f.writeUInt8(f.readUInt8(T+1)^re,T+1),O>=3&&f.writeUInt8(f.readUInt8(T+2)^le,T+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const l={[2]:107,[1]:103};function h(){const f=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):o=(0,P.join)(R().os.tmpdir(),`vscode-ipc-${f}.sock`),r(o),o}e.createRandomIPCHandle=h;function i(f,o,c){const T=R().crypto.createHash("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${c}-${o}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${c}-${o}.sock`):O=(0,P.join)(f,`${c}-${o}.sock`),r(O),O}e.createStaticIPCHandle=i;function r(f){const o=l[C.platform];typeof o=="number"&&f.length>=o&&console.warn(`WARNING: IPC handle "${f}" is longer than ${o} chars, try a shorter --user-data-dir`)}class n extends b.IPCServer{static toClientConnectionEvent(o){const c=D.Event.fromNodeEventEmitter(o,"connection");return D.Event.map(c,T=>({protocol:new k.Protocol(new S(T,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(T,"close"))}))}constructor(o){super(n.toClientConnectionEvent(o)),this.server=o}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function s(f){return new Promise((o,c)=>{const T=R().net.createServer();T.on("error",c),T.listen(f,()=>{T.removeListener("error",c),o(new n(T))})})}e.serve=s;function a(f,o){return new Promise((c,T)=>{const O=R().net.createConnection(f,()=>{O.removeListener("error",T),c(k.Client.fromSocket(new S(O,`ipc-client${o}`),o))});O.once("error",T)})}e.connect=a}),define(we[151],ye([1,0,14,7,2,13]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));function C(R){const S=R;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var E;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class b extends D.Disposable{constructor(S,w=Object.create(null)){super(),this.database=S,this.options=w,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new y.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((w,d)=>this.accept(d,w)),S.deleted?.forEach(w=>this.accept(w,void 0))}accept(S,w){if(this.state===E.Closed)return;let d=!1;(0,I.isUndefinedOrNull)(w)?d=this.cache.delete(S):this.cache.get(S)!==w&&(this.cache.set(S,w),d=!0),d&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,w){const d=this.cache.get(S);return(0,I.isUndefinedOrNull)(d)?w:d}getBoolean(S,w){const d=this.get(S);return(0,I.isUndefinedOrNull)(d)?w:d==="true"}getNumber(S,w){const d=this.get(S);return(0,I.isUndefinedOrNull)(d)?w:parseInt(d,10)}async set(S,w){if(this.state===E.Closed)return;if((0,I.isUndefinedOrNull)(w))return this.delete(S);const d=String(w);if(this.cache.get(S)!==d)return this.cache.set(S,d),this.pendingInserts.set(S,d),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===E.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class k{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((w,d)=>this.items.set(d,w)),S.delete?.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=k}),define(we[100],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class y{constructor(D,I){this.lineNumber=D,this.column=I}with(D=this.lineNumber,I=this.column){return D===this.lineNumber&&I===this.column?this:new y(D,I)}delta(D=0,I=0){return this.with(this.lineNumber+D,this.column+I)}equals(D){return y.equals(this,D)}static equals(D,I){return!D&&!I?!0:!!D&&!!I&&D.lineNumber===I.lineNumber&&D.column===I.column}isBefore(D){return y.isBefore(this,D)}static isBefore(D,I){return D.lineNumber<I.lineNumber?!0:I.lineNumber<D.lineNumber?!1:D.column<I.column}isBeforeOrEqual(D){return y.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,I){return D.lineNumber<I.lineNumber?!0:I.lineNumber<D.lineNumber?!1:D.column<=I.column}static compare(D,I){const P=D.lineNumber|0,C=I.lineNumber|0;if(P===C){const E=D.column|0,b=I.column|0;return E-b}return P-C}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new y(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=y}),define(we[48],ye([1,0,100]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(I,P,C,E){I>C||I===C&&P>E?(this.startLineNumber=C,this.startColumn=E,this.endLineNumber=I,this.endColumn=P):(this.startLineNumber=I,this.startColumn=P,this.endLineNumber=C,this.endColumn=E)}isEmpty(){return t.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return t.containsPosition(this,I)}static containsPosition(I,P){return!(P.lineNumber<I.startLineNumber||P.lineNumber>I.endLineNumber||P.lineNumber===I.startLineNumber&&P.column<I.startColumn||P.lineNumber===I.endLineNumber&&P.column>I.endColumn)}static strictContainsPosition(I,P){return!(P.lineNumber<I.startLineNumber||P.lineNumber>I.endLineNumber||P.lineNumber===I.startLineNumber&&P.column<=I.startColumn||P.lineNumber===I.endLineNumber&&P.column>=I.endColumn)}containsRange(I){return t.containsRange(this,I)}static containsRange(I,P){return!(P.startLineNumber<I.startLineNumber||P.endLineNumber<I.startLineNumber||P.startLineNumber>I.endLineNumber||P.endLineNumber>I.endLineNumber||P.startLineNumber===I.startLineNumber&&P.startColumn<I.startColumn||P.endLineNumber===I.endLineNumber&&P.endColumn>I.endColumn)}strictContainsRange(I){return t.strictContainsRange(this,I)}static strictContainsRange(I,P){return!(P.startLineNumber<I.startLineNumber||P.endLineNumber<I.startLineNumber||P.startLineNumber>I.endLineNumber||P.endLineNumber>I.endLineNumber||P.startLineNumber===I.startLineNumber&&P.startColumn<=I.startColumn||P.endLineNumber===I.endLineNumber&&P.endColumn>=I.endColumn)}plusRange(I){return t.plusRange(this,I)}static plusRange(I,P){let C,E,b,k;return P.startLineNumber<I.startLineNumber?(C=P.startLineNumber,E=P.startColumn):P.startLineNumber===I.startLineNumber?(C=P.startLineNumber,E=Math.min(P.startColumn,I.startColumn)):(C=I.startLineNumber,E=I.startColumn),P.endLineNumber>I.endLineNumber?(b=P.endLineNumber,k=P.endColumn):P.endLineNumber===I.endLineNumber?(b=P.endLineNumber,k=Math.max(P.endColumn,I.endColumn)):(b=I.endLineNumber,k=I.endColumn),new t(C,E,b,k)}intersectRanges(I){return t.intersectRanges(this,I)}static intersectRanges(I,P){let C=I.startLineNumber,E=I.startColumn,b=I.endLineNumber,k=I.endColumn;const R=P.startLineNumber,S=P.startColumn,w=P.endLineNumber,d=P.endColumn;return C<R?(C=R,E=S):C===R&&(E=Math.max(E,S)),b>w?(b=w,k=d):b===w&&(k=Math.min(k,d)),C>b||C===b&&E>k?null:new t(C,E,b,k)}equalsRange(I){return t.equalsRange(this,I)}static equalsRange(I,P){return!I&&!P?!0:!!I&&!!P&&I.startLineNumber===P.startLineNumber&&I.startColumn===P.startColumn&&I.endLineNumber===P.endLineNumber&&I.endColumn===P.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(I){return new y.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(I){return new y.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,P){return new t(this.startLineNumber,this.startColumn,I,P)}setStartPosition(I,P){return new t(I,P,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(I){return new t(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static collapseToStart(I){return new t(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,P=I){return new t(I.lineNumber,I.column,P.lineNumber,P.column)}static lift(I){return I?new t(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,P){return!(I.endLineNumber<P.startLineNumber||I.endLineNumber===P.startLineNumber&&I.endColumn<P.startColumn||P.endLineNumber<I.startLineNumber||P.endLineNumber===I.startLineNumber&&P.endColumn<I.startColumn)}static areIntersecting(I,P){return!(I.endLineNumber<P.startLineNumber||I.endLineNumber===P.startLineNumber&&I.endColumn<=P.startColumn||P.endLineNumber<I.startLineNumber||P.endLineNumber===I.startLineNumber&&P.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,P){if(I&&P){const b=I.startLineNumber|0,k=P.startLineNumber|0;if(b===k){const R=I.startColumn|0,S=P.startColumn|0;if(R===S){const w=I.endLineNumber|0,d=P.endLineNumber|0;if(w===d){const g=I.endColumn|0,v=P.endColumn|0;return g-v}return w-d}return R-S}return b-k}return(I?1:0)-(P?1:0)}static compareRangesUsingEnds(I,P){return I.endLineNumber===P.endLineNumber?I.endColumn===P.endColumn?I.startLineNumber===P.startLineNumber?I.startColumn-P.startColumn:I.startLineNumber-P.startLineNumber:I.endColumn-P.endColumn:I.endLineNumber-P.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[152],ye([1,0,7,2]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,E){return this._map.set(C,E),this.fire([C]),(0,t.toDisposable)(()=>{this._map.get(C)===E&&(this._map.delete(C),this.fire([C]))})}registerFactory(C,E){this._factories.get(C)?.dispose();const b=new I(this,C,E);return this._factories.set(C,b),(0,t.toDisposable)(()=>{const k=this._factories.get(C);!k||k!==b||(this._factories.delete(C),k.dispose())})}async getOrCreate(C){const E=this.get(C);if(E)return E;const b=this._factories.get(C);return!b||b.isResolved?null:(await b.resolve(),this.get(C))}get(C){return this._map.get(C)||null}isResolved(C){if(this.get(C))return!0;const b=this._factories.get(C);return!!(!b||b.isResolved)}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class I extends t.Disposable{get isResolved(){return this._isResolved}constructor(C,E,b){super(),this._registry=C,this._languageId=E,this._factory=b,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const C=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,C&&!this._isDisposed&&this._register(this._registry.register(this._languageId,C))}}}),define(we[153],ye([1,0,41,4,48,152]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class P{constructor(T,O,K){this._tokenBrand=void 0,this.offset=T,this.type=O,this.language=K}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=P;class C{constructor(T,O){this._tokenizationResultBrand=void 0,this.tokens=T,this.endState=O}}e.TokenizationResult=C;class E{constructor(T,O){this._encodedTokenizationResultBrand=void 0,this.tokens=T,this.endState=O}}e.EncodedTokenizationResult=E;var b;(function(c){c[c.Method=0]="Method",c[c.Function=1]="Function",c[c.Constructor=2]="Constructor",c[c.Field=3]="Field",c[c.Variable=4]="Variable",c[c.Class=5]="Class",c[c.Struct=6]="Struct",c[c.Interface=7]="Interface",c[c.Module=8]="Module",c[c.Property=9]="Property",c[c.Event=10]="Event",c[c.Operator=11]="Operator",c[c.Unit=12]="Unit",c[c.Value=13]="Value",c[c.Constant=14]="Constant",c[c.Enum=15]="Enum",c[c.EnumMember=16]="EnumMember",c[c.Keyword=17]="Keyword",c[c.Text=18]="Text",c[c.Color=19]="Color",c[c.File=20]="File",c[c.Reference=21]="Reference",c[c.Customcolor=22]="Customcolor",c[c.Folder=23]="Folder",c[c.TypeParameter=24]="TypeParameter",c[c.User=25]="User",c[c.Issue=26]="Issue",c[c.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var k;(function(c){const T=new Map;T.set(0,y.Codicon.symbolMethod),T.set(1,y.Codicon.symbolFunction),T.set(2,y.Codicon.symbolConstructor),T.set(3,y.Codicon.symbolField),T.set(4,y.Codicon.symbolVariable),T.set(5,y.Codicon.symbolClass),T.set(6,y.Codicon.symbolStruct),T.set(7,y.Codicon.symbolInterface),T.set(8,y.Codicon.symbolModule),T.set(9,y.Codicon.symbolProperty),T.set(10,y.Codicon.symbolEvent),T.set(11,y.Codicon.symbolOperator),T.set(12,y.Codicon.symbolUnit),T.set(13,y.Codicon.symbolValue),T.set(15,y.Codicon.symbolEnum),T.set(14,y.Codicon.symbolConstant),T.set(15,y.Codicon.symbolEnum),T.set(16,y.Codicon.symbolEnumMember),T.set(17,y.Codicon.symbolKeyword),T.set(27,y.Codicon.symbolSnippet),T.set(18,y.Codicon.symbolText),T.set(19,y.Codicon.symbolColor),T.set(20,y.Codicon.symbolFile),T.set(21,y.Codicon.symbolReference),T.set(22,y.Codicon.symbolCustomColor),T.set(23,y.Codicon.symbolFolder),T.set(24,y.Codicon.symbolTypeParameter),T.set(25,y.Codicon.account),T.set(26,y.Codicon.issues);function O(le){let ae=T.get(le);return ae||(console.info("No codicon found for CompletionItemKind "+le),ae=y.Codicon.symbolProperty),ae}c.toIcon=O;const K=new Map;K.set("method",0),K.set("function",1),K.set("constructor",2),K.set("field",3),K.set("variable",4),K.set("class",5),K.set("struct",6),K.set("interface",7),K.set("module",8),K.set("property",9),K.set("event",10),K.set("operator",11),K.set("unit",12),K.set("value",13),K.set("constant",14),K.set("enum",15),K.set("enum-member",16),K.set("enumMember",16),K.set("keyword",17),K.set("snippet",27),K.set("text",18),K.set("color",19),K.set("file",20),K.set("reference",21),K.set("customcolor",22),K.set("folder",23),K.set("type-parameter",24),K.set("typeParameter",24),K.set("account",25),K.set("issue",26);function re(le,ae){let F=K.get(le);return typeof F>"u"&&!ae&&(F=9),F}c.fromString=re})(k=e.CompletionItemKinds||(e.CompletionItemKinds={}));var R;(function(c){c[c.Deprecated=1]="Deprecated"})(R=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(c){c[c.KeepWhitespace=1]="KeepWhitespace",c[c.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(c){c[c.Invoke=0]="Invoke",c[c.TriggerCharacter=1]="TriggerCharacter",c[c.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var d;(function(c){c[c.Automatic=0]="Automatic",c[c.Explicit=1]="Explicit"})(d=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(c){c[c.Invoke=1]="Invoke",c[c.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(c){return c&&t.URI.isUri(c.uri)&&D.Range.isIRange(c.range)&&(D.Range.isIRange(c.originSelectionRange)||D.Range.isIRange(c.targetSelectionRange))}e.isLocationLink=p;var u;(function(c){c[c.File=0]="File",c[c.Module=1]="Module",c[c.Namespace=2]="Namespace",c[c.Package=3]="Package",c[c.Class=4]="Class",c[c.Method=5]="Method",c[c.Property=6]="Property",c[c.Field=7]="Field",c[c.Constructor=8]="Constructor",c[c.Enum=9]="Enum",c[c.Interface=10]="Interface",c[c.Function=11]="Function",c[c.Variable=12]="Variable",c[c.Constant=13]="Constant",c[c.String=14]="String",c[c.Number=15]="Number",c[c.Boolean=16]="Boolean",c[c.Array=17]="Array",c[c.Object=18]="Object",c[c.Key=19]="Key",c[c.Null=20]="Null",c[c.EnumMember=21]="EnumMember",c[c.Struct=22]="Struct",c[c.Event=23]="Event",c[c.Operator=24]="Operator",c[c.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var l;(function(c){c[c.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var h;(function(c){const T=new Map;T.set(0,y.Codicon.symbolFile),T.set(1,y.Codicon.symbolModule),T.set(2,y.Codicon.symbolNamespace),T.set(3,y.Codicon.symbolPackage),T.set(4,y.Codicon.symbolClass),T.set(5,y.Codicon.symbolMethod),T.set(6,y.Codicon.symbolProperty),T.set(7,y.Codicon.symbolField),T.set(8,y.Codicon.symbolConstructor),T.set(9,y.Codicon.symbolEnum),T.set(10,y.Codicon.symbolInterface),T.set(11,y.Codicon.symbolFunction),T.set(12,y.Codicon.symbolVariable),T.set(13,y.Codicon.symbolConstant),T.set(14,y.Codicon.symbolString),T.set(15,y.Codicon.symbolNumber),T.set(16,y.Codicon.symbolBoolean),T.set(17,y.Codicon.symbolArray),T.set(18,y.Codicon.symbolObject),T.set(19,y.Codicon.symbolKey),T.set(20,y.Codicon.symbolNull),T.set(21,y.Codicon.symbolEnumMember),T.set(22,y.Codicon.symbolStruct),T.set(23,y.Codicon.symbolEvent),T.set(24,y.Codicon.symbolOperator),T.set(25,y.Codicon.symbolTypeParameter);function O(K){let re=T.get(K);return re||(console.info("No codicon found for SymbolKind "+K),re=y.Codicon.symbolProperty),re}c.toIcon=O})(h=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(T){this.value=T}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var r;(function(c){function T(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}c.is=T})(r=e.Command||(e.Command={}));var n;(function(c){c[c.Collapsed=0]="Collapsed",c[c.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(c){c[c.Unresolved=0]="Unresolved",c[c.Resolved=1]="Resolved"})(s=e.CommentThreadState||(e.CommentThreadState={}));var a;(function(c){c[c.Editing=0]="Editing",c[c.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var f;(function(c){c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var o;(function(c){c[c.None=0]="None",c[c.Option=1]="Option",c[c.Default=2]="Default",c[c.Preferred=3]="Preferred"})(o=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[154],ye([10,11]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(we[155],ye([1,0,154]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,I=D*24,P=I*7,C=I*30,E=I*365;function b(R,S,w){typeof R!="number"&&(R=R.getTime());const d=Math.round((new Date().getTime()-R)/1e3);if(d<-30)return(0,y.localize)(0,null,b(new Date().getTime()+d*1e3,!1));if(d<30)return(0,y.localize)(1,null);let g;return d<t?(g=d,S?g===1?w?(0,y.localize)(2,null,g):(0,y.localize)(3,null,g):w?(0,y.localize)(4,null,g):(0,y.localize)(5,null,g):g===1?w?(0,y.localize)(6,null,g):(0,y.localize)(7,null,g):w?(0,y.localize)(8,null,g):(0,y.localize)(9,null,g)):d<D?(g=Math.floor(d/t),S?g===1?w?(0,y.localize)(10,null,g):(0,y.localize)(11,null,g):w?(0,y.localize)(12,null,g):(0,y.localize)(13,null,g):g===1?w?(0,y.localize)(14,null,g):(0,y.localize)(15,null,g):w?(0,y.localize)(16,null,g):(0,y.localize)(17,null,g)):d<I?(g=Math.floor(d/D),S?g===1?w?(0,y.localize)(18,null,g):(0,y.localize)(19,null,g):w?(0,y.localize)(20,null,g):(0,y.localize)(21,null,g):g===1?w?(0,y.localize)(22,null,g):(0,y.localize)(23,null,g):w?(0,y.localize)(24,null,g):(0,y.localize)(25,null,g)):d<P?(g=Math.floor(d/I),S?g===1?(0,y.localize)(26,null,g):(0,y.localize)(27,null,g):g===1?(0,y.localize)(28,null,g):(0,y.localize)(29,null,g)):d<C?(g=Math.floor(d/P),S?g===1?w?(0,y.localize)(30,null,g):(0,y.localize)(31,null,g):w?(0,y.localize)(32,null,g):(0,y.localize)(33,null,g):g===1?w?(0,y.localize)(34,null,g):(0,y.localize)(35,null,g):w?(0,y.localize)(36,null,g):(0,y.localize)(37,null,g)):d<E?(g=Math.floor(d/C),S?g===1?w?(0,y.localize)(38,null,g):(0,y.localize)(39,null,g):w?(0,y.localize)(40,null,g):(0,y.localize)(41,null,g):g===1?w?(0,y.localize)(42,null,g):(0,y.localize)(43,null,g):w?(0,y.localize)(44,null,g):(0,y.localize)(45,null,g)):(g=Math.floor(d/E),S?g===1?w?(0,y.localize)(46,null,g):(0,y.localize)(47,null,g):w?(0,y.localize)(48,null,g):(0,y.localize)(49,null,g):g===1?w?(0,y.localize)(50,null,g):(0,y.localize)(51,null,g):w?(0,y.localize)(52,null,g):(0,y.localize)(53,null,g))}e.fromNow=b;function k(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=k}),define(we[156],ye([10,11]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(we[38],ye([1,0,18,13,156]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function I(R,S){return S&&(R.stack||R.stacktrace)?D.localize(0,null,C(R),P(R.stack)||P(R.stacktrace)):C(R)}function P(R){return Array.isArray(R)?R.join(`
`):R}function C(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?D.localize(1,null,R.message):R.message||D.localize(2,null)}function E(R=null,S=!1){if(!R)return D.localize(3,null);if(Array.isArray(R)){const w=y.coalesce(R),d=E(w[0],S);return w.length>1?D.localize(4,null,d,w.length):d}if(t.isString(R))return R;if(R.detail){const w=R.detail;if(w.error)return I(w.error,S);if(w.exception)return I(w.exception,S)}return R.stack?I(R,S):R.message?R.message:D.localize(5,null)}e.toErrorMessage=E;function b(R){const S=R;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=b;function k(R,S){let w;return typeof R=="string"?w=new Error(R):w=R,w.actions=S,w}e.createErrorWithActions=k}),define(we[157],ye([10,11]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(we[158],ye([1,0,157]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(D){switch(D){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(we[159],ye([10,11]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(we[160],ye([10,11]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[161],ye([10,11]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(we[162],ye([10,11]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(we[163],ye([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[164],ye([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[165],ye([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(we[166],ye([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(we[167],ye([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[168],ye([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[169],ye([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[170],ye([10,11]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[171],ye([10,11]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(we[172],ye([10,11]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(we[173],ye([10,11]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(we[174],ye([10,11]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[175],ye([10,11]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[176],ye([10,11]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(we[177],ye([10,11]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(we[178],ye([10,11]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(we[179],ye([10,11]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[180],ye([10,11]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[181],ye([10,11]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[182],ye([10,11]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(we[183],ye([10,11]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(we[184],ye([10,11]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(we[185],ye([10,11]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(we[186],ye([10,11]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[187],ye([10,11]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(we[188],ye([1,0,7,2]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new y.Emitter,this._onReloadEmitter=new y.Emitter,this._onTerminateEmitter=new y.Emitter,this._onAttachEmitter=new y.Emitter}call(C,E,b){switch(E){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(C,E,b){switch(E){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class I extends t.Disposable{constructor(C){super(),this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,E,b){this.channel.call("attach",[C,E,b])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,E){this.channel.call("terminate",[C,E])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,E){return this.channel.call("openExtensionDevelopmentHostWindow",[C,E])}}e.ExtensionHostDebugChannelClient=I}),define(we[189],ye([1,0,4]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(P){this.service=P}listen(P,C,E){throw new Error("Invalid listen")}call(P,C,E){switch(C){case"download":return this.service.download(y.URI.revive(E[0]),y.URI.revive(E[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class D{constructor(P,C){this.channel=P,this.getUriTransformer=C}async download(P,C){const E=this.getUriTransformer();E&&(P=E.transformOutgoingURI(P),C=E.transformOutgoingURI(C)),await this.channel.call("download",[P,C])}}e.DownloadServiceChannelClient=D}),define(we[190],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class y{constructor(D){this.machineId=D}encryption(){return new Promise((D,I)=>oe(["vscode-encrypt"],D,I))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=y}),define(we[101],ye([1,0,155,85,9,6,26,19,4]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,I.dirname)(D.FileAccess.asFileUri("",oe).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,I.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return E.URI.file((0,I.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(E.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=P.env.VSCODE_PORTABLE;return g?E.URI.file((0,I.join)(g,"argv.json")):(0,C.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,I.resolve)(g):(0,I.normalize)((0,I.join)(D.FileAccess.asFileUri("",oe).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?E.URI.file((0,I.resolve)(g)):E.URI.file((0,I.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,I.resolve)(g);const v=P.env.VSCODE_EXTENSIONS;if(v)return v;const m=P.env.VSCODE_PORTABLE;return m?(0,I.join)(m,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(v=>/^[^:/?#]+?:\/\//.test(v)?E.URI.parse(v):E.URI.file((0,I.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?E.URI.parse(g):E.URI.file((0,I.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return k(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const v of this.args.log||[]){const m=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);m&&m[1]&&m[2]&&g.push([m[1],m[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,C.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=P.env.VSCODE_PORTABLE;return g?E.URI.file((0,I.join)(g,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this._args}constructor(g,v,m){this._args=g,this.paths=v,this.productService=m,this.editSessionId=this.args.editSessionId}}Ae([t.memoize],b.prototype,"appRoot",null),Ae([t.memoize],b.prototype,"userHome",null),Ae([t.memoize],b.prototype,"userDataPath",null),Ae([t.memoize],b.prototype,"appSettingsHome",null),Ae([t.memoize],b.prototype,"tmpDir",null),Ae([t.memoize],b.prototype,"cacheHome",null),Ae([t.memoize],b.prototype,"stateResource",null),Ae([t.memoize],b.prototype,"userRoamingDataHome",null),Ae([t.memoize],b.prototype,"userDataSyncHome",null),Ae([t.memoize],b.prototype,"userDataSyncLogResource",null),Ae([t.memoize],b.prototype,"editSessionsLogResource",null),Ae([t.memoize],b.prototype,"remoteTunnelLogResource",null),Ae([t.memoize],b.prototype,"sync",null),Ae([t.memoize],b.prototype,"machineSettingsResource",null),Ae([t.memoize],b.prototype,"workspaceStorageHome",null),Ae([t.memoize],b.prototype,"localHistoryHome",null),Ae([t.memoize],b.prototype,"keyboardLayoutResource",null),Ae([t.memoize],b.prototype,"argvResource",null),Ae([t.memoize],b.prototype,"isExtensionDevelopment",null),Ae([t.memoize],b.prototype,"untitledWorkspacesHome",null),Ae([t.memoize],b.prototype,"installSourcePath",null),Ae([t.memoize],b.prototype,"builtinExtensionsPath",null),Ae([t.memoize],b.prototype,"extensionsPath",null),Ae([t.memoize],b.prototype,"extensionDevelopmentLocationURI",null),Ae([t.memoize],b.prototype,"extensionDevelopmentKind",null),Ae([t.memoize],b.prototype,"extensionTestsLocationURI",null),Ae([t.memoize],b.prototype,"debugExtensionHost",null),Ae([t.memoize],b.prototype,"logLevel",null),Ae([t.memoize],b.prototype,"extensionLogLevel",null),Ae([t.memoize],b.prototype,"serviceMachineIdResource",null),Ae([t.memoize],b.prototype,"telemetryLogResource",null),Ae([t.memoize],b.prototype,"disableWorkspaceTrust",null),Ae([t.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function k(d,g){return w(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=k;function R(d,g){return w(d["inspect-search"],d["inspect-brk-search"],5876,g,d.extensionEnvironment)}e.parseSearchPort=R;function S(d,g){return w(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g,d.extensionEnvironment)}e.parsePtyHostPort=S;function w(d,g,v,m,p,u){const h=Number(g||d)||(m?null:v),i=h?Boolean(!!g):!1;let r;if(u)try{r=JSON.parse(u)}catch{}return{port:h,break:i,debugId:p,env:r}}}),define(we[59],ye([1,0,273,3,161]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const I={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(g,v,m=P){const p=g.find(f=>f.length>0&&f[0]!=="-"),u={},l=["_"],h=[],i={};let r;for(const f in v){const o=v[f];o.type==="subcommand"?f===p&&(r=o):(o.alias&&(u[f]=o.alias),o.type==="string"||o.type==="string[]"?(l.push(f),o.deprecates&&l.push(...o.deprecates)):o.type==="boolean"&&(h.push(f),o.deprecates&&h.push(...o.deprecates)),o.global&&(i[f]=o))}if(r&&p){const f=i;for(const O in r.options)f[O]=r.options[O];const o=g.filter(O=>O!==p),c=m.getSubcommandReporter?m.getSubcommandReporter(p):void 0,T=C(o,f,c);return{[p]:T,_:[]}}const n=y(g,{string:l,boolean:h,alias:u}),s={},a=n;s._=n._.map(f=>String(f)).filter(f=>f.length>0),delete a._;for(const f in v){const o=v[f];if(o.type==="subcommand")continue;o.alias&&delete a[o.alias];let c=a[f];if(o.deprecates)for(const T of o.deprecates)a.hasOwnProperty(T)&&(c||(c=a[T],c&&m.onDeprecatedOption(T,o.deprecationMessage||(0,D.localize)(36,null,f))),delete a[T]);if(typeof c<"u"){if(o.type==="string[]"){if(Array.isArray(c)||(c=[c]),!o.allowEmptyValue){const T=c.filter(O=>O.length>0);T.length!==c.length&&(m.onEmptyValue(f),c=T.length>0?T:void 0)}}else o.type==="string"&&(Array.isArray(c)?(c=c.pop(),m.onMultipleValues(f,c)):!c&&!o.allowEmptyValue&&(m.onEmptyValue(f),c=void 0));s[f]=c,o.deprecationMessage&&m.onDeprecatedOption(f,o.deprecationMessage)}delete a[f]}for(const f in a)m.onUnknownOption(f);return s}e.parseArgs=C;function E(g,v){let m="";return v.args&&(Array.isArray(v.args)?m=` <${v.args.join("> <")}>`:m=` <${v.args}>`),v.alias?`-${v.alias} --${g}${m}`:`--${g}${m}`}function b(g,v){const m=[];for(const p in g){const u=g[p],l=E(p,u);m.push([l,u.description])}return k(m,v)}e.formatOptions=b;function k(g,v){const p=g.reduce((h,i)=>Math.max(h,i[0].length),12)+2+1;if(v-p<25)return g.reduce((h,i)=>h.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const u=v-p-1,l=[];for(const h of g){const i=h[0],r=S(h[1],u),n=R(p-i.length-2);l.push("  "+i+n+r[0]);for(let s=1;s<r.length;s++)l.push(R(p)+r[s])}return l}function R(g){return" ".repeat(g)}function S(g,v){const m=[];for(;g.length;){const p=g.length<v?g.length:g.lastIndexOf(" ",v),u=g.slice(0,p).trim();g=g.slice(p),m.push(u)}return m}function w(g,v,m,p,u){const l=process.stdout.isTTY&&process.stdout.columns||80,h=u?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",i=[`${g} ${m}`];i.push(""),i.push(`${(0,D.localize)(38,null)}: ${v} [${(0,D.localize)(39,null)}]${h}`),i.push(""),u?.noPipe!==!0&&(t.isWindows?i.push((0,D.localize)(40,null,v)):i.push((0,D.localize)(41,null,v)),i.push(""));const r={},n=[];for(const s in p){const a=p[s];if(a.type==="subcommand")a.description&&n.push({command:s,description:a.description});else if(a.description&&a.cat){let f=r[a.cat];f||(r[a.cat]=f={}),f[s]=a}}for(const s in r){const a=s,f=r[a];f&&(i.push(I[a]),i.push(...b(f,l)),i.push(""))}return n.length&&(i.push((0,D.localize)(42,null)),i.push(...k(n.map(s=>[s.command,s.description]),l)),i.push("")),i.join(`
`)}e.buildHelpMessage=w;function d(g,v){return`${g||(0,D.localize)(43,null)}
${v||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(we[191],ye([1,0,274,162,59]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const I=2048;function P(S,w){const d=(l,h)=>{console.warn((0,t.localize)(0,null,l,h))},g=l=>{console.warn((0,t.localize)(1,null,l))},v=(l,h)=>{console.warn((0,t.localize)(2,null,l,h))},m=l=>({onUnknownOption:h=>{l!=="tunnel"&&console.warn((0,t.localize)(3,null,h,l))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:v,getSubcommandReporter:l!=="tunnel"?m:void 0}),p={onUnknownOption:l=>{console.warn((0,t.localize)(4,null,l))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:v,getSubcommandReporter:m},u=(0,D.parseArgs)(S,D.OPTIONS,w?p:void 0);return u.goto&&u._.forEach(l=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(l),(0,t.localize)(5,null))),u["max-memory"]&&y(parseInt(u["max-memory"])>=I,`The max-memory argument cannot be specified lower than ${I} MB.`),u}function C(S){const w=S.findIndex(d=>!/^-/.test(d));if(w>-1)return[...S.slice(0,w),...S.slice(w+1)]}function E(S){let[,...w]=S;process.env.VSCODE_DEV&&(w=C(w)||[]);const d=!R(process.env);return P(w,d)}e.parseMainProcessArgv=E;function b(S){let[,,...w]=S;return process.env.VSCODE_DEV&&(w=C(w)||[]),P(w,!0)}e.parseCLIProcessArgv=b;function k(S,...w){const d=S.indexOf("--");return d===-1?S.push(...w):S.splice(d,0,...w),S}e.addArg=k;function R(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function oe(e,y,t){function D(P,C){const E=I(P,C),b=[E];return e.isAbsolute(E)||b.unshift(t),e.resolve(...b)}function I(P,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,C);const k=P["user-data-dir"];if(k)return k;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(R,"AppData","Roaming")}break;case"darwin":b=e.join(y.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,C)}return{getUserDataPath:D}}if(typeof define=="function")define(we[192],ye([92,27,26]),function(e,y,t){return oe(e,y,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=oe(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[193],ye([1,0,27,101,192]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class I extends t.AbstractNativeEnvironmentService{constructor(C,E){super(C,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,D.getUserDataPath)(C,E.nameShort)},E)}}e.NativeEnvironmentService=I}),define(we[194],ye([1,0,13,166]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(P,C,E){try{I(P,C,E)}catch{}return P}e.localizeManifest=D;function I(P,C,E){const b=(k,R,S)=>{const w=k[R];if((0,y.isString)(w)){const d=w,g=d.length;if(g>1&&d[0]==="%"&&d[g-1]==="%"){const v=d.substr(1,g-2);let m=C[v];m===void 0&&E&&(m=E[v]);const p=typeof m=="string"?m:m.message;if(p!==void 0){const u=E?.[v],l=typeof u=="string"?u:u?.message;if(S&&(R==="title"||R==="category")&&l&&l!==p){const h={value:p,original:l};k[R]=h}else k[R]=p}else console.warn(`[${P.name}]: ${(0,t.localize)(0,null,v)}`)}}else if((0,y.isObject)(w))for(const d in w)w.hasOwnProperty(d)&&(d==="commands"?b(w,d,!0):b(w,d,S));else if(Array.isArray(w))for(let d=0;d<w.length;d++)b(w,d,S)};for(const k in P)P.hasOwnProperty(k)&&b(P,k)}}),define(we[72],ye([1,0,19,69,170,49]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function E(m){return m=m.trim(),m==="*"||P.test(m)}e.isValidVersionStr=E;function b(m){if(!E(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=m.match(P);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=b;function k(m){if(!m)return null;const p=m.majorBase,u=m.majorMustEqual,l=m.minorBase;let h=m.minorMustEqual;const i=m.patchBase;let r=m.patchMustEqual;m.hasCaret&&(p===0||(h=!1),r=!1);let n=0;if(m.preRelease){const s=C.exec(m.preRelease);if(s){const[,a,f,o]=s;n=Date.UTC(Number(a),Number(f)-1,Number(o))}}return{majorBase:p,majorMustEqual:u,minorBase:l,minorMustEqual:h,patchBase:i,patchMustEqual:r,isMinimum:m.hasGreaterEquals,notBefore:n}}e.normalizeVersion=k;function R(m,p,u){let l;typeof m=="string"?l=k(b(m)):l=m;let h;p instanceof Date?h=p.getTime():typeof p=="string"&&(h=new Date(p).getTime());let i;if(typeof u=="string"?i=k(b(u)):i=u,!l||!i)return!1;const r=l.majorBase,n=l.minorBase,s=l.patchBase;let a=i.majorBase,f=i.minorBase,o=i.patchBase;const c=i.notBefore;let T=i.majorMustEqual,O=i.minorMustEqual,K=i.patchMustEqual;return i.isMinimum?r>a?!0:r<a?!1:n>f?!0:n<f||h&&h<c?!1:s>=o:(r===1&&a===0&&(!T||!O||!K)&&(a=1,f=0,o=0,T=!0,O=!1,K=!1),r<a?!1:r>a?!T:n<f?!1:n>f?!O:s<o?!1:s>o?!K:!(h&&h<c))}e.isValidVersion=R;function S(m,p,u,l,h){const i=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return i.push([t.default.Error,D.localize(0,null)]),i;if(typeof l.name!="string")return i.push([t.default.Error,D.localize(1,null,"name")]),i;if(typeof l.version!="string")return i.push([t.default.Error,D.localize(2,null,"version")]),i;if(!l.engines)return i.push([t.default.Error,D.localize(3,null,"engines")]),i;if(typeof l.engines.vscode!="string")return i.push([t.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof l.extensionDependencies<"u"&&!v(l.extensionDependencies))return i.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof l.activationEvents<"u"){if(!v(l.activationEvents))return i.push([t.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof l.main>"u"&&typeof l.browser>"u")return i.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&i.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return i.push([t.default.Error,D.localize(9,null,"main")]),i;{const s=(0,y.joinPath)(u,l.main);(0,y.isEqualOrParent)(s,u)||i.push([t.default.Warning,D.localize(10,null,s.path,u.path)])}if(typeof l.activationEvents>"u")return i.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof l.browser<"u"){if(typeof l.browser!="string")return i.push([t.default.Error,D.localize(12,null,"browser")]),i;{const s=(0,y.joinPath)(u,l.browser);(0,y.isEqualOrParent)(s,u)||i.push([t.default.Warning,D.localize(13,null,s.path,u.path)])}if(typeof l.activationEvents>"u")return i.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!I.valid(l.version))return i.push([t.default.Error,D.localize(15,null)]),i;const r=[];if(!w(m,p,l,h,r))for(const s of r)i.push([t.default.Error,s]);return i}e.validateExtensionManifest=S;function w(m,p,u,l,h){return l||typeof u.main>"u"&&typeof u.browser>"u"?!0:g(m,p,u.engines.vscode,h)}e.isValidExtensionVersion=w;function d(m,p,u){return m==="*"||g(p,u,m)}e.isEngineValid=d;function g(m,p,u,l=[]){const h=k(b(u));if(!h)return l.push(D.localize(16,null,u)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return l.push(D.localize(17,null,u)),!1}else if(!h.majorMustEqual)return l.push(D.localize(18,null,u)),!1;return R(m,p,h)?!0:(l.push(D.localize(19,null,m,u)),!1)}function v(m){if(!Array.isArray(m))return!1;for(let p=0,u=m.length;p<u;p++)if(typeof m[p]!="string")return!1;return!0}}),define(we[195],ye([1,0,16,22]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(I,P,C){let E=C&&C.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const k=(await P.readFile(I.serviceMachineIdResource)).value.toString();E=(0,t.isUUID)(k)?k:null}catch{E=null}if(!E){E=(0,t.generateUuid)();try{await P.writeFile(I.serviceMachineIdResource,y.VSBuffer.fromString(E))}catch{}}return C?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=D}),define(we[60],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(D,I=[],P=!1){this.ctor=D,this.staticArguments=I,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=y}),define(we[196],ye([1,0,60]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var D;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function I(C,E,b){E instanceof y.SyncDescriptor||(E=new y.SyncDescriptor(E,[],Boolean(b))),t.push([C,E])}e.registerSingleton=I;function P(){return t}e.getSingletonServiceDescriptors=P}),define(we[197],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(I,P){this.key=I,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.Node=y;class t{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(const P of this._nodes.values())P.outgoing.size===0&&I.push(P);return I}insertEdge(I,P){const C=this.lookupOrInsertNode(I),E=this.lookupOrInsertNode(P);C.outgoing.set(E.key,E),E.incoming.set(C.key,C)}removeNode(I){const P=this._hashFn(I);this._nodes.delete(P);for(const C of this._nodes.values())C.outgoing.delete(P),C.incoming.delete(P)}lookupOrInsertNode(I){const P=this._hashFn(I);let C=this._nodes.get(P);return C||(C=new y(P,I),this._nodes.set(P,C)),C}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){const I=[];for(const[P,C]of this._nodes)I.push(`${P}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,P]of this._nodes){const C=new Set([I]),E=this._findCycle(P,C);if(E)return E}}_findCycle(I,P){for(const[C,E]of I.outgoing){if(P.has(C))return[...P,C].join(" -> ");P.add(C);const b=this._findCycle(E,P);if(b)return b;P.delete(C)}}}e.Graph=t}),define(we[5],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function C(E){return E[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=C})(y=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(P,C,E){C[y.DI_TARGET]===C?C[y.DI_DEPENDENCIES].push({id:P,index:E}):(C[y.DI_DEPENDENCIES]=[{id:P,index:E}],C[y.DI_TARGET]=C)}function D(P){if(y.serviceIds.has(P))return y.serviceIds.get(P);const C=function(E,b,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(C,E,k)};return C.toString=()=>P,y.serviceIds.set(P,C),C}e.createDecorator=D;function I(P){return P}e.refineServiceDecorator=I}),define(we[24],ye([1,0,13,4,5]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function I(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=I;function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=P;var C;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function b(m,p){const u=Object.create(null);for(const l in m)k(u,l,m[l],p);return u}e.toValuesTree=b;function k(m,p,u,l){const h=p.split("."),i=h.pop();let r=m;for(let n=0;n<h.length;n++){const s=h[n];let a=r[s];switch(typeof a){case"undefined":a=r[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${p} as ${h.slice(0,n+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[i]=u}catch{l(`Ignoring ${p} as ${h.join(".")} is ${JSON.stringify(r)}`)}else l(`Ignoring ${p} as ${h.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=k;function R(m,p){const u=p.split(".");S(m,u)}e.removeFromValueTree=R;function S(m,p){const u=p.shift();if(p.length===0){delete m[u];return}if(Object.keys(m).indexOf(u)!==-1){const l=m[u];typeof l=="object"&&!Array.isArray(l)&&(S(l,p),Object.keys(l).length===0&&delete m[u])}}function w(m,p,u){function l(r,n){let s=r;for(const a of n){if(typeof s!="object"||s===null)return;s=s[a]}return s}const h=p.split("."),i=l(m,h);return typeof i>"u"?u:i}e.getConfigurationValue=w;function d(m,p,u){Object.keys(p).forEach(l=>{l!=="__proto__"&&(l in m?y.isObject(m[l])&&y.isObject(p[l])?d(m[l],p[l],u):u&&(m[l]=p[l]):m[l]=p[l])})}e.merge=d;function g(m,p,u){const l=m.inspect(p),h=m.inspect(u);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:l.defaultValue}e.getMigratedSettingValue=g;function v(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(we[102],ye([1,0,3,15,5]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",y.isMacintosh),I.set("isLinux",y.isLinux),I.set("isWindows",y.isWindows),I.set("isWeb",y.isWeb),I.set("isMacNative",y.isMacintosh&&!y.isWeb),I.set("isEdge",y.isEdge),I.set("isFirefox",y.isFirefox),I.set("isChrome",y.isChrome),I.set("isSafari",y.isSafari);const P=Object.prototype.hasOwnProperty;var C;(function(ae){ae[ae.False=0]="False",ae[ae.True=1]="True",ae[ae.Defined=2]="Defined",ae[ae.Not=3]="Not",ae[ae.Equals=4]="Equals",ae[ae.NotEquals=5]="NotEquals",ae[ae.And=6]="And",ae[ae.Regex=7]="Regex",ae[ae.NotRegex=8]="NotRegex",ae[ae.Or=9]="Or",ae[ae.In=10]="In",ae[ae.NotIn=11]="NotIn",ae[ae.Greater=12]="Greater",ae[ae.GreaterEquals=13]="GreaterEquals",ae[ae.Smaller=14]="Smaller",ae[ae.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return R.INSTANCE}static true(){return S.INSTANCE}static has(F){return w.create(F)}static equals(F,Y){return d.create(F,Y)}static notEquals(F,Y){return m.create(F,Y)}static regex(F,Y){return n.create(F,Y)}static in(F,Y){return g.create(F,Y)}static notIn(F,Y){return v.create(F,Y)}static not(F){return p.create(F)}static and(...F){return f.create(F,null,!0)}static or(...F){return o.create(F,null,!0)}static greater(F,Y){return l.create(F,Y)}static greaterEquals(F,Y){return h.create(F,Y)}static smaller(F,Y){return i.create(F,Y)}static smallerEquals(F,Y){return r.create(F,Y)}static deserialize(F,Y=!1){if(!!F)return this._deserializeOrExpression(F,Y)}static _deserializeOrExpression(F,Y){const B=F.split("||");return o.create(B.map(H=>this._deserializeAndExpression(H,Y)),null,!0)}static _deserializeAndExpression(F,Y){const B=F.split("&&");return f.create(B.map(H=>this._deserializeOne(H,Y)),null,!0)}static _deserializeOne(F,Y){if(F=F.trim(),F.indexOf("!=")>=0){const B=F.split("!=");return m.create(B[0].trim(),this._deserializeValue(B[1],Y))}if(F.indexOf("==")>=0){const B=F.split("==");return d.create(B[0].trim(),this._deserializeValue(B[1],Y))}if(F.indexOf("=~")>=0){const B=F.split("=~");return n.create(B[0].trim(),this._deserializeRegexValue(B[1],Y))}if(F.indexOf(" not in ")>=0){const B=F.split(" not in ");return v.create(B[0].trim(),this._deserializeValue(B[1],Y))}if(F.indexOf(" in ")>=0){const B=F.split(" in ");return g.create(B[0].trim(),this._deserializeValue(B[1],Y))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const B=F.split(">=");return h.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const B=F.split(">");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const B=F.split("<=");return r.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const B=F.split("<");return i.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(F)?p.create(F.substr(1).trim()):w.create(F)}static _deserializeValue(F,Y){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const B=/^'([^']*)'$/.exec(F);return B?B[1].trim():F}static _deserializeRegexValue(F,Y){if((0,t.isFalsyOrWhitespace)(F)){if(Y)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const B=F.indexOf("/"),H=F.lastIndexOf("/");if(B===H||B<0){if(Y)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const $=F.slice(B+1,H),j=F[H+1]==="i"?"i":"";try{return new RegExp($,j)}catch(L){if(Y)throw new Error(`bad regexp-value '${F}', parse error: ${L}`);return console.warn(`bad regexp-value '${F}', parse error: ${L}`),null}}}e.ContextKeyExpr=E;function b(ae,F){const Y=ae?ae.substituteConstants():void 0,B=F?F.substituteConstants():void 0;return!Y&&!B?!0:!Y||!B?!1:Y.equals(B)}e.expressionsAreEqualWithConstantSubstitution=b;function k(ae,F){return ae.cmp(F)}class R{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class S{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class w{static create(F,Y=null){const B=I.get(F);return typeof B=="boolean"?B?S.INSTANCE:R.INSTANCE:new w(F,Y)}constructor(F,Y){this.key=F,this.negated=Y,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=I.get(this.key);return typeof F=="boolean"?F?S.INSTANCE:R.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class d{static create(F,Y,B=null){if(typeof Y=="boolean")return Y?w.create(F,B):p.create(F,B);const H=I.get(F);return typeof H=="boolean"?Y===(H?"true":"false")?S.INSTANCE:R.INSTANCE:new d(F,Y,B)}constructor(F,Y,B){this.key=F,this.value=Y,this.negated=B,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:O(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=I.get(this.key);if(typeof F=="boolean"){const Y=F?"true":"false";return this.value===Y?S.INSTANCE:R.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class g{static create(F,Y){return new g(F,Y)}constructor(F,Y){this.key=F,this.valueKey=Y,this.type=10,this.negated=null}cmp(F){return F.type!==this.type?this.type-F.type:O(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const Y=F.getValue(this.valueKey),B=F.getValue(this.key);return Array.isArray(Y)?Y.includes(B):typeof B=="string"&&typeof Y=="object"&&Y!==null?P.call(Y,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=g;class v{static create(F,Y){return new v(F,Y)}constructor(F,Y){this.key=F,this.valueKey=Y,this.type=11,this._negated=g.create(F,Y)}cmp(F){return F.type!==this.type?this.type-F.type:this._negated.cmp(F._negated)}equals(F){return F.type===this.type?this._negated.equals(F._negated):!1}substituteConstants(){return this}evaluate(F){return!this._negated.evaluate(F)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(F){return F.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=v;class m{static create(F,Y,B=null){if(typeof Y=="boolean")return Y?p.create(F,B):w.create(F,B);const H=I.get(F);return typeof H=="boolean"?Y===(H?"true":"false")?R.INSTANCE:S.INSTANCE:new m(F,Y,B)}constructor(F,Y,B){this.key=F,this.value=Y,this.negated=B,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:O(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=I.get(this.key);if(typeof F=="boolean"){const Y=F?"true":"false";return this.value===Y?R.INSTANCE:S.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class p{static create(F,Y=null){const B=I.get(F);return typeof B=="boolean"?B?R.INSTANCE:S.INSTANCE:new p(F,Y)}constructor(F,Y){this.key=F,this.negated=Y,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=I.get(this.key);return typeof F=="boolean"?F?R.INSTANCE:S.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function u(ae,F){if(typeof ae=="string"){const Y=parseFloat(ae);isNaN(Y)||(ae=Y)}return typeof ae=="string"||typeof ae=="number"?F(ae):R.INSTANCE}class l{static create(F,Y,B=null){return u(Y,H=>new l(F,H,B))}constructor(F,Y,B){this.key=F,this.value=Y,this.negated=B,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:O(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class h{static create(F,Y,B=null){return u(Y,H=>new h(F,H,B))}constructor(F,Y,B){this.key=F,this.value=Y,this.negated=B,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:O(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=h;class i{static create(F,Y,B=null){return u(Y,H=>new i(F,H,B))}constructor(F,Y,B){this.key=F,this.value=Y,this.negated=B,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:O(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class r{static create(F,Y,B=null){return u(Y,H=>new r(F,H,B))}constructor(F,Y,B){this.key=F,this.value=Y,this.negated=B,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:O(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class n{static create(F,Y){return new n(F,Y)}constructor(F,Y){this.key=F,this.regexp=Y,this.type=7,this.negated=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const Y=this.regexp?this.regexp.source:"",B=F.regexp?F.regexp.source:"";return Y<B?-1:Y>B?1:0}equals(F){if(F.type===this.type){const Y=this.regexp?this.regexp.source:"",B=F.regexp?F.regexp.source:"";return this.key===F.key&&Y===B}return!1}substituteConstants(){return this}evaluate(F){const Y=F.getValue(this.key);return this.regexp?this.regexp.test(Y):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class s{static create(F){return new s(F)}constructor(F){this._actual=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new s(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function a(ae){let F=null;for(let Y=0,B=ae.length;Y<B;Y++){const H=ae[Y].substituteConstants();if(ae[Y]!==H&&F===null){F=[];for(let $=0;$<Y;$++)F[$]=ae[$]}F!==null&&(F[Y]=H)}return F===null?ae:F}class f{static create(F,Y,B){return f._normalizeArr(F,Y,B)}constructor(F,Y){this.expr=F,this.negated=Y,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Y=0,B=this.expr.length;Y<B;Y++){const H=k(this.expr[Y],F.expr[Y]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Y=0,B=this.expr.length;Y<B;Y++)if(!this.expr[Y].equals(F.expr[Y]))return!1;return!0}return!1}substituteConstants(){const F=a(this.expr);return F===this.expr?this:f.create(F,this.negated,!1)}evaluate(F){for(let Y=0,B=this.expr.length;Y<B;Y++)if(!this.expr[Y].evaluate(F))return!1;return!0}static _normalizeArr(F,Y,B){const H=[];let $=!1;for(const j of F)if(!!j){if(j.type===1){$=!0;continue}if(j.type===0)return R.INSTANCE;if(j.type===6){H.push(...j.expr);continue}H.push(j)}if(H.length===0&&$)return S.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(k);for(let j=1;j<H.length;j++)H[j-1].equals(H[j])&&(H.splice(j,1),j--);if(H.length===1)return H[0];for(;H.length>1;){const j=H[H.length-1];if(j.type!==9)break;H.pop();const L=H.pop(),N=H.length===0,q=o.create(j.expr.map(se=>f.create([se,L],null,B)),null,N);q&&(H.push(q),H.sort(k))}if(H.length===1)return H[0];if(B){for(let j=0;j<H.length;j++)for(let L=j+1;L<H.length;L++)if(H[j].negate().equals(H[L]))return R.INSTANCE;if(H.length===1)return H[0]}return new f(H,Y)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const Y of this.expr)F.push(...Y.keys());return F}map(F){return new f(this.expr.map(Y=>Y.map(F)),null)}negate(){if(!this.negated){const F=[];for(const Y of this.expr)F.push(Y.negate());this.negated=o.create(F,this,!0)}return this.negated}}class o{static create(F,Y,B){return o._normalizeArr(F,Y,B)}constructor(F,Y){this.expr=F,this.negated=Y,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Y=0,B=this.expr.length;Y<B;Y++){const H=k(this.expr[Y],F.expr[Y]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Y=0,B=this.expr.length;Y<B;Y++)if(!this.expr[Y].equals(F.expr[Y]))return!1;return!0}return!1}substituteConstants(){const F=a(this.expr);return F===this.expr?this:o.create(F,this.negated,!1)}evaluate(F){for(let Y=0,B=this.expr.length;Y<B;Y++)if(this.expr[Y].evaluate(F))return!0;return!1}static _normalizeArr(F,Y,B){let H=[],$=!1;if(F){for(let j=0,L=F.length;j<L;j++){const N=F[j];if(!!N){if(N.type===0){$=!0;continue}if(N.type===1)return S.INSTANCE;if(N.type===9){H=H.concat(N.expr);continue}H.push(N)}}if(H.length===0&&$)return R.INSTANCE;H.sort(k)}if(H.length!==0){if(H.length===1)return H[0];for(let j=1;j<H.length;j++)H[j-1].equals(H[j])&&(H.splice(j,1),j--);if(H.length===1)return H[0];if(B){for(let j=0;j<H.length;j++)for(let L=j+1;L<H.length;L++)if(H[j].negate().equals(H[L]))return S.INSTANCE;if(H.length===1)return H[0]}return new o(H,Y)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const Y of this.expr)F.push(...Y.keys());return F}map(F){return new o(this.expr.map(Y=>Y.map(F)),null)}negate(){if(!this.negated){const F=[];for(const Y of this.expr)F.push(Y.negate());for(;F.length>1;){const Y=F.shift(),B=F.shift(),H=[];for(const $ of le(Y))for(const j of le(B))H.push(f.create([$,j],null,!1));F.unshift(o.create(H,null,!1))}this.negated=o.create(F,this,!0)}return this.negated}}class c extends w{static all(){return c._info.values()}constructor(F,Y,B){super(F,null),this._defaultValue=Y,typeof B=="object"?c._info.push({...B,key:F}):B!==!0&&c._info.push({key:F,description:B,type:Y!=null?typeof Y:void 0})}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return d.create(this.key,F)}notEqualsTo(F){return m.create(this.key,F)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function T(ae,F){return ae<F?-1:ae>F?1:0}function O(ae,F,Y,B){return ae<Y?-1:ae>Y?1:F<B?-1:F>B?1:0}function K(ae,F){if(ae.type===0||F.type===1)return!0;if(ae.type===9)return F.type===9?re(ae.expr,F.expr):!1;if(F.type===9){for(const Y of F.expr)if(K(ae,Y))return!0;return!1}if(ae.type===6){if(F.type===6)return re(F.expr,ae.expr);for(const Y of ae.expr)if(K(Y,F))return!0;return!1}return ae.equals(F)}e.implies=K;function re(ae,F){let Y=0,B=0;for(;Y<ae.length&&B<F.length;){const H=ae[Y].cmp(F[B]);if(H<0)return!1;H===0&&Y++,B++}return Y===ae.length}function le(ae){return ae.type===9?ae.expr:[ae]}}),define(we[73],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,y.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,y.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(I,P){return this.secretVault[I]?.[P]??null}async setPassword(I,P,C){this.secretVault[I]=this.secretVault[I]??{},this.secretVault[I][P]=C}async deletePassword(I,P){return this.secretVault[I]?.[P]?(delete this.secretVault[I][P],Object.keys(this.secretVault[I]).length===0&&delete this.secretVault[I],!0):!1}async findPassword(I){return JSON.stringify(this.secretVault[I])??null}async findCredentials(I){const P=[];for(const C of Object.keys(this.secretVault[I]||{}))P.push({account:C,password:this.secretVault[I][C]});return P}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(we[198],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function t(I){return!!I.hostName&&!!I.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(P,C){return{}}async getSystemInfo(P,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(P,C){return""}async getWorkspaceFileExtensions(P){return{extensions:[]}}async reportWorkspaceStats(P){}}e.NullDiagnosticsService=D}),define(we[74],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,y.createDecorator)("downloadService")}),define(we[199],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,y.createDecorator)("encryptionMainService")}),define(we[28],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(we[30],ye([1,0,164,5]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function I(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function P(m,p){switch(m){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=P;function C(m,p){return p==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function E(m,p,u){return C(p,u)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===u?!0:b(u).includes(m)}e.isTargetPlatformCompatible=E;function b(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function k(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=k;var R;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var S;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var w;(function(m){m.Install="install",m.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var d;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal",m.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(p,u){super(p),this.code=u,this.name=u}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,y.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,y.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(we[200],ye([1,0,7,2,45,23,4,71,30]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(v,m){return P.URI.revive(m?m.transformIncoming(v):v)}function k(v,m){return m?m.transformOutgoingURI(v):v}function R(v,m){m=m||C.DefaultURITransformer;const p=v.manifest;return{...(0,C.transformAndReviveIncomingURIs)({...v,manifest:void 0},m),manifest:p}}function S(v,m){return m?(0,I.cloneAndChange)(v,p=>p instanceof P.URI?m.transformOutgoingURI(p):void 0):v}class w{constructor(m,p){this.service=m,this.getUriTransformer=p,this.onInstallExtension=y.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,p){const u=this.getUriTransformer(m);switch(p){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,l=>l.map(h=>({...h,local:h.local?S(h.local,u):h.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,p,u){const l=this.getUriTransformer(m);switch(p){case"zip":return this.service.zip(R(u[0],l)).then(h=>k(h,l));case"unzip":return this.service.unzip(b(u[0],l));case"install":return this.service.install(b(u[0],l),(0,D.revive)(u[1]));case"getManifest":return this.service.getManifest(b(u[0],l));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],(0,D.revive)(u[1]));case"uninstall":return this.service.uninstall(R(u[0],l),(0,D.revive)(u[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(R(u[0],l));case"getInstalled":return this.service.getInstalled(u[0],P.URI.revive(u[1])).then(h=>h.map(i=>S(i,l)));case"getMetadata":return this.service.getMetadata(R(u[0],l));case"updateMetadata":return this.service.updateMetadata(R(u[0],l),u[1]).then(h=>S(h,l));case"updateExtensionScope":return this.service.updateExtensionScope(R(u[0],l),u[1]).then(h=>S(h,l));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(u[0],u[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=w;class d extends t.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(m){super(),this.channel=m,this._onInstallExtension=this._register(new y.Emitter),this._onDidInstallExtensions=this._register(new y.Emitter),this._onUninstallExtension=this._register(new y.Emitter),this._onDidUninstallExtension=this._register(new y.Emitter),this._register(this.channel.listen("onInstallExtension")(p=>this._onInstallExtension.fire({identifier:p.identifier,source:this.isUriComponents(p.source)?P.URI.revive(p.source):p.source,profileLocation:P.URI.revive(p.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(p=>this._onDidInstallExtensions.fire(p.map(u=>({...u,local:u.local?R(u.local,null):u.local,source:this.isUriComponents(u.source)?P.URI.revive(u.source):u.source,profileLocation:P.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(p=>this._onUninstallExtension.fire({identifier:p.identifier,profileLocation:P.URI.revive(p.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(p=>this._onDidUninstallExtension.fire({...p,profileLocation:P.URI.revive(p.profileLocation)})))}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const p=await this.getTargetPlatform();return m.allTargetPlatforms.some(u=>(0,E.isTargetPlatformCompatible)(u,m.allTargetPlatforms,p))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(p=>P.URI.revive(p)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,p){return Promise.resolve(this.channel.call("install",[m,p])).then(u=>R(u,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,p){return Promise.resolve(this.channel.call("installFromGallery",[m,p])).then(u=>R(u,null))}uninstall(m,p){return Promise.resolve(this.channel.call("uninstall",[m,p]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null,p){return Promise.resolve(this.channel.call("getInstalled",[m,p])).then(u=>u.map(l=>R(l,null)))}getMetadata(m){return Promise.resolve(this.channel.call("getMetadata",[m]))}updateMetadata(m,p){return Promise.resolve(this.channel.call("updateMetadata",[m,p])).then(u=>R(u,null))}updateExtensionScope(m,p){return Promise.resolve(this.channel.call("updateExtensionScope",[m,p])).then(u=>R(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(m,p){const u=await this.channel.call("download",[m,p]);return P.URI.revive(u)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class g{constructor(m){this.service=m}listen(m,p){throw new Error("Invalid listen")}call(m,p,u){switch(p){case"getConfigBasedTips":return this.service.getConfigBasedTips(P.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(we[75],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,y.createDecorator)("IExtensionSignatureVerificationService");class t{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((I,P)=>oe(["node-vsce-sign"],async C=>I(C),P))),this.moduleLoadingPromise}async verify(I,P){let C;try{C=await this.vsceSign()}catch{return!1}return C.verify(I,P)}}e.ExtensionSignatureVerificationService=t}),define(we[17],ye([1,0,57,6,15,13,4,172,5]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function b($){return $.create===!0}e.isFileOpenForWriteOptions=b;var k;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(k=e.FileType||(e.FileType={}));var R;(function($){$[$.Readonly=1]="Readonly"})(R=e.FilePermission||(e.FilePermission={}));var S;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w($){return!!($.capabilities&2)}e.hasReadWriteCapability=w;function d($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=d;function g($){return!!($.capabilities&32768)}e.hasFileCloneCapability=g;function v($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function m($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=m;function p($){return w($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var u;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(j,L){super(j),this.code=L}}e.FileSystemProviderError=l;function h($,j){const L=new l($.toString(),j);return r(L,j),L}e.createFileSystemProviderError=h;function i($){return $||h((0,C.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=i;function r($,j){return $.name=j?`${j} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=r;function n($){if(!$)return u.Unknown;if($ instanceof l)return $.code;const j=/^(.+) \(FileSystemError\)$/.exec($.name);if(!j)return u.Unknown;switch(j[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function s($){if($ instanceof O)return $.fileOperationResult;switch(n($)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class f{constructor(j,L,N){this.resource=j,this.operation=L,this.target=N}isOperation(j){return this.operation===j}}e.FileOperationEvent=f;var o;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class c{constructor(j,L){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const N=new Map;for(const q of j){const se=N.get(q.type);switch(se?se.push([q.resource,q]):N.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,se]of N)switch(q){case 1:this.added=y.TernarySearchTree.forUris(()=>L),this.added.fill(se);break;case 0:this.updated=y.TernarySearchTree.forUris(()=>L),this.updated.fill(se);break;case 2:this.deleted=y.TernarySearchTree.forUris(()=>L),this.deleted.fill(se);break}}contains(j,...L){return this.doContains(j,{includeChildren:!1},...L)}affects(j,...L){return this.doContains(j,{includeChildren:!0},...L)}doContains(j,L,...N){if(!j)return!1;const q=N.length>0;return!!((!q||N.includes(1))&&(this.added?.get(j)||L.includeChildren&&this.added?.findSuperstr(j))||(!q||N.includes(0))&&(this.updated?.get(j)||L.includeChildren&&this.updated?.findSuperstr(j))||(!q||N.includes(2))&&(this.deleted?.findSubstr(j)||L.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function T($,j,L){return!$||!j||$===j||j.length>$.length?!1:(j.charAt(j.length-1)!==t.sep&&(j+=t.sep),L?(0,D.startsWithIgnoreCase)($,j):$.indexOf(j)===0)}e.isParent=T;class O extends Error{constructor(j,L,N){super(j),this.fileOperationResult=L,this.options=N}}e.FileOperationError=O;class K extends O{constructor(j,L,N){super(j,2,N),this.stat=L}}e.NotModifiedSinceFileOperationError=K;var re;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(re=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var le;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(le=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ae($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=ae;async function F($,j){if(!j.hasProvider(P.URI.from({scheme:$.scheme})))return new Promise(L=>{const N=j.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===$.scheme&&q.added&&(N.dispose(),L())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Y{static formatSize(j){return(0,I.isNumber)(j)||(j=0),j<Y.KB?(0,C.localize)(1,null,j.toFixed(0)):j<Y.MB?(0,C.localize)(2,null,(j/Y.KB).toFixed(2)):j<Y.GB?(0,C.localize)(3,null,(j/Y.MB).toFixed(2)):j<Y.TB?(0,C.localize)(4,null,(j/Y.GB).toFixed(2)):(0,C.localize)(5,null,(j/Y.TB).toFixed(2))}}e.ByteSize=Y,Y.KB=1024,Y.MB=Y.KB*Y.KB,Y.GB=Y.MB*Y.KB,Y.TB=Y.GB*Y.KB;var B;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function H($){return{maxFileSize:$===0?300*Y.MB:16*Y.GB,maxHeapSize:$===0?700*Y.MB:2*700*Y.MB}}e.getPlatformLimits=H}),define(we[201],ye([1,0,16,38,8,7,2,44,4,22,17]),function(oe,e,y,t,D,I,P,C,E,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends P.Disposable{constructor(w,d){super(),this.channel=w,this.extraCapabilities=d,this.onDidChangeCapabilities=I.Event.None,this._onDidChange=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(w){return this.channel.call("stat",[w])}readdir(w){return this.channel.call("readdir",[w])}async readFile(w,d){const{buffer:g}=await this.channel.call("readFile",[w,d]);return g}readFileStream(w,d,g){const v=(0,C.newWriteableStream)(p=>y.VSBuffer.concat(p.map(u=>y.VSBuffer.wrap(u))).buffer),m=this.channel.listen("readFileStream",[w,d])(p=>{if(p instanceof y.VSBuffer)v.write(p.buffer);else{if(p==="end")v.end();else{let u=p;u instanceof Error||(u=(0,k.createFileSystemProviderError)((0,t.toErrorMessage)(u),k.FileSystemProviderErrorCode.Unknown)),v.error(u),v.end()}m.dispose()}});return g.onCancellationRequested(()=>{v.error((0,D.canceled)()),v.end(),m.dispose()}),v}writeFile(w,d,g){return this.channel.call("writeFile",[w,y.VSBuffer.wrap(d),g])}open(w,d){return this.channel.call("open",[w,d])}close(w){return this.channel.call("close",[w])}async read(w,d,g,v,m){const[p,u]=await this.channel.call("read",[w,d,m]);return g.set(p.buffer.slice(0,u),v),u}write(w,d,g,v,m){return this.channel.call("write",[w,d,y.VSBuffer.wrap(g),v,m])}mkdir(w){return this.channel.call("mkdir",[w])}delete(w,d){return this.channel.call("delete",[w,d])}rename(w,d,g){return this.channel.call("rename",[w,d,g])}copy(w,d,g){return this.channel.call("copy",[w,d,g])}cloneFile(w,d){return this.channel.call("cloneFile",[w,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(w=>{if(Array.isArray(w)){const d=w;this._onDidChange.fire(d.map(g=>({resource:E.URI.revive(g.resource),type:g.type})))}else{const d=w;this._onDidWatchError.fire(d)}}))}watch(w,d){const g=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,g,w,d]),(0,P.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,g]))}}e.DiskFileSystemProviderClient=R}),define(we[103],ye([1,0,16,8,173,17]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(k,R,S,w,d,g){let v;try{await C(k,R,S,w,d,g)}catch(m){v=m}finally{v&&d.errorTransformer&&(v=d.errorTransformer(v)),typeof v<"u"&&S.error(v),S.end()}}e.readFileIntoStream=P;async function C(k,R,S,w,d,g){E(g);const v=await k.open(R,{create:!1});try{E(g);let m=0,p=0,u=d&&typeof d.length=="number"?d.length:void 0,l=y.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),h=d&&typeof d.position=="number"?d.position:0,i=0;do p=await k.read(v,h,l.buffer,i,l.byteLength-i),h+=p,i+=p,m+=p,typeof u=="number"&&(u-=p),i===l.byteLength&&(await S.write(w(l)),l=y.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),i=0);while(p>0&&(typeof u!="number"||u>0)&&E(g)&&b(m,d));if(i>0){let r=i;typeof u=="number"&&(r=Math.min(i,u)),S.write(w(l.slice(0,r)))}}catch(m){throw(0,I.ensureFileSystemProviderError)(m)}finally{await k.close(v)}}function E(k){if(k.isCancellationRequested)throw(0,t.canceled)();return!0}function b(k,R){if(R?.limits){if(typeof R.limits.memory=="number"&&k>R.limits.memory)throw(0,I.createFileSystemProviderError)((0,D.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&k>R.limits.size)throw(0,I.createFileSystemProviderError)((0,D.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(we[61],ye([1,0,70,2,6,3,4,17]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(m){return m.recursive===!0}e.isRecursiveWatchRequest=E;class b extends t.Disposable{constructor(p,u,l,h){super(),this.onFileChanges=p,this.onLogMessage=u,this.verboseLogging=l,this.options=h,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const p=new t.DisposableStore;this.watcherDisposables.value=p,this.watcher=this.createWatcher(p),this.watcher.setVerboseLogging(this.verboseLogging),p.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),p.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),p.add(this.watcher.onDidError(u=>this.onError(u)))}onError(p){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${p}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${p}`):this.error(p)}restart(p){this.restartCounter++,this.init(),this.watch(p)}async watch(p){this.requests=p,await this.watcher?.watch(p)}async setVerboseLogging(p){this.verboseLogging=p,await this.watcher?.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${p}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class k extends b{constructor(p,u,l){super(p,u,l,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=k;class R extends b{constructor(p,u,l){super(p,u,l,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=R;function S(m){return m.map(p=>({type:p.type,resource:P.URI.file(p.path)}))}e.toFileChanges=S;function w(m){const p=new v;for(const u of m)p.processEvent(u);return p.coalesce()}e.coalesceEvents=w;function d(m,p){return typeof p=="string"&&!p.startsWith(y.GLOBSTAR)&&!(0,D.isAbsolute)(p)?{base:m,pattern:p}:p}e.normalizeWatcherPattern=d;function g(m,p){const u=[];for(const l of p)u.push((0,y.parse)(d(m,l)));return u}e.parseWatcherPatterns=g;class v{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(p){return I.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const u=this.mapPathToChange.get(this.toKey(p));let l=!1;if(u){const h=u.type,i=p.type;u.path!==p.path&&(p.type===2||p.type===1)?l=!0:h===1&&i===2?(this.mapPathToChange.delete(this.toKey(p)),this.coalesced.delete(u)):h===2&&i===1?u.type=0:h===1&&i===0||(u.type=i)}else l=!0;l&&(this.coalesced.add(p),this.mapPathToChange.set(this.toKey(p),p))}coalesce(){const p=[],u=[];return Array.from(this.coalesced).filter(l=>l.type!==2?(p.push(l),!1):!0).sort((l,h)=>l.path.length-h.path.length).filter(l=>u.some(h=>(0,C.isParent)(l.path,h,!I.isLinux))?!1:(u.push(l.path),!0)).concat(p)}}}),define(we[202],ye([1,0,29,14,20,36,2,88,6,3,148,21,61]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class w extends P.Disposable{constructor(v,m,p,u){super(),this.request=v,this.onDidFilesChange=m,this.onLogMessage=p,this.verboseLogging=u,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(w.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await R.Promises.stat(v);this._register(await this.doWatch(v,m.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let m=v.path;try{m=await R.Promises.realpath(v.path),v.path===m&&(m=await(0,k.realcase)(v.path)??v.path),v.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${m})`)}catch{}return m}async doWatch(v,m){if(b.isMacintosh&&(0,I.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.Disposable.None;const p=new D.CancellationTokenSource(this.cts.token),u=new P.DisposableStore;try{const l=(0,E.basename)(v),h=(0,y.watch)(v);u.add((0,P.toDisposable)(()=>{h.removeAllListeners(),h.close()})),this.trace(`Started watching: '${v}'`);const i=new Set;if(m)try{for(const n of await R.Promises.readdir(v))i.add(n)}catch(n){this.error(n)}const r=new Map;u.add((0,P.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),h.on("error",(n,s)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),h.on("change",(n,s)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${s}`);let a="";if(s&&(a=s.toString(),b.isMacintosh&&(a=(0,C.normalizeNFC)(a))),!(!a||n!=="change"&&n!=="rename"))if(m)if(n==="rename"){r.get(a)?.dispose();const f=setTimeout(async()=>{if(r.delete(a),a===l&&!await R.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,E.join)(v,a));if(p.token.isCancellationRequested)return;let c;o?i.has(a)?c=0:(c=1,i.add(a)):(i.delete(a),c=2),this.onFileChange({path:(0,E.join)(this.request.path,a),type:c})},w.FILE_DELETE_HANDLER_DELAY);r.set(a,(0,P.toDisposable)(()=>clearTimeout(f)))}else{let f;i.has(a)?f=0:(f=1,i.add(a)),this.onFileChange({path:(0,E.join)(this.request.path,a),type:f})}else if(n==="rename"||a!==l){const f=setTimeout(async()=>{const o=await R.Promises.exists(v);p.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},w.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,P.toDisposable)(()=>clearTimeout(f)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await R.Promises.exists(v)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${l.toString()})`)}return(0,P.toDisposable)(()=>{p.dispose(!0),u.dispose()})}async onFileChange(v,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!m&&this.excludes.some(p=>p(v.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${v.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(v.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,S.coalesceEvents)(p);if(u.length>0){if(this.verboseLogging)for(const h of u)this.trace(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(b.isLinux)return R.Promises.exists(v);try{const m=(0,E.basename)(v);return(await R.Promises.readdir((0,E.dirname)(v))).some(u=>u===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=w,w.FILE_DELETE_HANDLER_DELAY=100,w.FILE_CHANGES_HANDLER_DELAY=50;async function d(g,v,m,p,u=512){const l=await R.Promises.open(g,"r"),h=Buffer.allocUnsafe(u),i=new D.CancellationTokenSource(p);let r,n=!1;const s={path:g,excludes:[],recursive:!1},a=new w(s,f=>{(async()=>{for(const{type:o}of f)if(o===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:c}=await R.Promises.read(l,h,0,u,null);if(!c||i.token.isCancellationRequested)break;v(h.slice(0,c))}}catch(c){r=new Error(c),i.dispose(!0)}finally{n=!1}}})()});return await a.ready,m(),new Promise((f,o)=>{i.token.onCancellationRequested(async()=>{a.dispose();try{await R.Promises.close(l)}catch(c){r=new Error(c)}r?o(r):f()})})}e.watchFileContents=d}),define(we[203],ye([1,0,7,70,2,3,202]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class C extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new y.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new y.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=y.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const k=this.normalizeRequests(b),R=k.filter(w=>{const d=this.watchers.get(w.path);return d?!(0,t.patternsEquals)(d.request.excludes,w.excludes)||!(0,t.patternsEquals)(d.request.includes,w.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:w})=>!k.find(d=>d.path===w.path&&(0,t.patternsEquals)(d.excludes,w.excludes)&&(0,t.patternsEquals)(d.includes,w.includes))).map(({request:w})=>w.path);R.length&&this.trace(`Request to start watching: ${R.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const w of S)this.stopWatching(w);for(const w of R)this.startWatching(w)}startWatching(b){const k=new P.NodeJSFileWatcherLibrary(b,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),R={request:b,instance:k};this.watchers.set(b.path,R)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const k=this.watchers.get(b);k&&(this.watchers.delete(b),k.instance.dispose())}normalizeRequests(b){const k=new Map;for(const R of b){const S=I.isLinux?R.path:R.path.toLowerCase();k.set(S,R)}return Array.from(k.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,k]of this.watchers)k.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,k){return k?`[File Watcher (node.js)] ${b} (path: ${k.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=C}),define(we[204],ye([1,0,61,203]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends y.AbstractNonRecursiveWatcherClient{constructor(P,C,E){super(P,C,E),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(we[205],ye([1,0,9,42,99,61]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class P extends I.AbstractUniversalWatcherClient{constructor(E,b,k){super(E,b,k),this.init()}createWatcher(E){const b=E.add(new D.Client(y.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:k,signal:R})=>this.onError(`terminated by itself with code ${k}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=P}),define(we[76],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...D){this._entries=new Map;for(const[I,P]of D)this.set(I,P)}set(D,I){const P=this._entries.get(D);return this._entries.set(D,I),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=y}),define(we[104],ye([1,0,14,8,2,60,197,5,76,87]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const k=!1;class R extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class S{constructor(v=new E.ServiceCollection,m=!1,p,u=k){this._services=v,this._strict=m,this._parent=p,this._enableTracing=u,this._activeInstantiations=new Set,this._services.set(C.IInstantiationService,this),this._globalGraph=u?p?._globalGraph??new P.Graph(l=>l):void 0}createChild(v){return new S(v,this._strict,this,this._enableTracing)}invokeFunction(v,...m){const p=d.traceInvocation(this._enableTracing,v);let u=!1;try{return v({get:h=>{if(u)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(h,p);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...m)}finally{u=!0,p.stop()}}createInstance(v,...m){let p,u;return v instanceof I.SyncDescriptor?(p=d.traceCreation(this._enableTracing,v.ctor),u=this._createInstance(v.ctor,v.staticArguments.concat(m),p)):(p=d.traceCreation(this._enableTracing,v),u=this._createInstance(v,m,p)),p.stop(),u}_createInstance(v,m=[],p){const u=C._util.getServiceDependencies(v).sort((i,r)=>i.index-r.index),l=[];for(const i of u){const r=this._getOrCreateServiceInstance(i.id,p);r||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${i.id}.`,!1),l.push(r)}const h=u.length>0?u[0].index:m.length;if(m.length!==h){console.trace(`[createInstance] First service dependency of ${v.name} at position ${h+1} conflicts with ${m.length} static arguments`);const i=h-m.length;i>0?m=m.concat(new Array(i)):m=m.slice(0,h)}return Reflect.construct(v,m.concat(l))}_setServiceInstance(v,m){if(this._services.get(v)instanceof I.SyncDescriptor)this._services.set(v,m);else if(this._parent)this._parent._setServiceInstance(v,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const m=this._services.get(v);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):m}_getOrCreateServiceInstance(v,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const p=this._getServiceInstanceOrDescriptor(v);return p instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,p,m.branch(v,!0)):(m.branch(v,!1),p)}_safeCreateAndCacheServiceInstance(v,m,p){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,m,p)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,m,p){const u=new P.Graph(i=>i.id.toString());let l=0;const h=[{id:v,desc:m,_trace:p}];for(;h.length;){const i=h.pop();if(u.lookupOrInsertNode(i),l++>1e3)throw new R(u);for(const r of C._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(r.id);if(n||this._throwIfStrict(`[createInstance] ${v} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),n instanceof I.SyncDescriptor){const s={id:r.id,desc:n,_trace:i._trace.branch(r.id,!0)};u.insertEdge(i,s),h.push(s)}}}for(;;){const i=u.roots();if(i.length===0){if(!u.isEmpty())throw new R(u);break}for(const{data:r}of i){if(this._getServiceInstanceOrDescriptor(r.id)instanceof I.SyncDescriptor){const s=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,s)}u.removeNode(r)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,m,p=[],u,l){if(this._services.get(v)instanceof I.SyncDescriptor)return this._createServiceInstance(v,m,p,u,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,m,p,u,l);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(v,m,p=[],u,l){if(u){const h=new S(void 0,this._strict,this,this._enableTracing);h._globalGraphImplicitDependency=String(v);const i=new Map,r=new y.IdleValue(()=>{const n=h._createInstance(m,p,l);for(const[s,a]of i){const f=n[s];if(typeof f=="function")for(const o of a)f.apply(n,o)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let o=i.get(s);return o||(o=new b.LinkedList,i.set(s,o)),(T,O,K)=>{const re=o.push([T,O,K]);return(0,D.toDisposable)(re)}}if(s in n)return n[s];const a=r.value;let f=a[s];return typeof f!="function"||(f=f.bind(a),n[s]=f),f},set(n,s,a){return r.value[s]=a,!0}})}else return this._createInstance(m,p,l)}_throwIfStrict(v,m){if(m&&console.warn(v),this._strict)throw new Error(v)}}e.InstantiationService=S;var w;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(w||(w={}));class d{static traceInvocation(v,m){return v?new d(1,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d._None}static traceCreation(v,m){return v?new d(0,m.name):d._None}constructor(v,m){this.type=v,this.name=m,this._start=Date.now(),this._dep=[]}branch(v,m){const p=new d(2,v.toString());return this._dep.push([v,m,p]),p}stop(){const v=Date.now()-this._start;d._totals+=v;let m=!1;function p(l,h){const i=[],r=new Array(l+1).join("	");for(const[n,s,a]of h._dep)if(s&&a){m=!0,i.push(`${r}CREATES -> ${n}`);const f=p(l+1,a);f&&i.push(f)}else i.push(`${r}uses -> ${n}`);return i.join(`
`)}const u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(v>2||m)&&d.all.add(u.join(`
`))}}e.Trace=d,d.all=new Set,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(we[206],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,y.createDecorator)("labelService")});var _e=this&&this.__param||function(oe,e){return function(y,t){e(y,t,oe)}};define(we[77],ye([1,0,20,2,3,175,30,5]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,C.createDecorator)("languagePackService");let E=class extends t.Disposable{constructor(k){super(),this.extensionGalleryService=k}async getAvailableLanguages(){const k=new y.CancellationTokenSource;setTimeout(()=>k.cancel(),1e3);let R;try{R=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const w=R.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(g=>g.startsWith("lp-"))).map(d=>{const g=d.properties.localizedLanguages?.[0],v=this.getLocale(d);return{...this.createQuickPickItem(v,g,d),extensionId:d.identifier.id,galleryExtension:d}});return w.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),w}getLocale(k){return k.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(k,R,S){const w=R??k;let d;if(w!==k&&(d=`(${k})`),k.toLowerCase()===D.language.toLowerCase()&&(d??="",d+=(0,I.localize)(0,null)),S?.installCount){d??="";const g=S.installCount;let v;g>1e6?v=`${Math.floor(g/1e5)/10}M`:g>1e3?v=`${Math.floor(g/1e3)}K`:v=String(g),d+=` $(cloud-download) ${v}`}return{id:k,label:w,description:d}}};E=Ae([_e(0,P.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(we[12],ye([1,0,38,7,2,31,3,4,5]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function b(){return new Date().toISOString()}var k;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(k=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=k.Info;function R(f,o,c){switch(o){case k.Trace:f.trace(c);break;case k.Debug:f.debug(c);break;case k.Info:f.info(c);break;case k.Warning:f.warn(c);break;case k.Error:f.error(c);break;case k.Critical:f.critical(c);break;default:throw new Error("Invalid log level")}}e.log=R;function S(f){let o="";for(let c=0;c<f.length;c++){let T=f[c];if(typeof T=="object")try{T=JSON.stringify(T)}catch{}o+=(c>0?" ":"")+T}return o}e.format=S;class w extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class d extends w{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...c){this.checkLogLevel(k.Trace)&&this.log(k.Trace,S([o,...c]))}debug(o,...c){this.checkLogLevel(k.Debug)&&this.log(k.Debug,S([o,...c]))}info(o,...c){this.checkLogLevel(k.Info)&&this.log(k.Info,S([o,...c]))}warn(o,...c){this.checkLogLevel(k.Warning)&&this.log(k.Warning,S([o,...c]))}error(o,...c){if(this.checkLogLevel(k.Error))if(o instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=o.stack,this.log(k.Error,S(T))}else this.log(k.Error,S([o,...c]))}critical(o,...c){this.checkLogLevel(k.Critical)&&this.log(k.Critical,S([o,...c]))}flush(){}}e.AbstractMessageLogger=d;class g extends w{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!P.isWindows}trace(o,...c){this.getLevel()<=k.Trace&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,o,...c):console.log(`[main ${b()}]`,o,...c))}debug(o,...c){this.getLevel()<=k.Debug&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,o,...c):console.log(`[main ${b()}]`,o,...c))}info(o,...c){this.getLevel()<=k.Info&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,o,...c):console.log(`[main ${b()}]`,o,...c))}warn(o,...c){this.getLevel()<=k.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,o,...c):console.warn(`[main ${b()}]`,o,...c))}error(o,...c){this.getLevel()<=k.Error&&(this.useColors?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,o,...c):console.error(`[main ${b()}]`,o,...c))}critical(o,...c){this.getLevel()<=k.Critical&&(this.useColors?console.error(`\x1B[90m[main ${b()}]\x1B[0m`,o,...c):console.error(`[main ${b()}]`,o,...c))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class v extends w{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...c){this.getLevel()<=k.Trace&&console.log("%cTRACE","color: #888",o,...c)}debug(o,...c){this.getLevel()<=k.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...c)}info(o,...c){this.getLevel()<=k.Info&&console.log("%c INFO","color: #33f",o,...c)}warn(o,...c){this.getLevel()<=k.Warning&&console.log("%c WARN","color: #993",o,...c)}error(o,...c){this.getLevel()<=k.Error&&console.log("%c  ERR","color: #f33",o,...c)}critical(o,...c){this.getLevel()<=k.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...c)}dispose(){}flush(){}}e.ConsoleLogger=v;class m extends w{constructor(o,c=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(c)}trace(o,...c){this.getLevel()<=k.Trace&&this.adapter.log(k.Trace,[this.extractMessage(o),...c])}debug(o,...c){this.getLevel()<=k.Debug&&this.adapter.log(k.Debug,[this.extractMessage(o),...c])}info(o,...c){this.getLevel()<=k.Info&&this.adapter.log(k.Info,[this.extractMessage(o),...c])}warn(o,...c){this.getLevel()<=k.Warning&&this.adapter.log(k.Warning,[this.extractMessage(o),...c])}error(o,...c){this.getLevel()<=k.Error&&this.adapter.log(k.Error,[this.extractMessage(o),...c])}critical(o,...c){this.getLevel()<=k.Critical&&this.adapter.log(k.Critical,[this.extractMessage(o),...c])}extractMessage(o){return typeof o=="string"?o:(0,y.toErrorMessage)(o,this.getLevel()<=k.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class p extends w{constructor(o){super(),this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const c of this.logServices)c.setLevel(o);super.setLevel(o)}trace(o,...c){for(const T of this.logServices)T.trace(o,...c)}debug(o,...c){for(const T of this.logServices)T.debug(o,...c)}info(o,...c){for(const T of this.logServices)T.info(o,...c)}warn(o,...c){for(const T of this.logServices)T.warn(o,...c)}error(o,...c){for(const T of this.logServices)T.error(o,...c)}critical(o,...c){for(const T of this.logServices)T.critical(o,...c)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=p;class u extends D.Disposable{constructor(o){super(),this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...c){this.logger.trace(o,...c)}debug(o,...c){this.logger.debug(o,...c)}info(o,...c){this.logger.info(o,...c)}warn(o,...c){this.logger.warn(o,...c)}error(o,...c){this.logger.error(o,...c)}critical(o,...c){this.logger.critical(o,...c)}flush(){this.logger.flush()}}e.LogService=u;class l extends D.Disposable{constructor(o,c){super(),this.logLevel=o,this.loggerItems=new I.ResourceMap,this._register(c(T=>this.setLevel(T)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:o})=>o)}getLogger(o){return this.loggerItems.get(o)?.logger}createLogger(o,c,T){let O=this.loggerItems.get(o)?.logger;return O||(T=c?.always?k.Trace:T,O=this.doCreateLogger(o,T??this.logLevel,c),this.loggerItems.set(o,{logger:O,logLevel:T})),O}setLevel(o,c){const T=C.URI.isUri(o)?o:void 0,O=T?c:o;if(T){const K=this.loggerItems.get(T);K&&K.logLevel!==O&&(K.logLevel=O,K.logger.setLevel(O))}else this.logLevel=O,this.loggerItems.forEach(({logLevel:K,logger:re})=>{K===void 0&&re.setLevel(this.logLevel)})}getLogLevel(o){return this.loggerItems.get(o)?.logLevel}dispose(){this.loggerItems.forEach(({logger:o})=>o.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=l;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return k.Info}trace(o,...c){}debug(o,...c){}info(o,...c){}warn(o,...c){}error(o,...c){}critical(o,...c){}dispose(){}flush(){}}e.NullLogger=h;class i extends h{}e.NullLogService=i;class r extends l{constructor(){super(k.Info,t.Event.None)}doCreateLogger(o,c,T){return new h}}e.NullLoggerService=r;function n(f){if(f.verbose)return k.Trace;if(typeof f.logLevel=="string"){const o=s(f.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function s(f){switch(f){case"trace":return k.Trace;case"debug":return k.Debug;case"info":return k.Info;case"warn":return k.Warning;case"error":return k.Error;case"critical":return k.Critical;case"off":return k.Off}}e.parseLogLevel=s;function a(f){switch(f){case k.Trace:return"trace";case k.Debug:return"debug";case k.Info:return"info";case k.Warning:return"warn";case k.Error:return"error";case k.Critical:return"critical";case k.Off:return"off"}}e.LogLevelToString=a}),define(we[207],ye([1,0,73,7,2,12,3,14]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let E=class $t extends D.Disposable{constructor(k){super(),this.logService=k,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(k,R){this.logService.trace("Getting password from keytar:",k,R);let S;try{S=await this.withKeytar()}catch{return null}const w=await(0,C.retry)(()=>S.getPassword(k,R),50,3);if(!w)return this.logService.trace("Did not get a password from keytar for account:",R),w;let d,g;try{const v=JSON.parse(w);d=v.content,g=v.hasNextChunk}catch{}if(!d||!g)return this.logService.trace("Got password from keytar for account:",R),w;try{let v=1;for(;g;){const m=await(0,C.retry)(()=>S.getPassword(k,`${R}-${v}`),50,3),p=JSON.parse(m);d+=p.content,g=p.hasNextChunk,v++}return this.logService.trace(`Got ${v}-chunked password from keytar for account:`,R),d}catch(v){return this.logService.error(v),w}}async setPassword(k,R,S){this.logService.trace("Setting password using keytar:",k,R);let w;try{w=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}if(P.isWindows&&S.length>$t.MAX_PASSWORD_LENGTH){let d=0,g=0,v=!0;for(;v;){const m=S.substring(d,d+$t.PASSWORD_CHUNK_SIZE);d+=$t.PASSWORD_CHUNK_SIZE,v=S.length-d>0;const p={content:m,hasNextChunk:v};await(0,C.retry)(()=>w.setPassword(k,g?`${R}-${g}`:R,JSON.stringify(p)),50,3),g++}this.logService.trace(`Got${g?` ${g}-chunked`:""} password from keytar for account:`,R)}else await(0,C.retry)(()=>w.setPassword(k,R,S),50,3),this.logService.trace("Got password from keytar for account:",R);this._onDidChangePassword.fire({service:k,account:R})}async deletePassword(k,R){this.logService.trace("Deleting password using keytar:",k,R);let S;try{S=await this.withKeytar()}catch(m){throw this.surfaceKeytarLoadError?.(m),m}const w=await S.getPassword(k,R);if(!w)return this.logService.trace("Did not get a password to delete from keytar for account:",R),!1;let d,g;try{const m=JSON.parse(w);d=m.content,g=m.hasNextChunk}catch{}let v=0;if(d&&g)try{for(v++;g;){const m=`${R}-${v}`,p=await S.getPassword(k,m);await S.deletePassword(k,m),g=JSON.parse(p).hasNextChunk,v++}}catch(m){this.logService.error(m)}return await S.deletePassword(k,R)?(this._onDidChangePassword.fire({service:k,account:R}),this.logService.trace(`Deleted${v?` ${v}-chunked`:""} password from keytar for account:`,R),!0):(this.logService.trace(`Keytar failed to delete${v?` ${v}-chunked`:""} password for account:`,R),!1)}async findPassword(k){let R;try{R=await this.withKeytar()}catch{return null}return await R.findPassword(k)}async findCredentials(k){let R;try{R=await this.withKeytar()}catch{return[]}return await R.findCredentials(k)}clear(){return this._keytarCache instanceof y.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=Ae([_e(0,I.ILogService)],E),e.BaseCredentialsMainService=E}),define(we[208],ye([1,0,18,14,8,7,2,6,61,12]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class k extends P.Disposable{constructor(S,w){super(),this.logService=S,this.options=w,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,w):this.watchNonRecursive(S,w)}watchUniversal(S,w){const d={path:this.toFilePath(S),excludes:w.excludes,includes:w.includes,recursive:w.recursive},g=(0,y.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,P.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,E.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const w of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const w of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(w)&&S.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,w){const d={path:this.toFilePath(S),excludes:w.excludes,includes:w.includes,recursive:!1},g=(0,y.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,P.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,E.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,C.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=k}),define(we[105],ye([1,0,18,14,16,20,7,90,55,2,57,9,46,19,44,171,17,103,12]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends b.Disposable{constructor(h){super(),this.logService=h,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(h,i){if(this.provider.has(h))throw new Error(`A filesystem provider for the scheme '${h}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${h}`);const r=new b.DisposableStore;return this.provider.set(h,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:h,provider:i}),r.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new v.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&r.add(i.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),r.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:h}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:h,provider:i}),this.provider.delete(h),(0,b.dispose)(r)})}getProvider(h){return this.provider.get(h)}async activateProvider(h){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:h,join(r){i.push(r)}}),!this.provider.has(h)&&await t.Promises.settled(i)}async canHandleResource(h){return await this.activateProvider(h.scheme),this.hasProvider(h)}hasProvider(h){return this.provider.has(h.scheme)}hasCapability(h,i){const r=this.provider.get(h.scheme);return!!(r&&r.capabilities&i)}listCapabilities(){return E.Iterable.map(this.provider,([h,i])=>({scheme:h,capabilities:i.capabilities}))}async withProvider(h){if(!(0,w.isAbsolutePath)(h))throw new v.FileOperationError((0,g.localize)(0,null,this.resourceForError(h)),8);await this.activateProvider(h.scheme);const i=this.provider.get(h.scheme);if(!i){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,h.toString()),r}return i}async withReadProvider(h){const i=await this.withProvider(h);if((0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i)||(0,v.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(h){const i=await this.withProvider(h);if((0,v.hasOpenReadWriteCloseCapability)(i)||(0,v.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(h,i){try{return await this.doResolveFile(h,i)}catch(r){throw(0,v.toFileSystemProviderErrorCode)(r)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,g.localize)(2,null,this.resourceForError(h)),1):(0,v.ensureFileSystemProviderError)(r)}}async doResolveFile(h,i){const r=await this.withProvider(h),n=this.isPathCaseSensitive(r),s=i?.resolveTo,a=i?.resolveSingleChildDescendants,f=i?.resolveMetadata,o=await r.stat(h);let c;return this.toFileStat(r,h,o,void 0,!!f,(T,O)=>(c||(c=k.TernarySearchTree.forUris(()=>!n),c.set(h,!0),s&&c.fill(!0,s)),c.get(T.resource)||c.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&a?O===1:!1))}async toFileStat(h,i,r,n,s,a){const{providerExtUri:f}=this.getExtUri(h),o={resource:i,name:f.basename(i),isFile:(r.type&v.FileType.File)!==0,isDirectory:(r.type&v.FileType.Directory)!==0,isSymbolicLink:(r.type&v.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&v.FilePermission.Readonly)||Boolean(h.capabilities&2048),etag:(0,v.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&a(o,n)){try{const c=await h.readdir(i),T=await t.Promises.settled(c.map(async([O,K])=>{try{const re=f.joinPath(i,O),le=s?await h.stat(re):{type:K};return await this.toFileStat(h,re,le,c.length,s,a)}catch(re){return this.logService.trace(re),null}}));o.children=(0,y.coalesce)(T)}catch(c){this.logService.trace(c),o.children=[]}return o}return o}async resolveAll(h){return t.Promises.settled(h.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(h){const i=await this.withProvider(h),r=await i.stat(h);return this.toFileStat(i,h,r,void 0,!0,()=>!1)}async exists(h){const i=await this.withProvider(h);try{return!!await i.stat(h)}catch{return!1}}async canCreateFile(h,i){try{await this.doValidateCreateFile(h,i)}catch(r){return r}return!0}async doValidateCreateFile(h,i){if(!i?.overwrite&&await this.exists(h))throw new v.FileOperationError((0,g.localize)(3,null,this.resourceForError(h)),3,i)}async createFile(h,i=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(h,r);const n=await this.writeFile(h,i);return this._onDidRunOperation.fire(new v.FileOperationEvent(h,0,n)),n}async writeFile(h,i,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),{providerExtUri:s}=this.getExtUri(n);try{await this.validateWriteFile(n,h,r)||await this.mkdirp(n,s.dirname(h));let f;if((0,v.hasReadWriteCapability)(n)&&!(i instanceof D.VSBuffer))if((0,d.isReadableStream)(i)){const o=await(0,d.peekStream)(i,3);o.ended?f=D.VSBuffer.concat(o.buffer):f=o}else f=(0,d.peekReadable)(i,o=>D.VSBuffer.concat(o),3);else f=i;!(0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)&&f instanceof D.VSBuffer?await this.doWriteUnbuffered(n,h,r,f):await this.doWriteBuffered(n,h,r,f instanceof D.VSBuffer?(0,D.bufferToReadable)(f):f),this._onDidRunOperation.fire(new v.FileOperationEvent(h,4))}catch(a){throw new v.FileOperationError((0,g.localize)(4,null,this.resourceForError(h),(0,v.ensureFileSystemProviderError)(a).toString()),(0,v.toFileOperationResult)(a),r)}return this.resolve(h,{resolveMetadata:!0})}async validateWriteFile(h,i,r){if(!!r?.unlock&&!(h.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(i)));let s;try{s=await h.stat(i)}catch{return}if((s.type&v.FileType.Directory)!==0)throw new v.FileOperationError((0,g.localize)(6,null,this.resourceForError(i)),0,r);if(this.throwIfFileIsReadonly(i,s),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==v.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&r.mtime<s.mtime&&r.etag!==(0,v.etag)({mtime:r.mtime,size:s.size}))throw new v.FileOperationError((0,g.localize)(7,null),3,r);return s}async readFile(h,i,r){const n=await this.withReadProvider(h);return i?.atomic?this.doReadFileAtomic(n,h,i,r):this.doReadFile(n,h,i,r)}async doReadFileAtomic(h,i,r,n){return new Promise((s,a)=>{this.writeQueue.queueFor(i,this.getExtUri(h).providerExtUri).queue(async()=>{try{const f=await this.doReadFile(h,i,r,n);s(f)}catch(f){a(f)}})})}async doReadFile(h,i,r,n){const s=await this.doReadFileStream(h,i,{...r,preferUnbuffered:!0},n);return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(h,i,r){const n=await this.withReadProvider(h);return this.doReadFileStream(n,h,i,r)}async doReadFileStream(h,i,r,n){const s=new I.CancellationTokenSource(n),a=this.validateReadFile(i,r).then(o=>o,o=>{throw s.cancel(),o});let f;try{return typeof r?.etag=="string"&&r.etag!==v.ETAG_DISABLED&&await a,r?.atomic&&(0,v.hasFileAtomicReadCapability)(h)||!((0,v.hasOpenReadWriteCloseCapability)(h)||(0,v.hasFileReadStreamCapability)(h))||(0,v.hasReadWriteCapability)(h)&&r?.preferUnbuffered?f=this.readFileUnbuffered(h,i,r):(0,v.hasFileReadStreamCapability)(h)?f=this.readFileStreamed(h,i,s.token,r):f=this.readFileBuffered(h,i,s.token,r),{...await a,value:f}}catch(o){f&&await(0,d.consumeStream)(f);const c=(0,g.localize)(8,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(o).toString());throw o instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(c,o.stat,r):new v.FileOperationError(c,(0,v.toFileOperationResult)(o),r)}}readFileStreamed(h,i,r,n=Object.create(null)){const s=h.readFileStream(i,n,r);return(0,d.transform)(s,{data:a=>a instanceof D.VSBuffer?a:D.VSBuffer.wrap(a),error:a=>new v.FileOperationError((0,g.localize)(9,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(a).toString()),(0,v.toFileOperationResult)(a),n)},a=>D.VSBuffer.concat(a))}readFileBuffered(h,i,r,n=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,m.readFileIntoStream)(h,i,s,a=>a,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new v.FileOperationError((0,g.localize)(10,null,this.resourceForError(i),(0,v.ensureFileSystemProviderError)(a).toString()),(0,v.toFileOperationResult)(a),n)},r),s}readFileUnbuffered(h,i,r){const n=(0,d.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s;r?.atomic&&(0,v.hasFileAtomicReadCapability)(h)?s=await h.readFile(i,{atomic:!0}):s=await h.readFile(i),typeof r?.position=="number"&&(s=s.slice(r.position)),typeof r?.length=="number"&&(s=s.slice(0,r.length)),this.validateReadFileLimits(i,s.byteLength,r),n.end(D.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async validateReadFile(h,i){const r=await this.resolve(h,{resolveMetadata:!0});if(r.isDirectory)throw new v.FileOperationError((0,g.localize)(11,null,this.resourceForError(h)),0,i);if(typeof i?.etag=="string"&&i.etag!==v.ETAG_DISABLED&&i.etag===r.etag)throw new v.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,i);return this.validateReadFileLimits(h,r.size,i),r}validateReadFileLimits(h,i,r){if(r?.limits){let n;if(typeof r.limits.memory=="number"&&i>r.limits.memory&&(n=9),typeof r.limits.size=="number"&&i>r.limits.size&&(n=7),typeof n=="number")throw new v.FileOperationError((0,g.localize)(13,null,this.resourceForError(h)),n)}}async canMove(h,i,r){return this.doCanMoveCopy(h,i,"move",r)}async canCopy(h,i,r){return this.doCanMoveCopy(h,i,"copy",r)}async doCanMoveCopy(h,i,r,n){if(h.toString()!==i.toString())try{const s=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h):await this.withReadProvider(h),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(s,h,a,i,r,n)}catch(s){return s}return!0}async move(h,i,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,h,s,i,"move",!!r),f=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(h,a==="move"?2:3,f)),f}async copy(h,i,r){const n=await this.withReadProvider(h),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,h,s,i,"copy",!!r),f=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(h,a==="copy"?3:2,f)),f}async doMoveCopy(h,i,r,n,s,a){if(i.toString()===n.toString())return s;const{exists:f,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(h,i,r,n,s,a);if(f&&!o&&a&&await this.del(n,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(n)),s==="copy"){if(h===r&&(0,v.hasFileFolderCopyCapability)(h))await h.copy(i,n,{overwrite:a});else{const c=await this.resolve(i);c.isDirectory?await this.doCopyFolder(h,c,r,n):await this.doCopyFile(h,i,r,n)}return s}else return h===r?(await h.rename(i,n,{overwrite:a}),s):(await this.doMoveCopy(h,i,r,n,"copy",a),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(h,i,r,n){if((0,v.hasOpenReadWriteCloseCapability)(h)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(h,i,r,n);if((0,v.hasOpenReadWriteCloseCapability)(h)&&(0,v.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(h,i,r,n);if((0,v.hasReadWriteCapability)(h)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(h,i,r,n);if((0,v.hasReadWriteCapability)(h)&&(0,v.hasReadWriteCapability)(r))return this.doPipeUnbuffered(h,i,r,n)}async doCopyFolder(h,i,r,n){await r.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async s=>{const a=this.getExtUri(r).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.doCopyFolder(h,await this.resolve(s.resource),r,a):this.doCopyFile(h,s.resource,r,a)}))}async doValidateMoveCopy(h,i,r,n,s,a){let f=!1;if(h===r){const{providerExtUri:c,isPathCaseSensitive:T}=this.getExtUri(h);if(T||(f=c.isEqual(i,n)),f&&s==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!f&&c.isEqualOrParent(n,i))throw new Error((0,g.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const o=await this.exists(n);if(o&&!f){if(!a)throw new v.FileOperationError((0,g.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(h===r){const{providerExtUri:c}=this.getExtUri(h);if(c.isEqualOrParent(i,n))throw new Error((0,g.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:o,isSameResourceWithDifferentPathCase:f}}getExtUri(h){const i=this.isPathCaseSensitive(h);return{providerExtUri:i?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(h){return!!(h.capabilities&1024)}async createFolder(h){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(h),h);await this.mkdirp(i,h);const r=await this.resolve(h,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(h,0,r)),r}async mkdirp(h,i){const r=[],{providerExtUri:n}=this.getExtUri(h);for(;!n.isEqual(i,n.dirname(i));)try{if(((await h.stat(i)).type&v.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.resourceForError(i)));break}catch(s){if((0,v.toFileSystemProviderErrorCode)(s)!==v.FileSystemProviderErrorCode.FileNotFound)throw s;r.push(n.basename(i)),i=n.dirname(i)}for(let s=r.length-1;s>=0;s--){i=n.joinPath(i,r[s]);try{await h.mkdir(i)}catch(a){if((0,v.toFileSystemProviderErrorCode)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(h,i){try{await this.doValidateDelete(h,i)}catch(r){return r}return!0}async doValidateDelete(h,i){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(h),h);if(!!i?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(h)));let s;try{s=await r.stat(h)}catch{}if(s)this.throwIfFileIsReadonly(h,s);else throw new v.FileOperationError((0,g.localize)(20,null,this.resourceForError(h)),1);if(!!!i?.recursive){const f=await this.resolve(h);if(f.isDirectory&&Array.isArray(f.children)&&f.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(h)))}return r}async del(h,i){const r=await this.doValidateDelete(h,i),n=!!i?.useTrash,s=!!i?.recursive;await r.delete(h,{recursive:s,useTrash:n}),this._onDidRunOperation.fire(new v.FileOperationEvent(h,1))}async cloneFile(h,i){const r=await this.withProvider(h),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(r===n&&this.getExtUri(r).providerExtUri.isEqual(h,i))return;if(r===n&&(0,v.hasFileCloneCapability)(r))return r.cloneFile(h,i);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i));const s=this.writeQueue.queueFor(h,this.getExtUri(r).providerExtUri);return r===n&&(0,v.hasFileFolderCopyCapability)(r)?s.queue(()=>r.copy(h,i,{overwrite:!0})):s.queue(()=>this.doCopyFile(r,h,n,i))}watch(h,i={recursive:!1,excludes:[]}){const r=new b.DisposableStore;let n=!1,s=()=>{n=!0};return r.add((0,b.toDisposable)(()=>s())),(async()=>{try{const a=await this.doWatch(h,i);n?(0,b.dispose)(a):s=()=>(0,b.dispose)(a)}catch(a){this.logService.error(a)}})(),r}async doWatch(h,i){const r=await this.withProvider(h),n=(0,C.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(h),i]);let s=this.activeWatchers.get(n);return s||(s={count:0,disposable:r.watch(h,i)},this.activeWatchers.set(n,s)),s.count+=1,(0,b.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,b.dispose)(s.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,h]of this.activeWatchers)(0,b.dispose)(h.disposable);this.activeWatchers.clear()}async doWriteBuffered(h,i,r,n){return this.writeQueue.queueFor(i,this.getExtUri(h).providerExtUri).queue(async()=>{const s=await h.open(i,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(h,s,n):await this.doWriteReadableBufferedQueued(h,s,n)}catch(a){throw(0,v.ensureFileSystemProviderError)(a)}finally{await h.close(s)}})}async doWriteStreamBufferedQueued(h,i,r){let n=0,s;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const a=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(h,i,a,a.byteLength,n,0),n+=a.byteLength}if(r.ended)return;s=r.stream}else s=r;return new Promise((a,f)=>{(0,d.listenStream)(s,{onData:async o=>{s.pause();try{await this.doWriteBuffer(h,i,o,o.byteLength,n,0)}catch(c){return f(c)}n+=o.byteLength,setTimeout(()=>s.resume())},onError:o=>f(o),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(h,i,r){let n=0,s;for(;(s=r.read())!==null;)await this.doWriteBuffer(h,i,s,s.byteLength,n,0),n+=s.byteLength}async doWriteBuffer(h,i,r,n,s,a){let f=0;for(;f<n;)f+=await h.write(i,s+f,r.buffer,a+f,n-f)}async doWriteUnbuffered(h,i,r,n){return this.writeQueue.queueFor(i,this.getExtUri(h).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(h,i,r,n))}async doWriteUnbufferedQueued(h,i,r,n){let s;n instanceof D.VSBuffer?s=n:(0,d.isReadableStream)(n)?s=await(0,D.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?s=await(0,D.bufferedStreamToBuffer)(n):s=(0,D.readableToBuffer)(n),await h.writeFile(i,s.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(h,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(h,i,r,n))}async doPipeBufferedQueued(h,i,r,n){let s,a;try{s=await h.open(i,{create:!1}),a=await r.open(n,{create:!0,unlock:!1});const f=D.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,c=0,T=0;do T=await h.read(s,o,f.buffer,c,f.byteLength-c),await this.doWriteBuffer(r,a,f,T,o,c),o+=T,c+=T,c===f.byteLength&&(c=0);while(T>0)}catch(f){throw(0,v.ensureFileSystemProviderError)(f)}finally{await t.Promises.settled([typeof s=="number"?h.close(s):Promise.resolve(),typeof a=="number"?r.close(a):Promise.resolve()])}}async doPipeUnbuffered(h,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(h,i,r,n))}async doPipeUnbufferedQueued(h,i,r,n){return r.writeFile(n,await h.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(h,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(h,i,r,n))}async doPipeUnbufferedToBufferedQueued(h,i,r,n){const s=await r.open(n,{create:!0,unlock:!1});try{const a=await h.readFile(i);await this.doWriteBuffer(r,s,D.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,v.ensureFileSystemProviderError)(a)}finally{await r.close(s)}}async doPipeBufferedToUnbuffered(h,i,r,n){const s=await(0,D.streamToBuffer)(this.readFileBuffered(h,i,I.CancellationToken.None));await this.doWriteUnbuffered(r,n,void 0,s)}throwIfFileSystemIsReadonly(h,i){if(h.capabilities&2048)throw new v.FileOperationError((0,g.localize)(22,null,this.resourceForError(i)),6);return h}throwIfFileIsReadonly(h,i){if((i.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,g.localize)(23,null,this.resourceForError(h)),6)}resourceForError(h){return h.scheme===R.Schemas.file?h.fsPath:h.toString(!0)}};u=Ae([_e(0,p.ILogService)],u),e.FileService=u}),define(we[62],ye([1,0,29,275,14,31,16,7,36,2,6,3,19,44,21,174,17,103,208,38,205,204]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(y)}catch(r){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(r)}`)}})();class i extends p.AbstractDiskFileSystemProvider{constructor(n,s){super(n,s),this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new I.ResourceMap(a=>S.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:a}=await d.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,a),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await d.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),a=[];return await Promise.all(s.map(async f=>{try{let o;f.isSymbolicLink()?o=(await this.stat((0,S.joinPath)(n,f.name))).type:o=this.toType(f),a.push([f.name,o])}catch(o){this.logService.trace(o)}})),a}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let a;return s?.dangling?a=v.FileType.Unknown:n.isFile()?a=v.FileType.File:n.isDirectory()?a=v.FileType.Directory:a=v.FileType.Unknown,s&&(a|=v.FileType.SymbolicLink),a}async createResourceLock(n){const s=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let a;for(;a=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await a.wait();const f=new D.Barrier;return this.resourceLocks.set(n,f),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,b.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(n)===f&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),f.open()})}async readFile(n,s){let a;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),a=await this.createResourceLock(n));const f=this.toFilePath(n);return await d.Promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}finally{a?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,s,a){const f=(0,w.newWriteableStream)(o=>P.VSBuffer.concat(o.map(c=>P.VSBuffer.wrap(c))).buffer);return(0,m.readFileIntoStream)(this,n,f,o=>o.buffer,{...s,bufferSize:256*1024},a),f}async writeFile(n,s,a){let f;try{const o=this.toFilePath(n);if(!a.create||!a.overwrite){if(await d.Promises.exists(o)){if(!a.overwrite)throw(0,v.createFileSystemProviderError)((0,g.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,v.createFileSystemProviderError)((0,g.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(f,0,s,0,s.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(n,o)}finally{typeof f=="number"&&await this.close(f)}}static configureFlushOnWrite(n){i.canFlush=n}async open(n,s){const a=this.toFilePath(n);let f;(0,v.isFileOpenForWriteOptions)(s)&&(f=await this.createResourceLock(n));let o;try{if((0,v.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:T}=await d.SymlinkSupport.stat(a);T.mode&128||await d.Promises.chmod(a,T.mode|128)}catch(T){this.logService.trace(T)}let c;if((0,v.isFileOpenForWriteOptions)(s)){if(R.isWindows)try{await d.Promises.truncate(a,0),c="r+"}catch(T){T.code!=="ENOENT"&&this.logService.trace(T)}c||(c="w")}else c="r";o=await d.Promises.open(a,c)}catch(c){throw f?.dispose(),(0,v.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,c):this.toFileSystemProviderError(c)}if(this.mapHandleToPos.set(o,0),(0,v.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(o,n),f){const c=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${a})`),this.mapHandleToLock.set(o,f),c&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${a})`),c.dispose())}return o}async close(n){const s=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await d.Promises.fdatasync(n)}catch(a){i.configureFlushOnWrite(!1),this.logService.error(a)}return await d.Promises.close(n)}catch(a){throw this.toFileSystemProviderError(a)}finally{s&&(this.mapHandleToLock.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,a,f,o){const c=this.normalizePos(n,s);let T=null;try{T=(await d.Promises.read(n,a,f,o,c)).bytesRead}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(n,c,T)}return T}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,a){const f=this.mapHandleToPos.get(n);typeof f=="number"&&(typeof s=="number"||(typeof a=="number"?this.mapHandleToPos.set(n,f+a):this.mapHandleToPos.delete(n)))}async write(n,s,a,f,o){return(0,D.retry)(()=>this.doWrite(n,s,a,f,o),100,3)}async doWrite(n,s,a,f,o){const c=this.normalizePos(n,s);let T=null;try{T=(await d.Promises.write(n,a,f,o,c)).bytesWritten}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),O)}finally{this.updatePos(n,c,T)}return T}async mkdir(n){try{await d.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const a=this.toFilePath(n);s.recursive?await d.Promises.rm(a,d.RimRafMode.MOVE):await d.Promises.unlink(a)}catch(a){throw this.toFileSystemProviderError(a)}}async rename(n,s,a){const f=this.toFilePath(n),o=this.toFilePath(s);if(f!==o)try{await this.validateTargetDeleted(n,s,"move",a.overwrite),await d.Promises.move(f,o)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,g.localize)(2,null,(0,k.basename)(f),(0,k.basename)((0,k.dirname)(o)),c.toString()))),this.toFileSystemProviderError(c)}}async copy(n,s,a){const f=this.toFilePath(n),o=this.toFilePath(s);if(f!==o)try{await this.validateTargetDeleted(n,s,"copy",a.overwrite),await d.Promises.copy(f,o,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,g.localize)(3,null,(0,k.basename)(f),(0,k.basename)((0,k.dirname)(o)),c.toString()))),this.toFileSystemProviderError(c)}}async validateTargetDeleted(n,s,a,f){const o=this.toFilePath(n),c=this.toFilePath(s);let T=!1;if(!!(this.capabilities&1024)||(T=(0,E.isEqual)(o,c,!0)),T&&a==="copy")throw(0,v.createFileSystemProviderError)((0,g.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!T&&await d.Promises.exists(c)){if(!f)throw(0,v.createFileSystemProviderError)((0,g.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(n,s){return this.doCloneFile(n,s,!1)}async doCloneFile(n,s,a){const f=this.toFilePath(n),o=this.toFilePath(s),c=!!(this.capabilities&1024);if((0,E.isEqual)(f,o,!c))return;const T=new b.DisposableStore;try{const[O,K]=await Promise.all([this.createResourceLock(n),this.createResourceLock(s)]);T.add(O),T.add(K),a&&await d.Promises.mkdir((0,k.dirname)(o),{recursive:!0}),await d.Promises.copyFile(f,o)}catch(O){if(O.code==="ENOENT"&&!a)return this.doCloneFile(n,s,!0);throw this.toFileSystemProviderError(O)}finally{T.dispose()}}createUniversalWatcher(n,s,a){return new l.UniversalWatcherClient(f=>n(f),f=>s(f),a)}createNonRecursiveWatcher(n,s,a){return new h.NodeJSWatcherClient(f=>n(f),f=>s(f),a)}toFileSystemProviderError(n){if(n instanceof v.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=v.FileSystemProviderErrorCode.NoPermissions;break;default:s=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(n,s)}async toFileSystemProviderWriteError(n,s){let a=this.toFileSystemProviderError(s);if(n&&a.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await d.SymlinkSupport.stat(this.toFilePath(n));f.mode&128||(a=(0,v.createFileSystemProviderError)(s,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return a}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(we[209],ye([1,0,7,62,2,16,44,20]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class E extends D.Disposable{constructor(R,S){super(),this.provider=R,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,S,w){const d=this.getUriTransformer(R);switch(S){case"stat":return this.stat(d,w[0]);case"readdir":return this.readdir(d,w[0]);case"open":return this.open(d,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(d,w[0],w[1]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(d,w[0],w[1],w[2]);case"rename":return this.rename(d,w[0],w[1],w[2]);case"copy":return this.copy(d,w[0],w[1],w[2]);case"cloneFile":return this.cloneFile(d,w[0],w[1]);case"mkdir":return this.mkdir(d,w[0]);case"delete":return this.delete(d,w[0],w[1]);case"watch":return this.watch(d,w[0],w[1],w[2],w[3]);case"unwatch":return this.unwatch(w[0],w[1])}throw new Error(`IPC Command ${S} not found`)}listen(R,S,w){const d=this.getUriTransformer(R);switch(S){case"fileChange":return this.onFileChange(d,w[0]);case"readFileStream":return this.onReadFileStream(d,w[0],w[1])}throw new Error(`Unknown event ${S}`)}stat(R,S){const w=this.transformIncoming(R,S,!0);return this.provider.stat(w)}readdir(R,S){const w=this.transformIncoming(R,S);return this.provider.readdir(w)}async readFile(R,S,w){const d=this.transformIncoming(R,S,!0),g=await this.provider.readFile(d,w);return I.VSBuffer.wrap(g)}onReadFileStream(R,S,w){const d=this.transformIncoming(R,S,!0),g=new C.CancellationTokenSource,v=new y.Emitter({onLastListenerRemove:()=>{g.cancel()}}),m=this.provider.readFileStream(d,w,g.token);return(0,P.listenStream)(m,{onData:p=>v.fire(I.VSBuffer.wrap(p)),onError:p=>v.fire(p),onEnd:()=>{v.fire("end"),v.dispose(),g.dispose()}}),v.event}writeFile(R,S,w,d){const g=this.transformIncoming(R,S);return this.provider.writeFile(g,w.buffer,d)}open(R,S,w){const d=this.transformIncoming(R,S,!0);return this.provider.open(d,w)}close(R){return this.provider.close(R)}async read(R,S,w){const d=I.VSBuffer.alloc(w),g=0,v=await this.provider.read(R,S,d.buffer,g,w);return[d,v]}write(R,S,w,d,g){return this.provider.write(R,S,w.buffer,d,g)}mkdir(R,S){const w=this.transformIncoming(R,S);return this.provider.mkdir(w)}delete(R,S,w){const d=this.transformIncoming(R,S);return this.provider.delete(d,w)}rename(R,S,w,d){const g=this.transformIncoming(R,S),v=this.transformIncoming(R,w);return this.provider.rename(g,v,d)}copy(R,S,w,d){const g=this.transformIncoming(R,S),v=this.transformIncoming(R,w);return this.provider.copy(g,v,d)}cloneFile(R,S,w){const d=this.transformIncoming(R,S),g=this.transformIncoming(R,w);return this.provider.cloneFile(d,g)}onFileChange(R,S){const w=new y.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(R,w))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return w.event}async watch(R,S,w,d,g){const v=this.sessionToWatcher.get(S);if(v){const m=this.transformIncoming(R,d),p=v.watch(w,m,g);this.watchRequests.set(S+w,p)}}async unwatch(R,S){const w=R+S,d=this.watchRequests.get(w);d&&((0,D.dispose)(d),this.watchRequests.delete(w))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=E;class b extends D.Disposable{constructor(R,S,w,d){super(),this.uriTransformer=R,this.logService=w,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(R){const S=this._register(new y.Emitter);this._register(S.event(w=>{R.fire(w.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>S.fire(w))),this._register(this.fileWatcher.onDidWatchError(w=>R.fire(w)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,S,w){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(w.excludes=[...w.excludes,...d]),this.watcherRequests.set(R,this.fileWatcher.watch(S,w)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=b}),define(we[210],ye([1,0,12]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(I,P){switch(P){case y.LogLevel.Trace:return I.trace;case y.LogLevel.Debug:return I.debug;case y.LogLevel.Info:return I.info;case y.LogLevel.Warning:return I.warn;case y.LogLevel.Error:return I.error;case y.LogLevel.Critical:return I.critical;default:throw new Error("Invalid log level")}}class D extends y.AbstractLogger{constructor(P=y.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(C=>{this._logger?.setLevel(C)}))}set logger(P){this._logger=P;for(const{level:C,args:E}of this.buffer)t(P,C).apply(P,E);this.buffer=[]}_log(P,...C){this._logger?t(this._logger,P).apply(this._logger,C):this.getLevel()<=P&&this.buffer.push({level:P,args:C})}trace(P,...C){this._log(y.LogLevel.Trace,P,...C)}debug(P,...C){this._log(y.LogLevel.Debug,P,...C)}info(P,...C){this._log(y.LogLevel.Info,P,...C)}warn(P,...C){this._log(y.LogLevel.Warning,P,...C)}error(P,...C){this._log(y.LogLevel.Error,P,...C)}critical(P,...C){this._log(y.LogLevel.Critical,P,...C)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=D}),define(we[106],ye([1,0,7,4,12]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class I{constructor(S,w){this.logService=S,this.loggerService=w,this.onDidChangeLogLevel=y.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(S,w,d){switch(w){case"setLevel":return d[1]?this.loggerService.setLevel(t.URI.revive(d[1]),d[0]):this.logService.setLevel(d[0])}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=I;class P{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S,w){P.setLevel(this.channel,S,w)}static setLevel(S,w,d){return S.call("setLevel",[w,d])}}e.LogLevelChannelClient=P;class C{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,w){throw new Error(`Event not found: ${w}`)}async call(S,w,d){switch(w){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${w}`)}createLogger(S,w){this.loggers.set(S.toString(),this.loggerService.createLogger(S,w))}consoleLog(S,w){let d=console.log;switch(S){case D.LogLevel.Error:d=console.error;break;case D.LogLevel.Warning:d=console.warn;break;case D.LogLevel.Info:d=console.info;break}d.call(console,...w)}log(S,w){const d=this.loggers.get(S.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,v]of w)(0,D.log)(d,g,v)}}e.LoggerChannel=C;class E extends D.AbstractLoggerService{constructor(S,w,d){super(S,w),this.channel=d}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,w)=>{this.channel.call("consoleLog",[S,w])}})}doCreateLogger(S,w,d){return new b(this.channel,S,w,d)}}e.LoggerChannelClient=E;class b extends D.AbstractMessageLogger{constructor(S,w,d,g){super(g?.always),this.channel=S,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[w,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,w){const d=[[S,w]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(S){this.channel.call("log",[this.file,S])}}class k extends D.LogService{constructor(S,w){super(w),this.parent=S,this._register(S.onDidChangeLogLevel(d=>w.setLevel(d)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=k}),define(we[107],ye([1,0,17,12]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(C,E,b,k,R){try{const S=await new Promise((d,g)=>{oe(["spdlog"],d,g)});S.setFlushOn(t.LogLevel.Trace);const w=await S.createAsyncRotatingLogger(C,E,b,k);return R?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function I(C,E,b){switch(E){case t.LogLevel.Trace:C.trace(b);break;case t.LogLevel.Debug:C.debug(b);break;case t.LogLevel.Info:C.info(b);break;case t.LogLevel.Warning:C.warn(b);break;case t.LogLevel.Error:C.error(b);break;case t.LogLevel.Critical:C.critical(b);break;default:throw new Error("Invalid log level")}}class P extends t.AbstractMessageLogger{constructor(E,b,k,R,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(E,b,k,R),this._register(this.onDidChangeLogLevel(w=>{this._logger?.setLevel(w)}))}async _createSpdLogLogger(E,b,k,R){const S=k?6:1,w=30/S*y.ByteSize.MB,d=await D(E,b,w,S,R);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:g,message:v}of this.buffer)I(this._logger,g,v);this.buffer=[]}}log(E,b){this._logger?I(this._logger,E,b):this.getLevel()<=E&&this.buffer.push({level:E,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(we[211],ye([1,0,22,12,107]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let I=class extends t.AbstractLoggerService{constructor(C){super(C.getLevel(),C.onDidChangeLogLevel)}doCreateLogger(C,E,b){return new D.SpdLogLogger(b?.name||(0,y.generateUuid)(),C.fsPath,!b?.donotRotate,!!b?.donotUseFormatters,E)}};I=Ae([_e(0,t.ILogService)],I),e.LoggerService=I}),define(we[212],ye([1,0,69,176,5]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var P;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function b(d,g){return g-d}E.compare=b;const k=Object.create(null);k[E.Error]=(0,t.localize)(0,null),k[E.Warning]=(0,t.localize)(1,null),k[E.Info]=(0,t.localize)(2,null);function R(d){return k[d]||""}E.toString=R;function S(d){switch(d){case y.default.Error:return E.Error;case y.default.Warning:return E.Warning;case y.default.Info:return E.Info;case y.default.Ignore:return E.Hint}}E.fromSeverity=S;function w(d){switch(d){case E.Error:return y.default.Error;case E.Warning:return y.default.Warning;case E.Info:return y.default.Info;case E.Hint:return y.default.Ignore}}E.toSeverity=w}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(E){const b="";function k(S){return R(S,!0)}E.makeKey=k;function R(S,w){const d=[b];return S.source?d.push(S.source.replace("\xA6","\\\xA6")):d.push(b),S.code?typeof S.code=="string"?d.push(S.code.replace("\xA6","\\\xA6")):d.push(S.code.value.replace("\xA6","\\\xA6")):d.push(b),S.severity!==void 0&&S.severity!==null?d.push(P.toString(S.severity)):d.push(b),S.message&&w?d.push(S.message.replace("\xA6","\\\xA6")):d.push(b),S.startLineNumber!==void 0&&S.startLineNumber!==null?d.push(S.startLineNumber.toString()):d.push(b),S.startColumn!==void 0&&S.startColumn!==null?d.push(S.startColumn.toString()):d.push(b),S.endLineNumber!==void 0&&S.endLineNumber!==null?d.push(S.endLineNumber.toString()):d.push(b),S.endColumn!==void 0&&S.endColumn!==null?d.push(S.endColumn.toString()):d.push(b),d.push(b),d.join("\xA6")}E.makeKeyOptionalMessage=R})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(we[63],ye([1,0,7,55,2,5]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,I.createDecorator)("policy");class P extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(b){const k=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...b,...this.policyDefinitions},k!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(b),t.Iterable.reduce(this.policies.entries(),(R,[S,w])=>({...R,[S]:w}),{})}getPolicyValue(b){return this.policies.get(b)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(b,[k,R])=>({...b,[k]:{definition:R,value:this.policies.get(k)}}),{})}}e.AbstractPolicyService=P;class C{constructor(){this.onDidChange=y.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=C}),define(we[50],ye([1,0,9,3,26,19]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const C=t.globals.vscode.context.configuration();if(C)P=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof oe?.__$__nodeRequire=="function"){const C=(0,I.dirname)(y.FileAccess.asFileUri("",oe));if(P=oe.__$__nodeRequire((0,I.joinPath)(C,"product.json").fsPath),D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`,serverDataFolderName:P.serverDataFolderName?`${P.serverDataFolderName}-dev`:void 0}),!P.version){const E=oe.__$__nodeRequire((0,I.joinPath)(C,"package.json").fsPath);Object.assign(P,{version:E.version})}Object.assign(P,{extensionsGallery:D.env.EXTENSIONS_GALLERY?JSON.parse(D.env.EXTENSIONS_GALLERY):P.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else P={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.72.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.73.1",commit:"6261075646f055b99068d3688932416f2346dd3b",date:"2022-12-07T20:58:35.136Z"},Object.keys(P).length===0&&Object.assign(P,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=P}),define(we[25],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(we[34],ye([1,0,86,13]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,C){y.ok(t.isString(P)),y.ok(t.isObject(C)),y.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,C)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(we[213],ye([1,0,7,34]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class I{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,b){this.schemasById[D(E)]=b,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new I;t.Registry.add(e.Extensions.JSONContribution,P)}),define(we[51],ye([1,0,18,7,13,160,24,213,34]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=E.Registry.as(C.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const n=this.doRegisterConfigurations(i,r);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const r=this.doDeregisterConfigurations(i);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:i,remove:r}){const n=[];n.push(...this.doDeregisterConfigurations(r)),n.push(...this.doRegisterConfigurations(i,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,y.distinct)(n)})}registerDefaultConfigurations(i){const r=[],n=[];for(const{overrides:s,source:a}of i)for(const f in s)if(r.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const o=this.configurationDefaultsOverrides.get(f),c=o?.valuesSources??new Map;if(a)for(const re of Object.keys(s[f]))c.set(re,a);const T={...o?.value||{},...s[f]};this.configurationDefaultsOverrides.set(f,{source:a,value:T,valuesSources:c});const O=(0,P.getLanguageTagSettingPlainKey)(f),K={type:"object",default:T,description:I.localize(1,null,O),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:T,source:D.isString(a)?void 0:a,defaultValueSource:a};n.push(...g(f)),this.configurationProperties[f]=K,this.defaultLanguageConfigurationOverridesNode.properties[f]=K}else{this.configurationDefaultsOverrides.set(f,{value:s[f],source:a});const o=this.configurationProperties[f];o&&(this.updatePropertyDefaultValue(f,o),this.updateSchema(f,o))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const r=[];for(const{overrides:n,source:s}of i)for(const a in n){const f=this.configurationDefaultsOverrides.get(a),o=D.isString(s)?s:s?.id,c=D.isString(f?.source)?f?.source:f?.source?.id;if(o===c)if(r.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const T=this.configurationProperties[a];T&&(this.updatePropertyDefaultValue(a,T),this.updateSchema(a,T))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const r of i)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,r){const n=[];return i.forEach(s=>{n.push(...this.validateAndRegisterProperties(s,r,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),n}doDeregisterConfigurations(i){const r=[],n=s=>{if(s.properties)for(const a in s.properties){r.push(a);const f=this.configurationProperties[a];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,s.properties[a])}s.allOf?.forEach(a=>n(a))};for(const s of i){n(s);const a=this.configurationContributors.indexOf(s);a!==-1&&this.configurationContributors.splice(a,1)}return r}validateAndRegisterProperties(i,r=!0,n,s,a=3){a=D.isUndefinedOrNull(i.scope)?a:i.scope;const f=[],o=i.properties;if(o)for(const T in o){const O=o[T];if(r&&u(T,O)){delete o[T];continue}if(O.source=n,O.defaultDefaultValue=o[T].default,this.updatePropertyDefaultValue(T,O),e.OVERRIDE_PROPERTY_REGEX.test(T)?O.scope=void 0:(O.scope=D.isUndefinedOrNull(O.scope)?a:O.scope,O.restricted=D.isUndefinedOrNull(O.restricted)?!!s?.includes(T):O.restricted),o[T].hasOwnProperty("included")&&!o[T].included){this.excludedConfigurationProperties[T]=o[T],delete o[T];continue}else this.configurationProperties[T]=o[T],o[T].policy?.name&&this.policyConfigurations.set(o[T].policy.name,T);!o[T].deprecationMessage&&o[T].markdownDeprecationMessage&&(o[T].deprecationMessage=o[T].markdownDeprecationMessage),f.push(T)}const c=i.allOf;if(c)for(const T of c)f.push(...this.validateAndRegisterProperties(T,r,n,s,a));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const r=n=>{const s=n.properties;if(s)for(const f in s)this.updateSchema(f,s[f]);n.allOf?.forEach(r)};r(i)}updateSchema(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.resourceLanguageSettingsSchema.properties[i]=r;break}}removeFromSchema(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const r=`[${i}]`,n={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,r){const n=this.configurationDefaultsOverrides.get(i);let s=n?.value,a=n?.source;D.isUndefined(s)&&(s=r.defaultDefaultValue,a=void 0),D.isUndefined(s)&&(s=m(r.type)),r.default=s,r.defaultValueSource=a}}const w="\\[([^\\]]+)\\]",d=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(h){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let r=d.exec(h);for(;r?.length;){const n=r[1].trim();n&&i.push(n),r=d.exec(h)}}return(0,y.distinct)(i)}e.overrideIdentifiersFromKey=g;function v(h){return h.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=v;function m(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const p=new S;E.Registry.add(e.Extensions.Configuration,p);function u(h,i){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?I.localize(7,null,h):p.getConfigurationProperties()[h]!==void 0?I.localize(8,null,h):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?I.localize(9,null,h,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:I.localize(6,null)}e.validateProperty=u;function l(){const h=[],i=p.getConfigurationProperties();for(const r of Object.keys(i))h.push([r,i[r].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=l}),define(we[108],ye([1,0,18,7,67,2,31,23,13,4,24,51,34]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class w{constructor(r={},n=[],s=[],a){this._contents=r,this._keys=n,this._overrides=s,this.raw=a,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof w)return n;const s=new d("");return s.parseRaw(n),s.configurationModel});this._rawConfiguration=r.reduce((n,s)=>s===n?s:n.merge(s),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,k.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const s=this.rawConfiguration.getValue(r),a=n?this.rawConfiguration.getOverrideValue(r,n):void 0,f=n?this.rawConfiguration.override(n).getValue(r):s;return{value:s,override:a,merged:f}}getOverrideValue(r,n){const s=this.getContentsForOverrideIdentifer(n);return s?r?(0,k.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const s of this.overrides)s.identifiers.includes(r)&&n.push(...s.keys);return y.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return y.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=C.deepClone(this.contents),s=C.deepClone(this.overrides),a=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const o of r)if(f.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.mergeContents(n,o.contents);for(const c of o.overrides){const[T]=s.filter(O=>y.equals(O.identifiers,c.identifiers));T?(this.mergeContents(T.contents,c.contents),T.keys.push(...c.keys),T.keys=y.distinct(T.keys)):s.push(C.deepClone(c))}for(const c of o.keys)a.indexOf(c)===-1&&a.push(c)}return new w(n,a,s,f.every(o=>o instanceof w)?void 0:f)}freeze(){return this.frozen=!0,this}clone(){return new w(C.deepClone(this.contents),[...this.keys],C.deepClone(this.overrides))}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const a of y.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[a];const o=n[a];o&&(typeof f=="object"&&typeof o=="object"?(f=C.deepClone(f),this.mergeContents(f,o)):f=o),s[a]=f}return new w(s,this.keys,this.overrides)}mergeContents(r,n){for(const s of Object.keys(n)){if(s in r&&E.isObject(r[s])&&E.isObject(n[s])){this.mergeContents(r[s],n[s]);continue}r[s]=C.deepClone(n[s])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?C.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,s=null;const a=f=>{f&&(s?this.mergeContents(s,f):s=C.deepClone(f))};for(const f of this.overrides)y.equals(f.identifiers,[r])?n=f.contents:f.identifiers.includes(r)&&a(f.contents);return a(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,k.addToValueTree)(this.contents,r,n,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,k.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let s=0;s<n;s++)r.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,r)}removeKey(r){const n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=w;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!E.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:s,keys:a,overrides:f,restricted:o,hasExcludedProperties:c}=this.doParseRaw(r,n);this._configurationModel=new w(s,a,f,c?[r]:void 0),this._restrictedConfigurations=o||[]}doParseContent(r){let n={},s=null,a=[];const f=[],o=[];function c(O){Array.isArray(a)?a.push(O):s!==null&&(a[s]=O)}const T={onObjectBegin:()=>{const O={};c(O),f.push(a),a=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const O=[];c(O),f.push(a),a=O,s=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:c,onError:(O,K,re)=>{o.push({error:O,offset:K,length:re})}};if(r)try{D.visit(r,T),n=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return n}doParseRaw(r,n){const s=S.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),a=this.filter(r,s,!0,n);r=a.raw;const f=(0,k.toValuesTree)(r,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),o=Object.keys(r),c=this.toOverrides(r,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:f,keys:o,overrides:c,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(r,n,s,a){let f=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:f};const o={},c=[];for(const T in r)if(R.OVERRIDE_PROPERTY_REGEX.test(T)&&s){const O=this.filter(r[T],n,!1,a);o[T]=O.raw,f=f||O.hasExcludedProperties,c.push(...O.restricted)}else{const O=n[T],K=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&c.push(T),(K===void 0||a.scopes===void 0||a.scopes.includes(K))&&!(a.skipRestricted&&O?.restricted)?o[T]=r[T]:f=!0}return{raw:o,restricted:c,hasExcludedProperties:f}}toOverrides(r,n){const s=[];for(const a of Object.keys(r))if(R.OVERRIDE_PROPERTY_REGEX.test(a)){const f={};for(const o in r[a])f[o]=r[a][o];s.push({identifiers:(0,R.overrideIdentifiersFromKey)(a),keys:Object.keys(f),contents:(0,k.toValuesTree)(f,n)})}return s}}e.ConfigurationModelParser=d;class g extends I.Disposable{constructor(r,n,s,a){super(),this.userSettingsResource=r,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&s.isEqual(f.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class v{constructor(r,n,s,a,f,o,c,T,O,K,re,le,ae){this.key=r,this.overrides=n,this.value=s,this.overrideIdentifiers=a,this.defaultConfiguration=f,this.policyConfiguration=o,this.applicationConfiguration=c,this.userConfiguration=T,this.localUserConfiguration=O,this.remoteUserConfiguration=K,this.workspaceConfiguration=re,this.folderConfigurationModel=le,this.memoryInspectValue=ae}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class m{constructor(r,n,s,a,f=new w,o=new w,c=new P.ResourceMap,T=new w,O=new P.ResourceMap,K=!0){this._defaultConfiguration=r,this._policyConfiguration=n,this._applicationConfiguration=s,this._localUserConfiguration=a,this._remoteUserConfiguration=f,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=T,this._memoryConfigurationByResource=O,this._freeze=K,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(r,n,s){return this.getConsolidatedConfigurationModel(r,n,s).getValue(r)}updateValue(r,n,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new w,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(r):a.setValue(r,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,s){const a=this.getConsolidatedConfigurationModel(r,n,s),f=y.distinct(a.overrides.map(T=>T.identifiers).flat()).filter(T=>a.getOverrideValue(r,T)!==void 0),o=this.getFolderConfigurationModelForResource(n.resource,s),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new v(r,n,a.getValue(r),f.length?f:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),s?this._workspaceConfiguration.freeze():void 0,o?o.freeze():void 0,c.inspect(r,n.overrideIdentifier))}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const s=[];if(!n){const{added:a,updated:f,removed:o}=l(this._defaultConfiguration,r);n=[...a,...f,...o]}for(const a of n)for(const f of(0,R.overrideIdentifiersFromKey)(a)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(f),c=r.getKeysForOverrideIdentifier(f),T=[...c.filter(O=>o.indexOf(O)===-1),...o.filter(O=>c.indexOf(O)===-1),...o.filter(O=>!C.equals(this._defaultConfiguration.override(f).getValue(O),r.override(f).getValue(O)))];s.push([f,T])}return this.updateDefaultConfiguration(r),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:s,removed:a}=l(this._policyConfiguration,r),f=[...n,...s,...a];return f.length&&this.updatePolicyConfiguration(r),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:s,removed:a,overrides:f}=l(this.applicationConfiguration,r),o=[...n,...s,...a];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:f}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:s,removed:a,overrides:f}=l(this.localUserConfiguration,r),o=[...n,...s,...a];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:f}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:s,removed:a,overrides:f}=l(this.remoteUserConfiguration,r),o=[...n,...s,...a];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:f}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:s,removed:a,overrides:f}=l(this.workspaceConfiguration,r),o=[...n,...s,...a];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:f}}compareAndUpdateFolderConfiguration(r,n){const s=this.folderConfigurations.get(r),{added:a,updated:f,removed:o,overrides:c}=l(s,n),T=[...a,...f,...o];return(T.length||!s)&&this.updateFolderConfiguration(r,n),{keys:T,overrides:c}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:a,removed:f,overrides:o}=l(n,void 0);return{keys:[...s,...a,...f],overrides:o}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,n,s){let a=this.getConsolidatedConfigurationModelForResource(n,s);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:r},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const a=n.getFolder(r);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const f=this._memoryConfigurationByResource.get(r);f&&(s=s.merge(f))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(r);a?(n=s.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=s}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const s=n.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:s,overrides:a,keys:f}=this._folderConfigurations.get(n);return r.push([n,{contents:s,overrides:a,keys:f}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.policy),a=this.parseConfigurationModel(r.application),f=this.parseConfigurationModel(r.user),o=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((T,O)=>(T.set(b.URI.revive(O[0]),this.parseConfigurationModel(O[1])),T),new P.ResourceMap);return new m(n,s,a,f,new w,o,c,new w,new P.ResourceMap,!1)}static parseConfigurationModel(r){return new w(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=m;function p(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,n=new Map;for(const a of i)a.keys.forEach(f=>r.add(f)),a.overrides.forEach(([f,o])=>{const c=(0,P.getOrSet)(n,f,new Set);o.forEach(T=>c.add(T))});const s=[];return n.forEach((a,f)=>s.push([f,[...a.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=p;class u{constructor(r,n,s,a){this.change=r,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const f=new Set;r.keys.forEach(c=>f.add(c)),r.overrides.forEach(([,c])=>c.forEach(T=>f.add(T))),this.affectedKeys=[...f.values()];const o=new w;this.affectedKeys.forEach(c=>o.setValue(c,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!C.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let s=(0,k.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(r=r[a],!r)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=u;function l(i,r){const{added:n,removed:s,updated:a}=h(r?.rawConfiguration,i?.rawConfiguration),f=[],o=i?.getAllOverrideIdentifiers()||[],c=r?.getAllOverrideIdentifiers()||[];if(r){const T=c.filter(O=>!o.includes(O));for(const O of T)f.push([O,r.getKeysForOverrideIdentifier(O)])}if(i){const T=o.filter(O=>!c.includes(O));for(const O of T)f.push([O,i.getKeysForOverrideIdentifier(O)])}if(r&&i){for(const T of o)if(c.includes(T)){const O=h({contents:i.getOverrideValue(void 0,T)||{},keys:i.getKeysForOverrideIdentifier(T)},{contents:r.getOverrideValue(void 0,T)||{},keys:r.getKeysForOverrideIdentifier(T)});f.push([T,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:s,updated:a,overrides:f}}function h(i,r){const n=i?r?i.keys.filter(f=>r.keys.indexOf(f)===-1):[...i.keys]:[],s=r?i?r.keys.filter(f=>i.keys.indexOf(f)===-1):[...r.keys]:[],a=[];if(i&&r){for(const f of r.keys)if(i.keys.indexOf(f)!==-1){const o=(0,k.getConfigurationValue)(r.contents,f),c=(0,k.getConfigurationValue)(i.contents,f);C.equals(o,c)||a.push(f)}}return{added:n,removed:s,updated:a}}}),define(we[214],ye([1,0,18,7,2,23,13,24,108,51,12,63,34]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class w extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:u})=>this.onDidUpdateConfiguration(p,u))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(p,u){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=w;class d extends E.ConfigurationModel{constructor(p={}){const u=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(u),h=Object.create(null),i=[];for(const r in u){const n=p[r],s=n!==void 0?n:u[r].default;(0,C.addToValueTree)(h,r,s,a=>console.error(`Conflict in default settings: ${a}`))}for(const r of Object.keys(h))b.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(h[r]),contents:(0,C.toValuesTree)(h[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(h,l,i)}}e.DefaultConfigurationModel=d;class g{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let v=class extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(p,u,l){super(),this.defaultConfiguration=p,this.policyService=u,this.logService=l,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.registerPolicyDefinitions(p),!0))),this._configurationModel}async registerPolicyDefinitions(p){const u={},l=[],h=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const i of p){const r=h[i];if(!r){l.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}l.push(i),u[r.policy.name]={type:r.type}}}return(0,P.isEmptyObject)(u)||await this.policyService.registerPolicyDefinitions(u),l}onDidChangePolicies(p){const u=S.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),l=(0,y.coalesce)(p.map(h=>u.get(h)));this.update(l,!0)}update(p,u){const l=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),h=[],i=this._configurationModel.isEmpty();for(const r of p){const n=l[r]?.policy?.name;if(n){const s=this.policyService.getPolicyValue(n);(i?s!==void 0:!(0,I.equals)(this._configurationModel.getValue(r),s))&&h.push([r,s])}else this._configurationModel.getValue(r)!==void 0&&h.push([r,void 0])}if(h.length){const r=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const n of r.keys)this._configurationModel.setValue(n,r.getValue(n));for(const[n,s]of h)s===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,s);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};v=Ae([_e(1,R.IPolicyService),_e(2,k.ILogService)],v),e.PolicyConfiguration=v}),define(we[109],ye([1,0,14,7,2,19,24,108,214,63]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class k extends D.Disposable{constructor(S,w,d,g){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=d instanceof b.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,d,g)),this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,w)),this.configuration=new C.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new C.ConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:v,properties:m})=>this.onDidDefaultConfigurationChange(v,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(v=>this.onDidPolicyConfigurationChange(v))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,w,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new C.Configuration(S,w,new C.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(S,w){const d=typeof S=="string"?S:void 0,g=(0,P.isConfigurationOverrides)(S)?S:(0,P.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(d,g,void 0)}updateValue(S,w,d,g){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const w=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(d,w,2)}onDidDefaultConfigurationChange(S,w){const d=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(S,w);this.trigger(g,d,7)}onDidPolicyConfigurationChange(S){const w=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(d,w,7)}trigger(S,w,d){const g=new C.ConfigurationChangeEvent(S,{data:w},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=k}),define(we[110],ye([1,0,8,5]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends y.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof I&&C._code===D.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof I&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof I&&C._code===D.NoResolverFound}static isHandled(C){return C instanceof I&&C.isHandled}constructor(C,E=D.Unknown,b){super(C),this._message=C,this._code=E,this._detail=b,this.isHandled=E===D.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I}),define(we[78],ye([1,0,9]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(b){return b.scheme===y.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=t;function D(b){if(!b)return;const k=b.indexOf("+");return k<0?b:b.substr(0,k)}e.getRemoteName=D;function I(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=I;function P(b){const{host:k,port:R}=E(b);if(typeof R>"u")throw new Error("Remote authority doesn't contain a port!");return{host:k,port:R}}e.parseAuthorityWithPort=P;function C(b,k){let{host:R,port:S}=E(b);return typeof S>"u"&&(S=k),{host:R,port:S}}e.parseAuthorityWithOptionalPort=C;function E(b){const k=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const R=b.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const S=b.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:b,port:void 0}}}),define(we[35],ye([1,0,15,5,78]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=I;function P(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var E;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,v){if(typeof g>"u"||g===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof g=="string"||typeof v=="string"){const m=typeof g=="string"?g:g.value,p=typeof v=="string"?v:v.value;return y.equalsIgnoreCase(m,p)}return g._lower===v._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=b;function k(d){return R(d)}e.isApplicationScopedExtension=k;function R(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function S(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function w(d,g){if(g){const v=`onResolveRemoteAuthority:${(0,D.getRemoteName)(g)}`;return d.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[32],ye([1,0,15,30,35,3,4,8,26]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(r,n){return r.uuid&&n.uuid?r.uuid===n.uuid:r.id===n.id?!0:(0,y.compareIgnoreCase)(r.id,n.id)===0}e.areSameExtensions=b;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{static create(n){const s=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new R(n.identifier,s,a)}static parse(n){const s=k.exec(n);return s&&s[1]&&s[2]?new R({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof R?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=R;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(r){const n=S.exec(r);return n&&n[1]?[g(n[1]),n[2]]:[g(r),void 0]}e.getIdAndVersion=w;function d(r,n){return`${r}.${n}`}e.getExtensionId=d;function g(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function v(r,n){return g(d(r,n))}e.getGalleryExtensionId=v;function m(r,n){const s=[],a=f=>{for(const o of s)if(o.some(c=>b(n(c),n(f))))return o;return null};for(const f of r){const o=a(f);o?o.push(f):s.push([f])}return s}e.groupByExtension=m;function p(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function u(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function l(r,n){const s=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const f=a.shift();if(f&&s.every(o=>!b(o.identifier,{id:f}))){const o=r.filter(c=>b(c.identifier,{id:f}));o.length===1&&(s.push(o[0]),a.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=l;async function h(r,n){if(!I.isLinux)return!1;let s;try{s=(await r.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){n.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(f))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=h;async function i(r,n){const s=await h(r,n),a=(0,t.getTargetPlatform)(s?"alpine":I.platform,E.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=i}),define(we[111],ye([1,0,20,8,9,19,49,4,165,30,32,35]),function(oe,e,y,t,D,I,P,C,E,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const S=v=>(0,E.localize)(0,null,v),w=(0,E.localize)(1,null,"ms-dotnettools.csharp");function d(v,m){return m?`${v.publisher}.${v.name}@${v.version}`:`${v.publisher}.${v.name}`}let g=class{constructor(m,p){this.extensionManagementService=m,this.extensionGalleryService=p}get location(){}async listExtensions(m,p,u,l=console){let h=await this.extensionManagementService.getInstalled(1,u);const i=R.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(p&&p!==""){if(i.indexOf(p.toLowerCase())<0){l.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}h=h.filter(n=>n.manifest.categories?n.manifest.categories.map(a=>a.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){l.log("Possible Categories: "),i.forEach(n=>{l.log(n)});return}this.location&&l.log((0,E.localize)(2,null,this.location)),h=h.sort((n,s)=>n.identifier.id.localeCompare(s.identifier.id));let r;for(const n of h)r!==n.identifier.id&&(r=n.identifier.id,l.log(d(n.manifest,m)))}async installExtensions(m,p,u,l,h=console){const i=[],r=[];m.length&&h.log(this.location?(0,E.localize)(3,null,this.location):(0,E.localize)(4,null));const n=await this.extensionManagementService.getInstalled(1,u.profileLocation),s=(c,T)=>{const O=n.find(K=>(0,k.areSameExtensions)(K.identifier,{id:c}));if(O){if(!l&&(!T||T==="prerelease"&&O.preRelease))return h.log((0,E.localize)(5,null,c,O.manifest.version,c)),!1;if(T&&O.manifest.version===T)return h.log((0,E.localize)(6,null,`${c}@${T}`)),!1}return!0},a=(c,T,O)=>{o.push({id:c,version:T!=="prerelease"?T:void 0,installOptions:{...u,isBuiltin:O,installPreReleaseVersion:T==="prerelease"||u.installPreReleaseVersion}})},f=[],o=[];for(const c of m)if(c instanceof C.URI)f.push(c);else{const[T,O]=(0,k.getIdAndVersion)(c);s(T,O)&&a(T,O,!1)}for(const c of p){const[T,O]=(0,k.getIdAndVersion)(c);s(T,O)&&a(T,O,!0)}if(f.length&&await Promise.all(f.map(async c=>{try{const T=await this.installVSIX(c,{...u,isBuiltin:!1},l,h);T&&r.push(T)}catch(T){h.error(T.message||T.stack||T),i.push(c.toString())}})),o.length){const c=await this.getGalleryExtensions(o);await Promise.all(o.map(async T=>{const O=c.get(T.id.toLowerCase());if(O)try{const K=await this.installFromGallery(T,O,n,l,h);K&&r.push(K)}catch(K){h.error(K.message||K.stack||K),i.push(T.id)}else h.error(`${S(T.version?`${T.id}@${T.version}`:T.id)}
${w}`),i.push(T.id)}))}if(i.length)throw new Error((0,E.localize)(7,null,i.join(", ")))}async installVSIX(m,p,u,l){const h=await this.extensionManagementService.getManifest(m);if(!h)throw new Error("Invalid vsix");if(await this.validateVSIX(h,u,p.profileLocation,l))try{return await this.extensionManagementService.install(m,p),l.log((0,E.localize)(8,null,(0,I.basename)(m))),h}catch(r){if((0,t.isCancellationError)(r))return l.log((0,E.localize)(9,null,(0,I.basename)(m))),null;throw r}return null}async getGalleryExtensions(m){const p=new Map,u=m.some(h=>h.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(m.map(h=>({...h,preRelease:u})),y.CancellationToken.None);for(const h of l)p.set(h.identifier.id.toLowerCase(),h);return p}async installFromGallery({id:m,version:p,installOptions:u},l,h,i,r){const n=await this.extensionGalleryService.getManifest(l,y.CancellationToken.None);if(n&&!this.validateExtensionKind(n,r))return null;const s=h.find(a=>(0,k.areSameExtensions)(a.identifier,l.identifier));if(s){if(l.version===s.manifest.version)return r.log((0,E.localize)(10,null,p?`${m}@${p}`:m)),null;r.log((0,E.localize)(11,null,m,l.version))}try{u.isBuiltin?r.log(p?(0,E.localize)(12,null,m,p):(0,E.localize)(13,null,m)):r.log(p?(0,E.localize)(14,null,m,p):(0,E.localize)(15,null,m));const a=await this.extensionManagementService.installFromGallery(l,{...u,installGivenVersion:!!p});return r.log((0,E.localize)(16,null,m,a.manifest.version)),n}catch(a){if((0,t.isCancellationError)(a))return r.log((0,E.localize)(17,null,m)),null;throw a}}validateExtensionKind(m,p){return!0}async validateVSIX(m,p,u,l){const h={id:(0,k.getGalleryExtensionId)(m.publisher,m.name)},r=(await this.extensionManagementService.getInstalled(1,u)).find(n=>(0,k.areSameExtensions)(h,n.identifier)&&(0,P.gt)(n.manifest.version,m.version));return r&&!p?(l.log((0,E.localize)(18,null,r.identifier.id,r.manifest.version,m.version)),!1):this.validateExtensionKind(m,l)}async uninstallExtensions(m,p,u,l=console){const h=async r=>{if(r instanceof C.URI){const n=await this.extensionManagementService.getManifest(r);return d(n)}return r},i=[];for(const r of m){const n=await h(r),a=(await this.extensionManagementService.getInstalled(void 0,u)).filter(f=>(0,k.areSameExtensions)(f.identifier,{id:n}));if(!a.length)throw new Error(`${this.notInstalled(n)}
${w}`);if(a.some(f=>f.type===0)){l.log((0,E.localize)(19,null,n));return}if(!p&&a.some(f=>f.isBuiltin)){l.log((0,E.localize)(20,null,n));return}l.log((0,E.localize)(21,null,n));for(const f of a)await this.extensionManagementService.uninstall(f,{profileLocation:u}),i.push(f);this.location?l.log((0,E.localize)(22,null,n,this.location)):l.log((0,E.localize)(23,null,n))}}async locateExtension(m,p=console){const u=await this.extensionManagementService.getInstalled();m.forEach(l=>{u.forEach(h=>{if(h.identifier.id===l&&h.location.scheme===D.Schemas.file){p.log(h.location.fsPath);return}})})}notInstalled(m){return this.location?(0,E.localize)(24,null,m,this.location):(0,E.localize)(25,null,m)}};g=Ae([_e(0,b.IExtensionManagementService),_e(1,b.IExtensionGalleryService)],g),e.ExtensionManagementCLI=g}),define(we[52],ye([1,0,14,16,2,31,4,32,17,5,12]),function(oe,e,y,t,D,I,P,C,E,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let R=class extends D.Disposable{constructor(w,d){super(),this.fileService=w,this.logService=d,this.resourcesAccessQueueMap=new I.ResourceMap}scanProfileExtensions(w){return this.withProfileExtensions(w)}addExtensionsToProfile(w,d){return this.withProfileExtensions(d,g=>(g=g.filter(v=>w.some(([m])=>!(0,C.areSameExtensions)(v.identifier,m.identifier))),g.push(...w.map(([v,m])=>({identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:m}))),g))}removeExtensionFromProfile(w,d){return this.withProfileExtensions(d,g=>g.filter(v=>!(0,C.areSameExtensions)(v.identifier,w)))}async withProfileExtensions(w,d){return this.getResourceAccessQueue(w).queue(async()=>{let g=[];try{const v=await this.fileService.readFile(w),m=JSON.parse(v.value.toString());for(const p of m){if(!p.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",p);continue}if(!p.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",p);continue}if(!p.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",p);continue}g.push({identifier:p.identifier,location:P.URI.revive(p.location),version:p.version,metadata:p.metadata})}}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}if(d){g=d(g);const v=g.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(w,t.VSBuffer.fromString(JSON.stringify(v)))}return g})}getResourceAccessQueue(w){let d=this.resourcesAccessQueueMap.get(w);return d||(d=new y.Queue,this.resourcesAccessQueueMap.set(w,d)),d}};R=Ae([_e(0,E.IFileService),_e(1,k.ILogService)],R),e.ExtensionsProfileScannerService=R}),define(we[215],ye([1,0,14,8,2,9,3,19,49,22,21,24,28,30,32,75,17,12]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class Sn extends D.Disposable{constructor(l,h,i,r,n,s){super(),this.fileService=h,this.extensionGalleryService=i,this.configurationService=r,this.extensionSignatureVerificationService=n,this.logService=s,this.extensionsDownloadDir=l.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(l,h){await this.cleanUpPromise;const i=(0,C.joinPath)(this.extensionsDownloadDir,this.getName(l));try{await this.downloadFile(l,i,n=>this.extensionGalleryService.download(l,n,h))}catch(n){throw new w.ExtensionManagementError(n.message,w.ExtensionManagementErrorCode.Download)}let r=!1;if(l.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const n=await this.downloadSignatureArchive(l);try{r=await this.extensionSignatureVerificationService.verify(i.fsPath,n.fsPath),this.logService.info(`Verified extension: ${l.identifier.id}`,r)}catch(s){throw await this.delete(n),await this.delete(i),new w.ExtensionManagementError(s.code,w.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:r}}async downloadSignatureArchive(l){await this.cleanUpPromise;const h=(0,C.joinPath)(this.extensionsDownloadDir,`${this.getName(l)}${Sn.SignatureArchiveExtension}`);return await this.downloadFile(l,h,i=>this.extensionGalleryService.downloadSignatureArchive(l,i)),h}async downloadFile(l,h,i){if(await this.fileService.exists(h))return;if(h.scheme!==I.Schemas.file){await i(h);return}const r=(0,C.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(r)||await i(r);try{await this.rename(r,h,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",l.identifier.id,h.path);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(n)}. Deleted the file from downloaded location`,r.path),n}}async delete(l){await this.cleanUpPromise,await this.fileService.del(l)}async rename(l,h,i){try{await k.Promises.rename(l.fsPath,h.fsPath)}catch(r){if(P.isWindows&&r&&r.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${l} to ${h} with 'EPERM' error. Trying again...`),this.rename(l,h,i);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const l=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(l.children){const h=[],i=[],r=[];for(const a of l.children)if(a.name.endsWith(Sn.SignatureArchiveExtension))r.push(a.resource);else{const f=d.ExtensionKey.parse(a.name);f&&i.push([f,a])}const n=(0,d.groupByExtension)(i,([a])=>a),s=[];for(const a of n)a.sort((f,o)=>E.rcompare(f[0].version,o[0].version)),h.push(...a.slice(1).map(f=>f[1].resource)),s.push(a[0][1]);s.sort((a,f)=>a.mtime-f.mtime),h.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(a=>a.resource)),h.push(...r),await y.Promises.settled(h.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(l){this.logService.error(l)}}getName(l){return this.cache?d.ExtensionKey.create(l).toString().toLowerCase():(0,b.generateUuid)()}};p.SignatureArchiveExtension=".sigzip",p=Ae([_e(0,S.INativeEnvironmentService),_e(1,v.IFileService),_e(2,w.IExtensionGalleryService),_e(3,R.IConfigurationService),_e(4,g.IExtensionSignatureVerificationService),_e(5,m.ILogService)],p),e.ExtensionsDownloader=p}),define(we[216],ye([1,0,2,6,21,35]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class P extends y.Disposable{constructor(E,b){super(),this.environmentService=E,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(k=>this.onDidInstallExtensions(k))),this._register(b.onDidUninstallExtension(k=>this.onDidUnInstallExtension(k)))}onDidInstallExtensions(E){E.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=P}),define(we[112],ye([1,0,113,18,14,2,9,6,21,28,30,32,12,77,3,4]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let v=class extends w.LanguagePackBaseService{constructor(l,h,i,r){super(i),this.extensionManagementService=l,this.logService=r,this.cache=this._register(new m(h,r)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(l){const i=(await this.cache.getLanguagePacks())[d.Language.value()];if(!i){this.logService.warn(`No language pack found for ${d.Language.value()}`);return}const r=i.translations[l];return r?g.URI.file(r):void 0}async getInstalledLanguages(){const l=await this.cache.getLanguagePacks(),h=Object.keys(l).map(i=>{const r=l[i];return{...this.createQuickPickItem(i,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return h.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),h.sort((i,r)=>i.label.localeCompare(r.label)),h}async postInstallExtension(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",l.identifier.id),await this.update())}async postUninstallExtension(l){const h=await this.cache.getLanguagePacks();Object.keys(h).some(i=>h[i]&&h[i].extensions.some(r=>(0,R.areSameExtensions)(r.extensionIdentifier,l.identifier)))&&(this.logService.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(h);return!(0,t.equals)(Object.keys(l),Object.keys(i))}};v=Ae([_e(0,k.IExtensionManagementService),_e(1,b.INativeEnvironmentService),_e(2,k.IExtensionGalleryService),_e(3,S.ILogService)],v),e.NativeLanguagePackService=v;let m=class extends I.Disposable{constructor(l,h){super(),this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(l.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(l){return this.withLanguagePacks(h=>{Object.keys(h).forEach(i=>delete h[i]),this.createLanguagePacksFromExtensions(h,...l)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(l,...h){for(const i of h)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(l,i);Object.keys(l).forEach(i=>this.updateHash(l[i]))}createLanguagePacksFromExtension(l,h){const i=h.identifier,r=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const n of r)if(h.location.scheme===P.Schemas.file&&p(n)){let s=l[n.languageId];s||(s={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},l[n.languageId]=s);const a=s.extensions.filter(f=>(0,R.areSameExtensions)(f.extensionIdentifier,i))[0];a?a.version=h.manifest.version:s.extensions.push({extensionIdentifier:i,version:h.manifest.version});for(const f of n.translations)s.translations[f.id]=(0,C.join)(h.location.fsPath,f.path)}}updateHash(l){if(l){const h=(0,y.createHash)("md5");for(const i of l.extensions)h.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);l.hash=h.digest("hex")}}withLanguagePacks(l=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(h=l(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),E.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>h,i=>this.logService.error(i))})}};m=Ae([_e(0,b.INativeEnvironmentService),_e(1,S.ILogService)],m);function p(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const l of u.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(we[53],ye([1,0,16,177,51,5,34]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");function C(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=C;function E(g){return g.res.statusCode===204}async function b(g){return E(g)?null:(await(0,y.streamToBuffer)(g.stream)).toString()}e.asText=b;async function k(g){if(!C(g))throw new Error("Server returned "+g.res.statusCode);return b(g)}e.asTextOrError=k;async function R(g){if(!C(g))throw new Error("Server returned "+g.res.statusCode);if(E(g))return null;const m=(await(0,y.streamToBuffer)(g.stream)).toString();try{return JSON.parse(m)}catch(p){throw p.message+=`:
`+m,p}}e.asJson=R;function S(g){d(g)}e.updateProxyConfigurationsScope=S;let w;function d(g){const v=P.Registry.as(D.Extensions.Configuration),m=w;w={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[w],remove:m?[m]:[]})}d(2)}),define(we[217],ye([1,0,20,9,17,53]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let P=class{constructor(E,b){this.requestService=E,this.fileService=b}async download(E,b,k=y.CancellationToken.None){if(E.scheme===t.Schemas.file||E.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(E,b);return}const R={type:"GET",url:E.toString(!0)},S=await this.requestService.request(R,k);if(S.res.statusCode===200)await this.fileService.writeFile(b,S.stream);else{const w=await(0,I.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${w}`)}}};P=Ae([_e(0,I.IRequestService),_e(1,D.IFileService)],P),e.DownloadService=P}),define(we[218],ye([1,0,16,20]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(C){this.service=C}listen(C,E){throw new Error("Invalid listen")}call(C,E,b,k=t.CancellationToken.None){switch(E){case"request":return this.service.request(b[0],k).then(async({res:R,stream:S})=>{const w=await(0,y.streamToBuffer)(S);return[{statusCode:R.statusCode,headers:R.headers},w]});case"resolveProxy":return this.service.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class I{constructor(C){this.channel=C}async request(C,E){const[b,k]=await this.channel.call("request",[C],E);return{res:b,stream:(0,y.bufferToStream)(k)}}async resolveProxy(C){return this.channel.call("resolveProxy",[C])}}e.RequestChannelClient=I}),define(we[219],ye([1,0,79,13]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(P,C){return P.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:P.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function I(P,C,E={}){const b=(0,y.parse)(P),k=E.proxyUrl||D(b,C);if(!k)return null;const R=(0,y.parse)(k);if(!/^https?:$/.test(R.protocol||""))return null;const S={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(E.strictSSL)?E.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((w,d)=>{oe(["http-proxy-agent"],w,d)}))(S):new(await new Promise((w,d)=>{oe(["https-proxy-agent"],w,d)}))(S)}e.getProxyAgent=I}),define(we[80],ye([1,0,47,6,178,20,38,8,3,22,150,191,14]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const w=1e4;let d;async function g(m,p,u){return p["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(u)&&!p["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(u)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=S.Promises.withAsyncBody(async(l,h)=>{const i=new I.CancellationTokenSource,r=setTimeout(()=>{i.dispose(!0),h(new Error((0,D.localize)(0,null)))},w);try{l(await v(m,i.token))}catch(n){!(0,C.isCancellationError)(n)&&!i.token.isCancellationRequested?h(new Error((0,D.localize)(1,null,(0,P.toErrorMessage)(n)))):l({})}finally{clearTimeout(r),i.dispose()}})),d)}e.getResolvedShellEnv=g;async function v(m,p){const u=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",u);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",l);const h=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(h+"(.*)"+h),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const n=await(0,k.getSystemShell)(E.OS,r);return m.trace("getUnixShellEnvironment#shell",n),new Promise((s,a)=>{if(p.isCancellationRequested)return a((0,C.canceled)());const f=(0,t.basename)(n);let o,c;const T=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(f)?(o=`& '${process.execPath}' ${T} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,c=["-Login","-Command"]):(o=`'${process.execPath}' ${T} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,f==="tcsh"?c=["-ic"]:c=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),o);const O=(0,y.spawn)(n,[...c,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(O.kill(),a((0,C.canceled)()))),O.on("error",le=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(le)),a(le)});const K=[];O.stdout.on("data",le=>K.push(le));const re=[];O.stderr.on("data",le=>re.push(le)),O.on("close",(le,ae)=>{const F=Buffer.concat(K).toString("utf8");m.trace("getUnixShellEnvironment#raw",F);const Y=Buffer.concat(re).toString("utf8");if(Y.trim()&&m.trace("getUnixShellEnvironment#stderr",Y),le||ae)return a(new Error((0,D.localize)(2,null,le,ae)));const B=i.exec(F),H=B?B[1]:"{}";try{const $=JSON.parse(H);u?$.ELECTRON_RUN_AS_NODE=u:delete $.ELECTRON_RUN_AS_NODE,l?$.ELECTRON_NO_ATTACH_CONSOLE=l:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",$),s($)}catch($){m.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)($)),a($)}})})}}),define(we[114],ye([1,0,3,26,4,22]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(b){if(y.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function C(b,k,R,S,w,d,g,v,m,p){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=(0,I.generateUuid)()+Date.now(),u.commitHash=w,u.version=d,u["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,y.PlatformToString)(y.platform),u["common.nodePlatform"]=t.platform,u["common.nodeArch"]=S,u["common.product"]=p||"desktop",v&&(u["common.msftInternal"]=v);let l=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),y.isLinuxSnap&&(u["common.snap"]="true");const i=P(R);i&&(u["common.platformDetail"]=i);try{const r=await b.readFile(D.URI.file(m));u["common.source"]=r.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=C;function E(b){const k=t.env.USERDNSDOMAIN;if(!k)return!1;const R=k.toLowerCase();return b.some(S=>R===S)}e.verifyMicrosoftInternalDomain=E}),define(we[220],ye([1,0,18,8,2,23,17]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var C;(function(b){function k(R,S){return R.callstack<S.callstack?-1:R.callstack>S.callstack?1:0}b.compare=k})(C=e.ErrorEvent||(e.ErrorEvent={}));class E{constructor(k,R=E.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new D.DisposableStore,this._telemetryService=k,this._flushDelay=R;const S=t.errorHandler.addListener(w=>this._onErrorEvent(w));this._disposables.add((0,D.toDisposable)(S)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(k){if(!k||(k.detail&&k.detail.stack&&(k=k.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(k)||k instanceof P.FileOperationError))return;const R=Array.isArray(k.stack)?k.stack.join(`
`):k.stack,S=k.message?k.message:(0,I.safeStringify)(k);!R||this._enqueue({msg:S,callstack:R})}_enqueue(k){const R=(0,y.binarySearch)(this._buffer,k,C.compare);R<0?(k.count=1,this._buffer.splice(~R,0,k)):(this._buffer[R].count||(this._buffer[R].count=0),this._buffer[R].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(const k of this._buffer)this._telemetryService.publicLogError2("UnhandledError",k);this._buffer.length=0}}e.default=E,E.ERROR_FLUSH_TIMEOUT=5*1e3}),define(we[221],ye([1,0,2]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends y.Disposable{constructor(I,P){super(),this.telemetryService=I,this.telemetryAppender=P}async call(I,P,C){switch(P){case"updateTelemetryLevel":{const{telemetryLevel:E}=C;return this.telemetryService.updateInjectedTelemetryLevel(E)}case"logTelemetry":{const{eventName:E,data:b}=C;return this.telemetryAppender?this.telemetryAppender.log(E,b):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${P} not found`)}listen(I,P,C){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(we[33],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(we[222],ye([1,0,27,14,67,9,6,3,4,93,21,97,198,17,25,33]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function m(i,r){const n=`${i}::${r.join(":")}`,s=v.get(n);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],f=new Map,o=new Map,c=2e4;function T(K,re,le,ae){const F=re.substring(K.length+1);return t.Promises.withAsyncBody(async Y=>{let B;try{B=await k.Promises.readdir(re,{withFileTypes:!0})}catch{Y();return}if(ae.count>=c){ae.count+=B.length,ae.maxReached=!0,Y();return}let H=B.length;if(H===0){Y();return}let $=B;ae.count+B.length>c&&(ae.maxReached=!0,H=c-ae.count,$=B.slice(0,H)),ae.count+=B.length;for(const j of $)if(j.isDirectory()){if(le.includes(j.name)||await T(K,(0,P.join)(re,j.name),le,ae),--H===0){Y();return}}else{const L=j.name.lastIndexOf(".");if(L>=0){const N=j.name.substring(L+1);N&&f.set(N,(f.get(N)??0)+1)}for(const N of a)N.relativePathPattern?.test(F)!==!1&&N.filePattern.test(j.name)&&o.set(N.tag,(o.get(N.tag)??0)+1);if(--H===0){Y();return}}})}const O=t.Promises.withAsyncBody(async K=>{const re={count:0,maxReached:!1};await T(i,i,r,re);const le=await l(i);K({configFiles:p(o),fileTypes:p(f),fileCount:re.count,maxFilesReached:re.maxReached,launchConfigFiles:le})});return v.set(n,O),O}e.collectWorkspaceStats=m;function p(i){return Array.from(i.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function u(){const i={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},r=y.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=u;async function l(i){try{const r=new Map,n=(0,P.join)(i,".vscode","launch.json"),s=await k.Promises.readFile(n),a=[],f=(0,D.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,D.getNodeType)(f)==="object"&&f.configurations)for(const o of f.configurations){const c=o.type;c&&(r.has(c)?r.set(c,r.get(c)+1):r.set(c,1))}return p(r)}catch{return[]}}e.collectLaunchConfigs=l;let h=class{constructor(r,n){this.telemetryService=r,this.productService=n}formatMachineInfo(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}formatEnvironment(r){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const s=y.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(y.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||n.push(`Load (avg):       ${y.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,R.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async s=>{let[a,f]=s,o=this.formatProcessList(r,a);return n.forEach(c=>{if((0,S.isRemoteDiagnosticError)(c))o+=`
${c.errorMessage}`,f+=`
${c.errorMessage}`;else if(o+=`

Remote: ${c.hostName}`,c.processes&&(o+=`
${this.formatProcessList(r,c.processes)}`),c.workspaceMetadata){f+=`
|  Remote: ${c.hostName}`;for(const T of Object.keys(c.workspaceMetadata)){const O=c.workspaceMetadata[T];let K=`${O.fileCount} files`;O.maxFilesReached&&(K=`more than ${K}`),f+=`|    Folder (${T}): ${K}`,f+=this.formatWorkspaceStats(O)}}}),{processInfo:o,workspaceInfo:f}})}async getSystemInfo(r,n){const{memory:s,vmHint:a,os:f,cpus:o}=u(),c={os:f,memory:s,cpus:o,vmHint:a,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return C.isWindows||(c.load=`${y.loadavg().map(T=>Math.round(T)).join(", ")}`),C.isLinux&&(c.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(c)}async getDiagnostics(r,n){const s=[];return(0,R.listProcesses)(r.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(r)),s.push(""),s.push(this.formatProcessList(r,a)),r.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(r))),n.forEach(f=>{if((0,S.isRemoteDiagnosticError)(f))s.push(`
${f.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${f.hostName}`),s.push(this.formatMachineInfo(f.machineInfo)),f.processes&&s.push(this.formatProcessList(r,f.processes)),f.workspaceMetadata)for(const o of Object.keys(f.workspaceMetadata)){const c=f.workspaceMetadata[o];let T=`${c.fileCount} files`;c.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${o}): ${T}`),s.push(this.formatWorkspaceStats(c))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(r){const n=[];let a=0;const f=(O,K)=>{const re=` ${O}(${K})`;a+re.length>60?(n.push(o),o="|                 ",a=o.length):a+=re.length,o+=re};let o="|      File types:";const c=10,T=r.fileTypes.length>c?c:r.fileTypes.length;for(let O=0;O<T;O++){const K=r.fileTypes[O];f(K.name,K.count)}if(n.push(o),r.configFiles.length>=0&&(o="|      Conf files:",a=0,r.configFiles.forEach(O=>{f(O.name,O.count)}),n.push(o)),r.launchConfigFiles.length>0){let O="|      Launch Configs:";r.launchConfigFiles.forEach(K=>{O+=K.count>1?` ${K.name}(${K.count})`:` ${K.name}`}),n.push(O)}return n.join(`
`)}expandGPUFeatures(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}formatWorkspaceMetadata(r){const n=[],s=[];return r.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(f=>{const o=E.URI.revive(f);if(o.scheme===I.Schemas.file){const c=o.fsPath;s.push(m(c,["node_modules",".git"]).then(T=>{let O=`${T.fileCount} files`;T.maxFilesReached&&(O=`more than ${O}`),n.push(`|    Folder (${(0,P.basename)(c)}): ${O}`),n.push(this.formatWorkspaceStats(T))}).catch(T=>{n.push(`|      Error: Unable to collect workspace stats for folder ${c} (${T.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(r,n){const s=new Map;r.windows.forEach(f=>s.set(f.pid,f.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(r.mainPID,s,a,n,0),a.join(`
`)}formatProcessItem(r,n,s,a,f){const o=f===0;let c;o?c=a.pid===r?`${this.productService.applicationName} main`:"remote agent":(c=`${"  ".repeat(f)} ${a.name}`,a.name==="window"&&(c=`${c} (${n.get(a.pid)})`));const T=process.platform==="win32"?a.mem:y.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(T/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${c}`),Array.isArray(a.children)&&a.children.forEach(O=>this.formatProcessItem(r,n,s,O,f+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const a=E.URI.revive(s);if(a.scheme!==I.Schemas.file)continue;const f=a.fsPath;try{(await m(f,["node_modules",".git"])).fileTypes.forEach(c=>n.add(c.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=E.URI.revive(n);if(s.scheme!==I.Schemas.file)continue;const a=s.fsPath;try{const f=await m(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),f.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),f.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),f.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};h=Ae([_e(0,g.ITelemetryService),_e(1,d.IProductService)],h),e.DiagnosticsService=h}),define(we[43],ye([1,0,23,89,13,24,114,33]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(s,a){return Promise.resolve(void 0)}publicLog2(s,a){return this.publicLog(s,a)}publicLogError(s,a){return Promise.resolve(void 0)}publicLogError2(s,a){return this.publicLogError(s,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class b{async publicLog(s,a,f){}async publicLogError(s,a,f){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function k(n,s){return s.onDidChangeConfiguration(a=>{a.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(a.source),configurationKeys:m(a.sourceConfig)})})}e.configurationTelemetry=k;function R(n,s){return!(s.disableTelemetry||!n.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=R;function S(n){const s=n.getValue(C.TELEMETRY_SETTING_ID),a=n.getValue("telemetry.enableCrashReporter");if(n.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function w(n){const s={},a={},f={};v(n,f);for(let o in f){o=o.length>150?o.substr(o.length-149):o;const c=f[o];typeof c=="number"?a[o]=c:typeof c=="boolean"?a[o]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${c.length}`),s[o]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(s[o]=c)}return{properties:s,measurements:a}}e.validateTelemetryData=w;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function g(n){if(!n)return"none";for(const s of d)if(n.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=g;function v(n,s,a=0,f){if(!!n)for(const o of Object.getOwnPropertyNames(n)){const c=n[o],T=f?f+o:o;Array.isArray(c)?s[T]=(0,y.safeStringify)(c):c instanceof Date?s[T]=c.toISOString():(0,D.isObject)(c)?a<2?v(c,s,a+1,T+"."):s[T]=(0,y.safeStringify)(c):s[T]=c}}function m(n){if(!n)return[];const s=[];return p(s,"",n),s}function p(n,s,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(f=>p(n,s?`${s}.${f}`:f,a[f])):n.push(s)}function u(n,s){const a=n.msftInternalDomains||[],f=s.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(a)||f}e.isInternalTelemetry=u;function l(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=l;function h(n,s){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let a=n;const f=[];for(const O of s)for(;;){const K=O.exec(n);if(!K)break;f.push([K.index,O.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let T=0;for(a="";;){const O=c.exec(n);if(!O)break;const K=f.some(([re,le])=>O.index<le&&re<c.lastIndex);!o.test(O[0])&&!K&&(a+=n.substring(T,O.index)+"<REDACTED: user-file-path>",T=c.lastIndex)}return T<n.length&&(a+=n.substr(T)),a}function i(n){if(!n)return n;const s=n.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of a)if(f.regex.test(s))return`<REDACTED: ${f.label}>`;return n}function r(n,s){return(0,y.cloneAndChange)(n,a=>{if(typeof a=="string"){let f=a;f=h(f,s);for(const o of s)f=f.replace(o,"");return f=i(f),f}})}e.cleanData=r}),define(we[223],ye([1,0,195,43]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(I,P,C,E,b,k,R){const S={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${P.nameShort})`};if((0,t.supportsTelemetry)(P,C)&&(0,t.getTelemetryLevel)(E)===3){const w=await(0,y.getServiceMachineId)(C,b,k),{sessionId:d}=await R.getTelemetryInfo();S["X-Market-User-Id"]=w,S["VSCode-SessionId"]=d}return S}e.resolveMarketplaceHeaders=D}),define(we[224],ye([1,0,8,23,43]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function P(E,b,k){const R=await new Promise((v,m)=>{oe(["@microsoft/1ds-core-js"],v,m)}),S=await new Promise((v,m)=>{oe(["@microsoft/1ds-post-js"],v,m)}),w=new R.AppInsightsCore,d=new S.PostChannel,g={instrumentationKey:E,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(k){g.extensionConfig={};const v={alwaysUseXhrOverride:!0,httpXHROverride:k};g.extensionConfig[d.identifier]=v}return w.initialize(g,[]),w.addTelemetryInitializer(v=>{b&&(v.ext=v.ext??{},v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),w}class C{constructor(b,k,R,S,w){this._isInternalTelemetry=b,this._eventPrefix=k,this._defaultData=R,this._xhrOverride=w,this.endPointUrl=I,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(b){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=P(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(k=>{b(k)},k=>{(0,y.onUnexpectedError)(k),console.error(k)})}}log(b,k){if(!this._aiCoreOrKey)return;k=(0,t.mixin)(k,this._defaultData),k=(0,D.validateTelemetryData)(k);const R=this._eventPrefix+"/"+b;try{this._withAIClient(S=>{S.pluginVersionString=k?.properties.version??"Unknown",S.track({name:R,baseData:{name:R,properties:k?.properties,measurements:k?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(k=>{k.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=C}),define(we[225],ye([1,0,2,23,89,3,15,179,24,51,50,25,34,33,43]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(p,u,l){this._configurationService=u,this._productService=l,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(h),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(p,u){this._experimentProperties[p]=u}_updateTelemetryLevel(){let p=(0,d.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const l=u.usage?3:u.error?2:0;p=Math.min(p,l)}this.telemetryLevel.value=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const p=await this._commonProperties,u=p.sessionID,l=p["common.machineId"],h=p["common.firstSessionDate"],i=p["common.msftInternal"];return{sessionId:u,machineId:l,firstSessionDate:h,msftInternal:i}}dispose(){this._disposables.dispose()}_log(p,u,l,h){return this.telemetryLevel.value<u?Promise.resolve(void 0):this._commonProperties.then(i=>{l=(0,t.mixin)(l,this._experimentProperties),l=(0,d.cleanData)(l,this._cleanupPatterns),l=(0,t.mixin)(l,i),this._appenders.forEach(r=>r.log(p,l))},i=>{console.error(i)})}publicLog(p,u,l){return this._log(p,3,u,l)}publicLog2(p,u,l){return this.publicLog(p,u,l)}publicLogError(p,u){return this._sendErrorTelemetry?this._log(p,2,u,!0):Promise.resolve(void 0)}publicLogError2(p,u){return this.publicLogError(p,u)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=Ae([_e(1,E.IConfigurationService),_e(2,R.IProductService)],g),e.TelemetryService=g;function v(){const m=(0,C.localize)(0,null,k.default.nameLong),p=k.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",k.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=I.isWeb?"":(0,C.localize)(3,null),l=(0,C.localize)(4,null),h=(0,C.localize)(5,null),i=(0,C.localize)(6,null),r=(0,C.localize)(7,null),n=`
|       | ${l} | ${h} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,C.localize)(8,null);return`
${m} ${p} ${u}

&nbsp;

${r}
${n}

&nbsp;

${s}
`}S.Registry.as(b.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(b.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:k.default.privacyStatementUrl?(0,C.localize)(16,null,k.default.nameLong,k.default.privacyStatementUrl):(0,C.localize)(15,null,k.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[226],ye([1,0,24,5,25,33,225,43]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let E=class extends P.TelemetryService{constructor(k,R,S,w){super(k,S,w),this._injectedTelemetryLevel=R}publicLog(k,R,S){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(k,R,S)}publicLog2(k,R,S){return this.publicLog(k,R,S)}publicLogError(k,R){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(k,R)}publicLogError2(k,R){return this.publicLogError(k,R)}async updateInjectedTelemetryLevel(k){if(k===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,k):k,this._injectedTelemetryLevel===0&&this.dispose()}};E=Ae([_e(2,y.IConfigurationService),_e(3,D.IProductService)],E),e.ServerTelemetryService=E,e.ServerNullTelemetryService=new class extends C.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(I.ITelemetryService)}),define(we[227],ye([1,0,228,224]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends t.AbstractOneDataSystemAppender{constructor(P,C,E,b){const k={sendPOST:(R,S)=>{const w={method:"POST",headers:{...R.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(R.data)}};try{const d=y.request(R.urlString,w,g=>{g.on("data",function(v){S(g.statusCode??200,g.headers,v.toString())}),g.on("error",function(v){S(0,{})})});d.write(R.data),d.end()}catch{S(0,{})}}};super(P,C,E,b,k)}}e.OneDataSystemAppender=D}),define(we[229],ye([1,0,8,220]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class D extends t.default{installErrorListeners(){(0,y.setUnexpectedErrorHandler)(C=>console.error(C));const P=[];process.on("unhandledRejection",(C,E)=>{P.push(E),setTimeout(()=>{const b=P.indexOf(E);b>=0&&E.catch(k=>{P.splice(b,1),(0,y.isCancellationError)(k)||(console.warn(`rejected promise not handled within 1 second: ${k}`),k.stack&&console.warn(`stack trace: ${k.stack}`),C&&(0,y.onUnexpectedError)(C))})},1e3)}),process.on("rejectionHandled",C=>{const E=P.indexOf(C);E>=0&&P.splice(E,1)}),process.on("uncaughtException",C=>{(0,y.onUnexpectedError)(C)})}}e.default=D}),define(we[230],ye([1,0,14,20,7,2,12]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends I.Disposable{constructor(b,k){super(),this._logService=k,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((k,R)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,k),this._onCreateRequest.fire({requestId:S,...b});const w=new t.CancellationTokenSource;(0,y.timeout)(this._timeout,w.token).then(()=>R(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,I.toDisposable)(()=>w.cancel())])})}acceptReply(b,k){const R=this._pendingRequests.get(b);R?(this._pendingRequests.delete(b),(0,I.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),R(k)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};C=Ae([_e(1,P.ILogService)],C),e.RequestStore=C}),define(we[115],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var I;(function(u){u.FileName="ptyhost"})(I=e.TerminalLogConstants||(e.TerminalLogConstants={}));var P;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(P=e.PosixShellType||(e.PosixShellType={}));var C;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(C=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,y.createDecorator)("ptyService");var k;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(k=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(S=e.TerminalLocation||(e.TerminalLocation={}));var w;(function(u){u.TerminalView="view",u.Editor="editor"})(w=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}));var m;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(m=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var p;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(p=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(we[231],ye([1,0,3]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function t(P){let C=P;C.indexOf("\\")!==0&&(C=C.replace(/\\/g,"\\\\"));const E=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return C=C.replace(E,""),`'${C}'`}e.escapeNonWindowsPath=t;function D(P,C,E){if(!P)return"";if(!C)return P;C.match(/[\/\\]$/)&&(C=C.slice(0,C.length-1));const b=P.replace(/\\/g,"/").toLowerCase(),k=C.replace(/\\/g,"/").toLowerCase();return b.includes(k)?`~${E}${P.slice(C.length+1)}`:P}e.collapseTildePath=D;function I(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),y.OS===1&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}e.sanitizeCwd=I}),define(we[232],ye([1,0,27,9,23,6,3,26,15,13,21]),function(oe,e,y,t,D,I,P,C,E,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function R(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let h=0;return l&&l.length===4&&(h=parseInt(l[3])),h}e.getWindowsBuildNumber=R;async function S(l,h,i,r=C.env,n=k.Promises.exists){if(I.isAbsolute(l))return await n(l)?l:void 0;if(h===void 0&&(h=C.cwd()),I.dirname(l)!=="."){const o=I.join(h,l);return await n(o)?o:void 0}const a=(0,D.getCaseInsensitive)(r,"PATH");if(i===void 0&&(0,b.isString)(a)&&(i=a.split(I.delimiter)),i===void 0||i.length===0){const o=I.join(h,l);return await n(o)?o:void 0}for(const o of i){let c;if(I.isAbsolute(o)?c=I.join(o,l):c=I.join(h,o,l),await n(c))return c;if(P.isWindows){let T=c+".com";if(await n(T)||(T=c+".exe",await n(T)))return T}}const f=I.join(h,l);return await n(f)?f:void 0}e.findExecutable=S;function w(l,h,i,r,n){if(!h.shellIntegration.enabled||!l.executable||l.isFeatureTerminal||l.hideFromUser||l.ignoreShellIntegration||P.isWindows&&!h.windowsEnableConpty)return;const s=l.args,a=C.platform==="win32"?I.basename(l.executable).toLowerCase():I.basename(l.executable),f=I.dirname(t.FileAccess.asFileUri("",oe).fsPath);let o;const c={VSCODE_INJECTION:"1"};if(P.isWindows){if(a==="pwsh.exe")return!s||p(s)?o=e.shellIntegrationArgs.get(d.WindowsPwsh):m(s)&&(o=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),o?(o=[...o],o[o.length-1]=(0,E.format)(o[o.length-1],f,""),{newArgs:o,envMixin:c}):void 0;r.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(a){case"bash":return!s||s.length===0?o=e.shellIntegrationArgs.get(d.Bash):u(s)&&(c.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(d.Bash)),o?(o=[...o],o[o.length-1]=(0,E.format)(o[o.length-1],f),{newArgs:o,envMixin:c}):void 0;case"pwsh":return!s||p(s)?o=e.shellIntegrationArgs.get(d.Pwsh):m(s)&&(o=e.shellIntegrationArgs.get(d.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,E.format)(o[o.length-1],f,""),{newArgs:o,envMixin:c}):void 0;case"zsh":{if(!s||s.length===0?o=e.shellIntegrationArgs.get(d.Zsh):u(s)?o=e.shellIntegrationArgs.get(d.ZshLogin):(s===e.shellIntegrationArgs.get(d.Zsh)||s===e.shellIntegrationArgs.get(d.ZshLogin))&&(o=s),!o)return;o=[...o],o[o.length-1]=(0,E.format)(o[o.length-1],f);const T=I.join(y.tmpdir(),`${y.userInfo().username}-${n.applicationName}-zsh`);c.ZDOTDIR=T;const O=i?.ZDOTDIR??y.homedir()??"~";c.USER_ZDOTDIR=O;const K=[];return K.push({source:I.join(f,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.join(T,".zshrc")}),K.push({source:I.join(f,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.join(T,".zprofile")}),K.push({source:I.join(f,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.join(T,".zshenv")}),K.push({source:I.join(f,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.join(T,".zlogin")}),{newArgs:o,envMixin:c,filesToCopy:K}}}r.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}e.getShellIntegrationInjection=w;var d;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],v=["-nol","-nologo"];function m(l){return typeof l=="string"?g.includes(l.toLowerCase()):l.length===1&&g.includes(l[0].toLowerCase())||l.length===2&&(g.includes(l[0].toLowerCase())||g.includes(l[1].toLowerCase()))&&(v.includes(l[0].toLowerCase())||v.includes(l[1].toLowerCase()))}function p(l){return typeof l=="string"?v.includes(l.toLowerCase()):l.length===0||l?.length===1&&v.includes(l[0].toLowerCase())}function u(l){return l==="string"&&g.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&g.includes(l[0].toLowerCase())}}),define(we[233],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var y;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST_DARK="hcDark",I.HIGH_CONTRAST_LIGHT="hcLight"})(y=e.ColorScheme||(e.ColorScheme={}));function t(I){return I===y.HIGH_CONTRAST_DARK||I===y.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(I){return I===y.DARK||I===y.HIGH_CONTRAST_DARK}e.isDark=D}),define(we[116],ye([1,0,41,7,2,5,34,233]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,I.createDecorator)("themeService");var E;(function(v){function m(p){return p&&typeof p=="object"&&typeof p.id=="string"}v.isThemeColor=m})(E=e.ThemeColor||(e.ThemeColor={}));function b(v){return{id:v}}e.themeColorFromId=b;var k;(function(v){function m(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||E.isThemeColor(s.color))}v.isThemeIcon=m;const p=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function u(s){const a=p.exec(s);if(!a)return;const[,f]=a;return{id:f}}v.fromString=u;function l(s){return{id:s}}v.fromId=l;function h(s,a){let f=s.id;const o=f.lastIndexOf("~");return o!==-1&&(f=f.substring(0,o)),a&&(f=`${f}~${a}`),{id:f}}v.modify=h;function i(s){const a=s.id.lastIndexOf("~");if(a!==-1)return s.id.substring(a+1)}v.getModifier=i;function r(s,a){return s.id===a.id&&s.color?.id===a.color?.id}v.isEqual=r;function n(s,a){return{id:s.id,color:a?b(a):void 0}}v.asThemeIcon=n,v.asClassNameArray=y.CSSIcon.asClassNameArray,v.asClassName=y.CSSIcon.asClassName,v.asCSSSelector=y.CSSIcon.asCSSSelector})(k=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function R(v){switch(v){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case C.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const p=this.themingParticipants.indexOf(m);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const w=new S;P.Registry.add(e.Extensions.ThemingContribution,w);function d(v){return w.onColorThemeChange(v)}e.registerThemingParticipant=d;class g extends D.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,p){let u=this.theme.getColor(m);return u&&p&&(u=p(u,this.theme)),u?u.toString():null}}e.Themable=g}),define(we[234],ye([1,0,41,4,181,116]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function P(S,w){const d=[{name:null,description:(0,D.localize)(0,null)}];return d.push(...S.map(g=>({name:g.profileName,description:C(g)}))),w&&d.push(...w.map(g=>({name:g.title,description:E(g)}))),{values:d.map(g=>g.name),markdownDescriptions:d.map(g=>g.description)}}e.createProfileSchemaEnums=P;function C(S){let w=`$(${I.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:y.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?w+=`
- args: "${S.args}"`:w+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(w+=`
- overrideName: ${S.overrideName}`),S.color&&(w+=`
- color: ${S.color}`),S.env&&(w+=`
- env: ${JSON.stringify(S.env)}`),w}function E(S){return`$(${I.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:y.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function b(S,w){if(!S&&!w)return!0;if(typeof S=="string"&&typeof w=="string")return S===w;if(Array.isArray(S)&&Array.isArray(w)){if(S.length!==w.length)return!1;for(let d=0;d<S.length;d++)if(S[d]!==w[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function k(S,w){if(!S&&!w)return!0;if(!S||!w)return!1;if(I.ThemeIcon.isThemeIcon(S)&&I.ThemeIcon.isThemeIcon(w))return S.id===w.id&&S.color===w.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof w=="object"&&"light"in w&&"dark"in w){const d=S,g=w;if((t.URI.isUri(d.light)||R(d.light))&&(t.URI.isUri(d.dark)||R(d.dark))&&(t.URI.isUri(g.light)||R(g.light))&&(t.URI.isUri(g.dark)||R(g.dark)))return d.light.path===g.light.path&&d.dark.path===g.dark.path}if(t.URI.isUri(S)&&t.URI.isUri(w)||R(S)||R(w)){const d=S,g=w;return d.path===g.path&&d.scheme===g.scheme}return!1}e.terminalIconsEqual=k;function R(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=R}),define(we[235],ye([1,0,41,180,51,34,234]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(y.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(y.Codicon.getAll(),l=>`$(${l.id})`)};const C={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...C}},k=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),S=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),w=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),g=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:k},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:k},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:S},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...C}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...C}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...C}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){I.Registry.as(D.Extensions.Configuration).registerConfiguration(v),u()}e.registerTerminalPlatformConfiguration=m;let p;function u(l,h){const i=I.Registry.as(D.Extensions.Configuration);let r;l&&(r=(0,P.createProfileSchemaEnums)(l?.profiles,h));const n=p;p={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?r?.values:void 0,markdownEnumDescriptions:l?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?r?.values:void 0,markdownEnumDescriptions:l?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?r?.values:void 0,markdownEnumDescriptions:l?.os===1?r?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[p],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(we[236],ye([1,0,47,41,6,3,21,95,232,116]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let k,R=!0;function S(r,n,s,a,f=process.env,o,c,T,O){return o=o||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},I.isWindows?w(s,o,f,c,a.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:a.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:a.getValue("terminal.integrated.defaultProfile.windows"),O,T):l(o,c,s,r&&typeof r=="object"?{...r}:a.getValue(I.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:a.getValue(I.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),O,T,f)}e.detectAvailableProfiles=S;async function w(r,n,s,a,f,o,c,T,O){const K=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${K?"Sysnative":"System32"}`;let le=!1;(0,E.getWindowsBuildNumber)()>=16299&&(le=!0),await v(T);const ae=new Map;r&&(ae.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),h(o,ae);const F=await d(ae.entries(),c,n,s,a,O);if(r||f)try{const Y=await p(`${re}\\${le?"wsl":"bash"}.exe`,c);for(const B of Y)(!o||!(B.profileName in o))&&F.push(B)}catch{R&&(a?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return F}async function d(r,n,s,a=process.env,f,o){const c=[];for(const[T,O]of r){if(O===null)continue;let K,re,le;if("source"in O){const Y=k?.get(O.source);if(!Y)continue;K=Y.paths,re=O.args||Y.args,O.icon?le=g(O.icon):Y.icon&&(le=Y.icon)}else K=Array.isArray(O.path)?O.path:[O.path],re=I.isWindows||Array.isArray(O.args)?O.args:void 0,le=g(O.icon);const ae=await o?.(K)||K.slice(),F=await i(T,n,ae,s,a,re,O.env,O.overrideName,O.isAutoDetected,f);F?(F.isAutoDetected=O.isAutoDetected,F.icon=le,F.color=O.color,c.push(F)):f?.debug("Terminal profile not validated",T,K)}return f?.debug("Validated terminal profiles",c),c}function g(r){return typeof r=="string"?{id:r}:r}async function v(r){k&&!r||(k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),k.set("PowerShell",{profileName:"PowerShell",paths:r||await m(),icon:b.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function m(){const r=[];for await(const n of(0,C.enumeratePowerShellInstallations)())r.push(n.exePath);return r}async function p(r,n){const s=[],a=await new Promise((c,T)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(O,K)=>{if(O)return T("Problem occurred when getting wsl distros");c(K)})});if(!a)return[];const f=new RegExp(/[\r?\n]/),o=a.split(f).filter(c=>c.trim().length>0&&c!=="");for(const c of o){if(c===""||c.startsWith("docker-desktop"))continue;const T=`${c} (WSL)`,O={profileName:T,path:r,args:["-d",`${c}`],isDefault:T===n,icon:u(c),isAutoDetected:!1};s.push(O)}return s}function u(r){return r.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):r.includes("Debian")?b.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function l(r,n,s,a,f,o,c,T){const O=new Map;if(s){const K=(await r.readFile("/etc/shells")).toString(),re=o||K.split(`
`).filter(ae=>ae.trim().indexOf("#")!==0&&ae.trim().length>0),le=new Map;for(const ae of re){let F=(0,D.basename)(ae),Y=le.get(F)||0;Y++,Y>1&&(F=`${F} (${Y})`),le.set(F,Y),O.set(F,{path:ae,isAutoDetected:!0})}}return h(a,O),await d(O.entries(),f,r,T,n,c)}function h(r,n){if(!!r)for(const[s,a]of Object.entries(r))a===null||!("path"in a)&&!("source"in a)?n.delete(s):(a.icon=a.icon||n.get(s)?.icon,n.set(s,a))}async function i(r,n,s,a,f,o,c,T,O,K){if(s.length===0)return Promise.resolve(void 0);const re=s.shift();if(re==="")return i(r,n,s,a,f,o,c,T,O);const le={profileName:r,path:re,args:o,env:c,overrideName:T,isAutoDetected:O,isDefault:r===n};if((0,D.basename)(re)===re){const F=f.PATH?f.PATH.split(D.delimiter):void 0,Y=await(0,E.findExecutable)(re,void 0,F,void 0,a.existsFile);return Y?(le.path=Y,le.isFromPath=!0,le):i(r,n,s,a,f,o)}return await a.existsFile((0,D.normalize)(re))?le:i(r,n,s,a,f,o,c,T,O)}}),define(we[237],ye([1,0,7,2,9,3,42,99,24,28,101,80,12,106,230,115,235,236]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let u=0,l=class extends t.Disposable{constructor(i,r,n,s){super(),this._reconnectConstants=i,this._configurationService=r,this._environmentService=n,this._logService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new y.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new y.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new y.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new y.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new y.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new y.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new y.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new y.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new y.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new y.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new y.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new y.Emitter),this.onProcessExit=this._onProcessExit.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(I.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,k.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?i.debugBrk=r.port:!r.break&&r.port&&(i.debug=r.port));const n=new C.Client(D.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,i);this._onPtyHostStart.fire(),P.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),this._isDisposed||(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const a=n.getChannel(g.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const f=P.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(f.onProcessData(o=>this._onProcessData.fire(o))),this._register(f.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(f.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(f.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(f.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(f.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(f.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),[n,f]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,r,n,s,a,f,o,c,T,O,K){const re=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),le=await this._proxy.createProcess(i,r,n,s,a,f,o,c,T,O,K);return clearTimeout(re),u=Math.max(u,le),le}updateTitle(i,r,n){return this._proxy.updateTitle(i,r,n)}updateIcon(i,r,n,s){return this._proxy.updateIcon(i,r,n,s)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,r){return this._proxy.detachFromProcess(i,r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,r){return this._proxy.shutdown(i,r)}input(i,r){return this._proxy.input(i,r)}processBinary(i,r){return this._proxy.processBinary(i,r)}resize(i,r,n){return this._proxy.resize(i,r,n)}acknowledgeDataEvent(i,r){return this._proxy.acknowledgeDataEvent(i,r)}setUnicodeVersion(i,r){return this._proxy.setUnicodeVersion(i,r)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,r){return this._proxy.installAutoReply(i,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,r,n,s=!1){const a=await this._shellEnv;return(0,m.detectAvailableProfiles)(r,n,s,this._configurationService,a,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,r){return this._proxy.requestDetachInstance(i,r)}async acceptDetachInstanceReply(i,r){return this._proxy.acceptDetachInstanceReply(i,r)}async freePortKillProcess(i){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(i)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,r){return this._proxy.reviveTerminalProcesses(i,r)}async refreshProperty(i,r){return this._proxy.refreshProperty(i,r)}async updateProperty(i,r,n){return this._proxy.updateProperty(i,r,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:r})}async acceptPtyHostResolvedVariables(i,r){this._resolveVariablesRequestStore.acceptReply(i,r)}};l=Ae([_e(1,E.IConfigurationService),_e(2,b.IEnvironmentService),_e(3,S.ILogService)],l),e.PtyHostService=l}),define(we[39],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,y.createDecorator)("IUriIdentityService")}),define(we[238],ye([1,0,7,2,4,28,32,17,12,39]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let k=class extends t.Disposable{constructor(S,w,d,g,v){super(),this.extensionsManagementService=S,this.logService=g,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new y.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(p=>{this.installedExtensions=p.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(S.onInstallExtension(p=>this.onInstallExtension(p))),this._register(S.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(S.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const m=D.URI.file(d.extensionsPath);this._register(w.watch(m)),this._register(y.Event.filter(w.onDidFilesChange,p=>p.rawChanges.some(u=>this.doesChangeAffects(u,m)))(()=>this.onDidChange()))}doesChangeAffects(S,w){return S.type!==1&&S.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(S.resource),w)?!1:this.uriIdentityService.extUri.isEqual(S.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(S.resource).startsWith(".")}onInstallExtension(S){this.addInstallingExtension(S.identifier)}onDidInstallExtensions(S){for(const w of S)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(S){S.error||this.removeInstalledExtension(S.identifier)}addInstallingExtension(S){this.removeInstallingExtension(S),this.installingExtensions.push(S)}removeInstallingExtension(S){this.installingExtensions=this.installingExtensions.filter(w=>!(0,P.areSameExtensions)(w,S))}addInstalledExtension(S){this.installedExtensions&&(this.removeInstalledExtension(S),this.installedExtensions.push(S))}removeInstalledExtension(S){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,P.areSameExtensions)(w,S)))}async onDidChange(){if(this.installedExtensions){const S=await this.extensionsManagementService.getInstalled(),w=S.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,P.areSameExtensions)(v,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),d=this.installedExtensions.filter(g=>this.installingExtensions.some(v=>(0,P.areSameExtensions)(v,g))?!1:S.every(v=>!(0,P.areSameExtensions)(v.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=S.map(g=>g.identifier),(w.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:d})}}};k=Ae([_e(1,C.IFileService),_e(2,I.INativeEnvironmentService),_e(3,E.ILogService),_e(4,b.IUriIdentityService)],k),e.ExtensionsWatcher=k}),define(we[117],ye([1,0,39,196,17,19,139,7,2]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(S){this.uri=S,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let k=class{constructor(S){this._fileService=S,this._dispooables=new E.DisposableStore,this._limit=2**16;const w=new Map,d=g=>{let v=w.get(g.scheme);return v===void 0&&(v=S.hasProvider(g)&&!this._fileService.hasCapability(g,1024),w.set(g.scheme,v)),v};this._dispooables.add(C.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new I.ExtUri(d),this._canonicalUris=new P.SkipList((g,v)=>this.extUri.compare(g,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,I.normalizePath)(S));const w=this._canonicalUris.get(S);return w?w.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new b(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((d,g)=>d[1].touch<g[1].touch?1:d[1].touch>g[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let d=0;d<w;d++)this._canonicalUris.set(S[d][0],S[d][1].touch())}};k=Ae([_e(0,D.IFileService)],k),e.UriIdentityService=k,(0,t.registerSingleton)(y.IUriIdentityService,k,1)}),define(we[81],ye([1,0,183,6,57,19,4,5,9]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function b(r){const n=r;return typeof n?.id=="string"&&P.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function k(r,n){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const s=r;if(s.configuration)return{id:s.id,configPath:s.configuration};if(s.folders.length===1)return{id:s.id,uri:s.folders[0].uri}}e.toWorkspaceIdentifier=k;function R(r){const n=r;return typeof n?.id=="string"&&P.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=R;function S(r){const n=r;if(n?.uri)return{id:n.id,uri:P.URI.revive(n.uri)};const s=r;if(s?.configPath)return{id:s.id,configPath:P.URI.revive(s.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=S;var w;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function d(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function g(r){const n=r;return!!(n&&typeof n=="object"&&P.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=g;class v{constructor(n,s,a,f,o){this._id=n,this._transient=a,this._configuration=f,this._ignorePathCasing=o,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class m{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,I.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function p(r){return new m({uri:r,index:0,name:(0,I.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(r,n){return I.extUriBiasedIgnorePathCase.isEqualOrParent(r,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function l(r){let n;return P.URI.isUri(r)?n=r:n=r.configuration,n?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=l;function h(r,n){return!u(r,n)&&!l(r)}e.isSavedWorkspace=h;function i(r){return(typeof r=="string"?(0,t.extname)(r):(0,I.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(we[37],ye([1,0,90,7,2,19,13,4,182,28,17,5,12,81,31,39,14,22,15]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function u(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&((0,P.isUndefined)(s.extensionsResource)||C.URI.isUri(s.extensionsResource)))}e.isUserDataProfile=u,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function l(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:C.URI.revive(n.location).with({scheme:s}),globalStorageHome:C.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(n.extensionsResource)?.with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=l,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function h(n,s,a,f){return{id:n,name:s,location:a,isDefault:!1,shortName:f?.shortName,globalStorageHome:(0,I.joinPath)(a,"globalStorage"),settingsResource:(0,I.joinPath)(a,"settings.json"),keybindingsResource:(0,I.joinPath)(a,"keybindings.json"),tasksResource:(0,I.joinPath)(a,"tasks.json"),snippetsHome:(0,I.joinPath)(a,"snippets"),extensionsResource:(0,I.joinPath)(a,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:f?.useDefaultFlags,isTransient:f?.transient}}e.toUserDataProfile=h;let i=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(s,a,f,o){super(),this.environmentService=s,this.fileService=a,this.uriIdentityService=f,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,I.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(s){this.enabled!==s&&(this._profilesObject=void 0,this.enabled=s)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const s=this.enabled?this.getStoredProfiles().map(c=>h((0,I.basename)(c.location),c.name,c.location,{shortName:c.shortName,useDefaultFlags:c.useDefaultFlags})):[];let a;const f=new d.ResourceMap,o=h((0,y.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,E.localize)(0,null),this.environmentService.userRoamingDataHome);if(s.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||s.length>0||this.transientProfilesObject.profiles.length>0?o.extensionsResource:void 0}),s.length){const c=this.getStoredProfileAssociations();if(c.workspaces)for(const[T,O]of Object.entries(c.workspaces)){const K=C.URI.parse(T),re=C.URI.parse(O),le=s.find(ae=>this.uriIdentityService.extUri.isEqual(ae.location,re));le&&f.set(K,le)}if(c.emptyWindow){const T=C.URI.parse(c.emptyWindow);a=s.find(O=>this.uriIdentityService.extUri.isEqual(O.location,T))}}this._profilesObject={profiles:s,workspaces:f,emptyWindow:a}}return this._profilesObject}async createTransientProfile(s){const a="Temp",f=new RegExp(`${(0,p.escapeRegExpCharacters)(a)}\\s(\\d+)`);let o=0;for(const T of this.profiles){const O=f.exec(T.name),K=O?parseInt(O[1]):0;o=K>o?K:o}const c=`${a} ${o+1}`;return this.createProfile((0,y.hash)((0,m.generateUuid)()).toString(16),c,{transient:!0},s)}async createNamedProfile(s,a,f){return this.createProfile((0,y.hash)((0,m.generateUuid)()).toString(16),s,a,f)}async createProfile(s,a,f,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=await this.doCreateProfile(s,a,f);return o&&await this.setProfileForWorkspace(o,c),c}async doCreateProfile(s,a,f){let o=this.profileCreationPromises.get(a);return o||(o=(async()=>{try{const c=this.profiles.find(K=>K.name===a||K.id===s);if(c)return c;const T=h(s,a,(0,I.joinPath)(this.profilesHome,s),f);await this.fileService.createFolder(T.location);const O=[];return this._onWillCreateProfile.fire({profile:T,join(K){O.push(K)}}),await v.Promises.settled(O),this.updateProfiles([T],[],[]),T}finally{this.profileCreationPromises.delete(a)}})(),this.profileCreationPromises.set(a,o)),o}async updateProfile(s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let f=this.profiles.find(o=>o.id===s.id);if(!f)throw new Error(`Profile '${s.name}' does not exist`);return f=h(f.id,a.name??f.name,f.location,{shortName:a.shortName??f.shortName,transient:a.transient??f.isTransient,useDefaultFlags:a.useDefaultFlags??f.useDefaultFlags}),this.updateProfiles([],[],[f]),f}async removeProfile(s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(s.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(o=>o.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);const f=[];this._onWillRemoveProfile.fire({profile:a,join(o){f.push(o)}});try{await Promise.allSettled(f)}catch(o){this.logService.error(o)}a.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])a.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[a],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(a.location,{recursive:!0})}catch(o){this.logService.error(o)}}getOrSetProfileForWorkspace(s,a=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let f=this.getProfileForWorkspace(s);return f||(f=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(s,f)),f}async setProfileForWorkspace(s,a){this.setProfileForWorkspaceSync(s,a)}setProfileForWorkspaceSync(s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=this.profiles.find(o=>o.id===a.id);if(!f)throw new Error(`Profile '${a.name}' does not exist`);this.updateWorkspaceAssociation(s,f)}unsetWorkspace(s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(s,void 0,a)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const s=await this.fileService.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(a=>a.isDirectory&&this.profiles.every(f=>!this.uriIdentityService.extUri.isEqual(f.location,a.resource))).map(a=>this.fileService.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const s=this.transientProfilesObject.profiles.filter(a=>!this.isProfileAssociatedToWorkspace(a));await Promise.allSettled(s.map(a=>this.removeProfile(a)))}getProfileForWorkspace(s){const a=this.getWorkspace(s);return C.URI.isUri(a)?this.transientProfilesObject.workspaces.get(a)??this.profilesObject.workspaces.get(a):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(s){return(0,w.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,w.isWorkspaceIdentifier)(s)?s.configPath:"empty-window"}isProfileAssociatedToWorkspace(s){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,s.location)||[...this.transientProfilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,s.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,s.location)||[...this.profilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,s.location)))}updateProfiles(s,a,f){const o=[...this.profiles,...s],c=[];this.transientProfilesObject.profiles=[];for(let T of o)T.isDefault||a.some(O=>T.id===O.id)||(T=f.find(O=>T.id===O.id)??T,T.isTransient?this.transientProfilesObject.profiles.push(T):c.push({location:T.location,name:T.name,shortName:T.shortName,useDefaultFlags:T.useDefaultFlags}));this.saveStoredProfiles(c),this._profilesObject=void 0,this.triggerProfilesChanges(s,a,f)}triggerProfilesChanges(s,a,f){this._onDidChangeProfiles.fire({added:s,removed:a,updated:f,all:this.profiles})}updateWorkspaceAssociation(s,a,f){f=a?.isTransient?!0:f,f||this.updateWorkspaceAssociation(s,void 0,!0);const o=this.getWorkspace(s),c=f?this.transientProfilesObject:this.profilesObject;C.URI.isUri(o)?(c.workspaces.delete(o),a&&c.workspaces.set(o,a)):c.emptyWindow=a,f||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const s={};for(const[f,o]of this.profilesObject.workspaces.entries())s[f.toString()]=o.location.toString();const a=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:s,emptyWindow:a}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(s){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(s){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=Ae([_e(0,b.IEnvironmentService),_e(1,k.IFileService),_e(2,g.IUriIdentityService),_e(3,S.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(s){this.storedProfiles=s}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(s){this.storedProfileAssociations=s}}e.InMemoryUserDataProfilesService=r}),define(we[239],ye([1,0,18,14,20,8,7,2,3,4,163,30,32,35,12,25,33,37]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let p=class extends C.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,s,a,f,o){super(),this.galleryService=n,this.telemetryService=s,this.logService=a,this.productService=f,this.userDataProfilesService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new P.Emitter),this._onDidInstallExtensions=this._register(new P.Emitter),this._onUninstallExtension=this._register(new P.Emitter),this._onDidUninstallExtension=this._register(new P.Emitter),this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(({task:c})=>c.cancel()),this.uninstallingExtensions.forEach(c=>c.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,R.isTargetPlatformCompatible)(a,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(k.localize(0,null),R.ExtensionManagementErrorCode.Internal);const a=await this.checkAndGetCompatibleVersion(n,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(a.manifest,a.extension,s)}catch(a){throw h(this.telemetryService,"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(n),error:a}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(a),l(a)}}async uninstall(n,s={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,s)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(k.localize(1,null));const s=await this.getTargetPlatform(),[a]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:s,compatible:!0},D.CancellationToken.None);if(!a)throw new Error(k.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(a)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,s,a){const f=re=>`${S.ExtensionKey.create(re).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!b.URI.isUri(s)){const re=this.installingExtensions.get(f(s));if(re){this.logService.info("Extensions is already requested to install",s.identifier.id);const{local:le}=await re.task.waitUntilTaskIsFinished();return le}a={...a,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],c=[],T=[],O=this.createInstallExtensionTask(n,s,a);b.URI.isUri(s)||this.installingExtensions.set(f(s),{task:O,waitingTasks:[]}),this._onInstallExtension.fire({identifier:O.identifier,source:s,profileLocation:a.profileLocation}),this.logService.info("Installing extension:",O.identifier.id),o.push({task:O,manifest:n});let K=!1;try{if(a.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const le=await this.getAllDepsAndPackExtensions(O.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),ae=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:F,manifest:Y}of le){K=K||!!Y.extensionDependencies?.some($=>(0,S.areSameExtensions)({id:$},O.identifier));const B=f(F),H=this.installingExtensions.get(B);if(H){if(this.canWaitForTask(O,H.task)){this.logService.info("Waiting for already requested installing extension",F.identifier.id,O.identifier.id),H.waitingTasks.push(O);const $=H.task.identifier;c.push(P.Event.toPromise(P.Event.filter(this.onDidInstallExtensions,j=>j.some(L=>(0,S.areSameExtensions)(L.identifier,$)))).then(j=>{if(!j.find(N=>(0,S.areSameExtensions)(N.identifier,$))?.local)throw new Error(`Extension ${$.id} is not installed`)}))}}else if(!ae.some(({identifier:$})=>(0,S.areSameExtensions)($,F.identifier))){const $=this.createInstallExtensionTask(Y,F,{...a,donotIncludePackAndDependencies:!0});this.installingExtensions.set(B,{task:$,waitingTasks:[O]}),this._onInstallExtension.fire({identifier:$.identifier,source:F,profileLocation:a.profileLocation}),this.logService.info("Installing extension:",$.identifier.id,O.identifier.id),o.push({task:$,manifest:Y})}}}catch(le){if(b.URI.isUri(O.source))(0,y.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",O.identifier.id,le.message),(0,y.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",O.identifier.id,le.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),le}const re=o.reduce((le,{task:ae,manifest:F})=>(le.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:F}),le),new Map);for(;re.size;){let le;const ae=[...re.values()].filter(({manifest:F})=>!F.extensionDependencies?.some(Y=>re.has(Y.toLowerCase())));ae.length?le=re.size===1?ae:ae.filter(({task:F})=>!(F===O&&!K)):(this.logService.info("Found extensions with circular dependencies",ae.map(({task:F})=>F.identifier.id)),le=[...re.values()]),await this.joinAllSettled(le.map(async({task:F})=>{const Y=new Date().getTime();try{const{local:B}=await F.run();if(await this.joinAllSettled(this.participants.map(H=>H.postInstall(B,F.source,a,D.CancellationToken.None))),!b.URI.isUri(F.source)){const H=F.operation===3,$=H?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(h(this.telemetryService,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(F.source),wasVerified:F.wasVerified,duration:new Date().getTime()-Y,durationSinceUpdate:$}),E.isWeb&&F.operation!==3)try{await this.galleryService.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}T.push({local:B,identifier:F.identifier,operation:F.operation,source:F.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:B.isApplicationScoped})}catch(B){throw b.URI.isUri(F.source)||h(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(F.source),wasVerified:F.wasVerified,duration:new Date().getTime()-Y,error:B}),this.logService.error("Error while installing the extension:",F.identifier.id),B}finally{re.delete(F.identifier.id.toLowerCase())}}))}return c.length&&await this.joinAllSettled(c),T.forEach(({identifier:le})=>this.logService.info("Extension installed successfully:",le.id)),this._onDidInstallExtensions.fire(T),T.filter(({identifier:le})=>(0,S.areSameExtensions)(le,O.identifier))[0].local}catch(re){if(o.forEach(({task:le})=>le.cancel()),T.length)try{const le=await Promise.allSettled(T.map(({local:ae})=>this.createUninstallExtensionTask(ae,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let ae=0;ae<le.length;ae++){const F=le[ae],{identifier:Y}=T[ae];F.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Y.id):this.logService.warn("Rollback: Error while uninstalling extension",Y.id,(0,I.getErrorMessage)(F.reason))}}catch(le){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(le),T.map(({identifier:ae})=>ae.id))}throw this._onDidInstallExtensions.fire(o.map(({task:le})=>({identifier:le.identifier,operation:2,source:le.source,context:a.context,profileLocation:a.profileLocation}))),re}finally{for(const[re,{task:le,waitingTasks:ae}]of this.installingExtensions.entries()){const F=ae.indexOf(O);F!==-1&&ae.splice(F,1),ae.length===0&&(le===O||F!==-1)&&this.installingExtensions.delete(re)}}}canWaitForTask(n,s){for(const[,{task:a,waitingTasks:f}]of this.installingExtensions.entries())if(a===n&&(f.includes(s)||f.some(o=>this.canWaitForTask(o,s)))||a===s&&f[0]&&!this.canWaitForTask(n,f[0]))return!1;return!0}async joinAllSettled(n){const s=[],a=[],f=await Promise.allSettled(n);for(const o of f)o.status==="fulfilled"?s.push(o.value):a.push(o.reason);if(a.length)throw u(a);return s}async getAllDepsAndPackExtensions(n,s,a,f,o){if(!this.galleryService.isEnabled())return[];const c=await this.getInstalled(void 0,o),T=[n],O=[],K=async(re,le)=>{const ae=le.extensionDependencies||[],F=[...ae];if(le.extensionPack){const Y=a?c.find(B=>(0,S.areSameExtensions)(B.identifier,re)):void 0;for(const B of le.extensionPack)Y&&Y.manifest.extensionPack&&Y.manifest.extensionPack.some(H=>(0,S.areSameExtensions)({id:H},{id:B}))||F.every(H=>!(0,S.areSameExtensions)({id:H},{id:B}))&&F.push(B)}if(F.length){const Y=[...T,...O.map(H=>H.gallery.identifier)],B=F.filter(H=>Y.every($=>!(0,S.areSameExtensions)($,{id:H})));if(B.length){const H=await this.galleryService.getExtensions(B.map($=>({id:$,preRelease:f})),D.CancellationToken.None);for(const $ of H){if(Y.find(N=>(0,S.areSameExtensions)(N,$.identifier)))continue;const j=ae.some(N=>(0,S.areSameExtensions)({id:N},$.identifier));let L;try{L=await this.checkAndGetCompatibleVersion($,!1,f)}catch(N){if(N instanceof R.ExtensionManagementError&&N.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!j){this.logService.info("Skipping the packed extension as it cannot be installed",$.identifier.id);continue}else throw N}O.push({gallery:L.extension,manifest:L.manifest}),await K(L.extension.identifier,L.manifest)}}}};return await K(n,s),O}async checkAndGetCompatibleVersion(n,s,a){if((await this.getExtensionsControlManifest()).malicious.some(T=>(0,S.areSameExtensions)(n.identifier,T)))throw new R.ExtensionManagementError(k.localize(3,null,n.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const T=await this.getTargetPlatform();throw new R.ExtensionManagementError(k.localize(4,null,n.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)(T)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(n,s,a);if(o){if(a&&!s&&n.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(k.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],D.CancellationToken.None))[0]?new R.ExtensionManagementError(k.localize(6,null,n.identifier.id),R.ExtensionManagementErrorCode.ReleaseVersionNotFound):new R.ExtensionManagementError(k.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const c=await this.galleryService.getManifest(o,D.CancellationToken.None);if(c===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new R.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(n,s,a){const f=await this.getTargetPlatform();let o=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(o=(await this.galleryService.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:f,compatible:!0},D.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(n,a,f)&&(o=n),o||(s?o=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:f,compatible:!0},D.CancellationToken.None))[0]||null:o=await this.galleryService.getCompatibleExtension(n,a,f)),o}async uninstallExtension(n,s){const a=K=>`${K.id.toLowerCase()}${s.versionOnly?`-${n.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,f=this.uninstallingExtensions.get(a(n.identifier));if(f)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),f.waitUntilTaskIsFinished();const o=(K,re)=>{const le=this.createUninstallExtensionTask(K,re);return this.uninstallingExtensions.set(a(le.extension.identifier),le),s.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,s.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this._onUninstallExtension.fire({identifier:K.identifier,profileLocation:s.profileLocation,applicationScoped:K.isApplicationScoped}),le},c=(K,re)=>{re?s.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,s.profileLocation.toString(),re.message):this.logService.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,re.message):s.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,s.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),h(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)(K),error:re}),this._onDidUninstallExtension.fire({identifier:K.identifier,version:K.manifest.version,error:re?.code,profileLocation:s.profileLocation,applicationScoped:K.isApplicationScoped})},T=[],O=[];try{T.push(o(n,s));const K=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const re=this.getAllPackExtensionsToUninstall(n,K);for(const le of re)this.uninstallingExtensions.has(a(le.identifier))?this.logService.info("Extensions is already requested to uninstall",le.identifier.id):T.push(o(le,s))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(T.map(re=>re.extension),K,n),await this.joinAllSettled(T.map(async re=>{try{if(await re.run(),await this.joinAllSettled(this.participants.map(le=>le.postUninstall(re.extension,s,D.CancellationToken.None))),re.extension.identifier.uuid)try{await this.galleryService.reportStatistic(re.extension.manifest.publisher,re.extension.manifest.name,re.extension.manifest.version,"uninstall")}catch{}c(re.extension)}catch(le){const ae=le instanceof R.ExtensionManagementError?le:new R.ExtensionManagementError((0,I.getErrorMessage)(le),R.ExtensionManagementErrorCode.Internal);throw c(re.extension,ae),ae}finally{O.push(re)}}))}catch(K){const re=K instanceof R.ExtensionManagementError?K:new R.ExtensionManagementError((0,I.getErrorMessage)(K),R.ExtensionManagementErrorCode.Internal);for(const le of T){try{le.cancel()}catch{}O.includes(le)||c(le.extension,re)}throw re}finally{for(const K of T)this.uninstallingExtensions.delete(a(K.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}checkForDependents(n,s,a){for(const f of n){const o=this.getDependents(f,s);if(o.length){const c=o.filter(T=>!n.some(O=>(0,S.areSameExtensions)(O.identifier,T.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(f,c,a))}}}getDependentsErrorMessage(n,s,a){return a===n?s.length===1?k.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?k.localize(9,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):k.localize(10,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?k.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?k.localize(12,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):k.localize(13,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(n,s,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const f=n.manifest.extensionPack?n.manifest.extensionPack:[];if(f.length){const o=s.filter(T=>!T.isBuiltin&&f.some(O=>(0,S.areSameExtensions)({id:O},T.identifier))),c=[];for(const T of o)c.push(...this.getAllPackExtensionsToUninstall(T,s,a));return[...o,...c]}return[]}getDependents(n,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(f=>(0,S.areSameExtensions)({id:f},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(n,s,a){return a.profileLocation&&(0,w.isApplicationScopedExtension)(n)&&(a={...a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(n,s,a)}createUninstallExtensionTask(n,s){return s.profileLocation&&n.isApplicationScoped&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(n,s)}};p=Ae([_e(0,R.IExtensionGalleryService),_e(1,v.ITelemetryService),_e(2,d.ILogService),_e(3,g.IProductService),_e(4,m.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function u(r){const n=Array.isArray(r)?r:[r];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=u;function l(r){if(r instanceof R.ExtensionManagementError)return r;const n=new R.ExtensionManagementError(r.message,R.ExtensionManagementErrorCode.Internal);return n.stack=r.stack,n}function h(r,n,{extensionData:s,wasVerified:a,duration:f,error:o,durationSinceUpdate:c}){let T,O;o&&(o instanceof R.ExtensionManagementError?(T=o.code,o.code===R.ExtensionManagementErrorCode.Signature&&(O=o.message)):T=R.ExtensionManagementErrorCode.Internal),r.publicLog(n,{...s,wasVerified:a,success:!o,duration:f,errorcode:T,errorcodeDetail:O,durationSinceUpdate:c})}e.reportTelemetry=h;class i{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((s,a)=>{const f=n.onCancellationRequested(()=>{f.dispose(),a(new I.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(we[54],ye([1,0,18,14,23,16,8,67,158,2,9,6,3,19,49,69,13,4,167,28,32,35,72,17,5,12,25,7,45,52,37,39,194]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l,h,i,r,n,s,a,f,o,c,T,O,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var re;(function($){function j(L,N){if(L===N)return!0;const q=Object.keys(L),se=new Set;for(const he of Object.keys(N))se.add(he);if(q.length!==se.size)return!1;for(const he of q){if(L[he]!==N[he])return!1;se.delete(he)}return se.size===0}$.equals=j})(re=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let le=class extends b.Disposable{constructor(j,L,N,q,se,he,Z,ee,_,U,te){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=L,this.extensionsControlLocation=N,this.cacheLocation=q,this.userDataProfilesService=se,this.extensionsProfileScannerService=he,this.fileService=Z,this.logService=ee,this.environmentService=_,this.productService=U,this.instantiationService=te,this._onDidChangeCache=this._register(new f.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,w.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Y,(0,w.joinPath)(this.cacheLocation,h.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Y,(0,w.joinPath)(this.cacheLocation,h.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(F,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,L,N){const[q,se]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(L)]),he=N?await this.scanExtensionsUnderDevelopment(j,[...q,...se]):[];return this.dedupExtensions(q,se,he,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const L=[];L.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),L.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[N,q]=await Promise.all(L);return this.applyScanOptions([...N,...q],0,j,!1)}async scanUserExtensions(j){this.logService.trace("Started scanning user extensions");const L=await this.createExtensionScannerInput(j.profileLocation??this.userExtensionsLocation,!!j.profileLocation,1,!j.includeUninstalled,j.language);let q=await(j.useCache&&!L.devMode&&L.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(L);return q=await this.applyScanOptions(q,1,j,!0),this.logService.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(j,L){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const N=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===k.Schemas.file).map(async q=>{const se=await this.createExtensionScannerInput(q,!1,1,!0,j.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(se)).map(Z=>(Z.type=L.find(ee=>(0,l.areSameExtensions)(ee.identifier,Z.identifier))?.type??Z.type,this.extensionsScanner.validate(Z,se)))}))).flat();return this.applyScanOptions(N,"development",j,!0)}return[]}async scanExistingExtension(j,L,N){const q=await this.createExtensionScannerInput(j,!1,L,!0,N.language),se=await this.extensionsScanner.scanExtension(q);return!se||!N.includeInvalid&&!se.isValid?null:se}async scanOneOrMultipleExtensions(j,L,N){const q=await this.createExtensionScannerInput(j,!1,L,!0,N.language),se=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(se,L,N,!0)}async scanMetadata(j){const L=(0,w.joinPath)(j,"package.json"),N=(await this.fileService.readFile(L)).value.toString();return JSON.parse(N).__metadata}async updateMetadata(j,L){const N=(0,w.joinPath)(j,"package.json"),q=(await this.fileService.readFile(N)).value.toString(),se=JSON.parse(q);L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.installedTimestamp=L.installedTimestamp||void 0,se.__metadata={...se.__metadata,...L},await this.fileService.writeFile((0,w.joinPath)(j,"package.json"),I.VSBuffer.fromString(JSON.stringify(se,null,"	")))}async applyScanOptions(j,L,N,q){return N.includeAllVersions||(j=this.dedupExtensions(L===0?j:void 0,L===1?j:void 0,L==="development"?j:void 0,await this.getTargetPlatform(),q)),N.includeInvalid||(j=j.filter(se=>se.isValid)),j.sort((se,he)=>{const Z=R.basename(se.location.fsPath),ee=R.basename(he.location.fsPath);return Z<ee?-1:Z>ee?1:0})}dedupExtensions(j,L,N,q,se){const he=(ee,_,U)=>{if(ee.isValid&&!_.isValid)return!1;if(ee.isValid===_.isValid){if(se&&d.gt(ee.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(d.eq(ee.manifest.version,_.manifest.version)){if(ee.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===q)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return U?this.logService.warn(`Overwriting user extension ${ee.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${ee.location.path} with ${_.location.path}.`),!0},Z=new Map;return j?.forEach(ee=>{const _=h.ExtensionIdentifier.toKey(ee.identifier.id),U=Z.get(_);(!U||he(U,ee,!1))&&Z.set(_,ee)}),L?.forEach(ee=>{const _=h.ExtensionIdentifier.toKey(ee.identifier.id),U=Z.get(_);if(!U&&j&&ee.type===0){this.logService.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!U||he(U,ee,!1))&&Z.set(_,ee)}),N?.forEach(ee=>{const _=h.ExtensionIdentifier.toKey(ee.identifier.id),U=Z.get(_);(!U||he(U,ee,!0))&&Z.set(_,ee),Z.set(_,ee)}),[...Z.values()]}async scanDefaultSystemExtensions(j,L){this.logService.trace("Started scanning system extensions");const N=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,L),se=await(j&&!N.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return this.logService.trace("Scanned system extensions:",se.length),se}async scanDevSystemExtensions(j,L){const N=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!N?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=L?await this.getBuiltInExtensionControl():{},se=[],he=m.URI.file(R.normalize(R.join(k.FileAccess.asFileUri("",oe).fsPath,"..",".build","builtInExtensions")));for(const ee of N){const _=q[ee.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":se.push((0,w.joinPath)(he,ee.name));break;default:se.push(m.URI.file(_));break}}const Z=await Promise.all(se.map(async ee=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ee,!1,0,!0,j))));return this.logService.trace("Scanned dev system extensions:",Z.length),(0,y.coalesce)(Z)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,L,N,q,se,he=!0){const Z=await this.getTranslations(se??S.language),ee=await this.getMtime(j),_=L?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,U=_?await this.getMtime(_):void 0;return new ae(j,ee,_,U,L,N,q,he,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,se,Z)}async getMtime(j){try{const L=await this.fileService.stat(j);if(typeof L.mtime=="number")return L.mtime}catch{}}};le=Ae([_e(4,T.IUserDataProfilesService),_e(5,c.IExtensionsProfileScannerService),_e(6,r.IFileService),_e(7,s.ILogService),_e(8,u.IEnvironmentService),_e(9,a.IProductService),_e(10,n.IInstantiationService)],le),e.AbstractExtensionsScannerService=le;class ae{constructor(j,L,N,q,se,he,Z,ee,_,U,te,ie,fe,ve){this.location=j,this.mtime=L,this.applicationExtensionslocation=N,this.applicationExtensionslocationMtime=q,this.profile=se,this.type=he,this.excludeObsolete=Z,this.validate=ee,this.productVersion=_,this.productDate=U,this.productCommit=te,this.devMode=ie,this.language=fe,this.translations=ve}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,L){return(0,w.isEqual)(j.location,L.location)&&j.mtime===L.mtime&&(0,w.isEqual)(j.applicationExtensionslocation,L.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===L.applicationExtensionslocationMtime&&j.profile===L.profile&&j.type===L.type&&j.excludeObsolete===L.excludeObsolete&&j.validate===L.validate&&j.productVersion===L.productVersion&&j.productDate===L.productDate&&j.productCommit===L.productCommit&&j.devMode===L.devMode&&j.language===L.language&&re.equals(j.translations,L.translations)}}let F=class extends b.Disposable{constructor(j,L,N,q,se){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=L,this.uriIdentityService=N,this.fileService=q,this.logService=se}async scanExtensions(j){const L=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let N={};if(j.excludeObsolete&&j.type===1)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();N=JSON.parse(q)}catch{}return(0,v.isEmptyObject)(N)?L:L.filter(q=>!N[l.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(j){const L=await this.fileService.resolve(j.location);if(!L.children?.length)return[];const N=await Promise.all(L.children.map(async q=>{if(!q.isDirectory||j.type===1&&(0,w.basename)(q.resource).indexOf(".")===0)return null;const se=new ae(q.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(se)}));return(0,y.coalesce)(N).sort((q,se)=>q.location.path<se.location.path?-1:1)}async scanExtensionsFromProfile(j){let L=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){L=L.filter(q=>!q.metadata?.isApplicationScoped);const N=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,q=>!!q.metadata?.isApplicationScoped,j);L.push(...N)}return L}async scanExtensionsFromProfileResource(j,L,N){const q=await this.extensionsProfileScannerService.scanProfileExtensions(j);if(!q.length)return[];const se=await Promise.all(q.map(async he=>{if(L(he)){const Z=new ae(he.location,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(Z,he.metadata)}return null}));return(0,y.coalesce)(se)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,w.joinPath)(j.location,"package.json"))){const L=await this.scanExtension(j);return L?[L]:[]}else return await this.scanExtensions(j)}catch(L){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,P.getErrorMessage)(L)),[]}}async scanExtension(j,L){try{let N=await this.scanExtensionManifest(j.location);if(N){N.publisher||(N.publisher=h.UNDEFINED_PUBLISHER),L=L??N.__metadata,delete N.__metadata;const q=(0,l.getGalleryExtensionId)(N.publisher,N.name),se=L?.id?{id:q,uuid:L.id}:{id:q},he=L?.isSystem?0:j.type,Z=he===0||!!L?.isBuiltin;N=await this.translateManifest(j.location,N,ae.createNlsConfiguration(j));const ee={type:he,identifier:se,manifest:N,location:j.location,isBuiltin:Z,targetPlatform:L?.targetPlatform??"undefined",metadata:L,isValid:!0,validations:[]};return j.validate?this.validate(ee,j):ee}}catch(N){j.type!==0&&this.logService.error(N)}return null}validate(j,L){let N=!0;const q=(0,i.validateExtensionManifest)(L.productVersion,L.productDate,L.location,j.manifest,j.isBuiltin);for(const[se,he]of q)se===g.default.Error&&(N=!1,this.logService.error(this.formatMessage(L.location,he)));return j.isValid=N,j.validations=q,j}async scanExtensionManifest(j){const L=(0,w.joinPath)(j,"package.json");let N;try{N=(await this.fileService.readFile(L)).value.toString()}catch(se){return(0,r.toFileOperationResult)(se)!==1&&this.logService.error(this.formatMessage(j,(0,p.localize)(0,null,L.path,se.message))),null}let q;try{q=JSON.parse(N)}catch{const he=[];(0,C.parse)(N,he);for(const Z of he)this.logService.error(this.formatMessage(j,(0,p.localize)(1,null,L.path,Z.offset,Z.length,(0,E.getParseErrorMessage)(Z.error))));return null}return(0,C.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(j,(0,p.localize)(2,null,L.path))),null):q}async translateManifest(j,L,N){const q=await this.getLocalizedMessages(j,L,N);if(q)try{const se=[],he=await this.resolveOriginalMessageBundle(q.default,se);if(se.length>0)return se.forEach(ee=>{this.logService.error(this.formatMessage(j,(0,p.localize)(3,null,q.default?.path,(0,E.getParseErrorMessage)(ee.error))))}),L;if((0,C.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(j,(0,p.localize)(4,null,q.default?.path))),L;const Z=q.values||Object.create(null);return(0,K.localizeManifest)(L,Z,he)}catch{}return L}async getLocalizedMessages(j,L,N){const q=(0,w.joinPath)(j,"package.nls.json"),se=(_,U)=>{U.forEach(te=>{this.logService.error(this.formatMessage(j,(0,p.localize)(5,null,_?.path,(0,E.getParseErrorMessage)(te.error))))})},he=_=>{this.logService.error(this.formatMessage(j,(0,p.localize)(6,null,_?.path)))},Z=`${L.publisher}.${L.name}`,ee=N.translations[Z];if(ee)try{const _=m.URI.file(ee),U=(await this.fileService.readFile(_)).value.toString(),te=[],ie=(0,C.parse)(U,te);return te.length>0?(se(_,te),{values:void 0,default:q}):(0,C.getNodeType)(ie)!=="object"?(he(_),{values:void 0,default:q}):{values:ie.contents?ie.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let U;try{U=await this.findMessageBundles(j,N)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const te=(await this.fileService.readFile(U.localized)).value.toString(),ie=[],fe=(0,C.parse)(te,ie);return ie.length>0?(se(U.localized,ie),{values:void 0,default:U.original}):(0,C.getNodeType)(fe)!=="object"?(he(U.localized),{values:void 0,default:U.original}):{values:fe,default:U.original}}catch{return{values:void 0,default:U.original}}}}async resolveOriginalMessageBundle(j,L){if(j)try{const N=(await this.fileService.readFile(j)).value.toString();return(0,C.parse)(N,L)}catch{}}findMessageBundles(j,L){return new Promise((N,q)=>{const se=he=>{const Z=(0,w.joinPath)(j,`package.nls.${he}.json`);this.fileService.exists(Z).then(ee=>{ee&&N({localized:Z,original:(0,w.joinPath)(j,"package.nls.json")});const _=he.lastIndexOf("-");_===-1?N({localized:(0,w.joinPath)(j,"package.nls.json"),original:null}):(he=he.substring(0,_),se(he))})};if(L.devMode||L.pseudo||!L.language)return N({localized:(0,w.joinPath)(j,"package.nls.json"),original:null});se(L.language)})}formatMessage(j,L){return`[${j.path}]: ${L}`}};F=Ae([_e(1,c.IExtensionsProfileScannerService),_e(2,O.IUriIdentityService),_e(3,r.IFileService),_e(4,s.ILogService)],F);let Y=class extends F{constructor(j,L,N,q,se,he){super(L,N,q,se,he),this.cacheFile=j,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new f.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const L=await this.readExtensionCache();if(this.input=j,L&&L.input&&ae.equals(L.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),L.result.map(q=>(q.location=m.URI.revive(q.location),q));const N=await super.scanExtensions(j);return await this.writeExtensionCache({input:j,result:N}),N}async readExtensionCache(){try{const j=await this.fileService.readFile(this.cacheFile),L=JSON.parse(j.value.toString());return{result:L.result,input:(0,o.revive)(L.input)}}catch(j){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,P.getErrorMessage)(j))}return null}async writeExtensionCache(j){try{await this.fileService.writeFile(this.cacheFile,I.VSBuffer.fromString(JSON.stringify(j)))}catch(L){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,P.getErrorMessage)(L))}}async validateCache(){if(!this.input)return;const j=await this.readExtensionCache();if(!j)return;const L=j.result,N=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(N,L))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(q){this.logService.error(q)}}};Y=Ae([_e(2,c.IExtensionsProfileScannerService),_e(3,O.IUriIdentityService),_e(4,r.IFileService),_e(5,s.ILogService)],Y);function B($,j){const L=(0,l.getExtensionId)($.manifest.publisher,$.manifest.name);return{id:L,identifier:new h.ExtensionIdentifier(L),isBuiltin:$.type===0,isUserBuiltin:$.type===1&&$.isBuiltin,isUnderDevelopment:j,extensionLocation:$.location,uuid:$.identifier.uuid,targetPlatform:$.targetPlatform,...$.manifest}}e.toExtensionDescription=B;class H extends le{constructor(j,L,N,q,se,he,Z,ee,_,U,te){super(j,L,(0,w.joinPath)(N,".vscode-oss-dev","extensions","control.json"),(0,w.joinPath)(q,h.MANIFEST_CACHE_FOLDER),se,he,Z,ee,_,U,te),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const ie=await this.fileService.readFile(m.URI.file(S.translationsConfigFile));return JSON.parse(ie.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=H}),define(we[240],ye([1,0,47,14,38,7,2,9,6,21,12,37]),function(oe,e,y,t,D,I,P,C,E,b,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends P.Disposable{constructor(d,g){super(),this.userDataProfilesService=d,this.logService=g,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const g=this.parseScript(d,"uninstall");return g&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${v}`)))),b.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(d,g){const v=`vscode:${g}`;if(d.location.scheme===C.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[v]=="string"){const m=d.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${v} should be a node script`),null):{script:(0,E.join)(d.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(d,g,v,m,p){return new Promise((u,l)=>{const h=this.start(d,g,v,p);let i;const r=n=>{i&&(clearTimeout(i),i=null),n?l(n):u(void 0)};h.on("error",n=>{r((0,D.toErrorMessage)(n)||"Unknown")}),h.on("exit",(n,s)=>{r(n?`post-${g} process exited with code ${n}`:void 0)}),m&&(i=setTimeout(()=>{i=null,h.kill(),l("timed out")},5e3))})}start(d,g,v,m){const p={silent:!0,execArgv:void 0},u=(0,y.fork)(d,[`--type=extension-post-${g}`,...v],p);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const l=I.Event.fromNodeEventEmitter(u.stdout,"data"),h=I.Event.fromNodeEventEmitter(u.stderr,"data");l(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${g}`,n)),h(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${g}`,n));const i=I.Event.any(I.Event.map(l,n=>({data:`%c${n}`,format:[""]})),I.Event.map(h,n=>({data:`%c${n}`,format:["color: red"]})));return I.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}getExtensionStoragePath(d){return(0,E.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};S=Ae([_e(0,R.IUserDataProfilesService),_e(1,k.ILogService)],S),e.ExtensionsLifecycle=S}),define(we[241],ye([1,0,14,7,2,46,13,151,5,37]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var k;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(k=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var S;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function w(p){const u=p.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=w;class d extends D.Disposable{constructor(u={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=u,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new y.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,y.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,l){if(l===e.TARGET_KEY){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:l,target:this.getKeyTargets(u)[l]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,l,h){return this.getStorage(l)?.get(u,h)}getBoolean(u,l,h){return this.getStorage(l)?.getBoolean(u,h)}getNumber(u,l,h){return this.getStorage(l)?.getNumber(u,h)}store(u,l,h,i){if((0,P.isUndefinedOrNull)(l)){this.remove(u,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,h,i),this.getStorage(h)?.set(u,l)})}remove(u,l){this.withPausedEmitters(()=>{this.updateKeyTarget(u,l,void 0),this.getStorage(l)?.delete(u)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,l){const h=[],i=this.getKeyTargets(u);for(const r of Object.keys(i))i[r]===l&&h.push(r);return h}updateKeyTarget(u,l,h){const i=this.getKeyTargets(l);typeof h=="number"?i[u]!==h&&(i[u]=h,this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[u]=="number"&&(delete i[u],this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const l=this.getStorage(u);return l?w(l):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=k.NONE){this._onWillSaveState.fire({reason:u});const l=this.getStorage(-1),h=this.getStorage(0),i=this.getStorage(1);switch(u){case k.NONE:await y.Promises.settled([l?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await y.Promises.settled([l?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,h=this.getStorage(1)?.items??new Map;return m(u,l,h,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(u,l){return this.emitWillSaveState(k.NONE),(0,b.isUserDataProfile)(u)?this.switchToProfile(u,l):this.switchToWorkspace(u,l)}canSwitchProfile(u,l){return!(u.id===l.id||g(l)&&g(u))}switchData(u,l,h,i){this.withPausedEmitters(()=>{if(i)for(const[r,n]of u)l.set(r,n);else{const r=new Set;for(const[n,s]of u)r.add(n),l.get(n)!==s&&this.emitDidChangeValue(h,n);for(const[n]of l.items)r.has(n)||this.emitDidChangeValue(h,n)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function g(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class v extends d{constructor(){super(),this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(u){return!1}}e.InMemoryStorageService=v;async function m(p,u,l,h,i,r){const n=re=>{try{return JSON.parse(re)}catch{return re}},s=new Map,a=new Map;p.forEach((re,le)=>{s.set(le,re),a.set(le,n(re))});const f=new Map,o=new Map;u.forEach((re,le)=>{f.set(le,re),o.set(le,n(re))});const c=new Map,T=new Map;l.forEach((re,le)=>{c.set(le,re),T.set(le,n(re))}),console.group(h!==i?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const O=[];if(s.forEach((re,le)=>{O.push({key:le,value:re})}),console.table(O),console.groupEnd(),console.log(a),h!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const re=[];f.forEach((le,ae)=>{re.push({key:ae,value:le})}),console.table(re),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const K=[];c.forEach((re,le)=>{K.push({key:le,value:re})}),console.table(K),console.groupEnd(),console.log(T)}e.logStorage=m}),define(we[118],ye([1,0,18,20,8,3,26,13,4,24,28,30,32,72,17,12,25,53,223,241,33]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const h=I.isWeb?"web":(0,R.getTargetPlatform)(I.platform,P.arch);var i;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function r(..._){return String(_.reduce((U,te)=>U|te,0))}var n;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class c{constructor(U=o){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(U,te=this.state.pageSize){return new c({...this.state,pageNumber:U,pageSize:te})}withFilter(U,...te){const ie=[...this.state.criteria,...te.length?te.map(fe=>({filterType:U,value:fe})):[{filterType:U}]];return new c({...this.state,criteria:ie})}withSortBy(U){return new c({...this.state,sortBy:U})}withSortOrder(U){return new c({...this.state,sortOrder:U})}withFlags(...U){return new c({...this.state,flags:U.reduce((te,ie)=>te|ie,0)})}withAssetTypes(...U){return new c({...this.state,assetTypes:U})}withSource(U){return new c({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:te,pageSize:ie,sortBy:fe,sortOrder:ve,flags:z,assetTypes:Q}=this.state;return{filters:[{criteria:U,pageNumber:te,pageSize:ie,sortBy:fe,sortOrder:ve}],assetTypes:Q,flags:z}}get searchText(){const U=this.state.criteria.filter(te=>te.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function T(_,U){const te=(_||[]).filter(ie=>ie.statisticName===U)[0];return te?te.value:0}function O(_){const U="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(ie=>ie.assetType.indexOf(U)===0).reduce((ie,fe)=>{const ve=le(_,fe.assetType);return ve&&ie.push([fe.assetType.substring(U.length),ve]),ie},[])}function K(_){if(_.properties){const U=_.properties.filter(fe=>fe.key===s.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=U.filter(fe=>te.test(fe.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return le(_,s.Repository)}function re(_){return{uri:`${_.fallbackAssetUri}/${s.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${s.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function le(_,U){return _.files.filter(ie=>ie.assetType===U)[0]?{uri:`${_.assetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function ae(_,U){const te=_.properties?_.properties.filter(fe=>fe.key===U):[],ie=te.length>0&&te[0].value;return ie?ie.split(",").map(fe=>(0,S.adoptToGalleryExtensionId)(fe)):[]}function F(_){const U=_.properties?_.properties.filter(te=>te.key===a.Engine):[];return U.length>0&&U[0].value||""}function Y(_){const U=_.properties?_.properties.filter(te=>te.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function B(_){const U=_.properties?_.properties.filter(ie=>ie.key===a.LocalizedLanguages):[],te=U.length>0&&U[0].value||"";return te?te.split(","):[]}function H(_){return _.properties?.find(U=>U.key===a.SponsorLink)?.value}function $(_){return _.indexOf("preview")!==-1}function j(_){return _.targetPlatform?(0,R.toTargetPlatform)(_.targetPlatform):"undefined"}function L(_){const U=(0,y.distinct)(_.versions.map(j)),te=!!_.tags?.includes(R.WEB_EXTENSION_TAG),ie=U.indexOf("web");return te?ie===-1&&U.push("web"):ie!==-1&&U.splice(ie,1),U}function N(_,U){const te=(0,R.getFallbackTargetPlarforms)(U);for(let ie=0;ie<_.length;ie++){const fe=_[ie];if(fe.version===_[ie-1]?.version){let ve=ie;const z=j(fe);if(z===U)for(;ve>0&&_[ve-1].version===fe.version;)ve--;else if(te.includes(z))for(;ve>0&&_[ve-1].version===fe.version&&j(_[ve-1])!==U;)ve--;ve!==ie&&(_.splice(ie,1),_.splice(ve,0,fe))}}return _}e.sortExtensionVersions=N;function q(_,U,te){_.telemetryData={index:U,querySource:te}}function se(_,U,te){const ie=_.versions[0],fe={manifest:le(U,s.Manifest),readme:le(U,s.Details),changelog:le(U,s.Changelog),license:le(U,s.License),repository:K(U),download:re(U),icon:le(U,s.Icon),signature:le(U,s.Signature),coreTranslations:O(U)};return{identifier:{id:(0,S.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:U.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(ie),description:_.shortDescription||"",installCount:T(_.statistics,"install"),rating:T(_.statistics,"averagerating"),ratingCount:T(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:te,assets:fe,properties:{dependencies:ae(U,a.Dependency),extensionPack:ae(U,a.ExtensionPack),engine:F(U),localizedLanguages:B(U),targetPlatform:j(U),isPreReleaseVersion:Y(U)},hasPreReleaseVersion:Y(ie),hasReleaseVersion:!0,preview:$(_.flags),isSigned:!!fe.signature}}let he=class{constructor(U,te,ie,fe,ve,z,Q,J){this.requestService=te,this.logService=ie,this.environmentService=fe,this.telemetryService=ve,this.fileService=z,this.productService=Q,this.configurationService=J;const W=Q.extensionsGallery,V=W?.servicePPEUrl&&J.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=V?W.servicePPEUrl:W?.serviceUrl,this.extensionsGallerySearchUrl=V?void 0:W?.searchUrl,this.extensionsControlUrl=W?.controlUrl,this.commonHeadersPromise=(0,p.resolveMarketplaceHeaders)(Q.version,Q,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,te,ie){const fe=t.CancellationToken.isCancellationToken(te)?{}:te,ve=t.CancellationToken.isCancellationToken(te)?te:ie,z=[],Q=[],J=[],W=[];let V=!0;for(const ce of U){ce.uuid?Q.push(ce.uuid):z.push(ce.id);const pe=!!(ce.version||ce.preRelease);J.push({id:ce.id,uuid:ce.uuid,includePreRelease:pe}),ce.version&&W.push({id:ce.id,uuid:ce.uuid,version:ce.version}),V=V&&!!ce.hasPreRelease&&!pe}if(!Q.length&&!z.length)return[];let x=new c().withPage(1,U.length);Q.length&&(x=x.withFilter(n.ExtensionId,...Q)),z.length&&(x=x.withFilter(n.ExtensionName,...z)),(fe.queryAllVersions||V)&&(x=x.withFlags(x.flags,i.IncludeVersions)),fe.source&&(x=x.withSource(fe.source));const{extensions:X}=await this.queryGalleryExtensions(x,{targetPlatform:fe.targetPlatform??h,includePreRelease:J,versions:W,compatible:!!fe.compatible},ve);return fe.source&&X.forEach((ce,pe)=>q(ce,pe,fe.source)),X}async getCompatibleExtension(U,te,ie){if((0,R.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(U,te,ie))return U;const fe=new c().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:ve}=await this.queryGalleryExtensions(fe,{targetPlatform:ie,compatible:!0,includePreRelease:te},t.CancellationToken.None);return ve[0]||null}async isExtensionCompatible(U,te,ie){if(!(0,R.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,ie)||!te&&U.properties.isPreReleaseVersion)return!1;let fe=U.properties.engine;if(!fe){const ve=await this.getManifest(U,t.CancellationToken.None);if(!ve)throw new Error("Manifest was not found");fe=ve.engines.vscode}return(0,w.isEngineValid)(fe,this.productService.version,this.productService.date)}async isValidVersion(U,te,ie,fe,ve){if(!(0,R.isTargetPlatformCompatible)(j(U),fe,ve)||te!=="any"&&Y(U)!==(te==="prerelease"))return!1;if(ie)try{const z=await this.getEngine(U);if(!(0,w.isEngineValid)(z,this.productService.version,this.productService.date))return!1}catch(z){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,D.getErrorMessage)(z)),!1}return!0}async query(U,te){let ie=U.text||"";const fe=U.pageSize??50;let ve=new c().withPage(1,fe);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,x,X)=>(ve=ve.withFilter(n.Category,X||x),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,x,X)=>(ve=ve.withFilter(n.Tag,X||x),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(ve=ve.withFilter(n.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),ve=ve.withFilter(n.SearchText,ie)),ve=ve.withSortBy(0)):U.ids?ve=ve.withFilter(n.ExtensionId,...U.ids):U.names?ve=ve.withFilter(n.ExtensionName,...U.names):ve=ve.withSortBy(4),typeof U.sortBy=="number"&&(ve=ve.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(ve=ve.withSortOrder(U.sortOrder)),U.source&&(ve=ve.withSource(U.source));const z=async(V,x)=>{const{extensions:X,total:ce}=await this.queryGalleryExtensions(V,{targetPlatform:h,compatible:!1,includePreRelease:!!U.includePreRelease},x);return X.forEach((pe,ke)=>q(pe,(V.pageNumber-1)*V.pageSize+ke,U.source)),{extensions:X,total:ce}},{extensions:Q,total:J}=await z(ve,te),W=async(V,x)=>{if(x.isCancellationRequested)throw new D.CancellationError;const{extensions:X}=await z(ve.withPage(V+1),x);return X};return{firstPage:Q,total:J,pageSize:ve.pageSize,getPage:W}}async queryGalleryExtensions(U,te,ie){const fe=U.flags;!!(U.flags&i.IncludeLatestVersionOnly)&&!!(U.flags&i.IncludeVersions)&&(U=U.withFlags(U.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(U.flags&i.IncludeLatestVersionOnly)&&!(U.flags&i.IncludeVersions)&&(U=U.withFlags(U.flags,i.IncludeLatestVersionOnly)),te.versions?.length&&(U=U.withFlags(U.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),U=U.withFlags(U.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ve,total:z}=await this.queryRawGalleryExtensions(U,ie);if(!(U.flags&i.IncludeLatestVersionOnly)){const V=[];for(const x of ve){const X=await this.toGalleryExtensionWithCriteria(x,te);X&&V.push(X)}return{extensions:V,total:z}}const J=[],W=new Map;for(let V=0;V<ve.length;V++){const x=ve[V],X={id:(0,S.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},ce=(0,C.isBoolean)(te.includePreRelease)?te.includePreRelease:!!te.includePreRelease.find(ke=>(0,S.areSameExtensions)(ke,X))?.includePreRelease;if(te.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(L(x),te.targetPlatform))continue;const pe=await this.toGalleryExtensionWithCriteria(x,te);!pe||pe.properties.isPreReleaseVersion&&(!ce||!pe.hasReleaseVersion)||!pe.properties.isPreReleaseVersion&&pe.properties.targetPlatform!==te.targetPlatform&&pe.hasPreReleaseVersion?W.set(x.extensionId,V):J.push([V,pe])}if(W.size){const V=new Date().getTime(),x=new c().withFlags(fe&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,W.size).withFilter(n.ExtensionId,...W.keys()),{extensions:X}=await this.queryGalleryExtensions(x,te,ie);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-V,count:W.size});for(const ce of X){const pe=W.get(ce.identifier.uuid);J.push([pe,ce])}}return{extensions:J.sort((V,x)=>V[0]-x[0]).map(([,V])=>V),total:z}}async toGalleryExtensionWithCriteria(U,te){const ie={id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},fe=te.versions?.find(J=>(0,S.areSameExtensions)(J,ie))?.version,ve=(0,C.isBoolean)(te.includePreRelease)?te.includePreRelease:!!te.includePreRelease.find(J=>(0,S.areSameExtensions)(J,ie))?.includePreRelease,z=L(U),Q=N(U.versions,te.targetPlatform);if(te.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(z,te.targetPlatform))return null;for(let J=0;J<Q.length;J++){const W=Q[J];if(!(fe&&W.version!==fe)){if(await this.isValidVersion(W,ve?"any":"release",te.compatible,z,te.targetPlatform))return se(U,W,z);if(fe&&W.version===fe)return null}}return fe||te.compatible?null:se(U,U.versions[0],z)}async queryRawGalleryExtensions(U,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,r(i.Unpublished));const ie=await this.commonHeadersPromise,fe=JSON.stringify(U.raw),ve={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(fe.length)},z=new Date().getTime();let Q,J,W=0;try{if(Q=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&U.criteria.some(x=>x.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:fe,headers:ve},te),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:W};const V=await(0,m.asJson)(Q);if(V){const x=V.results[0],X=x.extensions,ce=x.resultMetadata&&x.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return W=ce&&ce.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:X,total:W}}return{galleryExtensions:[],total:W}}catch(V){throw J=V,V}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(fe.length),duration:new Date().getTime()-z,success:!!Q&&(0,m.isSuccess)(Q),responseBodySize:Q?.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:J?(0,D.isCancellationError)(J)?"canceled":(0,D.getErrorMessage)(J).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(W)})}}async reportStatistic(U,te,ie,fe){if(!this.isEnabled())return;const ve=I.isWeb?this.api(`/itemName/${U}.${te}/version/${ie}/statType/${fe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${te}/${ie}/stats?statType=${fe}`),z=I.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",J={...await this.commonHeadersPromise,Accept:z};try{await this.requestService.request({type:"POST",url:ve,headers:J},t.CancellationToken.None)}catch{}}async download(U,te,ie){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const fe=(0,S.getGalleryExtensionTelemetryData)(U),ve=new Date().getTime(),z=V=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...fe,duration:V}),Q=ie===2?"install":ie===3?"update":"",J=Q?{uri:`${U.assets.download.uri}${E.URI.parse(U.assets.download.uri).query?"&":"?"}${Q}=true`,fallbackUri:`${U.assets.download.fallbackUri}${E.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${Q}=true`}:U.assets.download,W=await this.getAsset(J);await this.fileService.writeFile(te,W.stream),z(new Date().getTime()-ve)}async downloadSignatureArchive(U,te){if(!U.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const ie=await this.getAsset(U.assets.signature);await this.fileService.writeFile(te,ie.stream)}async getReadme(U,te){if(U.assets.readme){const ie=await this.getAsset(U.assets.readme,{},te);return await(0,m.asTextOrError)(ie)||""}return""}async getManifest(U,te){if(U.assets.manifest){const ie=await this.getAsset(U.assets.manifest,{},te),fe=await(0,m.asTextOrError)(ie);return fe?JSON.parse(fe):null}return null}async getManifestFromRawExtensionVersion(U,te){const ie=le(U,s.Manifest);if(!ie)throw new Error("Manifest was not found");const fe={"Accept-Encoding":"gzip"},ve=await this.getAsset(ie,{headers:fe});return await(0,m.asJson)(ve)}async getCoreTranslation(U,te){const ie=U.assets.coreTranslations.filter(fe=>fe[0]===te.toUpperCase())[0];if(ie){const fe=await this.getAsset(ie[1]),ve=await(0,m.asTextOrError)(fe);return ve?JSON.parse(ve):null}return null}async getChangelog(U,te){if(U.assets.changelog){const ie=await this.getAsset(U.assets.changelog,{},te);return await(0,m.asTextOrError)(ie)||""}return""}async getAllCompatibleVersions(U,te,ie){let fe=new c().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?fe=fe.withFilter(n.ExtensionId,U.identifier.uuid):fe=fe.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:ve}=await this.queryRawGalleryExtensions(fe,t.CancellationToken.None);if(!ve.length)return[];const z=L(ve[0]);if((0,R.isNotWebExtensionInWebTargetPlatform)(z,ie))return[];const Q=[];await Promise.all(ve[0].versions.map(async V=>{try{await this.isValidVersion(V,te?"any":"release",!0,z,ie)&&Q.push(V)}catch{}}));const J=[],W=new Set;for(const V of N(Q,ie))W.has(V.version)||(W.add(V.version),J.push({version:V.version,date:V.lastUpdated,isPreReleaseVersion:Y(V)}));return J}async getAsset(U,te={},ie=t.CancellationToken.None){const fe=await this.commonHeadersPromise,ve={type:"GET"},z={...fe,...te.headers||{}};te={...te,...ve,headers:z};const Q=U.uri,J=U.fallbackUri,W={...te,url:Q};try{const V=await this.requestService.request(W,ie);if(V.res.statusCode===200)return V;const x=await(0,m.asTextOrError)(V);throw new Error(`Expected 200, got back ${V.res.statusCode} instead.

${x}`)}catch(V){if((0,D.isCancellationError)(V))throw V;const x=(0,D.getErrorMessage)(V);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:x});const X={...te,url:J};return this.requestService.request(X,ie)}}async getEngine(U){let te=F(U);if(!te){const ie=await this.getManifestFromRawExtensionVersion(U,t.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");te=ie.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,m.asJson)(U),ie=[],fe={};if(te){for(const ve of te.malicious)ie.push({id:ve});if(te.migrateToPreRelease)for(const[ve,z]of Object.entries(te.migrateToPreRelease))(!z.engine||(0,w.isEngineValid)(z.engine,this.productService.version,this.productService.date))&&(fe[ve.toLowerCase()]={disallowInstall:!0,extension:{id:z.id,displayName:z.displayName,autoMigrate:{storage:!!z.migrateStorage},preRelease:!0}});if(te.deprecated)for(const[ve,z]of Object.entries(te.deprecated))z&&(fe[ve.toLowerCase()]=(0,C.isBoolean)(z)?{}:z)}return{malicious:ie,deprecated:fe}}};he=Ae([_e(1,m.IRequestService),_e(2,g.ILogService),_e(3,k.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,d.IFileService),_e(6,v.IProductService),_e(7,b.IConfigurationService)],he);let Z=class extends he{constructor(U,te,ie,fe,ve,z,Q,J){super(U,te,ie,fe,ve,z,Q,J)}};Z=Ae([_e(0,u.IStorageService),_e(1,m.IRequestService),_e(2,g.ILogService),_e(3,k.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,d.IFileService),_e(6,v.IProductService),_e(7,b.IConfigurationService)],Z),e.ExtensionGalleryService=Z;let ee=class extends he{constructor(U,te,ie,fe,ve,z,Q){super(void 0,U,te,ie,fe,ve,z,Q)}};ee=Ae([_e(0,m.IRequestService),_e(1,g.ILogService),_e(2,k.IEnvironmentService),_e(3,l.ITelemetryService),_e(4,d.IFileService),_e(5,v.IProductService),_e(6,b.IConfigurationService)],ee),e.ExtensionGalleryServiceWithNoStorageService=ee}),define(we[119],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,y.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(I,P){this._exitInfo.set(I,P)}getExitInfo(I){return this._exitInfo.get(I)||null}}e.ExtensionHostStatusService=t}),define(we[242],ye([1,0,7,14]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function D(P){let C=0,E=0,b=0;P>=1e3&&(b=Math.floor(P/1e3),P-=b*1e3),b>=60&&(E=Math.floor(b/60),b-=E*60),E>=60&&(C=Math.floor(E/60),E-=C*60);const k=C?`${C}h`:"",R=E?`${E}m`:"",S=b?`${b}s`:"",w=P?`${P}ms`:"";return`${k}${R}${S}${w}`}e.printTime=D;class I{constructor(C,E,b,k){this._logService=C,this._reconnectionToken=E,this._onClose=new y.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=b,this.protocol=k,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${D(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${D(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${D(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(C){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${C}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${D(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const C=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),C.end(),this._onClose.fire(void 0)}acceptReconnection(C,E,b){this._remoteAddress=C,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(E,b),this.protocol.endAcceptReconnection()}}e.ManagementConnection=I}),define(we[82],ye([1,0,29,9,6,146,50]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const C=D.join(t.FileAccess.asFileUri("",oe).fsPath,"nls.metadata.json"),E=new Map;function b(d){return new Promise(g=>y.exists(d,g))}function k(d,g){return b(C).then(v=>{if(!v||!P.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const m=`${d}||${g}`;let p=E.get(m);return p||(p=I.getNLSConfiguration(P.default.commit,g,C,d).then(u=>(R.is(u)&&(u._languagePackSupport=!0),u.locale!=="en"&&u.locale!=="en-us"&&Object.keys(u.availableLanguages).length===0&&E.delete(m),u)),E.set(m,p)),p})}e.getNLSConfiguration=k;var R;(function(d){function g(v){const m=v;return m&&typeof m._languagePackId=="string"}d.is=g})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const S=async d=>{try{const g=w(await y.promises.readFile(d,"utf8"));return JSON.parse(g).locale}catch(g){return g.code!=="ENOENT"&&console.warn(g),"en"}};e.getLocaleFromConfig=S;const w=d=>{const g=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return d.replace(g,(v,m,p,u,l)=>{if(u)return"";if(l){const h=l.length;return h>2&&l[h-1]===`
`?l[h-2]==="\r"?`\r
`:`
`:""}else return v})}}),define(we[120],ye([1,0,19,4,28,52,54,35,17,5,12,25,37,82]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends P.AbstractExtensionsScannerService{constructor(v,m,p,u,l,h,i){super(t.URI.file(l.builtinExtensionsPath),t.URI.file(l.extensionsPath),(0,y.joinPath)(l.userHome,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(t.URI.file(l.userDataPath),C.MANIFEST_CACHE_FOLDER),v,m,p,u,l,h,i),this.nativeEnvironmentService=l}async getTranslations(v){const m=await(0,w.getNLSConfiguration)(v,this.nativeEnvironmentService.userDataPath);if(w.InternalNLSConfiguration.is(m))try{const p=await this.fileService.readFile(t.URI.file(m._translationsConfigFile));return JSON.parse(p.value.toString())}catch{}return Object.create(null)}};d=Ae([_e(0,S.IUserDataProfilesService),_e(1,I.IExtensionsProfileScannerService),_e(2,E.IFileService),_e(3,k.ILogService),_e(4,D.INativeEnvironmentService),_e(5,R.IProductService),_e(6,b.IInstantiationService)],d),e.ExtensionsScannerService=d}),define(we[243],ye([1,0,244,29,6,22,9,21]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const E=/^[0-9A-Za-z-]+$/;var b;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(b=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class k{constructor(){this.type=0}validate(p){return!0}}e.NoneServerConnectionToken=k;class R{constructor(p){this.value=p,this.type=1}validate(p){return p===this.value}}e.OptionalServerConnectionToken=R;class S{constructor(p){this.value=p,this.type=2}validate(p){return p===this.value}}e.MandatoryServerConnectionToken=S;class w{constructor(p){this.message=p}}e.ServerConnectionTokenParseError=w;async function d(m,p){const u=m["without-connection-token"],l=m["connection-token"],h=m["connection-token-file"],i=m.compatibility==="1.63";if(u)return typeof l<"u"||typeof h<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new k;if(typeof h<"u"){if(typeof l<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let r;try{r=t.readFileSync(h).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${h}'.`)}return E.test(r)?new S(r):new w(`The connection token defined in '${h} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof l<"u"?E.test(l)?i?new R(l):new S(l):new w(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):i?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await p())):new S(await p())}e.parseServerConnectionToken=d;async function g(m){return d(m,async()=>{if(!m["user-data-dir"])return(0,I.generateUuid)();const u=D.join(m["user-data-dir"],"token");try{const i=(await C.Promises.readFile(u)).toString().replace(/\r?\n$/,"");if(E.test(i))return i}catch{}const l=(0,I.generateUuid)();try{await C.Promises.writeFile(u,l,{mode:384})}catch{}return l})}e.determineServerConnectionToken=g;function v(m,p,u){if(m.validate(u.query[P.connectionTokenQueryName]))return!0;const l=y.parse(p.headers.cookie||"");return m.validate(l[P.connectionTokenCookieName])}e.requestHasValidConnectionToken=v}),define(we[40],ye([1,0,184,193,59,5,28]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":D.OPTIONS["user-data-dir"],"enable-smoke-test-driver":D.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":D.OPTIONS["disable-telemetry"],"disable-workspace-trust":D.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:D.OPTIONS.log,logsPath:D.OPTIONS.logsPath,"force-disable-user-env":D.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":D.OPTIONS["extensions-dir"],"extensions-download-dir":D.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":D.OPTIONS["builtin-extensions-dir"],"install-extension":D.OPTIONS["install-extension"],"install-builtin-extension":D.OPTIONS["install-builtin-extension"],"uninstall-extension":D.OPTIONS["uninstall-extension"],"list-extensions":D.OPTIONS["list-extensions"],"locate-extension":D.OPTIONS["locate-extension"],"show-versions":D.OPTIONS["show-versions"],category:D.OPTIONS.category,force:D.OPTIONS.force,"do-not-sync":D.OPTIONS["do-not-sync"],"pre-release":D.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:D.OPTIONS.help,version:D.OPTIONS.version,"locate-shell-integration-path":D.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:D.OPTIONS._},e.IServerEnvironmentService=(0,I.refineServiceDecorator)(P.IEnvironmentService);class C extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=C}),define(we[245],ye([1,0,73,12,40,25,207,22,18]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let b=class extends P.BaseCredentialsMainService{constructor(R,S,w){super(R),this.environmentMainService=S,this.productService=w,this.environmentMainService.args["github-auth"]&&this.storeGitHubToken(this.environmentMainService.args["github-auth"]).catch(d=>{this.logService.error("Failed to store provided GitHub token",d)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new y.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((R,S)=>{oe(["keytar"],R,S)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(R){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${R.message??R}`),this._keytarCache=new y.InMemoryCredentialsProvider}return this._keytarCache}async storeGitHubToken(R){const S="vscode.github-authentication",w=`${await this.getSecretStoragePrefix()}${S}`,d="github.auth",v=[["read:user","user:email","repo"]].map(u=>({id:(0,C.generateUuid)(),scopes:u.sort(),accessToken:R})),m=await this.getPassword(w,d);let p;if(m)try{const u=JSON.parse(m);u.content=JSON.parse(u.content),p=u}catch(u){this.logService.error("Failed to parse existing GitHub credentials",u)}return p?.content&&(p.content=p.content.filter(u=>{const l=u.scopes.sort();return!v.find(h=>(0,E.equals)(l,h.scopes)&&h.account?.label===u.account?.label)})),this.setPassword(w,d,JSON.stringify({extensionId:S,...p||{},content:JSON.stringify([...v,...p?.content||[]])}))}};b=Ae([_e(0,t.ILogService),_e(1,D.IServerEnvironmentService),_e(2,I.IProductService)],b),e.CredentialsWebMainService=b}),define(we[246],ye([1,0,276,228,247,27]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class P extends y.AppInsightsCore{constructor(E){super(),this.endpoint=E}track(E){const b=E.baseData||{};b.properties||(b.properties={}),b.measurements||(b.measurements={});try{const k=I.cpus();b.measurements.cores=k.length,b.properties["common.cpuModel"]=k[0].model}catch{}try{b.measurements.memoryFree=I.freemem(),b.measurements.memoryTotal=I.totalmem()}catch{}try{b.properties["common.shell"]=I.userInfo().shell,b.properties["common.release"]=I.release(),b.properties["common.arch"]=I.arch()}catch{}try{const k=(/^http:/.test(this.endpoint)?D:t).request(this.endpoint,{method:"POST",headers:{"Content-Type":"application/json"}});k.on("error",()=>{}),k.write(JSON.stringify(b)),k.end()}catch{}}}e.TelemetryClient=P}),define(we[248],ye([1,0,29,92,79,244,113,36,68,3,12,40,6,9,22,25,53,20,4,16,13,82,78]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const r={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(re,le,ae,F){le.writeHead(ae,{"Content-Type":"text/plain"}),le.end(F)}e.serveError=n;var s;(function(re){re[re.NO_CACHING=0]="NO_CACHING",re[re.ETAG=1]="ETAG",re[re.NO_EXPIRY=2]="NO_EXPIRY"})(s=e.CacheControl||(e.CacheControl={}));async function a(re,le,ae,F,Y,B){try{const H=await y.promises.stat(re);if(le===1){const $=`W/"${[H.ino,H.size,H.mtime.getTime()].join("-")}"`;if(F.headers["if-none-match"]===$)return Y.writeHead(304),void Y.end();B.Etag=$}else le===2?B["Cache-Control"]="public, max-age=31536000":le===0&&(B["Cache-Control"]="no-store");B["Content-Type"]=r[(0,S.extname)(re)]||(0,E.getMediaMime)(re)||"text/plain",Y.writeHead(200,B),(0,y.createReadStream)(re).pipe(Y)}catch(H){return H.code!=="ENOENT"?(ae.error(H),console.error(H.toString())):console.error(`File not found: ${re}`),Y.writeHead(404,{"Content-Type":"text/plain"}),void Y.end("Not found")}}e.serveFile=a;const f=(0,S.dirname)(w.FileAccess.asFileUri("",oe).fsPath);let o=class{constructor(le,ae,F,Y,B){this._connectionToken=le,this._environmentService=ae,this._logService=F,this._requestService=Y,this._productService=B,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?p.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const H=(0,i.getRemoteServerRootPath)(B);this._staticRoute=`${H}/static`,this._callbackRoute=`${H}/callback`,this._webExtensionRoute="/web-extension-resource"}async handle(le,ae,F){try{const Y=F.pathname;return Y.startsWith(this._staticRoute)&&Y.charCodeAt(this._staticRoute.length)===47?this._handleStatic(le,ae,F):Y==="/"?this._handleRoot(le,ae,F):Y===this._callbackRoute?this._handleCallback(ae):Y.startsWith(this._webExtensionRoute)&&Y.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(le,ae,F):n(le,ae,404,"Not found.")}catch(Y){return this._logService.error(Y),console.error(Y.toString()),n(le,ae,500,"Internal Server Error.")}}async _handleStatic(le,ae,F){const Y=Object.create(null),H=decodeURIComponent(F.pathname).substring(this._staticRoute.length+1),$=(0,S.join)(f,H);return(0,C.isEqualOrParent)($,f,!b.isLinux)?a($,this._environmentService.isBuilt?2:1,this._logService,le,ae,Y):n(le,ae,400,"Bad request.")}_getResourceURLTemplateAuthority(le){const ae=le.authority.indexOf(".");return ae!==-1?le.authority.substring(ae+1):void 0}async _handleWebExtensionResource(le,ae,F){if(!this._webExtensionResourceUrlTemplate)return n(le,ae,500,"No extension gallery service configured.");const Y=decodeURIComponent(F.pathname),B=(0,S.normalize)(Y.substring(this._webExtensionRoute.length+1)),H=p.URI.parse(B).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:B.substring(0,B.indexOf("/")),path:B.substring(B.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(H))return n(le,ae,403,"Request Forbidden");const $={},j=Z=>{const ee=le.headers[Z];ee&&((0,l.isString)(ee)||ee[0])?$[Z]=(0,l.isString)(ee)?ee:ee[0]:Z!==Z.toLowerCase()&&j(Z.toLowerCase())};j("X-Client-Name"),j("X-Client-Version"),j("X-Machine-Id"),j("X-Client-Commit");const L=await this._requestService.request({type:"GET",url:H.toString(!0),headers:$},m.CancellationToken.None),N=L.res.statusCode||500;if(N!==200){let Z=null;try{Z=await(0,v.asTextOrError)(L)}catch{}return n(le,ae,N,Z||`Request failed with status ${N}`)}const q=Object.create(null),se=Z=>{const ee=L.res.headers[Z];ee?q[Z]=ee:Z!==Z.toLowerCase()&&se(Z.toLowerCase())};se("Cache-Control"),se("Content-Type"),ae.writeHead(200,q);const he=await(0,u.streamToBuffer)(L.stream);return void ae.end(he.buffer)}async _handleRoot(le,ae,F){const Y=F.query[w.connectionTokenQueryName];if(typeof Y=="string"){const ve=Object.create(null);ve["Set-Cookie"]=I.serialize(w.connectionTokenCookieName,Y,{sameSite:"lax",maxAge:60*60*24*7});const z=Object.create(null);for(const J in F.query)J!==w.connectionTokenQueryName&&(z[J]=F.query[J]);const Q=D.format({pathname:"/",query:z});return ve.Location=Q,ae.writeHead(302,ve),void ae.end()}const B="remote";if(!B)return n(le,ae,400,"Bad request.");function H(ve){return JSON.stringify(ve).replace(/"/g,"&quot;")}let $;this._environmentService.args["enable-smoke-test-driver"]&&($=!1);const j=ve=>ve&&p.URI.file(t.resolve(ve)).with({scheme:w.Schemas.vscodeRemote,authority:B}),L=w.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",oe).fsPath,N=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,d.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,q=(0,e.relativeRoot)((0,e.getOriginalUrl)(le)),se=(0,e.relativePath)((0,e.getOriginalUrl)(le)),he=this._environmentService.args.locale||await(0,h.getLocaleFromConfig)(this._environmentService.argvResource.fsPath),Z=await(0,h.getNLSConfiguration)(he,this._environmentService.userDataPath),ee={remoteAuthority:B,webviewEndpoint:se+this._staticRoute+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this._environmentService.userDataPath,isEnabledFileDownloads:!this._environmentService.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this._environmentService.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:$,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this._logService.getLevel()},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:j(this._environmentService.args["default-folder"]),workspaceUri:j(this._environmentService.args["default-workspace"]),productConfiguration:{codeServerVersion:this._productService.codeServerVersion,rootEndpoint:q,updateEndpoint:this._environmentService.args["disable-update-check"]?void 0:q+"/update/check",logoutEndpoint:this._environmentService.args.auth&&this._environmentService.args.auth!=="none"?q+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??q+"/proxy/{{port}}/",serviceWorker:{scope:se+"/",path:q+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this._productService.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this._productService.extensionsGallery},callbackRoute:this._callbackRoute},_=this._productService.extensionsGallery?.nlsBaseUrl,U={WORKBENCH_WEB_CONFIGURATION:H(ee),WORKBENCH_AUTH_SESSION:N?H(N):"",WORKBENCH_WEB_BASE_URL:se+this._staticRoute,WORKBENCH_NLS_BASE_URL:se+(_?`${_}${_.endsWith("/")?"":"/"}${this._productService.commit}/${this._productService.version}/`:""),BASE:q,VS_BASE:se,NLS_CONFIGURATION:H(Z)};let te;try{te=(await y.promises.readFile(L)).toString().replace(/\{\{([^}]+)\}\}/g,(z,Q)=>U[Q]??"undefined")}catch{return ae.writeHead(404,{"Content-Type":"text/plain"}),void ae.end("Not found")}const ie=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(te).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),fe={"Content-Type":"text/html","Content-Security-Policy":ie};return this._connectionToken.type!==0&&(fe["Set-Cookie"]=I.serialize(w.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),ae.writeHead(200,fe),void ae.end(te)}_getScriptCspHashes(le){const ae=/<script>([\s\S]+?)<\/script>/img,F=[];let Y;for(;Y=ae.exec(le);){const B=P.createHash("sha256"),H=Y[1].replace(/\r\n/g,`
`),$=B.update(Buffer.from(H)).digest().toString("base64");F.push(`'sha256-${$}'`)}return F}async _handleCallback(le){const ae=w.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",oe).fsPath,F=(await y.promises.readFile(ae)).toString(),Y=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(F).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return le.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":Y}),void le.end(F)}};o=Ae([_e(1,R.IServerEnvironmentService),_e(2,k.ILogService),_e(3,v.IRequestService),_e(4,g.IProductService)],o),e.WebClientServer=o;const c=(re,le=!1)=>re.replace(/\/\/+/g,"/").replace(/\/+$/,le?"/":"");e.normalizeUrlPath=c;const T=re=>{const le=(re.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(le>1?"../".repeat(le-1):""))};e.relativeRoot=T;const O=re=>{const le=re.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+le[le.length-1])};e.relativePath=O;const K=re=>re.originalUrl||re.url;e.getOriginalUrl=K}),define(we[249],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,y.createDecorator)("IExtHostRpcService");class t{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=t}),define(we[64],ye([1,0,71]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(I){return{transformIncoming:P=>P.scheme==="vscode-remote"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="file"?{scheme:"vscode-local",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoing:P=>P.scheme==="file"?{scheme:"vscode-remote",authority:I,path:P.path,query:P.query,fragment:P.fragment}:P.scheme==="vscode-local"?{scheme:"file",path:P.path,query:P.query,fragment:P.fragment}:P,transformOutgoingScheme:P=>P==="file"?"vscode-remote":P==="vscode-local"?"file":P}}function D(I){return new y.URITransformer(t(I))}e.createURITransformer=D}),define(we[250],ye([1,0,4,64,62,6,209]),function(oe,e,y,t,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class C extends P.AbstractDiskFileSystemProviderChannel{constructor(k,R){super(new D.DiskFileSystemProvider(k),k),this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(k){let R=this.uriTransformerCache.get(k.remoteAuthority);return R||(R=(0,t.createURITransformer)(k.remoteAuthority),this.uriTransformerCache.set(k.remoteAuthority,R)),R}transformIncoming(k,R,S=!1){if(S&&R.path==="/vscode-resource"&&R.query){const w=JSON.parse(R.query).requestResourcePath;return y.URI.from({scheme:"file",path:w})}return y.URI.revive(k.transformIncoming(R))}createSessionFileWatcher(k,R){return new E(k,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=C;class E extends P.AbstractSessionFileWatcher{constructor(k,R,S,w){super(k,R,S,w)}getRecursiveWatcherOptions(k){const R=k.args["file-watcher-polling"];if(R){const S=R.split(I.delimiter),w=Number(S[0]);if(w>0)return{usePolling:S.length>1?S.slice(1):!0,pollingInterval:w}}}getExtraExcludes(k){if(k.extensionsPath)return[I.posix.join(k.extensionsPath,"**")]}}}),define(we[83],ye([1,0,185,13,4,2,5,34,17,9]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(L){L[L.PROGRAMMATIC=1]="PROGRAMMATIC",L[L.USER=2]="USER",L[L.EDIT=3]="EDIT",L[L.NAVIGATION=4]="NAVIGATION",L[L.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var R;(function(L){L[L.IDENTICAL=1]="IDENTICAL",L[L.SIMILAR=2]="SIMILAR",L[L.DIFFERENT=3]="DIFFERENT"})(R=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function S(L){const N=L;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}e.isEditorPaneWithSelection=S;function w(L,N,q){for(const se of q.visibleEditorPanes)if(se.group.id===N&&L.matches(se.input))return se.getViewState()}e.findViewStateForEditor=w;function d(L){if(a(L))return!1;const N=L;return D.URI.isUri(N?.resource)}e.isResourceEditorInput=d;function g(L){if(a(L))return!1;const N=L;return N?.original!==void 0&&N.modified!==void 0}e.isResourceDiffEditorInput=g;function v(L){if(a(L)||g(L))return!1;const N=L;return N?.primary!==void 0&&N.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function m(L){if(a(L))return!1;const N=L;return N?N.resource===void 0||N.resource.scheme===b.Schemas.untitled||N.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;const p=/Untitled-\d+/;function u(L){return L.scheme===b.Schemas.untitled&&L.path.length>1&&!p.test(L.path)}e.isUntitledWithAssociatedResource=u;function l(L){if(a(L))return!1;const N=L;return D.URI.isUri(N?.base?.resource)&&D.URI.isUri(N?.input1?.resource)&&D.URI.isUri(N?.input2?.resource)&&D.URI.isUri(N?.result?.resource)}e.isResourceMergeEditorInput=l;var h;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(h=e.Verbosity||(e.Verbosity={}));var i;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(N,q){let se=this.mapIdToSaveSource.get(N);return se||(se={source:N,label:q},this.mapIdToSaveSource.set(N,se)),se.source}getSourceLabel(N){return this.mapIdToSaveSource.get(N)?.label??N}}e.SaveSourceRegistry=new r;var n;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription",L[L.CanDropIntoEditor=128]="CanDropIntoEditor",L[L.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends I.Disposable{}e.AbstractEditorInput=s;function a(L){return L instanceof s}e.isEditorInput=a;function f(L){const N=L;return D.URI.isUri(N?.preferredResource)}function o(L){const N=L;return a(N?.primary)&&a(N?.secondary)}e.isSideBySideEditorInput=o;function c(L){const N=L;return a(N?.modified)&&a(N?.original)}e.isDiffEditorInput=c;function T(L){return a(L?.editor)}e.isEditorInputWithOptions=T;function O(L){const N=L;return T(L)&&N?.group!==void 0}e.isEditorInputWithOptionsAndGroup=O;function K(L){const N=L;return typeof N?.groupId=="number"&&a(N.editor)}e.isEditorIdentifier=K;var re;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(re=e.EditorCloseContext||(e.EditorCloseContext={}));var le;(function(L){L[L.GROUP_ACTIVE=0]="GROUP_ACTIVE",L[L.GROUP_INDEX=1]="GROUP_INDEX",L[L.GROUP_LOCKED=2]="GROUP_LOCKED",L[L.EDITOR_OPEN=3]="EDITOR_OPEN",L[L.EDITOR_CLOSE=4]="EDITOR_CLOSE",L[L.EDITOR_MOVE=5]="EDITOR_MOVE",L[L.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",L[L.EDITOR_LABEL=7]="EDITOR_LABEL",L[L.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",L[L.EDITOR_PIN=9]="EDITOR_PIN",L[L.EDITOR_STICKY=10]="EDITOR_STICKY",L[L.EDITOR_DIRTY=11]="EDITOR_DIRTY",L[L.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(le=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var ae;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(ae=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(N,q){if(!N)return;if(l(N))return e.EditorResourceAccessor.getOriginalUri(N.result,q);if(q?.supportSideBySide){const{primary:he,secondary:Z}=this.getSideEditors(N);if(he&&Z){if(q?.supportSideBySide===ae.BOTH)return{primary:this.getOriginalUri(he,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(Z,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===ae.ANY)return this.getOriginalUri(he,{filterByScheme:q.filterByScheme})??this.getOriginalUri(Z,{filterByScheme:q.filterByScheme});N=q.supportSideBySide===ae.PRIMARY?he:Z}}if(g(N)||v(N)||l(N))return;const se=f(N)?N.preferredResource:N.resource;return!se||!q||!q.filterByScheme?se:this.filterUri(se,q.filterByScheme)}getSideEditors(N){return o(N)||v(N)?{primary:N.primary,secondary:N.secondary}:c(N)||g(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,q){if(!N)return;if(l(N))return e.EditorResourceAccessor.getCanonicalUri(N.result,q);if(q?.supportSideBySide){const{primary:he,secondary:Z}=this.getSideEditors(N);if(he&&Z){if(q?.supportSideBySide===ae.BOTH)return{primary:this.getCanonicalUri(he,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(Z,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===ae.ANY)return this.getCanonicalUri(he,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(Z,{filterByScheme:q.filterByScheme});N=q.supportSideBySide===ae.PRIMARY?he:Z}}if(g(N)||v(N)||l(N))return;const se=N.resource;return!se||!q||!q.filterByScheme?se:this.filterUri(se,q.filterByScheme)}filterUri(N,q){if(Array.isArray(q)){if(q.some(se=>N.scheme===se))return N}else if(q===N.scheme)return N}}e.EditorResourceAccessor=new F;var Y;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(Y=e.CloseDirection||(e.CloseDirection={}));class B{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(N){const q=this.instantiationService=N.get(P.IInstantiationService);for(const[se,he]of this.editorSerializerConstructors)this.createEditorSerializer(se,he,q);this.editorSerializerConstructors.clear()}createEditorSerializer(N,q,se){const he=se.createInstance(q);this.editorSerializerInstances.set(N,he)}registerFileEditorFactory(N){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=N}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(N,q){if(this.editorSerializerConstructors.has(N)||this.editorSerializerInstances.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.instantiationService?this.createEditorSerializer(N,q,this.instantiationService):this.editorSerializerConstructors.set(N,q),(0,I.toDisposable)(()=>{this.editorSerializerConstructors.delete(N),this.editorSerializerInstances.delete(N)})}getEditorSerializer(N){return this.editorSerializerInstances.get(typeof N=="string"?N:N.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new B);async function H(L,N,q){return!L||!L.length?[]:await Promise.all(L.map(async se=>{const he=D.URI.revive(se.fileUri);if(!he){q.info("Cannot resolve the path because it is not valid.",se);return}if(!await N.canHandleResource(he)){q.info("Cannot resolve the path because it cannot be handled",se);return}let ee=se.exists,_=se.type;if(typeof ee!="boolean"||typeof _!="number")try{_=(await N.stat(he)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ee=!0}catch(te){q.error(te),ee=!1}if(!ee&&se.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",se);return}if(_===E.FileType.Directory){q.info("Cannot resolve the path because it is a directory",se);return}const U={...se.options,pinned:!0};return ee?{resource:he,options:U}:{resource:he,options:U,forceUntitled:!0}}))}e.pathsToEditors=H;var $;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}));function j(L){const N=L;if(!N)return!1;const q=N;if(q.modified)return j(q.modified);const se=N;return!!(se.contributionsState&&se.viewState&&Array.isArray(se.cursorState))}e.isTextEditorViewState=j}),define(we[121],ye([1,0,16,70,55,68,9,6,3,102]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var k;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(H){H[H.Running=1]="Running",H[H.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(H){H[H.Unconfirmed=1]="Unconfirmed",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var w;(function(H){H[H.WithHardKernelDependency=0]="WithHardKernelDependency",H[H.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",H[H.Pure=2]="Pure",H[H.Never=3]="Never"})(w=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(H){H.Always="always",H.Never="never",H.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(H){H[H.ModelChange=1]="ModelChange",H[H.Move=2]="Move",H[H.ChangeCellLanguage=5]="ChangeCellLanguage",H[H.Initialize=6]="Initialize",H[H.ChangeCellMetadata=7]="ChangeCellMetadata",H[H.Output=8]="Output",H[H.OutputItem=9]="OutputItem",H[H.ChangeCellContent=10]="ChangeCellContent",H[H.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",H[H.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",H[H.ChangeCellMime=13]="ChangeCellMime",H[H.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(H){H[H.Handle=0]="Handle",H[H.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(H){H[H.Replace=1]="Replace",H[H.Output=2]="Output",H[H.Metadata=3]="Metadata",H[H.CellLanguage=4]="CellLanguage",H[H.DocumentMetadata=5]="DocumentMetadata",H[H.Move=6]="Move",H[H.OutputItems=7]="OutputItems",H[H.PartialMetadata=8]="PartialMetadata",H[H.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var p;(function(H){H.scheme=P.Schemas.vscodeNotebookCell;const $=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${$.join("")}]+`),L=7;function N(_,U){const te=U.toString(L),fe=`${te.length<$.length?$[te.length-1]:"z"}${te}s${(0,y.encodeBase64)(y.VSBuffer.fromString(_.scheme),!0,!0)}`;return _.with({scheme:H.scheme,fragment:fe})}H.generate=N;function q(_){if(_.scheme!==H.scheme)return;const U=_.fragment.indexOf("s");if(U<0)return;const te=parseInt(_.fragment.substring(0,U).replace(j,""),L),ie=(0,y.decodeBase64)(_.fragment.substring(U+1)).toString();if(!isNaN(te))return{handle:te,notebook:_.with({scheme:ie,fragment:null})}}H.parse=q;function se(_,U){return _.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${U??""},${_.scheme!==P.Schemas.file?_.scheme:""}`})}H.generateCellOutputUri=se;function he(_){if(_.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const U=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!U)return;const te=U[1]&&U[1]!==""?U[1]:void 0,ie=U[2];return{outputId:te,notebook:_.with({scheme:ie||P.Schemas.file,fragment:null})}}H.parseCellOutputUri=he;function Z(_,U,te){return H.generate(_,U).with({scheme:te})}H.generateCellPropertyUri=Z;function ee(_,U){if(_.scheme===U)return H.parse(_.with({scheme:H.scheme}))}H.parseCellPropertyUri=ee})(p=e.CellUri||(e.CellUri={}));const u=H=>E.isWindows?H.replace(/\//g,"\\"):H;class l{constructor($=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=j,this.order=[...new Set($)].map(L=>({pattern:L,matches:t.parse(u(L))}))}sort($){const j=new Map(D.Iterable.map($,N=>[N,u(N)]));let L=[];for(const{matches:N}of this.order)for(const[q,se]of j)if(N(se)){L.push(q),j.delete(q);break}return j.size&&(L=L.concat([...j.keys()].sort((N,q)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(q)))),L}prioritize($,j){const L=this.findIndex($);if(L===-1){this.order.unshift({pattern:$,matches:t.parse(u($))});return}const N=new Set(j.map(se=>this.findIndex(se,L)));N.delete(-1);const q=Array.from(N).sort();this.order.splice(L+1,0,...q.map(se=>this.order[se]));for(let se=q.length-1;se>=0;se--)this.order.splice(q[se],1)}toArray(){return this.order.map($=>$.pattern)}findIndex($,j=this.order.length){const L=u($);for(let N=0;N<j;N++)if(this.order[N].matches(L))return N;return-1}}e.MimeTypeDisplayOrder=l;function h(H,$,j,L=(N,q)=>N===q){const N=[];function q(Z,ee,_){if(ee===0&&_.length===0)return;const U=N[N.length-1];U&&U.start+U.deleteCount===Z?(U.deleteCount+=ee,U.toInsert.push(..._)):N.push({start:Z,deleteCount:ee,toInsert:_})}let se=0,he=0;for(;;){if(se===H.length){q(se,0,$.slice(he));break}if(he===$.length){q(se,H.length-se,[]);break}const Z=H[se],ee=$[he];if(L(Z,ee)){se+=1,he+=1;continue}j(ee)?(q(se,1,[]),se+=1):(q(se,0,[ee]),he+=1)}return N}e.diff=h,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(H){H.default="default",H.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(H){const $=H;return!!((typeof $.include=="string"||t.isRelativePattern($.include))&&(typeof $.exclude=="string"||t.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=r;function n(H,$,j){if(Array.isArray(H.viewType)&&H.viewType.indexOf($)>=0||H.viewType===$)return!0;if(H.filenamePattern){const L=r(H.filenamePattern)?H.filenamePattern.include:H.filenamePattern,N=r(H.filenamePattern)?H.filenamePattern.exclude:void 0;if(t.match(L,(0,C.basename)(j.fsPath).toLowerCase()))return!(N&&t.match(N,(0,C.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var s;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(s=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create($){return`${a._prefix}${$}`}static parse($){if($.startsWith(a._prefix))return $.substring(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/";function f(H){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(H)}e.isTextStreamMime=f;const o=new TextDecoder;function c(H){const $=[];let j=!1;for(const L of H)($.length===0||j)&&($.push(L),j=!0);return re($),B(y.VSBuffer.concat($.map(L=>y.VSBuffer.wrap(L))))}e.compressOutputItemStreams=c;const T=`${String.fromCharCode(27)}[A`,O=T.split("").map(H=>H.charCodeAt(0)),K=10;function re(H){H.forEach(($,j)=>{if(j===0||$.length<T.length)return;const L=H[j-1],N=$.subarray(0,T.length);if(N[0]===O[0]&&N[1]===O[1]&&N[2]===O[2]){const q=L.lastIndexOf(K);if(q===-1)return;H[j-1]=L.subarray(0,q),H[j]=$.subarray(T.length)}})}function le(H){let $=H;do H=$,$=H.replace(/[^\n]\x08/gm,"");while($.length<H.length);return H}function ae(H){for(H=H.replace(/\r+\n/gm,`
`);H.search(/\r[^$]/g)>-1;){const $=H.match(/^(.*)\r+/m)[1];let j=H.match(/\r+(.*)$/m)[1];j=j+$.slice(j.length,$.length),H=H.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return H}const F="\b".charCodeAt(0),Y="\r".charCodeAt(0);function B(H){return!H.buffer.includes(F)&&!H.buffer.includes(Y)?H:y.VSBuffer.fromString(ae(le(o.decode(H.buffer))))}}),define(we[122],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,y.createDecorator)("environmentVariableService");var t;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(we[251],ye([1,0,3,122]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class D{constructor(E){this.collections=E,this.map=new Map,E.forEach((b,k)=>{const R=b.map.entries();let S=R.next();for(;!S.done;){const w=S.value[0];let d=this.map.get(w);if(d||(d=[],this.map.set(w,d)),d.length>0&&d[0].type===t.EnvironmentVariableMutatorType.Replace){S=R.next();continue}const g=S.value[1];d.unshift({extensionIdentifier:k,value:g.value,type:g.type}),S=R.next()}})}async applyToProcessEnvironment(E,b){let k;y.isWindows&&(k={},Object.keys(E).forEach(R=>k[R.toLowerCase()]=R));for(const[R,S]of this.map){const w=y.isWindows&&k[R.toLowerCase()]||R;for(const d of S){const g=b?await b(d.value):d.value;switch(d.type){case t.EnvironmentVariableMutatorType.Append:E[w]=(E[w]||"")+g;break;case t.EnvironmentVariableMutatorType.Prepend:E[w]=g+(E[w]||"");break;case t.EnvironmentVariableMutatorType.Replace:E[w]=g;break}}}}diff(E){const b=new Map,k=new Map,R=new Map;if(E.map.forEach((S,w)=>{const d=this.map.get(w),g=I(S,d);g&&b.set(w,g)}),this.map.forEach((S,w)=>{const d=E.map.get(w),g=I(S,d);g&&R.set(w,g)}),this.map.forEach((S,w)=>{const d=E.map.get(w),g=P(S,d);g&&k.set(w,g)}),!(b.size===0&&k.size===0&&R.size===0))return{added:b,changed:k,removed:R}}}e.MergedEnvironmentVariableCollection=D;function I(C,E){if(!E)return C;const b=new Set;E.forEach(R=>b.add(R.extensionIdentifier));const k=[];return C.forEach(R=>{b.has(R.extensionIdentifier)||k.push(R)}),k.length===0?void 0:k}function P(C,E){if(!E)return;const b=new Map;E.forEach(R=>b.set(R.extensionIdentifier,R));const k=[];return C.forEach(R=>{const S=b.get(R.extensionIdentifier);S&&(R.type!==S.type||R.value!==S.value)&&k.push(S)}),k.length===0?void 0:k}}),define(we[123],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function y(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=y;function t(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=t;function D(P){return Array.from(P.entries()).map(C=>[C[0],y(C[1].map)])}e.serializeEnvironmentVariableCollections=D;function I(P){return new Map(P.map(C=>[C[0],{map:t(C[1])}]))}e.deserializeEnvironmentVariableCollections=I}),define(we[252],ye([1,0,6,56,3,231]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(l,h){if(!!h)if(D.isWindows)for(const i in h){let r=i;for(const s in l)if(i.toLowerCase()===s.toLowerCase()){r=s;break}const n=h[i];n!==void 0&&C(l,r,n)}else Object.keys(h).forEach(i=>{const r=h[i];r!==void 0&&C(l,i,r)})}e.mergeEnvironments=P;function C(l,h,i){typeof i=="string"?l[h]=i:delete l[h]}function E(l,h,i,r){l.TERM_PROGRAM="vscode",h&&(l.TERM_PROGRAM_VERSION=h),R(l,r)&&(l.LANG=S(i)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=E;function b(l,h){if(!!h)for(const i of Object.keys(h)){const r=h[i];r&&(l[i]=r)}}async function k(l,h){return await Promise.all(Object.entries(h).map(async([i,r])=>{if(typeof r=="string")try{h[i]=await l(r)}catch{h[i]=r}})),h}function R(l,h){if(h==="on")return!0;if(h==="auto"){const i=l.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function S(l){const h=l?l.split("-"):[],i=h.length;if(i===0)return"en_US.UTF-8";if(i===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};h[0]in r&&h.push(r[h[0]])}else h[1]=h[1].toUpperCase();return h.join("_")+".UTF-8"}e.getLangEnvVariable=S;async function w(l,h,i,r,n,s){if(l.cwd){const f=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,o=await d(f,i);return(0,I.sanitizeCwd)(o||f)}let a;return!l.ignoreConfigurationCwd&&n&&(i&&(n=await d(n,i,s)),n&&(y.isAbsolute(n)?a=n:r&&(a=y.join(r.fsPath,n)))),a||(a=r?r.fsPath:h||""),(0,I.sanitizeCwd)(a)}e.getCwd=w;async function d(l,h,i){if(h)try{return await h(l)}catch(r){i?.error("Could not resolve terminal cwd",r);return}return l}function g(l,h,i){if(!!i)return r=>i.resolveWithEnvironment(h,l,r)}e.createVariableResolver=g;async function v(l,h,i,r,n,s,a,f=D.platform){let o;a&&(o=p(l,"automationShell",f)),o||(o=p(l,"shell",f));let c=o||h;if(f===3&&!i&&r){const T=y.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();c&&c.toLowerCase().indexOf(T)===0&&(c=y.join(r,"System32",c.substr(T.length+1)))}if(c&&f===3&&(c=c.replace(/\//g,"\\")),n)try{c=await n(c)}catch(T){s.error("Could not resolve shell",T)}return c}e.getDefaultShell=v;async function m(l,h,i,r,n=D.platform){if(h&&p(l,"automationShell",n))return[];const s=n===3?"windows":n===1?"osx":"linux";let a=l(`terminal.integrated.shellArgs.${s}`);if(!a)return[];if(typeof a=="string"&&n===3)return i?await i(a):a;if(i){const f=[];for(const o of a)try{f.push(await i(o))}catch(c){r.error(`Could not resolve terminal.integrated.shellArgs.${s}`,c),f.push(o)}a=f}return a}e.getDefaultShellArgs=m;function p(l,h,i=D.platform){return l(`terminal.integrated.${h}.${i===3?"windows":i===1?"osx":"linux"}`)}async function u(l,h,i,r,n,s){const a={};if(l.strictEnv)b(a,l.env);else{b(a,s);const f={...h};i&&(f&&await k(i,f),l.env&&await k(i,l.env)),(0,t.sanitizeProcessEnvironment)(a,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),P(a,f),P(a,l.env),E(a,r,D.locale,n)}return a}e.createTerminalEnvironment=u}),define(we[65],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(I){I.Delimiter="\0"})(y=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(P,C,E=P.parent){if(P._isRoot)return new D([C]);const b=[P.id];for(let k=E;k&&k.id!==C;k=k.parent)b.push(k.id);return b.push(C),new D(b.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const C=P.indexOf("\0");return C===-1?P:P.slice(0,C)}static fromString(P){return new D(P.split("\0"))}static join(P,C){return new D([...P.path,C])}static joinToString(P,C){return P.toString()+"\0"+C}static parentId(P){const C=P.lastIndexOf("\0");return C===-1?void 0:P.slice(0,C)}static compare(P,C){return P===C?0:C.startsWith(P+"\0")?2:P.startsWith(C+"\0")?3:1}constructor(P,C=P.length){if(this.path=P,this.viewEnd=C,P.length===0||C<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new D(this.path,P)}*idsToRoot(){for(let P=this.viewEnd;P>0;P--)yield new D(this.path,P)}compare(P){if(typeof P=="string")return D.compare(this.toString(),P);for(let C=0;C<P.viewEnd&&C<this.viewEnd;C++)if(P.path[C]!==this.path[C])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=D}),define(we[84],ye([1,0,4,48,65]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(o){o[o.Unset=0]="Unset",o[o.Queued=1]="Queued",o[o.Running=2]="Running",o[o.Passed=3]="Passed",o[o.Failed=4]="Failed",o[o.Skipped=5]="Skipped",o[o.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var P;(function(o){o[o.Run=2]="Run",o[o.Debug=4]="Debug",o[o.Coverage=8]="Coverage",o[o.HasNonDefaultProfile=16]="HasNonDefaultProfile",o[o.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(o){o.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),o.deserialize=c=>({range:t.Range.lift(c.range),uri:y.URI.revive(c.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var E;(function(o){o[o.Error=0]="Error",o[o.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var b;(function(o){o.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&C.serialize(c.location)}),o.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&C.deserialize(c.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));const k=(o,c)=>`${c?"s":"e"}${o}`;e.getMarkId=k;var R;(function(o){o.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&C.serialize(c.location)}),o.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&C.deserialize(c.location)})})(R=e.ITestOutputMessage||(e.ITestOutputMessage={}));var S;(function(o){o.serialize=c=>c.type===0?b.serialize(c):R.serialize(c),o.deserialize=c=>c.type===0?b.deserialize(c):R.deserialize(c)})(S=e.ITestMessage||(e.ITestMessage={}));var w;(function(o){o.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),o.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(S.serialize)}),o.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(S.deserialize)})})(w=e.ITestTaskState||(e.ITestTaskState={}));const d="\0",g=(o,c)=>o+d+c;e.namespaceTestTag=g;const v=o=>{const c=o.indexOf(d);return{ctrlId:o.slice(0,c),tagId:o.slice(c+1)}};e.denamespaceTestTag=v;var m;(function(o){o.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),o.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?y.URI.revive(c.uri):void 0,range:c.range?t.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(m=e.ITestItem||(e.ITestItem={}));var p;(function(o){o[o.NotExpandable=0]="NotExpandable",o[o.Expandable=1]="Expandable",o[o.BusyExpanding=2]="BusyExpanding",o[o.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var u;(function(o){o.serialize=c=>({expand:c.expand,item:m.serialize(c.item)}),o.deserialize=c=>({controllerId:D.TestId.root(c.item.extId),expand:c.expand,item:m.deserialize(c.item)})})(u=e.InternalTestItem||(e.InternalTestItem={}));var l;(function(o){o.serialize=c=>{let T;return c.item&&(T={},c.item.label!==void 0&&(T.label=c.item.label),c.item.tags!==void 0&&(T.tags=c.item.tags),c.item.busy!==void 0&&(T.busy=c.item.busy),c.item.uri!==void 0&&(T.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(T.range=c.item.range?.toJSON()),c.item.description!==void 0&&(T.description=c.item.description),c.item.error!==void 0&&(T.error=c.item.error),c.item.sortText!==void 0&&(T.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:T}},o.deserialize=c=>{let T;return c.item&&(T={},c.item.label!==void 0&&(T.label=c.item.label),c.item.tags!==void 0&&(T.tags=c.item.tags),c.item.busy!==void 0&&(T.busy=c.item.busy),c.item.range!==void 0&&(T.range=c.item.range?t.Range.lift(c.item.range):null),c.item.description!==void 0&&(T.description=c.item.description),c.item.error!==void 0&&(T.error=c.item.error),c.item.sortText!==void 0&&(T.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:T}}})(l=e.ITestItemUpdate||(e.ITestItemUpdate={}));const h=(o,c)=>{c.expand!==void 0&&(o.expand=c.expand),c.item!==void 0&&(o.item=o.item?Object.assign(o.item,c.item):c.item)};e.applyTestItemUpdate=h;var i;(function(o){o.serializeWithoutMessages=c=>({...u.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(w.serializeWithoutMessages),retired:c.retired}),o.serialize=c=>({...u.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(w.serialize),retired:c.retired}),o.deserialize=c=>({...u.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(w.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var r;(function(o){o[o.Function=0]="Function",o[o.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var n;(function(o){o[o.Add=0]="Add",o[o.Update=1]="Update",o[o.DocumentSynced=2]="DocumentSynced",o[o.Remove=3]="Remove",o[o.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",o[o.Retire=5]="Retire",o[o.AddTag=6]="AddTag",o[o.RemoveTag=7]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var s;(function(o){o.deserialize=c=>c.op===0?{op:c.op,item:u.deserialize(c.item)}:c.op===1?{op:c.op,item:l.deserialize(c.item)}:c.op===2?{op:c.op,uri:y.URI.revive(c.uri),docv:c.docv}:c,o.serialize=c=>c.op===0?{op:c.op,item:u.serialize(c.item)}:c.op===1?{op:c.op,item:l.serialize(c.item)}:c})(s=e.TestsDiffOp||(e.TestsDiffOp={}));class a{add(c){}update(c){}remove(c,T){}complete(){}}e.IncrementalChangeCollector=a;class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const T=this.createChangeCollector();for(const O of c)switch(O.op){case 0:{const K=u.deserialize(O.item),re=D.TestId.parentId(K.item.extId)?.toString();if(re){if(this.items.has(re)){const le=this.items.get(re);le.children.add(K.item.extId);const ae=this.createItem(K,le);this.items.set(K.item.extId,ae),T.add(ae)}}else{const le=this.createItem(K);this.roots.add(le),this.items.set(K.item.extId,le),T.add(le)}K.expand===2&&this.busyControllerCount++;break}case 1:{const K=l.deserialize(O.item),re=this.items.get(K.extId);if(!re)break;K.expand!==void 0&&(re.expand===2&&this.busyControllerCount--,K.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(re,K),T.update(re);break}case 3:{const K=this.items.get(O.itemId);if(!K)break;const re=D.TestId.parentId(K.item.extId)?.toString();re?this.items.get(re).children.delete(K.item.extId):this.roots.delete(K);const le=[[O.itemId]];for(;le.length;)for(const ae of le.pop()){const F=this.items.get(ae);F&&(le.push(F.children),this.items.delete(ae),T.remove(F,F!==K),F.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(O.itemId);break;case 4:this.updatePendingRoots(O.amount);break;case 6:this._tags.set(O.tag.id,O.tag);break;case 7:this._tags.delete(O.id);break}T.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new a}}e.AbstractIncrementalTestCollection=f}),define(we[124],ye([1,0,14,7,2,86,84,65]),function(oe,e,y,t,D,I,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const b=(m,p)=>m===p,k={range:(m,p)=>m===p?!0:!m||!p?!1:m.equalsRange(p),busy:b,label:b,description:b,error:b,tags:(m,p)=>!(m.length!==p.length||m.some(u=>!p.includes(u)))},R=(m,p)=>{let u;for(const[l,h]of Object.entries(k))h(m[l],p[l])||(u?u[l]=p[l]:u={[l]:p[l]});return u};class S extends D.Disposable{get root(){return this.options.root}constructor(p){super(),this.options=p,this.debounceSendDiff=this._register(new y.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(p){this._resolveHandler=p;for(const u of this.tree.values())this.updateExpandability(u)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){switch(p.op){case 2:{for(const u of this.diff)if(u.op===2&&u.uri===p.uri){u.docv=p.docv;return}break}case 1:{const u=this.diff[this.diff.length-1];if(u){if(u.op===1&&u.item.extId===p.item.extId){(0,P.applyTestItemUpdate)(u.item,p.item);return}if(u.op===0&&u.item.item.extId===p.item.extId){(0,P.applyTestItemUpdate)(u.item,p.item);return}}break}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,u){const l=this.tree.get(p);if(!!l){if((l.expandLevels===void 0||u>l.expandLevels)&&(l.expandLevels=u),l.expand===1){const h=this.resolveChildren(l);return h.isOpen()?this.expandChildren(l,u-1):h.wait().then(()=>this.expandChildren(l,u-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,u-1)):this.expandChildren(l,u-1)}}dispose(){for(const p of this.tree.values())this.options.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(p,u){switch(u.op){case 3:this.removeItem(C.TestId.joinToString(p.fullId,u.id));break;case 0:this.upsertItem(u.item,p);break;case 5:for(const l of u.ops)this.onTestItemEvent(p,l);break;case 1:this.diffTagRefs(u.new,u.old,p.fullId.toString());break;case 2:this.updateExpandability(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:u.update}});break;case 6:this.documentSynced(p.actual.uri);break;default:(0,I.assertNever)(u)}}documentSynced(p){p&&this.pushDiff({op:2,uri:p,docv:this.options.getDocumentVersion(p)})}upsertItem(p,u){const l=C.TestId.fromExtHostTestItem(p,this.root.id,u?.actual),h=this.options.getApiFor(p);h.parent&&h.parent!==u?.actual&&this.options.getChildren(h.parent).delete(p.id);let i=this.tree.get(l.toString());if(!i){i={fullId:l,actual:p,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},p.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(p,u),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(p)}}),this.connectItemAndChildren(p,i,u);return}if(i.actual===p){this.connectItem(p,i,u);return}const r=this.options.getChildren(i.actual),n=i.actual,s=R(this.options.toITestItem(n),this.options.toITestItem(p));this.options.getApiFor(n).listener=void 0,i.actual=p,i.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(p.tags,n.tags,l.toString()),delete s.tags),this.onTestItemEvent(i,{op:4,update:s})),this.connectItemAndChildren(p,i,u);for(const[a,f]of r)this.options.getChildren(p).get(f.id)||this.removeItem(C.TestId.joinToString(l,f.id));this.documentSynced(i.actual.uri)}diffTagRefs(p,u,l){const h=new Set(u.map(i=>i.id));for(const i of p)h.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:l,item:{tags:p.map(i=>(0,P.namespaceTestTag)(this.options.controllerId,i.id))}}}),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(p){const u=this.tags.get(p.id);u?u.refCount++:(this.tags.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.namespaceTestTag)(this.options.controllerId,p.id)}}))}decrementTagRefs(p){const u=this.tags.get(p);u&&!--u.refCount&&(this.tags.delete(p),this.pushDiff({op:7,id:(0,P.namespaceTestTag)(this.options.controllerId,p)}))}setItemParent(p,u){this.options.getApiFor(p).parent=u&&u.actual!==this.root?u.actual:void 0}connectItem(p,u,l){this.setItemParent(p,l);const h=this.options.getApiFor(p);h.parent=l?.actual,h.listener=i=>this.onTestItemEvent(u,i),this.updateExpandability(u)}connectItemAndChildren(p,u,l){this.connectItem(p,u,l);for(const[h,i]of this.options.getChildren(p))this.upsertItem(i,u)}updateExpandability(p){let u;this._resolveHandler?p.resolveBarrier?u=p.resolveBarrier.isOpen()?3:2:u=p.actual.canResolveChildren?1:0:u=0,u!==p.expand&&(p.expand=u,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:u}}),u===1&&p.expandLevels!==void 0&&this.resolveChildren(p))}expandChildren(p,u){if(u<0)return;const l=[];for(const[h,i]of this.options.getChildren(p.actual)){const r=this.expand(C.TestId.joinToString(p.fullId,i.id),u);(0,y.isThenable)(r)&&l.push(r)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this._resolveHandler){const i=new y.Barrier;return i.open(),i}p.expand=2,this.pushExpandStateUpdate(p);const u=p.resolveBarrier=new y.Barrier,l=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let h;try{h=this._resolveHandler(p.actual===this.root?void 0:p.actual)}catch(i){l(i)}return(0,y.isThenable)(h)?h.catch(l).then(()=>{u.open(),this.updateExpandability(p)}):(u.open(),this.updateExpandability(p)),p.resolveBarrier}pushExpandStateUpdate(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}removeItem(p){const u=this.tree.get(p);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const l=[u];for(;l.length;){const h=l.pop();if(!!h){this.options.getApiFor(h.actual).listener=void 0;for(const i of h.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(h.fullId.toString());for(const[i,r]of this.options.getChildren(h.actual))l.push(this.tree.get(C.TestId.joinToString(h.fullId,r.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}}e.TestItemCollection=S;class w extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=w;class d extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class g extends Error{constructor(p,u,l){super(`TestItem with ID "${p}" is from controller "${u}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=g;const v=(m,p,u)=>{let l=new Map;return{get size(){return l.size},forEach(h,i){for(const r of l.values())h.call(i,r,this)},[Symbol.iterator](){return l.entries()},replace(h){const i=new Map,r=new Set(l.keys()),n={op:5,ops:[]};for(const s of h){if(!(s instanceof u))throw new d(s.id);const a=p(s).controllerId;if(a!==m.controllerId)throw new g(s.id,a,m.controllerId);if(i.has(s.id))throw new w(s.id);i.set(s.id,s),r.delete(s.id),n.ops.push({op:0,item:s})}for(const s of r.keys())n.ops.push({op:3,id:s});m.listener?.(n),l=i},add(h){if(!(h instanceof u))throw new d(h.id);l.set(h.id,h),m.listener?.({op:0,item:h})},delete(h){l.delete(h)&&m.listener?.({op:3,id:h})},get(h){return l.get(h)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=v}),define(we[125],ye([1,0,124]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(P,C)=>{const E={controllerId:C};return t.set(P,E),E};e.createPrivateApiFor=D;const I=P=>{const C=t.get(P);if(!C)throw new y.InvalidTestItemError(P?.id||"<unknown>");return C};e.getPrivateApiFor=I}),define(we[253],ye([1,0,24,5]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(y.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(we[126],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,y.createDecorator)("configurationResolverService");var t;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(P,C){super(C),this.variable=P}}e.VariableError=D}),define(we[254],ye([1,0,6,26,13,23,3,145,186,126,15]),function(oe,e,y,t,D,I,P,C,E,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(w,d,g,v){this._contributedVariables=new Map,this._context=w,this._labelService=d,this._userHomePromise=g,v&&(this._envVariablesPromise=v.then(m=>this.prepareEnv(m)))}prepareEnv(w){if(P.isWindows){const d=Object.create(null);return Object.keys(w).forEach(g=>{d[g.toLowerCase()]=w[g]}),d}return w}resolveWithEnvironment(w,d,g){return this.recursiveResolve({env:this.prepareEnv(w),userHome:void 0},d?d.uri:void 0,g)}async resolveAsync(w,d){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,w?w.uri:void 0,d)}async resolveAnyBase(w,d,g,v){const m=I.deepClone(d);P.isWindows&&m.windows?Object.keys(m.windows).forEach(u=>m[u]=m.windows[u]):P.isMacintosh&&m.osx?Object.keys(m.osx).forEach(u=>m[u]=m.osx[u]):P.isLinux&&m.linux&&Object.keys(m.linux).forEach(u=>m[u]=m.linux[u]),delete m.windows,delete m.osx,delete m.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,w?w.uri:void 0,m,g,v)}async resolveAnyAsync(w,d,g){return this.resolveAnyBase(w,d,g)}async resolveAnyMap(w,d,g){const v=new Map;return{newConfig:await this.resolveAnyBase(w,d,g,v),resolvedVariables:v}}resolveWithInteractionReplace(w,d,g,v){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,d,g,v){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,d){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,d)}async recursiveResolve(w,d,g,v,m){if(D.isString(g))return this.resolveString(w,d,g,v,m);if(Array.isArray(g))return Promise.all(g.map(p=>this.recursiveResolve(w,d,p,v,m)));if(D.isObject(g)){const p=Object.create(null),u=await Promise.all(Object.keys(g).map(async l=>[await this.resolveString(w,d,l,v,m),await this.recursiveResolve(w,d,g[l],v,m)]));for(const[l,h]of u)p[l]=h;return p}return g}resolveString(w,d,g,v,m){return(0,k.replaceAsync)(g,R.VARIABLE_REGEXP,async(p,u)=>{if(u.includes(R.VARIABLE_LHS))return p;let l=await this.evaluateSingleVariable(w,p,u,d,v);return m?.set(u,l),l!==p&&D.isString(l)&&l.match(R.VARIABLE_REGEXP)&&(l=await this.resolveString(w,d,l,v,m)),l})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}async evaluateSingleVariable(w,d,g,v,m){let p;const u=g.split(":");u.length>1&&(g=u[0],p=u[1]);const l=r=>{const n=this._context.getFilePath();if(n)return n;throw new b.VariableError(r,(0,E.localize)(0,null,d))},h=r=>{const n=l(r);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new b.VariableError(r,(0,E.localize)(1,null,d,y.basename(n)))},i=r=>{if(p){const n=this._context.getFolderUri(p);if(n)return n;throw new b.VariableError(r,(0,E.localize)(2,null,d,p))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new b.VariableError(r,(0,E.localize)(3,null,d)):new b.VariableError(r,(0,E.localize)(4,null,d))};switch(g){case"env":if(p){if(w.env){const r=w.env[P.isWindows?p.toLowerCase():p];if(D.isString(r))return r}return""}throw new b.VariableError(b.VariableKind.Env,(0,E.localize)(5,null,d));case"config":if(p){const r=this._context.getConfigurationValue(v,p);if(D.isUndefinedOrNull(r))throw new b.VariableError(b.VariableKind.Config,(0,E.localize)(6,null,d,p));if(D.isObject(r))throw new b.VariableError(b.VariableKind.Config,(0,E.localize)(7,null,d,p));return r}throw new b.VariableError(b.VariableKind.Config,(0,E.localize)(8,null,d));case"command":return this.resolveFromMap(b.VariableKind.Command,d,p,m,"command");case"input":return this.resolveFromMap(b.VariableKind.Input,d,p,m,"input");case"extensionInstallFolder":if(p){const r=await this._context.getExtension(p);if(!r)throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,d,p));return this.fsPath(r.extensionLocation)}throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,d));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(i(b.VariableKind.WorkspaceFolder)));case"cwd":return v||p?(0,C.normalizeDriveLetter)(this.fsPath(i(b.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return y.basename(this.fsPath(i(b.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(w.userHome)return w.userHome;throw new b.VariableError(b.VariableKind.UserHome,(0,E.localize)(11,null,d))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new b.VariableError(b.VariableKind.LineNumber,(0,E.localize)(12,null,d))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new b.VariableError(b.VariableKind.SelectedText,(0,E.localize)(13,null,d))}case"file":return l(b.VariableKind.File);case"fileWorkspaceFolder":return h(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return v||p?y.relative(this.fsPath(i(b.VariableKind.RelativeFile)),l(b.VariableKind.RelativeFile)):l(b.VariableKind.RelativeFile);case"relativeFileDirname":{const r=y.dirname(l(b.VariableKind.RelativeFileDirname));if(v||p){const n=y.relative(this.fsPath(i(b.VariableKind.RelativeFileDirname)),r);return n.length===0?".":n}return r}case"fileDirname":return y.dirname(l(b.VariableKind.FileDirname));case"fileExtname":return y.extname(l(b.VariableKind.FileExtname));case"fileBasename":return y.basename(l(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=y.basename(l(b.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-y.extname(r).length)}case"fileDirnameBasename":return y.basename(y.dirname(l(b.VariableKind.FileDirnameBasename)));case"execPath":{const r=this._context.getExecPath();return r||d}case"execInstallFolder":{const r=this._context.getAppRoot();return r||d}case"pathSeparator":return y.sep;default:try{const r=p?`${g}:${p}`:g;return this.resolveFromMap(b.VariableKind.Unknown,d,r,m,void 0)}catch{return d}}}}resolveFromMap(w,d,g,v,m){if(g&&v){const p=m===void 0?v[g]:v[m+":"+g];if(typeof p=="string")return p;throw new b.VariableError(w,(0,E.localize)(14,null,d))}return d}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[255],ye([1,0,5,83]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,y.createDecorator)("editorGroupsService");var D;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var I;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var C;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function b(d){const g=d;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=b;var k;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(k=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function S(d){const g=d;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=S;function w(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(we[127],ye([1,0,5,255]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,y.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(I){const P=I;return typeof I=="number"||(0,t.isEditorGroup)(P)}e.isPreferredGroup=D}),define(we[256],ye([1,0,13,253,12,110,81,123,126,83,127,9,206,122]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let d=class{get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}constructor(v,m,p,u,l,h,i,r,n,s){this._remoteAuthority=v,this._channel=m,this._configurationService=p,this._workspaceContextService=u,this._resolverService=l,this._environmentVariableService=h,this._remoteAuthorityResolverService=i,this._logService=r,this._editorService=n,this._labelService=s}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(v,m,p,u,l,h,i,r){await this._configurationService.whenRemoteConfigurationLoaded();const n=Object.create(null),s=p?(0,y.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(p)):void 0;let a;try{a=(await this._resolverService.resolveAnyMap(s,{shellLaunchConfig:v,configuration:m})).resolvedVariables}catch(ae){this._logService.error(ae)}if(a)for(const[ae,F]of a.entries())(/^config:/.test(ae)||ae==="selectedText"||ae==="lineNumber")&&(n[ae]=F);const f=[];for(const[ae,F]of this._environmentVariableService.collections.entries())f.push([ae,(0,C.serializeEnvironmentVariableCollection)(F.map)]);const o=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),c=o.options&&o.options.extensionHostEnv,T=this._workspaceContextService.getWorkspace(),O=T.folders,K=p?this._workspaceContextService.getWorkspaceFolder(p):null,re=b.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:b.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.vscodeUserData,R.Schemas.vscodeRemote]}),le={configuration:m,resolvedVariables:n,envVariableCollections:f,shellLaunchConfig:v,workspaceId:T.id,workspaceName:this._labelService.getWorkspaceLabel(T),workspaceFolders:O,activeWorkspaceFolder:K,activeFileResource:re,shouldPersistTerminal:l,options:u,cols:h,rows:i,unicodeVersion:r,resolverEnv:c};return await this._channel.call("$createProcess",le)}requestDetachInstance(v,m){return this._channel.call("$requestDetachInstance",[v,m])}acceptDetachInstanceReply(v,m){return this._channel.call("$acceptDetachInstanceReply",[v,m])}attachToProcess(v){return this._channel.call("$attachToProcess",[v])}detachFromProcess(v,m){return this._channel.call("$detachFromProcess",[v,m])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(v,m){return this._channel.call("$processBinary",[v,m])}start(v){return this._channel.call("$start",[v])}input(v,m){return this._channel.call("$input",[v,m])}acknowledgeDataEvent(v,m){return this._channel.call("$acknowledgeDataEvent",[v,m])}setUnicodeVersion(v,m){return this._channel.call("$setUnicodeVersion",[v,m])}shutdown(v,m){return this._channel.call("$shutdown",[v,m])}resize(v,m,p){return this._channel.call("$resize",[v,m,p])}getInitialCwd(v){return this._channel.call("$getInitialCwd",[v])}getCwd(v){return this._channel.call("$getCwd",[v])}orphanQuestionReply(v){return this._channel.call("$orphanQuestionReply",[v])}sendCommandResult(v,m,p){return this._channel.call("$sendCommandResult",[v,m,p])}freePortKillProcess(v){return this._channel.call("$freePortKillProcess",[v])}installAutoReply(v,m){return this._channel.call("$installAutoReply",[v,m])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(v){return this._channel.call("$getDefaultSystemShell",[v])}getProfiles(v,m,p){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,v,m,p])}acceptPtyHostResolvedVariables(v,m){return this._channel.call("$acceptPtyHostResolvedVariables",[v,m])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(v){return this._channel.call("$getWslPath",[v])}setTerminalLayoutInfo(v){const p={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:v?v.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",p)}updateTitle(v,m,p){return this._channel.call("$updateTitle",[v,m,p])}updateIcon(v,m,p,u){return this._channel.call("$updateIcon",[v,m,p,u])}refreshProperty(v,m){return this._channel.call("$refreshProperty",[v,m])}updateProperty(v,m,p){return this._channel.call("$updateProperty",[v,m,p])}getTerminalLayoutInfo(){const m={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",m)}reviveTerminalProcesses(v,m){return this._channel.call("$reviveTerminalProcesses",[v,m])}getRevivedPtyNewId(v){return this._channel.call("$getRevivedPtyNewId",[v])}serializeTerminalState(v){return this._channel.call("$serializeTerminalState",[v])}};d=Ae([_e(2,t.IWorkbenchConfigurationService),_e(3,P.IWorkspaceContextService),_e(4,E.IConfigurationResolverService),_e(5,w.IEnvironmentVariableService),_e(6,I.IRemoteAuthorityResolverService),_e(7,D.ILogService),_e(8,k.IEditorService),_e(9,S.ILabelService)],d),e.RemoteTerminalChannelClient=d}),define(we[257],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var y;(function(k){k[k.IPC=1]="IPC",k[k.Socket=2]="Socket",k[k.MessagePort=3]="MessagePort"})(y=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(R){this.pipeName=R,this.type=1}serialize(R){R[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(R){R[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class I{constructor(){this.type=3}serialize(R){R[I.ENV_KEY]="1"}}e.MessagePortExtHostConnection=I,I.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function P(k){delete k[t.ENV_KEY],delete k[D.ENV_KEY],delete k[I.ENV_KEY]}function C(k,R){P(R),k.serialize(R)}e.writeExtHostConnection=C;function E(k){if(k[t.ENV_KEY])return b(k,new t(k[t.ENV_KEY]));if(k[D.ENV_KEY])return b(k,new D);if(k[I.ENV_KEY])return b(k,new I);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function b(k,R){return P(k),R}}),define(we[128],ye([1,0,47,94,82,9,6,16,7,58,80,12,40,3,56,119,2,257]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function p(n={},s,a,f,o){const c=await(0,D.getNLSConfiguration)(a,f.userDataPath);let T={};if(s)try{T=await(0,k.getResolvedShellEnv)(o,f.args,process.env)}catch(F){o.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",F)}const K={...process.env,...T,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(c,void 0,0),...n},re=f.isBuilt?(0,P.join)(f.appRoot,"bin"):(0,P.join)(f.appRoot,"resources","server","bin-dev"),le=(0,P.join)(re,"remote-cli");let ae=h(K,"PATH");return ae?ae=le+P.delimiter+ae:ae=le,i(K,"PATH",ae),f.args["without-browser-env-var"]||(K.BROWSER=(0,P.join)(re,"helpers",w.isWindows?"browser.cmd":"browser.sh")),r(K),K}e.buildUserEnvironment=p;class u{constructor(s,a){this.socket=s,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let s,a,f;return this.socket instanceof b.NodeSocket?(s=!0,a=!1,f=C.VSBuffer.alloc(0)):(s=!1,a=this.socket.permessageDeflate,f=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:s,permessageDeflate:a,inflateBytes:f.buffer.toString("base64")}}}let l=class{constructor(s,a,f,o,c,T,O){this._reconnectionToken=s,this._environmentService=c,this._logService=T,this._extensionHostStatusService=O,this._onClose=new E.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!w.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=a,this._extensionHostProcess=null,this._connectionData=new u(f,o),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(s){this._logService.info(`${this._logPrefix}${s}`)}_logError(s){this._logService.error(`${this._logPrefix}${s}`)}async _pipeSockets(s,a){const f=new v.DisposableStore;f.add(a.socket),f.add((0,v.toDisposable)(()=>{s.destroy()}));const o=()=>{f.dispose()};f.add(a.socket.onEnd(o)),f.add(a.socket.onClose(o)),f.add(E.Event.fromNodeEventEmitter(s,"end")(o)),f.add(E.Event.fromNodeEventEmitter(s,"close")(o)),f.add(E.Event.fromNodeEventEmitter(s,"error")(o)),f.add(a.socket.onData(c=>s.write(c.buffer))),f.add(E.Event.fromNodeEventEmitter(s,"data")(c=>{a.socket.write(C.VSBuffer.wrap(c))})),a.initialDataChunk.byteLength>0&&s.write(a.initialDataChunk.buffer)}async _sendSocketToExtensionHost(s,a){await a.socketDrain();const f=a.toIExtHostSocketMessage();let o;a.socket instanceof b.NodeSocket?o=a.socket.socket:o=a.socket.socket.socket,s.send(f,o)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const s={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(s)}acceptReconnection(s,a,f){this._remoteAddress=s,this._log("The client has reconnected.");const o=new u(a,f);if(!this._extensionHostProcess){this._connectionData=o;return}this._sendSocketToExtensionHost(this._extensionHostProcess,o)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(s){try{let a=process.execArgv?process.execArgv.filter(ae=>!/^--inspect(-brk)?=/.test(ae)):[];s.port&&!process.pkg&&(a=[`--inspect${s.break?"-brk":""}=${s.port}`]);const f=await p(s.env,!0,s.language,this._environmentService,this._logService);(0,d.removeDangerousEnvVariables)(f);let o;if(this._canSendSocket)(0,m.writeExtHostConnection)(new m.SocketExtHostConnection,f),o=null;else{const{namedPipeServer:ae,pipeName:F}=await this._listenOnPipe();(0,m.writeExtHostConnection)(new m.IPCExtHostConnection(F),f),o=ae}const c={env:f,execArgv:a,silent:!0},T=["--type=extensionHost","--transformURIs"],O=this._environmentService.args["use-host-proxy"];T.push(`--useHostProxy=${O?"true":"false"}`),this._extensionHostProcess=y.fork(I.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,T,c);const K=this._extensionHostProcess.pid;this._log(`<${K}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const re=E.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),le=E.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(re(ae=>this._log(`<${K}> ${ae}`)),le(ae=>this._log(`<${K}><stderr> ${ae}`)),this._extensionHostProcess.on("error",ae=>{this._logError(`<${K}> Extension Host Process had an error`),this._logService.error(ae),this._cleanResources()}),this._extensionHostProcess.on("exit",(ae,F)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:ae,signal:F}),this._log(`<${K}> Extension Host Process exited with code: ${ae}, signal: ${F}.`),this._cleanResources()}),o)o.on("connection",ae=>{o.close(),this._pipeSockets(ae,this._connectionData)});else{const ae=F=>{F.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",ae),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",ae)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}_listenOnPipe(){return new Promise((s,a)=>{const f=(0,b.createRandomIPCHandle)(),o=t.createServer();o.on("error",a),o.listen(f,()=>{o?.removeListener("error",a),s({pipeName:f,namedPipeServer:o})})})}};l=Ae([_e(4,S.IServerEnvironmentService),_e(5,R.ILogService),_e(6,g.IExtensionHostStatusService)],l),e.ExtensionHostConnection=l;function h(n,s){const a=Object.keys(n).filter(o=>o.toLowerCase()===s.toLowerCase()),f=a.length>0?a[0]:s;return n[f]}function i(n,s,a){const f=Object.keys(n).filter(c=>c.toLowerCase()===s.toLowerCase()),o=f.length>0?f[0]:s;n[o]=a}function r(n){for(const s of Object.keys(n))n[s]===null&&delete n[s]}}),define(we[258],ye([1,0,7,4,5,35,32]),function(oe,e,y,t,D,I,P){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class E{constructor(f){this.affinity=f,this.kind=1}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class b{constructor(f){this.affinity=f,this.kind=2}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=b;class k{constructor(){this.kind=3,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"Remote"}}e.RemoteRunningLocation=k;class R{constructor(f){this.dependency=f}}e.MissingExtensionDependency=R;var S;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function w(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=w;class d{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(f,o){const c=[],T=[],O=[],K=[],re=m(this._allExtensions),le=m(f),ae=(H,$)=>H.extensionLocation.toString()===$.extensionLocation.toString()||H.isBuiltin===$.isBuiltin||H.isUserBuiltin===$.isUserBuiltin||H.isUnderDevelopment===$.isUnderDevelopment;for(const H of this._allExtensions){const $=le.get(I.ExtensionIdentifier.toKey(H.identifier));if(!$){c.push(H.identifier),re.delete(I.ExtensionIdentifier.toKey(H.identifier));continue}if(!ae(H,$)){c.push(H.identifier),re.delete(I.ExtensionIdentifier.toKey(H.identifier));continue}}for(const H of f){const $=re.get(I.ExtensionIdentifier.toKey(H.identifier));if(!$){T.push(H);continue}if(!ae($,H)){c.push($.identifier),re.delete(I.ExtensionIdentifier.toKey($.identifier));continue}}const F=v(this._myExtensions),Y=v(o);for(const H of this._myExtensions)Y.has(I.ExtensionIdentifier.toKey(H))||O.push(H);for(const H of o)F.has(I.ExtensionIdentifier.toKey(H))||K.push(H);const B={toRemove:c,toAdd:T,myToRemove:O,myToAdd:K};return this.delta(B),B}delta(f){const{toRemove:o,toAdd:c,myToRemove:T,myToAdd:O}=f,K=v(o),re=v(T);for(let le=0;le<this._allExtensions.length;le++)K.has(I.ExtensionIdentifier.toKey(this._allExtensions[le].identifier))&&(this._allExtensions.splice(le,1),le--);for(let le=0;le<this._myExtensions.length;le++)re.has(I.ExtensionIdentifier.toKey(this._myExtensions[le]))&&(this._myExtensions.splice(le,1),le--);for(const le of c)this._allExtensions.push(le);for(const le of O)this._myExtensions.push(le)}containsExtension(f){for(const o of this._myExtensions)if(I.ExtensionIdentifier.equals(o,f))return!0;return!1}}e.ExtensionHostExtensions=d;class g{constructor(f){if(this[C]="ExtensionIdentifierSet",this._map=new Map,this._toKey=I.ExtensionIdentifier.toKey,f)for(const o of f)this.add(o)}get size(){return this._map.size}add(f){return this._map.set(this._toKey(f),f),this}clear(){this._map.clear()}delete(f){return this._map.delete(this._toKey(f))}has(f){return this._map.has(this._toKey(f))}forEach(f,o){this._map.forEach(c=>f.call(o,c,c,this))}*entries(){for(const[f,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=g;function v(a){const f=new Set;for(const o of a)f.add(I.ExtensionIdentifier.toKey(o));return f}e.extensionIdentifiersArrayToSet=v;function m(a){const f=new Map;for(const o of a)f.set(I.ExtensionIdentifier.toKey(o.identifier),o);return f}function p(a,f){return!0}e.isProposedApiEnabled=p;function u(a,f){if(!p(a,f))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=u;class l{constructor(f,o,c,T){this.codeLoadingTime=f,this.activateCallTime=o,this.activateResolvedTime=c,this.activationReason=T}}e.ActivationTimes=l;class h{constructor(f,o){this.description=f,this.value=o}}e.ExtensionPointContribution=h,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function r(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function n(a,f){return{identifier:new I.ExtensionIdentifier((0,P.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!f,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=n;class s{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.extensions=[]}activateByEvent(f){return Promise.resolve(void 0)}activationEventIsDone(f){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f,o){return Promise.resolve(0)}getInspectPorts(f,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,o){return Promise.resolve()}}e.NullExtensionService=s});var Rt=this&&this.__classPrivateFieldSet||function(oe,e,y,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,y):D?D.value=y:e.set(oe,y),y},it=this&&this.__classPrivateFieldGet||function(oe,e,y,t){if(y==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?t:y==="a"?t.call(oe):t?t.value:e.get(oe)};define(we[129],ye([1,0,18,8,91,31,68,15,13,4,22,17,110,121,258]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d){"use strict";var g,v,m,p,u,l,h,i,r,n,s,a,f,o,c,T,O,K,re,le,ae,F,Y;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function B(M){return Object.assign(M,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(M,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(M,[]);{const[ne,...ge]=arguments;return Reflect.construct(M,ge,ne.constructor)}}})}let H=l=class{static from(...A){let ne=A;return new l(function(){if(ne){for(const ge of ne)ge&&typeof ge.dispose=="function"&&ge.dispose();ne=void 0}})}constructor(A){g.set(this,void 0),Rt(this,g,A,"f")}dispose(){typeof it(this,g,"f")=="function"&&(it(this,g,"f").call(this),Rt(this,g,void 0,"f"))}};g=new WeakMap,H=l=Ae([B],H),e.Disposable=H;let $=h=class{static Min(...A){if(A.length===0)throw new TypeError;let ne=A[0];for(let ge=1;ge<A.length;ge++){const Ue=A[ge];Ue.isBefore(ne)&&(ne=Ue)}return ne}static Max(...A){if(A.length===0)throw new TypeError;let ne=A[0];for(let ge=1;ge<A.length;ge++){const Ue=A[ge];Ue.isAfter(ne)&&(ne=Ue)}return ne}static isPosition(A){if(!A)return!1;if(A instanceof h)return!0;const{line:ne,character:ge}=A;return typeof ne=="number"&&typeof ge=="number"}static of(A){if(A instanceof h)return A;if(this.isPosition(A))return new h(A.line,A.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(A,ne){if(A<0)throw(0,t.illegalArgument)("line must be non-negative");if(ne<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=A,this._character=ne}isBefore(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<A._character}isBeforeOrEqual(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<=A._character}isAfter(A){return!this.isBeforeOrEqual(A)}isAfterOrEqual(A){return!this.isBefore(A)}isEqual(A){return this._line===A._line&&this._character===A._character}compareTo(A){return this._line<A._line?-1:this._line>A.line?1:this._character<A._character?-1:this._character>A._character?1:0}translate(A,ne=0){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return typeof A>"u"?ge=0:typeof A=="number"?ge=A:(ge=typeof A.lineDelta=="number"?A.lineDelta:0,ne=typeof A.characterDelta=="number"?A.characterDelta:0),ge===0&&ne===0?this:new h(this.line+ge,this.character+ne)}with(A,ne=this.character){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return typeof A>"u"?ge=this.line:typeof A=="number"?ge=A:(ge=typeof A.line=="number"?A.line:this.line,ne=typeof A.character=="number"?A.character:this.character),ge===this.line&&ne===this.character?this:new h(ge,ne)}toJSON(){return{line:this.line,character:this.character}}};$=h=Ae([B],$),e.Position=$;let j=i=class{static isRange(A){return A instanceof i?!0:A?$.isPosition(A.start)&&$.isPosition(A.end):!1}static of(A){if(A instanceof i)return A;if(this.isRange(A))return new i(A.start,A.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(A,ne,ge,Ue){let Ve,Xe;if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"?(Ve=new $(A,ne),Xe=new $(ge,Ue)):$.isPosition(A)&&$.isPosition(ne)&&(Ve=$.of(A),Xe=$.of(ne)),!Ve||!Xe)throw new Error("Invalid arguments");Ve.isBefore(Xe)?(this._start=Ve,this._end=Xe):(this._start=Xe,this._end=Ve)}contains(A){return i.isRange(A)?this.contains(A.start)&&this.contains(A.end):$.isPosition(A)?!($.of(A).isBefore(this._start)||this._end.isBefore(A)):!1}isEqual(A){return this._start.isEqual(A._start)&&this._end.isEqual(A._end)}intersection(A){const ne=$.Max(A.start,this._start),ge=$.Min(A.end,this._end);if(!ne.isAfter(ge))return new i(ne,ge)}union(A){if(this.contains(A))return this;if(A.contains(this))return A;const ne=$.Min(A.start,this._start),ge=$.Max(A.end,this.end);return new i(ne,ge)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(A,ne=this.end){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return A?$.isPosition(A)?ge=A:(ge=A.start||this.start,ne=A.end||this.end):ge=this.start,ge.isEqual(this._start)&&ne.isEqual(this.end)?this:new i(ge,ne)}toJSON(){return[this.start,this.end]}};j=i=Ae([B],j),e.Range=j;let L=r=class extends j{static isSelection(A){return A instanceof r?!0:A?j.isRange(A)&&$.isPosition(A.anchor)&&$.isPosition(A.active)&&typeof A.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(A,ne,ge,Ue){let Ve,Xe;if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"?(Ve=new $(A,ne),Xe=new $(ge,Ue)):$.isPosition(A)&&$.isPosition(ne)&&(Ve=$.of(A),Xe=$.of(ne)),!Ve||!Xe)throw new Error("Invalid arguments");super(Ve,Xe),this._anchor=Ve,this._active=Xe}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=r=Ae([B],L),e.Selection=L;class N{constructor(A,ne,ge){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,t.illegalArgument)("port");if(typeof ge<"u"&&(typeof ge!="string"||ge.length===0||!/^[0-9A-Za-z\-]+$/.test(ge)))throw(0,t.illegalArgument)("connectionToken");this.host=A,this.port=Math.round(ne),this.connectionToken=ge}}e.ResolvedAuthority=N;class q extends Error{static NotAvailable(A,ne){return new q(A,S.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(A){return new q(A,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(A,ne=S.RemoteAuthorityResolverErrorCode.Unknown,ge){super(A),this._message=A,this._code=ne,this._detail=ge,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,q.prototype)}}e.RemoteAuthorityResolverError=q;var se;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(se=e.EndOfLine||(e.EndOfLine={}));var he;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(he=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Z=n=class{static isTextEdit(A){return A instanceof n?!0:A?j.isRange(A)&&typeof A.newText=="string":!1}static replace(A,ne){return new n(A,ne)}static insert(A,ne){return n.replace(new j(A,A),ne)}static delete(A){return n.replace(A,"")}static setEndOfLine(A){const ne=new n(new j(new $(0,0),new $(0,0)),"");return ne.newEol=A,ne}get range(){return this._range}set range(A){if(A&&!j.isRange(A))throw(0,t.illegalArgument)("range");this._range=A}get newText(){return this._newText||""}set newText(A){if(A&&typeof A!="string")throw(0,t.illegalArgument)("newText");this._newText=A}get newEol(){return this._newEol}set newEol(A){if(A&&typeof A!="number")throw(0,t.illegalArgument)("newEol");this._newEol=A}constructor(A,ne){this._range=A,this._newText=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Z=n=Ae([B],Z),e.TextEdit=Z;let ee=s=class{static isNotebookCellEdit(A){return A instanceof s?!0:A?Dt.isNotebookRange(A)&&Array.isArray(A.newCells):!1}static replaceCells(A,ne){return new s(A,ne)}static insertCells(A,ne){return new s(new Dt(A,A),ne)}static deleteCells(A){return new s(A,[])}static updateCellMetadata(A,ne){const ge=new s(new Dt(A,A),[]);return ge.newCellMetadata=ne,ge}static updateNotebookMetadata(A){const ne=new s(new Dt(0,0),[]);return ne.newNotebookMetadata=A,ne}constructor(A,ne){this.range=A,this.newCells=ne}};ee=s=Ae([B],ee),e.NotebookEdit=ee;class _{static isSnippetTextEdit(A){return A instanceof _?!0:A?j.isRange(A.range)&&ie.isSnippetString(A.snippet):!1}static replace(A,ne){return new _(A,ne)}static insert(A,ne){return _.replace(new j(A,A),ne)}constructor(A,ne){this.range=A,this.snippet=ne}}e.SnippetTextEdit=_;var U;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})(U=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(A,ne,ge,Ue){this._edits.push({_type:1,from:A,to:ne,options:ge,metadata:Ue})}createFile(A,ne,ge){this._edits.push({_type:1,from:void 0,to:A,options:ne,metadata:ge})}deleteFile(A,ne,ge){this._edits.push({_type:1,from:A,to:void 0,options:ne,metadata:ge})}replaceNotebookMetadata(A,ne,ge){this._edits.push({_type:3,metadata:ge,uri:A,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(A,ne,ge,Ue){const Ve=ne.start,Xe=ne.end;(Ve!==Xe||ge.length>0)&&this._edits.push({_type:5,uri:A,index:Ve,count:Xe-Ve,cells:ge,metadata:Ue})}replaceNotebookCellMetadata(A,ne,ge,Ue){this._edits.push({_type:3,metadata:Ue,uri:A,edit:{editType:8,index:ne,metadata:ge}})}replace(A,ne,ge,Ue){this._edits.push({_type:2,uri:A,edit:new Z(ne,ge),metadata:Ue})}insert(A,ne,ge,Ue){this.replace(A,new j(ne,ne),ge,Ue)}delete(A,ne,ge){this.replace(A,ne,"",ge)}has(A){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===A.toString())}set(A,ne){if(ne)for(const ge of ne){if(!ge)continue;let Ue,Ve;Array.isArray(ge)?(Ue=ge[0],Ve=ge[1]):Ue=ge,ee.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.replaceNotebookCellMetadata(A,Ue.range.start,Ue.newCellMetadata,Ve):Ue.newNotebookMetadata?this.replaceNotebookMetadata(A,Ue.newNotebookMetadata,Ve):this.replaceNotebookCells(A,Ue.range,Ue.newCells,Ve):_.isSnippetTextEdit(Ue)?this._edits.push({_type:6,uri:A,range:Ue.range,edit:Ue.snippet,metadata:Ve}):this._edits.push({_type:2,uri:A,edit:Ue,metadata:Ve})}else{for(let ge=0;ge<this._edits.length;ge++){const Ue=this._edits[ge];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===A.toString()&&(this._edits[ge]=void 0);break}}(0,y.coalesceInPlace)(this._edits)}}get(A){const ne=[];for(const ge of this._edits)ge._type===2&&ge.uri.toString()===A.toString()&&ne.push(ge.edit);return ne}entries(){const A=new I.ResourceMap;for(const ne of this._edits)if(ne._type===2){let ge=A.get(ne.uri);ge||(ge=[ne.uri,[]],A.set(ne.uri,ge)),ge[1].push(ne.edit)}return[...A.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=Ae([B],te),e.WorkspaceEdit=te;let ie=a=class{static isSnippetString(A){return A instanceof a?!0:A?typeof A.value=="string":!1}static _escape(A){return A.replace(/\$|}|\\/g,"\\$&")}constructor(A){this._tabstop=1,this.value=A||""}appendText(A){return this.value+=a._escape(A),this}appendTabstop(A=this._tabstop++){return this.value+="$",this.value+=A,this}appendPlaceholder(A,ne=this._tabstop++){if(typeof A=="function"){const ge=new a;ge._tabstop=this._tabstop,A(ge),this._tabstop=ge._tabstop,A=ge.value}else A=a._escape(A);return this.value+="${",this.value+=ne,this.value+=":",this.value+=A,this.value+="}",this}appendChoice(A,ne=this._tabstop++){const ge=A.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ge,this.value+="|}",this}appendVariable(A,ne){if(typeof ne=="function"){const ge=new a;ge._tabstop=this._tabstop,ne(ge),this._tabstop=ge._tabstop,ne=ge.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=A,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};ie=a=Ae([B],ie),e.SnippetString=ie;var fe;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(fe=e.DiagnosticTag||(e.DiagnosticTag={}));var ve;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(ve=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let z=f=class{static isLocation(A){return A instanceof f?!0:A?j.isRange(A.range)&&b.URI.isUri(A.uri):!1}constructor(A,ne){if(this.uri=A,ne)if(j.isRange(ne))this.range=j.of(ne);else if($.isPosition(ne))this.range=new j(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};z=f=Ae([B],z),e.Location=z;let Q=class{static is(A){return A?typeof A.message=="string"&&A.location&&j.isRange(A.location.range)&&b.URI.isUri(A.location.uri):!1}constructor(A,ne){this.location=A,this.message=ne}static isEqual(A,ne){return A===ne?!0:!A||!ne?!1:A.message===ne.message&&A.location.range.isEqual(ne.location.range)&&A.location.uri.toString()===ne.location.uri.toString()}};Q=Ae([B],Q),e.DiagnosticRelatedInformation=Q;let J=class{constructor(A,ne,ge=ve.Error){if(!j.isRange(A))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=A,this.message=ne,this.severity=ge}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(A,ne){return A===ne?!0:!A||!ne?!1:A.message===ne.message&&A.severity===ne.severity&&A.code===ne.code&&A.severity===ne.severity&&A.source===ne.source&&A.range.isEqual(ne.range)&&(0,y.equals)(A.tags,ne.tags)&&(0,y.equals)(A.relatedInformation,ne.relatedInformation,Q.isEqual)}};J=Ae([B],J),e.Diagnostic=J;let W=class{constructor(A,ne){if(!A)throw new Error("Illegal argument, contents must be defined");Array.isArray(A)?this.contents=A:this.contents=[A],this.range=ne}};W=Ae([B],W),e.Hover=W;var V;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(V=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let x=class{constructor(A,ne=V.Text){this.range=A,this.kind=ne}toJSON(){return{range:this.range,kind:V[this.kind]}}};x=Ae([B],x),e.DocumentHighlight=x;var X;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(X=e.SymbolKind||(e.SymbolKind={}));var ce;(function(M){M[M.Deprecated=1]="Deprecated"})(ce=e.SymbolTag||(e.SymbolTag={}));let pe=o=class{static validate(A){if(!A.name)throw new Error("name must not be falsy")}constructor(A,ne,ge,Ue,Ve){this.name=A,this.kind=ne,this.containerName=Ve,typeof ge=="string"&&(this.containerName=ge),Ue instanceof z?this.location=Ue:ge instanceof j&&(this.location=new z(Ue,ge)),o.validate(this)}toJSON(){return{name:this.name,kind:X[this.kind],location:this.location,containerName:this.containerName}}};pe=o=Ae([B],pe),e.SymbolInformation=pe;let ke=c=class{static validate(A){if(!A.name)throw new Error("name must not be falsy");if(!A.range.contains(A.selectionRange))throw new Error("selectionRange must be contained in fullRange");A.children?.forEach(c.validate)}constructor(A,ne,ge,Ue,Ve){this.name=A,this.detail=ne,this.kind=ge,this.range=Ue,this.selectionRange=Ve,this.children=[],c.validate(this)}};ke=c=Ae([B],ke),e.DocumentSymbol=ke;var Te;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(Te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Ne=class{constructor(A,ne){this.title=A,this.kind=ne}};Ne=Ae([B],Ne),e.CodeAction=Ne;let Oe=T=class{constructor(A){this.value=A}append(A){return new T(this.value?this.value+T.sep+A:A)}intersects(A){return this.contains(A)||A.contains(this)}contains(A){return this.value===A.value||A.value.startsWith(this.value+T.sep)}};Oe.sep=".",Oe=T=Ae([B],Oe),e.CodeActionKind=Oe,Oe.Empty=new Oe(""),Oe.QuickFix=Oe.Empty.append("quickfix"),Oe.Refactor=Oe.Empty.append("refactor"),Oe.RefactorExtract=Oe.Refactor.append("extract"),Oe.RefactorInline=Oe.Refactor.append("inline"),Oe.RefactorMove=Oe.Refactor.append("move"),Oe.RefactorRewrite=Oe.Refactor.append("rewrite"),Oe.Source=Oe.Empty.append("source"),Oe.SourceOrganizeImports=Oe.Source.append("organizeImports"),Oe.SourceFixAll=Oe.Source.append("fixAll");let me=class{constructor(A,ne){if(this.range=A,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=Ae([B],me),e.SelectionRange=me;class be{constructor(A,ne,ge,Ue,Ve,Xe){this.kind=A,this.name=ne,this.detail=ge,this.uri=Ue,this.range=Ve,this.selectionRange=Xe}}e.CallHierarchyItem=be;class Ee{constructor(A,ne){this.fromRanges=ne,this.from=A}}e.CallHierarchyIncomingCall=Ee;class Me{constructor(A,ne){this.fromRanges=ne,this.to=A}}e.CallHierarchyOutgoingCall=Me;var Be;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Be=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ge=class{constructor(A,ne){this.range=A,this.command=ne}get isResolved(){return!!this.command}};Ge=Ae([B],Ge),e.CodeLens=Ge;let ze=O=class{static isMarkdownString(A){return A instanceof O?!0:A&&A.appendCodeblock&&A.appendMarkdown&&A.appendText&&A.value!==void 0}constructor(A,ne=!1){v.set(this,void 0),Rt(this,v,new D.MarkdownString(A,{supportThemeIcons:ne}),"f")}get value(){return it(this,v,"f").value}set value(A){it(this,v,"f").value=A}get isTrusted(){return it(this,v,"f").isTrusted}set isTrusted(A){it(this,v,"f").isTrusted=A}get supportThemeIcons(){return it(this,v,"f").supportThemeIcons}set supportThemeIcons(A){it(this,v,"f").supportThemeIcons=A}get supportHtml(){return it(this,v,"f").supportHtml}set supportHtml(A){it(this,v,"f").supportHtml=A}get baseUri(){return it(this,v,"f").baseUri}set baseUri(A){it(this,v,"f").baseUri=A}appendText(A){return it(this,v,"f").appendText(A),this}appendMarkdown(A){return it(this,v,"f").appendMarkdown(A),this}appendCodeblock(A,ne){return it(this,v,"f").appendCodeblock(ne??"",A),this}};v=new WeakMap,ze=O=Ae([B],ze),e.MarkdownString=ze;let Ke=class{constructor(A,ne){this.label=A,this.documentation=ne}};Ke=Ae([B],Ke),e.ParameterInformation=Ke;let xe=class{constructor(A,ne){this.label=A,this.documentation=ne,this.parameters=[]}};xe=Ae([B],xe),e.SignatureInformation=xe;let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ze=Ae([B],Ze),e.SignatureHelp=Ze;var Qe;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(Qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var He;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(He=e.InlayHintKind||(e.InlayHintKind={}));let je=class{constructor(A){this.value=A}};je=Ae([B],je),e.InlayHintLabelPart=je;let ue=class{constructor(A,ne,ge){this.position=A,this.label=ne,this.kind=ge}};ue=Ae([B],ue),e.InlayHint=ue;var De;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Re;(function(M){M[M.Deprecated=1]="Deprecated"})(Re=e.CompletionItemTag||(e.CompletionItemTag={}));let Fe=class{constructor(A,ne){this.label=A,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Fe=Ae([B],Fe),e.CompletionItem=Fe;let $e=class{constructor(A=[],ne=!1){this.items=A,this.isIncomplete=ne}};$e=Ae([B],$e),e.CompletionList=$e;let qe=class{constructor(A,ne,ge){this.insertText=A,this.range=ne,this.command=ge}};qe=Ae([B],qe),e.InlineSuggestion=qe;let nt=class{constructor(A){this.commands=void 0,this.items=A}};nt=Ae([B],nt),e.InlineSuggestionList=nt;let rt=class{constructor(A,ne,ge){this.insertText=A,this.range=ne,this.command=ge}};rt=Ae([B],rt),e.InlineSuggestionNew=rt;let et=class{constructor(A,ne){this.items=A,this.commands=ne}};et=Ae([B],et),e.InlineSuggestionsNew=et;var st;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(st=e.ViewColumn||(e.ViewColumn={}));var lt;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(ct=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Pt;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Pt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var yt;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(yt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var At;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(At=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var _t;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(_t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(M){function A(ne){switch(ne){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=A}(yt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let kt=class{constructor(A,ne){if(ne&&!b.URI.isUri(ne))throw(0,t.illegalArgument)("target");if(!j.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.target=ne}};kt=Ae([B],kt),e.DocumentLink=kt;let ht=class{constructor(A,ne,ge,Ue){this.red=A,this.green=ne,this.blue=ge,this.alpha=Ue}};ht=Ae([B],ht),e.Color=ht;let bt=class{constructor(A,ne){if(ne&&!(ne instanceof ht))throw(0,t.illegalArgument)("color");if(!j.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.color=ne}};bt=Ae([B],bt),e.ColorInformation=bt;let ot=class{constructor(A){if(!A||typeof A!="string")throw(0,t.illegalArgument)("label");this.label=A}};ot=Ae([B],ot),e.ColorPresentation=ot;var Se;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var Ie;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Ie=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var de;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(de=e.TerminalExitReason||(e.TerminalExitReason={}));class G{constructor(A,ne,ge){if(this.startIndex=A,this.length=ne,this.tooltip=ge,typeof A!="number"||A<0)throw(0,t.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,t.illegalArgument)("length");if(ge!==void 0&&typeof ge!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=G;var Pe;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(Pe=e.TerminalLocation||(e.TerminalLocation={}));class Le{constructor(A){if(this.options=A,typeof A!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Le;var Ye;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Ye=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=K=class{static from(A){switch(A){case"clean":return K.Clean;case"build":return K.Build;case"rebuild":return K.Rebuild;case"test":return K.Test;default:return}}constructor(A,ne){if(this.label=ne,typeof A!="string"||typeof ne!="string")throw(0,t.illegalArgument)("name");this._id=A}get id(){return this._id}};tt.Clean=new K("clean","Clean"),tt.Build=new K("build","Build"),tt.Rebuild=new K("rebuild","Rebuild"),tt.Test=new K("test","Test"),tt=K=Ae([B],tt),e.TaskGroup=tt;function at(M){let A="";for(let ne=0;ne<M.length;ne++)A+=M[ne].replace(/,/g,",,")+",";return A}let Et=class{constructor(A,ne,ge){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=A,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=ge):this._options=ne)}get process(){return this._process}set process(A){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._process=A}get args(){return this._args}set args(A){Array.isArray(A)||(A=[]),this._args=A}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("process"),this._process!==void 0&&A.push(this._process),this._args&&this._args.length>0)for(const ne of this._args)A.push(ne);return at(A)}};Et=Ae([B],Et),e.ProcessExecution=Et;let dt=class{constructor(A,ne,ge){if(this._args=[],Array.isArray(ne)){if(!A)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A,this._args=ne,this._options=ge}else{if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(A){if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A}get command(){return this._command?this._command:""}set command(A){if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A}get args(){return this._args}set args(A){this._args=A||[]}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("shell"),this._commandLine!==void 0&&A.push(this._commandLine),this._command!==void 0&&A.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ne of this._args)A.push(typeof ne=="string"?ne:ne.value);return at(A)}};dt=Ae([B],dt),e.ShellExecution=dt;var mt;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class bn{constructor(A){this._callback=A}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(A){this._callback=A}get callback(){return this._callback}}e.CustomExecution=bn;let Tt=re=class{constructor(A,ne,ge,Ue,Ve,Xe){this.__deprecated=!1,this._definition=this.definition=A;let Je;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=ge,this.execution=Ue,Je=Ve,this.__deprecated=!0):ne===pt.Global||ne===pt.Workspace?(this.target=ne,this._name=this.name=ge,this._source=this.source=Ue,this.execution=Ve,Je=Xe):(this.target=ne,this._name=this.name=ge,this._source=this.source=Ue,this.execution=Ve,Je=Xe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(A){this.__id=A}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Et?this._definition={type:re.ProcessType,id:this._execution.computeId()}:this._execution instanceof dt?this._definition={type:re.ShellType,id:this._execution.computeId()}:this._execution instanceof bn?this._definition={type:re.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:re.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(A){if(A==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=A}get scope(){return this._scope}set target(A){this.clear(),this._scope=A}get name(){return this._name}set name(A){if(typeof A!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=A}get execution(){return this._execution}set execution(A){A===null&&(A=void 0),this.clear(),this._execution=A;const ne=this._definition.type;(re.EmptyType===ne||re.ProcessType===ne||re.ShellType===ne||re.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(A){if(Array.isArray(A))this.clear(),this._problemMatchers=A,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(A){A!==!0&&A!==!1&&(A=!1),this.clear(),this._isBackground=A}get source(){return this._source}set source(A){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=A}get group(){return this._group}set group(A){A===null&&(A=void 0),this.clear(),this._group=A}get detail(){return this._detail}set detail(A){A===null&&(A=void 0),this._detail=A}get presentationOptions(){return this._presentationOptions}set presentationOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._presentationOptions=A}get runOptions(){return this._runOptions}set runOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._runOptions=A}};Tt.ExtensionCallbackType="customExecution",Tt.ProcessType="process",Tt.ShellType="shell",Tt.EmptyType="$empty",Tt=re=Ae([B],Tt),e.Task=Tt;var In;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(In=e.ProgressLocation||(e.ProgressLocation={}));var Dn;(function(M){function A(ne){const ge=ne;return(0,E.isNumber)(ge.value)?ge.tooltip&&!(0,E.isString)(ge.tooltip)?(console.log("INVALID view badge, invalid tooltip",ge.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ge.value),!1)}M.isViewBadge=A})(Dn=e.ViewBadge||(e.ViewBadge={}));let zt=le=class{static isTreeItem(A,ne){if(A instanceof le)return!0;const ge=A;if(ge.label!==void 0&&!(0,E.isString)(ge.label)&&!ge.label?.label)return console.log("INVALID tree item, invalid label",ge.label),!1;if(ge.id!==void 0&&!(0,E.isString)(ge.id))return console.log("INVALID tree item, invalid id",ge.id),!1;if(ge.iconPath!==void 0&&!(0,E.isString)(ge.iconPath)&&!b.URI.isUri(ge.iconPath)&&(!ge.iconPath||!(0,E.isString)(ge.iconPath.id))){const Ue=ge.iconPath;if(!Ue||!(0,E.isString)(Ue.light)&&!b.URI.isUri(Ue.light)&&!(0,E.isString)(Ue.dark)&&!b.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",ge.iconPath),!1}if(ge.description!==void 0&&!(0,E.isString)(ge.description)&&typeof ge.description!="boolean")return console.log("INVALID tree item, invalid description",ge.description),!1;if(ge.resourceUri!==void 0&&!b.URI.isUri(ge.resourceUri))return console.log("INVALID tree item, invalid resourceUri",ge.resourceUri),!1;if(ge.tooltip!==void 0&&!(0,E.isString)(ge.tooltip)&&!(ge.tooltip instanceof ze))return console.log("INVALID tree item, invalid tooltip",ge.tooltip),!1;if(ge.command!==void 0&&!ge.command.command)return console.log("INVALID tree item, invalid command",ge.command),!1;if(ge.collapsibleState!==void 0&&ge.collapsibleState<Mt.None&&ge.collapsibleState>Mt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",ge.collapsibleState),!1;if(ge.contextValue!==void 0&&!(0,E.isString)(ge.contextValue))return console.log("INVALID tree item, invalid contextValue",ge.contextValue),!1;if(ge.accessibilityInformation!==void 0&&!ge.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",ge.accessibilityInformation),!1;if(ge.checkboxState!==void 0){(0,d.checkProposedApiEnabled)(ne,"treeItemCheckbox");const Ue=(0,E.isNumber)(ge.checkboxState)?ge.checkboxState:(0,E.isObject)(ge.checkboxState)&&(0,E.isNumber)(ge.checkboxState.state)?ge.checkboxState.state:void 0,Ve=!(0,E.isNumber)(ge.checkboxState)&&(0,E.isObject)(ge.checkboxState)?ge.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==Ht.Checked&&Ue!==Ht.Unchecked||Ve!==void 0&&!(0,E.isString)(Ve))return console.log("INVALID tree item, invalid checkboxState",ge.checkboxState),!1}return!0}constructor(A,ne=Mt.None){this.collapsibleState=ne,b.URI.isUri(A)?this.resourceUri=A:this.label=A}};zt=le=Ae([B],zt),e.TreeItem=zt;var Mt;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(Mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Ht;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(Ht=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(A,ne){this.value=A,this.id=ne??(0,k.generateUuid)()}};Vt=Ae([B],Vt),e.DataTransferItem=Vt;let jt=class{constructor(A){m.set(this,new Map);for(const[ne,ge]of A??[]){const Ue=it(this,m,"f").get(ne);Ue?Ue.push(ge):it(this,m,"f").set(ne,[ge])}}get(A){return it(this,m,"f").get(A)?.[0]}set(A,ne){it(this,m,"f").set(A,[ne])}forEach(A,ne){for(const[ge,Ue]of it(this,m,"f"))for(const Ve of Ue)A.call(ne,Ve,ge,this)}*[(m=new WeakMap,Symbol.iterator)](){for(const[A,ne]of it(this,m,"f"))for(const ge of ne)yield[A,ge]}};jt=Ae([B],jt),e.DataTransfer=jt;let qt=class{constructor(A){this.insertText=A}};qt=Ae([B],qt),e.DocumentDropEdit=qt;let xt=class{constructor(A){this.insertText=A}};xt=Ae([B],xt),e.DocumentPasteEdit=xt;let It=class{constructor(A,ne){this.id=A,this.color=ne}};It=Ae([B],It),e.ThemeIcon=It,It.File=new It("file"),It.Folder=new It("folder");let Gt=class{constructor(A){this.id=A}};Gt=Ae([B],Gt),e.ThemeColor=Gt;var Pn;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(Pn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{get base(){return this._base}set base(A){this._base=A,this._baseUri=b.URI.file(A)}get baseUri(){return this._baseUri}set baseUri(A){this._baseUri=A,this._base=A.fsPath}constructor(A,ne){if(typeof A!="string"&&(!A||!b.URI.isUri(A)&&!b.URI.isUri(A.uri)))throw(0,t.illegalArgument)("base");if(typeof ne!="string")throw(0,t.illegalArgument)("pattern");typeof A=="string"?this.baseUri=b.URI.file(A):b.URI.isUri(A)?this.baseUri=A:this.baseUri=A.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Kt=Ae([B],Kt),e.RelativePattern=Kt;let Lt=class{constructor(A,ne,ge,Ue){this.enabled=typeof A=="boolean"?A:!0,typeof ne=="string"&&(this.condition=ne),typeof ge=="string"&&(this.hitCondition=ge),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};Lt=Ae([B],Lt),e.Breakpoint=Lt;let Qt=class extends Lt{constructor(A,ne,ge,Ue,Ve){if(super(ne,ge,Ue,Ve),A===null)throw(0,t.illegalArgument)("location");this.location=A}};Qt=Ae([B],Qt),e.SourceBreakpoint=Qt;let Yt=class extends Lt{constructor(A,ne,ge,Ue,Ve){super(ne,ge,Ue,Ve),this.functionName=A}};Yt=Ae([B],Yt),e.FunctionBreakpoint=Yt;let Xt=class extends Lt{constructor(A,ne,ge,Ue,Ve,Xe,Je){if(super(Ue,Ve,Xe,Je),!ne)throw(0,t.illegalArgument)("dataId");this.label=A,this.dataId=ne,this.canPersist=ge}};Xt=Ae([B],Xt),e.DataBreakpoint=Xt;let Jt=class{constructor(A,ne,ge){this.command=A,this.args=ne||[],this.options=ge}};Jt=Ae([B],Jt),e.DebugAdapterExecutable=Jt;let Zt=class{constructor(A,ne){this.port=A,this.host=ne}};Zt=Ae([B],Zt),e.DebugAdapterServer=Zt;let en=class{constructor(A){this.path=A}};en=Ae([B],en),e.DebugAdapterNamedPipeServer=en;let tn=class{constructor(A){this.implementation=A}};tn=Ae([B],tn),e.DebugAdapterInlineImplementation=tn;let nn=class{constructor(A,ne){this.range=A,this.expression=ne}};nn=Ae([B],nn),e.EvaluatableExpression=nn;var kn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Tn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Tn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let rn=class{constructor(A,ne){this.range=A,this.text=ne}};rn=Ae([B],rn),e.InlineValueText=rn;let sn=class{constructor(A,ne,ge=!0){this.range=A,this.variableName=ne,this.caseSensitiveLookup=ge}};sn=Ae([B],sn),e.InlineValueVariableLookup=sn;let on=class{constructor(A,ne){this.range=A,this.expression=ne}};on=Ae([B],on),e.InlineValueEvaluatableExpression=on;let an=class{constructor(A,ne){this.frameId=A,this.stoppedLocation=ne}};an=Ae([B],an),e.InlineValueContext=an;var Rn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Rn=e.FileChangeType||(e.FileChangeType={}));let ln=ae=class extends Error{static FileExists(A){return new ae(A,R.FileSystemProviderErrorCode.FileExists,ae.FileExists)}static FileNotFound(A){return new ae(A,R.FileSystemProviderErrorCode.FileNotFound,ae.FileNotFound)}static FileNotADirectory(A){return new ae(A,R.FileSystemProviderErrorCode.FileNotADirectory,ae.FileNotADirectory)}static FileIsADirectory(A){return new ae(A,R.FileSystemProviderErrorCode.FileIsADirectory,ae.FileIsADirectory)}static NoPermissions(A){return new ae(A,R.FileSystemProviderErrorCode.NoPermissions,ae.NoPermissions)}static Unavailable(A){return new ae(A,R.FileSystemProviderErrorCode.Unavailable,ae.Unavailable)}constructor(A,ne=R.FileSystemProviderErrorCode.Unknown,ge){super(b.URI.isUri(A)?A.toString(!0):A),this.code=ge?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ae.prototype),typeof Error.captureStackTrace=="function"&&typeof ge=="function"&&Error.captureStackTrace(this,ge)}};ln=ae=Ae([B],ln),e.FileSystemError=ln;let cn=class{constructor(A,ne,ge){this.start=A,this.end=ne,this.kind=ge}};cn=Ae([B],cn),e.FoldingRange=cn;var An;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(An=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _n;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(_n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ln;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Ln=e.CommentMode||(e.CommentMode={}));var On;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(On=e.CommentThreadState||(e.CommentThreadState={}));class Fn{constructor(A,ne=[]){this.tokenTypes=A,this.tokenModifiers=ne}}e.SemanticTokensLegend=Fn;function Nn(M){return typeof M>"u"||(0,E.isStringArray)(M)}class un{constructor(A){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,A){this._hasLegend=!0;for(let ne=0,ge=A.tokenTypes.length;ne<ge;ne++)this._tokenTypeStrToInt.set(A.tokenTypes[ne],ne);for(let ne=0,ge=A.tokenModifiers.length;ne<ge;ne++)this._tokenModifierStrToInt.set(A.tokenModifiers[ne],ne)}}push(A,ne,ge,Ue,Ve){if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"&&(typeof Ve=="number"||typeof Ve>"u"))return typeof Ve>"u"&&(Ve=0),this._pushEncoded(A,ne,ge,Ue,Ve);if(j.isRange(A)&&typeof ne=="string"&&Nn(ge))return this._push(A,ne,ge);throw(0,t.illegalArgument)()}_push(A,ne,ge){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(A.start.line!==A.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ue=A.start.line,Ve=A.start.character,Xe=A.end.character-A.start.character,Je=this._tokenTypeStrToInt.get(ne);let ut=0;if(ge)for(const gt of ge){if(!this._tokenModifierStrToInt.has(gt))throw new Error("`tokenModifier` is not in the provided legend");const wt=this._tokenModifierStrToInt.get(gt);ut|=1<<wt>>>0}this._pushEncoded(Ue,Ve,Xe,Je,ut)}_pushEncoded(A,ne,ge,Ue,Ve){if(this._dataIsSortedAndDeltaEncoded&&(A<this._prevLine||A===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ut=this._data.length/5|0;let gt=0,wt=0;for(let St=0;St<ut;St++){let Ct=this._data[5*St],Ft=this._data[5*St+1];Ct===0?(Ct=gt,Ft+=wt):Ct+=gt,this._data[5*St]=Ct,this._data[5*St+1]=Ft,gt=Ct,wt=Ft}}let Xe=A,Je=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ge,this._data[this._dataLen++]=Ue,this._data[this._dataLen++]=Ve,this._prevLine=A,this._prevChar=ne}static _sortAndDeltaEncode(A){const ne=[],ge=A.length/5|0;for(let Je=0;Je<ge;Je++)ne[Je]=Je;ne.sort((Je,ut)=>{const gt=A[5*Je],wt=A[5*ut];if(gt===wt){const St=A[5*Je+1],Ct=A[5*ut+1];return St-Ct}return gt-wt});const Ue=new Uint32Array(A.length);let Ve=0,Xe=0;for(let Je=0;Je<ge;Je++){const ut=5*ne[Je],gt=A[ut+0],wt=A[ut+1],St=A[ut+2],Ct=A[ut+3],Ft=A[ut+4],Cn=gt-Ve,yi=Cn===0?wt-Xe:wt,Nt=5*Je;Ue[Nt+0]=Cn,Ue[Nt+1]=yi,Ue[Nt+2]=St,Ue[Nt+3]=Ct,Ue[Nt+4]=Ft,Ve=gt,Xe=wt}return Ue}build(A){return this._dataIsSortedAndDeltaEncoded?new fn(new Uint32Array(this._data),A):new fn(un._sortAndDeltaEncode(this._data),A)}}e.SemanticTokensBuilder=un;class fn{constructor(A,ne){this.resultId=ne,this.data=A}}e.SemanticTokens=fn;class Mn{constructor(A,ne,ge){this.start=A,this.deleteCount=ne,this.data=ge}}e.SemanticTokensEdit=Mn;class Un{constructor(A,ne){this.resultId=ne,this.edits=A}}e.SemanticTokensEdits=Un;var Bn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Bn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new It("arrow-left")},Ut=Ae([B],Ut),e.QuickInputButtons=Ut;var Wn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Wn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var $n;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})($n=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(zn=e.ExtensionKind||(e.ExtensionKind={}));class Hn{static validate(A){if(A.badge){let ne=(0,C.nextCharLength)(A.badge,0);if(ne<A.badge.length&&(ne+=(0,C.nextCharLength)(A.badge,ne)),A.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}if(!A.color&&!A.badge&&!A.tooltip)throw new Error("The decoration is empty");return!0}constructor(A,ne,ge){this.badge=A,this.tooltip=ne,this.color=ge}}e.FileDecoration=Hn;let hn=class{constructor(A){this.kind=A}};hn=Ae([B],hn),e.ColorTheme=hn;var Vn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Vn=e.ColorThemeKind||(e.ColorThemeKind={}));class Dt{static isNotebookRange(A){return A instanceof Dt?!0:A?typeof A.start=="number"&&typeof A.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(A,ne){if(A<0)throw(0,t.illegalArgument)("start must be positive");if(ne<0)throw(0,t.illegalArgument)("end must be positive");A<=ne?(this._start=A,this._end=ne):(this._start=ne,this._end=A)}with(A){let ne=this._start,ge=this._end;return A.start!==void 0&&(ne=A.start),A.end!==void 0&&(ge=A.end),ne===this._start&&ge===this._end?this:new Dt(ne,ge)}}e.NotebookRange=Dt;class Bt{static validate(A){if(typeof A.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof A.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof A.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(A){return Array.isArray(A)&&A.every(ne=>Bt.isNotebookCellData(ne))}static isNotebookCellData(A){return!0}constructor(A,ne,ge,Ue,Ve,Xe,Je){this.kind=A,this.value=ne,this.languageId=ge,this.mime=Ue,this.outputs=Ve??[],this.metadata=Xe,this.executionSummary=Je,Bt.validate(this)}}e.NotebookCellData=Bt;class jn{constructor(A){this.cells=A}}e.NotebookData=jn;class vt{static isNotebookCellOutputItem(A){return A instanceof vt?!0:A?typeof A.mime=="string"&&A.data instanceof Uint8Array:!1}static error(A){const ne={name:A.name,message:A.message,stack:A.stack};return vt.json(ne,"application/vnd.code.notebook.error")}static stdout(A){return vt.text(A,"application/vnd.code.notebook.stdout")}static stderr(A){return vt.text(A,"application/vnd.code.notebook.stderr")}static bytes(A,ne="application/octet-stream"){return new vt(A,ne)}static text(A,ne=P.Mimes.text){const ge=it(vt,p,"f",u).encode(String(A));return new vt(ge,ne)}static json(A,ne="text/x-json"){const ge=JSON.stringify(A,void 0,"	");return vt.text(ge,ne)}constructor(A,ne){this.data=A,this.mime=ne;const ge=(0,P.normalizeMimeType)(ne,!0);if(!ge)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ge}}e.NotebookCellOutputItem=vt,p=vt,u={value:new TextEncoder};class Wt{static isNotebookCellOutput(A){return A instanceof Wt?!0:!A||typeof A!="object"?!1:typeof A.id=="string"&&Array.isArray(A.items)}static ensureUniqueMimeTypes(A,ne=!1){const ge=new Set,Ue=new Set;for(let Ve=0;Ve<A.length;Ve++){const Xe=A[Ve],Je=(0,P.normalizeMimeType)(Xe.mime);if(!ge.has(Je)||(0,w.isTextStreamMime)(Je)){ge.add(Je);continue}Ue.add(Ve),ne&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return Ue.size===0?A:A.filter((Ve,Xe)=>!Ue.has(Xe))}constructor(A,ne,ge){this.items=Wt.ensureUniqueMimeTypes(A,!0),typeof ne=="string"?(this.id=ne,this.metadata=ge):(this.id=(0,k.generateUuid)(),this.metadata=ne??ge)}}e.NotebookCellOutput=Wt;var qn;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(qn=e.NotebookCellKind||(e.NotebookCellKind={}));var xn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(xn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Gn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Kn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Qn{constructor(A,ne){this.text=A,this.alignment=ne}}e.NotebookCellStatusBarItem=Qn;var Yn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(Yn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Xn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(Xn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Jn{constructor(A,ne=[]){this.uri=A,this.provides=(0,y.asArray)(ne)}}e.NotebookRendererScript=Jn;let dn=class{constructor(A,ne){this.label=A,this.timestamp=ne}};dn=Ae([B],dn),e.TimelineItem=dn;var Zn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(Zn=e.ExtensionMode||(e.ExtensionMode={}));var ei;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(ei=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ti;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(ti=e.StandardTokenType||(e.StandardTokenType={}));class ni{constructor(A,ne){this.ranges=A,this.wordPattern=ne}}e.LinkedEditingRanges=ni;class ii{constructor(A,ne){this._port=A,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ii;var ri;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(ri=e.TestResultState||(e.TestResultState={}));var si;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(si=e.TestRunProfileKind||(e.TestRunProfileKind={}));let mn=class{constructor(A=void 0,ne=void 0,ge=void 0){this.include=A,this.exclude=ne,this.profile=ge}};mn=Ae([B],mn),e.TestRunRequest=mn;let gn=F=class{static diff(A,ne,ge){const Ue=new F(A);return Ue.expectedOutput=ne,Ue.actualOutput=ge,Ue}constructor(A){this.message=A}};gn=F=Ae([B],gn),e.TestMessage=gn;let pn=class{constructor(A){this.id=A}};pn=Ae([B],pn),e.TestTag=pn;let Ot=class{constructor(A,ne){this.covered=A,this.total=ne}};Ot=Ae([B],Ot),e.CoveredCount=Ot;let vn=Y=class{static fromDetails(A,ne){const ge=new Ot(0,0),Ue=new Ot(0,0),Ve=new Ot(0,0);for(const Je of ne)if("branches"in Je){ge.total+=1,ge.covered+=Je.executionCount>0?1:0;for(const ut of Je.branches)Ue.total+=1,Ue.covered+=ut.executionCount>0?1:0}else Ve.total+=1,Ve.covered+=Je.executionCount>0?1:0;const Xe=new Y(A,ge,Ue.total>0?Ue:void 0,Ve.total>0?Ve:void 0);return Xe.detailedCoverage=ne,Xe}constructor(A,ne,ge,Ue){this.uri=A,this.statementCoverage=ne,this.branchCoverage=ge,this.functionCoverage=Ue}};vn=Y=Ae([B],vn),e.FileCoverage=vn;let wn=class{constructor(A,ne,ge=[]){this.executionCount=A,this.location=ne,this.branches=ge}};wn=Ae([B],wn),e.StatementCoverage=wn;let yn=class{constructor(A,ne){this.executionCount=A,this.location=ne}};yn=Ae([B],yn),e.BranchCoverage=yn;let En=class{constructor(A,ne){this.executionCount=A,this.location=ne}};En=Ae([B],En),e.FunctionCoverage=En;var oi;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(oi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ai;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(ai=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var li;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(li=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ci{constructor(A,ne,ge,Ue,Ve,Xe){this.kind=A,this.name=ne,this.detail=ge,this.uri=Ue,this.range=Ve,this.selectionRange=Xe}}e.TypeHierarchyItem=ci;class ui{constructor(A){this.uri=A}}e.TextTabInput=ui;class fi{constructor(A,ne){this.original=A,this.modified=ne}}e.TextDiffTabInput=fi;class hi{constructor(A,ne,ge,Ue){this.base=A,this.input1=ne,this.input2=ge,this.result=Ue}}e.TextMergeTabInput=hi;class di{constructor(A,ne){this.uri=A,this.viewType=ne}}e.CustomEditorTabInput=di;class mi{constructor(A){this.viewType=A}}e.WebviewEditorTabInput=mi;class gi{constructor(A,ne){this.uri=A,this.notebookType=ne}}e.NotebookEditorTabInput=gi;class pi{constructor(A,ne,ge){this.original=A,this.modified=ne,this.notebookType=ge}}e.NotebookDiffEditorTabInput=pi;class vi{constructor(){}}e.TerminalEditorTabInput=vi;class wi{constructor(A,ne){this.uri=A,this.inputBoxUri=ne}}e.InteractiveWindowInput=wi}),define(we[130],ye([1,0,18,16,91,31,138,45,23,13,4,48,153,212,125,83,121,65,84,127,129,66]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Se){function Ie(G){const{selectionStartLineNumber:Pe,selectionStartColumn:Le,positionLineNumber:Ye,positionColumn:We}=G,tt=new l.Position(Pe-1,Le-1),at=new l.Position(Ye-1,We-1);return new l.Selection(tt,at)}Se.to=Ie;function de(G){const{anchor:Pe,active:Le}=G;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=de})(i=e.Selection||(e.Selection={}));var r;(function(Se){function Ie(G){if(!G)return;const{start:Pe,end:Le}=G;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Ie;function de(G){if(!G)return;const{startLineNumber:Pe,startColumn:Le,endLineNumber:Ye,endColumn:We}=G;return new l.Range(Pe-1,Le-1,Ye-1,We-1)}Se.to=de})(r=e.Range||(e.Range={}));var n;(function(Se){function Ie(de){switch(de){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Se.to=Ie})(n=e.TokenType||(e.TokenType={}));var s;(function(Se){function Ie(G){return new l.Position(G.lineNumber-1,G.column-1)}Se.to=Ie;function de(G){return{lineNumber:G.line+1,column:G.character+1}}Se.from=de})(s=e.Position||(e.Position={}));var a;(function(Se){function Ie(Pe,Le){return(0,y.coalesce)((0,y.asArray)(Pe).map(Ye=>de(Ye,Le)))}Se.from=Ie;function de(Pe,Le){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:G(Pe.scheme,Le),pattern:He.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function G(Pe,Le){return Le&&typeof Pe=="string"?Le.transformOutgoingScheme(Pe):Pe}})(a=e.DocumentSelector||(e.DocumentSelector={}));var f;(function(Se){function Ie(G){switch(G){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function de(G){switch(G){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Se.to=de})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Se){function Ie(G){let Pe;return G.code&&((0,b.isString)(G.code)||(0,b.isNumber)(G.code)?Pe=String(G.code):Pe={value:String(G.code.value),target:G.code.target}),{...r.from(G.range),message:G.message,source:G.source,code:Pe,severity:T.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(c.from),tags:Array.isArray(G.tags)?(0,y.coalesce)(G.tags.map(f.from)):void 0}}Se.from=Ie;function de(G){const Pe=new l.Diagnostic(r.to(G),G.message,T.to(G.severity));return Pe.source=G.source,Pe.code=(0,b.isString)(G.code)?G.code:G.code?.value,Pe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(c.to),Pe.tags=G.tags&&(0,y.coalesce)(G.tags.map(f.to)),Pe}Se.to=de})(o=e.Diagnostic||(e.Diagnostic={}));var c;(function(Se){function Ie(G){return{...r.from(G.location.range),message:G.message,resource:G.location.uri}}Se.from=Ie;function de(G){return new l.DiagnosticRelatedInformation(new l.Location(G.resource,r.to(G)),G.message)}Se.to=de})(c=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var T;(function(Se){function Ie(G){switch(G){case l.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}Se.from=Ie;function de(G){switch(G){case w.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Se.to=de})(T=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var O;(function(Se){function Ie(G){return typeof G=="number"&&G>=l.ViewColumn.One?G-1:G===l.ViewColumn.Beside?u.SIDE_GROUP:u.ACTIVE_GROUP}Se.from=Ie;function de(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(O=e.ViewColumn||(e.ViewColumn={}));function K(Se){return typeof Se.range<"u"}function re(Se){return Se.length===0?!0:!!K(Se[0])}e.isDecorationOptionsArr=re;var le;(function(Se){function Ie(We){return We.map(Se.from)}Se.fromMany=Ie;function de(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function G(We){let tt;if(de(We)){const{language:mt,value:pt}=We;tt={value:"```"+mt+`
`+pt+"\n```\n"}}else l.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?tt={value:We}:tt={value:""};const at=Object.create(null);tt.uris=at;const Et=mt=>{try{let pt=k.URI.parse(mt,!0);pt=pt.with({query:Pe(pt.query,at)}),at[mt]=pt}catch{}return""},dt=new P.marked.Renderer;return dt.link=Et,dt.image=mt=>typeof mt=="string"?Et(D.parseHrefAndDimensions(mt).href):"",(0,P.marked)(tt.value,{renderer:dt}),tt}Se.from=G;function Pe(We,tt){if(!We)return We;let at;try{at=(0,C.parse)(We)}catch{}if(!at)return We;let Et=!1;return at=(0,E.cloneAndChange)(at,dt=>{if(k.URI.isUri(dt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[mt]=dt,Et=!0,mt}else return}),Et?JSON.stringify(at):We}function Le(We){const tt=new l.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt.baseUri=We.baseUri?k.URI.from(We.baseUri):void 0,tt}Se.to=Le;function Ye(We){if(!!We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=Ye})(le=e.MarkdownString||(e.MarkdownString={}));function ae(Se){return re(Se)?Se.map(Ie=>({range:r.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?le.fromMany(Ie.hoverMessage):Ie.hoverMessage?le.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:r.from(Ie)}))}e.fromRangeOrRangeWithMessage=ae;function F(Se){return typeof Se>"u"?Se:typeof Se=="string"?k.URI.file(Se):Se}e.pathOrURIToURI=F;var Y;(function(Se){function Ie(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?F(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=Ie})(Y=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Se){function Ie(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?F(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Y.from(de.before):void 0,after:de.after?Y.from(de.after):void 0}}Se.from=Ie})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(Se){function Ie(de){if(typeof de>"u")return de;switch(de){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(Se){function Ie(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?H.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?B.from(de.light):void 0,dark:de.dark?B.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?F(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Y.from(de.before):void 0,after:de.after?Y.from(de.after):void 0}}Se.from=Ie})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(Se){function Ie(G){return{text:G.newText,eol:G.newEol&&ze.from(G.newEol),range:r.from(G.range)}}Se.from=Ie;function de(G){const Pe=new l.TextEdit(r.to(G.range),G.text);return Pe.newEol=typeof G.eol>"u"?void 0:ze.to(G.eol),Pe}Se.to=de})(j=e.TextEdit||(e.TextEdit={}));var L;(function(Se){function Ie(G,Pe){const Le={edits:[]};if(G instanceof l.WorkspaceEdit){const Ye=new I.ResourceSet;for(const We of G._allEntries())We._type===1&&k.URI.isUri(We.to)&&We.from===void 0&&Ye.add(We.to);for(const We of G._allEntries())We._type===1?Le.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Le.edits.push({resource:We.uri,textEdit:j.from(We.edit),versionId:Ye.has(We.uri)?void 0:Pe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Le.edits.push({resource:We.uri,textEdit:{range:r.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ye.has(We.uri)?void 0:Pe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Le.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Le.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map($e.from)}})}return Le}Se.from=Ie;function de(G){const Pe=new l.WorkspaceEdit;for(const Le of G.edits)Le.textEdit?Pe.replace(k.URI.revive(Le.resource),r.to(Le.textEdit.range),Le.textEdit.text):Pe.renameFile(k.URI.revive(Le.oldResource),k.URI.revive(Le.newResource),Le.options);return Pe}Se.to=de})(L=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(Se){const Ie=Object.create(null);Ie[l.SymbolKind.File]=0,Ie[l.SymbolKind.Module]=1,Ie[l.SymbolKind.Namespace]=2,Ie[l.SymbolKind.Package]=3,Ie[l.SymbolKind.Class]=4,Ie[l.SymbolKind.Method]=5,Ie[l.SymbolKind.Property]=6,Ie[l.SymbolKind.Field]=7,Ie[l.SymbolKind.Constructor]=8,Ie[l.SymbolKind.Enum]=9,Ie[l.SymbolKind.Interface]=10,Ie[l.SymbolKind.Function]=11,Ie[l.SymbolKind.Variable]=12,Ie[l.SymbolKind.Constant]=13,Ie[l.SymbolKind.String]=14,Ie[l.SymbolKind.Number]=15,Ie[l.SymbolKind.Boolean]=16,Ie[l.SymbolKind.Array]=17,Ie[l.SymbolKind.Object]=18,Ie[l.SymbolKind.Key]=19,Ie[l.SymbolKind.Null]=20,Ie[l.SymbolKind.EnumMember]=21,Ie[l.SymbolKind.Struct]=22,Ie[l.SymbolKind.Event]=23,Ie[l.SymbolKind.Operator]=24,Ie[l.SymbolKind.TypeParameter]=25;function de(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}Se.from=de;function G(Pe){for(const Le in Ie)if(Ie[Le]===Pe)return Number(Le);return l.SymbolKind.Property}Se.to=G})(N=e.SymbolKind||(e.SymbolKind={}));var q;(function(Se){function Ie(G){switch(G){case l.SymbolTag.Deprecated:return 1}}Se.from=Ie;function de(G){switch(G){case 1:return l.SymbolTag.Deprecated}}Se.to=de})(q=e.SymbolTag||(e.SymbolTag={}));var se;(function(Se){function Ie(G){return{name:G.name,kind:N.from(G.kind),tags:G.tags&&G.tags.map(q.from),containerName:G.containerName,location:U.from(G.location)}}Se.from=Ie;function de(G){const Pe=new l.SymbolInformation(G.name,N.to(G.kind),G.containerName,U.to(G.location));return Pe.tags=G.tags&&G.tags.map(q.to),Pe}Se.to=de})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var he;(function(Se){function Ie(G){const Pe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:r.from(G.range),selectionRange:r.from(G.selectionRange),kind:N.from(G.kind),tags:G.tags?.map(q.from)??[]};return G.children&&(Pe.children=G.children.map(Ie)),Pe}Se.from=Ie;function de(G){const Pe=new l.DocumentSymbol(G.name,G.detail,N.to(G.kind),r.to(G.range),r.to(G.selectionRange));return(0,y.isNonEmptyArray)(G.tags)&&(Pe.tags=G.tags.map(q.to)),G.children&&(Pe.children=G.children.map(de)),Pe}Se.to=de})(he=e.DocumentSymbol||(e.DocumentSymbol={}));var Z;(function(Se){function Ie(G){const Pe=new l.CallHierarchyItem(N.to(G.kind),G.name,G.detail||"",k.URI.revive(G.uri),r.to(G.range),r.to(G.selectionRange));return Pe._sessionId=G._sessionId,Pe._itemId=G._itemId,Pe}Se.to=Ie;function de(G,Pe,Le){if(Pe=Pe??G._sessionId,Le=Le??G._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,name:G.name,detail:G.detail,kind:N.from(G.kind),uri:G.uri,range:r.from(G.range),selectionRange:r.from(G.selectionRange),tags:G.tags?.map(q.from)}}Se.from=de})(Z=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ee;(function(Se){function Ie(de){return new l.CallHierarchyIncomingCall(Z.to(de.from),de.fromRanges.map(G=>r.to(G)))}Se.to=Ie})(ee=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var _;(function(Se){function Ie(de){return new l.CallHierarchyOutgoingCall(Z.to(de.to),de.fromRanges.map(G=>r.to(G)))}Se.to=Ie})(_=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(Se){function Ie(G){return{range:G.range&&r.from(G.range),uri:G.uri}}Se.from=Ie;function de(G){return new l.Location(k.URI.revive(G.uri),r.to(G.range))}Se.to=de})(U=e.location||(e.location={}));var te;(function(Se){function Ie(G){const Pe=G,Le=G;return{originSelectionRange:Pe.originSelectionRange?r.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Le.uri,range:r.from(Pe.targetRange?Pe.targetRange:Le.range),targetSelectionRange:Pe.targetSelectionRange?r.from(Pe.targetSelectionRange):void 0}}Se.from=Ie;function de(G){return{targetUri:k.URI.revive(G.uri),targetRange:r.to(G.range),targetSelectionRange:G.targetSelectionRange?r.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?r.to(G.originSelectionRange):void 0}}Se.to=de})(te=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(Se){function Ie(G){return{range:r.from(G.range),contents:le.fromMany(G.contents)}}Se.from=Ie;function de(G){return new l.Hover(G.contents.map(le.to),r.to(G.range))}Se.to=de})(ie=e.Hover||(e.Hover={}));var fe;(function(Se){function Ie(G){return{range:r.from(G.range),expression:G.expression}}Se.from=Ie;function de(G){return new l.EvaluatableExpression(r.to(G.range),G.expression)}Se.to=de})(fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(Se){function Ie(G){if(G instanceof l.InlineValueText)return{type:"text",range:r.from(G.range),text:G.text};if(G instanceof l.InlineValueVariableLookup)return{type:"variable",range:r.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function de(G){switch(G.type){case"text":return{range:r.to(G.range),text:G.text};case"variable":return{range:r.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:r.to(G.range),expression:G.expression}}}Se.to=de})(ve=e.InlineValue||(e.InlineValue={}));var z;(function(Se){function Ie(G){return{frameId:G.frameId,stoppedLocation:r.from(G.stoppedLocation)}}Se.from=Ie;function de(G){return new l.InlineValueContext(G.frameId,r.to(G.stoppedLocation))}Se.to=de})(z=e.InlineValueContext||(e.InlineValueContext={}));var Q;(function(Se){function Ie(G){return{range:r.from(G.range),kind:G.kind}}Se.from=Ie;function de(G){return new l.DocumentHighlight(r.to(G.range),G.kind)}Se.to=de})(Q=e.DocumentHighlight||(e.DocumentHighlight={}));var J;(function(Se){function Ie(de){switch(de){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Se.to=Ie})(J=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var W;(function(Se){function Ie(de){return{triggerKind:J.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=Ie})(W=e.CompletionContext||(e.CompletionContext={}));var V;(function(Se){function Ie(G){switch(G){case l.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function de(G){switch(G){case 1:return l.CompletionItemTag.Deprecated}}Se.to=de})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var x;(function(Se){const Ie=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function de(Le){return Ie.get(Le)??9}Se.from=de;const G=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Pe(Le){return G.get(Le)??l.CompletionItemKind.Property}Se.to=Pe})(x=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(Se){function Ie(de,G){const Pe=new l.CompletionItem(de.label);return Pe.insertText=de.insertText,Pe.kind=x.to(de.kind),Pe.tags=de.tags?.map(V.to),Pe.detail=de.detail,Pe.documentation=D.isMarkdownString(de.documentation)?le.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,R.Range.isIRange(de.range)?Pe.range=r.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:r.to(de.range.insert),replacing:r.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new l.SnippetString(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof l.Range?new l.TextEdit(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Le=>j.to(Le))),Pe.command=G&&de.command?G.fromInternal(de.command):void 0,Pe}Se.to=Ie})(X=e.CompletionItem||(e.CompletionItem={}));var ce;(function(Se){function Ie(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:le.fromStrict(G.documentation)}}Se.from=Ie;function de(G){return{label:G.label,documentation:D.isMarkdownString(G.documentation)?le.to(G.documentation):G.documentation}}Se.to=de})(ce=e.ParameterInformation||(e.ParameterInformation={}));var pe;(function(Se){function Ie(G){return{label:G.label,documentation:le.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(ce.from):[],activeParameter:G.activeParameter}}Se.from=Ie;function de(G){return{label:G.label,documentation:D.isMarkdownString(G.documentation)?le.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(ce.to):[],activeParameter:G.activeParameter}}Se.to=de})(pe=e.SignatureInformation||(e.SignatureInformation={}));var ke;(function(Se){function Ie(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(pe.from):[]}}Se.from=Ie;function de(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(pe.to):[]}}Se.to=de})(ke=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Se){function Ie(de,G){const Pe=new l.InlayHint(s.to(G.position),typeof G.label=="string"?G.label:G.label.map(Ne.to.bind(void 0,de)),G.kind&&Oe.to(G.kind));return Pe.textEdits=G.textEdits&&G.textEdits.map(j.to),Pe.tooltip=D.isMarkdownString(G.tooltip)?le.to(G.tooltip):G.tooltip,Pe.paddingLeft=G.paddingLeft,Pe.paddingRight=G.paddingRight,Pe}Se.to=Ie})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(Se){function Ie(de,G){const Pe=new l.InlayHintLabelPart(G.label);return Pe.tooltip=D.isMarkdownString(G.tooltip)?le.to(G.tooltip):G.tooltip,S.Command.is(G.command)&&(Pe.command=de.fromInternal(G.command)),G.location&&(Pe.location=U.to(G.location)),Pe}Se.to=Ie})(Ne=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Oe;(function(Se){function Ie(G){return G}Se.from=Ie;function de(G){return G}Se.to=de})(Oe=e.InlayHintKind||(e.InlayHintKind={}));var me;(function(Se){function Ie(G){return{range:r.from(G.range),url:G.target,tooltip:G.tooltip}}Se.from=Ie;function de(G){let Pe;if(G.url)try{Pe=typeof G.url=="string"?k.URI.parse(G.url,!0):k.URI.revive(G.url)}catch{}return new l.DocumentLink(r.to(G.range),Pe)}Se.to=de})(me=e.DocumentLink||(e.DocumentLink={}));var be;(function(Se){function Ie(G){const Pe=new l.ColorPresentation(G.label);return G.textEdit&&(Pe.textEdit=j.to(G.textEdit)),G.additionalTextEdits&&(Pe.additionalTextEdits=G.additionalTextEdits.map(Le=>j.to(Le))),Pe}Se.to=Ie;function de(G){return{label:G.label,textEdit:G.textEdit?j.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Pe=>j.from(Pe)):void 0}}Se.from=de})(be=e.ColorPresentation||(e.ColorPresentation={}));var Ee;(function(Se){function Ie(G){return new l.Color(G[0],G[1],G[2],G[3])}Se.to=Ie;function de(G){return[G.red,G.green,G.blue,G.alpha]}Se.from=de})(Ee=e.Color||(e.Color={}));var Me;(function(Se){function Ie(G){return{range:r.from(G.range)}}Se.from=Ie;function de(G){return new l.SelectionRange(r.to(G.range))}Se.to=de})(Me=e.SelectionRange||(e.SelectionRange={}));var Be;(function(Se){function Ie(de){switch(de){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(Se){function Ie(G){switch(G){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function de(G){switch(G){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Se.to=de})(Ge=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ze;(function(Se){function Ie(G){if(G===l.EndOfLine.CRLF)return 1;if(G===l.EndOfLine.LF)return 0}Se.from=Ie;function de(G){if(G===1)return l.EndOfLine.CRLF;if(G===0)return l.EndOfLine.LF}Se.to=de})(ze=e.EndOfLine||(e.EndOfLine={}));var Ke;(function(Se){function Ie(de){if(typeof de=="object")return de.viewId;switch(de){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(Ke=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(Se){function Ie(de){const G={start:de.start+1,end:de.end+1};return de.kind&&(G.kind=Ze.from(de.kind)),G}Se.from=Ie})(xe=e.FoldingRange||(e.FoldingRange={}));var Ze;(function(Se){function Ie(de){if(de)switch(de){case l.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Se.from=Ie})(Ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Qe;(function(Se){function Ie(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?r.from(de.selection):void 0,override:typeof de.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Ie})(Qe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var He;(function(Se){function Ie(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:de(Le)||G(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Ie;function de(Le){const Ye=Le;return Ye?k.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function G(Le){const Ye=Le;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Pe(Le){return typeof Le=="string"?Le:new l.RelativePattern(k.URI.revive(Le.baseUri),Le.pattern)}Se.to=Pe})(He=e.GlobPattern||(e.GlobPattern={}));var je;(function(Se){function Ie(de){if(de){if(Array.isArray(de))return de.map(Ie);if(typeof de=="string")return de;{const G=de;return{language:G.language,scheme:G.scheme,pattern:He.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Se.from=Ie})(je=e.LanguageSelector||(e.LanguageSelector={}));var ue;(function(Se){function Ie(G){return{start:G.start,end:G.end}}Se.from=Ie;function de(G){return new l.NotebookRange(G.start,G.end)}Se.to=de})(ue=e.NotebookRange||(e.NotebookRange={}));var De;(function(Se){function Ie(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Se.to=Ie;function de(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Se.from=de})(De=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ce;(function(Se){function Ie(de){if(de===v.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(de===v.NotebookCellExecutionState.Pending)return;if(de===v.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=Ie})(Ce=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Re;(function(Se){function Ie(G){switch(G){case l.NotebookCellKind.Markup:return v.CellKind.Markup;case l.NotebookCellKind.Code:default:return v.CellKind.Code}}Se.from=Ie;function de(G){switch(G){case v.CellKind.Markup:return l.NotebookCellKind.Markup;case v.CellKind.Code:default:return l.NotebookCellKind.Code}}Se.to=de})(Re=e.NotebookCellKind||(e.NotebookCellKind={}));var Fe;(function(Se){function Ie(G){const Pe={metadata:G.metadata??Object.create(null),cells:[]};for(const Le of G.cells)l.NotebookCellData.validate(Le),Pe.cells.push($e.from(Le));return Pe}Se.from=Ie;function de(G){const Pe=new l.NotebookData(G.cells.map($e.to));return(0,b.isEmptyObject)(G.metadata)||(Pe.metadata=G.metadata),Pe}Se.to=de})(Fe=e.NotebookData||(e.NotebookData={}));var $e;(function(Se){function Ie(G){return{cellKind:Re.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:De.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(nt.from):[]}}Se.from=Ie;function de(G){return new l.NotebookCellData(Re.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(nt.to):void 0,G.metadata,G.internalMetadata?De.to(G.internalMetadata):void 0)}Se.to=de})($e=e.NotebookCellData||(e.NotebookCellData={}));var qe;(function(Se){function Ie(G){return{mime:G.mime,valueBytes:t.VSBuffer.wrap(G.data)}}Se.from=Ie;function de(G){return new l.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}Se.to=de})(qe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var nt;(function(Se){function Ie(G){return{outputId:G.id,items:G.items.map(qe.from),metadata:G.metadata}}Se.from=Ie;function de(G){const Pe=G.items.map(qe.to);return new l.NotebookCellOutput(Pe,G.outputId,G.metadata)}Se.to=de})(nt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(Se){function Ie(Pe){return G(Pe)?{include:(0,b.withNullAsUndefined)(He.from(Pe.include)),exclude:(0,b.withNullAsUndefined)(He.from(Pe.exclude))}:(0,b.withNullAsUndefined)(He.from(Pe))}Se.from=Ie;function de(Pe){return G(Pe)?{include:He.to(Pe.include),exclude:He.to(Pe.exclude)}:He.to(Pe)}Se.to=de;function G(Pe){const Le=Pe;return Le?!(0,b.isUndefinedOrNull)(Le.include)&&!(0,b.isUndefinedOrNull)(Le.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var et;(function(Se){function Ie(de,G,Pe){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Le,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=Ie})(et=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var st;(function(Se){function Ie(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Se.from=Ie})(st=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var lt;(function(Se){function Ie(G){return{uri:G.uri,provides:G.provides}}Se.from=Ie;function de(G){return new l.NotebookRendererScript(k.URI.revive(G.uri),G.provides)}Se.to=de})(lt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Se){function Ie(G){return{message:le.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:r.from(G.location.range),uri:G.location.uri}}}Se.from=Ie;function de(G){const Pe=new l.TestMessage(typeof G.message=="string"?G.message:le.to(G.message));return Pe.actualOutput=G.actual,Pe.expectedOutput=G.expected,Pe.location=G.location?U.to(G.location):void 0,Pe}Se.to=de})(ft=e.TestMessage||(e.TestMessage={}));var ct;(function(Se){Se.namespace=p.namespaceTestTag,Se.denamespace=p.denamespaceTestTag})(ct=e.TestTag||(e.TestTag={}));var Pt;(function(Se){function Ie(G){const Pe=(0,d.getPrivateApiFor)(G).controllerId;return{extId:m.TestId.fromExtHostTestItem(G,Pe).toString(),label:G.label,uri:k.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Le=>ct.namespace(Pe,Le.id)),range:R.Range.lift(r.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&le.fromStrict(G.error)||null}}Se.from=Ie;function de(G){return{parent:void 0,error:void 0,id:m.TestId.fromString(G.extId).localId,label:G.label,uri:k.URI.revive(G.uri),tags:(G.tags||[]).map(Pe=>{const{tagId:Le}=ct.denamespace(Pe);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:r.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Se.toPlain=de})(Pt=e.TestItem||(e.TestItem={})),function(Se){function Ie(G){return{id:G.id}}Se.from=Ie;function de(G){return new l.TestTag(G.id)}Se.to=de}(ct=e.TestTag||(e.TestTag={}));var yt;(function(Se){const Ie=(G,Pe)=>{const Le=[];for(const[We,tt]of Pe)m.TestId.compare(tt.item.extId,We)===2&&(Pe.delete(We),Le.push(tt));const Ye={...Pt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(tt=>tt.type===0).map(ft.to)})),children:Le.map(We=>Ie(We,Pe))};for(const We of Ye.children)We.parent=Ye;return Ye};function de(G){const Pe=[],Le=new Map;for(const Ye of G.items){Le.set(Ye.item.extId,Ye);const We=m.TestId.root(Ye.item.extId);G.request.targets.some(tt=>tt.controllerId===We&&tt.testIds.includes(Ye.item.extId))&&Pe.push(Ye)}return{completedAt:G.completedAt,results:Pe.map(Ye=>Ie(Ye,Le))}}Se.to=de})(yt=e.TestResults||(e.TestResults={}));var At;(function(Se){function Ie(Le){return{covered:Le.covered,total:Le.covered}}function de(Le){return"line"in Le?s.from(Le):r.from(Le)}function G(Le){return"branches"in Le?{count:Le.executionCount,location:de(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&de(Ye.location)})):void 0}:{type:0,count:Le.executionCount,location:de(Le.location)}}Se.fromDetailed=G;function Pe(Le){return{uri:Le.uri,statement:Ie(Le.statementCoverage),branch:Le.branchCoverage&&Ie(Le.branchCoverage),function:Le.functionCoverage&&Ie(Le.functionCoverage),details:Le.detailedCoverage?.map(G)}}Se.fromFile=Pe})(At=e.TestCoverage||(e.TestCoverage={}));var _t;(function(Se){function Ie(de){switch(de){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Se.to=Ie})(_t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var kt;(function(Se){function Ie(G){const Pe=new l.TypeHierarchyItem(N.to(G.kind),G.name,G.detail||"",k.URI.revive(G.uri),r.to(G.range),r.to(G.selectionRange));return Pe._sessionId=G._sessionId,Pe._itemId=G._itemId,Pe}Se.to=Ie;function de(G,Pe,Le){if(Pe=Pe??G._sessionId,Le=Le??G._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,kind:N.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:r.from(G.range),selectionRange:r.from(G.selectionRange),tags:G.tags?.map(q.from)}}Se.from=de})(kt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var ht;(function(Se){function Ie(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}Se.from=Ie})(ht=e.ViewBadge||(e.ViewBadge={}));var bt;(function(Se){function Ie(de,G){const Pe=de.fileData;return Pe?new class extends l.DataTransferItem{asFile(){return{name:Pe.name,uri:k.URI.revive(Pe.uri),data:(0,h.once)(()=>G())}}}("",de.id):new l.DataTransferItem(de.asString)}Se.toDataTransferItem=Ie})(bt=e.DataTransferItem||(e.DataTransferItem={}));var ot;(function(Se){function Ie(G,Pe){const Le=G.items.map(([Ye,We])=>[Ye,bt.toDataTransferItem(We,()=>Pe(We.id))]);return new l.DataTransfer(Le)}Se.toDataTransfer=Ie;async function de(G){const Pe={items:[]},Le=[];return G.forEach((Ye,We)=>{Le.push((async()=>{const tt=await Ye.asString(),at=Ye.asFile();Pe.items.push([We,{id:Ye.id,asString:tt,fileData:at?{name:at.name,uri:at.uri}:void 0}])})())}),await Promise.all(Le),Pe}Se.toDataTransferDTO=de})(ot=e.DataTransfer||(e.DataTransfer={}))}),define(we[259],ye([1,0,48,125,65,124,84,130,4]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const b=(u,l,h,i)=>{let r=l;return{enumerable:!0,configurable:!1,get(){return r},set(n){if(!h(r,n)){const s=r;r=n,u.listener?.(i(n,s))}}}},k=(u,l)=>u===l,R={range:(u,l)=>u===l?!0:!u||!l?!1:u.isEqual(l),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(u,l)=>!(u.length!==l.length||u.some(h=>!l.find(i=>h.id===i.id)))},S=u=>l=>({op:4,update:u(l)}),w=(u,l)=>({range:(()=>{let h;const i=S(r=>({range:y.Range.lift(C.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return h},set(r){u.listener?.({op:6}),R.range(h,r)||(h=r,u.listener?.(i(r)))}}})(),label:b(u,l,R.label,S(h=>({label:h}))),description:b(u,void 0,R.description,S(h=>({description:h}))),sortText:b(u,void 0,R.sortText,S(h=>({sortText:h}))),canResolveChildren:b(u,!1,R.canResolveChildren,h=>({op:2,state:h})),busy:b(u,!1,R.busy,S(h=>({busy:h}))),error:b(u,void 0,R.error,S(h=>({error:C.MarkdownString.fromStrict(h)||null}))),tags:b(u,[],R.tags,(h,i)=>({op:1,new:h.map(C.TestTag.from),old:i.map(C.TestTag.from)}))}),d=u=>{const l=D.TestId.fromString(u.extId),h=new v(l.controllerId,l.localId,u.label,E.URI.revive(u.uri)||void 0);return h.range=C.Range.to(u.range||void 0),h.description=u.description||void 0,h.sortText=u.sortText||void 0,h.tags=u.tags.map(i=>C.TestTag.to({id:(0,P.denamespaceTestTag)(i).tagId})),h},g=u=>{let l;for(const h of u.tests){const i=d(h.item);(0,t.getPrivateApiFor)(i).parent=l,l=i}return l};e.toItemFromContext=g;class v{constructor(l,h,i,r){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const n=(0,t.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof m?void 0:n.parent}},children:{value:(0,I.createTestItemChildren)(n,t.getPrivateApiFor,v),enumerable:!0,writable:!1},...w(n,i)})}}e.TestItemImpl=v;class m extends v{constructor(l,h){super(l,l,h,void 0),this._isRoot=!0}}e.TestItemRootImpl=m;class p extends I.TestItemCollection{constructor(l,h,i){super({controllerId:l,getDocumentVersion:r=>r&&i.getDocument(r)?.version,getApiFor:t.getPrivateApiFor,getChildren:r=>r.children,root:new m(l,h),toITestItem:C.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(we[260],ye([1,0,35,187,49]),function(oe,e,y,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function I(P,C,E,b){const k=new Map;P.forEach(S=>{const w=y.ExtensionIdentifier.toKey(S.identifier),d=k.get(w);d&&b.warn((0,t.localize)(0,null,d.extensionLocation.fsPath,S.extensionLocation.fsPath)),k.set(w,S)}),C.forEach(S=>{const w=y.ExtensionIdentifier.toKey(S.identifier),d=k.get(w);if(d)if(d.isBuiltin){if(D.gte(d.version,S.version)){b.warn(`Skipping extension ${S.extensionLocation.path} in favour of the builtin extension ${d.extensionLocation.path}.`);return}S.isBuiltin=!0}else b.warn((0,t.localize)(1,null,d.extensionLocation.fsPath,S.extensionLocation.fsPath));else if(S.isBuiltin){b.warn(`Skipping obsolete builtin extension ${S.extensionLocation.path}`);return}k.set(w,S)}),E.forEach(S=>{b.info((0,t.localize)(2,null,S.extensionLocation.fsPath));const w=y.ExtensionIdentifier.toKey(S.identifier),d=k.get(w);d&&d.isBuiltin&&(S.isBuiltin=!0),k.set(w,S)});const R=[];return k.forEach(S=>R.push(S)),R}e.dedupExtensions=I}),define(we[261],ye([1,0,3,46,4,64,9,71,102,97,222,6,26,54,260]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class g{constructor(m,p,u,l,h,i,r){if(this._connectionToken=m,this._environmentService=p,this._userDataProfilesService=u,this._logService=h,this._extensionHostStatusService=i,this._extensionsScannerService=r,p.args["install-builtin-extension"]){const s={isMachineScoped:!!p.args["do-not-sync"],installPreReleaseVersion:!!p.args["pre-release"]};this.whenExtensionsReady=l.installExtensions([],p.args["install-builtin-extension"],s,!!p.args.force).then(null,a=>{h.error(a)})}else this.whenExtensionsReady=Promise.resolve();const n=p.args["install-extension"];if(n){const s=n.map(a=>/\.vsix$/i.test(a)?D.URI.file((0,R.isAbsolute)(a)?a:(0,R.join)((0,S.cwd)(),a)):a);this.whenExtensionsReady.then(()=>l.installExtensions(s,[],{isMachineScoped:!!p.args["do-not-sync"],installPreReleaseVersion:!!p.args["pre-release"]},!!p.args.force)).then(null,a=>{h.error(a)})}}async call(m,p,u){switch(p){case"getEnvironmentData":{const l=u,h=(0,I.createURITransformer)(l.remoteAuthority);let i=await this._getEnvironmentData();return i=(0,C.transformOutgoingURIs)(i,h),i}case"getExtensionHostExitInfo":{const l=u;return this._extensionHostStatusService.getExitInfo(l.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const l=u,h=l.language;this._logService.trace(`Scanning extensions using UI language: ${h}`);const i=(0,I.createURITransformer)(l.remoteAuthority),r=l.extensionDevelopmentPath&&l.extensionDevelopmentPath.map(a=>D.URI.revive(i.transformIncoming(a))),n=r?r.filter(a=>a.scheme===P.Schemas.file).map(a=>a.fsPath):void 0;let s=await this._scanExtensions(h,n);return s=(0,C.transformOutgoingURIs)(s,i),this._logService.trace("Scanned Extensions",s),g._massageWhenConditions(s),s}case"scanSingleExtension":{await this.whenExtensionsReady;const l=u,h=l.language,i=l.isBuiltin,r=(0,I.createURITransformer)(l.remoteAuthority),n=D.URI.revive(r.transformIncoming(l.extensionLocation)),s=n.scheme===P.Schemas.file?n.fsPath:null;if(!s)return null;let a=await this._scanSingleExtension(s,i,h);return a?(a=(0,C.transformOutgoingURIs)(a,r),g._massageWhenConditions([a]),a):null}case"getDiagnosticInfo":{const l=u,h={machineInfo:(0,k.getMachineInfo)()},i=l.includeProcesses?(0,b.listProcesses)(process.pid):Promise.resolve();let r=[];const n={};if(l.folders){const s=(0,I.createURITransformer)("");r=l.folders.map(f=>D.URI.revive(s.transformIncoming(f))).filter(f=>f.scheme==="file").map(f=>(0,k.collectWorkspaceStats)(f.fsPath,["node_modules",".git"]).then(o=>{n[(0,R.basename)(f.fsPath)]=o}))}return Promise.all([i,...r]).then(([s,a])=>(h.processes=s||void 0,h.workspaceMetadata=l.folders?n:void 0,h))}}throw new Error(`IPC Command ${p} not found`)}listen(m,p,u){throw new Error("Not supported")}static _massageWhenConditions(m){const p=(n,s)=>n.replace(/file/g,"vscode-remote"),u=n=>{let s="";return s+=n.global?"g":"",s+=n.ignoreCase?"i":"",s+=n.multiline?"m":"",new RegExp(p(n.source,!0),s)},l=new class{mapDefined(n){return E.ContextKeyDefinedExpr.create(n)}mapNot(n){return E.ContextKeyNotExpr.create(n)}mapEquals(n,s){return n==="resourceScheme"&&typeof s=="string"?E.ContextKeyEqualsExpr.create(n,p(s,!1)):E.ContextKeyEqualsExpr.create(n,s)}mapNotEquals(n,s){return n==="resourceScheme"&&typeof s=="string"?E.ContextKeyNotEqualsExpr.create(n,p(s,!1)):E.ContextKeyNotEqualsExpr.create(n,s)}mapGreater(n,s){return E.ContextKeyGreaterExpr.create(n,s)}mapGreaterEquals(n,s){return E.ContextKeyGreaterEqualsExpr.create(n,s)}mapSmaller(n,s){return E.ContextKeySmallerExpr.create(n,s)}mapSmallerEquals(n,s){return E.ContextKeySmallerEqualsExpr.create(n,s)}mapRegex(n,s){return n==="resourceScheme"&&s?E.ContextKeyRegexExpr.create(n,u(s)):E.ContextKeyRegexExpr.create(n,s)}mapIn(n,s){return E.ContextKeyInExpr.create(n,s)}mapNotIn(n,s){return E.ContextKeyNotInExpr.create(n,s)}},h=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const s=E.ContextKeyExpr.deserialize(n.when);if(!s)return;const a=s.map(l);n.when=a.serialize()},i=n=>{if(Array.isArray(n))for(const s of n)h(s);else h(n)},r=n=>{for(const s in n)i(n[s])};m.forEach(n=>{n.contributes&&(n.contributes.menus&&r(n.contributes.menus),n.contributes.keybindings&&i(n.contributes.keybindings),n.contributes.views&&r(n.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:D.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:D.URI.file(this._environmentService.logsPath),extensionsPath:D.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:D.URI.file((0,R.join)(this._environmentService.logsPath,`exthost${g._namePool++}`)),globalStorageHome:this._userDataProfilesService.defaultProfile.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:y.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(m,p){const[u,l,h]=await Promise.all([this._scanBuiltinExtensions(m),this._scanInstalledExtensions(m),this._scanDevelopedExtensions(m,p)]);return(0,d.dedupExtensions)(u,l,h,this._logService)}async _scanDevelopedExtensions(m,p){return p?(await Promise.all(p.map(u=>this._extensionsScannerService.scanOneOrMultipleExtensions(D.URI.file((0,R.resolve)(u)),1,{language:m})))).flat().map(u=>(0,w.toExtensionDescription)(u,!0)):[]}async _scanBuiltinExtensions(m){return(await this._extensionsScannerService.scanSystemExtensions({language:m,useCache:!0})).map(u=>(0,w.toExtensionDescription)(u,!1))}async _scanInstalledExtensions(m){return(await this._extensionsScannerService.scanUserExtensions({language:m,useCache:!0})).map(u=>(0,w.toExtensionDescription)(u,!1))}async _scanSingleExtension(m,p,u){const l=D.URI.file((0,R.resolve)(m)),h=p?0:1,i=await this._extensionsScannerService.scanExistingExtension(l,h,{language:u});return i?(0,w.toExtensionDescription)(i,!1):null}}e.RemoteAgentEnvironmentChannel=g,g._namePool=1}),define(we[131],ye([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class y{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++y.count}}e.ProxyIdentifier=y,y.count=0;const t=[];function D(C){const E=new y(C);return t[E.nid]=E,E}e.createProxyIdentifier=D;function I(C){return t[C].sid}e.getStringIdentifierForProxy=I;class P{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=P}),define(we[262],ye([1,0,131]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var I;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(I=e.TabModelOperationKind||(e.TabModelOperationKind={}));var P;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var b;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(b=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));class R{static mixin(v){return v._id=R._n++,v}}e.IdObject=R,R._n=0;var S;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,y.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,y.createProxyIdentifier)("ExtHostLocalization")}});var Rt=this&&this.__classPrivateFieldSet||function(oe,e,y,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!D:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(oe,y):D?D.value=y:e.set(oe,y),y},it=this&&this.__classPrivateFieldGet||function(oe,e,y,t){if(y==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?t:y==="a"?t.call(oe):t?t.value:e.get(oe)};define(we[263],ye([1,0,13,129,130,23,262,18,12,45,48,100,4,2,5,249,259,16,131,38]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u){"use strict";var l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(o,c){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,h.set(this,void 0),Rt(this,l,o.getProxy(P.MainContext.MainThreadCommands),"f"),this._logService=c,Rt(this,h,o.getProxy(P.MainContext.MainThreadTelemetry),"f"),this.converter=new r(this,T=>{const O=this._apiCommands.get(T);return O?.result===s.Void?O:void 0},c),this._argumentProcessors=[{processArgument(T){return(0,b.revive)(T)}},{processArgument(T){return(0,I.cloneAndChange)(T,function(O){if(k.Range.isIRange(O))return D.Range.to(O);if(R.Position.isIPosition(O))return D.Position.to(O);if(k.Range.isIRange(O.range)&&S.URI.isUri(O.uri))return D.location.to(O);if(O instanceof m.VSBuffer)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const c=this.registerCommand(!1,o.id,async(...T)=>{const O=o.args.map((re,le)=>{if(!re.validate(T[le]))throw new Error(`Invalid argument '${re.name}' when running '${o.id}', received: ${T[le]}`);return re.convert(T[le])}),K=await this.executeCommand(o.internalId,...O);return o.result.convert(K,T,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,c,T,O,K,re){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:T,thisArg:O,description:K,extension:re}),o&&it(this,l,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&o&&it(this,l,"f").$unregisterCommand(c)})}executeCommand(o,...c){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,c,!0)}async _doExecuteCommand(o,c,T){if(this._commands.has(o))return it(this,l,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,c,!1);{let O=!1;const K=(0,I.cloneAndChange)(c,function(re){if(re instanceof t.Position)return D.Position.from(re);if(re instanceof t.Range)return D.Range.from(re);if(re instanceof t.Location)return D.location.from(re);if(t.NotebookRange.isNotebookRange(re))return D.NotebookRange.from(re);if(re instanceof ArrayBuffer)return O=!0,m.VSBuffer.wrap(new Uint8Array(re));if(re instanceof Uint8Array)return O=!0,m.VSBuffer.wrap(re);if(re instanceof m.VSBuffer)return O=!0,re;if(!Array.isArray(re))return re});try{const re=await it(this,l,"f").$executeCommand(o,O?new p.SerializableObjectWithBuffers(K):K,T);return(0,b.revive)(re)}catch(re){if(re instanceof Error&&re.message==="$executeCommand:retry")return this._doExecuteCommand(o,c,!1);throw re}}}async _executeContributedCommand(o,c,T){const O=this._commands.get(o);if(!O)throw new Error("Unknown command");this._reportTelemetry(O,o);const{callback:K,thisArg:re,description:le}=O;if(le)for(let ae=0;ae<le.args.length;ae++)try{(0,y.validateConstraint)(c[ae],le.args[ae].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${le.args[ae].name}' - ${le.args[ae].description}`)}try{return await K.apply(re,c)}catch(ae){if(o===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...c);F&&(o=F.command)}throw this._logService.error(ae,o,O.extension?.identifier),T?new class extends Error{constructor(){super((0,u.toErrorMessage)(ae)),this.id=o,this.source=O.extension?.displayName??O.extension?.name}}:ae}}_reportTelemetry(o,c){!o.extension||o.extension.isBuiltin||it(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:c})}$executeContributedCommand(o,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(c=c.map(T=>this._argumentProcessors.reduce((O,K)=>K.processArgument(O),T)),this._executeContributedCommand(o,c,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),it(this,l,"f").$getCommands().then(c=>(o&&(c=c.filter(T=>T[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[c,T]of this._commands){const{description:O}=T;O&&(o[c]=O)}return Promise.resolve(o)}};l=new WeakMap,h=new WeakMap,i=Ae([_e(0,g.IExtHostRpcService),_e(1,E.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class r{constructor(o,c,T){this._commands=o,this._lookupApiCommand=c,this._logService=T,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,c){if(!o)return;const T={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return T;const O=this._lookupApiCommand(o.command);if(O)T.id=O.internalId,T.arguments=O.args.map((K,re)=>K.convert(o.arguments&&o.arguments[re]));else if((0,C.isNonEmptyArray)(o.arguments)){const K=++this._cachIdPool;this._cache.set(K,o),c.add((0,w.toDisposable)(()=>{this._cache.delete(K),this._logService.trace("CommandsConverter#DISPOSE",K)})),T.$ident=K,T.id=this.delegatingCommandId,T.arguments=[K],this._logService.trace("CommandsConverter#CREATE",o.command,K)}return T}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const c=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=r;class n{constructor(o,c,T,O){this.name=o,this.description=c,this.validate=T,this.convert=O}optional(){return new n(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,c){return new n(o??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",f=>S.URI.isUri(f),f=>f),n.Position=new n("position","A position in a text document",f=>t.Position.isPosition(f),D.Position.from),n.Range=new n("range","A range in a text document",f=>t.Range.isRange(f),D.Range.from),n.Selection=new n("selection","A selection in a text document",f=>t.Selection.isSelection(f),D.Selection.from),n.Number=new n("number","",f=>typeof f=="number",f=>f),n.String=new n("string","",f=>typeof f=="string",f=>f),n.CallHierarchyItem=new n("item","A call hierarchy item",f=>f instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",f=>f instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",f=>f instanceof v.TestItemImpl,D.TestItem.from);class s{constructor(o,c){this.description=o,this.convert=c}}e.ApiCommandResult=s,s.Void=new s("no result",f=>f);class a{constructor(o,c,T,O,K){this.id=o,this.internalId=c,this.description=T,this.args=O,this.result=K}}e.ApiCommand=a}),define(we[264],ye([1,0,58,247,29,263,4,12,81]),function(oe,e,y,t,D,I,P,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class b{constructor(S,w,d){this._commands=S,this.logService=w,this._ipcHandlePath=d,this._server=t.createServer((g,v)=>this.onRequest(g,v)),this.setup().catch(g=>(w.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,w){const d=(v,m)=>{w.writeHead(v,{"content-type":"application/json"}),w.end(JSON.stringify(m||null),p=>p&&this.logService.error(p))},g=[];S.setEncoding("utf8"),S.on("data",v=>g.push(v)),S.on("end",async()=>{try{const v=JSON.parse(g.join(""));let m;switch(v.type){case"open":m=await this.open(v);break;case"openExternal":m=await this.openExternal(v);break;case"status":m=await this.getStatus(v);break;case"extensionManagement":m=await this.manageExtensions(v);break;default:d(404,`Unknown message type: ${v.type}`);break}d(200,m)}catch(v){const m=v instanceof Error?v.message:JSON.stringify(v);d(500,m),this.logService.error("Error while processing pipe request",v)}})}async open(S){const{fileURIs:w,folderURIs:d,forceNewWindow:g,diffMode:v,mergeMode:m,addMode:p,forceReuseWindow:u,gotoLineMode:l,waitMarkerFilePath:h,remoteAuthority:i}=S,r=[];if(Array.isArray(d))for(const f of d)try{r.push({folderUri:P.URI.parse(f)})}catch{}if(Array.isArray(w))for(const f of w)try{(0,E.hasWorkspaceFileExtension)(f)?r.push({workspaceUri:P.URI.parse(f)}):r.push({fileUri:P.URI.parse(f)})}catch{}const n=h?P.URI.file(h):void 0,a={forceNewWindow:g,diffMode:v,mergeMode:m,addMode:p,gotoLineMode:l,forceReuseWindow:u,preferNewWindow:!u&&!n&&!p,waitMarkerFileURI:n,remoteAuthority:i};return this._commands.executeCommand("_remoteCLI.windowOpen",r,a),""}async openExternal(S){for(const w of S.uris){const d=P.URI.parse(w),g=d.scheme==="file"?d:w;await this._commands.executeCommand("_remoteCLI.openExternal",g)}}async manageExtensions(S){const w=g=>g?.map(v=>/\.vsix$/i.test(v)?P.URI.parse(v):v),d={list:S.list,install:w(S.install),uninstall:w(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",d)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=b;let k=class extends b{constructor(S,w){super(S,w,(0,y.createRandomIPCHandle)())}};k=Ae([_e(0,I.IExtHostCommands),_e(1,C.ILogService)],k),e.CLIServer=k}),define(we[265],ye([1,0,27,7,23,2,6,3,4,58,64,264,251,123,252,254,128]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class m extends g.AbstractVariableResolverService{constructor(l,h,i,r,n){super({getFolderUri:s=>{const a=h.filter(f=>f.name===s);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(s,a)=>r[`config:${a}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(i)return P.normalize(i.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async s=>{const f=(await n.getInstalled()).find(o=>o.identifier.id===s);return f&&{extensionLocation:f.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve(l))}}class p extends I.Disposable{constructor(l,h,i,r,n){super(),this._environmentService=l,this._logService=h,this._ptyService=i,this._productService=r,this._extensionManagementService=n,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,h,i){switch(h){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,i);case"$createProcess":{const r=(0,k.createURITransformer)(l.remoteAuthority);return this._createProcess(r,i)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,i);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,i);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,i);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,i);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,i);case"$start":return this._ptyService.start.apply(this._ptyService,i);case"$input":return this._ptyService.input.apply(this._ptyService,i);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,i);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,i);case"$resize":return this._ptyService.resize.apply(this._ptyService,i);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,i);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,i);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,i);case"$sendCommandResult":return this._sendCommandResult(i[0],i[1],i[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,i);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,i);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,i);case"$getProfiles":return this._getProfiles.apply(this,i);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(i[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(i);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(i);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,i);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,i);case"$getRevivedPtyNewId":return this._ptyService.getRevivedPtyNewId.apply(this._ptyService,i);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,i);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,i);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,i);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,i);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,i);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(i[0],i[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(i[0],i[1]);case"$freePortKillProcess":return this._ptyService.freePortKillProcess?.apply(this._ptyService,i)}throw new Error(`IPC Command ${h} not found`)}listen(l,h,i){switch(h){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(l,h){const i={name:h.shellLaunchConfig.name,executable:h.shellLaunchConfig.executable,args:h.shellLaunchConfig.args,cwd:typeof h.shellLaunchConfig.cwd=="string"||typeof h.shellLaunchConfig.cwd>"u"?h.shellLaunchConfig.cwd:E.URI.revive(l.transformIncoming(h.shellLaunchConfig.cwd)),env:h.shellLaunchConfig.env,useShellEnvironment:h.shellLaunchConfig.useShellEnvironment,reconnectionProperties:h.shellLaunchConfig.reconnectionProperties,type:h.shellLaunchConfig.type,isFeatureTerminal:h.shellLaunchConfig.isFeatureTerminal},r=await(0,v.buildUserEnvironment)(h.resolverEnv,!!h.shellLaunchConfig.useShellEnvironment,C.language,this._environmentService,this._logService);this._logService.trace("baseEnv",r);const n=B=>({uri:E.URI.revive(l.transformIncoming(B.uri)),name:B.name,index:B.index,toResource:()=>{throw new Error("Not implemented")}}),s=h.workspaceFolders.map(n),a=h.activeWorkspaceFolder?n(h.activeWorkspaceFolder):void 0,f=h.activeFileResource?E.URI.revive(l.transformIncoming(h.activeFileResource)):void 0,o=new m(r,s,f,h.resolvedVariables,this._extensionManagementService),c=d.createVariableResolver(a,process.env,o),T=await d.getCwd(i,y.homedir(),c,a?.uri,h.configuration["terminal.integrated.cwd"],this._logService);i.cwd=T;const O=C.isWindows?"terminal.integrated.env.windows":C.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",K=h.configuration[O],re=await d.createTerminalEnvironment(i,K,c,this._productService.version,h.configuration["terminal.integrated.detectLocale"],r);if(!i.strictEnv){const B=[];for(const[j,L]of h.envVariableCollections)B.push([j,{map:(0,w.deserializeEnvironmentVariableCollection)(L)}]);const H=new Map(B);await new S.MergedEnvironmentVariableCollection(H).applyToProcessEnvironment(re,c)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:T,cols:h.cols,rows:h.rows,env:re});const le=(0,b.createRandomIPCHandle)();re.VSCODE_IPC_HOOK_CLI=le;const ae=await this._ptyService.createProcess(i,T,h.cols,h.rows,h.unicodeVersion,re,r,h.options,h.shouldPersistTerminal,h.workspaceId,h.workspaceName),F={executeCommand:(B,...H)=>this._executeCommand(ae,B,H,l)},Y=new R.CLIServerBase(F,this._logService,le);return this._ptyService.onProcessExit(B=>B.id===ae&&Y.dispose()),{persistentTerminalId:ae,resolvedShellLaunchConfig:i}}_executeCommand(l,h,i,r){let n,s;const a=new Promise((c,T)=>{n=c,s=T}),f=++this._lastReqId;this._pendingCommands.set(f,{resolve:n,reject:s,uriTransformer:r});const o=(0,D.cloneAndChange)(i,c=>{if(c&&c.$mid===1)return r.transformOutgoing(c);if(c&&c instanceof E.URI)return r.transformOutgoingURI(c)});return this._onExecuteCommand.fire({reqId:f,persistentProcessId:l,commandId:h,commandArgs:o}),a}_sendCommandResult(l,h,i){const r=this._pendingCommands.get(l);if(!r)return;this._pendingCommands.delete(l);const n=(0,D.cloneAndChange)(i,s=>{if(s&&s.$mid===1)return r.uriTransformer.transformIncoming(s)});h?r.reject(n):r.resolve(n)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,h,i,r){return this._ptyService.getProfiles?.(l,h,i,r)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=p}),define(we[132],ye([1,0,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,y.createDecorator)("remoteAgentService")}),define(we[266],ye([1,0,8,2,9,201]),function(oe,e,y,t,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class P extends I.DiskFileSystemProviderClient{static register(E,b,k){const R=E.getConnection();if(!R)return t.Disposable.None;const S=new t.DisposableStore,w=(async()=>{try{const d=await E.getRawEnvironment();d?b.registerProvider(D.Schemas.vscodeRemote,S.add(new P(d,R))):k.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){k.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.getErrorMessage)(d))}})();return S.add(b.onWillActivateFileSystemProvider(d=>{d.scheme===D.Schemas.vscodeRemote&&d.join(w)})),S}constructor(E,b){super(b.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:E.os===3})}}e.RemoteFileSystemProviderClient=P}),define(we[133],ye([1,0,29,14,6,13,21,159,277,278]),function(oe,e,y,t,D,I,P,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class k extends Error{constructor(i,r){let n=r.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=r}}e.ExtractError=k;function R(h){const i=h.externalFileAttributes>>16||33188;return[448,56,7].map(r=>i&r).reduce((r,n)=>r+n,i&61440)}function S(h){if(h instanceof k)return h;let i;return/end of central directory record signature not found/.test(h.message)&&(i="CorruptZip"),new k(i,h)}function w(h,i,r,n,s,a){const f=D.dirname(i),o=D.join(n,f);if(!o.startsWith(n))return Promise.reject(new Error(C.localize(0,null,i)));const c=D.join(n,i);let T;return a.onCancellationRequested(()=>{T?.destroy()}),Promise.resolve(P.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((O,K)=>{if(!a.isCancellationRequested)try{T=(0,y.createWriteStream)(c,{mode:r}),T.once("close",()=>O()),T.once("error",K),h.once("error",K),h.pipe(T)}catch(re){K(re)}}))}function d(h,i,r,n){let s=(0,t.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{s.cancel(),h.close()}),new Promise((f,o)=>{const c=new t.Sequencer,T=O=>{O.isCancellationRequested||(a++,h.readEntry())};h.once("error",o),h.once("close",()=>s.then(()=>{n.isCancellationRequested||h.entryCount===a?f():o(new k("Incomplete",new Error(C.localize(1,null,a,h.entryCount))))},o)),h.readEntry(),h.on("entry",O=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){T(n);return}const K=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(K)){const ae=D.join(i,K);s=(0,t.createCancelablePromise)(F=>P.Promises.mkdir(ae,{recursive:!0}).then(()=>T(F)).then(void 0,o));return}const re=v(h,O),le=R(O);s=(0,t.createCancelablePromise)(ae=>c.queue(()=>re.then(F=>w(F,K,le,i,r,ae).then(()=>T(ae)))).then(null,o))})})}function g(h,i=!1){return new Promise((r,n)=>{(0,E.open)(h,i?{lazyEntries:!0}:void 0,(s,a)=>{s?n(S(s)):r((0,I.assertIsDefined)(a))})})}function v(h,i){return new Promise((r,n)=>{h.openReadStream(i,(s,a)=>{s?n(S(s)):r((0,I.assertIsDefined)(a))})})}function m(h,i){return new Promise((r,n)=>{const s=new b.ZipFile;i.forEach(f=>{f.contents?s.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&s.addFile(f.localPath,f.path)}),s.end();const a=(0,y.createWriteStream)(h);s.outputStream.pipe(a),s.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>r(h))})}e.zip=m;function p(h,i,r={},n){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let a=g(h,!0);return r.overwrite&&(a=a.then(f=>P.Promises.rm(i).then(()=>f))),a.then(f=>d(f,i,{sourcePathRegex:s},n))}e.extract=p;function u(h,i){return g(h).then(r=>new Promise((n,s)=>{r.on("entry",a=>{a.fileName===i&&v(r,a).then(f=>n(f),f=>s(f))}),r.once("close",()=>s(new Error(C.localize(2,null,i))))}))}function l(h,i){return u(h,i).then(r=>new Promise((n,s)=>{const a=[];r.once("error",s),r.on("data",f=>a.push(f)),r.on("end",()=>n(Buffer.concat(a)))}))}e.buffer=l}),define(we[267],ye([1,0,133,169]),function(oe,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(I){return(0,y.buffer)(I,"extension/package.json").then(P=>{try{return JSON.parse(P.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=D}),define(we[134],ye([1,0,14,38,8,2,9,6,3,19,49,13,4,22,21,133,168,74,28,239,30,32,52,54,215,240,267,216,238,35,72,17,5,12,25,33,39,37]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l,h,i,r,n,s,a,f,o,c,T,O,K,re,le,ae,F,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,K.refineServiceDecorator)(l.IExtensionManagementService);let B=class extends u.AbstractExtensionManagementService{constructor(Z,ee,_,U,te,ie,fe,ve,z,Q,J,W){super(Z,ee,_,Q,W),this.extensionsScannerService=te,this.extensionsProfileScannerService=ie,this.downloadService=fe,this.fileService=z,this.installGalleryExtensionsTasks=new Map;const V=this._register(ve.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(ve.createInstance(H,X=>V.postUninstall(X))),this.manifestCache=this._register(new f.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(ve.createInstance(n.ExtensionsDownloader));const x=this._register(new o.ExtensionsWatcher(this,z,U,_,J));this._register(x.onDidChangeExtensionsByAnotherSource(({added:X,removed:ce})=>{X.length&&this._onDidInstallExtensions.fire(X.map(pe=>({identifier:pe.identifier,operation:1,local:pe}))),ce.forEach(pe=>this._onDidUninstallExtension.fire({identifier:pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(Z){this.logService.trace("ExtensionManagementService#zip",Z.identifier.id);const ee=await this.collectFiles(Z),_=await(0,g.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,w.generateUuid)()).fsPath,ee);return S.URI.file(_)}async unzip(Z){return this.logService.trace("ExtensionManagementService#unzip",Z.toString()),(await this.install(Z)).identifier}async getManifest(Z){const{location:ee,cleanup:_}=await this.downloadVsix(Z),U=C.resolve(ee.fsPath);try{return await(0,a.getManifest)(U)}finally{await _()}}getInstalled(Z,ee){return this.extensionsScanner.scanExtensions(Z??null,ee)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(Z,ee={}){this.logService.trace("ExtensionManagementService#install",Z.toString());const{location:_,cleanup:U}=await this.downloadVsix(Z);try{const te=await(0,a.getManifest)(C.resolve(_.fsPath));if(te.engines&&te.engines.vscode&&!(0,T.isEngineValid)(te.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,(0,h.getGalleryExtensionId)(te.publisher,te.name),this.productService.version));return await this.installExtension(te,_,ee)}finally{await U()}}getMetadata(Z){return this.extensionsScannerService.scanMetadata(Z.location)}async updateMetadata(Z,ee){this.logService.trace("ExtensionManagementService#updateMetadata",Z.identifier.id);const _={...ee};return ee.isPreReleaseVersion&&(_.preRelease=!0),Z=await this.extensionsScanner.updateMetadata(Z,_),this.manifestCache.invalidate(),Z}async updateExtensionScope(Z,ee){return this.logService.trace("ExtensionManagementService#updateExtensionScope",Z.identifier.id),Z=await this.extensionsScanner.updateMetadata(Z,{isMachineScoped:ee}),this.manifestCache.invalidate(),Z}removeUninstalledExtensions(Z){return this.extensionsScanner.cleanUp(Z)}async download(Z,ee){const{location:_}=await this.extensionsDownloader.download(Z,ee);return _}async downloadVsix(Z){if(Z.scheme===P.Schemas.file)return{location:Z,async cleanup(){}};this.logService.trace("Downloading extension from",Z.toString());const ee=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,w.generateUuid)());return await this.downloadService.download(Z,ee),this.logService.info("Downloaded extension to",ee.toString()),{location:ee,cleanup:async()=>{try{await this.fileService.del(ee)}catch(U){this.logService.error(U)}}}}doCreateInstallExtensionTask(Z,ee,_){let U;if(S.URI.isUri(ee))U=new L(Z,ee,_,this.galleryService,this.extensionsScanner,this.logService);else{const te=h.ExtensionKey.create(ee).toString();U=this.installGalleryExtensionsTasks.get(te),U||(this.installGalleryExtensionsTasks.set(te,U=new j(Z,ee,_,this.extensionsDownloader,this.extensionsScanner,this.logService)),U.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(te)))}return _.profileLocation?new N(U,_.profileLocation,this.extensionsProfileScannerService):U}doCreateUninstallExtensionTask(Z,ee){return ee.profileLocation?new se(Z,ee.profileLocation,this.extensionsProfileScannerService):new q(Z,ee,this.extensionsScanner)}async collectFiles(Z){const ee=async U=>{let te=await d.Promises.readdir(U);te=te.map(ve=>C.join(U,ve));const ie=await Promise.all(te.map(ve=>d.Promises.stat(ve)));let fe=Promise.resolve([]);return ie.forEach((ve,z)=>{const Q=te[z];ve.isFile()&&(fe=fe.then(J=>[...J,Q])),ve.isDirectory()&&(fe=fe.then(J=>ee(Q).then(W=>[...J,...W])))}),fe};return(await ee(Z.location.fsPath)).map(U=>({path:`extension/${C.relative(Z.location.fsPath,U)}`,localPath:U}))}};B=Ae([_e(0,l.IExtensionGalleryService),_e(1,ae.ITelemetryService),_e(2,re.ILogService),_e(3,p.INativeEnvironmentService),_e(4,r.IExtensionsScannerService),_e(5,i.IExtensionsProfileScannerService),_e(6,m.IDownloadService),_e(7,K.IInstantiationService),_e(8,O.IFileService),_e(9,le.IProductService),_e(10,F.IUriIdentityService),_e(11,Y.IUserDataProfilesService)],B),e.ExtensionManagementService=B;let H=class extends I.Disposable{constructor(Z,ee,_,U){super(),this.beforeRemovingExtension=Z,this.fileService=ee,this.extensionsScannerService=_,this.logService=U,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new y.Queue}async cleanUp(Z){await this.removeUninstalledExtensions(),Z&&await this.removeOutdatedExtensions()}async scanExtensions(Z,ee){const _={includeInvalid:!0,profileLocation:ee};let U=[];return Z===null||Z===0?U.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_,!1)):Z===1&&U.push(...await this.extensionsScannerService.scanUserExtensions(_)),U=Z!==null?U.filter(te=>te.type===Z):U,Promise.all(U.map(te=>this.toLocalExtension(te)))}async scanUserExtensions(Z){const ee=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!Z,includeInvalid:!0});return Promise.all(ee.map(_=>this.toLocalExtension(_)))}async extractUserExtension(Z,ee,_,U){const te=Z.toString(),ie=C.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,w.generateUuid)()}`),fe=C.join(this.extensionsScannerService.userExtensionsLocation.fsPath,te);try{await d.Promises.rm(fe)}catch{throw new l.ExtensionManagementError(v.localize(1,null,fe,Z.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(Z,ee,ie,U),await this.extensionsScannerService.updateMetadata(S.URI.file(ie),_);try{await this.rename(Z,ie,fe,Date.now()+2*60*1e3),this.logService.info("Renamed to",fe)}catch(ve){try{await d.Promises.rm(ie)}catch{}if(ve.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",Z.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(ve)}. Deleted from extracted location`,ie),ve}return this.scanLocalExtension(S.URI.file(fe),1)}async updateMetadata(Z,ee){return await this.extensionsScannerService.updateMetadata(Z.location,ee),this.scanLocalExtension(Z.location,Z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...Z){const ee=Z.map(_=>h.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>{ee.forEach(U=>_[U.toString()]=!0)})}async setInstalled(Z){await this.withUninstalledExtensions(U=>delete U[Z.toString()]);const _=(await this.scanUserExtensions(!0)).find(U=>h.ExtensionKey.create(U).equals(Z))||null;return _?this.updateMetadata(_,{installedTimestamp:Date.now()}):null}async removeExtension(Z,ee){this.logService.trace(`Deleting ${ee} extension from disk`,Z.identifier.id,Z.location.fsPath),await d.Promises.rm(Z.location.fsPath),this.logService.info("Deleted from disk",Z.identifier.id,Z.location.fsPath)}async removeUninstalledExtension(Z){await this.removeExtension(Z,"uninstalled"),await this.withUninstalledExtensions(ee=>delete ee[h.ExtensionKey.create(Z).toString()])}async withUninstalledExtensions(Z){return this.uninstalledFileLimiter.queue(async()=>{let ee;try{ee=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let _={};if(ee)try{_=JSON.parse(ee)}catch{}return Z&&(Z(_),Object.keys(_).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await d.Promises.rm(this.uninstalledPath)),_})}async extractAtLocation(Z,ee,_,U){this.logService.trace(`Started extracting the extension from ${ee} to ${_}`);try{await d.Promises.rm(_)}catch(te){throw new l.ExtensionManagementError(this.joinErrors(te).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(ee,_,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${_}:`,Z.id)}catch(te){try{await d.Promises.rm(_)}catch{}let ie=l.ExtensionManagementErrorCode.Extract;throw te instanceof g.ExtractError&&(te.type==="CorruptZip"?ie=l.ExtensionManagementErrorCode.CorruptZip:te.type==="Incomplete"&&(ie=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(te.message,ie)}}async rename(Z,ee,_,U){try{await d.Promises.rename(ee,_)}catch(te){if(E.isWindows&&te&&te.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${ee} to ${_} with 'EPERM' error. Trying again...`,Z.id),this.rename(Z,ee,_,U);throw new l.ExtensionManagementError(te.message||v.localize(2,null,ee,_),te.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Z,ee){const _=await this.extensionsScannerService.scanExistingExtension(Z,ee,{includeInvalid:!0});if(_)return this.toLocalExtension(_);throw new Error(v.localize(3,null,Z.path))}async toLocalExtension(Z){const ee=await this.fileService.resolve(Z.location);let _,U;return ee.children&&(_=ee.children.find(({name:te})=>/^readme(\.txt|\.md|)$/i.test(te))?.resource,U=ee.children.find(({name:te})=>/^changelog(\.txt|\.md|)$/i.test(te))?.resource),{identifier:Z.identifier,type:Z.type,isBuiltin:Z.isBuiltin||!!Z.metadata?.isBuiltin,location:Z.location,manifest:Z.manifest,targetPlatform:Z.targetPlatform,validations:Z.validations,isValid:Z.isValid,readmeUrl:_,changelogUrl:U,publisherDisplayName:Z.metadata?.publisherDisplayName||null,publisherId:Z.metadata?.publisherId||null,isApplicationScoped:!!Z.metadata?.isApplicationScoped,isMachineScoped:!!Z.metadata?.isMachineScoped,isPreReleaseVersion:!!Z.metadata?.isPreReleaseVersion,preRelease:!!Z.metadata?.preRelease,installedTimestamp:Z.metadata?.installedTimestamp,updated:!!Z.metadata?.updated}}async removeUninstalledExtensions(){const Z=await this.getUninstalledExtensions(),ee=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const ie of ee)Z[h.ExtensionKey.create(ie).toString()]||_.add(ie.identifier.id.toLowerCase());const U=(0,h.groupByExtension)(ee,ie=>ie.identifier);await y.Promises.settled(U.map(async ie=>{const fe=ie.sort((ve,z)=>k.rcompare(ve.manifest.version,z.manifest.version))[0];_.has(fe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(fe))}));const te=ee.filter(ie=>Z[h.ExtensionKey.create(ie).toString()]);await y.Promises.settled(te.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const Z=await this.extensionsScannerService.scanSystemExtensions({}),ee=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=[],U=await this.extensionsScannerService.getTargetPlatform(),te=(0,h.groupByExtension)(ee,ie=>ie.identifier);for(const ie of te)if(ie.length>1&&_.push(...ie.sort((fe,ve)=>{const z=k.rcompare(fe.manifest.version,ve.manifest.version);return z!==0?z:fe.targetPlatform===U?-1:1}).slice(1)),ie[0].type===0){const fe=Z.find(ve=>(0,h.areSameExtensions)(ve.identifier,ie[0].identifier));(!fe||k.gte(fe.manifest.version,ie[0].manifest.version))&&_.push(ie[0])}await y.Promises.settled(_.map(ie=>this.removeExtension(ie,"outdated")))}joinErrors(Z){const ee=Array.isArray(Z)?Z:[Z];return ee.length===1?ee[0]instanceof Error?ee[0]:new Error(ee[0]):ee.reduce((_,U)=>new Error(`${_.message}${_.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};H=Ae([_e(1,O.IFileService),_e(2,r.IExtensionsScannerService),_e(3,re.ILogService)],H),e.ExtensionsScanner=H;class $ extends u.AbstractExtensionTask{get operation(){return(0,R.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(Z,ee,_,U,te){super(),this.identifier=Z,this.source=ee,this.options=_,this.extensionsScanner=U,this.logService=te,this.wasVerified=!1,this._operation=2}async installExtension(Z,ee){try{const _=await this.unsetUninstalledAndGetLocal(Z.key);if(_)return this.extensionsScanner.updateMetadata(_,Z.metadata)}catch{throw E.isMacintosh?new l.ExtensionManagementError(v.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(v.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(Z,ee)}async unsetUninstalledAndGetLocal(Z){if(!await this.isUninstalled(Z))return null;this.logService.trace("Removing the extension from uninstalled list:",Z.id);const _=await this.extensionsScanner.setInstalled(Z);return this.logService.info("Removed the extension from uninstalled list:",Z.id),_}async isUninstalled(Z){return!!(await this.extensionsScanner.getUninstalledExtensions())[Z.toString()]}async extract({zipPath:Z,key:ee,metadata:_},U){const te=await this.extensionsScanner.extractUserExtension(ee,Z,_,U);return this.logService.info("Extracting completed.",ee.id),te}}class j extends ${constructor(Z,ee,_,U,te,ie){super(ee.identifier,ee,_,te,ie),this.manifest=Z,this.gallery=ee,this.extensionsDownloader=U}async doRun(Z){const _=(await this.extensionsScanner.scanExtensions(null,void 0)).find(fe=>(0,h.areSameExtensions)(fe.identifier,this.gallery.identifier));_&&(this._operation=3);const U={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,c.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,R.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(_,U),metadata:U};const{location:te,verified:ie}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!ie,this.validateManifest(te.fsPath);const fe=await this.installExtension({zipPath:te.fsPath,key:h.ExtensionKey.create(this.gallery),metadata:U},Z);return _&&!this.options.profileLocation&&(_.targetPlatform!==fe.targetPlatform||k.neq(_.manifest.version,fe.manifest.version))&&await this.extensionsScanner.setUninstalled(_),{local:fe,metadata:U}}catch(fe){try{await this.extensionsDownloader.delete(te)}catch(ve){this.logService.warn("Error while deleting the downloaded file",te.toString(),(0,D.getErrorMessage)(ve))}throw fe}}async validateManifest(Z){try{await(0,a.getManifest)(Z)}catch(ee){throw new l.ExtensionManagementError((0,u.joinErrors)(ee).message,l.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class L extends ${constructor(Z,ee,_,U,te,ie){super({id:(0,h.getGalleryExtensionId)(Z.publisher,Z.name)},ee,_,te,ie),this.manifest=Z,this.location=ee,this.galleryService=U}async doRun(Z){const ee=new h.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1,void 0)).find(fe=>(0,h.areSameExtensions)(this.identifier,fe.identifier)),te=await this.getMetadata(this.identifier.id,this.manifest.version,Z);if(te.isApplicationScoped=(0,c.isApplicationScopedExtension)(this.manifest),te.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,te.isBuiltin=this.options.isBuiltin||U?.isBuiltin,te.installedTimestamp=Date.now(),U)if(this._operation=3,ee.equals(new h.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&k.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const fe=await this.unsetUninstalledAndGetLocal(ee);if(fe)try{await this.extensionsScanner.removeExtension(fe,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:C.resolve(this.location.fsPath),key:ee,metadata:te},Z),metadata:te}}async getMetadata(Z,ee,_){try{let[U]=await this.galleryService.getExtensions([{id:Z,version:ee}],_);if(U||([U]=await this.galleryService.getExtensions([{id:Z}],_)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class N{constructor(Z,ee,_){this.task=Z,this.profileLocation=ee,this.extensionsProfileScannerService=_,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const Z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[Z.local,Z.metadata]],this.profileLocation),Z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class q extends u.AbstractExtensionTask{constructor(Z,ee,_){super(),this.extension=Z,this.options=ee,this.extensionsScanner=_}async doRun(Z){const ee=[],_=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=h.ExtensionKey.create(this.extension);ee.push(..._.filter(te=>U.equals(h.ExtensionKey.create(te))))}else ee.push(..._.filter(U=>(0,h.areSameExtensions)(U.identifier,this.extension.identifier)));if(!ee.length)throw new Error(v.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ee),this.options.remove)for(const U of ee)try{Z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch(te){throw new Error(v.localize(9,null,(0,t.toErrorMessage)(te)))}}}class se extends u.AbstractExtensionTask{constructor(Z,ee,_){super(),this.extension=Z,this.profileLocation=ee,this.extensionsProfileScannerService=_}async doRun(Z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(we[135],ye([1,0,79,14,16,8,2,13,24,28,80,12,219,279]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends P.Disposable{constructor(v,m,p){super(),this.environmentService=m,this.logService=p,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,m){this.logService.trace("RequestService#request (node) - begin",v.url);const{proxyUrl:p,strictSSL:u}=this;let l;try{l=await(0,k.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const h={...process.env,...l},i=v.agent?v.agent:await(0,S.getProxyAgent)(v.url||"",h,{proxyUrl:p,strictSSL:u});v.agent=i,v.strictSSL=u,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(v,m);return this.logService.trace("RequestService#request (node) - success",v.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",v.url,r),r}}async getNodeRequest(v){return((0,y.parse)(v.url).protocol==="https:"?await new Promise((u,l)=>{oe(["https"],u,l)}):await new Promise((u,l)=>{oe(["http"],u,l)})).request}_request(v,m){return t.Promises.withAsyncBody(async(p,u)=>{const l=(0,y.parse)(v.url),h=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),i={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,C.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(i.auth=v.user+":"+v.password);const r=h(i,n=>{const s=(0,C.isNumber)(v.followRedirects)?v.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)this._request({...v,url:n.headers.location,followRedirects:s-1},m).then(p,u);else{let a=n;n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,w.createGunzip)())),p({res:n,stream:(0,D.streamToBufferReadableStream)(a)})}});r.on("error",u),v.timeout&&r.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&r.write(v.data),r.end(),m.onCancellationRequested(()=>{r.abort(),u(new I.CancellationError)})})}async resolveProxy(v){}};d=Ae([_e(0,E.IConfigurationService),_e(1,b.INativeEnvironmentService),_e(2,R.ILogService)],d),e.RequestService=d}),define(we[268],ye([1,0,76,12,60,109,24,53,135,43,33,30,118,134,75,104,50,2,105,62,9,17,25,107,132,40,111,77,112,8,4,6,26,217,74,39,117,59,3,54,120,37,52,63]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l,h,i,r,n,s,a,f,o,c,T,O,K,re,le,ae,F,Y,B,H,$,j,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class q extends m.Disposable{constructor(ee,_){super(),this.args=ee,this.remoteDataFolder=_,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const ee=await this.initServices();await ee.invokeFunction(async _=>{const U=_.get(t.ILogService);try{await this.doRun(ee.createInstance(a.ExtensionManagementCLI))}catch(te){throw U.error(te),console.error((0,c.getErrorMessage)(te)),te}})}async initServices(){const ee=new y.ServiceCollection,_={_serviceBrand:void 0,...v.default};ee.set(i.IProductService,_);const U=new s.ServerEnvironmentService(this.args,_);ee.set(s.IServerEnvironmentService,U);const te=new t.LogService(new r.SpdLogLogger(n.RemoteExtensionLogFileName,(0,O.join)(U.logsPath,`${n.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(U)));ee.set(t.ILogService,te),te.trace(`Remote configuration data at ${this.remoteDataFolder}`),te.trace("process arguments:",this.args);const ie=this._register(new p.FileService(te));ee.set(h.IFileService,ie),ie.registerProvider(l.Schemas.file,this._register(new u.DiskFileSystemProvider(te)));const fe=new F.UriIdentityService(ie);ee.set(ae.IUriIdentityService,fe);const ve=this._register(new j.UserDataProfilesService(U,ie,fe,te));ee.set(j.IUserDataProfilesService,ve);const z=this._register(new I.ConfigurationService(ve.defaultProfile.settingsResource,ie,new N.NullPolicyService,te));return await z.initialize(),ee.set(P.IConfigurationService,z),ee.set(C.IRequestService,new D.SyncDescriptor(E.RequestService)),ee.set(le.IDownloadService,new D.SyncDescriptor(re.DownloadService)),ee.set(k.ITelemetryService,b.NullTelemetryService),ee.set(R.IExtensionGalleryService,new D.SyncDescriptor(S.ExtensionGalleryServiceWithNoStorageService)),ee.set(L.IExtensionsProfileScannerService,new D.SyncDescriptor(L.ExtensionsProfileScannerService)),ee.set(H.IExtensionsScannerService,new D.SyncDescriptor($.ExtensionsScannerService)),ee.set(d.IExtensionSignatureVerificationService,new D.SyncDescriptor(d.ExtensionSignatureVerificationService)),ee.set(w.INativeServerExtensionManagementService,new D.SyncDescriptor(w.ExtensionManagementService)),ee.set(f.ILanguagePackService,new D.SyncDescriptor(o.NativeLanguagePackService)),new g.InstantiationService(ee)}async doRun(ee){if(this.args["list-extensions"])return ee.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const _={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return ee.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],_,!!this.args.force)}else{if(this.args["uninstall-extension"])return ee.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return ee.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(ee){return ee.map(_=>/\.vsix$/i.test(_)?T.URI.file((0,O.isAbsolute)(_)?_:(0,O.join)((0,K.cwd)(),_)):_)}}function se(Z){setTimeout(()=>process.exit(Z),0)}async function he(Z,ee,_){if(Z.help){const te=v.default.serverApplicationName+(B.isWindows?".cmd":"");console.log((0,Y.buildHelpMessage)(v.default.nameLong,te,v.default.version,_,{noInputFiles:!0,noPipe:!0}));return}if(Z.version){console.log((0,Y.buildVersionMessage)(v.default.version,v.default.commit));return}const U=new q(Z,ee);try{await U.run(),se(0)}catch{se(1)}finally{U.dispose()}}e.run=he}),define(we[269],ye([1,0,27,7,2,9,6,93,21,42,24,109,73,245,188,74,189,199,190,28,118,30,75,111,200,134,17,105,62,60,104,76,77,112,12,106,50,25,53,218,135,114,33,43,229,115,237,39,117,261,250,221,226,265,64,40,256,132,266,119,54,120,52,37,246,63,227,211,4,210]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l,h,i,r,n,s,a,f,o,c,T,O,K,re,le,ae,F,Y,B,H,$,j,L,N,q,se,he,Z,ee,_,U,te,ie,fe,ve,z,Q,J,W,V,x,X,ce,pe,ke,Te,Ne,Oe,me,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ee="monacoworkbench";async function Me(He,je,ue,De){const Ce=new O.ServiceCollection,Re=new ze,Fe={_serviceBrand:void 0,...F.default};Ce.set(Y.IProductService,Fe);const $e=new z.ServerEnvironmentService(je,Fe);Ce.set(u.IEnvironmentService,$e),Ce.set(u.INativeEnvironmentService,$e);const qe=new be.BufferLogService,nt=new le.MultiplexLogService([new Ke((0,le.getLogLevel)($e)),qe]);Ce.set(le.ILogService,nt),setTimeout(()=>Qe($e.logsPath).then(null,ot=>nt.error(ot)),1e4);const rt=new Oe.LoggerService(nt);qe.logger=rt.createLogger(me.URI.file(P.join($e.logsPath,`${J.RemoteExtensionLogFileName}.log`)),{name:J.RemoteExtensionLogFileName}),nt.trace(`Remote configuration data at ${ue}`),nt.trace("process arguments:",$e.args),Array.isArray(Fe.serverGreeting)&&nt.info(`

${Fe.serverGreeting.join(`
`)}

`),Re.registerChannel(d.ExtensionHostDebugBroadcastChannel.ChannelName,new d.ExtensionHostDebugBroadcastChannel);const et=new b.StaticRouter(ot=>ot.clientId==="renderer");Re.registerChannel("logger",new ae.LogLevelChannel(nt,rt));const st=De.add(new f.FileService(nt));Ce.set(a.IFileService,st),st.registerProvider(I.Schemas.file,De.add(new o.DiskFileSystemProvider(nt)));const lt=new ee.UriIdentityService(st);Ce.set(Z.IUriIdentityService,lt);const ft=new pe.UserDataProfilesService($e,st,lt,nt);Ce.set(pe.IUserDataProfilesService,ft);const ct=new R.ConfigurationService($e.machineSettingsResource,st,new Te.NullPolicyService,nt);Ce.set(k.IConfigurationService,ct),await ct.initialize();const Pt=new V.ExtensionHostStatusService;Ce.set(V.IExtensionHostStatusService,Pt),Ce.set(B.IRequestService,new c.SyncDescriptor($.RequestService));let yt=N.NullAppender;const At=await(0,C.getMachineId)(),_t=(0,N.isInternalTelemetry)(Fe,ct);if((0,N.supportsTelemetry)(Fe,$e)){const ot=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";ot?yt=new Ne.OneDataSystemAppender(!1,Ee,null,()=>new ke.TelemetryClient(ot)):Fe.aiConfig&&Fe.aiConfig.ariaKey&&(yt=new Ne.OneDataSystemAppender(_t,Ee,null,Fe.aiConfig.ariaKey)),De.add((0,D.toDisposable)(()=>yt?.flush()));const Se={appenders:[yt],commonProperties:(0,j.resolveCommonProperties)(st,(0,y.release)(),(0,y.hostname)(),process.arch,Fe.commit,Fe.version+"-remote",At,_t,$e.installSourcePath,"remoteAgent"),piiPaths:(0,N.getPiiPathsFromEnvironment)($e)},Ie=$e.args["telemetry-level"];let de=3;Ie==="all"?de=3:Ie==="error"?de=2:Ie==="crash"?de=1:Ie!==void 0&&(de=0),Ce.set(ie.IServerTelemetryService,new c.SyncDescriptor(ie.ServerTelemetryService,[Se,de]))}else Ce.set(ie.IServerTelemetryService,ie.ServerNullTelemetryService);Ce.set(h.IExtensionGalleryService,new c.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService));const kt=Re.getChannel("download",et);Ce.set(g.IDownloadService,new v.DownloadServiceChannelClient(kt,()=>Ge("renderer"))),Ce.set(ce.IExtensionsProfileScannerService,new c.SyncDescriptor(ce.ExtensionsProfileScannerService)),Ce.set(x.IExtensionsScannerService,new c.SyncDescriptor(X.ExtensionsScannerService)),Ce.set(i.IExtensionSignatureVerificationService,new c.SyncDescriptor(i.ExtensionSignatureVerificationService)),Ce.set(s.INativeServerExtensionManagementService,new c.SyncDescriptor(s.ExtensionManagementService));const ht=new T.InstantiationService(Ce);Ce.set(K.ILanguagePackService,ht.createInstance(re.NativeLanguagePackService));const bt=ht.createInstance(he.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:ct.getValue("terminal.integrated.persistentSessionScrollback")??100});return Ce.set(se.IPtyService,bt),Ce.set(m.IEncryptionMainService,new c.SyncDescriptor(p.EncryptionMainService,[At])),Ce.set(S.ICredentialsMainService,new c.SyncDescriptor(w.CredentialsWebMainService)),ht.invokeFunction(ot=>{const Se=ot.get(s.INativeServerExtensionManagementService),Ie=ot.get(x.IExtensionsScannerService),de=new _.RemoteAgentEnvironmentChannel(He,$e,ft,ht.createInstance(r.ExtensionManagementCLI),nt,Pt,Ie);Re.registerChannel("remoteextensionsenvironment",de);const G=new te.ServerTelemetryChannel(ot.get(ie.IServerTelemetryService),yt);Re.registerChannel("telemetry",G),Re.registerChannel(Q.REMOTE_TERMINAL_CHANNEL_NAME,new fe.RemoteTerminalChannel($e,nt,bt,Fe,Se));const Pe=new U.RemoteAgentFileSystemProviderChannel(nt,$e);Re.registerChannel(W.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Pe),Re.registerChannel("request",new H.RequestChannel(ot.get(B.IRequestService)));const Le=new n.ExtensionManagementChannel(Se,at=>Ge(at.remoteAuthority));Re.registerChannel("extensions",Le);const Ye=b.ProxyChannel.fromService(ot.get(K.ILanguagePackService));Re.registerChannel("languagePacks",Ye);const We=b.ProxyChannel.fromService(ot.get(m.IEncryptionMainService));Re.registerChannel("encryption",We);const tt=b.ProxyChannel.fromService(ot.get(S.ICredentialsMainService));return Re.registerChannel("credentials",tt),Se.removeUninstalledExtensions(!0),De.add(new q.default(ot.get(L.ITelemetryService))),{telemetryService:ot.get(L.ITelemetryService)}}),{socketServer:Re,instantiationService:ht}}e.setupServerServices=Me;const Be=Object.create(null);function Ge(He){return Be[He]||(Be[He]=(0,ve.createURITransformer)(He)),Be[He]}class ze extends b.IPCServer{constructor(){const je=new t.Emitter;super(je.event),this._onDidConnectEmitter=je}acceptConnection(je,ue){this._onDidConnectEmitter.fire({protocol:je,onDidClientDisconnect:ue})}}e.SocketServer=ze;class Ke extends le.AbstractLogger{constructor(je=le.DEFAULT_LOG_LEVEL){super(),this.setLevel(je),this.useColors=Boolean(process.stdout.isTTY)}trace(je,...ue){this.getLevel()<=le.LogLevel.Trace&&(this.useColors?console.log(`\x1B[90m[${xe()}]\x1B[0m`,je,...ue):console.log(`[${xe()}]`,je,...ue))}debug(je,...ue){this.getLevel()<=le.LogLevel.Debug&&(this.useColors?console.log(`\x1B[90m[${xe()}]\x1B[0m`,je,...ue):console.log(`[${xe()}]`,je,...ue))}info(je,...ue){this.getLevel()<=le.LogLevel.Info&&(this.useColors?console.log(`\x1B[90m[${xe()}]\x1B[0m`,je,...ue):console.log(`[${xe()}]`,je,...ue))}warn(je,...ue){this.getLevel()<=le.LogLevel.Warning&&(this.useColors?console.warn(`\x1B[93m[${xe()}]\x1B[0m`,je,...ue):console.warn(`[${xe()}]`,je,...ue))}error(je,...ue){this.getLevel()<=le.LogLevel.Error&&(this.useColors?console.error(`\x1B[91m[${xe()}]\x1B[0m`,je,...ue):console.error(`[${xe()}]`,je,...ue))}critical(je,...ue){this.getLevel()<=le.LogLevel.Critical&&(this.useColors?console.error(`\x1B[90m[${xe()}]\x1B[0m`,je,...ue):console.error(`[${xe()}]`,je,...ue))}dispose(){}flush(){}}function xe(){const He=new Date;return`${Ze(He.getHours())}:${Ze(He.getMinutes())}:${Ze(He.getSeconds())}`}function Ze(He){return He<10?`0${He}`:String(He)}async function Qe(He){const je=P.basename(He),ue=P.dirname(He),Re=(await E.Promises.readdir(ue)).filter($e=>/^\d{8}T\d{6}$/.test($e)).sort().filter($e=>$e!==je),Fe=Re.slice(0,Math.max(0,Re.length-9));await Promise.all(Fe.map($e=>E.Promises.rm(P.join(ue,$e))))}}),define(we[270],ye([1,0,113,29,94,271,79,136,16,8,36,2,9,6,46,3,15,4,22,149,98,58,5,12,25,78,33,128,242,243,40,269,248]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S,w,d,g,v,m,p,u,l,h,i,r,n,s,a,f,o,c,T,O,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const re=5*60*1e3;let le=class extends R.Disposable{constructor(B,H,$,j,L,N,q,se){super(),this._socketServer=B,this._connectionToken=H,this._vsdaMod=$,this._environmentService=L,this._productService=N,this._logService=q,this._instantiationService=se,this._webEndpointOriginChecker=F.create(this._productService),this._serverRootPath=(0,s.getRemoteServerRootPath)(N),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=j?this._instantiationService.createInstance(K.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(B,H){if(B.method!=="GET")return(0,K.serveError)(B,H,405,`Unsupported method ${B.method}`);if(!B.url)return(0,K.serveError)(B,H,400,"Bad request.");const $=P.parse(B.url,!0);let j=$.pathname;if(!j)return(0,K.serveError)(B,H,400,"Bad request.");if(j.startsWith(this._serverRootPath)&&j.charCodeAt(this._serverRootPath.length)===47&&(j=j.substring(this._serverRootPath.length)),j==="/version")return H.writeHead(200,{"Content-Type":"text/plain"}),void H.end(this._productService.commit||"");if(j==="/delay-shutdown")return this._delayShutdown(),H.writeHead(200),void H.end("OK");if(!(0,c.requestHasValidConnectionToken)(this._connectionToken,B,$))return(0,K.serveError)(B,H,403,"Forbidden.");if(j==="/vscode-remote-resource"){const L=$.query.path;if(typeof L!="string")return(0,K.serveError)(B,H,400,"Bad request.");let N;try{N=m.URI.from({scheme:S.Schemas.file,path:L}).fsPath}catch{return(0,K.serveError)(B,H,400,"Bad request.")}const q=Object.create(null);this._environmentService.isBuilt&&((0,k.isEqualOrParent)(N,this._environmentService.builtinExtensionsPath,!g.isLinux)||(0,k.isEqualOrParent)(N,this._environmentService.extensionsPath,!g.isLinux))&&(q["Cache-Control"]="public, max-age=31536000"),q.Vary="Origin";const se=B.headers.origin;return se&&this._webEndpointOriginChecker.matches(se)&&(q["Access-Control-Allow-Origin"]=se),(0,K.serveFile)(N,1,this._logService,B,H,q)}if(this._webClientServer){this._webClientServer.handle(B,H,$);return}return H.writeHead(404,{"Content-Type":"text/plain"}),void H.end("Not found")}handleUpgrade(B,H){let $=(0,p.generateUuid)(),j=!1,L=!1;if(B.url){const ee=P.parse(B.url,!0).query;typeof ee.reconnectionToken=="string"&&($=ee.reconnectionToken),ee.reconnection==="true"&&(j=!0),ee.skipWebSocketFrames==="true"&&(L=!0)}if(B.headers.upgrade===void 0||B.headers.upgrade.toLowerCase()!=="websocket"){H.end("HTTP/1.1 400 Bad Request");return}const N=B.headers["sec-websocket-key"],q=y.createHash("sha1");q.update(N+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const se=q.digest("base64"),he=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${se}`];let Z=!1;if(!L&&!this._environmentService.args["disable-websocket-compression"]&&B.headers["sec-websocket-extensions"]){const ee=Array.isArray(B.headers["sec-websocket-extensions"])?B.headers["sec-websocket-extensions"]:[B.headers["sec-websocket-extensions"]];for(const _ of ee)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(_)){if(/\b(permessage-deflate)\b/.test(_)){Z=!0,he.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(_)){Z=!0,he.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}H.write(he.join(`\r
`)+`\r
\r
`),H.setTimeout(0),H.setNoDelay(!0),L?this._handleWebSocketConnection(new h.NodeSocket(H,`server-connection-${$}`),j,$):this._handleWebSocketConnection(new h.WebSocketNodeSocket(new h.NodeSocket(H,`server-connection-${$}`),Z,null,!0),j,$)}handleServerError(B){this._logService.error("Error occurred in server"),this._logService.error(B)}_getRemoteAddress(B){let H;return B instanceof h.NodeSocket?H=B.socket:H=B.socket.socket,H.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(B,H,$){const j=H.getSocket();this._logService.error(`${B} ${$}.`);const L={type:"error",reason:$};H.sendControl(E.VSBuffer.fromString(JSON.stringify(L))),H.dispose(),await j.drain(),j.dispose()}_handleWebSocketConnection(B,H,$){const j=this._getRemoteAddress(B),L=`[${j}][${$.substr(0,8)}]`,N=new l.PersistentProtocol(B),q=this._vsdaMod?new this._vsdaMod.validator:null,se=this._vsdaMod?new this._vsdaMod.signer:null;let he;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})(he||(he={}));let Z=0;const ee=U=>{Z=3,_.dispose(),this._rejectWebSocketConnection(L,N,U)},_=N.onControlMessage(U=>{if(Z===0){let te;try{te=JSON.parse(U.toString())}catch{return ee("Malformed first message")}if(te.type!=="auth")return ee("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(te.auth))return ee("Unauthorized client refused: auth mismatch");let ie=(0,p.generateUuid)();if(se)try{ie=se.sign(te.data)}catch{}let fe=(0,p.generateUuid)();if(q)try{fe=q.createNewMessage(fe)}catch{}const ve={type:"sign",data:fe,signedData:ie};N.sendControl(E.VSBuffer.fromString(JSON.stringify(ve))),Z=1}else if(Z===1){let te;try{te=JSON.parse(U.toString())}catch{return ee("Malformed second message")}if(te.type!=="connectionType")return ee("Invalid second message");if(typeof te.signedData!="string")return ee("Invalid second message field type");const ie=te.commit,fe=this._productService.commit;if(ie&&fe&&ie!==fe)return ee("Client refused: version mismatch");let ve=!1;if(!q)ve=!0;else if(this._connectionToken.validate(te.signedData))ve=!0;else try{ve=q.validate(te.signedData)==="ok"}catch{}if(!ve){if(this._environmentService.isBuilt)return ee("Unauthorized client refused");this._logService.error(`${L} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const z in this._managementConnections)this._managementConnections[z].shortenReconnectionGraceTimeIfNecessary();for(const z in this._extHostConnections)this._extHostConnections[z].shortenReconnectionGraceTimeIfNecessary();Z=2,_.dispose(),this._handleConnectionType(j,L,N,B,H,$,te)}})}async _handleConnectionType(B,H,$,j,L,N,q){const se=q.desiredConnectionType===1?`${H}[ManagementConnection]`:q.desiredConnectionType===2?`${H}[ExtensionHostConnection]`:H;if(q.desiredConnectionType===1)if(L){if(!this._managementConnections[N])return this._allReconnectionTokens.has(N)?this._rejectWebSocketConnection(se,$,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(se,$,"Unknown reconnection token (never seen)");$.sendControl(E.VSBuffer.fromString(JSON.stringify({type:"ok"})));const he=$.readEntireBuffer();$.dispose(),this._managementConnections[N].acceptReconnection(B,j,he)}else{if(this._managementConnections[N])return this._rejectWebSocketConnection(se,$,"Duplicate reconnection token");$.sendControl(E.VSBuffer.fromString(JSON.stringify({type:"ok"})));const he=new o.ManagementConnection(this._logService,N,B,$);this._socketServer.acceptConnection(he.protocol,he.onClose),this._managementConnections[N]=he,this._allReconnectionTokens.add(N),he.onClose(()=>{delete this._managementConnections[N]})}else if(q.desiredConnectionType===2){const he=q.args||{language:"en"},Z=await this._updateWithFreeDebugPort(he);if(Z.port&&this._logService.trace(`${se} - startParams debug port ${Z.port}`),this._logService.trace(`${se} - startParams language: ${Z.language}`),this._logService.trace(`${se} - startParams env: ${JSON.stringify(Z.env)}`),L){if(!this._extHostConnections[N])return this._allReconnectionTokens.has(N)?this._rejectWebSocketConnection(se,$,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(se,$,"Unknown reconnection token (never seen)");$.sendPause(),$.sendControl(E.VSBuffer.fromString(JSON.stringify(Z.port?{debugPort:Z.port}:{})));const ee=$.readEntireBuffer();$.dispose(),this._extHostConnections[N].acceptReconnection(B,j,ee)}else{if(this._extHostConnections[N])return this._rejectWebSocketConnection(se,$,"Duplicate reconnection token");$.sendPause(),$.sendControl(E.VSBuffer.fromString(JSON.stringify(Z.port?{debugPort:Z.port}:{})));const ee=$.readEntireBuffer();$.dispose();const _=this._instantiationService.createInstance(f.ExtensionHostConnection,N,B,j,ee);this._extHostConnections[N]=_,this._allReconnectionTokens.add(N),_.onClose(()=>{delete this._extHostConnections[N],this._onDidCloseExtHostConnection()}),_.start(Z)}}else if(q.desiredConnectionType===3){const he=q.args;this._createTunnel($,he)}else return this._rejectWebSocketConnection(se,$,"Unknown initial data received")}async _createTunnel(B,H){const $=B.getSocket().socket,j=B.readEntireBuffer();B.dispose(),$.pause();const L=await this._connectTunnelSocket(H.host,H.port);j.byteLength>0&&L.write(j.buffer),L.on("end",()=>$.end()),L.on("close",()=>$.end()),L.on("error",()=>$.destroy()),$.on("end",()=>L.end()),$.on("close",()=>L.end()),$.on("error",()=>L.destroy()),L.pipe($),$.pipe(L)}_connectTunnelSocket(B,H){return new Promise(($,j)=>{const L=D.createConnection({host:B,port:H},()=>{L.removeListener("error",j),L.pause(),$(L)});L.once("error",j)})}_updateWithFreeDebugPort(B){return typeof B.port=="number"?(0,u.findFreePort)(B.port,10,5e3).then(H=>(B.port=H,B)):(B.debugId=void 0,B.port=void 0,B.break=void 0,Promise.resolve(B))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},re))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};le=Ae([_e(4,T.IServerEnvironmentService),_e(5,n.IProductService),_e(6,r.ILogService),_e(7,i.IInstantiationService)],le),e.RemoteExtensionHostAgentServer=le;async function ae(Y,B,H){const $=await(0,c.determineServerConnectionToken)(B);$ instanceof c.ServerConnectionTokenParseError&&(console.warn($.message),process.exit(1));const j=new R.DisposableStore,{socketServer:L,instantiationService:N}=await(0,O.setupServerServices)($,B,H,j);N.invokeFunction(te=>{const ie=te.get(r.ILogService);(0,b.setUnexpectedErrorHandler)(fe=>{fe&&fe.code==="EPIPE"&&fe.syscall==="write"&&fe.stack&&/unexpectedErrorHandler/.test(fe.stack)||ie.error(fe)}),process.on("SIGPIPE",()=>{(0,b.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),N.invokeFunction(te=>{const ie=te.get(r.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const fe=(0,w.join)(process.env.HOMEDRIVE,"node_modules"),ve=(0,w.dirname)((0,w.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),z=(0,w.join)(ve,"node_modules");if(t.existsSync(fe)||t.existsSync(z)){const Q=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${fe}
* ${z}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;ie.warn(Q),console.warn(Q),process.exit(0)}}});const q=N.invokeFunction(te=>{const ie=te.get(r.ILogService);if(t.existsSync((0,w.join)(S.FileAccess.asFileUri("",oe).fsPath,"../node_modules/vsda")))try{return oe.__$__nodeRequire("vsda")}catch(ve){ie.error(ve)}return null}),se=t.existsSync(S.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",oe).fsPath);if(se&&Y&&typeof Y!="string"){const te=$.type!==0?`?${S.connectionTokenQueryName}=${$.value}`:"";console.log(`Web UI available at http://localhost${Y.port===80?"":`:${Y.port}`}/${te}`)}const he=N.createInstance(le,L,$,q,se);d.mark("code/server/ready");const Z=I.performance.now(),ee=global.vscodeServerStartTime,_=global.vscodeServerListenTime,U=global.vscodeServerCodeLoadedTime;if(N.invokeFunction(te=>{te.get(a.ITelemetryService).publicLog2("serverStart",{startTime:ee,startedTime:_,codeLoadedTime:U,readyTime:Z})}),B["print-startup-performance"]){const te=C.LoaderStats.get();let ie="";ie+=`

### Load AMD-module
`,ie+=C.LoaderStats.toMarkdownTable(["Module","Duration"],te.amdLoad),ie+=`

### Load commonjs-module
`,ie+=C.LoaderStats.toMarkdownTable(["Module","Duration"],te.nodeRequire),ie+=`

### Invoke AMD-module factory
`,ie+=C.LoaderStats.toMarkdownTable(["Module","Duration"],te.amdInvoke),ie+=`

### Invoke commonjs-module
`,ie+=C.LoaderStats.toMarkdownTable(["Module","Duration"],te.nodeEval),ie+=`Start-up time: ${_-ee}
`,ie+=`Code loading time: ${U-ee}
`,ie+=`Initialized time: ${Z-ee}
`,ie+=`
`,console.log(ie)}return he}e.createServer=ae;class F{static create(B){const H=B.webEndpointUrlTemplate,$=B.commit,j=B.quality;if(!H||!$||!j)return new F(null);const L=(0,p.generateUuid)(),q=new URL(H.replace("{{uuid}}",L).replace("{{commit}}",$).replace("{{quality}}",j)).origin,se=(0,v.escapeRegExpCharacters)(q).replace(L,"[a-zA-Z0-9\\-]+");try{const he=(0,v.createRegExp)(`^${se}$`,!0,{matchCase:!1});return new F(he)}catch{return new F(null)}}constructor(B){this._originRegExp=B}matches(B){return this._originRegExp?this._originRegExp.test(B):!1}}}),define(we[280],ye([1,0,27,29,9,268,270,59,6,271,40,50,46]),function(oe,e,y,t,D,I,P,C,E,b,k,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,S.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=b.performance.now();const w={onMultipleValues:(p,u)=>{console.error(`Option '${p}' can only be defined once. Using value ${u}.`)},onEmptyValue:p=>{console.error(`Ignoring option '${p}': Value must not be empty.`)},onUnknownOption:p=>{console.error(`Ignoring option '${p}': not supported for server.`)},onDeprecatedOption:(p,u)=>{console.warn(`Option '${p}' is deprecated: ${u}`)}};function d(){return(0,C.parseArgs)(process.argv.slice(2),k.serverOptions,w)}function g(p){const u=p["server-data-dir"]||p["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,E.join)(y.homedir(),R.default.serverDataFolderName||".vscode-remote"),l=p["user-data-dir"]||(0,E.join)(u,"data"),h=(0,E.join)(l,"User"),i=(0,E.join)(h,"globalStorage"),r=(0,E.join)(h,"History"),n=(0,E.join)(l,"Machine");p["user-data-dir"]=l;const s=(0,E.dirname)(D.FileAccess.asFileUri("",oe).fsPath),a=p["builtin-extensions-dir"]||(0,E.join)(s,"extensions");return p["builtin-extensions-dir"]=a,p["extensions-dir"]=p["extensions-dir"]||(0,E.join)(u,"extensions"),[u,p["extensions-dir"],l,h,n,i,r].forEach(f=>{try{t.existsSync(f)||t.mkdirSync(f,{mode:448})}catch(o){console.error(o)}}),u}function v(p=d()){return(0,I.run)(p,g(p),k.serverOptions)}e.spawnCli=v;function m(p,u=d()){return(0,P.createServer)(p,u,g(u))}e.createServer=m})}).call(this);

//# sourceMappingURL=server.main.js.map
